string DefaultParameterScopeBlock = "material"; // 1
float3 AmbientLightColor <bool unmanaged = 1;> = { 0.3, 0.3, 0.3 };
struct {
    float3 Color;
    float3 Direction;
} DirectionalLight[3] <bool unmanaged = 1;> = { 1.625198, 1.512711, 1.097048, 0.62914, -0.34874, 0.69465, 0.5232916, 0.6654605, 0.7815244, -0.32877, 0.90329, 0.27563, 0.4420466, 0.4102767, 0.4420466, -0.80704, -0.58635, 0.06975 };
struct {
    float3 Color;
    float3 Position;
    float2 Range_Inner_Outer;
} PointLight[8] <bool unmanaged = 1;>;
struct {
    float4 WorldPositionMultiplier_XYZZ;
    float2 CurrentOffsetUV;
} Cloud <bool unmanaged = 1;>;
float3 NoCloudMultiplier <bool unmanaged = 1;> = { 1, 1, 1 };
float3 RecolorColorDummy <bool unmanaged = 1;>;
row_major float4x4 ShadowMapWorldToShadow <bool unmanaged = 1;>;
float OpacityOverride <bool unmanaged = 1;> = { 1 };
float3 TintColor <bool unmanaged = 1;> = { 1, 1, 1 };
float3 EyePosition <bool unmanaged = 1;>;
column_major float4x4 ViewProjection : register(vs_2_0, c119) <bool unmanaged = 1;>;
float4 WorldBones[128] <bool unmanaged = 1;>;
struct {
    float4 VideoTex_NumPerRow_LastFrame_SingleRow_isRand;
    float4 ColorAnimationFunctions[6];
    float4 TimeKeys;
    int ShaderType;
    float SpeedMultiplier;
    float2 ColorScaleRange;
} Draw <string UIWidget = "None"; string SasBindAddress = "Particle.Draw";> = { 4, 15, -1, 0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 1, 1, -0.1, 0.2 };
struct {
    float3 Gravity;
    float3 DriftVelocity;
    float2 VelocityDampingRange;
} Physics <string UIWidget = "None"; string SasBindAddress = "Particle.Physics";> = { 0, 0, 0, 0, 0, 0, 1, 0 };
struct {
    float3 Size_Rate_Damping__Min;
    float3 Size_Rate_Damping__Spread;
    float3 XYRotation_Rate_Damping__Min;
    float3 XYRotation_Rate_Damping__Spread;
    float3 ZRotation_Rate_Damping__Min;
    float3 ZRotation_Rate_Damping__Spread;
} Update <string UIWidget = "None"; string SasBindAddress = "Particle.Update";> = { 0, 0, 1, 10, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0 };
texture ParticleTexture <string UIWidget = "None"; string SasBindAddress = "Particle.Draw.Texture";>; // 8
sampler2D ParticleTextureSampler : register(ps_2_0, s0) <string Texture = "ParticleTexture"; string UIWidget = "None"; string SasBindAddress = "Particle.Draw.Texture";> =
sampler_state
{
    Texture = <ParticleTexture>; // 11
    MinFilter = 2;
    MagFilter = 2;
    MipFilter = 2;
    AddressU = 3;
    AddressV = 3;
};
row_major float4x4 Projection : Projection;
column_major float4x3 View : View : register(vs_2_0, c20);
// Alpha2DShaderBillboard_M_PixelShader1 Pixel_2_0 Has PRES False
struct Alpha2DShaderBillboard_M_PixelShader1_Input
{
    float4 color : COLOR;
    float2 texcoord : TEXCOORD;
};

float4 Alpha2DShaderBillboard_M_PixelShader1(Alpha2DShaderBillboard_M_PixelShader1_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    // dcl v0
    // dcl t0.xy
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(ParticleTextureSampler, i.texcoord.xy);
    // mul r0, r0, v0
    temp0 = temp0 * i.color;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// Alpha2DShaderBillboard_M_VertexShader2 Vertex_2_0 Has PRES False
struct Alpha2DShaderBillboard_M_VertexShader2_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct Alpha2DShaderBillboard_M_VertexShader2_Output
{
    float2 texcoord : TEXCOORD;
    float4 position : POSITION;
    float4 color : COLOR;
};

Alpha2DShaderBillboard_M_VertexShader2_Output Alpha2DShaderBillboard_M_VertexShader2(Alpha2DShaderBillboard_M_VertexShader2_Input i)
{
    Alpha2DShaderBillboard_M_VertexShader2_Output o;
    float4 temp0;
    float3 temp1;
    float addr0;
    // def c12, 0.5, -0.5, 6.283185, -3.141593
    // def c11, -0.5, -0.5, 0.1591549, 0.5
    // def c13, 0.5, 0.5, 1, -1
    // def c14, -0.5, 0.5, 0, 0
    // def c15, 0, 0, 0, 0
    // def c16, -0.25, -0.25, 0, 0
    // def c17, 0.25, -0.25, 0, 0
    // def c18, 0.25, 0.25, 0, 0
    // def c19, -0.25, 0.25, 0, 0
    // def c0, -1.550099E-06, -2.170139E-05, 0.002604167, 0.0002604167
    // def c1, -0.02083333, -0.125, 1, 0.5
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_color v2
    // mad r0.x, v1.x, c11.z, c11.w
    temp0.x = i.texcoord.x * float1(0.15915494) + float1(0.5);
    // frc r0.x, r0.x
    temp0.x = frac(temp0.x);
    // mad r0.x, r0.x, c12.z, c12.w
    temp0.x = temp0.x * float1(6.2831855) + float1(-3.1415927);
    // sincos r1.xy, r0.x, c0, c1
    temp1.xy = float2(cos(temp0.x), sin(temp0.x));
    // frc r0.x, v0.w
    temp0.x = frac(i.position.w);
    // add r0.x, -r0.x, v0.w
    temp0.x = -temp0.x + i.position.w;
    // mova a0.x, r0.x
    addr0.x = temp0.x;
    // mul r0.xyz, r1.xyxw, c11[a0.x].xyyw
    temp0.xyz = temp1.xyx * float3(-0.5, -0.5, -0.5);
    // mad r0.z, c11[a0.x].x, -r1.y, r0.z
    temp0.z = float1(-0.5) * -temp1.y + temp0.z;
    // mov r1.xy, c11[a0.x]
    temp1.xy = float2(-0.5, -0.5);
    // mad oT0.xy, r1, c13.zwzw, c13.x
    o.texcoord = temp1 * float4(1, -1, 1, -1) + float4(0.5, 0.5, 0.5, 0.5);
    // add r0.x, r0.y, r0.x
    temp0.x = temp0.y + temp0.x;
    // mul r0.yzw, r0.z, c21.xxyz
    temp0.yzw = temp0.zzz * (View._m01_m11_m21_m31).xyz;
    // mad r0.xyz, r0.x, c20, r0.yzww
    temp0.xyz = temp0.xxx * (View._m00_m10_m20_m30).xyz + temp0.yzw;
    // mov r1.xyz, v0
    temp1.xyz = i.position.xyz;
    // mad r0.xyz, v1.y, r0, r1
    temp0.xyz = i.texcoord.yyy * temp0.xyz + temp1.xyz;
    // mov r0.w, c13.z
    temp0.w = float1(1);
    // dp4 oPos.x, r0, c119
    o.position.x = dot(temp0, (ViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c120
    o.position.y = dot(temp0, (ViewProjection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c121
    o.position.z = dot(temp0, (ViewProjection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c122
    o.position.w = dot(temp0, (ViewProjection._m03_m13_m23_m33));
    // mov oD0, v2
    o.color = i.color;
    // 

    return o;
}

// Additive2DShaderBillboard_M_PixelShader3 Pixel_2_0 Has PRES False
struct Additive2DShaderBillboard_M_PixelShader3_Input
{
    float4 color : COLOR;
    float2 texcoord : TEXCOORD;
};

float4 Additive2DShaderBillboard_M_PixelShader3(Additive2DShaderBillboard_M_PixelShader3_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    // dcl v0
    // dcl t0.xy
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(ParticleTextureSampler, i.texcoord.xy);
    // mul r0, r0, v0
    temp0 = temp0 * i.color;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// Additive2DShaderBillboard_M_VertexShader4 Vertex_2_0 Has PRES False
struct Additive2DShaderBillboard_M_VertexShader4_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct Additive2DShaderBillboard_M_VertexShader4_Output
{
    float2 texcoord : TEXCOORD;
    float4 position : POSITION;
    float4 color : COLOR;
};

Additive2DShaderBillboard_M_VertexShader4_Output Additive2DShaderBillboard_M_VertexShader4(Additive2DShaderBillboard_M_VertexShader4_Input i)
{
    Additive2DShaderBillboard_M_VertexShader4_Output o;
    float4 temp0;
    float3 temp1;
    float addr0;
    // def c12, 0.5, -0.5, 6.283185, -3.141593
    // def c11, -0.5, -0.5, 0.1591549, 0.5
    // def c13, 0.5, 0.5, 1, -1
    // def c14, -0.5, 0.5, 0, 0
    // def c15, 0, 0, 0, 0
    // def c16, -0.25, -0.25, 0, 0
    // def c17, 0.25, -0.25, 0, 0
    // def c18, 0.25, 0.25, 0, 0
    // def c19, -0.25, 0.25, 0, 0
    // def c0, -1.550099E-06, -2.170139E-05, 0.002604167, 0.0002604167
    // def c1, -0.02083333, -0.125, 1, 0.5
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_color v2
    // mad r0.x, v1.x, c11.z, c11.w
    temp0.x = i.texcoord.x * float1(0.15915494) + float1(0.5);
    // frc r0.x, r0.x
    temp0.x = frac(temp0.x);
    // mad r0.x, r0.x, c12.z, c12.w
    temp0.x = temp0.x * float1(6.2831855) + float1(-3.1415927);
    // sincos r1.xy, r0.x, c0, c1
    temp1.xy = float2(cos(temp0.x), sin(temp0.x));
    // frc r0.x, v0.w
    temp0.x = frac(i.position.w);
    // add r0.x, -r0.x, v0.w
    temp0.x = -temp0.x + i.position.w;
    // mova a0.x, r0.x
    addr0.x = temp0.x;
    // mul r0.xyz, r1.xyxw, c11[a0.x].xyyw
    temp0.xyz = temp1.xyx * float3(-0.5, -0.5, -0.5);
    // mad r0.z, c11[a0.x].x, -r1.y, r0.z
    temp0.z = float1(-0.5) * -temp1.y + temp0.z;
    // mov r1.xy, c11[a0.x]
    temp1.xy = float2(-0.5, -0.5);
    // mad oT0.xy, r1, c13.zwzw, c13.x
    o.texcoord = temp1 * float4(1, -1, 1, -1) + float4(0.5, 0.5, 0.5, 0.5);
    // add r0.x, r0.y, r0.x
    temp0.x = temp0.y + temp0.x;
    // mul r0.yzw, r0.z, c21.xxyz
    temp0.yzw = temp0.zzz * (View._m01_m11_m21_m31).xyz;
    // mad r0.xyz, r0.x, c20, r0.yzww
    temp0.xyz = temp0.xxx * (View._m00_m10_m20_m30).xyz + temp0.yzw;
    // mov r1.xyz, v0
    temp1.xyz = i.position.xyz;
    // mad r0.xyz, v1.y, r0, r1
    temp0.xyz = i.texcoord.yyy * temp0.xyz + temp1.xyz;
    // mov r0.w, c13.z
    temp0.w = float1(1);
    // dp4 oPos.x, r0, c119
    o.position.x = dot(temp0, (ViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c120
    o.position.y = dot(temp0, (ViewProjection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c121
    o.position.z = dot(temp0, (ViewProjection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c122
    o.position.w = dot(temp0, (ViewProjection._m03_m13_m23_m33));
    // mov oD0, v2
    o.color = i.color;
    // 

    return o;
}

// MultiplicativeSpriteShaderBillboard_M_PixelShader5 Pixel_2_0 Has PRES False
struct MultiplicativeSpriteShaderBillboard_M_PixelShader5_Input
{
    float4 color : COLOR;
    float2 texcoord : TEXCOORD;
};

float4 MultiplicativeSpriteShaderBillboard_M_PixelShader5(MultiplicativeSpriteShaderBillboard_M_PixelShader5_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    // dcl v0
    // dcl t0.xy
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(ParticleTextureSampler, i.texcoord.xy);
    // mul r0, r0, v0
    temp0 = temp0 * i.color;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// MultiplicativeSpriteShaderBillboard_M_VertexShader6 Vertex_2_0 Has PRES False
struct MultiplicativeSpriteShaderBillboard_M_VertexShader6_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct MultiplicativeSpriteShaderBillboard_M_VertexShader6_Output
{
    float2 texcoord : TEXCOORD;
    float4 position : POSITION;
    float4 color : COLOR;
};

MultiplicativeSpriteShaderBillboard_M_VertexShader6_Output MultiplicativeSpriteShaderBillboard_M_VertexShader6(MultiplicativeSpriteShaderBillboard_M_VertexShader6_Input i)
{
    MultiplicativeSpriteShaderBillboard_M_VertexShader6_Output o;
    float4 temp0;
    float3 temp1;
    float addr0;
    // def c12, 0.5, -0.5, 6.283185, -3.141593
    // def c11, -0.5, -0.5, 0.1591549, 0.5
    // def c13, 0.5, 0.5, 1, -1
    // def c14, -0.5, 0.5, 0, 0
    // def c15, 0, 0, 0, 0
    // def c16, -0.25, -0.25, 0, 0
    // def c17, 0.25, -0.25, 0, 0
    // def c18, 0.25, 0.25, 0, 0
    // def c19, -0.25, 0.25, 0, 0
    // def c0, -1.550099E-06, -2.170139E-05, 0.002604167, 0.0002604167
    // def c1, -0.02083333, -0.125, 1, 0.5
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_color v2
    // mad r0.x, v1.x, c11.z, c11.w
    temp0.x = i.texcoord.x * float1(0.15915494) + float1(0.5);
    // frc r0.x, r0.x
    temp0.x = frac(temp0.x);
    // mad r0.x, r0.x, c12.z, c12.w
    temp0.x = temp0.x * float1(6.2831855) + float1(-3.1415927);
    // sincos r1.xy, r0.x, c0, c1
    temp1.xy = float2(cos(temp0.x), sin(temp0.x));
    // frc r0.x, v0.w
    temp0.x = frac(i.position.w);
    // add r0.x, -r0.x, v0.w
    temp0.x = -temp0.x + i.position.w;
    // mova a0.x, r0.x
    addr0.x = temp0.x;
    // mul r0.xyz, r1.xyxw, c11[a0.x].xyyw
    temp0.xyz = temp1.xyx * float3(-0.5, -0.5, -0.5);
    // mad r0.z, c11[a0.x].x, -r1.y, r0.z
    temp0.z = float1(-0.5) * -temp1.y + temp0.z;
    // mov r1.xy, c11[a0.x]
    temp1.xy = float2(-0.5, -0.5);
    // mad oT0.xy, r1, c13.zwzw, c13.x
    o.texcoord = temp1 * float4(1, -1, 1, -1) + float4(0.5, 0.5, 0.5, 0.5);
    // add r0.x, r0.y, r0.x
    temp0.x = temp0.y + temp0.x;
    // mul r0.yzw, r0.z, c21.xxyz
    temp0.yzw = temp0.zzz * (View._m01_m11_m21_m31).xyz;
    // mad r0.xyz, r0.x, c20, r0.yzww
    temp0.xyz = temp0.xxx * (View._m00_m10_m20_m30).xyz + temp0.yzw;
    // mov r1.xyz, v0
    temp1.xyz = i.position.xyz;
    // mad r0.xyz, v1.y, r0, r1
    temp0.xyz = i.texcoord.yyy * temp0.xyz + temp1.xyz;
    // mov r0.w, c13.z
    temp0.w = float1(1);
    // dp4 oPos.x, r0, c119
    o.position.x = dot(temp0, (ViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c120
    o.position.y = dot(temp0, (ViewProjection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c121
    o.position.z = dot(temp0, (ViewProjection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c122
    o.position.w = dot(temp0, (ViewProjection._m03_m13_m23_m33));
    // mov oD0, v2
    o.color = i.color;
    // 

    return o;
}

// ATestSpriteShaderBillboard_M_PixelShader7 Pixel_2_0 Has PRES False
struct ATestSpriteShaderBillboard_M_PixelShader7_Input
{
    float4 color : COLOR;
    float2 texcoord : TEXCOORD;
};

float4 ATestSpriteShaderBillboard_M_PixelShader7(ATestSpriteShaderBillboard_M_PixelShader7_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    // dcl v0
    // dcl t0.xy
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(ParticleTextureSampler, i.texcoord.xy);
    // mul r0, r0, v0
    temp0 = temp0 * i.color;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// ATestSpriteShaderBillboard_M_VertexShader8 Vertex_2_0 Has PRES False
struct ATestSpriteShaderBillboard_M_VertexShader8_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct ATestSpriteShaderBillboard_M_VertexShader8_Output
{
    float2 texcoord : TEXCOORD;
    float4 position : POSITION;
    float4 color : COLOR;
};

ATestSpriteShaderBillboard_M_VertexShader8_Output ATestSpriteShaderBillboard_M_VertexShader8(ATestSpriteShaderBillboard_M_VertexShader8_Input i)
{
    ATestSpriteShaderBillboard_M_VertexShader8_Output o;
    float4 temp0;
    float3 temp1;
    float addr0;
    // def c12, 0.5, -0.5, 6.283185, -3.141593
    // def c11, -0.5, -0.5, 0.1591549, 0.5
    // def c13, 0.5, 0.5, 1, -1
    // def c14, -0.5, 0.5, 0, 0
    // def c15, 0, 0, 0, 0
    // def c16, -0.25, -0.25, 0, 0
    // def c17, 0.25, -0.25, 0, 0
    // def c18, 0.25, 0.25, 0, 0
    // def c19, -0.25, 0.25, 0, 0
    // def c0, -1.550099E-06, -2.170139E-05, 0.002604167, 0.0002604167
    // def c1, -0.02083333, -0.125, 1, 0.5
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_color v2
    // mad r0.x, v1.x, c11.z, c11.w
    temp0.x = i.texcoord.x * float1(0.15915494) + float1(0.5);
    // frc r0.x, r0.x
    temp0.x = frac(temp0.x);
    // mad r0.x, r0.x, c12.z, c12.w
    temp0.x = temp0.x * float1(6.2831855) + float1(-3.1415927);
    // sincos r1.xy, r0.x, c0, c1
    temp1.xy = float2(cos(temp0.x), sin(temp0.x));
    // frc r0.x, v0.w
    temp0.x = frac(i.position.w);
    // add r0.x, -r0.x, v0.w
    temp0.x = -temp0.x + i.position.w;
    // mova a0.x, r0.x
    addr0.x = temp0.x;
    // mul r0.xyz, r1.xyxw, c11[a0.x].xyyw
    temp0.xyz = temp1.xyx * float3(-0.5, -0.5, -0.5);
    // mad r0.z, c11[a0.x].x, -r1.y, r0.z
    temp0.z = float1(-0.5) * -temp1.y + temp0.z;
    // mov r1.xy, c11[a0.x]
    temp1.xy = float2(-0.5, -0.5);
    // mad oT0.xy, r1, c13.zwzw, c13.x
    o.texcoord = temp1 * float4(1, -1, 1, -1) + float4(0.5, 0.5, 0.5, 0.5);
    // add r0.x, r0.y, r0.x
    temp0.x = temp0.y + temp0.x;
    // mul r0.yzw, r0.z, c21.xxyz
    temp0.yzw = temp0.zzz * (View._m01_m11_m21_m31).xyz;
    // mad r0.xyz, r0.x, c20, r0.yzww
    temp0.xyz = temp0.xxx * (View._m00_m10_m20_m30).xyz + temp0.yzw;
    // mov r1.xyz, v0
    temp1.xyz = i.position.xyz;
    // mad r0.xyz, v1.y, r0, r1
    temp0.xyz = i.texcoord.yyy * temp0.xyz + temp1.xyz;
    // mov r0.w, c13.z
    temp0.w = float1(1);
    // dp4 oPos.x, r0, c119
    o.position.x = dot(temp0, (ViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c120
    o.position.y = dot(temp0, (ViewProjection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c121
    o.position.z = dot(temp0, (ViewProjection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c122
    o.position.w = dot(temp0, (ViewProjection._m03_m13_m23_m33));
    // mov oD0, v2
    o.color = i.color;
    // 

    return o;
}

// AlphaSpriteShaderBillboard_M_PixelShader9 Pixel_2_0 Has PRES False
struct AlphaSpriteShaderBillboard_M_PixelShader9_Input
{
    float4 color : COLOR;
    float2 texcoord : TEXCOORD;
};

float4 AlphaSpriteShaderBillboard_M_PixelShader9(AlphaSpriteShaderBillboard_M_PixelShader9_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    // dcl v0
    // dcl t0.xy
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(ParticleTextureSampler, i.texcoord.xy);
    // mul r0, r0, v0
    temp0 = temp0 * i.color;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// AlphaSpriteShaderBillboard_M_VertexShader10 Vertex_2_0 Has PRES False
struct AlphaSpriteShaderBillboard_M_VertexShader10_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct AlphaSpriteShaderBillboard_M_VertexShader10_Output
{
    float2 texcoord : TEXCOORD;
    float4 position : POSITION;
    float4 color : COLOR;
};

AlphaSpriteShaderBillboard_M_VertexShader10_Output AlphaSpriteShaderBillboard_M_VertexShader10(AlphaSpriteShaderBillboard_M_VertexShader10_Input i)
{
    AlphaSpriteShaderBillboard_M_VertexShader10_Output o;
    float4 temp0;
    float3 temp1;
    float addr0;
    // def c12, 0.5, -0.5, 6.283185, -3.141593
    // def c11, -0.5, -0.5, 0.1591549, 0.5
    // def c13, 0.5, 0.5, 1, -1
    // def c14, -0.5, 0.5, 0, 0
    // def c15, 0, 0, 0, 0
    // def c16, -0.25, -0.25, 0, 0
    // def c17, 0.25, -0.25, 0, 0
    // def c18, 0.25, 0.25, 0, 0
    // def c19, -0.25, 0.25, 0, 0
    // def c0, -1.550099E-06, -2.170139E-05, 0.002604167, 0.0002604167
    // def c1, -0.02083333, -0.125, 1, 0.5
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_color v2
    // mad r0.x, v1.x, c11.z, c11.w
    temp0.x = i.texcoord.x * float1(0.15915494) + float1(0.5);
    // frc r0.x, r0.x
    temp0.x = frac(temp0.x);
    // mad r0.x, r0.x, c12.z, c12.w
    temp0.x = temp0.x * float1(6.2831855) + float1(-3.1415927);
    // sincos r1.xy, r0.x, c0, c1
    temp1.xy = float2(cos(temp0.x), sin(temp0.x));
    // frc r0.x, v0.w
    temp0.x = frac(i.position.w);
    // add r0.x, -r0.x, v0.w
    temp0.x = -temp0.x + i.position.w;
    // mova a0.x, r0.x
    addr0.x = temp0.x;
    // mul r0.xyz, r1.xyxw, c11[a0.x].xyyw
    temp0.xyz = temp1.xyx * float3(-0.5, -0.5, -0.5);
    // mad r0.z, c11[a0.x].x, -r1.y, r0.z
    temp0.z = float1(-0.5) * -temp1.y + temp0.z;
    // mov r1.xy, c11[a0.x]
    temp1.xy = float2(-0.5, -0.5);
    // mad oT0.xy, r1, c13.zwzw, c13.x
    o.texcoord = temp1 * float4(1, -1, 1, -1) + float4(0.5, 0.5, 0.5, 0.5);
    // add r0.x, r0.y, r0.x
    temp0.x = temp0.y + temp0.x;
    // mul r0.yzw, r0.z, c21.xxyz
    temp0.yzw = temp0.zzz * (View._m01_m11_m21_m31).xyz;
    // mad r0.xyz, r0.x, c20, r0.yzww
    temp0.xyz = temp0.xxx * (View._m00_m10_m20_m30).xyz + temp0.yzw;
    // mov r1.xyz, v0
    temp1.xyz = i.position.xyz;
    // mad r0.xyz, v1.y, r0, r1
    temp0.xyz = i.texcoord.yyy * temp0.xyz + temp1.xyz;
    // mov r0.w, c13.z
    temp0.w = float1(1);
    // dp4 oPos.x, r0, c119
    o.position.x = dot(temp0, (ViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c120
    o.position.y = dot(temp0, (ViewProjection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c121
    o.position.z = dot(temp0, (ViewProjection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c122
    o.position.w = dot(temp0, (ViewProjection._m03_m13_m23_m33));
    // mov oD0, v2
    o.color = i.color;
    // 

    return o;
}

// AdditiveAlphaTestSpriteShaderBillboard_M_PixelShader11 Pixel_2_0 Has PRES False
struct AdditiveAlphaTestSpriteShaderBillboard_M_PixelShader11_Input
{
    float4 color : COLOR;
    float2 texcoord : TEXCOORD;
};

float4 AdditiveAlphaTestSpriteShaderBillboard_M_PixelShader11(AdditiveAlphaTestSpriteShaderBillboard_M_PixelShader11_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    // dcl v0
    // dcl t0.xy
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(ParticleTextureSampler, i.texcoord.xy);
    // mul r0, r0, v0
    temp0 = temp0 * i.color;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// AdditiveAlphaTestSpriteShaderBillboard_M_VertexShader12 Vertex_2_0 Has PRES False
struct AdditiveAlphaTestSpriteShaderBillboard_M_VertexShader12_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct AdditiveAlphaTestSpriteShaderBillboard_M_VertexShader12_Output
{
    float2 texcoord : TEXCOORD;
    float4 position : POSITION;
    float4 color : COLOR;
};

AdditiveAlphaTestSpriteShaderBillboard_M_VertexShader12_Output AdditiveAlphaTestSpriteShaderBillboard_M_VertexShader12(AdditiveAlphaTestSpriteShaderBillboard_M_VertexShader12_Input i)
{
    AdditiveAlphaTestSpriteShaderBillboard_M_VertexShader12_Output o;
    float4 temp0;
    float3 temp1;
    float addr0;
    // def c12, 0.5, -0.5, 6.283185, -3.141593
    // def c11, -0.5, -0.5, 0.1591549, 0.5
    // def c13, 0.5, 0.5, 1, -1
    // def c14, -0.5, 0.5, 0, 0
    // def c15, 0, 0, 0, 0
    // def c16, -0.25, -0.25, 0, 0
    // def c17, 0.25, -0.25, 0, 0
    // def c18, 0.25, 0.25, 0, 0
    // def c19, -0.25, 0.25, 0, 0
    // def c0, -1.550099E-06, -2.170139E-05, 0.002604167, 0.0002604167
    // def c1, -0.02083333, -0.125, 1, 0.5
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_color v2
    // mad r0.x, v1.x, c11.z, c11.w
    temp0.x = i.texcoord.x * float1(0.15915494) + float1(0.5);
    // frc r0.x, r0.x
    temp0.x = frac(temp0.x);
    // mad r0.x, r0.x, c12.z, c12.w
    temp0.x = temp0.x * float1(6.2831855) + float1(-3.1415927);
    // sincos r1.xy, r0.x, c0, c1
    temp1.xy = float2(cos(temp0.x), sin(temp0.x));
    // frc r0.x, v0.w
    temp0.x = frac(i.position.w);
    // add r0.x, -r0.x, v0.w
    temp0.x = -temp0.x + i.position.w;
    // mova a0.x, r0.x
    addr0.x = temp0.x;
    // mul r0.xyz, r1.xyxw, c11[a0.x].xyyw
    temp0.xyz = temp1.xyx * float3(-0.5, -0.5, -0.5);
    // mad r0.z, c11[a0.x].x, -r1.y, r0.z
    temp0.z = float1(-0.5) * -temp1.y + temp0.z;
    // mov r1.xy, c11[a0.x]
    temp1.xy = float2(-0.5, -0.5);
    // mad oT0.xy, r1, c13.zwzw, c13.x
    o.texcoord = temp1 * float4(1, -1, 1, -1) + float4(0.5, 0.5, 0.5, 0.5);
    // add r0.x, r0.y, r0.x
    temp0.x = temp0.y + temp0.x;
    // mul r0.yzw, r0.z, c21.xxyz
    temp0.yzw = temp0.zzz * (View._m01_m11_m21_m31).xyz;
    // mad r0.xyz, r0.x, c20, r0.yzww
    temp0.xyz = temp0.xxx * (View._m00_m10_m20_m30).xyz + temp0.yzw;
    // mov r1.xyz, v0
    temp1.xyz = i.position.xyz;
    // mad r0.xyz, v1.y, r0, r1
    temp0.xyz = i.texcoord.yyy * temp0.xyz + temp1.xyz;
    // mov r0.w, c13.z
    temp0.w = float1(1);
    // dp4 oPos.x, r0, c119
    o.position.x = dot(temp0, (ViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c120
    o.position.y = dot(temp0, (ViewProjection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c121
    o.position.z = dot(temp0, (ViewProjection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c122
    o.position.w = dot(temp0, (ViewProjection._m03_m13_m23_m33));
    // mov oD0, v2
    o.color = i.color;
    // 

    return o;
}

// AdditiveSpriteShaderBillboard_M_PixelShader13 Pixel_2_0 Has PRES False
struct AdditiveSpriteShaderBillboard_M_PixelShader13_Input
{
    float4 color : COLOR;
    float2 texcoord : TEXCOORD;
};

float4 AdditiveSpriteShaderBillboard_M_PixelShader13(AdditiveSpriteShaderBillboard_M_PixelShader13_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    // dcl v0
    // dcl t0.xy
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(ParticleTextureSampler, i.texcoord.xy);
    // mul r0, r0, v0
    temp0 = temp0 * i.color;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// AdditiveSpriteShaderBillboard_M_VertexShader14 Vertex_2_0 Has PRES False
struct AdditiveSpriteShaderBillboard_M_VertexShader14_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct AdditiveSpriteShaderBillboard_M_VertexShader14_Output
{
    float2 texcoord : TEXCOORD;
    float4 position : POSITION;
    float4 color : COLOR;
};

AdditiveSpriteShaderBillboard_M_VertexShader14_Output AdditiveSpriteShaderBillboard_M_VertexShader14(AdditiveSpriteShaderBillboard_M_VertexShader14_Input i)
{
    AdditiveSpriteShaderBillboard_M_VertexShader14_Output o;
    float4 temp0;
    float3 temp1;
    float addr0;
    // def c12, 0.5, -0.5, 6.283185, -3.141593
    // def c11, -0.5, -0.5, 0.1591549, 0.5
    // def c13, 0.5, 0.5, 1, -1
    // def c14, -0.5, 0.5, 0, 0
    // def c15, 0, 0, 0, 0
    // def c16, -0.25, -0.25, 0, 0
    // def c17, 0.25, -0.25, 0, 0
    // def c18, 0.25, 0.25, 0, 0
    // def c19, -0.25, 0.25, 0, 0
    // def c0, -1.550099E-06, -2.170139E-05, 0.002604167, 0.0002604167
    // def c1, -0.02083333, -0.125, 1, 0.5
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_color v2
    // mad r0.x, v1.x, c11.z, c11.w
    temp0.x = i.texcoord.x * float1(0.15915494) + float1(0.5);
    // frc r0.x, r0.x
    temp0.x = frac(temp0.x);
    // mad r0.x, r0.x, c12.z, c12.w
    temp0.x = temp0.x * float1(6.2831855) + float1(-3.1415927);
    // sincos r1.xy, r0.x, c0, c1
    temp1.xy = float2(cos(temp0.x), sin(temp0.x));
    // frc r0.x, v0.w
    temp0.x = frac(i.position.w);
    // add r0.x, -r0.x, v0.w
    temp0.x = -temp0.x + i.position.w;
    // mova a0.x, r0.x
    addr0.x = temp0.x;
    // mul r0.xyz, r1.xyxw, c11[a0.x].xyyw
    temp0.xyz = temp1.xyx * float3(-0.5, -0.5, -0.5);
    // mad r0.z, c11[a0.x].x, -r1.y, r0.z
    temp0.z = float1(-0.5) * -temp1.y + temp0.z;
    // mov r1.xy, c11[a0.x]
    temp1.xy = float2(-0.5, -0.5);
    // mad oT0.xy, r1, c13.zwzw, c13.x
    o.texcoord = temp1 * float4(1, -1, 1, -1) + float4(0.5, 0.5, 0.5, 0.5);
    // add r0.x, r0.y, r0.x
    temp0.x = temp0.y + temp0.x;
    // mul r0.yzw, r0.z, c21.xxyz
    temp0.yzw = temp0.zzz * (View._m01_m11_m21_m31).xyz;
    // mad r0.xyz, r0.x, c20, r0.yzww
    temp0.xyz = temp0.xxx * (View._m00_m10_m20_m30).xyz + temp0.yzw;
    // mov r1.xyz, v0
    temp1.xyz = i.position.xyz;
    // mad r0.xyz, v1.y, r0, r1
    temp0.xyz = i.texcoord.yyy * temp0.xyz + temp1.xyz;
    // mov r0.w, c13.z
    temp0.w = float1(1);
    // dp4 oPos.x, r0, c119
    o.position.x = dot(temp0, (ViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c120
    o.position.y = dot(temp0, (ViewProjection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c121
    o.position.z = dot(temp0, (ViewProjection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c122
    o.position.w = dot(temp0, (ViewProjection._m03_m13_m23_m33));
    // mov oD0, v2
    o.color = i.color;
    // 

    return o;
}

// Alpha2DShader_M_PixelShader15 Pixel_2_0 Has PRES False
struct Alpha2DShader_M_PixelShader15_Input
{
    float4 color : COLOR;
    float2 texcoord : TEXCOORD;
};

float4 Alpha2DShader_M_PixelShader15(Alpha2DShader_M_PixelShader15_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    // dcl v0
    // dcl t0.xy
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(ParticleTextureSampler, i.texcoord.xy);
    // mul r0, r0, v0
    temp0 = temp0 * i.color;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// Alpha2DShader_M_VertexShader16 Vertex_2_0 Has PRES False
struct Alpha2DShader_M_VertexShader16_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct Alpha2DShader_M_VertexShader16_Output
{
    float2 texcoord : TEXCOORD;
    float4 position : POSITION;
    float4 color : COLOR;
};

Alpha2DShader_M_VertexShader16_Output Alpha2DShader_M_VertexShader16(Alpha2DShader_M_VertexShader16_Input i)
{
    Alpha2DShader_M_VertexShader16_Output o;
    float4 temp0;
    float2 temp1;
    float addr0;
    // def c12, 0.5, -0.5, 6.283185, -3.141593
    // def c11, -0.5, -0.5, 0.1591549, 0.5
    // def c14, -0.5, 0.5, 1, -1
    // def c13, 0.5, 0.5, 1, 0
    // def c15, 0, 0, 0, 0
    // def c16, -0.25, -0.25, 0, 0
    // def c17, 0.25, -0.25, 0, 0
    // def c18, 0.25, 0.25, 0, 0
    // def c19, -0.25, 0.25, 0, 0
    // def c0, -1.550099E-06, -2.170139E-05, 0.002604167, 0.0002604167
    // def c1, -0.02083333, -0.125, 1, 0.5
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_color v2
    // mad r0.x, v1.x, c11.z, c11.w
    temp0.x = i.texcoord.x * float1(0.15915494) + float1(0.5);
    // frc r0.x, r0.x
    temp0.x = frac(temp0.x);
    // mad r0.x, r0.x, c12.z, c12.w
    temp0.x = temp0.x * float1(6.2831855) + float1(-3.1415927);
    // sincos r1.xy, r0.x, c0, c1
    temp1.xy = float2(cos(temp0.x), sin(temp0.x));
    // frc r0.x, v0.w
    temp0.x = frac(i.position.w);
    // add r0.x, -r0.x, v0.w
    temp0.x = -temp0.x + i.position.w;
    // mova a0.x, r0.x
    addr0.x = temp0.x;
    // mul r0.xyz, r1.xyxw, c11[a0.x].xyyw
    temp0.xyz = temp1.xyx * float3(-0.5, -0.5, -0.5);
    // mad r0.w, c11[a0.x].x, -r1.y, r0.z
    temp0.w = float1(-0.5) * -temp1.y + temp0.z;
    // mov r1.xy, c11[a0.x]
    temp1.xy = float2(-0.5, -0.5);
    // mad oT0.xy, r1, c14.zwzw, c14.y
    o.texcoord = temp1 * float4(1, -1, 1, -1) + float4(0.5, 0.5, 0.5, 0.5);
    // add r0.z, r0.y, r0.x
    temp0.z = temp0.y + temp0.x;
    // mov r0.xy, v0
    temp0.xy = i.position.xy;
    // mad r0.xy, v1.y, r0.zwzw, r0
    temp0.xy = i.texcoord.yy * temp0.zw + temp0.xy;
    // mad r0.zw, v0.z, c13, c13.xywz
    temp0.zw = i.position.zz * float2(1, 0) + float2(0, 1);
    // dp4 oPos.x, r0, c119
    o.position.x = dot(temp0, (ViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c120
    o.position.y = dot(temp0, (ViewProjection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c121
    o.position.z = dot(temp0, (ViewProjection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c122
    o.position.w = dot(temp0, (ViewProjection._m03_m13_m23_m33));
    // mov oD0, v2
    o.color = i.color;
    // 

    return o;
}

// Additive2DShader_M_PixelShader17 Pixel_2_0 Has PRES False
struct Additive2DShader_M_PixelShader17_Input
{
    float4 color : COLOR;
    float2 texcoord : TEXCOORD;
};

float4 Additive2DShader_M_PixelShader17(Additive2DShader_M_PixelShader17_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    // dcl v0
    // dcl t0.xy
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(ParticleTextureSampler, i.texcoord.xy);
    // mul r0, r0, v0
    temp0 = temp0 * i.color;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// Additive2DShader_M_VertexShader18 Vertex_2_0 Has PRES False
struct Additive2DShader_M_VertexShader18_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct Additive2DShader_M_VertexShader18_Output
{
    float2 texcoord : TEXCOORD;
    float4 position : POSITION;
    float4 color : COLOR;
};

Additive2DShader_M_VertexShader18_Output Additive2DShader_M_VertexShader18(Additive2DShader_M_VertexShader18_Input i)
{
    Additive2DShader_M_VertexShader18_Output o;
    float4 temp0;
    float2 temp1;
    float addr0;
    // def c12, 0.5, -0.5, 6.283185, -3.141593
    // def c11, -0.5, -0.5, 0.1591549, 0.5
    // def c14, -0.5, 0.5, 1, -1
    // def c13, 0.5, 0.5, 1, 0
    // def c15, 0, 0, 0, 0
    // def c16, -0.25, -0.25, 0, 0
    // def c17, 0.25, -0.25, 0, 0
    // def c18, 0.25, 0.25, 0, 0
    // def c19, -0.25, 0.25, 0, 0
    // def c0, -1.550099E-06, -2.170139E-05, 0.002604167, 0.0002604167
    // def c1, -0.02083333, -0.125, 1, 0.5
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_color v2
    // mad r0.x, v1.x, c11.z, c11.w
    temp0.x = i.texcoord.x * float1(0.15915494) + float1(0.5);
    // frc r0.x, r0.x
    temp0.x = frac(temp0.x);
    // mad r0.x, r0.x, c12.z, c12.w
    temp0.x = temp0.x * float1(6.2831855) + float1(-3.1415927);
    // sincos r1.xy, r0.x, c0, c1
    temp1.xy = float2(cos(temp0.x), sin(temp0.x));
    // frc r0.x, v0.w
    temp0.x = frac(i.position.w);
    // add r0.x, -r0.x, v0.w
    temp0.x = -temp0.x + i.position.w;
    // mova a0.x, r0.x
    addr0.x = temp0.x;
    // mul r0.xyz, r1.xyxw, c11[a0.x].xyyw
    temp0.xyz = temp1.xyx * float3(-0.5, -0.5, -0.5);
    // mad r0.w, c11[a0.x].x, -r1.y, r0.z
    temp0.w = float1(-0.5) * -temp1.y + temp0.z;
    // mov r1.xy, c11[a0.x]
    temp1.xy = float2(-0.5, -0.5);
    // mad oT0.xy, r1, c14.zwzw, c14.y
    o.texcoord = temp1 * float4(1, -1, 1, -1) + float4(0.5, 0.5, 0.5, 0.5);
    // add r0.z, r0.y, r0.x
    temp0.z = temp0.y + temp0.x;
    // mov r0.xy, v0
    temp0.xy = i.position.xy;
    // mad r0.xy, v1.y, r0.zwzw, r0
    temp0.xy = i.texcoord.yy * temp0.zw + temp0.xy;
    // mad r0.zw, v0.z, c13, c13.xywz
    temp0.zw = i.position.zz * float2(1, 0) + float2(0, 1);
    // dp4 oPos.x, r0, c119
    o.position.x = dot(temp0, (ViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c120
    o.position.y = dot(temp0, (ViewProjection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c121
    o.position.z = dot(temp0, (ViewProjection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c122
    o.position.w = dot(temp0, (ViewProjection._m03_m13_m23_m33));
    // mov oD0, v2
    o.color = i.color;
    // 

    return o;
}

// MultiplicativeSpriteShader_M_PixelShader19 Pixel_2_0 Has PRES False
struct MultiplicativeSpriteShader_M_PixelShader19_Input
{
    float4 color : COLOR;
    float2 texcoord : TEXCOORD;
};

float4 MultiplicativeSpriteShader_M_PixelShader19(MultiplicativeSpriteShader_M_PixelShader19_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    // dcl v0
    // dcl t0.xy
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(ParticleTextureSampler, i.texcoord.xy);
    // mul r0, r0, v0
    temp0 = temp0 * i.color;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// MultiplicativeSpriteShader_M_VertexShader20 Vertex_2_0 Has PRES False
struct MultiplicativeSpriteShader_M_VertexShader20_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct MultiplicativeSpriteShader_M_VertexShader20_Output
{
    float2 texcoord : TEXCOORD;
    float4 position : POSITION;
    float4 color : COLOR;
};

MultiplicativeSpriteShader_M_VertexShader20_Output MultiplicativeSpriteShader_M_VertexShader20(MultiplicativeSpriteShader_M_VertexShader20_Input i)
{
    MultiplicativeSpriteShader_M_VertexShader20_Output o;
    float4 temp0;
    float2 temp1;
    float addr0;
    // def c12, 0.5, -0.5, 6.283185, -3.141593
    // def c11, -0.5, -0.5, 0.1591549, 0.5
    // def c14, -0.5, 0.5, 1, -1
    // def c13, 0.5, 0.5, 1, 0
    // def c15, 0, 0, 0, 0
    // def c16, -0.25, -0.25, 0, 0
    // def c17, 0.25, -0.25, 0, 0
    // def c18, 0.25, 0.25, 0, 0
    // def c19, -0.25, 0.25, 0, 0
    // def c0, -1.550099E-06, -2.170139E-05, 0.002604167, 0.0002604167
    // def c1, -0.02083333, -0.125, 1, 0.5
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_color v2
    // mad r0.x, v1.x, c11.z, c11.w
    temp0.x = i.texcoord.x * float1(0.15915494) + float1(0.5);
    // frc r0.x, r0.x
    temp0.x = frac(temp0.x);
    // mad r0.x, r0.x, c12.z, c12.w
    temp0.x = temp0.x * float1(6.2831855) + float1(-3.1415927);
    // sincos r1.xy, r0.x, c0, c1
    temp1.xy = float2(cos(temp0.x), sin(temp0.x));
    // frc r0.x, v0.w
    temp0.x = frac(i.position.w);
    // add r0.x, -r0.x, v0.w
    temp0.x = -temp0.x + i.position.w;
    // mova a0.x, r0.x
    addr0.x = temp0.x;
    // mul r0.xyz, r1.xyxw, c11[a0.x].xyyw
    temp0.xyz = temp1.xyx * float3(-0.5, -0.5, -0.5);
    // mad r0.w, c11[a0.x].x, -r1.y, r0.z
    temp0.w = float1(-0.5) * -temp1.y + temp0.z;
    // mov r1.xy, c11[a0.x]
    temp1.xy = float2(-0.5, -0.5);
    // mad oT0.xy, r1, c14.zwzw, c14.y
    o.texcoord = temp1 * float4(1, -1, 1, -1) + float4(0.5, 0.5, 0.5, 0.5);
    // add r0.z, r0.y, r0.x
    temp0.z = temp0.y + temp0.x;
    // mov r0.xy, v0
    temp0.xy = i.position.xy;
    // mad r0.xy, v1.y, r0.zwzw, r0
    temp0.xy = i.texcoord.yy * temp0.zw + temp0.xy;
    // mad r0.zw, v0.z, c13, c13.xywz
    temp0.zw = i.position.zz * float2(1, 0) + float2(0, 1);
    // dp4 oPos.x, r0, c119
    o.position.x = dot(temp0, (ViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c120
    o.position.y = dot(temp0, (ViewProjection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c121
    o.position.z = dot(temp0, (ViewProjection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c122
    o.position.w = dot(temp0, (ViewProjection._m03_m13_m23_m33));
    // mov oD0, v2
    o.color = i.color;
    // 

    return o;
}

// ATestSpriteShader_M_PixelShader21 Pixel_2_0 Has PRES False
struct ATestSpriteShader_M_PixelShader21_Input
{
    float4 color : COLOR;
    float2 texcoord : TEXCOORD;
};

float4 ATestSpriteShader_M_PixelShader21(ATestSpriteShader_M_PixelShader21_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    // dcl v0
    // dcl t0.xy
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(ParticleTextureSampler, i.texcoord.xy);
    // mul r0, r0, v0
    temp0 = temp0 * i.color;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// ATestSpriteShader_M_VertexShader22 Vertex_2_0 Has PRES False
struct ATestSpriteShader_M_VertexShader22_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct ATestSpriteShader_M_VertexShader22_Output
{
    float2 texcoord : TEXCOORD;
    float4 position : POSITION;
    float4 color : COLOR;
};

ATestSpriteShader_M_VertexShader22_Output ATestSpriteShader_M_VertexShader22(ATestSpriteShader_M_VertexShader22_Input i)
{
    ATestSpriteShader_M_VertexShader22_Output o;
    float4 temp0;
    float2 temp1;
    float addr0;
    // def c12, 0.5, -0.5, 6.283185, -3.141593
    // def c11, -0.5, -0.5, 0.1591549, 0.5
    // def c14, -0.5, 0.5, 1, -1
    // def c13, 0.5, 0.5, 1, 0
    // def c15, 0, 0, 0, 0
    // def c16, -0.25, -0.25, 0, 0
    // def c17, 0.25, -0.25, 0, 0
    // def c18, 0.25, 0.25, 0, 0
    // def c19, -0.25, 0.25, 0, 0
    // def c0, -1.550099E-06, -2.170139E-05, 0.002604167, 0.0002604167
    // def c1, -0.02083333, -0.125, 1, 0.5
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_color v2
    // mad r0.x, v1.x, c11.z, c11.w
    temp0.x = i.texcoord.x * float1(0.15915494) + float1(0.5);
    // frc r0.x, r0.x
    temp0.x = frac(temp0.x);
    // mad r0.x, r0.x, c12.z, c12.w
    temp0.x = temp0.x * float1(6.2831855) + float1(-3.1415927);
    // sincos r1.xy, r0.x, c0, c1
    temp1.xy = float2(cos(temp0.x), sin(temp0.x));
    // frc r0.x, v0.w
    temp0.x = frac(i.position.w);
    // add r0.x, -r0.x, v0.w
    temp0.x = -temp0.x + i.position.w;
    // mova a0.x, r0.x
    addr0.x = temp0.x;
    // mul r0.xyz, r1.xyxw, c11[a0.x].xyyw
    temp0.xyz = temp1.xyx * float3(-0.5, -0.5, -0.5);
    // mad r0.w, c11[a0.x].x, -r1.y, r0.z
    temp0.w = float1(-0.5) * -temp1.y + temp0.z;
    // mov r1.xy, c11[a0.x]
    temp1.xy = float2(-0.5, -0.5);
    // mad oT0.xy, r1, c14.zwzw, c14.y
    o.texcoord = temp1 * float4(1, -1, 1, -1) + float4(0.5, 0.5, 0.5, 0.5);
    // add r0.z, r0.y, r0.x
    temp0.z = temp0.y + temp0.x;
    // mov r0.xy, v0
    temp0.xy = i.position.xy;
    // mad r0.xy, v1.y, r0.zwzw, r0
    temp0.xy = i.texcoord.yy * temp0.zw + temp0.xy;
    // mad r0.zw, v0.z, c13, c13.xywz
    temp0.zw = i.position.zz * float2(1, 0) + float2(0, 1);
    // dp4 oPos.x, r0, c119
    o.position.x = dot(temp0, (ViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c120
    o.position.y = dot(temp0, (ViewProjection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c121
    o.position.z = dot(temp0, (ViewProjection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c122
    o.position.w = dot(temp0, (ViewProjection._m03_m13_m23_m33));
    // mov oD0, v2
    o.color = i.color;
    // 

    return o;
}

// AlphaSpriteShader_M_PixelShader23 Pixel_2_0 Has PRES False
struct AlphaSpriteShader_M_PixelShader23_Input
{
    float4 color : COLOR;
    float2 texcoord : TEXCOORD;
};

float4 AlphaSpriteShader_M_PixelShader23(AlphaSpriteShader_M_PixelShader23_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    // dcl v0
    // dcl t0.xy
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(ParticleTextureSampler, i.texcoord.xy);
    // mul r0, r0, v0
    temp0 = temp0 * i.color;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// AlphaSpriteShader_M_VertexShader24 Vertex_2_0 Has PRES False
struct AlphaSpriteShader_M_VertexShader24_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct AlphaSpriteShader_M_VertexShader24_Output
{
    float2 texcoord : TEXCOORD;
    float4 position : POSITION;
    float4 color : COLOR;
};

AlphaSpriteShader_M_VertexShader24_Output AlphaSpriteShader_M_VertexShader24(AlphaSpriteShader_M_VertexShader24_Input i)
{
    AlphaSpriteShader_M_VertexShader24_Output o;
    float4 temp0;
    float2 temp1;
    float addr0;
    // def c12, 0.5, -0.5, 6.283185, -3.141593
    // def c11, -0.5, -0.5, 0.1591549, 0.5
    // def c14, -0.5, 0.5, 1, -1
    // def c13, 0.5, 0.5, 1, 0
    // def c15, 0, 0, 0, 0
    // def c16, -0.25, -0.25, 0, 0
    // def c17, 0.25, -0.25, 0, 0
    // def c18, 0.25, 0.25, 0, 0
    // def c19, -0.25, 0.25, 0, 0
    // def c0, -1.550099E-06, -2.170139E-05, 0.002604167, 0.0002604167
    // def c1, -0.02083333, -0.125, 1, 0.5
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_color v2
    // mad r0.x, v1.x, c11.z, c11.w
    temp0.x = i.texcoord.x * float1(0.15915494) + float1(0.5);
    // frc r0.x, r0.x
    temp0.x = frac(temp0.x);
    // mad r0.x, r0.x, c12.z, c12.w
    temp0.x = temp0.x * float1(6.2831855) + float1(-3.1415927);
    // sincos r1.xy, r0.x, c0, c1
    temp1.xy = float2(cos(temp0.x), sin(temp0.x));
    // frc r0.x, v0.w
    temp0.x = frac(i.position.w);
    // add r0.x, -r0.x, v0.w
    temp0.x = -temp0.x + i.position.w;
    // mova a0.x, r0.x
    addr0.x = temp0.x;
    // mul r0.xyz, r1.xyxw, c11[a0.x].xyyw
    temp0.xyz = temp1.xyx * float3(-0.5, -0.5, -0.5);
    // mad r0.w, c11[a0.x].x, -r1.y, r0.z
    temp0.w = float1(-0.5) * -temp1.y + temp0.z;
    // mov r1.xy, c11[a0.x]
    temp1.xy = float2(-0.5, -0.5);
    // mad oT0.xy, r1, c14.zwzw, c14.y
    o.texcoord = temp1 * float4(1, -1, 1, -1) + float4(0.5, 0.5, 0.5, 0.5);
    // add r0.z, r0.y, r0.x
    temp0.z = temp0.y + temp0.x;
    // mov r0.xy, v0
    temp0.xy = i.position.xy;
    // mad r0.xy, v1.y, r0.zwzw, r0
    temp0.xy = i.texcoord.yy * temp0.zw + temp0.xy;
    // mad r0.zw, v0.z, c13, c13.xywz
    temp0.zw = i.position.zz * float2(1, 0) + float2(0, 1);
    // dp4 oPos.x, r0, c119
    o.position.x = dot(temp0, (ViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c120
    o.position.y = dot(temp0, (ViewProjection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c121
    o.position.z = dot(temp0, (ViewProjection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c122
    o.position.w = dot(temp0, (ViewProjection._m03_m13_m23_m33));
    // mov oD0, v2
    o.color = i.color;
    // 

    return o;
}

// AdditiveAlphaTestSpriteShader_M_PixelShader25 Pixel_2_0 Has PRES False
struct AdditiveAlphaTestSpriteShader_M_PixelShader25_Input
{
    float4 color : COLOR;
    float2 texcoord : TEXCOORD;
};

float4 AdditiveAlphaTestSpriteShader_M_PixelShader25(AdditiveAlphaTestSpriteShader_M_PixelShader25_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    // dcl v0
    // dcl t0.xy
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(ParticleTextureSampler, i.texcoord.xy);
    // mul r0, r0, v0
    temp0 = temp0 * i.color;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// AdditiveAlphaTestSpriteShader_M_VertexShader26 Vertex_2_0 Has PRES False
struct AdditiveAlphaTestSpriteShader_M_VertexShader26_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct AdditiveAlphaTestSpriteShader_M_VertexShader26_Output
{
    float2 texcoord : TEXCOORD;
    float4 position : POSITION;
    float4 color : COLOR;
};

AdditiveAlphaTestSpriteShader_M_VertexShader26_Output AdditiveAlphaTestSpriteShader_M_VertexShader26(AdditiveAlphaTestSpriteShader_M_VertexShader26_Input i)
{
    AdditiveAlphaTestSpriteShader_M_VertexShader26_Output o;
    float4 temp0;
    float2 temp1;
    float addr0;
    // def c12, 0.5, -0.5, 6.283185, -3.141593
    // def c11, -0.5, -0.5, 0.1591549, 0.5
    // def c14, -0.5, 0.5, 1, -1
    // def c13, 0.5, 0.5, 1, 0
    // def c15, 0, 0, 0, 0
    // def c16, -0.25, -0.25, 0, 0
    // def c17, 0.25, -0.25, 0, 0
    // def c18, 0.25, 0.25, 0, 0
    // def c19, -0.25, 0.25, 0, 0
    // def c0, -1.550099E-06, -2.170139E-05, 0.002604167, 0.0002604167
    // def c1, -0.02083333, -0.125, 1, 0.5
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_color v2
    // mad r0.x, v1.x, c11.z, c11.w
    temp0.x = i.texcoord.x * float1(0.15915494) + float1(0.5);
    // frc r0.x, r0.x
    temp0.x = frac(temp0.x);
    // mad r0.x, r0.x, c12.z, c12.w
    temp0.x = temp0.x * float1(6.2831855) + float1(-3.1415927);
    // sincos r1.xy, r0.x, c0, c1
    temp1.xy = float2(cos(temp0.x), sin(temp0.x));
    // frc r0.x, v0.w
    temp0.x = frac(i.position.w);
    // add r0.x, -r0.x, v0.w
    temp0.x = -temp0.x + i.position.w;
    // mova a0.x, r0.x
    addr0.x = temp0.x;
    // mul r0.xyz, r1.xyxw, c11[a0.x].xyyw
    temp0.xyz = temp1.xyx * float3(-0.5, -0.5, -0.5);
    // mad r0.w, c11[a0.x].x, -r1.y, r0.z
    temp0.w = float1(-0.5) * -temp1.y + temp0.z;
    // mov r1.xy, c11[a0.x]
    temp1.xy = float2(-0.5, -0.5);
    // mad oT0.xy, r1, c14.zwzw, c14.y
    o.texcoord = temp1 * float4(1, -1, 1, -1) + float4(0.5, 0.5, 0.5, 0.5);
    // add r0.z, r0.y, r0.x
    temp0.z = temp0.y + temp0.x;
    // mov r0.xy, v0
    temp0.xy = i.position.xy;
    // mad r0.xy, v1.y, r0.zwzw, r0
    temp0.xy = i.texcoord.yy * temp0.zw + temp0.xy;
    // mad r0.zw, v0.z, c13, c13.xywz
    temp0.zw = i.position.zz * float2(1, 0) + float2(0, 1);
    // dp4 oPos.x, r0, c119
    o.position.x = dot(temp0, (ViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c120
    o.position.y = dot(temp0, (ViewProjection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c121
    o.position.z = dot(temp0, (ViewProjection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c122
    o.position.w = dot(temp0, (ViewProjection._m03_m13_m23_m33));
    // mov oD0, v2
    o.color = i.color;
    // 

    return o;
}

// AdditiveSpriteShader_M_PixelShader27 Pixel_2_0 Has PRES False
struct AdditiveSpriteShader_M_PixelShader27_Input
{
    float4 color : COLOR;
    float2 texcoord : TEXCOORD;
};

float4 AdditiveSpriteShader_M_PixelShader27(AdditiveSpriteShader_M_PixelShader27_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    // dcl v0
    // dcl t0.xy
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(ParticleTextureSampler, i.texcoord.xy);
    // mul r0, r0, v0
    temp0 = temp0 * i.color;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// AdditiveSpriteShader_M_VertexShader28 Vertex_2_0 Has PRES False
struct AdditiveSpriteShader_M_VertexShader28_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct AdditiveSpriteShader_M_VertexShader28_Output
{
    float2 texcoord : TEXCOORD;
    float4 position : POSITION;
    float4 color : COLOR;
};

AdditiveSpriteShader_M_VertexShader28_Output AdditiveSpriteShader_M_VertexShader28(AdditiveSpriteShader_M_VertexShader28_Input i)
{
    AdditiveSpriteShader_M_VertexShader28_Output o;
    float4 temp0;
    float2 temp1;
    float addr0;
    // def c12, 0.5, -0.5, 6.283185, -3.141593
    // def c11, -0.5, -0.5, 0.1591549, 0.5
    // def c14, -0.5, 0.5, 1, -1
    // def c13, 0.5, 0.5, 1, 0
    // def c15, 0, 0, 0, 0
    // def c16, -0.25, -0.25, 0, 0
    // def c17, 0.25, -0.25, 0, 0
    // def c18, 0.25, 0.25, 0, 0
    // def c19, -0.25, 0.25, 0, 0
    // def c0, -1.550099E-06, -2.170139E-05, 0.002604167, 0.0002604167
    // def c1, -0.02083333, -0.125, 1, 0.5
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_color v2
    // mad r0.x, v1.x, c11.z, c11.w
    temp0.x = i.texcoord.x * float1(0.15915494) + float1(0.5);
    // frc r0.x, r0.x
    temp0.x = frac(temp0.x);
    // mad r0.x, r0.x, c12.z, c12.w
    temp0.x = temp0.x * float1(6.2831855) + float1(-3.1415927);
    // sincos r1.xy, r0.x, c0, c1
    temp1.xy = float2(cos(temp0.x), sin(temp0.x));
    // frc r0.x, v0.w
    temp0.x = frac(i.position.w);
    // add r0.x, -r0.x, v0.w
    temp0.x = -temp0.x + i.position.w;
    // mova a0.x, r0.x
    addr0.x = temp0.x;
    // mul r0.xyz, r1.xyxw, c11[a0.x].xyyw
    temp0.xyz = temp1.xyx * float3(-0.5, -0.5, -0.5);
    // mad r0.w, c11[a0.x].x, -r1.y, r0.z
    temp0.w = float1(-0.5) * -temp1.y + temp0.z;
    // mov r1.xy, c11[a0.x]
    temp1.xy = float2(-0.5, -0.5);
    // mad oT0.xy, r1, c14.zwzw, c14.y
    o.texcoord = temp1 * float4(1, -1, 1, -1) + float4(0.5, 0.5, 0.5, 0.5);
    // add r0.z, r0.y, r0.x
    temp0.z = temp0.y + temp0.x;
    // mov r0.xy, v0
    temp0.xy = i.position.xy;
    // mad r0.xy, v1.y, r0.zwzw, r0
    temp0.xy = i.texcoord.yy * temp0.zw + temp0.xy;
    // mad r0.zw, v0.z, c13, c13.xywz
    temp0.zw = i.position.zz * float2(1, 0) + float2(0, 1);
    // dp4 oPos.x, r0, c119
    o.position.x = dot(temp0, (ViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c120
    o.position.y = dot(temp0, (ViewProjection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c121
    o.position.z = dot(temp0, (ViewProjection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c122
    o.position.w = dot(temp0, (ViewProjection._m03_m13_m23_m33));
    // mov oD0, v2
    o.color = i.color;
    // 

    return o;
}

// Alpha2DShaderBillboard_PixelShader29 Pixel_2_0 Has PRES False
struct Alpha2DShaderBillboard_PixelShader29_Input
{
    float4 color : COLOR;
    float2 texcoord : TEXCOORD;
};

float4 Alpha2DShaderBillboard_PixelShader29(Alpha2DShaderBillboard_PixelShader29_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    float3 temp1;
    // def c0, 2.2, 0, 0, 0
    // dcl v0
    // dcl t0.xy
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(ParticleTextureSampler, i.texcoord.xy);
    // log r1.x, r0.x
    temp1.x = log2(temp0.x);
    // log r1.y, r0.y
    temp1.y = log2(temp0.y);
    // log r1.z, r0.z
    temp1.z = log2(temp0.z);
    // mul r1.xyz, r1, c0.x
    temp1.xyz = temp1.xyz * float3(2.2, 2.2, 2.2);
    // exp r0.x, r1.x
    temp0.x = exp2(temp1.x);
    // exp r0.y, r1.y
    temp0.y = exp2(temp1.y);
    // exp r0.z, r1.z
    temp0.z = exp2(temp1.z);
    // mul r0, r0, v0
    temp0 = temp0 * i.color;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// Alpha2DShaderBillboard_VertexShader30 Vertex_2_0 Has PRES False
struct Alpha2DShaderBillboard_VertexShader30_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct Alpha2DShaderBillboard_VertexShader30_Output
{
    float2 texcoord : TEXCOORD;
    float4 position : POSITION;
    float4 color : COLOR;
};

Alpha2DShaderBillboard_VertexShader30_Output Alpha2DShaderBillboard_VertexShader30(Alpha2DShaderBillboard_VertexShader30_Input i)
{
    Alpha2DShaderBillboard_VertexShader30_Output o;
    float4 temp0;
    float3 temp1;
    float addr0;
    // def c12, 0.5, -0.5, 6.283185, -3.141593
    // def c11, -0.5, -0.5, 0.1591549, 0.5
    // def c13, 0.5, 0.5, 1, -1
    // def c14, -0.5, 0.5, 0, 0
    // def c15, 0, 0, 0, 0
    // def c16, -0.25, -0.25, 0, 0
    // def c17, 0.25, -0.25, 0, 0
    // def c18, 0.25, 0.25, 0, 0
    // def c19, -0.25, 0.25, 0, 0
    // def c0, -1.550099E-06, -2.170139E-05, 0.002604167, 0.0002604167
    // def c1, -0.02083333, -0.125, 1, 0.5
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_color v2
    // mad r0.x, v1.x, c11.z, c11.w
    temp0.x = i.texcoord.x * float1(0.15915494) + float1(0.5);
    // frc r0.x, r0.x
    temp0.x = frac(temp0.x);
    // mad r0.x, r0.x, c12.z, c12.w
    temp0.x = temp0.x * float1(6.2831855) + float1(-3.1415927);
    // sincos r1.xy, r0.x, c0, c1
    temp1.xy = float2(cos(temp0.x), sin(temp0.x));
    // frc r0.x, v0.w
    temp0.x = frac(i.position.w);
    // add r0.x, -r0.x, v0.w
    temp0.x = -temp0.x + i.position.w;
    // mova a0.x, r0.x
    addr0.x = temp0.x;
    // mul r0.xyz, r1.xyxw, c11[a0.x].xyyw
    temp0.xyz = temp1.xyx * float3(-0.5, -0.5, -0.5);
    // mad r0.z, c11[a0.x].x, -r1.y, r0.z
    temp0.z = float1(-0.5) * -temp1.y + temp0.z;
    // mov r1.xy, c11[a0.x]
    temp1.xy = float2(-0.5, -0.5);
    // mad oT0.xy, r1, c13.zwzw, c13.x
    o.texcoord = temp1 * float4(1, -1, 1, -1) + float4(0.5, 0.5, 0.5, 0.5);
    // add r0.x, r0.y, r0.x
    temp0.x = temp0.y + temp0.x;
    // mul r0.yzw, r0.z, c21.xxyz
    temp0.yzw = temp0.zzz * (View._m01_m11_m21_m31).xyz;
    // mad r0.xyz, r0.x, c20, r0.yzww
    temp0.xyz = temp0.xxx * (View._m00_m10_m20_m30).xyz + temp0.yzw;
    // mov r1.xyz, v0
    temp1.xyz = i.position.xyz;
    // mad r0.xyz, v1.y, r0, r1
    temp0.xyz = i.texcoord.yyy * temp0.xyz + temp1.xyz;
    // mov r0.w, c13.z
    temp0.w = float1(1);
    // dp4 oPos.x, r0, c119
    o.position.x = dot(temp0, (ViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c120
    o.position.y = dot(temp0, (ViewProjection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c121
    o.position.z = dot(temp0, (ViewProjection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c122
    o.position.w = dot(temp0, (ViewProjection._m03_m13_m23_m33));
    // mov oD0, v2
    o.color = i.color;
    // 

    return o;
}

// Additive2DShaderBillboard_PixelShader31 Pixel_2_0 Has PRES False
struct Additive2DShaderBillboard_PixelShader31_Input
{
    float4 color : COLOR;
    float2 texcoord : TEXCOORD;
};

float4 Additive2DShaderBillboard_PixelShader31(Additive2DShaderBillboard_PixelShader31_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    float3 temp1;
    // def c0, 2.2, 0, 0, 0
    // dcl v0
    // dcl t0.xy
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(ParticleTextureSampler, i.texcoord.xy);
    // log r1.x, r0.x
    temp1.x = log2(temp0.x);
    // log r1.y, r0.y
    temp1.y = log2(temp0.y);
    // log r1.z, r0.z
    temp1.z = log2(temp0.z);
    // mul r1.xyz, r1, c0.x
    temp1.xyz = temp1.xyz * float3(2.2, 2.2, 2.2);
    // exp r0.x, r1.x
    temp0.x = exp2(temp1.x);
    // exp r0.y, r1.y
    temp0.y = exp2(temp1.y);
    // exp r0.z, r1.z
    temp0.z = exp2(temp1.z);
    // mul r0, r0, v0
    temp0 = temp0 * i.color;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// Additive2DShaderBillboard_VertexShader32 Vertex_2_0 Has PRES False
struct Additive2DShaderBillboard_VertexShader32_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct Additive2DShaderBillboard_VertexShader32_Output
{
    float2 texcoord : TEXCOORD;
    float4 position : POSITION;
    float4 color : COLOR;
};

Additive2DShaderBillboard_VertexShader32_Output Additive2DShaderBillboard_VertexShader32(Additive2DShaderBillboard_VertexShader32_Input i)
{
    Additive2DShaderBillboard_VertexShader32_Output o;
    float4 temp0;
    float3 temp1;
    float addr0;
    // def c12, 0.5, -0.5, 6.283185, -3.141593
    // def c11, -0.5, -0.5, 0.1591549, 0.5
    // def c13, 0.5, 0.5, 1, -1
    // def c14, -0.5, 0.5, 0, 0
    // def c15, 0, 0, 0, 0
    // def c16, -0.25, -0.25, 0, 0
    // def c17, 0.25, -0.25, 0, 0
    // def c18, 0.25, 0.25, 0, 0
    // def c19, -0.25, 0.25, 0, 0
    // def c0, -1.550099E-06, -2.170139E-05, 0.002604167, 0.0002604167
    // def c1, -0.02083333, -0.125, 1, 0.5
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_color v2
    // mad r0.x, v1.x, c11.z, c11.w
    temp0.x = i.texcoord.x * float1(0.15915494) + float1(0.5);
    // frc r0.x, r0.x
    temp0.x = frac(temp0.x);
    // mad r0.x, r0.x, c12.z, c12.w
    temp0.x = temp0.x * float1(6.2831855) + float1(-3.1415927);
    // sincos r1.xy, r0.x, c0, c1
    temp1.xy = float2(cos(temp0.x), sin(temp0.x));
    // frc r0.x, v0.w
    temp0.x = frac(i.position.w);
    // add r0.x, -r0.x, v0.w
    temp0.x = -temp0.x + i.position.w;
    // mova a0.x, r0.x
    addr0.x = temp0.x;
    // mul r0.xyz, r1.xyxw, c11[a0.x].xyyw
    temp0.xyz = temp1.xyx * float3(-0.5, -0.5, -0.5);
    // mad r0.z, c11[a0.x].x, -r1.y, r0.z
    temp0.z = float1(-0.5) * -temp1.y + temp0.z;
    // mov r1.xy, c11[a0.x]
    temp1.xy = float2(-0.5, -0.5);
    // mad oT0.xy, r1, c13.zwzw, c13.x
    o.texcoord = temp1 * float4(1, -1, 1, -1) + float4(0.5, 0.5, 0.5, 0.5);
    // add r0.x, r0.y, r0.x
    temp0.x = temp0.y + temp0.x;
    // mul r0.yzw, r0.z, c21.xxyz
    temp0.yzw = temp0.zzz * (View._m01_m11_m21_m31).xyz;
    // mad r0.xyz, r0.x, c20, r0.yzww
    temp0.xyz = temp0.xxx * (View._m00_m10_m20_m30).xyz + temp0.yzw;
    // mov r1.xyz, v0
    temp1.xyz = i.position.xyz;
    // mad r0.xyz, v1.y, r0, r1
    temp0.xyz = i.texcoord.yyy * temp0.xyz + temp1.xyz;
    // mov r0.w, c13.z
    temp0.w = float1(1);
    // dp4 oPos.x, r0, c119
    o.position.x = dot(temp0, (ViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c120
    o.position.y = dot(temp0, (ViewProjection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c121
    o.position.z = dot(temp0, (ViewProjection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c122
    o.position.w = dot(temp0, (ViewProjection._m03_m13_m23_m33));
    // mov oD0, v2
    o.color = i.color;
    // 

    return o;
}

// MultiplicativeSpriteShaderBillboard_PixelShader33 Pixel_2_0 Has PRES False
struct MultiplicativeSpriteShaderBillboard_PixelShader33_Input
{
    float4 color : COLOR;
    float2 texcoord : TEXCOORD;
};

float4 MultiplicativeSpriteShaderBillboard_PixelShader33(MultiplicativeSpriteShaderBillboard_PixelShader33_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    float3 temp1;
    // def c0, 2.2, 0, 0, 0
    // dcl v0
    // dcl t0.xy
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(ParticleTextureSampler, i.texcoord.xy);
    // log r1.x, r0.x
    temp1.x = log2(temp0.x);
    // log r1.y, r0.y
    temp1.y = log2(temp0.y);
    // log r1.z, r0.z
    temp1.z = log2(temp0.z);
    // mul r1.xyz, r1, c0.x
    temp1.xyz = temp1.xyz * float3(2.2, 2.2, 2.2);
    // exp r0.x, r1.x
    temp0.x = exp2(temp1.x);
    // exp r0.y, r1.y
    temp0.y = exp2(temp1.y);
    // exp r0.z, r1.z
    temp0.z = exp2(temp1.z);
    // mul r0, r0, v0
    temp0 = temp0 * i.color;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// MultiplicativeSpriteShaderBillboard_VertexShader34 Vertex_2_0 Has PRES False
struct MultiplicativeSpriteShaderBillboard_VertexShader34_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct MultiplicativeSpriteShaderBillboard_VertexShader34_Output
{
    float2 texcoord : TEXCOORD;
    float4 position : POSITION;
    float4 color : COLOR;
};

MultiplicativeSpriteShaderBillboard_VertexShader34_Output MultiplicativeSpriteShaderBillboard_VertexShader34(MultiplicativeSpriteShaderBillboard_VertexShader34_Input i)
{
    MultiplicativeSpriteShaderBillboard_VertexShader34_Output o;
    float4 temp0;
    float3 temp1;
    float addr0;
    // def c12, 0.5, -0.5, 6.283185, -3.141593
    // def c11, -0.5, -0.5, 0.1591549, 0.5
    // def c13, 0.5, 0.5, 1, -1
    // def c14, -0.5, 0.5, 0, 0
    // def c15, 0, 0, 0, 0
    // def c16, -0.25, -0.25, 0, 0
    // def c17, 0.25, -0.25, 0, 0
    // def c18, 0.25, 0.25, 0, 0
    // def c19, -0.25, 0.25, 0, 0
    // def c0, -1.550099E-06, -2.170139E-05, 0.002604167, 0.0002604167
    // def c1, -0.02083333, -0.125, 1, 0.5
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_color v2
    // mad r0.x, v1.x, c11.z, c11.w
    temp0.x = i.texcoord.x * float1(0.15915494) + float1(0.5);
    // frc r0.x, r0.x
    temp0.x = frac(temp0.x);
    // mad r0.x, r0.x, c12.z, c12.w
    temp0.x = temp0.x * float1(6.2831855) + float1(-3.1415927);
    // sincos r1.xy, r0.x, c0, c1
    temp1.xy = float2(cos(temp0.x), sin(temp0.x));
    // frc r0.x, v0.w
    temp0.x = frac(i.position.w);
    // add r0.x, -r0.x, v0.w
    temp0.x = -temp0.x + i.position.w;
    // mova a0.x, r0.x
    addr0.x = temp0.x;
    // mul r0.xyz, r1.xyxw, c11[a0.x].xyyw
    temp0.xyz = temp1.xyx * float3(-0.5, -0.5, -0.5);
    // mad r0.z, c11[a0.x].x, -r1.y, r0.z
    temp0.z = float1(-0.5) * -temp1.y + temp0.z;
    // mov r1.xy, c11[a0.x]
    temp1.xy = float2(-0.5, -0.5);
    // mad oT0.xy, r1, c13.zwzw, c13.x
    o.texcoord = temp1 * float4(1, -1, 1, -1) + float4(0.5, 0.5, 0.5, 0.5);
    // add r0.x, r0.y, r0.x
    temp0.x = temp0.y + temp0.x;
    // mul r0.yzw, r0.z, c21.xxyz
    temp0.yzw = temp0.zzz * (View._m01_m11_m21_m31).xyz;
    // mad r0.xyz, r0.x, c20, r0.yzww
    temp0.xyz = temp0.xxx * (View._m00_m10_m20_m30).xyz + temp0.yzw;
    // mov r1.xyz, v0
    temp1.xyz = i.position.xyz;
    // mad r0.xyz, v1.y, r0, r1
    temp0.xyz = i.texcoord.yyy * temp0.xyz + temp1.xyz;
    // mov r0.w, c13.z
    temp0.w = float1(1);
    // dp4 oPos.x, r0, c119
    o.position.x = dot(temp0, (ViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c120
    o.position.y = dot(temp0, (ViewProjection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c121
    o.position.z = dot(temp0, (ViewProjection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c122
    o.position.w = dot(temp0, (ViewProjection._m03_m13_m23_m33));
    // mov oD0, v2
    o.color = i.color;
    // 

    return o;
}

// ATestSpriteShaderBillboard_PixelShader35 Pixel_2_0 Has PRES False
struct ATestSpriteShaderBillboard_PixelShader35_Input
{
    float4 color : COLOR;
    float2 texcoord : TEXCOORD;
};

float4 ATestSpriteShaderBillboard_PixelShader35(ATestSpriteShaderBillboard_PixelShader35_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    float3 temp1;
    // def c0, 2.2, 0, 0, 0
    // dcl v0
    // dcl t0.xy
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(ParticleTextureSampler, i.texcoord.xy);
    // log r1.x, r0.x
    temp1.x = log2(temp0.x);
    // log r1.y, r0.y
    temp1.y = log2(temp0.y);
    // log r1.z, r0.z
    temp1.z = log2(temp0.z);
    // mul r1.xyz, r1, c0.x
    temp1.xyz = temp1.xyz * float3(2.2, 2.2, 2.2);
    // exp r0.x, r1.x
    temp0.x = exp2(temp1.x);
    // exp r0.y, r1.y
    temp0.y = exp2(temp1.y);
    // exp r0.z, r1.z
    temp0.z = exp2(temp1.z);
    // mul r0, r0, v0
    temp0 = temp0 * i.color;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// ATestSpriteShaderBillboard_VertexShader36 Vertex_2_0 Has PRES False
struct ATestSpriteShaderBillboard_VertexShader36_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct ATestSpriteShaderBillboard_VertexShader36_Output
{
    float2 texcoord : TEXCOORD;
    float4 position : POSITION;
    float4 color : COLOR;
};

ATestSpriteShaderBillboard_VertexShader36_Output ATestSpriteShaderBillboard_VertexShader36(ATestSpriteShaderBillboard_VertexShader36_Input i)
{
    ATestSpriteShaderBillboard_VertexShader36_Output o;
    float4 temp0;
    float3 temp1;
    float addr0;
    // def c12, 0.5, -0.5, 6.283185, -3.141593
    // def c11, -0.5, -0.5, 0.1591549, 0.5
    // def c13, 0.5, 0.5, 1, -1
    // def c14, -0.5, 0.5, 0, 0
    // def c15, 0, 0, 0, 0
    // def c16, -0.25, -0.25, 0, 0
    // def c17, 0.25, -0.25, 0, 0
    // def c18, 0.25, 0.25, 0, 0
    // def c19, -0.25, 0.25, 0, 0
    // def c0, -1.550099E-06, -2.170139E-05, 0.002604167, 0.0002604167
    // def c1, -0.02083333, -0.125, 1, 0.5
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_color v2
    // mad r0.x, v1.x, c11.z, c11.w
    temp0.x = i.texcoord.x * float1(0.15915494) + float1(0.5);
    // frc r0.x, r0.x
    temp0.x = frac(temp0.x);
    // mad r0.x, r0.x, c12.z, c12.w
    temp0.x = temp0.x * float1(6.2831855) + float1(-3.1415927);
    // sincos r1.xy, r0.x, c0, c1
    temp1.xy = float2(cos(temp0.x), sin(temp0.x));
    // frc r0.x, v0.w
    temp0.x = frac(i.position.w);
    // add r0.x, -r0.x, v0.w
    temp0.x = -temp0.x + i.position.w;
    // mova a0.x, r0.x
    addr0.x = temp0.x;
    // mul r0.xyz, r1.xyxw, c11[a0.x].xyyw
    temp0.xyz = temp1.xyx * float3(-0.5, -0.5, -0.5);
    // mad r0.z, c11[a0.x].x, -r1.y, r0.z
    temp0.z = float1(-0.5) * -temp1.y + temp0.z;
    // mov r1.xy, c11[a0.x]
    temp1.xy = float2(-0.5, -0.5);
    // mad oT0.xy, r1, c13.zwzw, c13.x
    o.texcoord = temp1 * float4(1, -1, 1, -1) + float4(0.5, 0.5, 0.5, 0.5);
    // add r0.x, r0.y, r0.x
    temp0.x = temp0.y + temp0.x;
    // mul r0.yzw, r0.z, c21.xxyz
    temp0.yzw = temp0.zzz * (View._m01_m11_m21_m31).xyz;
    // mad r0.xyz, r0.x, c20, r0.yzww
    temp0.xyz = temp0.xxx * (View._m00_m10_m20_m30).xyz + temp0.yzw;
    // mov r1.xyz, v0
    temp1.xyz = i.position.xyz;
    // mad r0.xyz, v1.y, r0, r1
    temp0.xyz = i.texcoord.yyy * temp0.xyz + temp1.xyz;
    // mov r0.w, c13.z
    temp0.w = float1(1);
    // dp4 oPos.x, r0, c119
    o.position.x = dot(temp0, (ViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c120
    o.position.y = dot(temp0, (ViewProjection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c121
    o.position.z = dot(temp0, (ViewProjection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c122
    o.position.w = dot(temp0, (ViewProjection._m03_m13_m23_m33));
    // mov oD0, v2
    o.color = i.color;
    // 

    return o;
}

// AlphaSpriteShaderBillboard_PixelShader37 Pixel_2_0 Has PRES False
struct AlphaSpriteShaderBillboard_PixelShader37_Input
{
    float4 color : COLOR;
    float2 texcoord : TEXCOORD;
};

float4 AlphaSpriteShaderBillboard_PixelShader37(AlphaSpriteShaderBillboard_PixelShader37_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    float3 temp1;
    // def c0, 2.2, 0, 0, 0
    // dcl v0
    // dcl t0.xy
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(ParticleTextureSampler, i.texcoord.xy);
    // log r1.x, r0.x
    temp1.x = log2(temp0.x);
    // log r1.y, r0.y
    temp1.y = log2(temp0.y);
    // log r1.z, r0.z
    temp1.z = log2(temp0.z);
    // mul r1.xyz, r1, c0.x
    temp1.xyz = temp1.xyz * float3(2.2, 2.2, 2.2);
    // exp r0.x, r1.x
    temp0.x = exp2(temp1.x);
    // exp r0.y, r1.y
    temp0.y = exp2(temp1.y);
    // exp r0.z, r1.z
    temp0.z = exp2(temp1.z);
    // mul r0, r0, v0
    temp0 = temp0 * i.color;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// AlphaSpriteShaderBillboard_VertexShader38 Vertex_2_0 Has PRES False
struct AlphaSpriteShaderBillboard_VertexShader38_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct AlphaSpriteShaderBillboard_VertexShader38_Output
{
    float2 texcoord : TEXCOORD;
    float4 position : POSITION;
    float4 color : COLOR;
};

AlphaSpriteShaderBillboard_VertexShader38_Output AlphaSpriteShaderBillboard_VertexShader38(AlphaSpriteShaderBillboard_VertexShader38_Input i)
{
    AlphaSpriteShaderBillboard_VertexShader38_Output o;
    float4 temp0;
    float3 temp1;
    float addr0;
    // def c12, 0.5, -0.5, 6.283185, -3.141593
    // def c11, -0.5, -0.5, 0.1591549, 0.5
    // def c13, 0.5, 0.5, 1, -1
    // def c14, -0.5, 0.5, 0, 0
    // def c15, 0, 0, 0, 0
    // def c16, -0.25, -0.25, 0, 0
    // def c17, 0.25, -0.25, 0, 0
    // def c18, 0.25, 0.25, 0, 0
    // def c19, -0.25, 0.25, 0, 0
    // def c0, -1.550099E-06, -2.170139E-05, 0.002604167, 0.0002604167
    // def c1, -0.02083333, -0.125, 1, 0.5
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_color v2
    // mad r0.x, v1.x, c11.z, c11.w
    temp0.x = i.texcoord.x * float1(0.15915494) + float1(0.5);
    // frc r0.x, r0.x
    temp0.x = frac(temp0.x);
    // mad r0.x, r0.x, c12.z, c12.w
    temp0.x = temp0.x * float1(6.2831855) + float1(-3.1415927);
    // sincos r1.xy, r0.x, c0, c1
    temp1.xy = float2(cos(temp0.x), sin(temp0.x));
    // frc r0.x, v0.w
    temp0.x = frac(i.position.w);
    // add r0.x, -r0.x, v0.w
    temp0.x = -temp0.x + i.position.w;
    // mova a0.x, r0.x
    addr0.x = temp0.x;
    // mul r0.xyz, r1.xyxw, c11[a0.x].xyyw
    temp0.xyz = temp1.xyx * float3(-0.5, -0.5, -0.5);
    // mad r0.z, c11[a0.x].x, -r1.y, r0.z
    temp0.z = float1(-0.5) * -temp1.y + temp0.z;
    // mov r1.xy, c11[a0.x]
    temp1.xy = float2(-0.5, -0.5);
    // mad oT0.xy, r1, c13.zwzw, c13.x
    o.texcoord = temp1 * float4(1, -1, 1, -1) + float4(0.5, 0.5, 0.5, 0.5);
    // add r0.x, r0.y, r0.x
    temp0.x = temp0.y + temp0.x;
    // mul r0.yzw, r0.z, c21.xxyz
    temp0.yzw = temp0.zzz * (View._m01_m11_m21_m31).xyz;
    // mad r0.xyz, r0.x, c20, r0.yzww
    temp0.xyz = temp0.xxx * (View._m00_m10_m20_m30).xyz + temp0.yzw;
    // mov r1.xyz, v0
    temp1.xyz = i.position.xyz;
    // mad r0.xyz, v1.y, r0, r1
    temp0.xyz = i.texcoord.yyy * temp0.xyz + temp1.xyz;
    // mov r0.w, c13.z
    temp0.w = float1(1);
    // dp4 oPos.x, r0, c119
    o.position.x = dot(temp0, (ViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c120
    o.position.y = dot(temp0, (ViewProjection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c121
    o.position.z = dot(temp0, (ViewProjection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c122
    o.position.w = dot(temp0, (ViewProjection._m03_m13_m23_m33));
    // mov oD0, v2
    o.color = i.color;
    // 

    return o;
}

// AdditiveAlphaTestSpriteShaderBillboard_PixelShader39 Pixel_2_0 Has PRES False
struct AdditiveAlphaTestSpriteShaderBillboard_PixelShader39_Input
{
    float4 color : COLOR;
    float2 texcoord : TEXCOORD;
};

float4 AdditiveAlphaTestSpriteShaderBillboard_PixelShader39(AdditiveAlphaTestSpriteShaderBillboard_PixelShader39_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    float3 temp1;
    // def c0, 2.2, 0, 0, 0
    // dcl v0
    // dcl t0.xy
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(ParticleTextureSampler, i.texcoord.xy);
    // log r1.x, r0.x
    temp1.x = log2(temp0.x);
    // log r1.y, r0.y
    temp1.y = log2(temp0.y);
    // log r1.z, r0.z
    temp1.z = log2(temp0.z);
    // mul r1.xyz, r1, c0.x
    temp1.xyz = temp1.xyz * float3(2.2, 2.2, 2.2);
    // exp r0.x, r1.x
    temp0.x = exp2(temp1.x);
    // exp r0.y, r1.y
    temp0.y = exp2(temp1.y);
    // exp r0.z, r1.z
    temp0.z = exp2(temp1.z);
    // mul r0, r0, v0
    temp0 = temp0 * i.color;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// AdditiveAlphaTestSpriteShaderBillboard_VertexShader40 Vertex_2_0 Has PRES False
struct AdditiveAlphaTestSpriteShaderBillboard_VertexShader40_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct AdditiveAlphaTestSpriteShaderBillboard_VertexShader40_Output
{
    float2 texcoord : TEXCOORD;
    float4 position : POSITION;
    float4 color : COLOR;
};

AdditiveAlphaTestSpriteShaderBillboard_VertexShader40_Output AdditiveAlphaTestSpriteShaderBillboard_VertexShader40(AdditiveAlphaTestSpriteShaderBillboard_VertexShader40_Input i)
{
    AdditiveAlphaTestSpriteShaderBillboard_VertexShader40_Output o;
    float4 temp0;
    float3 temp1;
    float addr0;
    // def c12, 0.5, -0.5, 6.283185, -3.141593
    // def c11, -0.5, -0.5, 0.1591549, 0.5
    // def c13, 0.5, 0.5, 1, -1
    // def c14, -0.5, 0.5, 0, 0
    // def c15, 0, 0, 0, 0
    // def c16, -0.25, -0.25, 0, 0
    // def c17, 0.25, -0.25, 0, 0
    // def c18, 0.25, 0.25, 0, 0
    // def c19, -0.25, 0.25, 0, 0
    // def c0, -1.550099E-06, -2.170139E-05, 0.002604167, 0.0002604167
    // def c1, -0.02083333, -0.125, 1, 0.5
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_color v2
    // mad r0.x, v1.x, c11.z, c11.w
    temp0.x = i.texcoord.x * float1(0.15915494) + float1(0.5);
    // frc r0.x, r0.x
    temp0.x = frac(temp0.x);
    // mad r0.x, r0.x, c12.z, c12.w
    temp0.x = temp0.x * float1(6.2831855) + float1(-3.1415927);
    // sincos r1.xy, r0.x, c0, c1
    temp1.xy = float2(cos(temp0.x), sin(temp0.x));
    // frc r0.x, v0.w
    temp0.x = frac(i.position.w);
    // add r0.x, -r0.x, v0.w
    temp0.x = -temp0.x + i.position.w;
    // mova a0.x, r0.x
    addr0.x = temp0.x;
    // mul r0.xyz, r1.xyxw, c11[a0.x].xyyw
    temp0.xyz = temp1.xyx * float3(-0.5, -0.5, -0.5);
    // mad r0.z, c11[a0.x].x, -r1.y, r0.z
    temp0.z = float1(-0.5) * -temp1.y + temp0.z;
    // mov r1.xy, c11[a0.x]
    temp1.xy = float2(-0.5, -0.5);
    // mad oT0.xy, r1, c13.zwzw, c13.x
    o.texcoord = temp1 * float4(1, -1, 1, -1) + float4(0.5, 0.5, 0.5, 0.5);
    // add r0.x, r0.y, r0.x
    temp0.x = temp0.y + temp0.x;
    // mul r0.yzw, r0.z, c21.xxyz
    temp0.yzw = temp0.zzz * (View._m01_m11_m21_m31).xyz;
    // mad r0.xyz, r0.x, c20, r0.yzww
    temp0.xyz = temp0.xxx * (View._m00_m10_m20_m30).xyz + temp0.yzw;
    // mov r1.xyz, v0
    temp1.xyz = i.position.xyz;
    // mad r0.xyz, v1.y, r0, r1
    temp0.xyz = i.texcoord.yyy * temp0.xyz + temp1.xyz;
    // mov r0.w, c13.z
    temp0.w = float1(1);
    // dp4 oPos.x, r0, c119
    o.position.x = dot(temp0, (ViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c120
    o.position.y = dot(temp0, (ViewProjection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c121
    o.position.z = dot(temp0, (ViewProjection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c122
    o.position.w = dot(temp0, (ViewProjection._m03_m13_m23_m33));
    // mov oD0, v2
    o.color = i.color;
    // 

    return o;
}

// AdditiveSpriteShaderBillboard_PixelShader41 Pixel_2_0 Has PRES False
struct AdditiveSpriteShaderBillboard_PixelShader41_Input
{
    float4 color : COLOR;
    float2 texcoord : TEXCOORD;
};

float4 AdditiveSpriteShaderBillboard_PixelShader41(AdditiveSpriteShaderBillboard_PixelShader41_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    float3 temp1;
    // def c0, 2.2, 0, 0, 0
    // dcl v0
    // dcl t0.xy
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(ParticleTextureSampler, i.texcoord.xy);
    // log r1.x, r0.x
    temp1.x = log2(temp0.x);
    // log r1.y, r0.y
    temp1.y = log2(temp0.y);
    // log r1.z, r0.z
    temp1.z = log2(temp0.z);
    // mul r1.xyz, r1, c0.x
    temp1.xyz = temp1.xyz * float3(2.2, 2.2, 2.2);
    // exp r0.x, r1.x
    temp0.x = exp2(temp1.x);
    // exp r0.y, r1.y
    temp0.y = exp2(temp1.y);
    // exp r0.z, r1.z
    temp0.z = exp2(temp1.z);
    // mul r0, r0, v0
    temp0 = temp0 * i.color;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// AdditiveSpriteShaderBillboard_VertexShader42 Vertex_2_0 Has PRES False
struct AdditiveSpriteShaderBillboard_VertexShader42_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct AdditiveSpriteShaderBillboard_VertexShader42_Output
{
    float2 texcoord : TEXCOORD;
    float4 position : POSITION;
    float4 color : COLOR;
};

AdditiveSpriteShaderBillboard_VertexShader42_Output AdditiveSpriteShaderBillboard_VertexShader42(AdditiveSpriteShaderBillboard_VertexShader42_Input i)
{
    AdditiveSpriteShaderBillboard_VertexShader42_Output o;
    float4 temp0;
    float3 temp1;
    float addr0;
    // def c12, 0.5, -0.5, 6.283185, -3.141593
    // def c11, -0.5, -0.5, 0.1591549, 0.5
    // def c13, 0.5, 0.5, 1, -1
    // def c14, -0.5, 0.5, 0, 0
    // def c15, 0, 0, 0, 0
    // def c16, -0.25, -0.25, 0, 0
    // def c17, 0.25, -0.25, 0, 0
    // def c18, 0.25, 0.25, 0, 0
    // def c19, -0.25, 0.25, 0, 0
    // def c0, -1.550099E-06, -2.170139E-05, 0.002604167, 0.0002604167
    // def c1, -0.02083333, -0.125, 1, 0.5
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_color v2
    // mad r0.x, v1.x, c11.z, c11.w
    temp0.x = i.texcoord.x * float1(0.15915494) + float1(0.5);
    // frc r0.x, r0.x
    temp0.x = frac(temp0.x);
    // mad r0.x, r0.x, c12.z, c12.w
    temp0.x = temp0.x * float1(6.2831855) + float1(-3.1415927);
    // sincos r1.xy, r0.x, c0, c1
    temp1.xy = float2(cos(temp0.x), sin(temp0.x));
    // frc r0.x, v0.w
    temp0.x = frac(i.position.w);
    // add r0.x, -r0.x, v0.w
    temp0.x = -temp0.x + i.position.w;
    // mova a0.x, r0.x
    addr0.x = temp0.x;
    // mul r0.xyz, r1.xyxw, c11[a0.x].xyyw
    temp0.xyz = temp1.xyx * float3(-0.5, -0.5, -0.5);
    // mad r0.z, c11[a0.x].x, -r1.y, r0.z
    temp0.z = float1(-0.5) * -temp1.y + temp0.z;
    // mov r1.xy, c11[a0.x]
    temp1.xy = float2(-0.5, -0.5);
    // mad oT0.xy, r1, c13.zwzw, c13.x
    o.texcoord = temp1 * float4(1, -1, 1, -1) + float4(0.5, 0.5, 0.5, 0.5);
    // add r0.x, r0.y, r0.x
    temp0.x = temp0.y + temp0.x;
    // mul r0.yzw, r0.z, c21.xxyz
    temp0.yzw = temp0.zzz * (View._m01_m11_m21_m31).xyz;
    // mad r0.xyz, r0.x, c20, r0.yzww
    temp0.xyz = temp0.xxx * (View._m00_m10_m20_m30).xyz + temp0.yzw;
    // mov r1.xyz, v0
    temp1.xyz = i.position.xyz;
    // mad r0.xyz, v1.y, r0, r1
    temp0.xyz = i.texcoord.yyy * temp0.xyz + temp1.xyz;
    // mov r0.w, c13.z
    temp0.w = float1(1);
    // dp4 oPos.x, r0, c119
    o.position.x = dot(temp0, (ViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c120
    o.position.y = dot(temp0, (ViewProjection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c121
    o.position.z = dot(temp0, (ViewProjection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c122
    o.position.w = dot(temp0, (ViewProjection._m03_m13_m23_m33));
    // mov oD0, v2
    o.color = i.color;
    // 

    return o;
}

// Alpha2DShader_PixelShader43 Pixel_2_0 Has PRES False
struct Alpha2DShader_PixelShader43_Input
{
    float4 color : COLOR;
    float2 texcoord : TEXCOORD;
};

float4 Alpha2DShader_PixelShader43(Alpha2DShader_PixelShader43_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    float3 temp1;
    // def c0, 2.2, 0, 0, 0
    // dcl v0
    // dcl t0.xy
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(ParticleTextureSampler, i.texcoord.xy);
    // log r1.x, r0.x
    temp1.x = log2(temp0.x);
    // log r1.y, r0.y
    temp1.y = log2(temp0.y);
    // log r1.z, r0.z
    temp1.z = log2(temp0.z);
    // mul r1.xyz, r1, c0.x
    temp1.xyz = temp1.xyz * float3(2.2, 2.2, 2.2);
    // exp r0.x, r1.x
    temp0.x = exp2(temp1.x);
    // exp r0.y, r1.y
    temp0.y = exp2(temp1.y);
    // exp r0.z, r1.z
    temp0.z = exp2(temp1.z);
    // mul r0, r0, v0
    temp0 = temp0 * i.color;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// Alpha2DShader_VertexShader44 Vertex_2_0 Has PRES False
struct Alpha2DShader_VertexShader44_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct Alpha2DShader_VertexShader44_Output
{
    float2 texcoord : TEXCOORD;
    float4 position : POSITION;
    float4 color : COLOR;
};

Alpha2DShader_VertexShader44_Output Alpha2DShader_VertexShader44(Alpha2DShader_VertexShader44_Input i)
{
    Alpha2DShader_VertexShader44_Output o;
    float4 temp0;
    float2 temp1;
    float addr0;
    // def c12, 0.5, -0.5, 6.283185, -3.141593
    // def c11, -0.5, -0.5, 0.1591549, 0.5
    // def c14, -0.5, 0.5, 1, -1
    // def c13, 0.5, 0.5, 1, 0
    // def c15, 0, 0, 0, 0
    // def c16, -0.25, -0.25, 0, 0
    // def c17, 0.25, -0.25, 0, 0
    // def c18, 0.25, 0.25, 0, 0
    // def c19, -0.25, 0.25, 0, 0
    // def c0, -1.550099E-06, -2.170139E-05, 0.002604167, 0.0002604167
    // def c1, -0.02083333, -0.125, 1, 0.5
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_color v2
    // mad r0.x, v1.x, c11.z, c11.w
    temp0.x = i.texcoord.x * float1(0.15915494) + float1(0.5);
    // frc r0.x, r0.x
    temp0.x = frac(temp0.x);
    // mad r0.x, r0.x, c12.z, c12.w
    temp0.x = temp0.x * float1(6.2831855) + float1(-3.1415927);
    // sincos r1.xy, r0.x, c0, c1
    temp1.xy = float2(cos(temp0.x), sin(temp0.x));
    // frc r0.x, v0.w
    temp0.x = frac(i.position.w);
    // add r0.x, -r0.x, v0.w
    temp0.x = -temp0.x + i.position.w;
    // mova a0.x, r0.x
    addr0.x = temp0.x;
    // mul r0.xyz, r1.xyxw, c11[a0.x].xyyw
    temp0.xyz = temp1.xyx * float3(-0.5, -0.5, -0.5);
    // mad r0.w, c11[a0.x].x, -r1.y, r0.z
    temp0.w = float1(-0.5) * -temp1.y + temp0.z;
    // mov r1.xy, c11[a0.x]
    temp1.xy = float2(-0.5, -0.5);
    // mad oT0.xy, r1, c14.zwzw, c14.y
    o.texcoord = temp1 * float4(1, -1, 1, -1) + float4(0.5, 0.5, 0.5, 0.5);
    // add r0.z, r0.y, r0.x
    temp0.z = temp0.y + temp0.x;
    // mov r0.xy, v0
    temp0.xy = i.position.xy;
    // mad r0.xy, v1.y, r0.zwzw, r0
    temp0.xy = i.texcoord.yy * temp0.zw + temp0.xy;
    // mad r0.zw, v0.z, c13, c13.xywz
    temp0.zw = i.position.zz * float2(1, 0) + float2(0, 1);
    // dp4 oPos.x, r0, c119
    o.position.x = dot(temp0, (ViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c120
    o.position.y = dot(temp0, (ViewProjection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c121
    o.position.z = dot(temp0, (ViewProjection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c122
    o.position.w = dot(temp0, (ViewProjection._m03_m13_m23_m33));
    // mov oD0, v2
    o.color = i.color;
    // 

    return o;
}

// Additive2DShader_PixelShader45 Pixel_2_0 Has PRES False
struct Additive2DShader_PixelShader45_Input
{
    float4 color : COLOR;
    float2 texcoord : TEXCOORD;
};

float4 Additive2DShader_PixelShader45(Additive2DShader_PixelShader45_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    float3 temp1;
    // def c0, 2.2, 0, 0, 0
    // dcl v0
    // dcl t0.xy
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(ParticleTextureSampler, i.texcoord.xy);
    // log r1.x, r0.x
    temp1.x = log2(temp0.x);
    // log r1.y, r0.y
    temp1.y = log2(temp0.y);
    // log r1.z, r0.z
    temp1.z = log2(temp0.z);
    // mul r1.xyz, r1, c0.x
    temp1.xyz = temp1.xyz * float3(2.2, 2.2, 2.2);
    // exp r0.x, r1.x
    temp0.x = exp2(temp1.x);
    // exp r0.y, r1.y
    temp0.y = exp2(temp1.y);
    // exp r0.z, r1.z
    temp0.z = exp2(temp1.z);
    // mul r0, r0, v0
    temp0 = temp0 * i.color;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// Additive2DShader_VertexShader46 Vertex_2_0 Has PRES False
struct Additive2DShader_VertexShader46_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct Additive2DShader_VertexShader46_Output
{
    float2 texcoord : TEXCOORD;
    float4 position : POSITION;
    float4 color : COLOR;
};

Additive2DShader_VertexShader46_Output Additive2DShader_VertexShader46(Additive2DShader_VertexShader46_Input i)
{
    Additive2DShader_VertexShader46_Output o;
    float4 temp0;
    float2 temp1;
    float addr0;
    // def c12, 0.5, -0.5, 6.283185, -3.141593
    // def c11, -0.5, -0.5, 0.1591549, 0.5
    // def c14, -0.5, 0.5, 1, -1
    // def c13, 0.5, 0.5, 1, 0
    // def c15, 0, 0, 0, 0
    // def c16, -0.25, -0.25, 0, 0
    // def c17, 0.25, -0.25, 0, 0
    // def c18, 0.25, 0.25, 0, 0
    // def c19, -0.25, 0.25, 0, 0
    // def c0, -1.550099E-06, -2.170139E-05, 0.002604167, 0.0002604167
    // def c1, -0.02083333, -0.125, 1, 0.5
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_color v2
    // mad r0.x, v1.x, c11.z, c11.w
    temp0.x = i.texcoord.x * float1(0.15915494) + float1(0.5);
    // frc r0.x, r0.x
    temp0.x = frac(temp0.x);
    // mad r0.x, r0.x, c12.z, c12.w
    temp0.x = temp0.x * float1(6.2831855) + float1(-3.1415927);
    // sincos r1.xy, r0.x, c0, c1
    temp1.xy = float2(cos(temp0.x), sin(temp0.x));
    // frc r0.x, v0.w
    temp0.x = frac(i.position.w);
    // add r0.x, -r0.x, v0.w
    temp0.x = -temp0.x + i.position.w;
    // mova a0.x, r0.x
    addr0.x = temp0.x;
    // mul r0.xyz, r1.xyxw, c11[a0.x].xyyw
    temp0.xyz = temp1.xyx * float3(-0.5, -0.5, -0.5);
    // mad r0.w, c11[a0.x].x, -r1.y, r0.z
    temp0.w = float1(-0.5) * -temp1.y + temp0.z;
    // mov r1.xy, c11[a0.x]
    temp1.xy = float2(-0.5, -0.5);
    // mad oT0.xy, r1, c14.zwzw, c14.y
    o.texcoord = temp1 * float4(1, -1, 1, -1) + float4(0.5, 0.5, 0.5, 0.5);
    // add r0.z, r0.y, r0.x
    temp0.z = temp0.y + temp0.x;
    // mov r0.xy, v0
    temp0.xy = i.position.xy;
    // mad r0.xy, v1.y, r0.zwzw, r0
    temp0.xy = i.texcoord.yy * temp0.zw + temp0.xy;
    // mad r0.zw, v0.z, c13, c13.xywz
    temp0.zw = i.position.zz * float2(1, 0) + float2(0, 1);
    // dp4 oPos.x, r0, c119
    o.position.x = dot(temp0, (ViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c120
    o.position.y = dot(temp0, (ViewProjection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c121
    o.position.z = dot(temp0, (ViewProjection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c122
    o.position.w = dot(temp0, (ViewProjection._m03_m13_m23_m33));
    // mov oD0, v2
    o.color = i.color;
    // 

    return o;
}

// MultiplicativeSpriteShader_PixelShader47 Pixel_2_0 Has PRES False
struct MultiplicativeSpriteShader_PixelShader47_Input
{
    float4 color : COLOR;
    float2 texcoord : TEXCOORD;
};

float4 MultiplicativeSpriteShader_PixelShader47(MultiplicativeSpriteShader_PixelShader47_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    float3 temp1;
    // def c0, 2.2, 0, 0, 0
    // dcl v0
    // dcl t0.xy
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(ParticleTextureSampler, i.texcoord.xy);
    // log r1.x, r0.x
    temp1.x = log2(temp0.x);
    // log r1.y, r0.y
    temp1.y = log2(temp0.y);
    // log r1.z, r0.z
    temp1.z = log2(temp0.z);
    // mul r1.xyz, r1, c0.x
    temp1.xyz = temp1.xyz * float3(2.2, 2.2, 2.2);
    // exp r0.x, r1.x
    temp0.x = exp2(temp1.x);
    // exp r0.y, r1.y
    temp0.y = exp2(temp1.y);
    // exp r0.z, r1.z
    temp0.z = exp2(temp1.z);
    // mul r0, r0, v0
    temp0 = temp0 * i.color;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// MultiplicativeSpriteShader_VertexShader48 Vertex_2_0 Has PRES False
struct MultiplicativeSpriteShader_VertexShader48_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct MultiplicativeSpriteShader_VertexShader48_Output
{
    float2 texcoord : TEXCOORD;
    float4 position : POSITION;
    float4 color : COLOR;
};

MultiplicativeSpriteShader_VertexShader48_Output MultiplicativeSpriteShader_VertexShader48(MultiplicativeSpriteShader_VertexShader48_Input i)
{
    MultiplicativeSpriteShader_VertexShader48_Output o;
    float4 temp0;
    float2 temp1;
    float addr0;
    // def c12, 0.5, -0.5, 6.283185, -3.141593
    // def c11, -0.5, -0.5, 0.1591549, 0.5
    // def c14, -0.5, 0.5, 1, -1
    // def c13, 0.5, 0.5, 1, 0
    // def c15, 0, 0, 0, 0
    // def c16, -0.25, -0.25, 0, 0
    // def c17, 0.25, -0.25, 0, 0
    // def c18, 0.25, 0.25, 0, 0
    // def c19, -0.25, 0.25, 0, 0
    // def c0, -1.550099E-06, -2.170139E-05, 0.002604167, 0.0002604167
    // def c1, -0.02083333, -0.125, 1, 0.5
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_color v2
    // mad r0.x, v1.x, c11.z, c11.w
    temp0.x = i.texcoord.x * float1(0.15915494) + float1(0.5);
    // frc r0.x, r0.x
    temp0.x = frac(temp0.x);
    // mad r0.x, r0.x, c12.z, c12.w
    temp0.x = temp0.x * float1(6.2831855) + float1(-3.1415927);
    // sincos r1.xy, r0.x, c0, c1
    temp1.xy = float2(cos(temp0.x), sin(temp0.x));
    // frc r0.x, v0.w
    temp0.x = frac(i.position.w);
    // add r0.x, -r0.x, v0.w
    temp0.x = -temp0.x + i.position.w;
    // mova a0.x, r0.x
    addr0.x = temp0.x;
    // mul r0.xyz, r1.xyxw, c11[a0.x].xyyw
    temp0.xyz = temp1.xyx * float3(-0.5, -0.5, -0.5);
    // mad r0.w, c11[a0.x].x, -r1.y, r0.z
    temp0.w = float1(-0.5) * -temp1.y + temp0.z;
    // mov r1.xy, c11[a0.x]
    temp1.xy = float2(-0.5, -0.5);
    // mad oT0.xy, r1, c14.zwzw, c14.y
    o.texcoord = temp1 * float4(1, -1, 1, -1) + float4(0.5, 0.5, 0.5, 0.5);
    // add r0.z, r0.y, r0.x
    temp0.z = temp0.y + temp0.x;
    // mov r0.xy, v0
    temp0.xy = i.position.xy;
    // mad r0.xy, v1.y, r0.zwzw, r0
    temp0.xy = i.texcoord.yy * temp0.zw + temp0.xy;
    // mad r0.zw, v0.z, c13, c13.xywz
    temp0.zw = i.position.zz * float2(1, 0) + float2(0, 1);
    // dp4 oPos.x, r0, c119
    o.position.x = dot(temp0, (ViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c120
    o.position.y = dot(temp0, (ViewProjection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c121
    o.position.z = dot(temp0, (ViewProjection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c122
    o.position.w = dot(temp0, (ViewProjection._m03_m13_m23_m33));
    // mov oD0, v2
    o.color = i.color;
    // 

    return o;
}

// ATestSpriteShader_PixelShader49 Pixel_2_0 Has PRES False
struct ATestSpriteShader_PixelShader49_Input
{
    float4 color : COLOR;
    float2 texcoord : TEXCOORD;
};

float4 ATestSpriteShader_PixelShader49(ATestSpriteShader_PixelShader49_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    float3 temp1;
    // def c0, 2.2, 0, 0, 0
    // dcl v0
    // dcl t0.xy
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(ParticleTextureSampler, i.texcoord.xy);
    // log r1.x, r0.x
    temp1.x = log2(temp0.x);
    // log r1.y, r0.y
    temp1.y = log2(temp0.y);
    // log r1.z, r0.z
    temp1.z = log2(temp0.z);
    // mul r1.xyz, r1, c0.x
    temp1.xyz = temp1.xyz * float3(2.2, 2.2, 2.2);
    // exp r0.x, r1.x
    temp0.x = exp2(temp1.x);
    // exp r0.y, r1.y
    temp0.y = exp2(temp1.y);
    // exp r0.z, r1.z
    temp0.z = exp2(temp1.z);
    // mul r0, r0, v0
    temp0 = temp0 * i.color;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// ATestSpriteShader_VertexShader50 Vertex_2_0 Has PRES False
struct ATestSpriteShader_VertexShader50_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct ATestSpriteShader_VertexShader50_Output
{
    float2 texcoord : TEXCOORD;
    float4 position : POSITION;
    float4 color : COLOR;
};

ATestSpriteShader_VertexShader50_Output ATestSpriteShader_VertexShader50(ATestSpriteShader_VertexShader50_Input i)
{
    ATestSpriteShader_VertexShader50_Output o;
    float4 temp0;
    float2 temp1;
    float addr0;
    // def c12, 0.5, -0.5, 6.283185, -3.141593
    // def c11, -0.5, -0.5, 0.1591549, 0.5
    // def c14, -0.5, 0.5, 1, -1
    // def c13, 0.5, 0.5, 1, 0
    // def c15, 0, 0, 0, 0
    // def c16, -0.25, -0.25, 0, 0
    // def c17, 0.25, -0.25, 0, 0
    // def c18, 0.25, 0.25, 0, 0
    // def c19, -0.25, 0.25, 0, 0
    // def c0, -1.550099E-06, -2.170139E-05, 0.002604167, 0.0002604167
    // def c1, -0.02083333, -0.125, 1, 0.5
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_color v2
    // mad r0.x, v1.x, c11.z, c11.w
    temp0.x = i.texcoord.x * float1(0.15915494) + float1(0.5);
    // frc r0.x, r0.x
    temp0.x = frac(temp0.x);
    // mad r0.x, r0.x, c12.z, c12.w
    temp0.x = temp0.x * float1(6.2831855) + float1(-3.1415927);
    // sincos r1.xy, r0.x, c0, c1
    temp1.xy = float2(cos(temp0.x), sin(temp0.x));
    // frc r0.x, v0.w
    temp0.x = frac(i.position.w);
    // add r0.x, -r0.x, v0.w
    temp0.x = -temp0.x + i.position.w;
    // mova a0.x, r0.x
    addr0.x = temp0.x;
    // mul r0.xyz, r1.xyxw, c11[a0.x].xyyw
    temp0.xyz = temp1.xyx * float3(-0.5, -0.5, -0.5);
    // mad r0.w, c11[a0.x].x, -r1.y, r0.z
    temp0.w = float1(-0.5) * -temp1.y + temp0.z;
    // mov r1.xy, c11[a0.x]
    temp1.xy = float2(-0.5, -0.5);
    // mad oT0.xy, r1, c14.zwzw, c14.y
    o.texcoord = temp1 * float4(1, -1, 1, -1) + float4(0.5, 0.5, 0.5, 0.5);
    // add r0.z, r0.y, r0.x
    temp0.z = temp0.y + temp0.x;
    // mov r0.xy, v0
    temp0.xy = i.position.xy;
    // mad r0.xy, v1.y, r0.zwzw, r0
    temp0.xy = i.texcoord.yy * temp0.zw + temp0.xy;
    // mad r0.zw, v0.z, c13, c13.xywz
    temp0.zw = i.position.zz * float2(1, 0) + float2(0, 1);
    // dp4 oPos.x, r0, c119
    o.position.x = dot(temp0, (ViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c120
    o.position.y = dot(temp0, (ViewProjection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c121
    o.position.z = dot(temp0, (ViewProjection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c122
    o.position.w = dot(temp0, (ViewProjection._m03_m13_m23_m33));
    // mov oD0, v2
    o.color = i.color;
    // 

    return o;
}

// AlphaSpriteShader_PixelShader51 Pixel_2_0 Has PRES False
struct AlphaSpriteShader_PixelShader51_Input
{
    float4 color : COLOR;
    float2 texcoord : TEXCOORD;
};

float4 AlphaSpriteShader_PixelShader51(AlphaSpriteShader_PixelShader51_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    float3 temp1;
    // def c0, 2.2, 0, 0, 0
    // dcl v0
    // dcl t0.xy
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(ParticleTextureSampler, i.texcoord.xy);
    // log r1.x, r0.x
    temp1.x = log2(temp0.x);
    // log r1.y, r0.y
    temp1.y = log2(temp0.y);
    // log r1.z, r0.z
    temp1.z = log2(temp0.z);
    // mul r1.xyz, r1, c0.x
    temp1.xyz = temp1.xyz * float3(2.2, 2.2, 2.2);
    // exp r0.x, r1.x
    temp0.x = exp2(temp1.x);
    // exp r0.y, r1.y
    temp0.y = exp2(temp1.y);
    // exp r0.z, r1.z
    temp0.z = exp2(temp1.z);
    // mul r0, r0, v0
    temp0 = temp0 * i.color;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// AlphaSpriteShader_VertexShader52 Vertex_2_0 Has PRES False
struct AlphaSpriteShader_VertexShader52_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct AlphaSpriteShader_VertexShader52_Output
{
    float2 texcoord : TEXCOORD;
    float4 position : POSITION;
    float4 color : COLOR;
};

AlphaSpriteShader_VertexShader52_Output AlphaSpriteShader_VertexShader52(AlphaSpriteShader_VertexShader52_Input i)
{
    AlphaSpriteShader_VertexShader52_Output o;
    float4 temp0;
    float2 temp1;
    float addr0;
    // def c12, 0.5, -0.5, 6.283185, -3.141593
    // def c11, -0.5, -0.5, 0.1591549, 0.5
    // def c14, -0.5, 0.5, 1, -1
    // def c13, 0.5, 0.5, 1, 0
    // def c15, 0, 0, 0, 0
    // def c16, -0.25, -0.25, 0, 0
    // def c17, 0.25, -0.25, 0, 0
    // def c18, 0.25, 0.25, 0, 0
    // def c19, -0.25, 0.25, 0, 0
    // def c0, -1.550099E-06, -2.170139E-05, 0.002604167, 0.0002604167
    // def c1, -0.02083333, -0.125, 1, 0.5
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_color v2
    // mad r0.x, v1.x, c11.z, c11.w
    temp0.x = i.texcoord.x * float1(0.15915494) + float1(0.5);
    // frc r0.x, r0.x
    temp0.x = frac(temp0.x);
    // mad r0.x, r0.x, c12.z, c12.w
    temp0.x = temp0.x * float1(6.2831855) + float1(-3.1415927);
    // sincos r1.xy, r0.x, c0, c1
    temp1.xy = float2(cos(temp0.x), sin(temp0.x));
    // frc r0.x, v0.w
    temp0.x = frac(i.position.w);
    // add r0.x, -r0.x, v0.w
    temp0.x = -temp0.x + i.position.w;
    // mova a0.x, r0.x
    addr0.x = temp0.x;
    // mul r0.xyz, r1.xyxw, c11[a0.x].xyyw
    temp0.xyz = temp1.xyx * float3(-0.5, -0.5, -0.5);
    // mad r0.w, c11[a0.x].x, -r1.y, r0.z
    temp0.w = float1(-0.5) * -temp1.y + temp0.z;
    // mov r1.xy, c11[a0.x]
    temp1.xy = float2(-0.5, -0.5);
    // mad oT0.xy, r1, c14.zwzw, c14.y
    o.texcoord = temp1 * float4(1, -1, 1, -1) + float4(0.5, 0.5, 0.5, 0.5);
    // add r0.z, r0.y, r0.x
    temp0.z = temp0.y + temp0.x;
    // mov r0.xy, v0
    temp0.xy = i.position.xy;
    // mad r0.xy, v1.y, r0.zwzw, r0
    temp0.xy = i.texcoord.yy * temp0.zw + temp0.xy;
    // mad r0.zw, v0.z, c13, c13.xywz
    temp0.zw = i.position.zz * float2(1, 0) + float2(0, 1);
    // dp4 oPos.x, r0, c119
    o.position.x = dot(temp0, (ViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c120
    o.position.y = dot(temp0, (ViewProjection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c121
    o.position.z = dot(temp0, (ViewProjection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c122
    o.position.w = dot(temp0, (ViewProjection._m03_m13_m23_m33));
    // mov oD0, v2
    o.color = i.color;
    // 

    return o;
}

// AdditiveAlphaTestSpriteShader_PixelShader53 Pixel_2_0 Has PRES False
struct AdditiveAlphaTestSpriteShader_PixelShader53_Input
{
    float4 color : COLOR;
    float2 texcoord : TEXCOORD;
};

float4 AdditiveAlphaTestSpriteShader_PixelShader53(AdditiveAlphaTestSpriteShader_PixelShader53_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    float3 temp1;
    // def c0, 2.2, 0, 0, 0
    // dcl v0
    // dcl t0.xy
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(ParticleTextureSampler, i.texcoord.xy);
    // log r1.x, r0.x
    temp1.x = log2(temp0.x);
    // log r1.y, r0.y
    temp1.y = log2(temp0.y);
    // log r1.z, r0.z
    temp1.z = log2(temp0.z);
    // mul r1.xyz, r1, c0.x
    temp1.xyz = temp1.xyz * float3(2.2, 2.2, 2.2);
    // exp r0.x, r1.x
    temp0.x = exp2(temp1.x);
    // exp r0.y, r1.y
    temp0.y = exp2(temp1.y);
    // exp r0.z, r1.z
    temp0.z = exp2(temp1.z);
    // mul r0, r0, v0
    temp0 = temp0 * i.color;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// AdditiveAlphaTestSpriteShader_VertexShader54 Vertex_2_0 Has PRES False
struct AdditiveAlphaTestSpriteShader_VertexShader54_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct AdditiveAlphaTestSpriteShader_VertexShader54_Output
{
    float2 texcoord : TEXCOORD;
    float4 position : POSITION;
    float4 color : COLOR;
};

AdditiveAlphaTestSpriteShader_VertexShader54_Output AdditiveAlphaTestSpriteShader_VertexShader54(AdditiveAlphaTestSpriteShader_VertexShader54_Input i)
{
    AdditiveAlphaTestSpriteShader_VertexShader54_Output o;
    float4 temp0;
    float2 temp1;
    float addr0;
    // def c12, 0.5, -0.5, 6.283185, -3.141593
    // def c11, -0.5, -0.5, 0.1591549, 0.5
    // def c14, -0.5, 0.5, 1, -1
    // def c13, 0.5, 0.5, 1, 0
    // def c15, 0, 0, 0, 0
    // def c16, -0.25, -0.25, 0, 0
    // def c17, 0.25, -0.25, 0, 0
    // def c18, 0.25, 0.25, 0, 0
    // def c19, -0.25, 0.25, 0, 0
    // def c0, -1.550099E-06, -2.170139E-05, 0.002604167, 0.0002604167
    // def c1, -0.02083333, -0.125, 1, 0.5
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_color v2
    // mad r0.x, v1.x, c11.z, c11.w
    temp0.x = i.texcoord.x * float1(0.15915494) + float1(0.5);
    // frc r0.x, r0.x
    temp0.x = frac(temp0.x);
    // mad r0.x, r0.x, c12.z, c12.w
    temp0.x = temp0.x * float1(6.2831855) + float1(-3.1415927);
    // sincos r1.xy, r0.x, c0, c1
    temp1.xy = float2(cos(temp0.x), sin(temp0.x));
    // frc r0.x, v0.w
    temp0.x = frac(i.position.w);
    // add r0.x, -r0.x, v0.w
    temp0.x = -temp0.x + i.position.w;
    // mova a0.x, r0.x
    addr0.x = temp0.x;
    // mul r0.xyz, r1.xyxw, c11[a0.x].xyyw
    temp0.xyz = temp1.xyx * float3(-0.5, -0.5, -0.5);
    // mad r0.w, c11[a0.x].x, -r1.y, r0.z
    temp0.w = float1(-0.5) * -temp1.y + temp0.z;
    // mov r1.xy, c11[a0.x]
    temp1.xy = float2(-0.5, -0.5);
    // mad oT0.xy, r1, c14.zwzw, c14.y
    o.texcoord = temp1 * float4(1, -1, 1, -1) + float4(0.5, 0.5, 0.5, 0.5);
    // add r0.z, r0.y, r0.x
    temp0.z = temp0.y + temp0.x;
    // mov r0.xy, v0
    temp0.xy = i.position.xy;
    // mad r0.xy, v1.y, r0.zwzw, r0
    temp0.xy = i.texcoord.yy * temp0.zw + temp0.xy;
    // mad r0.zw, v0.z, c13, c13.xywz
    temp0.zw = i.position.zz * float2(1, 0) + float2(0, 1);
    // dp4 oPos.x, r0, c119
    o.position.x = dot(temp0, (ViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c120
    o.position.y = dot(temp0, (ViewProjection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c121
    o.position.z = dot(temp0, (ViewProjection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c122
    o.position.w = dot(temp0, (ViewProjection._m03_m13_m23_m33));
    // mov oD0, v2
    o.color = i.color;
    // 

    return o;
}

// AdditiveSpriteShader_PixelShader55 Pixel_2_0 Has PRES False
struct AdditiveSpriteShader_PixelShader55_Input
{
    float4 color : COLOR;
    float2 texcoord : TEXCOORD;
};

float4 AdditiveSpriteShader_PixelShader55(AdditiveSpriteShader_PixelShader55_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    float3 temp1;
    // def c0, 2.2, 0, 0, 0
    // dcl v0
    // dcl t0.xy
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(ParticleTextureSampler, i.texcoord.xy);
    // log r1.x, r0.x
    temp1.x = log2(temp0.x);
    // log r1.y, r0.y
    temp1.y = log2(temp0.y);
    // log r1.z, r0.z
    temp1.z = log2(temp0.z);
    // mul r1.xyz, r1, c0.x
    temp1.xyz = temp1.xyz * float3(2.2, 2.2, 2.2);
    // exp r0.x, r1.x
    temp0.x = exp2(temp1.x);
    // exp r0.y, r1.y
    temp0.y = exp2(temp1.y);
    // exp r0.z, r1.z
    temp0.z = exp2(temp1.z);
    // mul r0, r0, v0
    temp0 = temp0 * i.color;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// AdditiveSpriteShader_VertexShader56 Vertex_2_0 Has PRES False
struct AdditiveSpriteShader_VertexShader56_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct AdditiveSpriteShader_VertexShader56_Output
{
    float2 texcoord : TEXCOORD;
    float4 position : POSITION;
    float4 color : COLOR;
};

AdditiveSpriteShader_VertexShader56_Output AdditiveSpriteShader_VertexShader56(AdditiveSpriteShader_VertexShader56_Input i)
{
    AdditiveSpriteShader_VertexShader56_Output o;
    float4 temp0;
    float2 temp1;
    float addr0;
    // def c12, 0.5, -0.5, 6.283185, -3.141593
    // def c11, -0.5, -0.5, 0.1591549, 0.5
    // def c14, -0.5, 0.5, 1, -1
    // def c13, 0.5, 0.5, 1, 0
    // def c15, 0, 0, 0, 0
    // def c16, -0.25, -0.25, 0, 0
    // def c17, 0.25, -0.25, 0, 0
    // def c18, 0.25, 0.25, 0, 0
    // def c19, -0.25, 0.25, 0, 0
    // def c0, -1.550099E-06, -2.170139E-05, 0.002604167, 0.0002604167
    // def c1, -0.02083333, -0.125, 1, 0.5
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_color v2
    // mad r0.x, v1.x, c11.z, c11.w
    temp0.x = i.texcoord.x * float1(0.15915494) + float1(0.5);
    // frc r0.x, r0.x
    temp0.x = frac(temp0.x);
    // mad r0.x, r0.x, c12.z, c12.w
    temp0.x = temp0.x * float1(6.2831855) + float1(-3.1415927);
    // sincos r1.xy, r0.x, c0, c1
    temp1.xy = float2(cos(temp0.x), sin(temp0.x));
    // frc r0.x, v0.w
    temp0.x = frac(i.position.w);
    // add r0.x, -r0.x, v0.w
    temp0.x = -temp0.x + i.position.w;
    // mova a0.x, r0.x
    addr0.x = temp0.x;
    // mul r0.xyz, r1.xyxw, c11[a0.x].xyyw
    temp0.xyz = temp1.xyx * float3(-0.5, -0.5, -0.5);
    // mad r0.w, c11[a0.x].x, -r1.y, r0.z
    temp0.w = float1(-0.5) * -temp1.y + temp0.z;
    // mov r1.xy, c11[a0.x]
    temp1.xy = float2(-0.5, -0.5);
    // mad oT0.xy, r1, c14.zwzw, c14.y
    o.texcoord = temp1 * float4(1, -1, 1, -1) + float4(0.5, 0.5, 0.5, 0.5);
    // add r0.z, r0.y, r0.x
    temp0.z = temp0.y + temp0.x;
    // mov r0.xy, v0
    temp0.xy = i.position.xy;
    // mad r0.xy, v1.y, r0.zwzw, r0
    temp0.xy = i.texcoord.yy * temp0.zw + temp0.xy;
    // mad r0.zw, v0.z, c13, c13.xywz
    temp0.zw = i.position.zz * float2(1, 0) + float2(0, 1);
    // dp4 oPos.x, r0, c119
    o.position.x = dot(temp0, (ViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c120
    o.position.y = dot(temp0, (ViewProjection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c121
    o.position.z = dot(temp0, (ViewProjection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c122
    o.position.w = dot(temp0, (ViewProjection._m03_m13_m23_m33));
    // mov oD0, v2
    o.color = i.color;
    // 

    return o;
}

technique AdditiveSpriteShader
{
    pass P0
    {
        VertexShader = compile vs_2_0 AdditiveSpriteShader_VertexShader56(); // 15
        PixelShader = compile ps_2_0 AdditiveSpriteShader_PixelShader55(); // 16
        ZEnable = 1;
        ZFunc = 4;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 1;
        SrcBlend = 2;
        DestBlend = 2;
        AlphaTestEnable = 0;
    }
}

technique AdditiveAlphaTestSpriteShader
{
    pass P0
    {
        VertexShader = compile vs_2_0 AdditiveAlphaTestSpriteShader_VertexShader54(); // 17
        PixelShader = compile ps_2_0 AdditiveAlphaTestSpriteShader_PixelShader53(); // 18
        ZEnable = 1;
        ZFunc = 4;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 1;
        SrcBlend = 2;
        DestBlend = 2;
        AlphaTestEnable = 1;
        AlphaFunc = 7;
        AlphaRef = 96;
    }
}

technique AlphaSpriteShader
{
    pass P0
    {
        VertexShader = compile vs_2_0 AlphaSpriteShader_VertexShader52(); // 19
        PixelShader = compile ps_2_0 AlphaSpriteShader_PixelShader51(); // 20
        ZEnable = 1;
        ZFunc = 4;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 1;
        SrcBlend = 5;
        DestBlend = 6;
        AlphaTestEnable = 0;
    }
}

technique ATestSpriteShader
{
    pass P0
    {
        VertexShader = compile vs_2_0 ATestSpriteShader_VertexShader50(); // 21
        PixelShader = compile ps_2_0 ATestSpriteShader_PixelShader49(); // 22
        ZEnable = 1;
        ZFunc = 4;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 0;
        AlphaTestEnable = 1;
        AlphaFunc = 7;
        AlphaRef = 96;
    }
}

technique MultiplicativeSpriteShader
{
    pass P0
    {
        VertexShader = compile vs_2_0 MultiplicativeSpriteShader_VertexShader48(); // 23
        PixelShader = compile ps_2_0 MultiplicativeSpriteShader_PixelShader47(); // 24
        ZEnable = 1;
        ZFunc = 4;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 1;
        SrcBlend = 9;
        DestBlend = 1;
        AlphaTestEnable = 0;
    }
}

technique Additive2DShader
{
    pass P0
    {
        VertexShader = compile vs_2_0 Additive2DShader_VertexShader46(); // 25
        PixelShader = compile ps_2_0 Additive2DShader_PixelShader45(); // 26
        ZEnable = 0;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 1;
        SrcBlend = 2;
        DestBlend = 2;
        AlphaTestEnable = 0;
    }
}

technique Alpha2DShader
{
    pass P0
    {
        VertexShader = compile vs_2_0 Alpha2DShader_VertexShader44(); // 27
        PixelShader = compile ps_2_0 Alpha2DShader_PixelShader43(); // 28
        ZEnable = 0;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 1;
        SrcBlend = 5;
        DestBlend = 6;
        AlphaTestEnable = 0;
    }
}

technique AdditiveSpriteShaderBillboard
{
    pass P0
    {
        VertexShader = compile vs_2_0 AdditiveSpriteShaderBillboard_VertexShader42(); // 29
        PixelShader = compile ps_2_0 AdditiveSpriteShaderBillboard_PixelShader41(); // 30
        ZEnable = 1;
        ZFunc = 4;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 1;
        SrcBlend = 2;
        DestBlend = 2;
        AlphaTestEnable = 0;
    }
}

technique AdditiveAlphaTestSpriteShaderBillboard
{
    pass P0
    {
        VertexShader = compile vs_2_0 AdditiveAlphaTestSpriteShaderBillboard_VertexShader40(); // 31
        PixelShader = compile ps_2_0 AdditiveAlphaTestSpriteShaderBillboard_PixelShader39(); // 32
        ZEnable = 1;
        ZFunc = 4;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 1;
        SrcBlend = 2;
        DestBlend = 2;
        AlphaTestEnable = 1;
        AlphaFunc = 7;
        AlphaRef = 96;
    }
}

technique AlphaSpriteShaderBillboard
{
    pass P0
    {
        VertexShader = compile vs_2_0 AlphaSpriteShaderBillboard_VertexShader38(); // 33
        PixelShader = compile ps_2_0 AlphaSpriteShaderBillboard_PixelShader37(); // 34
        ZEnable = 1;
        ZFunc = 4;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 1;
        SrcBlend = 5;
        DestBlend = 6;
        AlphaTestEnable = 0;
    }
}

technique ATestSpriteShaderBillboard
{
    pass P0
    {
        VertexShader = compile vs_2_0 ATestSpriteShaderBillboard_VertexShader36(); // 35
        PixelShader = compile ps_2_0 ATestSpriteShaderBillboard_PixelShader35(); // 36
        ZEnable = 1;
        ZFunc = 4;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 0;
        AlphaTestEnable = 1;
        AlphaFunc = 7;
        AlphaRef = 96;
    }
}

technique MultiplicativeSpriteShaderBillboard
{
    pass P0
    {
        VertexShader = compile vs_2_0 MultiplicativeSpriteShaderBillboard_VertexShader34(); // 37
        PixelShader = compile ps_2_0 MultiplicativeSpriteShaderBillboard_PixelShader33(); // 38
        ZEnable = 1;
        ZFunc = 4;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 1;
        SrcBlend = 9;
        DestBlend = 1;
        AlphaTestEnable = 0;
    }
}

technique Additive2DShaderBillboard
{
    pass P0
    {
        VertexShader = compile vs_2_0 Additive2DShaderBillboard_VertexShader32(); // 39
        PixelShader = compile ps_2_0 Additive2DShaderBillboard_PixelShader31(); // 40
        ZEnable = 0;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 1;
        SrcBlend = 2;
        DestBlend = 2;
        AlphaTestEnable = 0;
    }
}

technique Alpha2DShaderBillboard
{
    pass P0
    {
        VertexShader = compile vs_2_0 Alpha2DShaderBillboard_VertexShader30(); // 41
        PixelShader = compile ps_2_0 Alpha2DShaderBillboard_PixelShader29(); // 42
        ZEnable = 0;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 1;
        SrcBlend = 5;
        DestBlend = 6;
        AlphaTestEnable = 0;
    }
}

technique AdditiveSpriteShader_M
{
    pass P0
    {
        VertexShader = compile vs_2_0 AdditiveSpriteShader_M_VertexShader28(); // 43
        PixelShader = compile ps_2_0 AdditiveSpriteShader_M_PixelShader27(); // 44
        ZEnable = 1;
        ZFunc = 4;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 1;
        SrcBlend = 2;
        DestBlend = 2;
        AlphaTestEnable = 0;
    }
}

technique AdditiveAlphaTestSpriteShader_M
{
    pass P0
    {
        VertexShader = compile vs_2_0 AdditiveAlphaTestSpriteShader_M_VertexShader26(); // 45
        PixelShader = compile ps_2_0 AdditiveAlphaTestSpriteShader_M_PixelShader25(); // 46
        ZEnable = 1;
        ZFunc = 4;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 1;
        SrcBlend = 2;
        DestBlend = 2;
        AlphaTestEnable = 1;
        AlphaFunc = 7;
        AlphaRef = 96;
    }
}

technique AlphaSpriteShader_M
{
    pass P0
    {
        VertexShader = compile vs_2_0 AlphaSpriteShader_M_VertexShader24(); // 47
        PixelShader = compile ps_2_0 AlphaSpriteShader_M_PixelShader23(); // 48
        ZEnable = 1;
        ZFunc = 4;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 1;
        SrcBlend = 5;
        DestBlend = 6;
        AlphaTestEnable = 0;
    }
}

technique ATestSpriteShader_M
{
    pass P0
    {
        VertexShader = compile vs_2_0 ATestSpriteShader_M_VertexShader22(); // 49
        PixelShader = compile ps_2_0 ATestSpriteShader_M_PixelShader21(); // 50
        ZEnable = 1;
        ZFunc = 4;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 0;
        AlphaTestEnable = 1;
        AlphaFunc = 7;
        AlphaRef = 96;
    }
}

technique MultiplicativeSpriteShader_M
{
    pass P0
    {
        VertexShader = compile vs_2_0 MultiplicativeSpriteShader_M_VertexShader20(); // 51
        PixelShader = compile ps_2_0 MultiplicativeSpriteShader_M_PixelShader19(); // 52
        ZEnable = 1;
        ZFunc = 4;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 1;
        SrcBlend = 9;
        DestBlend = 1;
        AlphaTestEnable = 0;
    }
}

technique Additive2DShader_M
{
    pass P0
    {
        VertexShader = compile vs_2_0 Additive2DShader_M_VertexShader18(); // 53
        PixelShader = compile ps_2_0 Additive2DShader_M_PixelShader17(); // 54
        ZEnable = 0;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 1;
        SrcBlend = 2;
        DestBlend = 2;
        AlphaTestEnable = 0;
    }
}

technique Alpha2DShader_M
{
    pass P0
    {
        VertexShader = compile vs_2_0 Alpha2DShader_M_VertexShader16(); // 55
        PixelShader = compile ps_2_0 Alpha2DShader_M_PixelShader15(); // 56
        ZEnable = 0;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 1;
        SrcBlend = 5;
        DestBlend = 6;
        AlphaTestEnable = 0;
    }
}

technique AdditiveSpriteShaderBillboard_M
{
    pass P0
    {
        VertexShader = compile vs_2_0 AdditiveSpriteShaderBillboard_M_VertexShader14(); // 57
        PixelShader = compile ps_2_0 AdditiveSpriteShaderBillboard_M_PixelShader13(); // 58
        ZEnable = 1;
        ZFunc = 4;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 1;
        SrcBlend = 2;
        DestBlend = 2;
        AlphaTestEnable = 0;
    }
}

technique AdditiveAlphaTestSpriteShaderBillboard_M
{
    pass P0
    {
        VertexShader = compile vs_2_0 AdditiveAlphaTestSpriteShaderBillboard_M_VertexShader12(); // 59
        PixelShader = compile ps_2_0 AdditiveAlphaTestSpriteShaderBillboard_M_PixelShader11(); // 60
        ZEnable = 1;
        ZFunc = 4;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 1;
        SrcBlend = 2;
        DestBlend = 2;
        AlphaTestEnable = 1;
        AlphaFunc = 7;
        AlphaRef = 96;
    }
}

technique AlphaSpriteShaderBillboard_M
{
    pass P0
    {
        VertexShader = compile vs_2_0 AlphaSpriteShaderBillboard_M_VertexShader10(); // 61
        PixelShader = compile ps_2_0 AlphaSpriteShaderBillboard_M_PixelShader9(); // 62
        ZEnable = 1;
        ZFunc = 4;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 1;
        SrcBlend = 5;
        DestBlend = 6;
        AlphaTestEnable = 0;
    }
}

technique ATestSpriteShaderBillboard_M
{
    pass P0
    {
        VertexShader = compile vs_2_0 ATestSpriteShaderBillboard_M_VertexShader8(); // 63
        PixelShader = compile ps_2_0 ATestSpriteShaderBillboard_M_PixelShader7(); // 64
        ZEnable = 1;
        ZFunc = 4;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 0;
        AlphaTestEnable = 1;
        AlphaFunc = 7;
        AlphaRef = 96;
    }
}

technique MultiplicativeSpriteShaderBillboard_M
{
    pass P0
    {
        VertexShader = compile vs_2_0 MultiplicativeSpriteShaderBillboard_M_VertexShader6(); // 65
        PixelShader = compile ps_2_0 MultiplicativeSpriteShaderBillboard_M_PixelShader5(); // 66
        ZEnable = 1;
        ZFunc = 4;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 1;
        SrcBlend = 9;
        DestBlend = 1;
        AlphaTestEnable = 0;
    }
}

technique Additive2DShaderBillboard_M
{
    pass P0
    {
        VertexShader = compile vs_2_0 Additive2DShaderBillboard_M_VertexShader4(); // 67
        PixelShader = compile ps_2_0 Additive2DShaderBillboard_M_PixelShader3(); // 68
        ZEnable = 0;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 1;
        SrcBlend = 2;
        DestBlend = 2;
        AlphaTestEnable = 0;
    }
}

technique Alpha2DShaderBillboard_M
{
    pass P0
    {
        VertexShader = compile vs_2_0 Alpha2DShaderBillboard_M_VertexShader2(); // 69
        PixelShader = compile ps_2_0 Alpha2DShaderBillboard_M_PixelShader1(); // 70
        ZEnable = 0;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 1;
        SrcBlend = 5;
        DestBlend = 6;
        AlphaTestEnable = 0;
    }
}

