string DefaultParameterScopeBlock = "material"; // 1
float3 AmbientLightColor <bool unmanaged = 1;> = { 0.3, 0.3, 0.3 };
struct {
    float3 Color;
    float3 Direction;
} DirectionalLight[3] <bool unmanaged = 1;> = { 1.625198, 1.512711, 1.097048, 0.62914, -0.34874, 0.69465, 0.5232916, 0.6654605, 0.7815244, -0.32877, 0.90329, 0.27563, 0.4420466, 0.4102767, 0.4420466, -0.80704, -0.58635, 0.06975 };
struct {
    float3 Color;
    float3 Position;
    float2 Range_Inner_Outer;
} PointLight[8] <bool unmanaged = 1;>;
struct {
    float4 WorldPositionMultiplier_XYZZ;
    float2 CurrentOffsetUV;
} Cloud <bool unmanaged = 1;>;
float3 NoCloudMultiplier <bool unmanaged = 1;> = { 1, 1, 1 };
float3 RecolorColorDummy <bool unmanaged = 1;>;
row_major float4x4 ShadowMapWorldToShadow <bool unmanaged = 1;>;
float OpacityOverride <bool unmanaged = 1;> = { 1 };
float3 TintColor <bool unmanaged = 1;> = { 1, 1, 1 };
float3 EyePosition <bool unmanaged = 1;>;
row_major float4x4 ViewProjection <bool unmanaged = 1;>;
float4 WorldBones[128] <bool unmanaged = 1;>;
struct
{
    float4 VideoTex_NumPerRow_LastFrame_SingleRow_isRand;
    float4 ColorAnimationFunctions[6];
    float4 TimeKeys;
    int ShaderType;
    float SpeedMultiplier;
    float2 ColorScaleRange;
} Draw : register(vs_2_0, c54) : register(vs_3_0, c57) <string UIWidget = "None"; string SasBindAddress = "Particle.Draw";> = { 4, 15, -1, 0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 1, 1, -0.1, 0.2 };
struct
{
    float3 Gravity;
    float3 DriftVelocity;
    float2 VelocityDampingRange;
} Physics : register(vs_2_0, c75) : register(vs_3_0, c82) <string UIWidget = "None"; string SasBindAddress = "Particle.Physics";> = { 0, 0, 0, 0, 0, 0, 1, 0 };
struct
{
    float3 Size_Rate_Damping__Min;
    float3 Size_Rate_Damping__Spread;
    float3 XYRotation_Rate_Damping__Min;
    float3 XYRotation_Rate_Damping__Spread;
    float3 ZRotation_Rate_Damping__Min;
    float3 ZRotation_Rate_Damping__Spread;
} Update : register(vs_2_0, c65) : register(vs_3_0, c68) <string UIWidget = "None"; string SasBindAddress = "Particle.Update";> = { 0, 0, 1, 10, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0 };
texture DepthLutSampler <string UIWidget = "None"; string SasBindAddress = "Water.DepthLutTexture";>; // 8
sampler2D DepthLutSamplerSampler : register(ps_2_0, s0) : register(ps_3_0, s0) <string Texture = "DepthLutSampler"; string UIWidget = "None"; string SasBindAddress = "Water.DepthLutTexture";> =
sampler_state
{
    Texture = <DepthLutSampler>; // 11
    MinFilter = 2;
    MagFilter = 2;
    MipFilter = 2;
    AddressU = 3;
    AddressV = 3;
};
texture CausticSampler <string UIWidget = "None"; string SasBindAddress = "Water.CausticsTexture";>; // 15
sampler2D CausticSamplerSampler <string Texture = "CausticSampler"; string UIWidget = "None"; string SasBindAddress = "Water.CausticsTexture";> =
sampler_state
{
    Texture = <CausticSampler>; // 18
    MinFilter = 2;
    MagFilter = 2;
    MipFilter = 2;
    AddressU = 1;
    AddressV = 1;
};
int _SasGlobal : SasGlobal <string UIWidget = "None"; int3 SasVersion = int3(1, 0, 0); string RenderBin = "Underwater";>;
texture ParticleTextureSampler <string UIWidget = "None"; string SasBindAddress = "Particle.Draw.Texture";>; // 24
sampler2D ParticleTextureSamplerSampler : register(ps_3_0, s1) <string Texture = "ParticleTextureSampler"; string UIWidget = "None"; string SasBindAddress = "Particle.Draw.Texture";> =
sampler_state
{
    Texture = <ParticleTextureSampler>; // 27
    MinFilter = 2;
    MagFilter = 2;
    MipFilter = 2;
    AddressU = 3;
    AddressV = 3;
};
texture NextFrameTextureSampler <string UIWidget = "None"; string SasBindAddress = "Particle.Draw.Texture";>; // 31
sampler2D NextFrameTextureSamplerSampler : register(ps_2_0, s2) : register(ps_3_0, s2) <string Texture = "NextFrameTextureSampler"; string UIWidget = "None"; string SasBindAddress = "Particle.Draw.Texture";> =
sampler_state
{
    Texture = <NextFrameTextureSampler>; // 34
    MinFilter = 2;
    MagFilter = 2;
    MipFilter = 2;
    AddressU = 3;
    AddressV = 3;
};
texture DepthTexture <string SasBindAddress = "WW3D.DepthTexture";>; // 38
sampler2D DepthTextureSampler : register(ps_3_0, s3) <string Texture = "DepthTexture"; string SasBindAddress = "WW3D.DepthTexture";> =
sampler_state
{
    Texture = <DepthTexture>; // 40
    MinFilter = 2;
    MagFilter = 2;
    MipFilter = 1;
    AddressU = 3;
    AddressV = 3;
};
bool ShouldDrawParticleSoft <string UIWidget = "None"; string SasBindAddress = "Particle.Draw.ShouldDrawParticleSoft";>;
column_major float4x4 WorldView : WorldView : register(vs_3_0, c74);
column_major float4x4 Projection : Projection : register(vs_3_0, c78);
column_major float4x4 WorldViewProjection : WorldViewProjection : register(vs_2_0, c71);
column_major float4x3 View : View : register(vs_2_0, c78) : register(vs_3_0, c85);
row_major float4x4 ProjectionI : ProjectionInverse;
float Time : Time;
// PS_Array_H_Shader_0 Pixel_3_0 Has PRES False
struct PS_Array_H_Shader_0_Input
{
    float2 texcoord : TEXCOORD;
    float4 color : COLOR;
    float3 texcoord3 : TEXCOORD3;
    float4 texcoord4 : TEXCOORD4;
    float2 texcoord5 : TEXCOORD5;
    float3 texcoord6 : TEXCOORD6;
};

float4 PS_Array_H_Shader_0(PS_Array_H_Shader_0_Input i) : COLOR
{
    float4 out_color;
    float4 temp0, temp1, temp2, temp3;
    // def c0, 0.5, -0.5, 2.2, 0
    // def c1, -0.005, 0, 1.005, 0
    // dcl_texcoord v0.xy
    // dcl_color v1
    // dcl_texcoord3 v2.xyz
    // dcl_texcoord4 v3.xyw
    // dcl_texcoord5 v4.xy
    // dcl_texcoord6 v5.z
    // dcl_2d s0
    // dcl_2d s1
    // dcl_2d s2
    // dcl_2d s3
    // rcp r0.x, v3.w
    temp0.x = 1.0f / i.texcoord4.w;
    // mul r0.xy, r0.x, v3
    temp0.xy = temp0.xx * i.texcoord4.xy;
    // mad r0.xy, r0, c0, c0.x
    temp0.xy = temp0.xy * float2(0.5, -0.5) + float2(0.5, 0.5);
    // texld r0, r0, s3
    temp0 = tex2D(DepthTextureSampler, temp0.xy);
    // mad_sat r0.x, r0.x, -v4.y, v4.x
    temp0.x = saturate(temp0.x * -i.texcoord5.y + i.texcoord5.x);
    // texld r1, v0, s1
    temp1 = tex2D(ParticleTextureSamplerSampler, i.texcoord.xy);
    // texld r2, v2, s2
    temp2 = tex2D(NextFrameTextureSamplerSampler, i.texcoord3.xy);
    // lrp r3, v2.z, r2, r1
    temp3 = lerp(temp1, temp2, i.texcoord3.z);
    // mul r1, r3, v1
    temp1 = temp3 * i.color;
    // log r0.y, r1.x
    temp0.y = log2(temp1.x);
    // log r0.z, r1.y
    temp0.z = log2(temp1.y);
    // log r0.w, r1.z
    temp0.w = log2(temp1.z);
    // mov oC0.w, r1.w
    out_color.w = temp1.w;
    // mul r0.yzw, r0, c0.z
    temp0.yzw = temp0.yzw * float3(2.2, 2.2, 2.2);
    // exp r1.x, r0.y
    temp1.x = exp2(temp0.y);
    // exp r1.y, r0.z
    temp1.y = exp2(temp0.z);
    // exp r1.z, r0.w
    temp1.z = exp2(temp0.w);
    // mul r0.xyz, r0.x, r1
    temp0.xyz = temp0.xxx * temp1.xyz;
    // mad r1, v5.z, c1.xxyy, c1.zzyy
    temp1 = i.texcoord6.z * float4(-0.005, -0.005, 0, 0) + float4(1.005, 1.005, 0, 0);
    // texldl r1, r1, s0
    temp1 = tex2Dlod(DepthLutSamplerSampler, temp1);
    // log r2.x, r1.x
    temp2.x = log2(temp1.x);
    // log r2.y, r1.y
    temp2.y = log2(temp1.y);
    // log r2.z, r1.z
    temp2.z = log2(temp1.z);
    // mul r1.xyz, r2, c0.z
    temp1.xyz = temp2.xyz * float3(2.2, 2.2, 2.2);
    // exp r2.x, r1.x
    temp2.x = exp2(temp1.x);
    // exp r2.y, r1.y
    temp2.y = exp2(temp1.y);
    // exp r2.z, r1.z
    temp2.z = exp2(temp1.z);
    // mul oC0.xyz, r0, r2
    out_color.xyz = temp0.xyz * temp2.xyz;
    // 

    return out_color;
}

// PS_Array_H_Shader_1 Pixel_3_0 Has PRES False
struct PS_Array_H_Shader_1_Input
{
    float2 texcoord : TEXCOORD;
    float4 color : COLOR;
    float3 texcoord1 : TEXCOORD1;
    float3 texcoord3 : TEXCOORD3;
    float4 texcoord4 : TEXCOORD4;
    float2 texcoord5 : TEXCOORD5;
    float3 texcoord6 : TEXCOORD6;
};

float4 PS_Array_H_Shader_1(PS_Array_H_Shader_1_Input i) : COLOR
{
    float4 out_color;
    float4 temp0, temp1, temp2, temp3;
    // def c0, 0.5, -0.5, 2.2, -1
    // def c1, -0.005, 0, 1.005, 0
    // dcl_texcoord v0.xy
    // dcl_color v1
    // dcl_texcoord1 v2.xyz
    // dcl_texcoord3 v3.xyz
    // dcl_texcoord4 v4.xyw
    // dcl_texcoord5 v5.xy
    // dcl_texcoord6 v6.z
    // dcl_2d s0
    // dcl_2d s1
    // dcl_2d s2
    // dcl_2d s3
    // rcp r0.x, v4.w
    temp0.x = 1.0f / i.texcoord4.w;
    // mul r0.xy, r0.x, v4
    temp0.xy = temp0.xx * i.texcoord4.xy;
    // mad r0.xy, r0, c0, c0.x
    temp0.xy = temp0.xy * float2(0.5, -0.5) + float2(0.5, 0.5);
    // texld r0, r0, s3
    temp0 = tex2D(DepthTextureSampler, temp0.xy);
    // mad_sat r0.x, r0.x, -v5.y, v5.x
    temp0.x = saturate(temp0.x * -i.texcoord5.y + i.texcoord5.x);
    // texld r1, v0, s1
    temp1 = tex2D(ParticleTextureSamplerSampler, i.texcoord.xy);
    // texld r2, v3, s2
    temp2 = tex2D(NextFrameTextureSamplerSampler, i.texcoord3.xy);
    // lrp r3, v3.z, r2, r1
    temp3 = lerp(temp1, temp2, i.texcoord3.z);
    // mul r1, r3, v1
    temp1 = temp3 * i.color;
    // log r0.y, r1.x
    temp0.y = log2(temp1.x);
    // log r0.z, r1.y
    temp0.z = log2(temp1.y);
    // log r0.w, r1.z
    temp0.w = log2(temp1.z);
    // mov oC0.w, r1.w
    out_color.w = temp1.w;
    // mul r0.yzw, r0, c0.z
    temp0.yzw = temp0.yzw * float3(2.2, 2.2, 2.2);
    // exp r1.x, r0.y
    temp1.x = exp2(temp0.y);
    // exp r1.y, r0.z
    temp1.y = exp2(temp0.z);
    // exp r1.z, r0.w
    temp1.z = exp2(temp0.w);
    // mul r0.xyz, r0.x, r1
    temp0.xyz = temp0.xxx * temp1.xyz;
    // mad r1, v6.z, c1.xxyy, c1.zzyy
    temp1 = i.texcoord6.z * float4(-0.005, -0.005, 0, 0) + float4(1.005, 1.005, 0, 0);
    // texldl r1, r1, s0
    temp1 = tex2Dlod(DepthLutSamplerSampler, temp1);
    // log r2.x, r1.x
    temp2.x = log2(temp1.x);
    // log r2.y, r1.y
    temp2.y = log2(temp1.y);
    // log r2.z, r1.z
    temp2.z = log2(temp1.z);
    // mul r1.xyz, r2, c0.z
    temp1.xyz = temp2.xyz * float3(2.2, 2.2, 2.2);
    // exp r2.x, r1.x
    temp2.x = exp2(temp1.x);
    // exp r2.y, r1.y
    temp2.y = exp2(temp1.y);
    // exp r2.z, r1.z
    temp2.z = exp2(temp1.z);
    // mad r0.xyz, r0, r2, c0.w
    temp0.xyz = temp0.xyz * temp2.xyz + float3(-1, -1, -1);
    // mov_sat r1.xyz, v2
    temp1.xyz = saturate(i.texcoord1.xyz);
    // mad oC0.xyz, r1, r0, -c0.w
    out_color.xyz = temp1.xyz * temp0.xyz + float3(1, 1, 1);
    // 

    return out_color;
}

// PS_Array_H_Shader_2 Pixel_3_0 Has PRES False
struct PS_Array_H_Shader_2_Input
{
    float2 texcoord : TEXCOORD;
    float4 color : COLOR;
    float3 texcoord1 : TEXCOORD1;
    float3 texcoord3 : TEXCOORD3;
    float4 texcoord4 : TEXCOORD4;
    float2 texcoord5 : TEXCOORD5;
    float3 texcoord6 : TEXCOORD6;
};

float4 PS_Array_H_Shader_2(PS_Array_H_Shader_2_Input i) : COLOR
{
    float4 out_color;
    float4 temp0, temp1, temp2, temp3;
    // def c0, 0.5, -0.5, 2.2, 0
    // def c1, -0.005, 0, 1.005, 0
    // dcl_texcoord v0.xy
    // dcl_color v1
    // dcl_texcoord1 v2.xyz
    // dcl_texcoord3 v3.xyz
    // dcl_texcoord4 v4.xyw
    // dcl_texcoord5 v5.xy
    // dcl_texcoord6 v6.z
    // dcl_2d s0
    // dcl_2d s1
    // dcl_2d s2
    // dcl_2d s3
    // rcp r0.x, v4.w
    temp0.x = 1.0f / i.texcoord4.w;
    // mul r0.xy, r0.x, v4
    temp0.xy = temp0.xx * i.texcoord4.xy;
    // mad r0.xy, r0, c0, c0.x
    temp0.xy = temp0.xy * float2(0.5, -0.5) + float2(0.5, 0.5);
    // texld r0, r0, s3
    temp0 = tex2D(DepthTextureSampler, temp0.xy);
    // mad_sat r0.x, r0.x, -v5.y, v5.x
    temp0.x = saturate(temp0.x * -i.texcoord5.y + i.texcoord5.x);
    // texld r1, v0, s1
    temp1 = tex2D(ParticleTextureSamplerSampler, i.texcoord.xy);
    // texld r2, v3, s2
    temp2 = tex2D(NextFrameTextureSamplerSampler, i.texcoord3.xy);
    // lrp r3, v3.z, r2, r1
    temp3 = lerp(temp1, temp2, i.texcoord3.z);
    // mul r1, r3, v1
    temp1 = temp3 * i.color;
    // log r0.y, r1.x
    temp0.y = log2(temp1.x);
    // log r0.z, r1.y
    temp0.z = log2(temp1.y);
    // log r0.w, r1.z
    temp0.w = log2(temp1.z);
    // mov oC0.w, r1.w
    out_color.w = temp1.w;
    // mul r0.yzw, r0, c0.z
    temp0.yzw = temp0.yzw * float3(2.2, 2.2, 2.2);
    // exp r1.x, r0.y
    temp1.x = exp2(temp0.y);
    // exp r1.y, r0.z
    temp1.y = exp2(temp0.z);
    // exp r1.z, r0.w
    temp1.z = exp2(temp0.w);
    // mul r0.xyz, r0.x, r1
    temp0.xyz = temp0.xxx * temp1.xyz;
    // mad r1, v6.z, c1.xxyy, c1.zzyy
    temp1 = i.texcoord6.z * float4(-0.005, -0.005, 0, 0) + float4(1.005, 1.005, 0, 0);
    // texldl r1, r1, s0
    temp1 = tex2Dlod(DepthLutSamplerSampler, temp1);
    // log r2.x, r1.x
    temp2.x = log2(temp1.x);
    // log r2.y, r1.y
    temp2.y = log2(temp1.y);
    // log r2.z, r1.z
    temp2.z = log2(temp1.z);
    // mul r1.xyz, r2, c0.z
    temp1.xyz = temp2.xyz * float3(2.2, 2.2, 2.2);
    // exp r2.x, r1.x
    temp2.x = exp2(temp1.x);
    // exp r2.y, r1.y
    temp2.y = exp2(temp1.y);
    // exp r2.z, r1.z
    temp2.z = exp2(temp1.z);
    // mul r0.xyz, r0, r2
    temp0.xyz = temp0.xyz * temp2.xyz;
    // mov_sat r1.xyz, v2
    temp1.xyz = saturate(i.texcoord1.xyz);
    // mul oC0.xyz, r0, r1
    out_color.xyz = temp0.xyz * temp1.xyz;
    // 

    return out_color;
}

// PS_Array_H_Shader_3 Pixel_3_0 Has PRES False
struct PS_Array_H_Shader_3_Input
{
    float2 texcoord : TEXCOORD;
    float4 color : COLOR;
    float3 texcoord3 : TEXCOORD3;
    float4 texcoord4 : TEXCOORD4;
    float2 texcoord5 : TEXCOORD5;
    float3 texcoord6 : TEXCOORD6;
};

float4 PS_Array_H_Shader_3(PS_Array_H_Shader_3_Input i) : COLOR
{
    float4 out_color;
    float4 temp0, temp1, temp2, temp3;
    // def c0, 0.5, -0.5, 2.2, 0
    // def c1, -0.005, 0, 1.005, 0
    // dcl_texcoord v0.xy
    // dcl_color v1
    // dcl_texcoord3 v2.xyz
    // dcl_texcoord4 v3.xyw
    // dcl_texcoord5 v4.xy
    // dcl_texcoord6 v5.z
    // dcl_2d s0
    // dcl_2d s1
    // dcl_2d s2
    // dcl_2d s3
    // rcp r0.x, v3.w
    temp0.x = 1.0f / i.texcoord4.w;
    // mul r0.xy, r0.x, v3
    temp0.xy = temp0.xx * i.texcoord4.xy;
    // mad r0.xy, r0, c0, c0.x
    temp0.xy = temp0.xy * float2(0.5, -0.5) + float2(0.5, 0.5);
    // texld r0, r0, s3
    temp0 = tex2D(DepthTextureSampler, temp0.xy);
    // mad_sat r0.x, r0.x, -v4.y, v4.x
    temp0.x = saturate(temp0.x * -i.texcoord5.y + i.texcoord5.x);
    // texld r1, v0, s1
    temp1 = tex2D(ParticleTextureSamplerSampler, i.texcoord.xy);
    // texld r2, v2, s2
    temp2 = tex2D(NextFrameTextureSamplerSampler, i.texcoord3.xy);
    // lrp r3, v2.z, r2, r1
    temp3 = lerp(temp1, temp2, i.texcoord3.z);
    // mul r1, r3, v1
    temp1 = temp3 * i.color;
    // mul oC0.w, r0.x, r1.w
    out_color.w = temp0.x * temp1.w;
    // log r0.x, r1.x
    temp0.x = log2(temp1.x);
    // log r0.y, r1.y
    temp0.y = log2(temp1.y);
    // log r0.z, r1.z
    temp0.z = log2(temp1.z);
    // mul r0.xyz, r0, c0.z
    temp0.xyz = temp0.xyz * float3(2.2, 2.2, 2.2);
    // exp r1.x, r0.x
    temp1.x = exp2(temp0.x);
    // exp r1.y, r0.y
    temp1.y = exp2(temp0.y);
    // exp r1.z, r0.z
    temp1.z = exp2(temp0.z);
    // mad r0, v5.z, c1.xxyy, c1.zzyy
    temp0 = i.texcoord6.z * float4(-0.005, -0.005, 0, 0) + float4(1.005, 1.005, 0, 0);
    // texldl r0, r0, s0
    temp0 = tex2Dlod(DepthLutSamplerSampler, temp0);
    // log r2.x, r0.x
    temp2.x = log2(temp0.x);
    // log r2.y, r0.y
    temp2.y = log2(temp0.y);
    // log r2.z, r0.z
    temp2.z = log2(temp0.z);
    // mul r0.xyz, r2, c0.z
    temp0.xyz = temp2.xyz * float3(2.2, 2.2, 2.2);
    // exp r2.x, r0.x
    temp2.x = exp2(temp0.x);
    // exp r2.y, r0.y
    temp2.y = exp2(temp0.y);
    // exp r2.z, r0.z
    temp2.z = exp2(temp0.z);
    // mul oC0.xyz, r1, r2
    out_color.xyz = temp1.xyz * temp2.xyz;
    // 

    return out_color;
}

// PS_Array_H_Shader_4 Pixel_3_0 Has PRES False
struct PS_Array_H_Shader_4_Input
{
    float2 texcoord : TEXCOORD;
    float4 color : COLOR;
    float3 texcoord1 : TEXCOORD1;
    float3 texcoord3 : TEXCOORD3;
    float4 texcoord4 : TEXCOORD4;
    float2 texcoord5 : TEXCOORD5;
    float3 texcoord6 : TEXCOORD6;
};

float4 PS_Array_H_Shader_4(PS_Array_H_Shader_4_Input i) : COLOR
{
    float4 out_color;
    float4 temp0, temp1, temp2, temp3;
    // def c0, 0.5, -0.5, 2.2, -1
    // def c1, -0.005, 0, 1.005, 0
    // dcl_texcoord v0.xy
    // dcl_color v1
    // dcl_texcoord1 v2.xyz
    // dcl_texcoord3 v3.xyz
    // dcl_texcoord4 v4.xyw
    // dcl_texcoord5 v5.xy
    // dcl_texcoord6 v6.z
    // dcl_2d s0
    // dcl_2d s1
    // dcl_2d s2
    // dcl_2d s3
    // rcp r0.x, v4.w
    temp0.x = 1.0f / i.texcoord4.w;
    // mul r0.xy, r0.x, v4
    temp0.xy = temp0.xx * i.texcoord4.xy;
    // mad r0.xy, r0, c0, c0.x
    temp0.xy = temp0.xy * float2(0.5, -0.5) + float2(0.5, 0.5);
    // texld r0, r0, s3
    temp0 = tex2D(DepthTextureSampler, temp0.xy);
    // mad_sat r0.x, r0.x, -v5.y, v5.x
    temp0.x = saturate(temp0.x * -i.texcoord5.y + i.texcoord5.x);
    // texld r1, v0, s1
    temp1 = tex2D(ParticleTextureSamplerSampler, i.texcoord.xy);
    // texld r2, v3, s2
    temp2 = tex2D(NextFrameTextureSamplerSampler, i.texcoord3.xy);
    // lrp r3, v3.z, r2, r1
    temp3 = lerp(temp1, temp2, i.texcoord3.z);
    // mul r1, r3, v1
    temp1 = temp3 * i.color;
    // mul oC0.w, r0.x, r1.w
    out_color.w = temp0.x * temp1.w;
    // log r0.x, r1.x
    temp0.x = log2(temp1.x);
    // log r0.y, r1.y
    temp0.y = log2(temp1.y);
    // log r0.z, r1.z
    temp0.z = log2(temp1.z);
    // mul r0.xyz, r0, c0.z
    temp0.xyz = temp0.xyz * float3(2.2, 2.2, 2.2);
    // exp r1.x, r0.x
    temp1.x = exp2(temp0.x);
    // exp r1.y, r0.y
    temp1.y = exp2(temp0.y);
    // exp r1.z, r0.z
    temp1.z = exp2(temp0.z);
    // mad r0, v6.z, c1.xxyy, c1.zzyy
    temp0 = i.texcoord6.z * float4(-0.005, -0.005, 0, 0) + float4(1.005, 1.005, 0, 0);
    // texldl r0, r0, s0
    temp0 = tex2Dlod(DepthLutSamplerSampler, temp0);
    // log r2.x, r0.x
    temp2.x = log2(temp0.x);
    // log r2.y, r0.y
    temp2.y = log2(temp0.y);
    // log r2.z, r0.z
    temp2.z = log2(temp0.z);
    // mul r0.xyz, r2, c0.z
    temp0.xyz = temp2.xyz * float3(2.2, 2.2, 2.2);
    // exp r2.x, r0.x
    temp2.x = exp2(temp0.x);
    // exp r2.y, r0.y
    temp2.y = exp2(temp0.y);
    // exp r2.z, r0.z
    temp2.z = exp2(temp0.z);
    // mad r0.xyz, r1, r2, c0.w
    temp0.xyz = temp1.xyz * temp2.xyz + float3(-1, -1, -1);
    // mov_sat r1.xyz, v2
    temp1.xyz = saturate(i.texcoord1.xyz);
    // mad oC0.xyz, r1, r0, -c0.w
    out_color.xyz = temp1.xyz * temp0.xyz + float3(1, 1, 1);
    // 

    return out_color;
}

// PS_Array_H_Shader_5 Pixel_3_0 Has PRES False
struct PS_Array_H_Shader_5_Input
{
    float2 texcoord : TEXCOORD;
    float4 color : COLOR;
    float3 texcoord1 : TEXCOORD1;
    float3 texcoord3 : TEXCOORD3;
    float4 texcoord4 : TEXCOORD4;
    float2 texcoord5 : TEXCOORD5;
    float3 texcoord6 : TEXCOORD6;
};

float4 PS_Array_H_Shader_5(PS_Array_H_Shader_5_Input i) : COLOR
{
    float4 out_color;
    float4 temp0, temp1, temp2, temp3;
    // def c0, 0.5, -0.5, 2.2, 0
    // def c1, -0.005, 0, 1.005, 0
    // dcl_texcoord v0.xy
    // dcl_color v1
    // dcl_texcoord1 v2.xyz
    // dcl_texcoord3 v3.xyz
    // dcl_texcoord4 v4.xyw
    // dcl_texcoord5 v5.xy
    // dcl_texcoord6 v6.z
    // dcl_2d s0
    // dcl_2d s1
    // dcl_2d s2
    // dcl_2d s3
    // rcp r0.x, v4.w
    temp0.x = 1.0f / i.texcoord4.w;
    // mul r0.xy, r0.x, v4
    temp0.xy = temp0.xx * i.texcoord4.xy;
    // mad r0.xy, r0, c0, c0.x
    temp0.xy = temp0.xy * float2(0.5, -0.5) + float2(0.5, 0.5);
    // texld r0, r0, s3
    temp0 = tex2D(DepthTextureSampler, temp0.xy);
    // mad_sat r0.x, r0.x, -v5.y, v5.x
    temp0.x = saturate(temp0.x * -i.texcoord5.y + i.texcoord5.x);
    // texld r1, v0, s1
    temp1 = tex2D(ParticleTextureSamplerSampler, i.texcoord.xy);
    // texld r2, v3, s2
    temp2 = tex2D(NextFrameTextureSamplerSampler, i.texcoord3.xy);
    // lrp r3, v3.z, r2, r1
    temp3 = lerp(temp1, temp2, i.texcoord3.z);
    // mul r1, r3, v1
    temp1 = temp3 * i.color;
    // mul oC0.w, r0.x, r1.w
    out_color.w = temp0.x * temp1.w;
    // log r0.x, r1.x
    temp0.x = log2(temp1.x);
    // log r0.y, r1.y
    temp0.y = log2(temp1.y);
    // log r0.z, r1.z
    temp0.z = log2(temp1.z);
    // mul r0.xyz, r0, c0.z
    temp0.xyz = temp0.xyz * float3(2.2, 2.2, 2.2);
    // exp r1.x, r0.x
    temp1.x = exp2(temp0.x);
    // exp r1.y, r0.y
    temp1.y = exp2(temp0.y);
    // exp r1.z, r0.z
    temp1.z = exp2(temp0.z);
    // mad r0, v6.z, c1.xxyy, c1.zzyy
    temp0 = i.texcoord6.z * float4(-0.005, -0.005, 0, 0) + float4(1.005, 1.005, 0, 0);
    // texldl r0, r0, s0
    temp0 = tex2Dlod(DepthLutSamplerSampler, temp0);
    // log r2.x, r0.x
    temp2.x = log2(temp0.x);
    // log r2.y, r0.y
    temp2.y = log2(temp0.y);
    // log r2.z, r0.z
    temp2.z = log2(temp0.z);
    // mul r0.xyz, r2, c0.z
    temp0.xyz = temp2.xyz * float3(2.2, 2.2, 2.2);
    // exp r2.x, r0.x
    temp2.x = exp2(temp0.x);
    // exp r2.y, r0.y
    temp2.y = exp2(temp0.y);
    // exp r2.z, r0.z
    temp2.z = exp2(temp0.z);
    // mul r0.xyz, r1, r2
    temp0.xyz = temp1.xyz * temp2.xyz;
    // mov_sat r1.xyz, v2
    temp1.xyz = saturate(i.texcoord1.xyz);
    // mul oC0.xyz, r0, r1
    out_color.xyz = temp0.xyz * temp1.xyz;
    // 

    return out_color;
}

// PS_Array_H_Shader_6 Pixel_3_0 Has PRES False
struct PS_Array_H_Shader_6_Input
{
    float2 texcoord : TEXCOORD;
    float4 color : COLOR;
    float3 texcoord3 : TEXCOORD3;
    float3 texcoord6 : TEXCOORD6;
};

float4 PS_Array_H_Shader_6(PS_Array_H_Shader_6_Input i) : COLOR
{
    float4 out_color;
    float4 temp0, temp2, temp3;
    float3 temp1;
    // def c0, 2.2, -0.005, 0, 1.005
    // dcl_texcoord v0.xy
    // dcl_color v1
    // dcl_texcoord3 v2.xyz
    // dcl_texcoord6 v3.z
    // dcl_2d s0
    // dcl_2d s1
    // dcl_2d s2
    // mad r0, v3.z, c0.yyzz, c0.wwzz
    temp0 = i.texcoord6.z * float4(-0.005, -0.005, 0, 0) + float4(1.005, 1.005, 0, 0);
    // texldl r0, r0, s0
    temp0 = tex2Dlod(DepthLutSamplerSampler, temp0);
    // log r1.x, r0.x
    temp1.x = log2(temp0.x);
    // log r1.y, r0.y
    temp1.y = log2(temp0.y);
    // log r1.z, r0.z
    temp1.z = log2(temp0.z);
    // mul r0.xyz, r1, c0.x
    temp0.xyz = temp1.xyz * float3(2.2, 2.2, 2.2);
    // exp r1.x, r0.x
    temp1.x = exp2(temp0.x);
    // exp r1.y, r0.y
    temp1.y = exp2(temp0.y);
    // exp r1.z, r0.z
    temp1.z = exp2(temp0.z);
    // texld r0, v0, s1
    temp0 = tex2D(ParticleTextureSamplerSampler, i.texcoord.xy);
    // texld r2, v2, s2
    temp2 = tex2D(NextFrameTextureSamplerSampler, i.texcoord3.xy);
    // lrp r3, v2.z, r2, r0
    temp3 = lerp(temp0, temp2, i.texcoord3.z);
    // mul r0, r3, v1
    temp0 = temp3 * i.color;
    // log r2.x, r0.x
    temp2.x = log2(temp0.x);
    // log r2.y, r0.y
    temp2.y = log2(temp0.y);
    // log r2.z, r0.z
    temp2.z = log2(temp0.z);
    // mov oC0.w, r0.w
    out_color.w = temp0.w;
    // mul r0.xyz, r2, c0.x
    temp0.xyz = temp2.xyz * float3(2.2, 2.2, 2.2);
    // exp r2.x, r0.x
    temp2.x = exp2(temp0.x);
    // exp r2.y, r0.y
    temp2.y = exp2(temp0.y);
    // exp r2.z, r0.z
    temp2.z = exp2(temp0.z);
    // mul oC0.xyz, r1, r2
    out_color.xyz = temp1.xyz * temp2.xyz;
    // 

    return out_color;
}

// PS_Array_H_Shader_7 Pixel_3_0 Has PRES False
struct PS_Array_H_Shader_7_Input
{
    float2 texcoord : TEXCOORD;
    float4 color : COLOR;
    float3 texcoord1 : TEXCOORD1;
    float3 texcoord3 : TEXCOORD3;
    float3 texcoord6 : TEXCOORD6;
};

float4 PS_Array_H_Shader_7(PS_Array_H_Shader_7_Input i) : COLOR
{
    float4 out_color;
    float4 temp0, temp2, temp3;
    float3 temp1;
    // def c0, -1, 1, 0, 0
    // def c1, 2.2, -0.005, 0, 1.005
    // dcl_texcoord v0.xy
    // dcl_color v1
    // dcl_texcoord1 v2.xyz
    // dcl_texcoord3 v3.xyz
    // dcl_texcoord6 v4.z
    // dcl_2d s0
    // dcl_2d s1
    // dcl_2d s2
    // mad r0, v4.z, c1.yyzz, c1.wwzz
    temp0 = i.texcoord6.z * float4(-0.005, -0.005, 0, 0) + float4(1.005, 1.005, 0, 0);
    // texldl r0, r0, s0
    temp0 = tex2Dlod(DepthLutSamplerSampler, temp0);
    // log r1.x, r0.x
    temp1.x = log2(temp0.x);
    // log r1.y, r0.y
    temp1.y = log2(temp0.y);
    // log r1.z, r0.z
    temp1.z = log2(temp0.z);
    // mul r0.xyz, r1, c1.x
    temp0.xyz = temp1.xyz * float3(2.2, 2.2, 2.2);
    // exp r1.x, r0.x
    temp1.x = exp2(temp0.x);
    // exp r1.y, r0.y
    temp1.y = exp2(temp0.y);
    // exp r1.z, r0.z
    temp1.z = exp2(temp0.z);
    // texld r0, v0, s1
    temp0 = tex2D(ParticleTextureSamplerSampler, i.texcoord.xy);
    // texld r2, v3, s2
    temp2 = tex2D(NextFrameTextureSamplerSampler, i.texcoord3.xy);
    // lrp r3, v3.z, r2, r0
    temp3 = lerp(temp0, temp2, i.texcoord3.z);
    // mul r0, r3, v1
    temp0 = temp3 * i.color;
    // log r2.x, r0.x
    temp2.x = log2(temp0.x);
    // log r2.y, r0.y
    temp2.y = log2(temp0.y);
    // log r2.z, r0.z
    temp2.z = log2(temp0.z);
    // mov oC0.w, r0.w
    out_color.w = temp0.w;
    // mul r0.xyz, r2, c1.x
    temp0.xyz = temp2.xyz * float3(2.2, 2.2, 2.2);
    // exp r2.x, r0.x
    temp2.x = exp2(temp0.x);
    // exp r2.y, r0.y
    temp2.y = exp2(temp0.y);
    // exp r2.z, r0.z
    temp2.z = exp2(temp0.z);
    // mad r0.xyz, r2, r1, c0.x
    temp0.xyz = temp2.xyz * temp1.xyz + float3(-1, -1, -1);
    // mov_sat r1.xyz, v2
    temp1.xyz = saturate(i.texcoord1.xyz);
    // mad oC0.xyz, r1, r0, c0.y
    out_color.xyz = temp1.xyz * temp0.xyz + float3(1, 1, 1);
    // 

    return out_color;
}

// PS_Array_H_Shader_8 Pixel_3_0 Has PRES False
struct PS_Array_H_Shader_8_Input
{
    float2 texcoord : TEXCOORD;
    float4 color : COLOR;
    float3 texcoord1 : TEXCOORD1;
    float3 texcoord3 : TEXCOORD3;
    float3 texcoord6 : TEXCOORD6;
};

float4 PS_Array_H_Shader_8(PS_Array_H_Shader_8_Input i) : COLOR
{
    float4 out_color;
    float4 temp0, temp2, temp3;
    float3 temp1;
    // def c0, 2.2, -0.005, 0, 1.005
    // dcl_texcoord v0.xy
    // dcl_color v1
    // dcl_texcoord1 v2.xyz
    // dcl_texcoord3 v3.xyz
    // dcl_texcoord6 v4.z
    // dcl_2d s0
    // dcl_2d s1
    // dcl_2d s2
    // mad r0, v4.z, c0.yyzz, c0.wwzz
    temp0 = i.texcoord6.z * float4(-0.005, -0.005, 0, 0) + float4(1.005, 1.005, 0, 0);
    // texldl r0, r0, s0
    temp0 = tex2Dlod(DepthLutSamplerSampler, temp0);
    // log r1.x, r0.x
    temp1.x = log2(temp0.x);
    // log r1.y, r0.y
    temp1.y = log2(temp0.y);
    // log r1.z, r0.z
    temp1.z = log2(temp0.z);
    // mul r0.xyz, r1, c0.x
    temp0.xyz = temp1.xyz * float3(2.2, 2.2, 2.2);
    // exp r1.x, r0.x
    temp1.x = exp2(temp0.x);
    // exp r1.y, r0.y
    temp1.y = exp2(temp0.y);
    // exp r1.z, r0.z
    temp1.z = exp2(temp0.z);
    // texld r0, v0, s1
    temp0 = tex2D(ParticleTextureSamplerSampler, i.texcoord.xy);
    // texld r2, v3, s2
    temp2 = tex2D(NextFrameTextureSamplerSampler, i.texcoord3.xy);
    // lrp r3, v3.z, r2, r0
    temp3 = lerp(temp0, temp2, i.texcoord3.z);
    // mul r0, r3, v1
    temp0 = temp3 * i.color;
    // log r2.x, r0.x
    temp2.x = log2(temp0.x);
    // log r2.y, r0.y
    temp2.y = log2(temp0.y);
    // log r2.z, r0.z
    temp2.z = log2(temp0.z);
    // mov oC0.w, r0.w
    out_color.w = temp0.w;
    // mul r0.xyz, r2, c0.x
    temp0.xyz = temp2.xyz * float3(2.2, 2.2, 2.2);
    // exp r2.x, r0.x
    temp2.x = exp2(temp0.x);
    // exp r2.y, r0.y
    temp2.y = exp2(temp0.y);
    // exp r2.z, r0.z
    temp2.z = exp2(temp0.z);
    // mul r0.xyz, r1, r2
    temp0.xyz = temp1.xyz * temp2.xyz;
    // mov_sat r1.xyz, v2
    temp1.xyz = saturate(i.texcoord1.xyz);
    // mul oC0.xyz, r0, r1
    out_color.xyz = temp0.xyz * temp1.xyz;
    // 

    return out_color;
}

PixelShader PS_Array_H[9] = {
    compile ps_3_0 PS_Array_H_Shader_0(), // 45
    compile ps_3_0 PS_Array_H_Shader_1(), // 46
    compile ps_3_0 PS_Array_H_Shader_2(), // 47
    compile ps_3_0 PS_Array_H_Shader_3(), // 48
    compile ps_3_0 PS_Array_H_Shader_4(), // 49
    compile ps_3_0 PS_Array_H_Shader_5(), // 50
    compile ps_3_0 PS_Array_H_Shader_6(), // 51
    compile ps_3_0 PS_Array_H_Shader_7(), // 52
    compile ps_3_0 PS_Array_H_Shader_8(), // 53
};
// PS_Array_M_Shader_0 Pixel_2_0 Has PRES False
struct PS_Array_M_Shader_0_Input
{
    float2 texcoord : TEXCOORD;
    float4 color : COLOR;
    float3 texcoord3 : TEXCOORD3;
    float3 texcoord4 : TEXCOORD4;
};

float4 PS_Array_M_Shader_0(PS_Array_M_Shader_0_Input i) : COLOR
{
    float4 out_color;
    float4 temp0, temp1, temp2, temp3;
    // def c0, 201, 0.005, 0, 0
    // dcl t0.xy
    // dcl v0
    // dcl t3.xyz
    // dcl t4.xyz
    // dcl_2d s0
    // dcl_2d s1
    // dcl_2d s2
    // add r0.w, -t4.z, c0.x
    temp0.w = -i.texcoord4.z + float1(201);
    // mul r0.xy, r0.w, c0.y
    temp0.xy = temp0.ww * float2(0.005, 0.005);
    // texld r0, r0, s0
    temp0 = tex2D(DepthLutSamplerSampler, temp0.xy);
    // texld r1, t0, s1
    temp1 = tex2D(ParticleTextureSamplerSampler, i.texcoord.xy);
    // texld r2, t3, s2
    temp2 = tex2D(NextFrameTextureSamplerSampler, i.texcoord3.xy);
    // lrp r3, t3.z, r2, r1
    temp3 = lerp(temp1, temp2, i.texcoord3.z);
    // mul r1, r3, v0
    temp1 = temp3 * i.color;
    // mul r1.xyz, r0, r1
    temp1.xyz = temp0.xyz * temp1.xyz;
    // mov oC0, r1
    out_color = temp1;
    // 

    return out_color;
}

// PS_Array_M_Shader_1 Pixel_2_0 Has PRES False
struct PS_Array_M_Shader_1_Input
{
    float2 texcoord : TEXCOORD;
    float4 color : COLOR;
    float3 texcoord1 : TEXCOORD1;
    float3 texcoord3 : TEXCOORD3;
    float3 texcoord4 : TEXCOORD4;
};

float4 PS_Array_M_Shader_1(PS_Array_M_Shader_1_Input i) : COLOR
{
    float4 out_color;
    float4 temp0, temp1, temp2, temp3;
    // def c0, 201, 0.005, -1, 1
    // dcl t0.xy
    // dcl v0
    // dcl t1.xyz
    // dcl t3.xyz
    // dcl t4.xyz
    // dcl_2d s0
    // dcl_2d s1
    // dcl_2d s2
    // add r0.w, -t4.z, c0.x
    temp0.w = -i.texcoord4.z + float1(201);
    // mul r0.xy, r0.w, c0.y
    temp0.xy = temp0.ww * float2(0.005, 0.005);
    // texld r0, r0, s0
    temp0 = tex2D(DepthLutSamplerSampler, temp0.xy);
    // texld r1, t0, s1
    temp1 = tex2D(ParticleTextureSamplerSampler, i.texcoord.xy);
    // texld r2, t3, s2
    temp2 = tex2D(NextFrameTextureSamplerSampler, i.texcoord3.xy);
    // lrp r3, t3.z, r2, r1
    temp3 = lerp(temp1, temp2, i.texcoord3.z);
    // mul r1, r3, v0
    temp1 = temp3 * i.color;
    // mad r0.xyz, r1, r0, c0.z
    temp0.xyz = temp1.xyz * temp0.xyz + float3(-1, -1, -1);
    // mov_sat r2.xyz, t1
    temp2.xyz = saturate(i.texcoord1.xyz);
    // mad r1.xyz, r2, r0, c0.w
    temp1.xyz = temp2.xyz * temp0.xyz + float3(1, 1, 1);
    // mov oC0, r1
    out_color = temp1;
    // 

    return out_color;
}

// PS_Array_M_Shader_2 Pixel_2_0 Has PRES False
struct PS_Array_M_Shader_2_Input
{
    float2 texcoord : TEXCOORD;
    float4 color : COLOR;
    float3 texcoord1 : TEXCOORD1;
    float3 texcoord3 : TEXCOORD3;
    float3 texcoord4 : TEXCOORD4;
};

float4 PS_Array_M_Shader_2(PS_Array_M_Shader_2_Input i) : COLOR
{
    float4 out_color;
    float4 temp0, temp1, temp2, temp3;
    // def c0, 201, 0.005, 0, 0
    // dcl t0.xy
    // dcl v0
    // dcl t1.xyz
    // dcl t3.xyz
    // dcl t4.xyz
    // dcl_2d s0
    // dcl_2d s1
    // dcl_2d s2
    // add r0.w, -t4.z, c0.x
    temp0.w = -i.texcoord4.z + float1(201);
    // mul r0.xy, r0.w, c0.y
    temp0.xy = temp0.ww * float2(0.005, 0.005);
    // texld r0, r0, s0
    temp0 = tex2D(DepthLutSamplerSampler, temp0.xy);
    // texld r1, t0, s1
    temp1 = tex2D(ParticleTextureSamplerSampler, i.texcoord.xy);
    // texld r2, t3, s2
    temp2 = tex2D(NextFrameTextureSamplerSampler, i.texcoord3.xy);
    // lrp r3, t3.z, r2, r1
    temp3 = lerp(temp1, temp2, i.texcoord3.z);
    // mul r1, r3, v0
    temp1 = temp3 * i.color;
    // mul r0.xyz, r0, r1
    temp0.xyz = temp0.xyz * temp1.xyz;
    // mov_sat r2.xyz, t1
    temp2.xyz = saturate(i.texcoord1.xyz);
    // mul r1.xyz, r0, r2
    temp1.xyz = temp0.xyz * temp2.xyz;
    // mov oC0, r1
    out_color = temp1;
    // 

    return out_color;
}

PixelShader PS_Array_M[3] = {
    compile ps_2_0 PS_Array_M_Shader_0(), // 57
    compile ps_2_0 PS_Array_M_Shader_1(), // 58
    compile ps_2_0 PS_Array_M_Shader_2(), // 59
};
// PSCreateShadowMap_Array_Shader_0 Pixel_2_0 Has PRES False
float4 PSCreateShadowMap_Array_Shader_0(float texcoord2 : TEXCOORD2) : COLOR
{
    float4 out_color;
    float4 temp0;
    // dcl t2.x
    // mov r0, t2.x
    temp0 = texcoord2.x;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// PSCreateShadowMap_Array_Shader_1 Pixel_2_0 Has PRES False
struct PSCreateShadowMap_Array_Shader_1_Input
{
    float2 texcoord : TEXCOORD;
    float3 color : COLOR;
    float texcoord2 : TEXCOORD2;
};

float4 PSCreateShadowMap_Array_Shader_1(PSCreateShadowMap_Array_Shader_1_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    // def c0, 1, -0.3, 0, 0
    // dcl t0.xy
    // dcl v0.xyz
    // dcl t2.x
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(ParticleTextureSamplerSampler, i.texcoord.xy);
    // mul r0.xyz, r0, v0
    temp0.xyz = temp0.xyz * i.color.xyz;
    // dp3 r0.x, r0, c0.x
    temp0.x = dot(temp0.xyz, float3(1, 1, 1));
    // add r0, r0.x, c0.y
    temp0 = temp0.x + float4(-0.3, -0.3, -0.3, -0.3);
    // texkill r0
    clip(temp0);
    // mov r0, t2.x
    temp0 = i.texcoord2.x;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// PSCreateShadowMap_Array_Shader_2 Pixel_2_0 Has PRES False
struct PSCreateShadowMap_Array_Shader_2_Input
{
    float2 texcoord : TEXCOORD;
    float4 color : COLOR;
    float texcoord2 : TEXCOORD2;
};

float4 PSCreateShadowMap_Array_Shader_2(PSCreateShadowMap_Array_Shader_2_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    // def c0, -0.1, 0, 0, 0
    // dcl t0.xy
    // dcl v0
    // dcl t2.x
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(ParticleTextureSamplerSampler, i.texcoord.xy);
    // mad r0, r0.w, v0.w, c0.x
    temp0 = temp0.w * i.color.w + float4(-0.1, -0.1, -0.1, -0.1);
    // texkill r0
    clip(temp0);
    // mov r0, t2.x
    temp0 = i.texcoord2.x;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// PSCreateShadowMap_Array_Shader_3 Pixel_2_0 Has PRES False
struct PSCreateShadowMap_Array_Shader_3_Input
{
    float2 texcoord : TEXCOORD;
    float4 color : COLOR;
    float texcoord2 : TEXCOORD2;
};

float4 PSCreateShadowMap_Array_Shader_3(PSCreateShadowMap_Array_Shader_3_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    // def c0, -0.1, 0, 0, 0
    // dcl t0.xy
    // dcl v0
    // dcl t2.x
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(ParticleTextureSamplerSampler, i.texcoord.xy);
    // mad r0, r0.w, v0.w, c0.x
    temp0 = temp0.w * i.color.w + float4(-0.1, -0.1, -0.1, -0.1);
    // texkill r0
    clip(temp0);
    // mov r0, t2.x
    temp0 = i.texcoord2.x;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// PSCreateShadowMap_Array_Shader_4 Pixel_2_0 Has PRES False
struct PSCreateShadowMap_Array_Shader_4_Input
{
    float2 texcoord : TEXCOORD;
    float4 color : COLOR;
    float texcoord2 : TEXCOORD2;
};

float4 PSCreateShadowMap_Array_Shader_4(PSCreateShadowMap_Array_Shader_4_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    // def c0, -0.1, 0, 0, 0
    // dcl t0.xy
    // dcl v0
    // dcl t2.x
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(ParticleTextureSamplerSampler, i.texcoord.xy);
    // mad r0, r0.w, v0.w, c0.x
    temp0 = temp0.w * i.color.w + float4(-0.1, -0.1, -0.1, -0.1);
    // texkill r0
    clip(temp0);
    // mov r0, t2.x
    temp0 = i.texcoord2.x;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// PSCreateShadowMap_Array_Shader_5 Pixel_2_0 Has PRES False
struct PSCreateShadowMap_Array_Shader_5_Input
{
    float2 texcoord : TEXCOORD;
    float3 color : COLOR;
    float texcoord2 : TEXCOORD2;
};

float4 PSCreateShadowMap_Array_Shader_5(PSCreateShadowMap_Array_Shader_5_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    // def c0, 1, 0.3, 0, 0
    // dcl t0.xy
    // dcl v0.xyz
    // dcl t2.x
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(ParticleTextureSamplerSampler, i.texcoord.xy);
    // mul r0.xyz, r0, v0
    temp0.xyz = temp0.xyz * i.color.xyz;
    // dp3 r0.x, r0, c0.x
    temp0.x = dot(temp0.xyz, float3(1, 1, 1));
    // add r0, -r0.x, c0.y
    temp0 = -temp0.x + float4(0.3, 0.3, 0.3, 0.3);
    // texkill r0
    clip(temp0);
    // mov r0, t2.x
    temp0 = i.texcoord2.x;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

PixelShader PSCreateShadowMap_Array[6] = {
    compile ps_2_0 PSCreateShadowMap_Array_Shader_0(), // 66
    compile ps_2_0 PSCreateShadowMap_Array_Shader_1(), // 67
    compile ps_2_0 PSCreateShadowMap_Array_Shader_2(), // 68
    compile ps_2_0 PSCreateShadowMap_Array_Shader_3(), // 69
    compile ps_2_0 PSCreateShadowMap_Array_Shader_4(), // 70
    compile ps_2_0 PSCreateShadowMap_Array_Shader_5(), // 71
};
// _CreateShadowMap_Expression19 Expression_2_0 Has PRES False
float _CreateShadowMap_Expression19()
{
    float1 expr0;
    // min c0.x, c8.x, (5)
    expr0.x = min(Draw.ShaderType.x, (5));
    return expr0;
}

// _CreateShadowMap_VertexShader20 Vertex_2_0 Has PRES True
struct _CreateShadowMap_VertexShader20_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 texcoord1 : TEXCOORD1;
};

struct _CreateShadowMap_VertexShader20_Output
{
    float4 position : POSITION;
    float3 texcoord4 : TEXCOORD4;
    float texcoord2 : TEXCOORD2;
    float3 texcoord3 : TEXCOORD3;
    float2 texcoord : TEXCOORD;
    float4 color : COLOR;
    float3 texcoord1 : TEXCOORD1;
};

_CreateShadowMap_VertexShader20_Output _CreateShadowMap_VertexShader20(_CreateShadowMap_VertexShader20_Input i)
{
    /*
    PRSI
      OutputRegisterOffset: 39
      Unknown1: 0
      Unknown2: 0
      OutputRegisterCount: 15
      Unknown3: 0
      Unknown4: 0
      Unknown5: 39
      Unknown6: 2
      Mappings: 4
        0 - ConstOutput: 45 ConstInput 2
        1 - ConstOutput: 48 ConstInput 1
        2 - ConstOutput: 50 ConstInput 4
        3 - ConstOutput: 0 ConstInput 0
    
    */
    float4 expr39;
    float4 expr40;
    float4 expr41;
    float4 expr42;
    float4 expr43;
    float4 expr44;
    float4 expr45;
    float4 expr46;
    float4 expr47;
    float4 expr48;
    float4 expr49;
    float4 expr50;
    float4 expr51;
    float4 expr52;
    float4 expr53;
    {
        float4 temp0;
        float4 temp1;
        float4 temp2;
        // Expression_2_1
        // mul c39.x, c1.x, (30)
        expr39.x = Time.x * (30);
        // add c40.x, c0.x, (-1)
        expr40.x = Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.x + (-1);
        // lt r0.x, (0), c0.z
        temp0.x = (0) < Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.z;
        // mul r0.y, c0.w, c0.w
        temp0.y = Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.w * Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.w;
        // neg r1.x, r0.y
        temp1.x = -temp0.y;
        // ge r2.x, r1.x, r0.y
        temp2.x = temp1.x >= temp0.y;
        // lt c52.x, r1.x, r0.y
        expr52.x = temp1.x < temp0.y;
        // mul c53.x, r0.x, r2.x
        expr53.x = temp0.x * temp2.x;
        // rcp c46.x, c0.x
        expr46.x = 1.0f / (Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.x);
        // add r0.x, c0.z, (1)
        temp0.x = Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.z + (1);
        // mul r1.x, r0.x, r0.x
        temp1.x = temp0.x * temp0.x;
        // neg r0.x, r1.x
        temp0.x = -temp1.x;
        // ge c51.x, r0.x, r1.x
        expr51.x = temp0.x >= temp1.x;
        // rcp c50.x, c0.y
        expr50.x = 1.0f / (Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.y);
        // add r0.x, c0.z, (-1)
        temp0.x = Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.z + (-1);
        // neg r1.x, r0.x
        temp1.x = -temp0.x;
        // lt r2.x, r0.x, r1.x
        temp2.x = temp0.x < temp1.x;
        // frc r0.y, c0.z
        temp0.y = frac(Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.z);
        // neg r1.x, r0.y
        temp1.x = -temp0.y;
        // lt r2.y, r1.x, r0.y
        temp2.y = temp1.x < temp0.y;
        // add r2.z, r0.x, r1.x
        temp2.z = temp0.x + temp1.x;
        // mul r0.x, r2.x, r2.y
        temp0.x = temp2.x * temp2.y;
        // add r1.x, r2.z, r0.x
        temp1.x = temp2.z + temp0.x;
        // mov c45.x, r1.x
        expr45.x = temp1.x;
        // mov c48.x, r1.x
        expr48.x = temp1.x;
    }

    _CreateShadowMap_VertexShader20_Output o;
    float4 temp0, temp1, addr0, temp2, temp3, temp4;
    float3 temp5, temp6, temp7;
    // def c36, 2.0625, 8.9375, 6.1875, 1.375
    // def c28, 0.5, -0.5, 16, -1
    // def c30, -0.5, 0.5, 0.1591549, 0
    // def c31, 0, 0, 6.283185, -3.141593
    // def c38, 0.1875, 4.8125, 2.75, 0
    // def c37, 1, -1, 0.5, 0
    // def c29, 0.5, 0.5, 1.0001, 0.6931472
    // def c27, -0.5, -0.5, 0, 0.1875
    // def c11, 0.957897, 0.3788705, 0.3635719, 0.3287609
    // def c12, 0.1762373, 0.9145751, 0.4360935, 0.3476284
    // def c13, 0.743219, 0.4425611, 0.9974546, 0.3622138
    // def c14, 0.4896626, 0.6664233, 0.8305699, 0.9742577
    // def c15, 0.8947675, 0.8236215, 0.9309705, 0.05219847
    // def c16, 0.1411007, 0.6527002, 0.008452523, 0.6430574
    // def c17, 0.229799, 0.897999, 0.753822, 0.1316504
    // def c18, 0.5815384, 0.2836916, 0.09156471, 0.407481
    // def c19, 0.2706044, 0.7228181, 0.1694367, 0.1469052
    // def c20, 0.5995556, 0.0964533, 0.8763983, 0.1172229
    // def c21, 0.5101711, 0.9421572, 0.1957888, 0.9167565
    // def c22, 0.03546793, 0.5340094, 0.1673218, 0.5576764
    // def c23, 0.861564, 0.2251601, 0.082332, 0.8790039
    // def c24, 0.1730866, 0.8935188, 0.01392406, 0.1787381
    // def c25, 0.8269383, 0.7718143, 0.4395359, 0.493963
    // def c26, 0.5423613, 0.7218617, 0.7697314, 0.5878567
    // def c32, -0.25, -0.25, 0, 0
    // def c33, 0.25, -0.25, 0, 0
    // def c34, 0.25, 0.25, 0, 0
    // def c35, -0.25, 0.25, 0, 0
    // def c0, -1.550099E-06, -2.170139E-05, 0.002604167, 0.0002604167
    // def c1, -0.02083333, -0.125, 1, 0.5
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_texcoord1 v2
    // mov r0.w, c27.w
    temp0.w = float1(0.1875);
    // mad r0, v2.x, r0.w, c36
    temp0 = i.texcoord1.x * temp0.w + float4(2.0625, 8.9375, 6.1875, 1.375);
    // frc r0, r0
    temp0 = frac(temp0);
    // mul r0, r0, c28.z
    temp0 = temp0 * float4(16, 16, 16, 16);
    // frc r1, r0
    temp1 = frac(temp0);
    // add r0, r0, -r1
    temp0 = temp0 + -temp1;
    // mova a0, r0
    addr0 = temp0;
    // mov r0.xy, c77
    temp0.xy = Physics.VelocityDampingRange.xy;
    // mad r0.x, c11[a0.y].x, r0.y, r0.x
    temp0.x = float1(0.957897) * temp0.y + temp0.x;
    // add r0.y, r0.x, c28.w
    temp0.y = temp0.x + float1(-1);
    // mul r0.y, r0.y, r0.y
    temp0.y = temp0.y * temp0.y;
    // sge r0.y, -r0.y, r0.y
    temp0.y = (-temp0.y >= temp0.y) ? 1 : 0;
    // lrp r1.x, r0.y, c29.z, r0.x
    temp1.x = lerp(temp0.x, float1(1.0001), temp0.y);
    // log r0.x, r1.x
    temp0.x = log2(temp1.x);
    // mul r0.y, r0.x, c29.w
    temp0.y = temp0.x * float1(0.6931472);
    // rcp r0.y, r0.y
    temp0.y = 1.0f / temp0.y;
    // add r0.z, -v1.w, c39.x
    temp0.z = -i.texcoord.w + expr39.x;
    // mul r0.x, r0.x, r0.z
    temp0.x = temp0.x * temp0.z;
    // exp r0.x, r0.x
    temp0.x = exp2(temp0.x);
    // add r0.x, r0.x, c28.w
    temp0.x = temp0.x + float1(-1);
    // mul r0.x, r0.y, r0.x
    temp0.x = temp0.y * temp0.x;
    // mov r1.xyz, v0
    temp1.xyz = i.position.xyz;
    // mad r0.xyw, v1.xyzz, r0.x, r1.xyzz
    temp0.xyw = i.texcoord.xyz * temp0.xxx + temp1.xyz;
    // mul r1.x, r0.z, -c27.x
    temp1.x = temp0.z * float1(0.5);
    // mov r2.xyz, c75
    temp2.xyz = Physics.Gravity.xyz;
    // mad r1.xyz, r1.x, r2, c76
    temp1.xyz = temp1.xxx * temp2.xyz + Physics.DriftVelocity.xyz;
    // mad r0.xyw, r1.xyzz, r0.z, r0
    temp0.xyw = temp1.xyz * temp0.zzz + temp0.xyw;
    // add r1.xyz, r0.xyyw, -v0.xyyw
    temp1.xyz = temp0.xyy + -i.position.xyy;
    // mov r2.xyz, c11[a0.z]
    temp2.xyz = float3(0.957897, 0.37887052, 0.36357188);
    // mov r3.xyz, c68
    temp3.xyz = Update.XYRotation_Rate_Damping__Spread.xyz;
    // mad r2.xyz, r2, r3, c67
    temp2.xyz = temp2.xyz * temp3.xyz + Update.XYRotation_Rate_Damping__Min.xyz;
    // add r1.w, r2.z, c28.w
    temp1.w = temp2.z + float1(-1);
    // mul r1.w, r1.w, r1.w
    temp1.w = temp1.w * temp1.w;
    // sge r1.w, -r1.w, r1.w
    temp1.w = (-temp1.w >= temp1.w) ? 1 : 0;
    // lrp r3.x, r1.w, c29.z, r2.z
    temp3.x = lerp(temp2.z, float1(1.0001), temp1.w);
    // log r1.w, r3.x
    temp1.w = log2(temp3.x);
    // mul r2.z, r1.w, c29.w
    temp2.z = temp1.w * float1(0.6931472);
    // mul r1.w, r0.z, r1.w
    temp1.w = temp0.z * temp1.w;
    // rcp r2.z, r2.z
    temp2.z = 1.0f / temp2.z;
    // exp r1.w, r1.w
    temp1.w = exp2(temp1.w);
    // add r1.w, r1.w, c28.w
    temp1.w = temp1.w + float1(-1);
    // mul r1.w, r2.z, r1.w
    temp1.w = temp2.z * temp1.w;
    // mad r1.w, r2.y, r1.w, r2.x
    temp1.w = temp2.y * temp1.w + temp2.x;
    // mad r1.w, r1.w, c30.z, c30.y
    temp1.w = temp1.w * float1(0.15915494) + float1(0.5);
    // frc r1.w, r1.w
    temp1.w = frac(temp1.w);
    // mad r1.w, r1.w, c31.z, c31.w
    temp1.w = temp1.w * float1(6.2831855) + float1(-3.1415927);
    // sincos r2.xy, r1.w, c0, c1
    temp2.xy = float2(cos(temp1.w), sin(temp1.w));
    // mul r1.yzw, r1.xxyz, r2.xxyx
    temp1.yzw = temp1.xyz * temp2.xyx;
    // mad r1.w, r1.x, -r2.y, r1.w
    temp1.w = temp1.x * -temp2.y + temp1.w;
    // add r1.x, r1.z, r1.y
    temp1.x = temp1.z + temp1.y;
    // add r0.xy, r1.xwzw, v0
    temp0.xy = temp1.xw + i.position.xy;
    // mov r1.xyz, c11[a0.w]
    temp1.xyz = float3(0.957897, 0.37887052, 0.36357188);
    // mov r2.xyz, c70
    temp2.xyz = Update.ZRotation_Rate_Damping__Spread.xyz;
    // mad r1.yzw, r1.xxyz, r2.xxyz, c69.xxyz
    temp1.yzw = temp1.xyz * temp2.xyz + Update.ZRotation_Rate_Damping__Min.xyz;
    // add r2.x, r1.w, c28.w
    temp2.x = temp1.w + float1(-1);
    // mul r2.x, r2.x, r2.x
    temp2.x = temp2.x * temp2.x;
    // sge r2.x, -r2.x, r2.x
    temp2.x = (-temp2.x >= temp2.x) ? 1 : 0;
    // lrp r3.x, r2.x, c29.z, r1.w
    temp3.x = lerp(temp1.w, float1(1.0001), temp2.x);
    // log r1.w, r3.x
    temp1.w = log2(temp3.x);
    // mul r2.x, r1.w, c29.w
    temp2.x = temp1.w * float1(0.6931472);
    // mul r1.w, r0.z, r1.w
    temp1.w = temp0.z * temp1.w;
    // rcp r2.x, r2.x
    temp2.x = 1.0f / temp2.x;
    // exp r1.w, r1.w
    temp1.w = exp2(temp1.w);
    // add r1.w, r1.w, c28.w
    temp1.w = temp1.w + float1(-1);
    // mul r1.w, r2.x, r1.w
    temp1.w = temp2.x * temp1.w;
    // mad r1.y, r1.z, r1.w, r1.y
    temp1.y = temp1.z * temp1.w + temp1.y;
    // mad r1.y, r1.y, c30.z, c30.y
    temp1.y = temp1.y * float1(0.15915494) + float1(0.5);
    // frc r1.y, r1.y
    temp1.y = frac(temp1.y);
    // mad r1.y, r1.y, c31.z, c31.w
    temp1.y = temp1.y * float1(6.2831855) + float1(-3.1415927);
    // sincos r2.xy, r1.y, c0, c1
    temp2.xy = float2(cos(temp1.y), sin(temp1.y));
    // slt r1.y, v0.w, r0.z
    temp1.y = (i.position.w < temp0.z) ? 1 : 0;
    // mad r1.y, r1.y, -v2.y, v2.y
    temp1.y = temp1.y * -i.texcoord1.y + i.texcoord1.y;
    // frc r1.z, r1.y
    temp1.z = frac(temp1.y);
    // add r1.y, r1.y, -r1.z
    temp1.y = temp1.y + -temp1.z;
    // mova a0.y, r1.y
    addr0.y = temp1.y;
    // mul r1.yzw, r2.xxyx, c27[a0.y].xxyy
    temp1.yzw = temp2.xyx * float3(-0.5, -0.5, -0.5);
    // mad r1.w, c27[a0.y].x, -r2.y, r1.w
    temp1.w = float1(-0.5) * -temp2.y + temp1.w;
    // mov r2.xy, c27[a0.y]
    temp2.xy = float2(-0.5, -0.5);
    // mad r2.xy, r2, c37, c37.z
    temp2.xy = temp2.xy * float2(1, -1) + float2(0.5, 0.5);
    // add r1.y, r1.z, r1.y
    temp1.y = temp1.z + temp1.y;
    // mul r3.xyz, r1.w, c79
    temp3.xyz = temp1.www * (View._m01_m11_m21_m31).xyz;
    // mad r1.yzw, r1.y, c78.xxyz, r3.xxyz
    temp1.yzw = temp1.yyy * (View._m00_m10_m20_m30).xyz + temp3.xyz;
    // mov r3.xyz, c11[a0.x]
    temp3.xyz = float3(0.957897, 0.37887052, 0.36357188);
    // mov r4.xyz, c66
    temp4.xyz = Update.Size_Rate_Damping__Spread.xyz;
    // mad r3.xyz, r3, r4, c65
    temp3.xyz = temp3.xyz * temp4.xyz + Update.Size_Rate_Damping__Min.xyz;
    // mul r1.x, r1.x, c54.x
    temp1.x = temp1.x * Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.x;
    // add r2.z, r3.z, c28.w
    temp2.z = temp3.z + float1(-1);
    // mul r2.z, r2.z, r2.z
    temp2.z = temp2.z * temp2.z;
    // sge r2.z, -r2.z, r2.z
    temp2.z = (-temp2.z >= temp2.z) ? 1 : 0;
    // lrp r4.x, r2.z, c29.z, r3.z
    temp4.x = lerp(temp3.z, float1(1.0001), temp2.z);
    // log r2.z, r4.x
    temp2.z = log2(temp4.x);
    // mul r2.w, r2.z, c29.w
    temp2.w = temp2.z * float1(0.6931472);
    // mul r2.z, r0.z, r2.z
    temp2.z = temp0.z * temp2.z;
    // rcp r2.w, r2.w
    temp2.w = 1.0f / temp2.w;
    // exp r2.z, r2.z
    temp2.z = exp2(temp2.z);
    // add r2.z, r2.z, c28.w
    temp2.z = temp2.z + float1(-1);
    // mul r2.z, r2.w, r2.z
    temp2.z = temp2.w * temp2.z;
    // mad r2.z, r3.y, r2.z, r3.x
    temp2.z = temp3.y * temp2.z + temp3.x;
    // mad r3.xyz, r2.z, r1.yzww, r0.xyww
    temp3.xyz = temp2.zzz * temp1.yzw + temp0.xyw;
    // mov r3.w, -c28.w
    temp3.w = float1(1);
    // dp4 oPos.x, r3, c71
    o.position.x = dot(temp3, (WorldViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r3, c72
    o.position.y = dot(temp3, (WorldViewProjection._m01_m11_m21_m31));
    // dp4 r0.y, r3, c74
    temp0.y = dot(temp3, (WorldViewProjection._m03_m13_m23_m33));
    // dp4 r0.x, r3, c73
    temp0.x = dot(temp3, (WorldViewProjection._m02_m12_m22_m32));
    // mov oT4.xyz, r3
    o.texcoord4 = temp3;
    // rcp r0.w, r0.y
    temp0.w = 1.0f / temp0.y;
    // mov oPos.zw, r0.xyxy
    o.position.zw = temp0.xy;
    // mul oT2.x, r0.x, r0.w
    o.texcoord2 = temp0.x * temp0.w;
    // mov r0.w, c28.w
    temp0.w = float1(-1);
    // mad r0.x, r0.z, c63.x, -r0.w
    temp0.x = temp0.z * Draw.SpeedMultiplier.x + -temp0.w;
    // mul r0.y, r0.x, c50.x
    temp0.y = temp0.x * expr50.x;
    // min r3.x, r0.x, c40.x
    temp3.x = min(temp0.x, expr40.x);
    // abs r0.x, r0.y
    temp0.x = abs(temp0.y);
    // sge r0.y, r0.y, -r0.y
    temp0.y = (temp0.y >= -temp0.y) ? 1 : 0;
    // frc r0.x, r0.x
    temp0.x = frac(temp0.x);
    // lrp r1.y, r0.y, r0.x, -r0.x
    temp1.y = lerp(-temp0.x, temp0.x, temp0.y);
    // mul r0.x, r1.y, c54.y
    temp0.x = temp1.y * Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.y;
    // mul r0.y, r0.x, c46.x
    temp0.y = temp0.x * expr46.x;
    // abs r0.w, r0.y
    temp0.w = abs(temp0.y);
    // frc r0.w, r0.w
    temp0.w = frac(temp0.w);
    // sge r1.y, r0.y, -r0.y
    temp1.y = (temp0.y >= -temp0.y) ? 1 : 0;
    // lrp r2.z, r1.y, r0.w, -r0.w
    temp2.z = lerp(-temp0.w, temp0.w, temp1.y);
    // mul r0.x, r2.z, c54.x
    temp0.x = temp2.z * Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.x;
    // frc r1.yz, r0.xxyw
    temp1.yz = frac(temp0.xy);
    // add r0.xy, r0, -r1.yzzw
    temp0.xy = temp0.xy + -temp1.yz;
    // add r0.xy, r2, r0
    temp0.xy = temp2.xy + temp0.xy;
    // mul r0.xy, r0, c46.x
    temp0.xy = temp0.xy * expr46.xx;
    // frc r1.y, r1.x
    temp1.y = frac(temp1.x);
    // add r1.z, r1.x, -r1.y
    temp1.z = temp1.x + -temp1.y;
    // slt r1.y, -r1.y, r1.y
    temp1.y = (-temp1.y < temp1.y) ? 1 : 0;
    // slt r1.x, r1.x, -r1.x
    temp1.x = (temp1.x < -temp1.x) ? 1 : 0;
    // mad r3.w, r1.x, r1.y, r1.z
    temp3.w = temp1.x * temp1.y + temp1.z;
    // mov r1.w, c27.z
    temp1.w = float1(0);
    // mul r2.z, r0.z, c63.x
    temp2.z = temp0.z * Draw.SpeedMultiplier.x;
    // min r3.y, r2.z, c40.x
    temp3.y = min(temp2.z, expr40.x);
    // frc r1.xyz, r3.yxxw
    temp1.xyz = frac(temp3.yxx);
    // add r1.zw, r3.xyxw, -r1
    temp1.zw = temp3.xw + -temp1.zw;
    // add r4.xz, r3.yyxw, -r1.xyyw
    temp4.xz = temp3.yx + -temp1.xy;
    // add r1.xy, r2, r1.zwzw
    temp1.xy = temp2.xy + temp1.zw;
    // mul r1.xy, r1, c46.x
    temp1.xy = temp1.xy * expr46.xx;
    // frc r0.w, r2.z
    temp0.w = frac(temp2.z);
    // mul r2.z, r2.z, c50.x
    temp2.z = temp2.z * expr50.x;
    // frc r1.z, r3.y
    temp1.z = frac(temp3.y);
    // lrp r5.xyz, c51.x, r1, r0.xyww
    temp5.xyz = lerp(temp0.xyw, temp1.xyz, expr51.xxx);
    // mad r0.xy, v2.x, c38.x, c38.yzzw
    temp0.xy = i.texcoord1.xx * float2(0.1875, 0.1875) + float2(4.8125, 2.75);
    // frc r0.xy, r0
    temp0.xy = frac(temp0.xy);
    // mul r0.xy, r0, c28.z
    temp0.xy = temp0.xy * float2(16, 16);
    // frc r1.xy, r0
    temp1.xy = frac(temp0.xy);
    // add r0.xy, r0, -r1
    temp0.xy = temp0.xy + -temp1.xy;
    // mova a0.xy, r0
    addr0.xy = temp0.xy;
    // mov r0.x, c54.x
    temp0.x = Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.x;
    // mul r0.x, r0.x, c11[a0.x].x
    temp0.x = temp0.x * float1(0.957897);
    // mov r1.xy, c64
    temp1.xy = Draw.ColorScaleRange.xy;
    // mad r0.y, c11[a0.y].x, r1.y, r1.x
    temp0.y = float1(0.957897) * temp1.y + temp1.x;
    // frc r0.w, r0.x
    temp0.w = frac(temp0.x);
    // add r1.x, r0.x, -r0.w
    temp1.x = temp0.x + -temp0.w;
    // slt r0.x, r0.x, -r0.x
    temp0.x = (temp0.x < -temp0.x) ? 1 : 0;
    // slt r0.w, -r0.w, r0.w
    temp0.w = (-temp0.w < temp0.w) ? 1 : 0;
    // mad r3.z, r0.x, r0.w, r1.x
    temp3.z = temp0.x * temp0.w + temp1.x;
    // add r0.xw, r2.xyzy, r3.zyzw
    temp0.xw = temp2.xy + temp3.zw;
    // mul r6.xy, r0.xwzw, c46.x
    temp6.xy = temp0.xw * expr46.xx;
    // mov r6.z, c27.z
    temp6.z = float1(0);
    // lrp r7.xyz, c52.x, r6, r5
    temp7.xyz = lerp(temp5.xyz, temp6.xyz, expr52.xxx);
    // mov r4.w, c48.x
    temp4.w = expr48.x;
    // add r1.xy, r2, r4.zwzw
    temp1.xy = temp2.xy + temp4.zw;
    // mul r5.xy, r1, c46.x
    temp5.xy = temp1.xy * expr46.xx;
    // mov r5.z, r1.z
    temp5.z = temp1.z;
    // add r5.xyz, -r7, r5
    temp5.xyz = -temp7.xyz + temp5.xyz;
    // mad oT3.xyz, c53.x, r5, r7
    o.texcoord3 = expr53.x * temp5 + temp7;
    // mov r1.w, c27.z
    temp1.w = float1(0);
    // add r1.xy, r3.ywzw, -r1.zwzw
    temp1.xy = temp3.yw + -temp1.zw;
    // add r1.xy, r2, r1
    temp1.xy = temp2.xy + temp1.xy;
    // abs r1.z, r2.z
    temp1.z = abs(temp2.z);
    // sge r1.w, r2.z, -r2.z
    temp1.w = (temp2.z >= -temp2.z) ? 1 : 0;
    // frc r1.z, r1.z
    temp1.z = frac(temp1.z);
    // lrp r2.z, r1.w, r1.z, -r1.z
    temp2.z = lerp(-temp1.z, temp1.z, temp1.w);
    // mul r1.z, r2.z, c54.y
    temp1.z = temp2.z * Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.y;
    // mul r1.w, r1.z, c46.x
    temp1.w = temp1.z * expr46.x;
    // abs r2.z, r1.w
    temp2.z = abs(temp1.w);
    // frc r2.z, r2.z
    temp2.z = frac(temp2.z);
    // sge r2.w, r1.w, -r1.w
    temp2.w = (temp1.w >= -temp1.w) ? 1 : 0;
    // lrp r3.x, r2.w, r2.z, -r2.z
    temp3.x = lerp(-temp2.z, temp2.z, temp2.w);
    // mul r1.z, r3.x, c54.x
    temp1.z = temp3.x * Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.x;
    // frc r2.zw, r1
    temp2.zw = frac(temp1.zw);
    // add r1.zw, r1, -r2
    temp1.zw = temp1.zw + -temp2.zw;
    // add r1.zw, r2.xyxy, r1
    temp1.zw = temp2.xy + temp1.zw;
    // mul r1.zw, r1, c46.x
    temp1.zw = temp1.zw * expr46.xx;
    // mad r1.xy, r1, c46.x, -r1.zwzw
    temp1.xy = temp1.xy * expr46.xx + -temp1.zw;
    // mad r1.xy, c51.x, r1, r1.zwzw
    temp1.xy = expr51.xx * temp1.xy + temp1.zw;
    // mad r0.xw, r0, c46.x, -r1.xyzy
    temp0.xw = temp0.xw * expr46.xx + -temp1.xy;
    // mad r0.xw, c52.x, r0, r1.xyzy
    temp0.xw = expr52.xx * temp0.xw + temp1.xy;
    // mov r4.y, c45.x
    temp4.y = expr45.x;
    // add r1.xy, r2, r4
    temp1.xy = temp2.xy + temp4.xy;
    // mad r1.xy, r1, c46.x, -r0.xwzw
    temp1.xy = temp1.xy * expr46.xx + -temp0.xw;
    // mad oT0.xy, c53.x, r1, r0.xwzw
    o.texcoord = expr53.x * temp1 + temp0.xwzw;
    // rcp r0.x, v0.w
    temp0.x = 1.0f / i.position.w;
    // mul r0.x, r0.z, r0.x
    temp0.x = temp0.z * temp0.x;
    // mov r1, c57
    temp1 = Draw.ColorAnimationFunctions[2];
    // mad r1, r1, r0.x, c58
    temp1 = temp1 * temp0.x + Draw.ColorAnimationFunctions[3];
    // mov r2, c59
    temp2 = Draw.ColorAnimationFunctions[4];
    // mad r2, r2, r0.x, c60
    temp2 = temp2 * temp0.x + Draw.ColorAnimationFunctions[5];
    // slt r0.zw, r0.x, c61.xyyz
    temp0.zw = (temp0.xx < Draw.TimeKeys.yz) ? 1 : 0;
    // mov r3, c55
    temp3 = Draw.ColorAnimationFunctions[0];
    // mad r3, r3, r0.x, c56
    temp3 = temp3 * temp0.x + Draw.ColorAnimationFunctions[1];
    // lrp r4, r0.w, r1, r2
    temp4 = lerp(temp2, temp1, temp0.w);
    // lrp r1, r0.z, r3, r4
    temp1 = lerp(temp4, temp3, temp0.z);
    // mul oD0, r0.y, r1
    o.color = temp0.y * temp1;
    // mov oT1.xyz, c27.z
    o.texcoord1 = float4(0, 0, 0, 0);
    // 

    return o;
}

// Default_L_PixelShader21 Pixel_2_0 Has PRES False
struct Default_L_PixelShader21_Input
{
    float2 texcoord : TEXCOORD;
    float4 color : COLOR;
};

float4 Default_L_PixelShader21(Default_L_PixelShader21_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    // dcl t0.xy
    // dcl v0
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(ParticleTextureSamplerSampler, i.texcoord.xy);
    // mul r0, r0, v0
    temp0 = temp0 * i.color;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// Default_L_VertexShader22 Vertex_2_0 Has PRES True
struct Default_L_VertexShader22_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 texcoord1 : TEXCOORD1;
};

struct Default_L_VertexShader22_Output
{
    float4 position : POSITION;
    float2 texcoord : TEXCOORD;
    float4 color : COLOR;
};

Default_L_VertexShader22_Output Default_L_VertexShader22(Default_L_VertexShader22_Input i)
{
    /*
    PRSI
      OutputRegisterOffset: 38
      Unknown1: 0
      Unknown2: 0
      OutputRegisterCount: 13
      Unknown3: 0
      Unknown4: 0
      Unknown5: 38
      Unknown6: 2
      Mappings: 3
        0 - ConstOutput: 44 ConstInput 2
        1 - ConstOutput: 47 ConstInput 4
        2 - ConstOutput: 0 ConstInput 0
    
    */
    float4 expr38;
    float4 expr39;
    float4 expr40;
    float4 expr41;
    float4 expr42;
    float4 expr43;
    float4 expr44;
    float4 expr45;
    float4 expr46;
    float4 expr47;
    float4 expr48;
    float4 expr49;
    float4 expr50;
    {
        float4 temp0;
        float4 temp1;
        float4 temp2;
        // Expression_2_1
        // mul c38.x, c1.x, (30)
        expr38.x = Time.x * (30);
        // add c39.x, c0.x, (-1)
        expr39.x = Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.x + (-1);
        // lt r0.x, (0), c0.z
        temp0.x = (0) < Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.z;
        // mul r0.y, c0.w, c0.w
        temp0.y = Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.w * Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.w;
        // neg r1.x, r0.y
        temp1.x = -temp0.y;
        // ge r2.x, r1.x, r0.y
        temp2.x = temp1.x >= temp0.y;
        // lt c49.x, r1.x, r0.y
        expr49.x = temp1.x < temp0.y;
        // mul c50.x, r0.x, r2.x
        expr50.x = temp0.x * temp2.x;
        // add r0.x, c0.z, (-1)
        temp0.x = Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.z + (-1);
        // neg r1.x, r0.x
        temp1.x = -temp0.x;
        // lt r2.x, r0.x, r1.x
        temp2.x = temp0.x < temp1.x;
        // frc r0.y, c0.z
        temp0.y = frac(Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.z);
        // neg r1.x, r0.y
        temp1.x = -temp0.y;
        // lt r2.y, r1.x, r0.y
        temp2.y = temp1.x < temp0.y;
        // add r2.z, r0.x, r1.x
        temp2.z = temp0.x + temp1.x;
        // mul r0.x, r2.x, r2.y
        temp0.x = temp2.x * temp2.y;
        // add c44.x, r2.z, r0.x
        expr44.x = temp2.z + temp0.x;
        // rcp c45.x, c0.x
        expr45.x = 1.0f / (Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.x);
        // add r0.x, c0.z, (1)
        temp0.x = Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.z + (1);
        // mul r1.x, r0.x, r0.x
        temp1.x = temp0.x * temp0.x;
        // neg r0.x, r1.x
        temp0.x = -temp1.x;
        // ge c48.x, r0.x, r1.x
        expr48.x = temp0.x >= temp1.x;
        // rcp c47.x, c0.y
        expr47.x = 1.0f / (Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.y);
    }

    Default_L_VertexShader22_Output o;
    float4 temp0, temp1, temp2, temp3, addr0, temp4;
    float2 temp5;
    // def c36, 2.0625, 6.1875, 1.375, 4.8125
    // def c28, 0.5, -0.5, 16, -1
    // def c30, -0.5, 0.5, 0.1591549, 0
    // def c37, 1, -1, 0.5, 0
    // def c31, 0, 0, 6.283185, -3.141593
    // def c29, 0.5, 0.5, 1.0001, 0.6931472
    // def c27, -0.5, -0.5, 0, 0.1875
    // def c11, 0.957897, 0.3788705, 0.3635719, 0.3287609
    // def c12, 0.1762373, 0.9145751, 0.4360935, 0.3476284
    // def c13, 0.743219, 0.4425611, 0.9974546, 0.3622138
    // def c14, 0.4896626, 0.6664233, 0.8305699, 0.9742577
    // def c15, 0.8947675, 0.8236215, 0.9309705, 0.05219847
    // def c16, 0.1411007, 0.6527002, 0.008452523, 0.6430574
    // def c17, 0.229799, 0.897999, 0.753822, 0.1316504
    // def c18, 0.5815384, 0.2836916, 0.09156471, 0.407481
    // def c19, 0.2706044, 0.7228181, 0.1694367, 0.1469052
    // def c20, 0.5995556, 0.0964533, 0.8763983, 0.1172229
    // def c21, 0.5101711, 0.9421572, 0.1957888, 0.9167565
    // def c22, 0.03546793, 0.5340094, 0.1673218, 0.5576764
    // def c23, 0.861564, 0.2251601, 0.082332, 0.8790039
    // def c24, 0.1730866, 0.8935188, 0.01392406, 0.1787381
    // def c25, 0.8269383, 0.7718143, 0.4395359, 0.493963
    // def c26, 0.5423613, 0.7218617, 0.7697314, 0.5878567
    // def c32, -0.25, -0.25, 0, 0
    // def c33, 0.25, -0.25, 0, 0
    // def c34, 0.25, 0.25, 0, 0
    // def c35, -0.25, 0.25, 0, 0
    // def c0, -1.550099E-06, -2.170139E-05, 0.002604167, 0.0002604167
    // def c1, -0.02083333, -0.125, 1, 0.5
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_texcoord1 v2
    // mov r0.xyz, c62
    temp0.xyz = Update.Size_Rate_Damping__Spread.xyz;
    // mov r0.w, c73.y
    temp0.w = Physics.VelocityDampingRange.y;
    // mov r1.xyz, c61
    temp1.xyz = Update.Size_Rate_Damping__Min.xyz;
    // mov r1.w, c73.x
    temp1.w = Physics.VelocityDampingRange.x;
    // mov r2.w, c27.w
    temp2.w = float1(0.1875);
    // mad r2, v2.x, r2.w, c36
    temp2 = i.texcoord1.x * temp2.w + float4(2.0625, 6.1875, 1.375, 4.8125);
    // frc r2, r2
    temp2 = frac(temp2);
    // mul r2, r2, c28.z
    temp2 = temp2 * float4(16, 16, 16, 16);
    // frc r3, r2
    temp3 = frac(temp2);
    // add r2, r2, -r3
    temp2 = temp2 + -temp3;
    // mova a0, r2
    addr0 = temp2;
    // mad r0, c11[a0.x], r0, r1
    temp0 = float4(0.957897, 0.37887052, 0.36357188, 0.32876092) * temp0 + temp1;
    // add r1.xy, r0.zwzw, c28.w
    temp1.xy = temp0.zw + float2(-1, -1);
    // mul r1.xy, r1, r1
    temp1.xy = temp1.xy * temp1.xy;
    // sge r1.xy, -r1, r1
    temp1.xy = (-temp1.xy >= temp1.xy) ? 1 : 0;
    // lrp r2.xy, r1, c29.z, r0.zwzw
    temp2.xy = lerp(temp0.zw, float2(1.0001, 1.0001), temp1.xy);
    // log r0.z, r2.y
    temp0.z = log2(temp2.y);
    // log r0.w, r2.x
    temp0.w = log2(temp2.x);
    // mul r1.x, r0.z, c29.w
    temp1.x = temp0.z * float1(0.6931472);
    // rcp r1.x, r1.x
    temp1.x = 1.0f / temp1.x;
    // add r1.y, -v1.w, c38.x
    temp1.y = -i.texcoord.w + expr38.x;
    // mul r0.z, r0.z, r1.y
    temp0.z = temp0.z * temp1.y;
    // exp r0.z, r0.z
    temp0.z = exp2(temp0.z);
    // add r0.z, r0.z, c28.w
    temp0.z = temp0.z + float1(-1);
    // mul r0.z, r1.x, r0.z
    temp0.z = temp1.x * temp0.z;
    // mov r2.xyz, v0
    temp2.xyz = i.position.xyz;
    // mad r1.xzw, v1.xyyz, r0.z, r2.xyyz
    temp1.xzw = i.texcoord.xyz * temp0.zzz + temp2.xyz;
    // mul r0.z, r1.y, -c27.x
    temp0.z = temp1.y * float1(0.5);
    // mov r2.xyz, c71
    temp2.xyz = Physics.Gravity.xyz;
    // mad r2.xyz, r0.z, r2, c72
    temp2.xyz = temp0.zzz * temp2.xyz + Physics.DriftVelocity.xyz;
    // mad r1.xzw, r2.xyyz, r1.y, r1
    temp1.xzw = temp2.xyz * temp1.yyy + temp1.xzw;
    // add r2.xyz, r1.xzzw, -v0.xyyw
    temp2.xyz = temp1.xzz + -i.position.xyy;
    // mov r3.xy, c64
    temp3.xy = Update.XYRotation_Rate_Damping__Spread.xy;
    // mov r3.zw, c66.xyxy
    temp3.zw = Update.ZRotation_Rate_Damping__Spread.xy;
    // mov r4.xy, c63
    temp4.xy = Update.XYRotation_Rate_Damping__Min.xy;
    // mov r4.zw, c65.xyxy
    temp4.zw = Update.ZRotation_Rate_Damping__Min.xy;
    // mad r3, c11[a0.y], r3, r4
    temp3 = float4(0.957897, 0.37887052, 0.36357188, 0.32876092) * temp3 + temp4;
    // mad r3.xy, r3.ywzw, r1.y, r3.xzzw
    temp3.xy = temp3.yw * temp1.yy + temp3.xz;
    // mad r3.xy, r3, c30.z, c30.y
    temp3.xy = temp3.xy * float2(0.15915494, 0.15915494) + float2(0.5, 0.5);
    // frc r3.xy, r3
    temp3.xy = frac(temp3.xy);
    // mad r3.xy, r3, c31.z, c31.w
    temp3.xy = temp3.xy * float2(6.2831855, 6.2831855) + float2(-3.1415927, -3.1415927);
    // sincos r4.xy, r3.x, c0, c1
    temp4.xy = float2(cos(temp3.x), sin(temp3.x));
    // sincos r5.xy, r3.y, c0, c1
    temp5.xy = float2(cos(temp3.y), sin(temp3.y));
    // mul r2.yzw, r2.xxyz, r4.xxyx
    temp2.yzw = temp2.xyz * temp4.xyx;
    // mad r2.w, r2.x, -r4.y, r2.w
    temp2.w = temp2.x * -temp4.y + temp2.w;
    // add r2.x, r2.z, r2.y
    temp2.x = temp2.z + temp2.y;
    // add r1.xz, r2.xyww, v0.xyyw
    temp1.xz = temp2.xw + i.position.xy;
    // slt r0.z, v0.w, r1.y
    temp0.z = (i.position.w < temp1.y) ? 1 : 0;
    // mad r0.z, r0.z, -v2.y, v2.y
    temp0.z = temp0.z * -i.texcoord1.y + i.texcoord1.y;
    // frc r2.x, r0.z
    temp2.x = frac(temp0.z);
    // add r0.z, r0.z, -r2.x
    temp0.z = temp0.z + -temp2.x;
    // mova a0.x, r0.z
    addr0.x = temp0.z;
    // mul r2.xyz, r5.xyxw, c27[a0.x].xyyw
    temp2.xyz = temp5.xyx * float3(-0.5, -0.5, -0.5);
    // mad r0.z, c27[a0.x].x, -r5.y, r2.z
    temp0.z = float1(-0.5) * -temp5.y + temp2.z;
    // mov r3.xy, c27[a0.x]
    temp3.xy = float2(-0.5, -0.5);
    // mad r2.zw, r3.xyxy, c37.xyxy, c37.z
    temp2.zw = temp3.xy * float2(1, -1) + float2(0.5, 0.5);
    // add r2.x, r2.y, r2.x
    temp2.x = temp2.y + temp2.x;
    // mul r3.xyz, r0.z, c75
    temp3.xyz = temp0.zzz * (View._m01_m11_m21_m31).xyz;
    // mad r3.xyz, r2.x, c74, r3
    temp3.xyz = temp2.xxx * (View._m00_m10_m20_m30).xyz + temp3.xyz;
    // mul r0.z, r0.w, c29.w
    temp0.z = temp0.w * float1(0.6931472);
    // mul r0.w, r0.w, r1.y
    temp0.w = temp0.w * temp1.y;
    // rcp r0.z, r0.z
    temp0.z = 1.0f / temp0.z;
    // exp r0.w, r0.w
    temp0.w = exp2(temp0.w);
    // add r0.w, r0.w, c28.w
    temp0.w = temp0.w + float1(-1);
    // mul r0.z, r0.z, r0.w
    temp0.z = temp0.z * temp0.w;
    // mad r0.x, r0.y, r0.z, r0.x
    temp0.x = temp0.y * temp0.z + temp0.x;
    // mad r0.xyz, r0.x, r3, r1.xzww
    temp0.xyz = temp0.xxx * temp3.xyz + temp1.xzw;
    // mov r0.w, -c28.w
    temp0.w = float1(1);
    // dp4 oPos.x, r0, c67
    o.position.x = dot(temp0, (WorldViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c68
    o.position.y = dot(temp0, (WorldViewProjection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c69
    o.position.z = dot(temp0, (WorldViewProjection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c70
    o.position.w = dot(temp0, (WorldViewProjection._m03_m13_m23_m33));
    // mul r0.x, r1.y, c60.x
    temp0.x = temp1.y * Draw.SpeedMultiplier.x;
    // mul r0.y, r0.x, c47.x
    temp0.y = temp0.x * expr47.x;
    // min r0.x, r0.x, c39.x
    temp0.x = min(temp0.x, expr39.x);
    // abs r1.x, r0.y
    temp1.x = abs(temp0.y);
    // sge r0.y, r0.y, -r0.y
    temp0.y = (temp0.y >= -temp0.y) ? 1 : 0;
    // frc r1.x, r1.x
    temp1.x = frac(temp1.x);
    // lrp r2.x, r0.y, r1.x, -r1.x
    temp2.x = lerp(-temp1.x, temp1.x, temp0.y);
    // mul r0.y, r2.x, c51.y
    temp0.y = temp2.x * Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.y;
    // mul r1.z, r0.y, c45.x
    temp1.z = temp0.y * expr45.x;
    // abs r0.y, r1.z
    temp0.y = abs(temp1.z);
    // frc r0.y, r0.y
    temp0.y = frac(temp0.y);
    // sge r1.w, r1.z, -r1.z
    temp1.w = (temp1.z >= -temp1.z) ? 1 : 0;
    // lrp r2.x, r1.w, r0.y, -r0.y
    temp2.x = lerp(-temp0.y, temp0.y, temp1.w);
    // mul r1.x, r2.x, c51.x
    temp1.x = temp2.x * Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.x;
    // frc r2.xy, r1.xzzw
    temp2.xy = frac(temp1.xz);
    // add r1.xz, r1, -r2.xyyw
    temp1.xz = temp1.xz + -temp2.xy;
    // add r1.xz, r2.zyww, r1
    temp1.xz = temp2.zw + temp1.xz;
    // mul r1.xz, r1, c45.x
    temp1.xz = temp1.xz * expr45.xx;
    // mov r2.x, c51.x
    temp2.x = Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.x;
    // mul r0.y, r2.x, c11[a0.z].x
    temp0.y = temp2.x * float1(0.957897);
    // mul r1.w, r2.x, c11[a0.w].x
    temp1.w = temp2.x * float1(0.957897);
    // frc r2.x, r0.y
    temp2.x = frac(temp0.y);
    // add r2.y, r0.y, -r2.x
    temp2.y = temp0.y + -temp2.x;
    // slt r0.y, r0.y, -r0.y
    temp0.y = (temp0.y < -temp0.y) ? 1 : 0;
    // slt r2.x, -r2.x, r2.x
    temp2.x = (-temp2.x < temp2.x) ? 1 : 0;
    // mad r0.w, r0.y, r2.x, r2.y
    temp0.w = temp0.y * temp2.x + temp2.y;
    // mov r3.z, c27.z
    temp3.z = float1(0);
    // frc r3.xy, r0.x
    temp3.xy = frac(temp0.x);
    // add r2.xy, r0.xwzw, -r3.yzzw
    temp2.xy = temp0.xw + -temp3.yz;
    // add r0.x, r0.x, -r3.x
    temp0.x = temp0.x + -temp3.x;
    // add r2.xy, r2.zwzw, r2
    temp2.xy = temp2.zw + temp2.xy;
    // mad r2.xy, r2, c45.x, -r1.xzzw
    temp2.xy = temp2.xy * expr45.xx + -temp1.xz;
    // mad r1.xz, c48.x, r2.xyyw, r1
    temp1.xz = expr48.xx * temp2.xy + temp1.xz;
    // frc r2.x, r1.w
    temp2.x = frac(temp1.w);
    // add r2.y, r1.w, -r2.x
    temp2.y = temp1.w + -temp2.x;
    // slt r2.x, -r2.x, r2.x
    temp2.x = (-temp2.x < temp2.x) ? 1 : 0;
    // slt r1.w, r1.w, -r1.w
    temp1.w = (temp1.w < -temp1.w) ? 1 : 0;
    // mad r0.z, r1.w, r2.x, r2.y
    temp0.z = temp1.w * temp2.x + temp2.y;
    // add r0.zw, r2, r0
    temp0.zw = temp2.zw + temp0.zw;
    // mad r0.zw, r0, c45.x, -r1.xyxz
    temp0.zw = temp0.zw * expr45.xx + -temp1.xz;
    // mad r0.zw, c49.x, r0, r1.xyxz
    temp0.zw = expr49.xx * temp0.zw + temp1.xz;
    // mov r0.y, c44.x
    temp0.y = expr44.x;
    // add r0.xy, r2.zwzw, r0
    temp0.xy = temp2.zw + temp0.xy;
    // mad r0.xy, r0, c45.x, -r0.zwzw
    temp0.xy = temp0.xy * expr45.xx + -temp0.zw;
    // mad oT0.xy, c50.x, r0, r0.zwzw
    o.texcoord = expr50.x * temp0 + temp0.zwzw;
    // rcp r0.x, v0.w
    temp0.x = 1.0f / i.position.w;
    // mul r0.x, r1.y, r0.x
    temp0.x = temp1.y * temp0.x;
    // mov r1, c54
    temp1 = Draw.ColorAnimationFunctions[2];
    // mad r1, r1, r0.x, c55
    temp1 = temp1 * temp0.x + Draw.ColorAnimationFunctions[3];
    // mov r2, c56
    temp2 = Draw.ColorAnimationFunctions[4];
    // mad r2, r2, r0.x, c57
    temp2 = temp2 * temp0.x + Draw.ColorAnimationFunctions[5];
    // slt r0.yz, r0.x, c58
    temp0.yz = (temp0.xx < Draw.TimeKeys.yz) ? 1 : 0;
    // mov r3, c52
    temp3 = Draw.ColorAnimationFunctions[0];
    // mad r3, r3, r0.x, c53
    temp3 = temp3 * temp0.x + Draw.ColorAnimationFunctions[1];
    // lrp r4, r0.z, r1, r2
    temp4 = lerp(temp2, temp1, temp0.z);
    // add r1, r3, -r4
    temp1 = temp3 + -temp4;
    // mad oD0, r0.y, r1, r4
    o.color = temp0.y * temp1 + temp4;
    // 

    return o;
}

// Default_M_Expression23 Expression_2_0 Has PRES False
float Default_M_Expression23()
{
    float1 expr0;
    // mov c0.x, (0)
    expr0.x = (0);
    return expr0;
}

// Default_M_VertexShader24 Vertex_2_0 Has PRES True
struct Default_M_VertexShader24_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 texcoord1 : TEXCOORD1;
};

struct Default_M_VertexShader24_Output
{
    float4 position : POSITION;
    float3 texcoord4 : TEXCOORD4;
    float texcoord2 : TEXCOORD2;
    float3 texcoord3 : TEXCOORD3;
    float2 texcoord : TEXCOORD;
    float4 color : COLOR;
    float3 texcoord1 : TEXCOORD1;
};

Default_M_VertexShader24_Output Default_M_VertexShader24(Default_M_VertexShader24_Input i)
{
    /*
    PRSI
      OutputRegisterOffset: 39
      Unknown1: 0
      Unknown2: 0
      OutputRegisterCount: 15
      Unknown3: 0
      Unknown4: 0
      Unknown5: 39
      Unknown6: 2
      Mappings: 4
        0 - ConstOutput: 45 ConstInput 2
        1 - ConstOutput: 48 ConstInput 1
        2 - ConstOutput: 50 ConstInput 4
        3 - ConstOutput: 0 ConstInput 0
    
    */
    float4 expr39;
    float4 expr40;
    float4 expr41;
    float4 expr42;
    float4 expr43;
    float4 expr44;
    float4 expr45;
    float4 expr46;
    float4 expr47;
    float4 expr48;
    float4 expr49;
    float4 expr50;
    float4 expr51;
    float4 expr52;
    float4 expr53;
    {
        float4 temp0;
        float4 temp1;
        float4 temp2;
        // Expression_2_1
        // mul c39.x, c1.x, (30)
        expr39.x = Time.x * (30);
        // add c40.x, c0.x, (-1)
        expr40.x = Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.x + (-1);
        // lt r0.x, (0), c0.z
        temp0.x = (0) < Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.z;
        // mul r0.y, c0.w, c0.w
        temp0.y = Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.w * Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.w;
        // neg r1.x, r0.y
        temp1.x = -temp0.y;
        // ge r2.x, r1.x, r0.y
        temp2.x = temp1.x >= temp0.y;
        // lt c52.x, r1.x, r0.y
        expr52.x = temp1.x < temp0.y;
        // mul c53.x, r0.x, r2.x
        expr53.x = temp0.x * temp2.x;
        // rcp c46.x, c0.x
        expr46.x = 1.0f / (Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.x);
        // add r0.x, c0.z, (1)
        temp0.x = Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.z + (1);
        // mul r1.x, r0.x, r0.x
        temp1.x = temp0.x * temp0.x;
        // neg r0.x, r1.x
        temp0.x = -temp1.x;
        // ge c51.x, r0.x, r1.x
        expr51.x = temp0.x >= temp1.x;
        // rcp c50.x, c0.y
        expr50.x = 1.0f / (Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.y);
        // add r0.x, c0.z, (-1)
        temp0.x = Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.z + (-1);
        // neg r1.x, r0.x
        temp1.x = -temp0.x;
        // lt r2.x, r0.x, r1.x
        temp2.x = temp0.x < temp1.x;
        // frc r0.y, c0.z
        temp0.y = frac(Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.z);
        // neg r1.x, r0.y
        temp1.x = -temp0.y;
        // lt r2.y, r1.x, r0.y
        temp2.y = temp1.x < temp0.y;
        // add r2.z, r0.x, r1.x
        temp2.z = temp0.x + temp1.x;
        // mul r0.x, r2.x, r2.y
        temp0.x = temp2.x * temp2.y;
        // add r1.x, r2.z, r0.x
        temp1.x = temp2.z + temp0.x;
        // mov c45.x, r1.x
        expr45.x = temp1.x;
        // mov c48.x, r1.x
        expr48.x = temp1.x;
    }

    Default_M_VertexShader24_Output o;
    float4 temp0, temp1, addr0, temp2, temp3, temp4;
    float3 temp5, temp6, temp7;
    // def c36, 2.0625, 8.9375, 6.1875, 1.375
    // def c28, 0.5, -0.5, 16, -1
    // def c37, 1, -1, 0.5, 0
    // def c30, -0.5, 0.5, 0.1591549, 0
    // def c31, 0, 0, 6.283185, -3.141593
    // def c38, 0.1875, 4.8125, 2.75, 0
    // def c29, 0.5, 0.5, 1.0001, 0.6931472
    // def c27, -0.5, -0.5, 0, 0.1875
    // def c11, 0.957897, 0.3788705, 0.3635719, 0.3287609
    // def c12, 0.1762373, 0.9145751, 0.4360935, 0.3476284
    // def c13, 0.743219, 0.4425611, 0.9974546, 0.3622138
    // def c14, 0.4896626, 0.6664233, 0.8305699, 0.9742577
    // def c15, 0.8947675, 0.8236215, 0.9309705, 0.05219847
    // def c16, 0.1411007, 0.6527002, 0.008452523, 0.6430574
    // def c17, 0.229799, 0.897999, 0.753822, 0.1316504
    // def c18, 0.5815384, 0.2836916, 0.09156471, 0.407481
    // def c19, 0.2706044, 0.7228181, 0.1694367, 0.1469052
    // def c20, 0.5995556, 0.0964533, 0.8763983, 0.1172229
    // def c21, 0.5101711, 0.9421572, 0.1957888, 0.9167565
    // def c22, 0.03546793, 0.5340094, 0.1673218, 0.5576764
    // def c23, 0.861564, 0.2251601, 0.082332, 0.8790039
    // def c24, 0.1730866, 0.8935188, 0.01392406, 0.1787381
    // def c25, 0.8269383, 0.7718143, 0.4395359, 0.493963
    // def c26, 0.5423613, 0.7218617, 0.7697314, 0.5878567
    // def c32, -0.25, -0.25, 0, 0
    // def c33, 0.25, -0.25, 0, 0
    // def c34, 0.25, 0.25, 0, 0
    // def c35, -0.25, 0.25, 0, 0
    // def c0, -1.550099E-06, -2.170139E-05, 0.002604167, 0.0002604167
    // def c1, -0.02083333, -0.125, 1, 0.5
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_texcoord1 v2
    // mov r0.w, c27.w
    temp0.w = float1(0.1875);
    // mad r0, v2.x, r0.w, c36
    temp0 = i.texcoord1.x * temp0.w + float4(2.0625, 8.9375, 6.1875, 1.375);
    // frc r0, r0
    temp0 = frac(temp0);
    // mul r0, r0, c28.z
    temp0 = temp0 * float4(16, 16, 16, 16);
    // frc r1, r0
    temp1 = frac(temp0);
    // add r0, r0, -r1
    temp0 = temp0 + -temp1;
    // mova a0, r0
    addr0 = temp0;
    // mov r0.xy, c77
    temp0.xy = Physics.VelocityDampingRange.xy;
    // mad r0.x, c11[a0.y].x, r0.y, r0.x
    temp0.x = float1(0.957897) * temp0.y + temp0.x;
    // add r0.y, r0.x, c28.w
    temp0.y = temp0.x + float1(-1);
    // mul r0.y, r0.y, r0.y
    temp0.y = temp0.y * temp0.y;
    // sge r0.y, -r0.y, r0.y
    temp0.y = (-temp0.y >= temp0.y) ? 1 : 0;
    // lrp r1.x, r0.y, c29.z, r0.x
    temp1.x = lerp(temp0.x, float1(1.0001), temp0.y);
    // log r0.x, r1.x
    temp0.x = log2(temp1.x);
    // mul r0.y, r0.x, c29.w
    temp0.y = temp0.x * float1(0.6931472);
    // rcp r0.y, r0.y
    temp0.y = 1.0f / temp0.y;
    // add r0.z, -v1.w, c39.x
    temp0.z = -i.texcoord.w + expr39.x;
    // mul r0.x, r0.x, r0.z
    temp0.x = temp0.x * temp0.z;
    // exp r0.x, r0.x
    temp0.x = exp2(temp0.x);
    // add r0.x, r0.x, c28.w
    temp0.x = temp0.x + float1(-1);
    // mul r0.x, r0.y, r0.x
    temp0.x = temp0.y * temp0.x;
    // mov r1.xyz, v0
    temp1.xyz = i.position.xyz;
    // mad r0.xyw, v1.xyzz, r0.x, r1.xyzz
    temp0.xyw = i.texcoord.xyz * temp0.xxx + temp1.xyz;
    // mul r1.x, r0.z, -c27.x
    temp1.x = temp0.z * float1(0.5);
    // mov r2.xyz, c75
    temp2.xyz = Physics.Gravity.xyz;
    // mad r1.xyz, r1.x, r2, c76
    temp1.xyz = temp1.xxx * temp2.xyz + Physics.DriftVelocity.xyz;
    // mad r0.xyw, r1.xyzz, r0.z, r0
    temp0.xyw = temp1.xyz * temp0.zzz + temp0.xyw;
    // add r1.xyz, r0.xyyw, -v0.xyyw
    temp1.xyz = temp0.xyy + -i.position.xyy;
    // mov r2.xyz, c11[a0.z]
    temp2.xyz = float3(0.957897, 0.37887052, 0.36357188);
    // mov r3.xyz, c68
    temp3.xyz = Update.XYRotation_Rate_Damping__Spread.xyz;
    // mad r2.xyz, r2, r3, c67
    temp2.xyz = temp2.xyz * temp3.xyz + Update.XYRotation_Rate_Damping__Min.xyz;
    // add r1.w, r2.z, c28.w
    temp1.w = temp2.z + float1(-1);
    // mul r1.w, r1.w, r1.w
    temp1.w = temp1.w * temp1.w;
    // sge r1.w, -r1.w, r1.w
    temp1.w = (-temp1.w >= temp1.w) ? 1 : 0;
    // lrp r3.x, r1.w, c29.z, r2.z
    temp3.x = lerp(temp2.z, float1(1.0001), temp1.w);
    // log r1.w, r3.x
    temp1.w = log2(temp3.x);
    // mul r2.z, r1.w, c29.w
    temp2.z = temp1.w * float1(0.6931472);
    // mul r1.w, r0.z, r1.w
    temp1.w = temp0.z * temp1.w;
    // rcp r2.z, r2.z
    temp2.z = 1.0f / temp2.z;
    // exp r1.w, r1.w
    temp1.w = exp2(temp1.w);
    // add r1.w, r1.w, c28.w
    temp1.w = temp1.w + float1(-1);
    // mul r1.w, r2.z, r1.w
    temp1.w = temp2.z * temp1.w;
    // mad r1.w, r2.y, r1.w, r2.x
    temp1.w = temp2.y * temp1.w + temp2.x;
    // mad r1.w, r1.w, c30.z, c30.y
    temp1.w = temp1.w * float1(0.15915494) + float1(0.5);
    // frc r1.w, r1.w
    temp1.w = frac(temp1.w);
    // mad r1.w, r1.w, c31.z, c31.w
    temp1.w = temp1.w * float1(6.2831855) + float1(-3.1415927);
    // sincos r2.xy, r1.w, c0, c1
    temp2.xy = float2(cos(temp1.w), sin(temp1.w));
    // mul r1.yzw, r1.xxyz, r2.xxyx
    temp1.yzw = temp1.xyz * temp2.xyx;
    // mad r1.w, r1.x, -r2.y, r1.w
    temp1.w = temp1.x * -temp2.y + temp1.w;
    // add r1.x, r1.z, r1.y
    temp1.x = temp1.z + temp1.y;
    // add r0.xy, r1.xwzw, v0
    temp0.xy = temp1.xw + i.position.xy;
    // mov r1.xyz, c11[a0.w]
    temp1.xyz = float3(0.957897, 0.37887052, 0.36357188);
    // mov r2.xyz, c70
    temp2.xyz = Update.ZRotation_Rate_Damping__Spread.xyz;
    // mad r1.yzw, r1.xxyz, r2.xxyz, c69.xxyz
    temp1.yzw = temp1.xyz * temp2.xyz + Update.ZRotation_Rate_Damping__Min.xyz;
    // add r2.x, r1.w, c28.w
    temp2.x = temp1.w + float1(-1);
    // mul r2.x, r2.x, r2.x
    temp2.x = temp2.x * temp2.x;
    // sge r2.x, -r2.x, r2.x
    temp2.x = (-temp2.x >= temp2.x) ? 1 : 0;
    // lrp r3.x, r2.x, c29.z, r1.w
    temp3.x = lerp(temp1.w, float1(1.0001), temp2.x);
    // log r1.w, r3.x
    temp1.w = log2(temp3.x);
    // mul r2.x, r1.w, c29.w
    temp2.x = temp1.w * float1(0.6931472);
    // mul r1.w, r0.z, r1.w
    temp1.w = temp0.z * temp1.w;
    // rcp r2.x, r2.x
    temp2.x = 1.0f / temp2.x;
    // exp r1.w, r1.w
    temp1.w = exp2(temp1.w);
    // add r1.w, r1.w, c28.w
    temp1.w = temp1.w + float1(-1);
    // mul r1.w, r2.x, r1.w
    temp1.w = temp2.x * temp1.w;
    // mad r1.y, r1.z, r1.w, r1.y
    temp1.y = temp1.z * temp1.w + temp1.y;
    // mad r1.y, r1.y, c30.z, c30.y
    temp1.y = temp1.y * float1(0.15915494) + float1(0.5);
    // frc r1.y, r1.y
    temp1.y = frac(temp1.y);
    // mad r1.y, r1.y, c31.z, c31.w
    temp1.y = temp1.y * float1(6.2831855) + float1(-3.1415927);
    // sincos r2.xy, r1.y, c0, c1
    temp2.xy = float2(cos(temp1.y), sin(temp1.y));
    // slt r1.y, v0.w, r0.z
    temp1.y = (i.position.w < temp0.z) ? 1 : 0;
    // mad r1.y, r1.y, -v2.y, v2.y
    temp1.y = temp1.y * -i.texcoord1.y + i.texcoord1.y;
    // frc r1.z, r1.y
    temp1.z = frac(temp1.y);
    // add r1.y, r1.y, -r1.z
    temp1.y = temp1.y + -temp1.z;
    // mova a0.y, r1.y
    addr0.y = temp1.y;
    // mul r1.yzw, r2.xxyx, c27[a0.y].xxyy
    temp1.yzw = temp2.xyx * float3(-0.5, -0.5, -0.5);
    // mad r1.w, c27[a0.y].x, -r2.y, r1.w
    temp1.w = float1(-0.5) * -temp2.y + temp1.w;
    // mov r2.xy, c27[a0.y]
    temp2.xy = float2(-0.5, -0.5);
    // mad r2.xy, r2, c37, c37.z
    temp2.xy = temp2.xy * float2(1, -1) + float2(0.5, 0.5);
    // add r1.y, r1.z, r1.y
    temp1.y = temp1.z + temp1.y;
    // mul r3.xyz, r1.w, c79
    temp3.xyz = temp1.www * (View._m01_m11_m21_m31).xyz;
    // mad r1.yzw, r1.y, c78.xxyz, r3.xxyz
    temp1.yzw = temp1.yyy * (View._m00_m10_m20_m30).xyz + temp3.xyz;
    // mov r3.xyz, c11[a0.x]
    temp3.xyz = float3(0.957897, 0.37887052, 0.36357188);
    // mov r4.xyz, c66
    temp4.xyz = Update.Size_Rate_Damping__Spread.xyz;
    // mad r3.xyz, r3, r4, c65
    temp3.xyz = temp3.xyz * temp4.xyz + Update.Size_Rate_Damping__Min.xyz;
    // mul r1.x, r1.x, c54.x
    temp1.x = temp1.x * Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.x;
    // add r2.z, r3.z, c28.w
    temp2.z = temp3.z + float1(-1);
    // mul r2.z, r2.z, r2.z
    temp2.z = temp2.z * temp2.z;
    // sge r2.z, -r2.z, r2.z
    temp2.z = (-temp2.z >= temp2.z) ? 1 : 0;
    // lrp r4.x, r2.z, c29.z, r3.z
    temp4.x = lerp(temp3.z, float1(1.0001), temp2.z);
    // log r2.z, r4.x
    temp2.z = log2(temp4.x);
    // mul r2.w, r2.z, c29.w
    temp2.w = temp2.z * float1(0.6931472);
    // mul r2.z, r0.z, r2.z
    temp2.z = temp0.z * temp2.z;
    // rcp r2.w, r2.w
    temp2.w = 1.0f / temp2.w;
    // exp r2.z, r2.z
    temp2.z = exp2(temp2.z);
    // add r2.z, r2.z, c28.w
    temp2.z = temp2.z + float1(-1);
    // mul r2.z, r2.w, r2.z
    temp2.z = temp2.w * temp2.z;
    // mad r2.z, r3.y, r2.z, r3.x
    temp2.z = temp3.y * temp2.z + temp3.x;
    // mad r3.xyz, r2.z, r1.yzww, r0.xyww
    temp3.xyz = temp2.zzz * temp1.yzw + temp0.xyw;
    // mov r3.w, -c28.w
    temp3.w = float1(1);
    // dp4 oPos.x, r3, c71
    o.position.x = dot(temp3, (WorldViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r3, c72
    o.position.y = dot(temp3, (WorldViewProjection._m01_m11_m21_m31));
    // dp4 r0.y, r3, c74
    temp0.y = dot(temp3, (WorldViewProjection._m03_m13_m23_m33));
    // dp4 r0.x, r3, c73
    temp0.x = dot(temp3, (WorldViewProjection._m02_m12_m22_m32));
    // mov oT4.xyz, r3
    o.texcoord4 = temp3;
    // rcp r0.w, r0.y
    temp0.w = 1.0f / temp0.y;
    // mov oPos.zw, r0.xyxy
    o.position.zw = temp0.xy;
    // mul oT2.x, r0.x, r0.w
    o.texcoord2 = temp0.x * temp0.w;
    // mov r0.w, c28.w
    temp0.w = float1(-1);
    // mad r0.x, r0.z, c63.x, -r0.w
    temp0.x = temp0.z * Draw.SpeedMultiplier.x + -temp0.w;
    // mul r0.y, r0.x, c50.x
    temp0.y = temp0.x * expr50.x;
    // min r3.x, r0.x, c40.x
    temp3.x = min(temp0.x, expr40.x);
    // abs r0.x, r0.y
    temp0.x = abs(temp0.y);
    // sge r0.y, r0.y, -r0.y
    temp0.y = (temp0.y >= -temp0.y) ? 1 : 0;
    // frc r0.x, r0.x
    temp0.x = frac(temp0.x);
    // lrp r1.y, r0.y, r0.x, -r0.x
    temp1.y = lerp(-temp0.x, temp0.x, temp0.y);
    // mul r0.x, r1.y, c54.y
    temp0.x = temp1.y * Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.y;
    // mul r0.y, r0.x, c46.x
    temp0.y = temp0.x * expr46.x;
    // abs r0.w, r0.y
    temp0.w = abs(temp0.y);
    // frc r0.w, r0.w
    temp0.w = frac(temp0.w);
    // sge r1.y, r0.y, -r0.y
    temp1.y = (temp0.y >= -temp0.y) ? 1 : 0;
    // lrp r2.z, r1.y, r0.w, -r0.w
    temp2.z = lerp(-temp0.w, temp0.w, temp1.y);
    // mul r0.x, r2.z, c54.x
    temp0.x = temp2.z * Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.x;
    // frc r1.yz, r0.xxyw
    temp1.yz = frac(temp0.xy);
    // add r0.xy, r0, -r1.yzzw
    temp0.xy = temp0.xy + -temp1.yz;
    // add r0.xy, r2, r0
    temp0.xy = temp2.xy + temp0.xy;
    // mul r0.xy, r0, c46.x
    temp0.xy = temp0.xy * expr46.xx;
    // frc r1.y, r1.x
    temp1.y = frac(temp1.x);
    // add r1.z, r1.x, -r1.y
    temp1.z = temp1.x + -temp1.y;
    // slt r1.y, -r1.y, r1.y
    temp1.y = (-temp1.y < temp1.y) ? 1 : 0;
    // slt r1.x, r1.x, -r1.x
    temp1.x = (temp1.x < -temp1.x) ? 1 : 0;
    // mad r3.w, r1.x, r1.y, r1.z
    temp3.w = temp1.x * temp1.y + temp1.z;
    // mov r1.w, c27.z
    temp1.w = float1(0);
    // mul r2.z, r0.z, c63.x
    temp2.z = temp0.z * Draw.SpeedMultiplier.x;
    // min r3.y, r2.z, c40.x
    temp3.y = min(temp2.z, expr40.x);
    // frc r1.xyz, r3.yxxw
    temp1.xyz = frac(temp3.yxx);
    // add r1.zw, r3.xyxw, -r1
    temp1.zw = temp3.xw + -temp1.zw;
    // add r4.xz, r3.yyxw, -r1.xyyw
    temp4.xz = temp3.yx + -temp1.xy;
    // add r1.xy, r2, r1.zwzw
    temp1.xy = temp2.xy + temp1.zw;
    // mul r1.xy, r1, c46.x
    temp1.xy = temp1.xy * expr46.xx;
    // frc r0.w, r2.z
    temp0.w = frac(temp2.z);
    // mul r2.z, r2.z, c50.x
    temp2.z = temp2.z * expr50.x;
    // frc r1.z, r3.y
    temp1.z = frac(temp3.y);
    // lrp r5.xyz, c51.x, r1, r0.xyww
    temp5.xyz = lerp(temp0.xyw, temp1.xyz, expr51.xxx);
    // mad r0.xy, v2.x, c38.x, c38.yzzw
    temp0.xy = i.texcoord1.xx * float2(0.1875, 0.1875) + float2(4.8125, 2.75);
    // frc r0.xy, r0
    temp0.xy = frac(temp0.xy);
    // mul r0.xy, r0, c28.z
    temp0.xy = temp0.xy * float2(16, 16);
    // frc r1.xy, r0
    temp1.xy = frac(temp0.xy);
    // add r0.xy, r0, -r1
    temp0.xy = temp0.xy + -temp1.xy;
    // mova a0.xy, r0
    addr0.xy = temp0.xy;
    // mov r0.x, c54.x
    temp0.x = Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.x;
    // mul r0.x, r0.x, c11[a0.x].x
    temp0.x = temp0.x * float1(0.957897);
    // mov r1.xy, c64
    temp1.xy = Draw.ColorScaleRange.xy;
    // mad r0.y, c11[a0.y].x, r1.y, r1.x
    temp0.y = float1(0.957897) * temp1.y + temp1.x;
    // frc r0.w, r0.x
    temp0.w = frac(temp0.x);
    // add r1.x, r0.x, -r0.w
    temp1.x = temp0.x + -temp0.w;
    // slt r0.x, r0.x, -r0.x
    temp0.x = (temp0.x < -temp0.x) ? 1 : 0;
    // slt r0.w, -r0.w, r0.w
    temp0.w = (-temp0.w < temp0.w) ? 1 : 0;
    // mad r3.z, r0.x, r0.w, r1.x
    temp3.z = temp0.x * temp0.w + temp1.x;
    // add r0.xw, r2.xyzy, r3.zyzw
    temp0.xw = temp2.xy + temp3.zw;
    // mul r6.xy, r0.xwzw, c46.x
    temp6.xy = temp0.xw * expr46.xx;
    // mov r6.z, c27.z
    temp6.z = float1(0);
    // lrp r7.xyz, c52.x, r6, r5
    temp7.xyz = lerp(temp5.xyz, temp6.xyz, expr52.xxx);
    // mov r4.w, c48.x
    temp4.w = expr48.x;
    // add r1.xy, r2, r4.zwzw
    temp1.xy = temp2.xy + temp4.zw;
    // mul r5.xy, r1, c46.x
    temp5.xy = temp1.xy * expr46.xx;
    // mov r5.z, r1.z
    temp5.z = temp1.z;
    // add r5.xyz, -r7, r5
    temp5.xyz = -temp7.xyz + temp5.xyz;
    // mad oT3.xyz, c53.x, r5, r7
    o.texcoord3 = expr53.x * temp5 + temp7;
    // mov r1.w, c27.z
    temp1.w = float1(0);
    // add r1.xy, r3.ywzw, -r1.zwzw
    temp1.xy = temp3.yw + -temp1.zw;
    // add r1.xy, r2, r1
    temp1.xy = temp2.xy + temp1.xy;
    // abs r1.z, r2.z
    temp1.z = abs(temp2.z);
    // sge r1.w, r2.z, -r2.z
    temp1.w = (temp2.z >= -temp2.z) ? 1 : 0;
    // frc r1.z, r1.z
    temp1.z = frac(temp1.z);
    // lrp r2.z, r1.w, r1.z, -r1.z
    temp2.z = lerp(-temp1.z, temp1.z, temp1.w);
    // mul r1.z, r2.z, c54.y
    temp1.z = temp2.z * Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.y;
    // mul r1.w, r1.z, c46.x
    temp1.w = temp1.z * expr46.x;
    // abs r2.z, r1.w
    temp2.z = abs(temp1.w);
    // frc r2.z, r2.z
    temp2.z = frac(temp2.z);
    // sge r2.w, r1.w, -r1.w
    temp2.w = (temp1.w >= -temp1.w) ? 1 : 0;
    // lrp r3.x, r2.w, r2.z, -r2.z
    temp3.x = lerp(-temp2.z, temp2.z, temp2.w);
    // mul r1.z, r3.x, c54.x
    temp1.z = temp3.x * Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.x;
    // frc r2.zw, r1
    temp2.zw = frac(temp1.zw);
    // add r1.zw, r1, -r2
    temp1.zw = temp1.zw + -temp2.zw;
    // add r1.zw, r2.xyxy, r1
    temp1.zw = temp2.xy + temp1.zw;
    // mul r1.zw, r1, c46.x
    temp1.zw = temp1.zw * expr46.xx;
    // mad r1.xy, r1, c46.x, -r1.zwzw
    temp1.xy = temp1.xy * expr46.xx + -temp1.zw;
    // mad r1.xy, c51.x, r1, r1.zwzw
    temp1.xy = expr51.xx * temp1.xy + temp1.zw;
    // mad r0.xw, r0, c46.x, -r1.xyzy
    temp0.xw = temp0.xw * expr46.xx + -temp1.xy;
    // mad r0.xw, c52.x, r0, r1.xyzy
    temp0.xw = expr52.xx * temp0.xw + temp1.xy;
    // mov r4.y, c45.x
    temp4.y = expr45.x;
    // add r1.xy, r2, r4
    temp1.xy = temp2.xy + temp4.xy;
    // mad r1.xy, r1, c46.x, -r0.xwzw
    temp1.xy = temp1.xy * expr46.xx + -temp0.xw;
    // mad oT0.xy, c53.x, r1, r0.xwzw
    o.texcoord = expr53.x * temp1 + temp0.xwzw;
    // rcp r0.x, v0.w
    temp0.x = 1.0f / i.position.w;
    // mul r0.x, r0.z, r0.x
    temp0.x = temp0.z * temp0.x;
    // mov r1, c57
    temp1 = Draw.ColorAnimationFunctions[2];
    // mad r1, r1, r0.x, c58
    temp1 = temp1 * temp0.x + Draw.ColorAnimationFunctions[3];
    // mov r2, c59
    temp2 = Draw.ColorAnimationFunctions[4];
    // mad r2, r2, r0.x, c60
    temp2 = temp2 * temp0.x + Draw.ColorAnimationFunctions[5];
    // slt r0.zw, r0.x, c61.xyyz
    temp0.zw = (temp0.xx < Draw.TimeKeys.yz) ? 1 : 0;
    // mov r3, c55
    temp3 = Draw.ColorAnimationFunctions[0];
    // mad r3, r3, r0.x, c56
    temp3 = temp3 * temp0.x + Draw.ColorAnimationFunctions[1];
    // lrp r4, r0.w, r1, r2
    temp4 = lerp(temp2, temp1, temp0.w);
    // lrp r1, r0.z, r3, r4
    temp1 = lerp(temp4, temp3, temp0.z);
    // mul oD0, r0.y, r1
    o.color = temp0.y * temp1;
    // mov oT1.xyz, -c28.w
    o.texcoord1 = float4(1, 1, 1, 1);
    // 

    return o;
}

// Default_Expression25 Expression_2_0 Has PRES False
float Default_Expression25()
{
    float4 temp0;
    float4 temp1;
    float4 temp2;
    float1 expr0;
    // add r0.x, c8.x, (-3)
    temp0.x = Draw.ShaderType.x + (-3);
    // mul r1.x, r0.x, r0.x
    temp1.x = temp0.x * temp0.x;
    // neg r0.x, r1.x
    temp0.x = -temp1.x;
    // ge r2.x, r0.x, r1.x
    temp2.x = temp0.x >= temp1.x;
    // add r0.x, r2.x, (-2)
    temp0.x = temp2.x + (-2);
    // mul r1.x, r0.x, c9.x
    temp1.x = temp0.x * ShouldDrawParticleSoft.x;
    // add r0.x, r1.x, (2)
    temp0.x = temp1.x + (2);
    // mul c0.x, r0.x, (3)
    expr0.x = temp0.x * (3);
    return expr0;
}

// Default_VertexShader26 Vertex_3_0 Has PRES True
struct Default_VertexShader26_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 texcoord1 : TEXCOORD1;
};

struct Default_VertexShader26_Output
{
    float4 position : POSITION;
    float2 texcoord : TEXCOORD;
    float4 color : COLOR;
    float3 texcoord1 : TEXCOORD1;
    float texcoord2 : TEXCOORD2;
    float3 texcoord3 : TEXCOORD3;
    float4 texcoord4 : TEXCOORD4;
    float2 texcoord5 : TEXCOORD5;
    float3 texcoord6 : TEXCOORD6;
};

Default_VertexShader26_Output Default_VertexShader26(Default_VertexShader26_Input i)
{
    /*
    PRSI
      OutputRegisterOffset: 38
      Unknown1: 0
      Unknown2: 0
      OutputRegisterCount: 19
      Unknown3: 3
      Unknown4: 0
      Unknown5: 38
      Unknown6: 2
      Mappings: 5
        0 - ConstOutput: 45 ConstInput 2
        1 - ConstOutput: 48 ConstInput 1
        2 - ConstOutput: 50 ConstInput 1
        3 - ConstOutput: 54 ConstInput 3
        4 - ConstOutput: 1 ConstInput 0
    
    */
    float4 expr38;
    float4 expr39;
    float4 expr40;
    float4 expr41;
    float4 expr42;
    float4 expr43;
    float4 expr44;
    float4 expr45;
    float4 expr46;
    float4 expr47;
    float4 expr48;
    float4 expr49;
    float4 expr50;
    float4 expr51;
    float4 expr52;
    float4 expr53;
    float4 expr54;
    float4 expr55;
    float4 expr56;
    {
        float4 temp0;
        float4 temp1;
        float4 temp2;
        // Expression_2_1
        // mul c38.x, c1.x, (30)
        expr38.x = Time.x * (30);
        // add c39.x, c0.x, (-1)
        expr39.x = Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.x + (-1);
        // lt r0.x, (0), c0.z
        temp0.x = (0) < Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.z;
        // neg r0.y, c0.w
        temp0.y = -Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.w;
        // max r1.x, r0.y, c0.w
        temp1.x = max(temp0.y, Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.w);
        // neg r0.y, r1.x
        temp0.y = -temp1.x;
        // ge r2.x, r0.y, r1.x
        temp2.x = temp0.y >= temp1.x;
        // lt unknown1.x, r0.y, r1.x
        unknown1.x = temp0.y < temp1.x;
        // mul unknown0.x, r0.x, r2.x
        unknown0.x = temp0.x * temp2.x;
        // add r0.x, c0.z, (1)
        temp0.x = Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.z + (1);
        // neg r1.x, r0.x
        temp1.x = -temp0.x;
        // max r2.x, r0.x, r1.x
        temp2.x = max(temp0.x, temp1.x);
        // neg r0.x, r2.x
        temp0.x = -temp2.x;
        // ge unknown2.x, r0.x, r2.x
        unknown2.x = temp0.x >= temp2.x;
        // rcp c55.x, c0.y
        expr55.x = 1.0f / (Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.y);
        // add r0.x, c0.z, (-1)
        temp0.x = Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.z + (-1);
        // neg r1.x, r0.x
        temp1.x = -temp0.x;
        // lt r2.x, r0.x, r1.x
        temp2.x = temp0.x < temp1.x;
        // frc r0.y, c0.z
        temp0.y = frac(Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.z);
        // neg r1.x, r0.y
        temp1.x = -temp0.y;
        // lt r2.y, r1.x, r0.y
        temp2.y = temp1.x < temp0.y;
        // add r2.z, r0.x, r1.x
        temp2.z = temp0.x + temp1.x;
        // mul r0.x, r2.x, r2.y
        temp0.x = temp2.x * temp2.y;
        // add r1.x, r2.z, r0.x
        temp1.x = temp2.z + temp0.x;
        // mov c45.x, r1.x
        expr45.x = temp1.x;
        // mov c48.x, r1.x
        expr48.x = temp1.x;
        // rcp r0.x, c0.x
        temp0.x = 1.0f / (Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.x);
        // mov c46.x, r0.x
        expr46.x = temp0.x;
        // mov c50.x, r0.x
        expr50.x = temp0.x;
        // mov c54.x, r0.x
        expr54.x = temp0.x;
        // mov c56.x, r0.x
        expr56.x = temp0.x;
    }

    Default_VertexShader26_Output o;
    float4 temp0, temp1, temp2, addr0, temp3, temp4, temp5, temp6;
    // def c36, 2.0625, 8.9375, 6.1875, 1.375
    // def c28, 0.5, -0.5, 16, -1
    // def c37, 1, -1, 0.5, 0
    // def c30, -0.5, 0.5, 0.1591549, 0.2
    // def c31, 0, 0, 6.283185, -3.141593
    // def c32, -0.25, -0.25, 0.1875, 4.8125
    // def c33, 0.25, -0.25, 0.1875, 2.75
    // def c29, 0.5, 0.5, 1.0001, 0.6931472
    // def c27, -0.5, -0.5, 0, 0.1875
    // def c11, 0.957897, 0.3788705, 0.3635719, 0.3287609
    // def c12, 0.1762373, 0.9145751, 0.4360935, 0.3476284
    // def c13, 0.743219, 0.4425611, 0.9974546, 0.3622138
    // def c14, 0.4896626, 0.6664233, 0.8305699, 0.9742577
    // def c15, 0.8947675, 0.8236215, 0.9309705, 0.05219847
    // def c16, 0.1411007, 0.6527002, 0.008452523, 0.6430574
    // def c17, 0.229799, 0.897999, 0.753822, 0.1316504
    // def c18, 0.5815384, 0.2836916, 0.09156471, 0.407481
    // def c19, 0.2706044, 0.7228181, 0.1694367, 0.1469052
    // def c20, 0.5995556, 0.0964533, 0.8763983, 0.1172229
    // def c21, 0.5101711, 0.9421572, 0.1957888, 0.9167565
    // def c22, 0.03546793, 0.5340094, 0.1673218, 0.5576764
    // def c23, 0.861564, 0.2251601, 0.082332, 0.8790039
    // def c24, 0.1730866, 0.8935188, 0.01392406, 0.1787381
    // def c25, 0.8269383, 0.7718143, 0.4395359, 0.493963
    // def c26, 0.5423613, 0.7218617, 0.7697314, 0.5878567
    // def c34, 0.25, 0.25, 0, 0
    // def c35, -0.25, 0.25, 0, 0
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_texcoord1 v2
    // dcl_position o0
    // dcl_texcoord o1.xy
    // dcl_color o2
    // dcl_texcoord1 o3.xyz
    // dcl_texcoord2 o4.x
    // dcl_texcoord3 o5.xyz
    // dcl_texcoord4 o6
    // dcl_texcoord5 o7.xy
    // dcl_texcoord6 o8.xyz
    // add r0.x, c38.x, -v1.w
    temp0.x = expr38.x + -i.texcoord.w;
    // slt r0.y, v0.w, r0.x
    temp0.y = (i.position.w < temp0.x) ? 1 : 0;
    // mad r0.y, r0.y, -v2.y, v2.y
    temp0.y = temp0.y * -i.texcoord1.y + i.texcoord1.y;
    // rcp r0.z, v0.w
    temp0.z = 1.0f / i.position.w;
    // mul r0.z, r0.x, r0.z
    temp0.z = temp0.x * temp0.z;
    // mov r0.w, c27.w
    temp0.w = float1(0.1875);
    // mad r1, v2.x, r0.w, c36
    temp1 = i.texcoord1.x * temp0.w + float4(2.0625, 8.9375, 6.1875, 1.375);
    // frc r1, r1
    temp1 = frac(temp1);
    // mul r1, r1, c28.z
    temp1 = temp1 * float4(16, 16, 16, 16);
    // frc r2, r1
    temp2 = frac(temp1);
    // add r1, r1, -r2
    temp1 = temp1 + -temp2;
    // mova a0, r1
    addr0 = temp1;
    // mov r1.xyz, c11[a0.x]
    temp1.xyz = float3(0.957897, 0.37887052, 0.36357188);
    // mov r2.xyz, c69
    temp2.xyz = Update.Size_Rate_Damping__Spread.xyz;
    // mad r1.xyz, r1, r2, c68
    temp1.xyz = temp1.xyz * temp2.xyz + Update.Size_Rate_Damping__Min.xyz;
    // add r0.w, r1.z, c28.w
    temp0.w = temp1.z + float1(-1);
    // sge r0.w, -r0_abs.w, r0_abs.w
    temp0.w = (r0.w == 0) ? 1 : 0;
    // lrp r2.x, r0.w, c29.z, r1.z
    temp2.x = lerp(temp1.z, float1(1.0001), temp0.w);
    // log r0.w, r2.x
    temp0.w = log2(temp2.x);
    // mul r1.z, r0.x, r0.w
    temp1.z = temp0.x * temp0.w;
    // exp r1.z, r1.z
    temp1.z = exp2(temp1.z);
    // add r1.z, r1.z, c28.w
    temp1.z = temp1.z + float1(-1);
    // mul r0.w, r0.w, c29.w
    temp0.w = temp0.w * float1(0.6931472);
    // rcp r0.w, r0.w
    temp0.w = 1.0f / temp0.w;
    // mul r0.w, r1.z, r0.w
    temp0.w = temp1.z * temp0.w;
    // mad r0.w, r1.y, r0.w, r1.x
    temp0.w = temp1.y * temp0.w + temp1.x;
    // mov r1.xy, c84
    temp1.xy = Physics.VelocityDampingRange.xy;
    // mad r1.x, c11[a0.y].x, r1.y, r1.x
    temp1.x = float1(0.957897) * temp1.y + temp1.x;
    // add r1.y, r1.x, c28.w
    temp1.y = temp1.x + float1(-1);
    // sge r1.y, -r1_abs.y, r1_abs.y
    temp1.y = (r1.y == 0) ? 1 : 0;
    // lrp r2.x, r1.y, c29.z, r1.x
    temp2.x = lerp(temp1.x, float1(1.0001), temp1.y);
    // log r1.x, r2.x
    temp1.x = log2(temp2.x);
    // mul r1.y, r0.x, r1.x
    temp1.y = temp0.x * temp1.x;
    // exp r1.y, r1.y
    temp1.y = exp2(temp1.y);
    // add r1.y, r1.y, c28.w
    temp1.y = temp1.y + float1(-1);
    // mul r1.x, r1.x, c29.w
    temp1.x = temp1.x * float1(0.6931472);
    // rcp r1.x, r1.x
    temp1.x = 1.0f / temp1.x;
    // mul r1.x, r1.y, r1.x
    temp1.x = temp1.y * temp1.x;
    // mov r2.xyz, v0
    temp2.xyz = i.position.xyz;
    // mad r1.xyz, v1, r1.x, r2
    temp1.xyz = i.texcoord.xyz * temp1.xxx + temp2.xyz;
    // mul r1.w, r0.x, -c27.x
    temp1.w = temp0.x * float1(0.5);
    // mov r2.xyz, c82
    temp2.xyz = Physics.Gravity.xyz;
    // mad r2.xyz, r1.w, r2, c83
    temp2.xyz = temp1.www * temp2.xyz + Physics.DriftVelocity.xyz;
    // mad r1.xyz, r2, r0.x, r1
    temp1.xyz = temp2.xyz * temp0.xxx + temp1.xyz;
    // add r2.xyz, r1.xyyw, -v0.xyyw
    temp2.xyz = temp1.xyy + -i.position.xyy;
    // mov r3.xyz, c11[a0.z]
    temp3.xyz = float3(0.957897, 0.37887052, 0.36357188);
    // mov r4.xyz, c71
    temp4.xyz = Update.XYRotation_Rate_Damping__Spread.xyz;
    // mad r3.xyz, r3, r4, c70
    temp3.xyz = temp3.xyz * temp4.xyz + Update.XYRotation_Rate_Damping__Min.xyz;
    // add r1.w, r3.z, c28.w
    temp1.w = temp3.z + float1(-1);
    // sge r1.w, -r1_abs.w, r1_abs.w
    temp1.w = (r1.w == 0) ? 1 : 0;
    // lrp r2.w, r1.w, c29.z, r3.z
    temp2.w = lerp(temp3.z, float1(1.0001), temp1.w);
    // log r1.w, r2.w
    temp1.w = log2(temp2.w);
    // mul r2.w, r0.x, r1.w
    temp2.w = temp0.x * temp1.w;
    // exp r2.w, r2.w
    temp2.w = exp2(temp2.w);
    // add r2.w, r2.w, c28.w
    temp2.w = temp2.w + float1(-1);
    // mul r1.w, r1.w, c29.w
    temp1.w = temp1.w * float1(0.6931472);
    // rcp r1.w, r1.w
    temp1.w = 1.0f / temp1.w;
    // mul r1.w, r2.w, r1.w
    temp1.w = temp2.w * temp1.w;
    // mad r1.w, r3.y, r1.w, r3.x
    temp1.w = temp3.y * temp1.w + temp3.x;
    // mad r1.w, r1.w, c30.z, c30.y
    temp1.w = temp1.w * float1(0.15915494) + float1(0.5);
    // frc r1.w, r1.w
    temp1.w = frac(temp1.w);
    // mad r1.w, r1.w, c31.z, c31.w
    temp1.w = temp1.w * float1(6.2831855) + float1(-3.1415927);
    // sincos r3.xy, r1.w
    temp3.xy = float2(cos(temp1.w), sin(temp1.w));
    // mul r2.yzw, r2.xxyz, r3.xxyx
    temp2.yzw = temp2.xyz * temp3.xyx;
    // add r2.y, r2.z, r2.y
    temp2.y = temp2.z + temp2.y;
    // mad r2.z, r2.x, -r3.y, r2.w
    temp2.z = temp2.x * -temp3.y + temp2.w;
    // add r1.xy, r2.yzzw, v0
    temp1.xy = temp2.yz + i.position.xy;
    // mov r2.xyz, c11[a0.w]
    temp2.xyz = float3(0.957897, 0.37887052, 0.36357188);
    // mov r3.xyz, c73
    temp3.xyz = Update.ZRotation_Rate_Damping__Spread.xyz;
    // mad r2.yzw, r2.xxyz, r3.xxyz, c72.xxyz
    temp2.yzw = temp2.xyz * temp3.xyz + Update.ZRotation_Rate_Damping__Min.xyz;
    // add r1.w, r2.w, c28.w
    temp1.w = temp2.w + float1(-1);
    // sge r1.w, -r1_abs.w, r1_abs.w
    temp1.w = (r1.w == 0) ? 1 : 0;
    // lrp r3.x, r1.w, c29.z, r2.w
    temp3.x = lerp(temp2.w, float1(1.0001), temp1.w);
    // log r1.w, r3.x
    temp1.w = log2(temp3.x);
    // mul r2.w, r0.x, r1.w
    temp2.w = temp0.x * temp1.w;
    // exp r2.w, r2.w
    temp2.w = exp2(temp2.w);
    // add r2.w, r2.w, c28.w
    temp2.w = temp2.w + float1(-1);
    // mul r1.w, r1.w, c29.w
    temp1.w = temp1.w * float1(0.6931472);
    // rcp r1.w, r1.w
    temp1.w = 1.0f / temp1.w;
    // mul r1.w, r2.w, r1.w
    temp1.w = temp2.w * temp1.w;
    // mad r1.w, r2.z, r1.w, r2.y
    temp1.w = temp2.z * temp1.w + temp2.y;
    // mad r1.w, r1.w, c30.z, c30.y
    temp1.w = temp1.w * float1(0.15915494) + float1(0.5);
    // frc r1.w, r1.w
    temp1.w = frac(temp1.w);
    // mad r1.w, r1.w, c31.z, c31.w
    temp1.w = temp1.w * float1(6.2831855) + float1(-3.1415927);
    // sincos r3.xy, r1.w
    temp3.xy = float2(cos(temp1.w), sin(temp1.w));
    // frc r1.w, r0.y
    temp1.w = frac(temp0.y);
    // add r0.y, r0.y, -r1.w
    temp0.y = temp0.y + -temp1.w;
    // mova a0.x, r0.y
    addr0.x = temp0.y;
    // mul r2.yzw, r3.xxyx, c27[a0.x].xxyy
    temp2.yzw = temp3.xyx * float3(-0.5, -0.5, -0.5);
    // add r0.y, r2.z, r2.y
    temp0.y = temp2.z + temp2.y;
    // mad r1.w, c27[a0.x].x, -r3.y, r2.w
    temp1.w = float1(-0.5) * -temp3.y + temp2.w;
    // mul r2.yzw, r1.w, c86.xxyz
    temp2.yzw = temp1.www * (View._m01_m11_m21_m31).xyz;
    // mad r2.yzw, r0.y, c85.xxyz, r2
    temp2.yzw = temp0.yyy * (View._m00_m10_m20_m30).xyz + temp2.yzw;
    // mad r1.xyz, r0.w, r2.yzww, r1
    temp1.xyz = temp0.www * temp2.yzw + temp1.xyz;
    // mul r0.y, r0.w, c30.w
    temp0.y = temp0.w * float1(0.2);
    // mov r1.w, -c28.w
    temp1.w = float1(1);
    // dp4 r3.x, r1, c74
    temp3.x = dot(temp1, (WorldView._m00_m10_m20_m30));
    // dp4 r3.y, r1, c75
    temp3.y = dot(temp1, (WorldView._m01_m11_m21_m31));
    // dp4 r3.z, r1, c76
    temp3.z = dot(temp1, (WorldView._m02_m12_m22_m32));
    // dp4 r3.w, r1, c77
    temp3.w = dot(temp1, (WorldView._m03_m13_m23_m33));
    // rcp r0.y, r0.y
    temp0.y = 1.0f / temp0.y;
    // mul o7.x, r3.z, r0.y
    o.texcoord5.x = temp3.z * temp0.y;
    // dp4 r4.x, r3, c78
    temp4.x = dot(temp3, (Projection._m00_m10_m20_m30));
    // dp4 r4.y, r3, c79
    temp4.y = dot(temp3, (Projection._m01_m11_m21_m31));
    // dp4 r4.z, r3, c80
    temp4.z = dot(temp3, (Projection._m02_m12_m22_m32));
    // dp4 r4.w, r3, c81
    temp4.w = dot(temp3, (Projection._m03_m13_m23_m33));
    // rcp r0.w, r4.w
    temp0.w = 1.0f / temp4.w;
    // mul o4.x, r4.z, r0.w
    o.texcoord2 = temp4.z * temp0.w;
    // mov r3.xy, c27[a0.x]
    temp3.xy = float2(-0.5, -0.5);
    // mad r2.yz, r3.xxyw, c37.xxyw, c37.z
    temp2.yz = temp3.xy * float2(1, -1) + float2(0.5, 0.5);
    // mul r0.w, r0.x, c66.x
    temp0.w = temp0.x * Draw.SpeedMultiplier.x;
    // min r3.y, r0.w, c39.x
    temp3.y = min(temp0.w, expr39.x);
    // mov r1.w, c28.w
    temp1.w = float1(-1);
    // mad r0.x, r0.x, c66.x, -r1.w
    temp0.x = temp0.x * Draw.SpeedMultiplier.x + -temp1.w;
    // min r3.x, r0.x, c39.x
    temp3.x = min(temp0.x, expr39.x);
    // if b0
    if (Error ConstBool0Error) {
        // frc r5.xy, r3.yxzw
        temp5.xy = frac(temp3.yx);
        // add r6.xz, r3.yyxw, -r5.xyyw
        temp6.xz = temp3.yx + -temp5.xy;
        // mov r6.y, c45.x
        temp6.y = expr45.x;
        // add r5.yz, r2, r6.xxyw
        temp5.yz = temp2.yz + temp6.xy;
        // mul o1.xy, r5.yzzw, c46.x
        o.texcoord = temp5.yzzw * expr46.x;
        // mov r6.w, c48.x
        temp6.w = expr48.x;
        // add r5.yz, r2, r6.xzww
        temp5.yz = temp2.yz + temp6.zw;
        // mul o5.xy, r5.yzzw, c46.x
        o.texcoord3.xy = temp5.yz * expr46.xx;
        // mov o5.z, r5.x
        o.texcoord3.z = temp5.x;
        // else
    } else {
        // mul r1.w, r2.x, c57.x
        temp1.w = temp2.x * Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.x;
        // frc r2.x, r1.w
        temp2.x = frac(temp1.w);
        // add r2.w, r1.w, -r2.x
        temp2.w = temp1.w + -temp2.x;
        // slt r1.w, r1.w, -r1.w
        temp1.w = (temp1.w < -temp1.w) ? 1 : 0;
        // slt r2.x, -r2.x, r2.x
        temp2.x = (-temp2.x < temp2.x) ? 1 : 0;
        // mad r3.w, r1.w, r2.x, r2.w
        temp3.w = temp1.w * temp2.x + temp2.w;
        // if b1
        if (Error ConstBool1Error) {
            // mad r1.w, v2.x, c32.z, c32.w
            temp1.w = i.texcoord1.x * float1(0.1875) + float1(4.8125);
            // frc r1.w, r1.w
            temp1.w = frac(temp1.w);
            // mul r1.w, r1.w, c28.z
            temp1.w = temp1.w * float1(16);
            // frc r2.x, r1.w
            temp2.x = frac(temp1.w);
            // add r1.w, r1.w, -r2.x
            temp1.w = temp1.w + -temp2.x;
            // mova a0.x, r1.w
            addr0.x = temp1.w;
            // mov r2.x, c57.x
            temp2.x = Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.x;
            // mul r1.w, r2.x, c11[a0.x].x
            temp1.w = temp2.x * float1(0.957897);
            // frc r2.x, r1.w
            temp2.x = frac(temp1.w);
            // add r2.w, r1.w, -r2.x
            temp2.w = temp1.w + -temp2.x;
            // slt r1.w, r1.w, -r1.w
            temp1.w = (temp1.w < -temp1.w) ? 1 : 0;
            // slt r2.x, -r2.x, r2.x
            temp2.x = (-temp2.x < temp2.x) ? 1 : 0;
            // mad r3.z, r1.w, r2.x, r2.w
            temp3.z = temp1.w * temp2.x + temp2.w;
            // add r2.xw, r2.yyzz, r3.zyzw
            temp2.xw = temp2.yz + temp3.zw;
            // mul r2.xw, r2, c50.x
            temp2.xw = temp2.xw * expr50.xx;
            // mov o5.z, c27.z
            o.texcoord3.z = float1(0);
            // mov o5.xy, r2.xwzw
            o.texcoord3.xy = temp2.xw;
            // mov o1.xy, r2.xwzw
            o.texcoord = temp2.xwzw;
            // else
        } else {
            // if b2
            if (Error ConstBool2Error) {
                // frc r5.z, r3.y
                temp5.z = frac(temp3.y);
                // mov r5.w, c27.z
                temp5.w = float1(0);
                // add r2.xw, r3.yyzw, -r5.zyzw
                temp2.xw = temp3.yw + -temp5.zw;
                // add r2.xw, r2.yyzz, r2
                temp2.xw = temp2.yz + temp2.xw;
                // mul o1.xy, r2.xwzw, c54.x
                o.texcoord = temp2.xwzw * expr54.x;
                // frc r2.x, r3.x
                temp2.x = frac(temp3.x);
                // mov r2.w, c27.z
                temp2.w = float1(0);
                // add r2.xw, r3, -r2
                temp2.xw = temp3.xw + -temp2.xw;
                // add r2.xw, r2.yyzz, r2
                temp2.xw = temp2.yz + temp2.xw;
                // mul r5.xy, r2.xwzw, c54.x
                temp5.xy = temp2.xw * expr54.xx;
                // mov o5.xyz, r5
                o.texcoord3 = temp5;
                // else
            } else {
                // mul r1.w, r0.w, c55.x
                temp1.w = temp0.w * expr55.x;
                // frc r2.x, r1_abs.w
                temp2.x = frac(abs(temp1).w);
                // sge r1.w, r1.w, -r1.w
                temp1.w = (temp1.w >= -temp1.w) ? 1 : 0;
                // lrp r3.x, r1.w, r2.x, -r2.x
                temp3.x = lerp(-temp2.x, temp2.x, temp1.w);
                // mul r1.w, r3.x, c57.y
                temp1.w = temp3.x * Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.y;
                // mul r2.w, r1.w, c56.x
                temp2.w = temp1.w * expr56.x;
                // frc r1.w, r2_abs.w
                temp1.w = frac(abs(temp2).w);
                // sge r3.x, r2.w, -r2.w
                temp3.x = (temp2.w >= -temp2.w) ? 1 : 0;
                // lrp r5.x, r3.x, r1.w, -r1.w
                temp5.x = lerp(-temp1.w, temp1.w, temp3.x);
                // mul r2.x, r5.x, c57.x
                temp2.x = temp5.x * Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.x;
                // frc r3.xy, r2.xwzw
                temp3.xy = frac(temp2.xw);
                // add r2.xw, r2, -r3.xyzy
                temp2.xw = temp2.xw + -temp3.xy;
                // add r2.xw, r2.yyzz, r2
                temp2.xw = temp2.yz + temp2.xw;
                // mul o1.xy, r2.xwzw, c56.x
                o.texcoord = temp2.xwzw * expr56.x;
                // mul r0.x, r0.x, c55.x
                temp0.x = temp0.x * expr55.x;
                // frc r1.w, r0_abs.x
                temp1.w = frac(abs(temp0).x);
                // sge r0.x, r0.x, -r0.x
                temp0.x = (temp0.x >= -temp0.x) ? 1 : 0;
                // lrp r2.x, r0.x, r1.w, -r1.w
                temp2.x = lerp(-temp1.w, temp1.w, temp0.x);
                // mul r0.x, r2.x, c57.y
                temp0.x = temp2.x * Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.y;
                // mul r2.w, r0.x, c56.x
                temp2.w = temp0.x * expr56.x;
                // frc r0.x, r2_abs.w
                temp0.x = frac(abs(temp2).w);
                // sge r1.w, r2.w, -r2.w
                temp1.w = (temp2.w >= -temp2.w) ? 1 : 0;
                // lrp r3.x, r1.w, r0.x, -r0.x
                temp3.x = lerp(-temp0.x, temp0.x, temp1.w);
                // mul r2.x, r3.x, c57.x
                temp2.x = temp3.x * Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.x;
                // frc r3.xy, r2.xwzw
                temp3.xy = frac(temp2.xw);
                // add r2.xw, r2, -r3.xyzy
                temp2.xw = temp2.xw + -temp3.xy;
                // add r2.xy, r2.yzzw, r2.xwzw
                temp2.xy = temp2.yz + temp2.xw;
                // mul o5.xy, r2, c56.x
                o.texcoord3.xy = temp2.xy * expr56.xx;
                // frc o5.z, r0.w
                o.texcoord3.z = frac(temp0.w);
                // endif
            }
            // endif
        }
        // endif
    }
    // mov r2, c58
    temp2 = Draw.ColorAnimationFunctions[0];
    // mad r2, r2, r0.z, c59
    temp2 = temp2 * temp0.z + Draw.ColorAnimationFunctions[1];
    // slt r0.xw, r0.z, c64.yyzz
    temp0.xw = (temp0.zz < Draw.TimeKeys.yz) ? 1 : 0;
    // mov r3, c60
    temp3 = Draw.ColorAnimationFunctions[2];
    // mad r3, r3, r0.z, c61
    temp3 = temp3 * temp0.z + Draw.ColorAnimationFunctions[3];
    // mov r5, c62
    temp5 = Draw.ColorAnimationFunctions[4];
    // mad r5, r5, r0.z, c63
    temp5 = temp5 * temp0.z + Draw.ColorAnimationFunctions[5];
    // lrp r6, r0.w, r3, r5
    temp6 = lerp(temp5, temp3, temp0.w);
    // lrp r3, r0.x, r2, r6
    temp3 = lerp(temp6, temp2, temp0.x);
    // mad r0.x, v2.x, c33.z, c33.w
    temp0.x = i.texcoord1.x * float1(0.1875) + float1(2.75);
    // frc r0.x, r0.x
    temp0.x = frac(temp0.x);
    // mul r0.x, r0.x, c28.z
    temp0.x = temp0.x * float1(16);
    // frc r0.z, r0.x
    temp0.z = frac(temp0.x);
    // add r0.x, r0.x, -r0.z
    temp0.x = temp0.x + -temp0.z;
    // mova a0.x, r0.x
    addr0.x = temp0.x;
    // mov r2.xy, c67
    temp2.xy = Draw.ColorScaleRange.xy;
    // mad r0.x, c11[a0.x].x, r2.y, r2.x
    temp0.x = float1(0.957897) * temp2.y + temp2.x;
    // mul o2, r3, r0.x
    o.color = temp3 * temp0.x;
    // mov o0, r4
    o.position = temp4;
    // mov o3.xyz, -c28.w
    o.texcoord1 = float4(1, 1, 1, 1);
    // mov o6, r4
    o.texcoord4 = temp4;
    // mov o7.y, r0.y
    o.texcoord5.y = temp0.y;
    // mov o8.xyz, r1
    o.texcoord6 = temp1;
    // 

    return o;
}

technique Default
{
    pass P0 <string ExpressionEvaluator = "Particle";>
    {
        VertexShader = compile vs_3_0 Default_VertexShader26(); // 55
        PixelShader = PS_Array_H[Default_Expression25()]; // 56
        ZEnable = 1;
        ZFunc = 4;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 1;
        AlphaFunc = 7;
        AlphaRef = 96;
    }
}

technique Default_M
{
    pass P0 <string ExpressionEvaluator = "Particle";>
    {
        VertexShader = compile vs_2_0 Default_M_VertexShader24(); // 61
        PixelShader = PS_Array_M[Default_M_Expression23()]; // 62
        ZEnable = 1;
        ZFunc = 4;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 1;
        AlphaFunc = 7;
        AlphaRef = 96;
    }
}

technique Default_L
{
    pass P0 <string ExpressionEvaluator = "Particle";>
    {
        VertexShader = compile vs_2_0 Default_L_VertexShader22(); // 64
        PixelShader = compile ps_2_0 Default_L_PixelShader21(); // 65
        ZEnable = 1;
        ZFunc = 4;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 1;
        AlphaFunc = 7;
        AlphaRef = 96;
    }
}

technique _CreateShadowMap
{
    pass P0 <string ExpressionEvaluator = "GPUParticle_CreateShadowMap";>
    {
        VertexShader = compile vs_2_0 _CreateShadowMap_VertexShader20(); // 73
        PixelShader = PSCreateShadowMap_Array[_CreateShadowMap_Expression19()]; // 74
        ZEnable = 1;
        ZFunc = 4;
        ZWriteEnable = 1;
        CullMode = 1;
        AlphaBlendEnable = 0;
        AlphaTestEnable = 0;
    }
}

