string DefaultParameterScopeBlock = "material"; // 1
float3 AmbientLightColor <bool unmanaged = 1;> = { 0.3, 0.3, 0.3 };
struct {
    float3 Color;
    float3 Direction;
} DirectionalLight[3] <bool unmanaged = 1;> = { 1.625198, 1.512711, 1.097048, 0.62914, -0.34874, 0.69465, 0.5232916, 0.6654605, 0.7815244, -0.32877, 0.90329, 0.27563, 0.4420466, 0.4102767, 0.4420466, -0.80704, -0.58635, 0.06975 };
struct {
    float3 Color;
    float3 Position;
    float2 Range_Inner_Outer;
} PointLight[8] <bool unmanaged = 1;>;
struct {
    float4 WorldPositionMultiplier_XYZZ;
    float2 CurrentOffsetUV;
} Cloud <bool unmanaged = 1;>;
float3 NoCloudMultiplier <bool unmanaged = 1;> = { 1, 1, 1 };
float3 RecolorColorDummy <bool unmanaged = 1;>;
row_major float4x4 ShadowMapWorldToShadow <bool unmanaged = 1;>;
float OpacityOverride <bool unmanaged = 1;> = { 1 };
float3 TintColor <bool unmanaged = 1;> = { 1, 1, 1 };
float3 EyePosition <bool unmanaged = 1;>;
row_major float4x4 ViewProjection <bool unmanaged = 1;>;
float4 WorldBones[128] <bool unmanaged = 1;>;
column_major float4x4 Projection : Projection : register(vs_2_0, c11);
float Time : Time;
texture Texture0 <string UIWidget = "None"; string SasBindAddress = "WW3D.MiscTexture";>; // 2
sampler2D Texture0Sampler : register(ps_2_0, s0) <string Texture = "Texture0"; string UIWidget = "None"; string SasBindAddress = "WW3D.MiscTexture";> =
sampler_state
{
    Texture = <Texture0>; // 5
    MinFilter = 2;
    MagFilter = 2;
    MipFilter = 2;
    AddressU = 1;
    AddressV = 1;
};
texture Texture1 <string UIWidget = "None"; string SasBindAddress = "WW3D.FXDistortionFractal";>; // 9
sampler2D Texture1Sampler : register(ps_2_0, s1) <string Texture = "Texture1"; string UIWidget = "None"; string SasBindAddress = "WW3D.FXDistortionFractal";> =
sampler_state
{
    Texture = <Texture1>; // 12
    MinFilter = 2;
    MagFilter = 2;
    MipFilter = 2;
    AddressU = 1;
    AddressV = 1;
};
int BlendMode <string UIName = "Blend mode"; int UIMin = 0; int UIMax = 6;>;
// PSCreateShadowMap_Array_Shader_0 Pixel_2_0 Has PRES False
struct PSCreateShadowMap_Array_Shader_0_Input
{
    float4 color : COLOR;
    float2 texcoord : TEXCOORD;
    float texcoord1 : TEXCOORD1;
};

float4 PSCreateShadowMap_Array_Shader_0(PSCreateShadowMap_Array_Shader_0_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    // def c0, -0.3529412, 0, 0, 0
    // dcl v0
    // dcl t0.xy
    // dcl t1.x
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(Texture0Sampler, i.texcoord.xy);
    // mad r0, v0.w, r0.w, c0.x
    temp0 = i.color.w * temp0.w + float4(-0.3529412, -0.3529412, -0.3529412, -0.3529412);
    // texkill r0
    clip(temp0);
    // mov r0, t1.x
    temp0 = i.texcoord1.x;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// PSCreateShadowMap_Array_Shader_1 Pixel_2_0 Has PRES False
struct PSCreateShadowMap_Array_Shader_1_Input
{
    float3 color : COLOR;
    float2 texcoord : TEXCOORD;
    float texcoord1 : TEXCOORD1;
};

float4 PSCreateShadowMap_Array_Shader_1(PSCreateShadowMap_Array_Shader_1_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    // def c0, 1, -2.352941, 0, 0
    // dcl v0.xyz
    // dcl t0.xy
    // dcl t1.x
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(Texture0Sampler, i.texcoord.xy);
    // mul r0.xyz, r0, v0
    temp0.xyz = temp0.xyz * i.color.xyz;
    // dp3 r0.x, r0, c0.x
    temp0.x = dot(temp0.xyz, float3(1, 1, 1));
    // add r0, r0.x, c0.y
    temp0 = temp0.x + float4(-2.3529413, -2.3529413, -2.3529413, -2.3529413);
    // texkill r0
    clip(temp0);
    // mov r0, t1.x
    temp0 = i.texcoord1.x;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// PSCreateShadowMap_Array_Shader_2 Pixel_2_0 Has PRES False
struct PSCreateShadowMap_Array_Shader_2_Input
{
    float4 color : COLOR;
    float2 texcoord : TEXCOORD;
    float texcoord1 : TEXCOORD1;
};

float4 PSCreateShadowMap_Array_Shader_2(PSCreateShadowMap_Array_Shader_2_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    // def c0, -0.3529412, 0, 0, 0
    // dcl v0
    // dcl t0.xy
    // dcl t1.x
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(Texture0Sampler, i.texcoord.xy);
    // mad r0, v0.w, r0.w, c0.x
    temp0 = i.color.w * temp0.w + float4(-0.3529412, -0.3529412, -0.3529412, -0.3529412);
    // texkill r0
    clip(temp0);
    // mov r0, t1.x
    temp0 = i.texcoord1.x;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// PSCreateShadowMap_Array_Shader_3 Pixel_2_0 Has PRES False
struct PSCreateShadowMap_Array_Shader_3_Input
{
    float4 color : COLOR;
    float2 texcoord : TEXCOORD;
    float texcoord1 : TEXCOORD1;
};

float4 PSCreateShadowMap_Array_Shader_3(PSCreateShadowMap_Array_Shader_3_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    // def c0, -0.3529412, 0, 0, 0
    // dcl v0
    // dcl t0.xy
    // dcl t1.x
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(Texture0Sampler, i.texcoord.xy);
    // mad r0, v0.w, r0.w, c0.x
    temp0 = i.color.w * temp0.w + float4(-0.3529412, -0.3529412, -0.3529412, -0.3529412);
    // texkill r0
    clip(temp0);
    // mov r0, t1.x
    temp0 = i.texcoord1.x;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// PSCreateShadowMap_Array_Shader_4 Pixel_2_0 Has PRES False
struct PSCreateShadowMap_Array_Shader_4_Input
{
    float3 color : COLOR;
    float2 texcoord : TEXCOORD;
    float texcoord1 : TEXCOORD1;
};

float4 PSCreateShadowMap_Array_Shader_4(PSCreateShadowMap_Array_Shader_4_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    // def c0, 1, -2.352941, 0, 0
    // dcl v0.xyz
    // dcl t0.xy
    // dcl t1.x
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(Texture0Sampler, i.texcoord.xy);
    // mul r0.xyz, r0, v0
    temp0.xyz = temp0.xyz * i.color.xyz;
    // dp3 r0.x, r0, c0.x
    temp0.x = dot(temp0.xyz, float3(1, 1, 1));
    // add r0, r0.x, c0.y
    temp0 = temp0.x + float4(-2.3529413, -2.3529413, -2.3529413, -2.3529413);
    // texkill r0
    clip(temp0);
    // mov r0, t1.x
    temp0 = i.texcoord1.x;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// PSCreateShadowMap_Array_Shader_5 Pixel_2_0 Has PRES False
struct PSCreateShadowMap_Array_Shader_5_Input
{
    float3 color : COLOR;
    float2 texcoord : TEXCOORD;
    float texcoord1 : TEXCOORD1;
};

float4 PSCreateShadowMap_Array_Shader_5(PSCreateShadowMap_Array_Shader_5_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    // def c0, 1, -2.352941, 0, 0
    // dcl v0.xyz
    // dcl t0.xy
    // dcl t1.x
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(Texture0Sampler, i.texcoord.xy);
    // mul r0.xyz, r0, v0
    temp0.xyz = temp0.xyz * i.color.xyz;
    // dp3 r0.x, r0, c0.x
    temp0.x = dot(temp0.xyz, float3(1, 1, 1));
    // add r0, r0.x, c0.y
    temp0 = temp0.x + float4(-2.3529413, -2.3529413, -2.3529413, -2.3529413);
    // texkill r0
    clip(temp0);
    // mov r0, t1.x
    temp0 = i.texcoord1.x;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// PSCreateShadowMap_Array_Shader_6 Pixel_2_0 Has PRES False
struct PSCreateShadowMap_Array_Shader_6_Input
{
    float4 color : COLOR;
    float2 texcoord : TEXCOORD;
    float texcoord1 : TEXCOORD1;
};

float4 PSCreateShadowMap_Array_Shader_6(PSCreateShadowMap_Array_Shader_6_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    // def c0, -0.3529412, 0, 0, 0
    // dcl v0
    // dcl t0.xy
    // dcl t1.x
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(Texture0Sampler, i.texcoord.xy);
    // mad r0, v0.w, r0.w, c0.x
    temp0 = i.color.w * temp0.w + float4(-0.3529412, -0.3529412, -0.3529412, -0.3529412);
    // texkill r0
    clip(temp0);
    // mov r0, t1.x
    temp0 = i.texcoord1.x;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

PixelShader PSCreateShadowMap_Array[7] = {
    compile ps_2_0 PSCreateShadowMap_Array_Shader_0(), // 45
    compile ps_2_0 PSCreateShadowMap_Array_Shader_1(), // 46
    compile ps_2_0 PSCreateShadowMap_Array_Shader_2(), // 47
    compile ps_2_0 PSCreateShadowMap_Array_Shader_3(), // 48
    compile ps_2_0 PSCreateShadowMap_Array_Shader_4(), // 49
    compile ps_2_0 PSCreateShadowMap_Array_Shader_5(), // 50
    compile ps_2_0 PSCreateShadowMap_Array_Shader_6(), // 51
};
// _CreateShadowMap_Expression8 Expression_2_0 Has PRES False
float _CreateShadowMap_Expression8()
{
    float1 expr0;
    // mov c0.x, c0.x
    expr0.x = BlendMode.x;
    return expr0;
}

// _CreateShadowMap_VertexShader9 Vertex_2_0 Has PRES False
struct _CreateShadowMap_VertexShader9_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct _CreateShadowMap_VertexShader9_Output
{
    float4 position : POSITION;
    float texcoord1 : TEXCOORD1;
    float4 color : COLOR;
    float2 texcoord : TEXCOORD;
};

_CreateShadowMap_VertexShader9_Output _CreateShadowMap_VertexShader9(_CreateShadowMap_VertexShader9_Input i)
{
    _CreateShadowMap_VertexShader9_Output o;
    float4 temp0;
    float2 temp1;
    // def c0, 1, 0, 0, 0
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_color v2
    // mad r0, v0.xyzx, c0.xxxy, c0.yyyx
    temp0 = i.position.xyzx * float4(1, 1, 1, 0) + float4(0, 0, 0, 1);
    // dp4 oPos.x, r0, c11
    o.position.x = dot(temp0, (Projection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c12
    o.position.y = dot(temp0, (Projection._m01_m11_m21_m31));
    // dp4 r1.y, r0, c14
    temp1.y = dot(temp0, (Projection._m03_m13_m23_m33));
    // dp4 r1.x, r0, c13
    temp1.x = dot(temp0, (Projection._m02_m12_m22_m32));
    // rcp r0.x, r1.y
    temp0.x = 1.0f / temp1.y;
    // mov oPos.zw, r1.xyxy
    o.position.zw = temp1.xy;
    // mul oT1.x, r1.x, r0.x
    o.texcoord1 = temp1.x * temp0.x;
    // mov oD0, v2
    o.color = i.color;
    // mov oT0.xy, v1
    o.texcoord = i.texcoord;
    // 

    return o;
}

// AlphaNoDepthTest_M_PixelShader10 Pixel_2_0 Has PRES False
struct AlphaNoDepthTest_M_PixelShader10_Input
{
    float2 texcoord : TEXCOORD;
    float4 texcoord1 : TEXCOORD1;
};

float4 AlphaNoDepthTest_M_PixelShader10(AlphaNoDepthTest_M_PixelShader10_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    // dcl t0.xy
    // dcl t1
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(Texture0Sampler, i.texcoord.xy);
    // mul r0, r0, t1
    temp0 = temp0 * i.texcoord1;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// AlphaNoDepthTest_M_VertexShader11 Vertex_2_0 Has PRES False
struct AlphaNoDepthTest_M_VertexShader11_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct AlphaNoDepthTest_M_VertexShader11_Output
{
    float4 position : POSITION;
    float2 texcoord : TEXCOORD;
    float4 texcoord1 : TEXCOORD1;
};

AlphaNoDepthTest_M_VertexShader11_Output AlphaNoDepthTest_M_VertexShader11(AlphaNoDepthTest_M_VertexShader11_Input i)
{
    AlphaNoDepthTest_M_VertexShader11_Output o;
    float4 temp0;
    // def c0, 1, 0, 0, 0
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_color v2
    // mad r0, v0.xyzx, c0.xxxy, c0.yyyx
    temp0 = i.position.xyzx * float4(1, 1, 1, 0) + float4(0, 0, 0, 1);
    // dp4 oPos.x, r0, c11
    o.position.x = dot(temp0, (Projection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c12
    o.position.y = dot(temp0, (Projection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c13
    o.position.z = dot(temp0, (Projection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c14
    o.position.w = dot(temp0, (Projection._m03_m13_m23_m33));
    // mov oT0.xy, v1
    o.texcoord = i.texcoord;
    // mov oT1, v2
    o.texcoord1 = i.color;
    // 

    return o;
}

// AdditiveNoDepthTest_M_PixelShader12 Pixel_2_0 Has PRES False
struct AdditiveNoDepthTest_M_PixelShader12_Input
{
    float2 texcoord : TEXCOORD;
    float4 texcoord1 : TEXCOORD1;
};

float4 AdditiveNoDepthTest_M_PixelShader12(AdditiveNoDepthTest_M_PixelShader12_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    // dcl t0.xy
    // dcl t1
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(Texture0Sampler, i.texcoord.xy);
    // mul r0, r0, t1
    temp0 = temp0 * i.texcoord1;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// AdditiveNoDepthTest_M_VertexShader13 Vertex_2_0 Has PRES False
struct AdditiveNoDepthTest_M_VertexShader13_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct AdditiveNoDepthTest_M_VertexShader13_Output
{
    float4 position : POSITION;
    float2 texcoord : TEXCOORD;
    float4 texcoord1 : TEXCOORD1;
};

AdditiveNoDepthTest_M_VertexShader13_Output AdditiveNoDepthTest_M_VertexShader13(AdditiveNoDepthTest_M_VertexShader13_Input i)
{
    AdditiveNoDepthTest_M_VertexShader13_Output o;
    float4 temp0;
    // def c0, 1, 0, 0, 0
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_color v2
    // mad r0, v0.xyzx, c0.xxxy, c0.yyyx
    temp0 = i.position.xyzx * float4(1, 1, 1, 0) + float4(0, 0, 0, 1);
    // dp4 oPos.x, r0, c11
    o.position.x = dot(temp0, (Projection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c12
    o.position.y = dot(temp0, (Projection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c13
    o.position.z = dot(temp0, (Projection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c14
    o.position.w = dot(temp0, (Projection._m03_m13_m23_m33));
    // mov oT0.xy, v1
    o.texcoord = i.texcoord;
    // mov oT1, v2
    o.texcoord1 = i.color;
    // 

    return o;
}

// Multiplicative_M_PixelShader14 Pixel_2_0 Has PRES False
struct Multiplicative_M_PixelShader14_Input
{
    float2 texcoord : TEXCOORD;
    float4 texcoord1 : TEXCOORD1;
};

float4 Multiplicative_M_PixelShader14(Multiplicative_M_PixelShader14_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    // dcl t0.xy
    // dcl t1
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(Texture0Sampler, i.texcoord.xy);
    // mul r0, r0, t1
    temp0 = temp0 * i.texcoord1;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// Multiplicative_M_VertexShader15 Vertex_2_0 Has PRES False
struct Multiplicative_M_VertexShader15_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct Multiplicative_M_VertexShader15_Output
{
    float4 position : POSITION;
    float2 texcoord : TEXCOORD;
    float4 texcoord1 : TEXCOORD1;
};

Multiplicative_M_VertexShader15_Output Multiplicative_M_VertexShader15(Multiplicative_M_VertexShader15_Input i)
{
    Multiplicative_M_VertexShader15_Output o;
    float4 temp0;
    // def c0, 1, 0, 0, 0
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_color v2
    // mad r0, v0.xyzx, c0.xxxy, c0.yyyx
    temp0 = i.position.xyzx * float4(1, 1, 1, 0) + float4(0, 0, 0, 1);
    // dp4 oPos.x, r0, c11
    o.position.x = dot(temp0, (Projection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c12
    o.position.y = dot(temp0, (Projection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c13
    o.position.z = dot(temp0, (Projection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c14
    o.position.w = dot(temp0, (Projection._m03_m13_m23_m33));
    // mov oT0.xy, v1
    o.texcoord = i.texcoord;
    // mov oT1, v2
    o.texcoord1 = i.color;
    // 

    return o;
}

// AlphaTest_M_PixelShader16 Pixel_2_0 Has PRES False
struct AlphaTest_M_PixelShader16_Input
{
    float2 texcoord : TEXCOORD;
    float4 texcoord1 : TEXCOORD1;
};

float4 AlphaTest_M_PixelShader16(AlphaTest_M_PixelShader16_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    // dcl t0.xy
    // dcl t1
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(Texture0Sampler, i.texcoord.xy);
    // mul r0, r0, t1
    temp0 = temp0 * i.texcoord1;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// AlphaTest_M_VertexShader17 Vertex_2_0 Has PRES False
struct AlphaTest_M_VertexShader17_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct AlphaTest_M_VertexShader17_Output
{
    float4 position : POSITION;
    float2 texcoord : TEXCOORD;
    float4 texcoord1 : TEXCOORD1;
};

AlphaTest_M_VertexShader17_Output AlphaTest_M_VertexShader17(AlphaTest_M_VertexShader17_Input i)
{
    AlphaTest_M_VertexShader17_Output o;
    float4 temp0;
    // def c0, 1, 0, 0, 0
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_color v2
    // mad r0, v0.xyzx, c0.xxxy, c0.yyyx
    temp0 = i.position.xyzx * float4(1, 1, 1, 0) + float4(0, 0, 0, 1);
    // dp4 oPos.x, r0, c11
    o.position.x = dot(temp0, (Projection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c12
    o.position.y = dot(temp0, (Projection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c13
    o.position.z = dot(temp0, (Projection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c14
    o.position.w = dot(temp0, (Projection._m03_m13_m23_m33));
    // mov oT0.xy, v1
    o.texcoord = i.texcoord;
    // mov oT1, v2
    o.texcoord1 = i.color;
    // 

    return o;
}

// AdditiveAlphaTest_M_PixelShader18 Pixel_2_0 Has PRES False
struct AdditiveAlphaTest_M_PixelShader18_Input
{
    float2 texcoord : TEXCOORD;
    float4 texcoord1 : TEXCOORD1;
    float4 texcoord2 : TEXCOORD2;
};

float4 AdditiveAlphaTest_M_PixelShader18(AdditiveAlphaTest_M_PixelShader18_Input i) : COLOR
{
    float4 out_color;
    float4 temp0, temp1;
    // def c0, -1, 0.01, 0, 0
    // dcl t0.xy
    // dcl t1
    // dcl t2
    // dcl_2d s0
    // dcl_2d s1
    // mov r0.x, t1.z
    temp0.x = i.texcoord1.z;
    // mov r0.y, t1.w
    temp0.y = i.texcoord1.w;
    // texld r0, r0, s1
    temp0 = tex2D(Texture1Sampler, temp0.xy);
    // texld r1, t1, s1
    temp1 = tex2D(Texture1Sampler, i.texcoord1.xy);
    // add r0.xy, r0, r1
    temp0.xy = temp0.xy + temp1.xy;
    // add r0.xy, r0, c0.x
    temp0.xy = temp0.xy + float2(-1, -1);
    // mad r0.xy, r0, c0.y, t0
    temp0.xy = temp0.xy * float2(0.01, 0.01) + i.texcoord.xy;
    // texld r0, r0, s0
    temp0 = tex2D(Texture0Sampler, temp0.xy);
    // mul r0, r0, t2
    temp0 = temp0 * i.texcoord2;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// AdditiveAlphaTest_M_VertexShader19 Vertex_2_0 Has PRES True
struct AdditiveAlphaTest_M_VertexShader19_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct AdditiveAlphaTest_M_VertexShader19_Output
{
    float4 texcoord1 : TEXCOORD1;
    float4 position : POSITION;
    float2 texcoord : TEXCOORD;
    float4 texcoord2 : TEXCOORD2;
};

AdditiveAlphaTest_M_VertexShader19_Output AdditiveAlphaTest_M_VertexShader19(AdditiveAlphaTest_M_VertexShader19_Input i)
{
    /*
    PRSI
      OutputRegisterOffset: 15
      Unknown1: 0
      Unknown2: 0
      OutputRegisterCount: 2
      Unknown3: 0
      Unknown4: 0
      Unknown5: 15
      Unknown6: 2
      Mappings: 1
        0 - ConstOutput: 0 ConstInput 0
    
    */
    float4 expr15;
    float4 expr16;
    {
        // Expression_2_1
        // mul c15.x, c0.x, (0.03)
        expr15.x = Time.x * (0.03);
        // mul c16.x, c0.x, (0.06)
        expr16.x = Time.x * (0.06);
    }

    AdditiveAlphaTest_M_VertexShader19_Output o;
    float4 temp0;
    // def c0, 0.07071161, 0.001325808, -0.07070975, 0.0006629213
    // def c1, 0.001325843, 0.0353558, -0.0006629039, 0.03535488
    // def c2, 1, 0, 0.00625, 0
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_color v2
    // mul r0.xy, v1, c0
    temp0.xy = i.texcoord.xy * float2(0.070711605, 0.0013258078);
    // add r0.x, r0.y, r0.x
    temp0.x = temp0.y + temp0.x;
    // add oT1.x, r0.x, c15.x
    o.texcoord1.x = temp0.x + expr15.x;
    // mul r0, v1.yxyx, c1
    temp0 = i.texcoord.yxyx * float4(0.0013258426, 0.035355803, -0.0006629039, 0.035354875);
    // mad oT1.yw, v1.xxzy, c0.xzzw, r0.xxzw
    o.texcoord1.yw = i.texcoord.xy * float2(-0.07070975, 0.0006629213) + temp0.xw;
    // add r0.x, r0.z, r0.y
    temp0.x = temp0.z + temp0.y;
    // add oT1.z, r0.x, c16.x
    o.texcoord1.z = temp0.x + expr16.x;
    // mad r0, v0.xyzx, c2.xxxy, c2.yyyx
    temp0 = i.position.xyzx * float4(1, 1, 1, 0) + float4(0, 0, 0, 1);
    // dp4 oPos.x, r0, c11
    o.position.x = dot(temp0, (Projection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c12
    o.position.y = dot(temp0, (Projection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c13
    o.position.z = dot(temp0, (Projection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c14
    o.position.w = dot(temp0, (Projection._m03_m13_m23_m33));
    // mul oT0.xy, v1, c2.xzzw
    o.texcoord = i.texcoord * float4(1, 0.00625, 0.00625, 0);
    // mov oT2, v2
    o.texcoord2 = i.color;
    // 

    return o;
}

// Additive_M_PixelShader20 Pixel_2_0 Has PRES False
struct Additive_M_PixelShader20_Input
{
    float2 texcoord : TEXCOORD;
    float4 texcoord1 : TEXCOORD1;
};

float4 Additive_M_PixelShader20(Additive_M_PixelShader20_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    // dcl t0.xy
    // dcl t1
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(Texture0Sampler, i.texcoord.xy);
    // mul r0, r0, t1
    temp0 = temp0 * i.texcoord1;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// Additive_M_VertexShader21 Vertex_2_0 Has PRES False
struct Additive_M_VertexShader21_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct Additive_M_VertexShader21_Output
{
    float4 position : POSITION;
    float2 texcoord : TEXCOORD;
    float4 texcoord1 : TEXCOORD1;
};

Additive_M_VertexShader21_Output Additive_M_VertexShader21(Additive_M_VertexShader21_Input i)
{
    Additive_M_VertexShader21_Output o;
    float4 temp0;
    // def c0, 1, 0, 0, 0
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_color v2
    // mad r0, v0.xyzx, c0.xxxy, c0.yyyx
    temp0 = i.position.xyzx * float4(1, 1, 1, 0) + float4(0, 0, 0, 1);
    // dp4 oPos.x, r0, c11
    o.position.x = dot(temp0, (Projection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c12
    o.position.y = dot(temp0, (Projection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c13
    o.position.z = dot(temp0, (Projection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c14
    o.position.w = dot(temp0, (Projection._m03_m13_m23_m33));
    // mov oT0.xy, v1
    o.texcoord = i.texcoord;
    // mov oT1, v2
    o.texcoord1 = i.color;
    // 

    return o;
}

// Alpha_M_PixelShader22 Pixel_2_0 Has PRES False
struct Alpha_M_PixelShader22_Input
{
    float2 texcoord : TEXCOORD;
    float4 texcoord1 : TEXCOORD1;
};

float4 Alpha_M_PixelShader22(Alpha_M_PixelShader22_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    // dcl t0.xy
    // dcl t1
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(Texture0Sampler, i.texcoord.xy);
    // mul r0, r0, t1
    temp0 = temp0 * i.texcoord1;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// Alpha_M_VertexShader23 Vertex_2_0 Has PRES False
struct Alpha_M_VertexShader23_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct Alpha_M_VertexShader23_Output
{
    float4 position : POSITION;
    float2 texcoord : TEXCOORD;
    float4 texcoord1 : TEXCOORD1;
};

Alpha_M_VertexShader23_Output Alpha_M_VertexShader23(Alpha_M_VertexShader23_Input i)
{
    Alpha_M_VertexShader23_Output o;
    float4 temp0;
    // def c0, 1, 0, 0, 0
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_color v2
    // mad r0, v0.xyzx, c0.xxxy, c0.yyyx
    temp0 = i.position.xyzx * float4(1, 1, 1, 0) + float4(0, 0, 0, 1);
    // dp4 oPos.x, r0, c11
    o.position.x = dot(temp0, (Projection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c12
    o.position.y = dot(temp0, (Projection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c13
    o.position.z = dot(temp0, (Projection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c14
    o.position.w = dot(temp0, (Projection._m03_m13_m23_m33));
    // mov oT0.xy, v1
    o.texcoord = i.texcoord;
    // mov oT1, v2
    o.texcoord1 = i.color;
    // 

    return o;
}

// AlphaNoDepthTest_PixelShader24 Pixel_2_0 Has PRES False
struct AlphaNoDepthTest_PixelShader24_Input
{
    float2 texcoord : TEXCOORD;
    float4 texcoord1 : TEXCOORD1;
};

float4 AlphaNoDepthTest_PixelShader24(AlphaNoDepthTest_PixelShader24_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    float3 temp1;
    // def c0, 2.2, 0, 0, 0
    // dcl t0.xy
    // dcl t1
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(Texture0Sampler, i.texcoord.xy);
    // log r1.x, r0.x
    temp1.x = log2(temp0.x);
    // log r1.y, r0.y
    temp1.y = log2(temp0.y);
    // log r1.z, r0.z
    temp1.z = log2(temp0.z);
    // mul r1.xyz, r1, c0.x
    temp1.xyz = temp1.xyz * float3(2.2, 2.2, 2.2);
    // exp r0.x, r1.x
    temp0.x = exp2(temp1.x);
    // exp r0.y, r1.y
    temp0.y = exp2(temp1.y);
    // exp r0.z, r1.z
    temp0.z = exp2(temp1.z);
    // mul r0, r0, t1
    temp0 = temp0 * i.texcoord1;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// AlphaNoDepthTest_VertexShader25 Vertex_2_0 Has PRES False
struct AlphaNoDepthTest_VertexShader25_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct AlphaNoDepthTest_VertexShader25_Output
{
    float4 position : POSITION;
    float2 texcoord : TEXCOORD;
    float4 texcoord1 : TEXCOORD1;
};

AlphaNoDepthTest_VertexShader25_Output AlphaNoDepthTest_VertexShader25(AlphaNoDepthTest_VertexShader25_Input i)
{
    AlphaNoDepthTest_VertexShader25_Output o;
    float4 temp0;
    // def c0, 1, 0, 0, 0
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_color v2
    // mad r0, v0.xyzx, c0.xxxy, c0.yyyx
    temp0 = i.position.xyzx * float4(1, 1, 1, 0) + float4(0, 0, 0, 1);
    // dp4 oPos.x, r0, c11
    o.position.x = dot(temp0, (Projection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c12
    o.position.y = dot(temp0, (Projection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c13
    o.position.z = dot(temp0, (Projection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c14
    o.position.w = dot(temp0, (Projection._m03_m13_m23_m33));
    // mov oT0.xy, v1
    o.texcoord = i.texcoord;
    // mov oT1, v2
    o.texcoord1 = i.color;
    // 

    return o;
}

// AdditiveNoDepthTest_PixelShader26 Pixel_2_0 Has PRES False
struct AdditiveNoDepthTest_PixelShader26_Input
{
    float2 texcoord : TEXCOORD;
    float4 texcoord1 : TEXCOORD1;
};

float4 AdditiveNoDepthTest_PixelShader26(AdditiveNoDepthTest_PixelShader26_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    float3 temp1;
    // def c0, 2.2, 0, 0, 0
    // dcl t0.xy
    // dcl t1
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(Texture0Sampler, i.texcoord.xy);
    // log r1.x, r0.x
    temp1.x = log2(temp0.x);
    // log r1.y, r0.y
    temp1.y = log2(temp0.y);
    // log r1.z, r0.z
    temp1.z = log2(temp0.z);
    // mul r1.xyz, r1, c0.x
    temp1.xyz = temp1.xyz * float3(2.2, 2.2, 2.2);
    // exp r0.x, r1.x
    temp0.x = exp2(temp1.x);
    // exp r0.y, r1.y
    temp0.y = exp2(temp1.y);
    // exp r0.z, r1.z
    temp0.z = exp2(temp1.z);
    // mul r0, r0, t1
    temp0 = temp0 * i.texcoord1;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// AdditiveNoDepthTest_VertexShader27 Vertex_2_0 Has PRES False
struct AdditiveNoDepthTest_VertexShader27_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct AdditiveNoDepthTest_VertexShader27_Output
{
    float4 position : POSITION;
    float2 texcoord : TEXCOORD;
    float4 texcoord1 : TEXCOORD1;
};

AdditiveNoDepthTest_VertexShader27_Output AdditiveNoDepthTest_VertexShader27(AdditiveNoDepthTest_VertexShader27_Input i)
{
    AdditiveNoDepthTest_VertexShader27_Output o;
    float4 temp0;
    // def c0, 1, 0, 0, 0
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_color v2
    // mad r0, v0.xyzx, c0.xxxy, c0.yyyx
    temp0 = i.position.xyzx * float4(1, 1, 1, 0) + float4(0, 0, 0, 1);
    // dp4 oPos.x, r0, c11
    o.position.x = dot(temp0, (Projection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c12
    o.position.y = dot(temp0, (Projection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c13
    o.position.z = dot(temp0, (Projection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c14
    o.position.w = dot(temp0, (Projection._m03_m13_m23_m33));
    // mov oT0.xy, v1
    o.texcoord = i.texcoord;
    // mov oT1, v2
    o.texcoord1 = i.color;
    // 

    return o;
}

// Multiplicative_PixelShader28 Pixel_2_0 Has PRES False
struct Multiplicative_PixelShader28_Input
{
    float2 texcoord : TEXCOORD;
    float4 texcoord1 : TEXCOORD1;
};

float4 Multiplicative_PixelShader28(Multiplicative_PixelShader28_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    float3 temp1;
    // def c0, 2.2, 0, 0, 0
    // dcl t0.xy
    // dcl t1
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(Texture0Sampler, i.texcoord.xy);
    // log r1.x, r0.x
    temp1.x = log2(temp0.x);
    // log r1.y, r0.y
    temp1.y = log2(temp0.y);
    // log r1.z, r0.z
    temp1.z = log2(temp0.z);
    // mul r1.xyz, r1, c0.x
    temp1.xyz = temp1.xyz * float3(2.2, 2.2, 2.2);
    // exp r0.x, r1.x
    temp0.x = exp2(temp1.x);
    // exp r0.y, r1.y
    temp0.y = exp2(temp1.y);
    // exp r0.z, r1.z
    temp0.z = exp2(temp1.z);
    // mul r0, r0, t1
    temp0 = temp0 * i.texcoord1;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// Multiplicative_VertexShader29 Vertex_2_0 Has PRES False
struct Multiplicative_VertexShader29_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct Multiplicative_VertexShader29_Output
{
    float4 position : POSITION;
    float2 texcoord : TEXCOORD;
    float4 texcoord1 : TEXCOORD1;
};

Multiplicative_VertexShader29_Output Multiplicative_VertexShader29(Multiplicative_VertexShader29_Input i)
{
    Multiplicative_VertexShader29_Output o;
    float4 temp0;
    // def c0, 1, 0, 0, 0
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_color v2
    // mad r0, v0.xyzx, c0.xxxy, c0.yyyx
    temp0 = i.position.xyzx * float4(1, 1, 1, 0) + float4(0, 0, 0, 1);
    // dp4 oPos.x, r0, c11
    o.position.x = dot(temp0, (Projection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c12
    o.position.y = dot(temp0, (Projection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c13
    o.position.z = dot(temp0, (Projection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c14
    o.position.w = dot(temp0, (Projection._m03_m13_m23_m33));
    // mov oT0.xy, v1
    o.texcoord = i.texcoord;
    // mov oT1, v2
    o.texcoord1 = i.color;
    // 

    return o;
}

// AlphaTest_PixelShader30 Pixel_2_0 Has PRES False
struct AlphaTest_PixelShader30_Input
{
    float2 texcoord : TEXCOORD;
    float4 texcoord1 : TEXCOORD1;
};

float4 AlphaTest_PixelShader30(AlphaTest_PixelShader30_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    float3 temp1;
    // def c0, 2.2, 0, 0, 0
    // dcl t0.xy
    // dcl t1
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(Texture0Sampler, i.texcoord.xy);
    // log r1.x, r0.x
    temp1.x = log2(temp0.x);
    // log r1.y, r0.y
    temp1.y = log2(temp0.y);
    // log r1.z, r0.z
    temp1.z = log2(temp0.z);
    // mul r1.xyz, r1, c0.x
    temp1.xyz = temp1.xyz * float3(2.2, 2.2, 2.2);
    // exp r0.x, r1.x
    temp0.x = exp2(temp1.x);
    // exp r0.y, r1.y
    temp0.y = exp2(temp1.y);
    // exp r0.z, r1.z
    temp0.z = exp2(temp1.z);
    // mul r0, r0, t1
    temp0 = temp0 * i.texcoord1;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// AlphaTest_VertexShader31 Vertex_2_0 Has PRES False
struct AlphaTest_VertexShader31_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct AlphaTest_VertexShader31_Output
{
    float4 position : POSITION;
    float2 texcoord : TEXCOORD;
    float4 texcoord1 : TEXCOORD1;
};

AlphaTest_VertexShader31_Output AlphaTest_VertexShader31(AlphaTest_VertexShader31_Input i)
{
    AlphaTest_VertexShader31_Output o;
    float4 temp0;
    // def c0, 1, 0, 0, 0
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_color v2
    // mad r0, v0.xyzx, c0.xxxy, c0.yyyx
    temp0 = i.position.xyzx * float4(1, 1, 1, 0) + float4(0, 0, 0, 1);
    // dp4 oPos.x, r0, c11
    o.position.x = dot(temp0, (Projection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c12
    o.position.y = dot(temp0, (Projection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c13
    o.position.z = dot(temp0, (Projection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c14
    o.position.w = dot(temp0, (Projection._m03_m13_m23_m33));
    // mov oT0.xy, v1
    o.texcoord = i.texcoord;
    // mov oT1, v2
    o.texcoord1 = i.color;
    // 

    return o;
}

// AdditiveAlphaTest_PixelShader32 Pixel_2_0 Has PRES False
struct AdditiveAlphaTest_PixelShader32_Input
{
    float2 texcoord : TEXCOORD;
    float4 texcoord1 : TEXCOORD1;
    float4 texcoord2 : TEXCOORD2;
};

float4 AdditiveAlphaTest_PixelShader32(AdditiveAlphaTest_PixelShader32_Input i) : COLOR
{
    float4 out_color;
    float4 temp0, temp1;
    // def c0, -1, 0.01, 2.2, 0
    // dcl t0.xy
    // dcl t1
    // dcl t2
    // dcl_2d s0
    // dcl_2d s1
    // mov r0.x, t1.z
    temp0.x = i.texcoord1.z;
    // mov r0.y, t1.w
    temp0.y = i.texcoord1.w;
    // texld r0, r0, s1
    temp0 = tex2D(Texture1Sampler, temp0.xy);
    // texld r1, t1, s1
    temp1 = tex2D(Texture1Sampler, i.texcoord1.xy);
    // add r0.xy, r0, r1
    temp0.xy = temp0.xy + temp1.xy;
    // add r0.xy, r0, c0.x
    temp0.xy = temp0.xy + float2(-1, -1);
    // mad r0.xy, r0, c0.y, t0
    temp0.xy = temp0.xy * float2(0.01, 0.01) + i.texcoord.xy;
    // texld r0, r0, s0
    temp0 = tex2D(Texture0Sampler, temp0.xy);
    // log r1.x, r0.x
    temp1.x = log2(temp0.x);
    // log r1.y, r0.y
    temp1.y = log2(temp0.y);
    // log r1.z, r0.z
    temp1.z = log2(temp0.z);
    // mul r1.xyz, r1, c0.z
    temp1.xyz = temp1.xyz * float3(2.2, 2.2, 2.2);
    // exp r0.x, r1.x
    temp0.x = exp2(temp1.x);
    // exp r0.y, r1.y
    temp0.y = exp2(temp1.y);
    // exp r0.z, r1.z
    temp0.z = exp2(temp1.z);
    // mul r0, r0, t2
    temp0 = temp0 * i.texcoord2;
    // add r0, r0, r0
    temp0 = temp0 + temp0;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// AdditiveAlphaTest_VertexShader33 Vertex_2_0 Has PRES True
struct AdditiveAlphaTest_VertexShader33_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct AdditiveAlphaTest_VertexShader33_Output
{
    float4 texcoord1 : TEXCOORD1;
    float4 position : POSITION;
    float2 texcoord : TEXCOORD;
    float4 texcoord2 : TEXCOORD2;
};

AdditiveAlphaTest_VertexShader33_Output AdditiveAlphaTest_VertexShader33(AdditiveAlphaTest_VertexShader33_Input i)
{
    /*
    PRSI
      OutputRegisterOffset: 15
      Unknown1: 0
      Unknown2: 0
      OutputRegisterCount: 2
      Unknown3: 0
      Unknown4: 0
      Unknown5: 15
      Unknown6: 2
      Mappings: 1
        0 - ConstOutput: 0 ConstInput 0
    
    */
    float4 expr15;
    float4 expr16;
    {
        // Expression_2_1
        // mul c15.x, c0.x, (0.03)
        expr15.x = Time.x * (0.03);
        // mul c16.x, c0.x, (0.06)
        expr16.x = Time.x * (0.06);
    }

    AdditiveAlphaTest_VertexShader33_Output o;
    float4 temp0;
    // def c0, 0.07071161, 0.001325808, -0.07070975, 0.0006629213
    // def c1, 0.001325843, 0.0353558, -0.0006629039, 0.03535488
    // def c2, 1, 0, 0.00625, 0
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_color v2
    // mul r0.xy, v1, c0
    temp0.xy = i.texcoord.xy * float2(0.070711605, 0.0013258078);
    // add r0.x, r0.y, r0.x
    temp0.x = temp0.y + temp0.x;
    // add oT1.x, r0.x, c15.x
    o.texcoord1.x = temp0.x + expr15.x;
    // mul r0, v1.yxyx, c1
    temp0 = i.texcoord.yxyx * float4(0.0013258426, 0.035355803, -0.0006629039, 0.035354875);
    // mad oT1.yw, v1.xxzy, c0.xzzw, r0.xxzw
    o.texcoord1.yw = i.texcoord.xy * float2(-0.07070975, 0.0006629213) + temp0.xw;
    // add r0.x, r0.z, r0.y
    temp0.x = temp0.z + temp0.y;
    // add oT1.z, r0.x, c16.x
    o.texcoord1.z = temp0.x + expr16.x;
    // mad r0, v0.xyzx, c2.xxxy, c2.yyyx
    temp0 = i.position.xyzx * float4(1, 1, 1, 0) + float4(0, 0, 0, 1);
    // dp4 oPos.x, r0, c11
    o.position.x = dot(temp0, (Projection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c12
    o.position.y = dot(temp0, (Projection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c13
    o.position.z = dot(temp0, (Projection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c14
    o.position.w = dot(temp0, (Projection._m03_m13_m23_m33));
    // mul oT0.xy, v1, c2.xzzw
    o.texcoord = i.texcoord * float4(1, 0.00625, 0.00625, 0);
    // mov oT2, v2
    o.texcoord2 = i.color;
    // 

    return o;
}

// Additive_PixelShader34 Pixel_2_0 Has PRES False
struct Additive_PixelShader34_Input
{
    float2 texcoord : TEXCOORD;
    float4 texcoord1 : TEXCOORD1;
};

float4 Additive_PixelShader34(Additive_PixelShader34_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    float3 temp1;
    // def c0, 2.2, 0, 0, 0
    // dcl t0.xy
    // dcl t1
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(Texture0Sampler, i.texcoord.xy);
    // log r1.x, r0.x
    temp1.x = log2(temp0.x);
    // log r1.y, r0.y
    temp1.y = log2(temp0.y);
    // log r1.z, r0.z
    temp1.z = log2(temp0.z);
    // mul r1.xyz, r1, c0.x
    temp1.xyz = temp1.xyz * float3(2.2, 2.2, 2.2);
    // exp r0.x, r1.x
    temp0.x = exp2(temp1.x);
    // exp r0.y, r1.y
    temp0.y = exp2(temp1.y);
    // exp r0.z, r1.z
    temp0.z = exp2(temp1.z);
    // mul r0, r0, t1
    temp0 = temp0 * i.texcoord1;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// Additive_VertexShader35 Vertex_2_0 Has PRES False
struct Additive_VertexShader35_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct Additive_VertexShader35_Output
{
    float4 position : POSITION;
    float2 texcoord : TEXCOORD;
    float4 texcoord1 : TEXCOORD1;
};

Additive_VertexShader35_Output Additive_VertexShader35(Additive_VertexShader35_Input i)
{
    Additive_VertexShader35_Output o;
    float4 temp0;
    // def c0, 1, 0, 0, 0
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_color v2
    // mad r0, v0.xyzx, c0.xxxy, c0.yyyx
    temp0 = i.position.xyzx * float4(1, 1, 1, 0) + float4(0, 0, 0, 1);
    // dp4 oPos.x, r0, c11
    o.position.x = dot(temp0, (Projection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c12
    o.position.y = dot(temp0, (Projection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c13
    o.position.z = dot(temp0, (Projection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c14
    o.position.w = dot(temp0, (Projection._m03_m13_m23_m33));
    // mov oT0.xy, v1
    o.texcoord = i.texcoord;
    // mov oT1, v2
    o.texcoord1 = i.color;
    // 

    return o;
}

// Alpha_PixelShader36 Pixel_2_0 Has PRES False
struct Alpha_PixelShader36_Input
{
    float2 texcoord : TEXCOORD;
    float4 texcoord1 : TEXCOORD1;
};

float4 Alpha_PixelShader36(Alpha_PixelShader36_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    float3 temp1;
    // def c0, 2.2, 0, 0, 0
    // dcl t0.xy
    // dcl t1
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(Texture0Sampler, i.texcoord.xy);
    // log r1.x, r0.x
    temp1.x = log2(temp0.x);
    // log r1.y, r0.y
    temp1.y = log2(temp0.y);
    // log r1.z, r0.z
    temp1.z = log2(temp0.z);
    // mul r1.xyz, r1, c0.x
    temp1.xyz = temp1.xyz * float3(2.2, 2.2, 2.2);
    // exp r0.x, r1.x
    temp0.x = exp2(temp1.x);
    // exp r0.y, r1.y
    temp0.y = exp2(temp1.y);
    // exp r0.z, r1.z
    temp0.z = exp2(temp1.z);
    // mul r0, r0, t1
    temp0 = temp0 * i.texcoord1;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// Alpha_VertexShader37 Vertex_2_0 Has PRES False
struct Alpha_VertexShader37_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct Alpha_VertexShader37_Output
{
    float4 position : POSITION;
    float2 texcoord : TEXCOORD;
    float4 texcoord1 : TEXCOORD1;
};

Alpha_VertexShader37_Output Alpha_VertexShader37(Alpha_VertexShader37_Input i)
{
    Alpha_VertexShader37_Output o;
    float4 temp0;
    // def c0, 1, 0, 0, 0
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_color v2
    // mad r0, v0.xyzx, c0.xxxy, c0.yyyx
    temp0 = i.position.xyzx * float4(1, 1, 1, 0) + float4(0, 0, 0, 1);
    // dp4 oPos.x, r0, c11
    o.position.x = dot(temp0, (Projection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c12
    o.position.y = dot(temp0, (Projection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c13
    o.position.z = dot(temp0, (Projection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c14
    o.position.w = dot(temp0, (Projection._m03_m13_m23_m33));
    // mov oT0.xy, v1
    o.texcoord = i.texcoord;
    // mov oT1, v2
    o.texcoord1 = i.color;
    // 

    return o;
}

technique Alpha
{
    pass P0
    {
        VertexShader = compile vs_2_0 Alpha_VertexShader37(); // 17
        PixelShader = compile ps_2_0 Alpha_PixelShader36(); // 18
        ZEnable = 1;
        ZFunc = 4;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 1;
        SrcBlend = 5;
        DestBlend = 6;
        AlphaTestEnable = 0;
    }
}

technique Additive
{
    pass P0
    {
        VertexShader = compile vs_2_0 Additive_VertexShader35(); // 19
        PixelShader = compile ps_2_0 Additive_PixelShader34(); // 20
        ZEnable = 1;
        ZFunc = 4;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 1;
        SrcBlend = 2;
        DestBlend = 2;
        AlphaTestEnable = 0;
    }
}

technique AdditiveAlphaTest
{
    pass P0
    {
        VertexShader = compile vs_2_0 AdditiveAlphaTest_VertexShader33(); // 21
        PixelShader = compile ps_2_0 AdditiveAlphaTest_PixelShader32(); // 22
        ZEnable = 1;
        ZFunc = 4;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 1;
        SrcBlend = 2;
        DestBlend = 2;
        AlphaTestEnable = 0;
    }
}

technique AlphaTest
{
    pass P0
    {
        VertexShader = compile vs_2_0 AlphaTest_VertexShader31(); // 23
        PixelShader = compile ps_2_0 AlphaTest_PixelShader30(); // 24
        ZEnable = 1;
        ZFunc = 4;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 0;
        AlphaTestEnable = 1;
        AlphaFunc = 7;
        AlphaRef = 96;
    }
}

technique Multiplicative
{
    pass P0
    {
        VertexShader = compile vs_2_0 Multiplicative_VertexShader29(); // 25
        PixelShader = compile ps_2_0 Multiplicative_PixelShader28(); // 26
        ZEnable = 1;
        ZFunc = 4;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 1;
        SrcBlend = 9;
        DestBlend = 1;
        AlphaTestEnable = 0;
    }
}

technique AdditiveNoDepthTest
{
    pass P0
    {
        VertexShader = compile vs_2_0 AdditiveNoDepthTest_VertexShader27(); // 27
        PixelShader = compile ps_2_0 AdditiveNoDepthTest_PixelShader26(); // 28
        ZEnable = 0;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 1;
        SrcBlend = 2;
        DestBlend = 2;
        AlphaTestEnable = 0;
    }
}

technique AlphaNoDepthTest
{
    pass P0
    {
        VertexShader = compile vs_2_0 AlphaNoDepthTest_VertexShader25(); // 29
        PixelShader = compile ps_2_0 AlphaNoDepthTest_PixelShader24(); // 30
        ZEnable = 0;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 1;
        SrcBlend = 5;
        DestBlend = 6;
        AlphaTestEnable = 0;
    }
}

technique Alpha_M
{
    pass P0
    {
        VertexShader = compile vs_2_0 Alpha_M_VertexShader23(); // 31
        PixelShader = compile ps_2_0 Alpha_M_PixelShader22(); // 32
        ZEnable = 1;
        ZFunc = 4;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 1;
        SrcBlend = 5;
        DestBlend = 6;
        AlphaTestEnable = 0;
    }
}

technique Additive_M
{
    pass P0
    {
        VertexShader = compile vs_2_0 Additive_M_VertexShader21(); // 33
        PixelShader = compile ps_2_0 Additive_M_PixelShader20(); // 34
        ZEnable = 1;
        ZFunc = 4;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 1;
        SrcBlend = 2;
        DestBlend = 2;
        AlphaTestEnable = 0;
    }
}

technique AdditiveAlphaTest_M
{
    pass P0
    {
        VertexShader = compile vs_2_0 AdditiveAlphaTest_M_VertexShader19(); // 35
        PixelShader = compile ps_2_0 AdditiveAlphaTest_M_PixelShader18(); // 36
        ZEnable = 1;
        ZFunc = 4;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 1;
        SrcBlend = 2;
        DestBlend = 2;
        AlphaTestEnable = 0;
    }
}

technique AlphaTest_M
{
    pass P0
    {
        VertexShader = compile vs_2_0 AlphaTest_M_VertexShader17(); // 37
        PixelShader = compile ps_2_0 AlphaTest_M_PixelShader16(); // 38
        ZEnable = 1;
        ZFunc = 4;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 0;
        AlphaTestEnable = 1;
        AlphaFunc = 7;
        AlphaRef = 96;
    }
}

technique Multiplicative_M
{
    pass P0
    {
        VertexShader = compile vs_2_0 Multiplicative_M_VertexShader15(); // 39
        PixelShader = compile ps_2_0 Multiplicative_M_PixelShader14(); // 40
        ZEnable = 1;
        ZFunc = 4;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 1;
        SrcBlend = 9;
        DestBlend = 1;
        AlphaTestEnable = 0;
    }
}

technique AdditiveNoDepthTest_M
{
    pass P0
    {
        VertexShader = compile vs_2_0 AdditiveNoDepthTest_M_VertexShader13(); // 41
        PixelShader = compile ps_2_0 AdditiveNoDepthTest_M_PixelShader12(); // 42
        ZEnable = 0;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 1;
        SrcBlend = 2;
        DestBlend = 2;
        AlphaTestEnable = 0;
    }
}

technique AlphaNoDepthTest_M
{
    pass P0
    {
        VertexShader = compile vs_2_0 AlphaNoDepthTest_M_VertexShader11(); // 43
        PixelShader = compile ps_2_0 AlphaNoDepthTest_M_PixelShader10(); // 44
        ZEnable = 0;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 1;
        SrcBlend = 5;
        DestBlend = 6;
        AlphaTestEnable = 0;
    }
}

technique _CreateShadowMap
{
    pass P0
    {
        VertexShader = compile vs_2_0 _CreateShadowMap_VertexShader9(); // 52
        PixelShader = PSCreateShadowMap_Array[_CreateShadowMap_Expression8()]; // 53
        ZEnable = 1;
        ZFunc = 4;
        ZWriteEnable = 1;
        CullMode = 1;
        AlphaBlendEnable = 0;
        AlphaTestEnable = 0;
    }
}

