string DefaultParameterScopeBlock = "material"; // 1
float3 AmbientLightColor : register(vs_2_0, c4) : register(vs_3_0, c4) <bool unmanaged = 1;> = { 0.3, 0.3, 0.3 };
struct
{
    float3 Color;
    float3 Direction;
} DirectionalLight[3] : register(vs_2_0, c5) : register(ps_3_0, c5) : register(vs_3_0, c5) <bool unmanaged = 1;> = { 1.625198, 1.512711, 1.097048, 0.62914, -0.34874, 0.69465, 0.5232916, 0.6654605, 0.7815244, -0.32877, 0.90329, 0.27563, 0.4420466, 0.4102767, 0.4420466, -0.80704, -0.58635, 0.06975 };
int NumPointLights : register(ps_3_0, i0) <string SasBindAddress = "Sas.NumPointLights"; string UIWidget = "None";>;
struct
{
    float3 Color;
    float3 Position;
    float2 Range_Inner_Outer;
} PointLight[8] : register(ps_3_0, c89) <bool unmanaged = 1;>;
struct
{
    float4 WorldPositionMultiplier_XYZZ;
    float2 CurrentOffsetUV;
} Cloud : register(vs_3_0, c117) <bool unmanaged = 1;>;
float3 NoCloudMultiplier <bool unmanaged = 1;> = { 1, 1, 1 };
float3 RecolorColorDummy <bool unmanaged = 1;>;
column_major float4x4 ShadowMapWorldToShadow : register(vs_3_0, c113) <bool unmanaged = 1;>;
float OpacityOverride : register(vs_2_0, c1) : register(vs_3_0, c1) <bool unmanaged = 1;> = { 1 };
float3 TintColor : register(ps_2_0, c2) : register(ps_3_0, c2) <bool unmanaged = 1;> = { 1, 1, 1 };
float3 EyePosition : register(vs_3_0, c123) <bool unmanaged = 1;>;
column_major float4x4 ViewProjection : register(vs_2_0, c119) : register(vs_3_0, c119) <bool unmanaged = 1;>;
float4 WorldBones[128] : register(vs_2_0, c128) : register(vs_3_0, c128) <bool unmanaged = 1;>;
bool HasShadow <string UIWidget = "None"; string SasBindAddress = "Sas.HasShadow";>;
texture ShadowMap <string UIWidget = "None"; string SasBindAddress = "Sas.Shadow[0].ShadowMap";>; // 6
sampler2D ShadowMapSampler : register(ps_3_0, s0) <string Texture = "ShadowMap"; string UIWidget = "None"; string SasBindAddress = "Sas.Shadow[0].ShadowMap";> =
sampler_state
{
    Texture = <ShadowMap>; // 9
    MinFilter = 1;
    MagFilter = 1;
    MipFilter = 0;
    AddressU = 3;
    AddressV = 3;
};
float4 Shadowmap_Zero_Zero_OneOverMapSize_OneOverMapSize : register(ps_3_0, c11) <string UIWidget = "None"; string SasBindAddress = "Sas.Shadow[0].Zero_Zero_OneOverMapSize_OneOverMapSize";>;
float2 MapCellSize <string UIWidget = "None"; string SasBindAddress = "Terrain.Map.CellSize";> = { 10, 10 };
texture MacroSampler <string UIWidget = "None"; string SasBindAddress = "Terrain.MacroTexture"; string ResourceName = "ShaderPreviewMacro.dds";>; // 17
sampler2D MacroSamplerSampler <string Texture = "MacroSampler"; string UIWidget = "None"; string SasBindAddress = "Terrain.MacroTexture"; string ResourceName = "ShaderPreviewMacro.dds";> =
sampler_state
{
    Texture = <MacroSampler>; // 21
    MinFilter = 2;
    MagFilter = 2;
    MipFilter = 2;
    AddressU = 1;
    AddressV = 1;
};
int _SasGlobal : SasGlobal <string UIWidget = "None"; int3 SasVersion = int3(1, 0, 0); int MaxLocalLights = 8; int MaxSupportedInstancingMode = 1;>;
int NumJointsPerVertex <string UIWidget = "None"; string SasBindAddress = "Sas.Skeleton.NumJointsPerVertex";>;
column_major float4x3 World : World : register(vs_2_0, c124) : register(vs_3_0, c124);
texture CloudTexture <string UIWidget = "None"; string SasBindAddress = "Terrain.Cloud.Texture"; string ResourceName = "ShaderPreviewCloud.dds";>; // 29
sampler2D CloudTextureSampler <string Texture = "CloudTexture"; string UIWidget = "None"; string SasBindAddress = "Terrain.Cloud.Texture"; string ResourceName = "ShaderPreviewCloud.dds";> =
sampler_state
{
    Texture = <CloudTexture>; // 33
    MinFilter = 2;
    MagFilter = 2;
    MipFilter = 2;
    AddressU = 1;
    AddressV = 1;
};
texture EnvironmentTexture <string UIWidget = "None"; string SasBindAddress = "Objects.LightSpaceEnvironmentMap"; string ResourceType = "Cube";>; // 38
samplerCUBE EnvironmentTextureSampler <string Texture = "EnvironmentTexture"; string UIWidget = "None"; string SasBindAddress = "Objects.LightSpaceEnvironmentMap"; string ResourceType = "Cube";> =
sampler_state
{
    Texture = <EnvironmentTexture>; // 42
    MinFilter = 2;
    MagFilter = 2;
    MipFilter = 2;
    AddressU = 3;
    AddressV = 3;
    AddressW = 3;
};
texture DiffuseTexture <string UIName = "Diffuse Texture";>; // 47
sampler2D DiffuseTextureSampler : register(ps_2_0, s0) <string Texture = "DiffuseTexture"; string UIName = "Diffuse Texture";> =
sampler_state
{
    Texture = <DiffuseTexture>; // 49
    MinFilter = 3;
    MagFilter = 2;
    MipFilter = 2;
    MaxAnisotropy = 8;
    AddressU = 1;
    AddressV = 1;
};
texture NormalMap <string UIName = "Normal Texture";>; // 52
sampler2D NormalMapSampler <string Texture = "NormalMap"; string UIName = "Normal Texture";> =
sampler_state
{
    Texture = <NormalMap>; // 54
    MinFilter = 3;
    MagFilter = 2;
    MipFilter = 2;
    MaxAnisotropy = 8;
    AddressU = 1;
    AddressV = 1;
};
float BumpScale <string UIName = "Bump Height"; string UIWidget = "Slider"; float UIMin = 0; float UIMax = 10; float UIStep = 0.1;> = { 1 };
float3 AmbientColor : register(vs_2_0, c11) : register(vs_3_0, c11) <string UIName = "Ambient Color"; string UIWidget = "Color";> = { 0.4, 0.4, 0.4 };
float4 DiffuseColor : register(vs_2_0, c12) : register(vs_3_0, c12) <string UIName = "Diffuse Color"; string UIWidget = "Color";> = { 1, 1, 1, 1 };
float3 SpecularColor <string UIName = "Specular Color"; string UIWidget = "Color";> = { 0.8, 0.8, 0.8 };
float SpecularExponent <string UIName = "Specular Exponent"; string UIWidget = "Slider"; float UIMax = 200; float UIMin = 0; float UIStep = 1;> = { 50 };
bool AlphaTestEnable <string UIName = "Alpha Test Enable";>;
struct
{
    float4 ScaleUV_OffsetUV;
} Shroud : register(vs_2_0, c13) : register(vs_3_0, c13) <string UIWidget = "None"; string SasBindAddress = "Terrain.Shroud";> = { 1, 1, 0, 0 };
texture ShroudTexture <string UIWidget = "None"; string SasBindAddress = "Terrain.Shroud.Texture";>; // 70
sampler2D ShroudTextureSampler : register(ps_2_0, s1) <string Texture = "ShroudTexture"; string UIWidget = "None"; string SasBindAddress = "Terrain.Shroud.Texture";> =
sampler_state
{
    Texture = <ShroudTexture>; // 73
    MinFilter = 2;
    MagFilter = 2;
    MipFilter = 2;
    AddressU = 3;
    AddressV = 3;
};
float Time : Time;
// VS_H_Array_Shader_0 Vertex_3_0 Has PRES False
struct VS_H_Array_Shader_0_Input
{
    float4 position : POSITION;
    float4 normal : NORMAL;
    float4 tangent : TANGENT;
    float4 binormal : BINORMAL;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct VS_H_Array_Shader_0_Output
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float3 texcoord1 : TEXCOORD1;
    float3 texcoord2 : TEXCOORD2;
    float3 texcoord3 : TEXCOORD3;
    float3 texcoord4 : TEXCOORD4;
    float4 texcoord5 : TEXCOORD5;
    float4 texcoord6 : TEXCOORD6;
    float4 color : COLOR;
};

VS_H_Array_Shader_0_Output VS_H_Array_Shader_0(VS_H_Array_Shader_0_Input i)
{
    VS_H_Array_Shader_0_Output o;
    float4 temp0, temp1;
    // def c0, 1, 0, 0.5, -0.0015
    // dcl_position v0
    // dcl_normal v1
    // dcl_tangent v2
    // dcl_binormal v3
    // dcl_texcoord v4
    // dcl_color v5
    // dcl_position o0
    // dcl_texcoord o1
    // dcl_texcoord1 o2.xyz
    // dcl_texcoord2 o3.xyz
    // dcl_texcoord3 o4.xyz
    // dcl_texcoord4 o5.xyz
    // dcl_texcoord5 o6
    // dcl_texcoord6 o7
    // dcl_color o8
    // dp3 r0.x, v1, c124
    temp0.x = dot(i.normal.xyz, (World._m00_m10_m20_m30).xyz);
    // dp3 r0.y, v1, c125
    temp0.y = dot(i.normal.xyz, (World._m01_m11_m21_m31).xyz);
    // dp3 r0.z, v1, c126
    temp0.z = dot(i.normal.xyz, (World._m02_m12_m22_m32).xyz);
    // dp3 r0.w, r0, c10
    temp0.w = dot(temp0.xyz, DirectionalLight[2].Direction.xyz);
    // mov o2.z, r0.x
    o.texcoord1.z = temp0.x;
    // mov o3.z, r0.y
    o.texcoord2.z = temp0.y;
    // mov o4.z, r0.z
    o.texcoord3.z = temp0.z;
    // max r0.x, r0.w, c0.y
    temp0.x = max(temp0.w, float1(0));
    // mul r0.xyz, r0.x, c9
    temp0.xyz = temp0.xxx * DirectionalLight[2].Color.xyz;
    // mul r0.xyz, r0, c12
    temp0.xyz = temp0.xyz * DiffuseColor.xyz;
    // mov r1.xyz, c4
    temp1.xyz = AmbientLightColor.xyz;
    // mad r0.xyz, r1, c11, r0
    temp0.xyz = temp1.xyz * AmbientColor.xyz + temp0.xyz;
    // mul r0.xyz, r0, v5
    temp0.xyz = temp0.xyz * i.color.xyz;
    // mov r0.w, c1.x
    temp0.w = OpacityOverride.x;
    // mad r1, v5.w, c0.yyyx, c0.zzzy
    temp1 = i.color.w * float4(0, 0, 0, 1) + float4(0.5, 0.5, 0.5, 0);
    // mul o8, r0, r1
    o.color = temp0 * temp1;
    // mad r0, v0.xyzx, c0.xxxy, c0.yyyx
    temp0 = i.position.xyzx * float4(1, 1, 1, 0) + float4(0, 0, 0, 1);
    // dp4 r1.z, r0, c126
    temp1.z = dot(temp0, (World._m02_m12_m22_m32));
    // mov r1.w, c0.x
    temp1.w = float1(1);
    // dp4 r1.x, r0, c124
    temp1.x = dot(temp0, (World._m00_m10_m20_m30));
    // dp4 r1.y, r0, c125
    temp1.y = dot(temp0, (World._m01_m11_m21_m31));
    // dp4 o0.x, r1, c119
    o.position.x = dot(temp1, (ViewProjection._m00_m10_m20_m30));
    // dp4 o0.y, r1, c120
    o.position.y = dot(temp1, (ViewProjection._m01_m11_m21_m31));
    // dp4 o0.z, r1, c121
    o.position.z = dot(temp1, (ViewProjection._m02_m12_m22_m32));
    // dp4 o0.w, r1, c122
    o.position.w = dot(temp1, (ViewProjection._m03_m13_m23_m33));
    // add r0.xy, r1, c13.zwzw
    temp0.xy = temp1.xy + Shroud.ScaleUV_OffsetUV.zw;
    // mul o7.xy, r0, c13
    o.texcoord6.xy = temp0.xy * Shroud.ScaleUV_OffsetUV.xy;
    // mul r0.xy, r1.z, c117.zwzw
    temp0.xy = temp1.zz * Cloud.WorldPositionMultiplier_XYZZ.zw;
    // mad r0.xy, r1, c117, -r0
    temp0.xy = temp1.xy * Cloud.WorldPositionMultiplier_XYZZ.xy + -temp0.xy;
    // add o7.zw, r0.xyxy, c118.xyxy
    o.texcoord6.zw = temp0.xy + Cloud.CurrentOffsetUV.xy;
    // mov o1, v4.xyyx
    o.texcoord = i.texcoord.xyyx;
    // dp3 r0.x, v3, c124
    temp0.x = dot(i.binormal.xyz, (World._m00_m10_m20_m30).xyz);
    // mov o2.x, -r0.x
    o.texcoord1.x = -temp0.x;
    // dp3 r0.x, v2, c124
    temp0.x = dot(i.tangent.xyz, (World._m00_m10_m20_m30).xyz);
    // mov o2.y, -r0.x
    o.texcoord1.y = -temp0.x;
    // dp3 r0.x, v3, c125
    temp0.x = dot(i.binormal.xyz, (World._m01_m11_m21_m31).xyz);
    // mov o3.x, -r0.x
    o.texcoord2.x = -temp0.x;
    // dp3 r0.x, v2, c125
    temp0.x = dot(i.tangent.xyz, (World._m01_m11_m21_m31).xyz);
    // mov o3.y, -r0.x
    o.texcoord2.y = -temp0.x;
    // dp3 r0.x, v3, c126
    temp0.x = dot(i.binormal.xyz, (World._m02_m12_m22_m32).xyz);
    // mov o4.x, -r0.x
    o.texcoord3.x = -temp0.x;
    // dp3 r0.x, v2, c126
    temp0.x = dot(i.tangent.xyz, (World._m02_m12_m22_m32).xyz);
    // mov o4.y, -r0.x
    o.texcoord3.y = -temp0.x;
    // mov o5.xyz, r1
    o.texcoord4 = temp1;
    // dp4 r0.x, r1, c116
    temp0.x = dot(temp1, (ShadowMapWorldToShadow._m03_m13_m23_m33));
    // rcp r0.y, r0.x
    temp0.y = 1.0f / temp0.x;
    // mov o6.w, r0.x
    o.texcoord5.w = temp0.x;
    // dp4 r0.x, r1, c113
    temp0.x = dot(temp1, (ShadowMapWorldToShadow._m00_m10_m20_m30));
    // dp4 r0.z, r1, c114
    temp0.z = dot(temp1, (ShadowMapWorldToShadow._m01_m11_m21_m31));
    // dp4 r0.w, r1, c115
    temp0.w = dot(temp1, (ShadowMapWorldToShadow._m02_m12_m22_m32));
    // mad o6.xyz, r0.xzww, r0.y, c0.yyww
    o.texcoord5.xyz = temp0.xzw * temp0.yyy + float3(0, 0, -0.0015);
    // 

    return o;
}

// VS_H_Array_Shader_1 Vertex_3_0 Has PRES False
struct VS_H_Array_Shader_1_Input
{
    float4 position : POSITION;
    float4 normal : NORMAL;
    float4 tangent : TANGENT;
    float4 binormal : BINORMAL;
    float4 blendindices : BLENDINDICES;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct VS_H_Array_Shader_1_Output
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float3 texcoord1 : TEXCOORD1;
    float3 texcoord2 : TEXCOORD2;
    float3 texcoord3 : TEXCOORD3;
    float3 texcoord4 : TEXCOORD4;
    float4 texcoord5 : TEXCOORD5;
    float4 texcoord6 : TEXCOORD6;
    float4 color : COLOR;
};

VS_H_Array_Shader_1_Output VS_H_Array_Shader_1(VS_H_Array_Shader_1_Input i)
{
    VS_H_Array_Shader_1_Output o;
    float4 temp0, temp1, temp2, temp3, temp4;
    float addr0;
    // def c0, 1, -1, 0, 0.5
    // def c2, 0, -0.0015, 0, 0
    // dcl_position v0
    // dcl_normal v1
    // dcl_tangent v2
    // dcl_binormal v3
    // dcl_blendindices v4
    // dcl_texcoord v5
    // dcl_color v6
    // dcl_position o0
    // dcl_texcoord o1
    // dcl_texcoord1 o2.xyz
    // dcl_texcoord2 o3.xyz
    // dcl_texcoord3 o4.xyz
    // dcl_texcoord4 o5.xyz
    // dcl_texcoord5 o6
    // dcl_texcoord6 o7
    // dcl_color o8
    // slt r0.x, v4.x, -v4.x
    temp0.x = (i.blendindices.x < -i.blendindices.x) ? 1 : 0;
    // frc r0.y, v4.x
    temp0.y = frac(i.blendindices.x);
    // add r0.z, -r0.y, v4.x
    temp0.z = -temp0.y + i.blendindices.x;
    // slt r0.y, -r0.y, r0.y
    temp0.y = (-temp0.y < temp0.y) ? 1 : 0;
    // mad r0.x, r0.x, r0.y, r0.z
    temp0.x = temp0.x * temp0.y + temp0.z;
    // add r0.x, r0.x, r0.x
    temp0.x = temp0.x + temp0.x;
    // mova a0.x, r0.x
    addr0.x = temp0.x;
    // mul r0.w, v6.w, c129[a0.x].w
    temp0.w = i.color.w * WorldBones[1 + addr0.x].w;
    // mov r1.w, c1.x
    temp1.w = OpacityOverride.x;
    // mov r0.xyz, c0.w
    temp0.xyz = float3(0.5, 0.5, 0.5);
    // add r2.x, v4.x, v4.x
    temp2.x = i.blendindices.x + i.blendindices.x;
    // frc r2.y, r2.x
    temp2.y = frac(temp2.x);
    // add r2.z, r2.x, -r2.y
    temp2.z = temp2.x + -temp2.y;
    // slt r2.y, -r2.y, r2.y
    temp2.y = (-temp2.y < temp2.y) ? 1 : 0;
    // slt r2.x, r2.x, -r2.x
    temp2.x = (temp2.x < -temp2.x) ? 1 : 0;
    // mad r2.x, r2.x, r2.y, r2.z
    temp2.x = temp2.x * temp2.y + temp2.z;
    // mova a0.x, r2.x
    addr0.x = temp2.x;
    // mul r2, v1.zxyy, c128[a0.x].yzxy
    temp2 = i.normal.zxyy * WorldBones[0 + addr0.x].yzxy;
    // mad r2, c128[a0.x].wwwx, v1.xyzx, r2
    temp2 = WorldBones[0 + addr0.x].wwwx * i.normal.xyzx + temp2;
    // mul r3, v1.yzxz, c128[a0.x].zxyz
    temp3 = i.normal.yzxz * WorldBones[0 + addr0.x].zxyz;
    // mad r2, r2, c0.xxxy, -r3
    temp2 = temp2 * float4(1, 1, 1, -1) + -temp3;
    // mul r3.xyz, r2.w, c128[a0.x]
    temp3.xyz = temp2.www * WorldBones[0 + addr0.x].xyz;
    // mad r3.xyz, c128[a0.x].w, r2, -r3
    temp3.xyz = WorldBones[0 + addr0.x].www * temp2.xyz + -temp3.xyz;
    // mad r3.xyz, c128[a0.x].yzxw, r2.zxyw, r3
    temp3.xyz = WorldBones[0 + addr0.x].yzx * temp2.zxy + temp3.xyz;
    // mad r2.xyz, c128[a0.x].zxyw, -r2.yzxw, r3
    temp2.xyz = WorldBones[0 + addr0.x].zxy * -temp2.yzx + temp3.xyz;
    // dp3 r2.w, r2, c10
    temp2.w = dot(temp2.xyz, DirectionalLight[2].Direction.xyz);
    // max r2.w, r2.w, c0.z
    temp2.w = max(temp2.w, float1(0));
    // mul r3.xyz, r2.w, c9
    temp3.xyz = temp2.www * DirectionalLight[2].Color.xyz;
    // mul r3.xyz, r3, c12
    temp3.xyz = temp3.xyz * DiffuseColor.xyz;
    // mov r4.xyz, c4
    temp4.xyz = AmbientLightColor.xyz;
    // mad r3.xyz, r4, c11, r3
    temp3.xyz = temp4.xyz * AmbientColor.xyz + temp3.xyz;
    // mul r1.xyz, r3, v6
    temp1.xyz = temp3.xyz * i.color.xyz;
    // mul o8, r0, r1
    o.color = temp0 * temp1;
    // mul r0, v0.zxyy, c128[a0.x].yzxy
    temp0 = i.position.zxyy * WorldBones[0 + addr0.x].yzxy;
    // mad r0, c128[a0.x].wwwx, v0.xyzx, r0
    temp0 = WorldBones[0 + addr0.x].wwwx * i.position.xyzx + temp0;
    // mul r1, v0.yzxz, c128[a0.x].zxyz
    temp1 = i.position.yzxz * WorldBones[0 + addr0.x].zxyz;
    // mad r0, r0, c0.xxxy, -r1
    temp0 = temp0 * float4(1, 1, 1, -1) + -temp1;
    // mul r1.xyz, r0.w, c128[a0.x]
    temp1.xyz = temp0.www * WorldBones[0 + addr0.x].xyz;
    // mad r1.xyz, c128[a0.x].w, r0, -r1
    temp1.xyz = WorldBones[0 + addr0.x].www * temp0.xyz + -temp1.xyz;
    // mad r1.xyz, c128[a0.x].yzxw, r0.zxyw, r1
    temp1.xyz = WorldBones[0 + addr0.x].yzx * temp0.zxy + temp1.xyz;
    // mad r0.xyz, c128[a0.x].zxyw, -r0.yzxw, r1
    temp0.xyz = WorldBones[0 + addr0.x].zxy * -temp0.yzx + temp1.xyz;
    // add r0.xyz, r0, c129[a0.x]
    temp0.xyz = temp0.xyz + WorldBones[1 + addr0.x].xyz;
    // mov r0.w, c0.x
    temp0.w = float1(1);
    // dp4 o0.x, r0, c119
    o.position.x = dot(temp0, (ViewProjection._m00_m10_m20_m30));
    // dp4 o0.y, r0, c120
    o.position.y = dot(temp0, (ViewProjection._m01_m11_m21_m31));
    // dp4 o0.z, r0, c121
    o.position.z = dot(temp0, (ViewProjection._m02_m12_m22_m32));
    // dp4 o0.w, r0, c122
    o.position.w = dot(temp0, (ViewProjection._m03_m13_m23_m33));
    // add r1.xy, r0, c13.zwzw
    temp1.xy = temp0.xy + Shroud.ScaleUV_OffsetUV.zw;
    // mul o7.xy, r1, c13
    o.texcoord6.xy = temp1.xy * Shroud.ScaleUV_OffsetUV.xy;
    // mul r1.xy, r0.z, c117.zwzw
    temp1.xy = temp0.zz * Cloud.WorldPositionMultiplier_XYZZ.zw;
    // mad r1.xy, r0, c117, -r1
    temp1.xy = temp0.xy * Cloud.WorldPositionMultiplier_XYZZ.xy + -temp1.xy;
    // add o7.zw, r1.xyxy, c118.xyxy
    o.texcoord6.zw = temp1.xy + Cloud.CurrentOffsetUV.xy;
    // mov o1, v5.xyyx
    o.texcoord = i.texcoord.xyyx;
    // mul r1, v3.zxyy, c128[a0.x].yzxy
    temp1 = i.binormal.zxyy * WorldBones[0 + addr0.x].yzxy;
    // mad r1, c128[a0.x].wwwx, v3.xyzx, r1
    temp1 = WorldBones[0 + addr0.x].wwwx * i.binormal.xyzx + temp1;
    // mul r3, v3.yzxz, c128[a0.x].zxyz
    temp3 = i.binormal.yzxz * WorldBones[0 + addr0.x].zxyz;
    // mad r1, r1, c0.xxxy, -r3
    temp1 = temp1 * float4(1, 1, 1, -1) + -temp3;
    // mul r3.xyz, r1.w, c128[a0.x]
    temp3.xyz = temp1.www * WorldBones[0 + addr0.x].xyz;
    // mad r3.xyz, c128[a0.x].w, r1, -r3
    temp3.xyz = WorldBones[0 + addr0.x].www * temp1.xyz + -temp3.xyz;
    // mad r3.xyz, c128[a0.x].yzxw, r1.zxyw, r3
    temp3.xyz = WorldBones[0 + addr0.x].yzx * temp1.zxy + temp3.xyz;
    // mad r1.xyz, c128[a0.x].zxyw, -r1.yzxw, r3
    temp1.xyz = WorldBones[0 + addr0.x].zxy * -temp1.yzx + temp3.xyz;
    // mov o2.x, -r1.x
    o.texcoord1.x = -temp1.x;
    // mul r3, v2.zxyy, c128[a0.x].yzxy
    temp3 = i.tangent.zxyy * WorldBones[0 + addr0.x].yzxy;
    // mad r3, c128[a0.x].wwwx, v2.xyzx, r3
    temp3 = WorldBones[0 + addr0.x].wwwx * i.tangent.xyzx + temp3;
    // mul r4, v2.yzxz, c128[a0.x].zxyz
    temp4 = i.tangent.yzxz * WorldBones[0 + addr0.x].zxyz;
    // mad r3, r3, c0.xxxy, -r4
    temp3 = temp3 * float4(1, 1, 1, -1) + -temp4;
    // mul r4.xyz, r3.w, c128[a0.x]
    temp4.xyz = temp3.www * WorldBones[0 + addr0.x].xyz;
    // mad r4.xyz, c128[a0.x].w, r3, -r4
    temp4.xyz = WorldBones[0 + addr0.x].www * temp3.xyz + -temp4.xyz;
    // mad r4.xyz, c128[a0.x].yzxw, r3.zxyw, r4
    temp4.xyz = WorldBones[0 + addr0.x].yzx * temp3.zxy + temp4.xyz;
    // mad r3.xyz, c128[a0.x].zxyw, -r3.yzxw, r4
    temp3.xyz = WorldBones[0 + addr0.x].zxy * -temp3.yzx + temp4.xyz;
    // mov o2.y, -r3.x
    o.texcoord1.y = -temp3.x;
    // mov o2.z, r2.x
    o.texcoord1.z = temp2.x;
    // mov o3.x, -r1.y
    o.texcoord2.x = -temp1.y;
    // mov o4.x, -r1.z
    o.texcoord3.x = -temp1.z;
    // mov o3.y, -r3.y
    o.texcoord2.y = -temp3.y;
    // mov o4.y, -r3.z
    o.texcoord3.y = -temp3.z;
    // mov o3.z, r2.y
    o.texcoord2.z = temp2.y;
    // mov o4.z, r2.z
    o.texcoord3.z = temp2.z;
    // mov o5.xyz, r0
    o.texcoord4 = temp0;
    // dp4 r1.x, r0, c113
    temp1.x = dot(temp0, (ShadowMapWorldToShadow._m00_m10_m20_m30));
    // dp4 r1.y, r0, c114
    temp1.y = dot(temp0, (ShadowMapWorldToShadow._m01_m11_m21_m31));
    // dp4 r1.z, r0, c115
    temp1.z = dot(temp0, (ShadowMapWorldToShadow._m02_m12_m22_m32));
    // dp4 r0.x, r0, c116
    temp0.x = dot(temp0, (ShadowMapWorldToShadow._m03_m13_m23_m33));
    // rcp r0.y, r0.x
    temp0.y = 1.0f / temp0.x;
    // mov o6.w, r0.x
    o.texcoord5.w = temp0.x;
    // mad o6.xyz, r1, r0.y, c2.xxyw
    o.texcoord5.xyz = temp1.xyz * temp0.yyy + float3(0, 0, -0.0015);
    // 

    return o;
}

VertexShader VS_H_Array[2] = {
    compile vs_3_0 VS_H_Array_Shader_0(), // 77
    compile vs_3_0 VS_H_Array_Shader_1(), // 78
};
// PS_H_Array_Shader_0 Pixel_3_0 Has PRES False
struct PS_H_Array_Shader_0_Input
{
    float2 texcoord : TEXCOORD;
    float3 texcoord1 : TEXCOORD1;
    float3 texcoord2 : TEXCOORD2;
    float3 texcoord3 : TEXCOORD3;
    float3 texcoord4 : TEXCOORD4;
    float4 texcoord6 : TEXCOORD6;
    float4 color : COLOR;
};

float4 PS_H_Array_Shader_0(PS_H_Array_Shader_0_Input i) : COLOR
{
    float4 out_color;
    float4 temp0, temp1, temp2, temp3, temp4, temp5;
    float3 temp6, temp7;
    float2 temp8;
    // def c0, 2.2, 2, -1, 0
    // def c1, -0, -1, -2, -3
    // def c3, -4, -5, -6, -7
    // dcl_texcoord v0.xy
    // dcl_texcoord1_centroid v1.xyz
    // dcl_texcoord2_centroid v2.xyz
    // dcl_texcoord3_centroid v3.xyz
    // dcl_texcoord4 v4.xyz
    // dcl_texcoord6 v5
    // dcl_color v6
    // dcl_2d s0
    // dcl_2d s1
    // dcl_2d s2
    // dcl_2d s3
    // texld r0, v0, s1
    temp0 = tex2D(DiffuseTextureSampler, i.texcoord.xy);
    // log r1.x, r0.x
    temp1.x = log2(temp0.x);
    // log r1.y, r0.y
    temp1.y = log2(temp0.y);
    // log r1.z, r0.z
    temp1.z = log2(temp0.z);
    // mul r0.xyz, r1, c0.x
    temp0.xyz = temp1.xyz * float3(2.2, 2.2, 2.2);
    // exp r1.x, r0.x
    temp1.x = exp2(temp0.x);
    // exp r1.y, r0.y
    temp1.y = exp2(temp0.y);
    // exp r1.z, r0.z
    temp1.z = exp2(temp0.z);
    // mul r0.xyz, r1, c12
    temp0.xyz = temp1.xyz * DiffuseColor.xyz;
    // texld r2, v0, s2
    temp2 = tex2D(NormalMapSampler, i.texcoord.xy);
    // mad r2.xyz, r2, c0.y, c0.z
    temp2.xyz = temp2.xyz * float3(2, 2, 2) + float3(-1, -1, -1);
    // mul r2.xy, r2, c11.x
    temp2.xy = temp2.xy * BumpScale.xx;
    // dp3 r3.x, r2, v1
    temp3.x = dot(temp2.xyz, i.texcoord1.xyz);
    // dp3 r3.y, r2, v2
    temp3.y = dot(temp2.xyz, i.texcoord2.xyz);
    // dp3 r3.z, r2, v3
    temp3.z = dot(temp2.xyz, i.texcoord3.xyz);
    // nrm r2.xyz, r3
    temp2.xyz = normalize(temp3.xyz).xyz;
    // texld r3, v5.zwzw, s0
    temp3 = tex2D(CloudTextureSampler, i.texcoord6.zw);
    // log r4.x, r3.x
    temp4.x = log2(temp3.x);
    // log r4.y, r3.y
    temp4.y = log2(temp3.y);
    // log r4.z, r3.z
    temp4.z = log2(temp3.z);
    // mul r3.xyz, r4, c0.x
    temp3.xyz = temp4.xyz * float3(2.2, 2.2, 2.2);
    // exp r4.x, r3.x
    temp4.x = exp2(temp3.x);
    // exp r4.y, r3.y
    temp4.y = exp2(temp3.y);
    // exp r4.z, r3.z
    temp4.z = exp2(temp3.z);
    // dp3 r1.w, r2, c6
    temp1.w = dot(temp2.xyz, DirectionalLight[0].Direction.xyz);
    // max r2.w, r1.w, c0.w
    temp2.w = max(temp1.w, float1(0));
    // mul r3.xyz, r4, c5
    temp3.xyz = temp4.xyz * DirectionalLight[0].Color.xyz;
    // mul r4.xyz, r0, r2.w
    temp4.xyz = temp0.xyz * temp2.www;
    // mul r3.xyz, r3, r4
    temp3.xyz = temp3.xyz * temp4.xyz;
    // mad r1.xyz, r1, v6, r3
    temp1.xyz = temp1.xyz * i.color.xyz + temp3.xyz;
    // dp3 r1.w, r2, c8
    temp1.w = dot(temp2.xyz, DirectionalLight[1].Direction.xyz);
    // max r2.w, r1.w, c0.w
    temp2.w = max(temp1.w, float1(0));
    // mul r3.xyz, r0, r2.w
    temp3.xyz = temp0.xyz * temp2.www;
    // mad r1.xyz, c7, r3, r1
    temp1.xyz = DirectionalLight[1].Color.xyz * temp3.xyz + temp1.xyz;
    // mov r3.xyz, c0.w
    temp3.xyz = float3(0, 0, 0);
    // mov r1.w, c0.w
    temp1.w = float1(0);
    // rep i0
    for (int it0 = 0; it0 < NumPointLights; ++it0) {
        // add r4, r1.w, c1
        temp4 = temp1.w + float4(-0, -1, -2, -3);
        // add r5, r1.w, c3
        temp5 = temp1.w + float4(-4, -5, -6, -7);
        // mov r2.w, c0.w
        temp2.w = float1(0);
        // cmp r6.xyz, -r4_abs.x, c89, r2.w
        temp6.xyz = (-abs(temp4).xxx >= 0) ? PointLight[0].Color.xyz : temp2.www;
        // cmp r7.xyz, -r4_abs.x, c90, r2.w
        temp7.xyz = (-abs(temp4).xxx >= 0) ? PointLight[0].Position.xyz : temp2.www;
        // cmp r8.xy, -r4_abs.x, c91, r2.w
        temp8.xy = (-abs(temp4).xx >= 0) ? PointLight[0].Range_Inner_Outer.xy : temp2.ww;
        // cmp r6.xyz, -r4_abs.y, c92, r6
        temp6.xyz = (-abs(temp4).yyy >= 0) ? PointLight[1].Color.xyz : temp6.xyz;
        // cmp r7.xyz, -r4_abs.y, c93, r7
        temp7.xyz = (-abs(temp4).yyy >= 0) ? PointLight[1].Position.xyz : temp7.xyz;
        // cmp r4.xy, -r4_abs.y, c94, r8
        temp4.xy = (-abs(temp4).yy >= 0) ? PointLight[1].Range_Inner_Outer.xy : temp8.xy;
        // cmp r6.xyz, -r4_abs.z, c95, r6
        temp6.xyz = (-abs(temp4).zzz >= 0) ? PointLight[2].Color.xyz : temp6.xyz;
        // cmp r7.xyz, -r4_abs.z, c96, r7
        temp7.xyz = (-abs(temp4).zzz >= 0) ? PointLight[2].Position.xyz : temp7.xyz;
        // cmp r4.xy, -r4_abs.z, c97, r4
        temp4.xy = (-abs(temp4).zz >= 0) ? PointLight[2].Range_Inner_Outer.xy : temp4.xy;
        // cmp r6.xyz, -r4_abs.w, c98, r6
        temp6.xyz = (-abs(temp4).www >= 0) ? PointLight[3].Color.xyz : temp6.xyz;
        // cmp r7.xyz, -r4_abs.w, c99, r7
        temp7.xyz = (-abs(temp4).www >= 0) ? PointLight[3].Position.xyz : temp7.xyz;
        // cmp r4.xy, -r4_abs.w, c100, r4
        temp4.xy = (-abs(temp4).ww >= 0) ? PointLight[3].Range_Inner_Outer.xy : temp4.xy;
        // cmp r6.xyz, -r5_abs.x, c101, r6
        temp6.xyz = (-abs(temp5).xxx >= 0) ? PointLight[4].Color.xyz : temp6.xyz;
        // cmp r7.xyz, -r5_abs.x, c102, r7
        temp7.xyz = (-abs(temp5).xxx >= 0) ? PointLight[4].Position.xyz : temp7.xyz;
        // cmp r4.xy, -r5_abs.x, c103, r4
        temp4.xy = (-abs(temp5).xx >= 0) ? PointLight[4].Range_Inner_Outer.xy : temp4.xy;
        // cmp r6.xyz, -r5_abs.y, c104, r6
        temp6.xyz = (-abs(temp5).yyy >= 0) ? PointLight[5].Color.xyz : temp6.xyz;
        // cmp r7.xyz, -r5_abs.y, c105, r7
        temp7.xyz = (-abs(temp5).yyy >= 0) ? PointLight[5].Position.xyz : temp7.xyz;
        // cmp r4.xy, -r5_abs.y, c106, r4
        temp4.xy = (-abs(temp5).yy >= 0) ? PointLight[5].Range_Inner_Outer.xy : temp4.xy;
        // cmp r6.xyz, -r5_abs.z, c107, r6
        temp6.xyz = (-abs(temp5).zzz >= 0) ? PointLight[6].Color.xyz : temp6.xyz;
        // cmp r7.xyz, -r5_abs.z, c108, r7
        temp7.xyz = (-abs(temp5).zzz >= 0) ? PointLight[6].Position.xyz : temp7.xyz;
        // cmp r4.xy, -r5_abs.z, c109, r4
        temp4.xy = (-abs(temp5).zz >= 0) ? PointLight[6].Range_Inner_Outer.xy : temp4.xy;
        // cmp r5.xyz, -r5_abs.w, c110, r6
        temp5.xyz = (-abs(temp5).www >= 0) ? PointLight[7].Color.xyz : temp6.xyz;
        // cmp r6.xyz, -r5_abs.w, c111, r7
        temp6.xyz = (-abs(temp5).www >= 0) ? PointLight[7].Position.xyz : temp7.xyz;
        // cmp r4.xy, -r5_abs.w, c112, r4
        temp4.xy = (-abs(temp5).ww >= 0) ? PointLight[7].Range_Inner_Outer.xy : temp4.xy;
        // add r6.xyz, r6, -v4
        temp6.xyz = temp6.xyz + -i.texcoord4.xyz;
        // dp3 r2.w, r6, r6
        temp2.w = dot(temp6.xyz, temp6.xyz);
        // rsq r2.w, r2.w
        temp2.w = 1 / sqrt(temp2.w);
        // rcp r3.w, r2.w
        temp3.w = 1.0f / temp2.w;
        // mul r6.xyz, r6, r2.w
        temp6.xyz = temp6.xyz * temp2.www;
        // add r2.w, -r4.x, r3.w
        temp2.w = -temp4.x + temp3.w;
        // add r3.w, -r4.x, r4.y
        temp3.w = -temp4.x + temp4.y;
        // rcp r3.w, r3.w
        temp3.w = 1.0f / temp3.w;
        // mad_sat r2.w, r2.w, -r3.w, -c0.z
        temp2.w = saturate(temp2.w * -temp3.w + float1(1));
        // mul r2.w, r2.w, r2.w
        temp2.w = temp2.w * temp2.w;
        // mul r4.xyz, r5, r2.w
        temp4.xyz = temp5.xyz * temp2.www;
        // dp3 r2.w, r2, r6
        temp2.w = dot(temp2.xyz, temp6.xyz);
        // max r3.w, r2.w, c0.w
        temp3.w = max(temp2.w, float1(0));
        // mad r3.xyz, r4, r3.w, r3
        temp3.xyz = temp4.xyz * temp3.www + temp3.xyz;
        // add r1.w, r1.w, -c0.z
        temp1.w = temp1.w + float1(1);
        // endrep
    }
    // mad r0.xyz, r3, r0, r1
    temp0.xyz = temp3.xyz * temp0.xyz + temp1.xyz;
    // mul oC0.w, r0.w, v6.w
    out_color.w = temp0.w * i.color.w;
    // mul r0.xyz, r0, c2
    temp0.xyz = temp0.xyz * TintColor.xyz;
    // texld r1, v5, s3
    temp1 = tex2D(ShroudTextureSampler, i.texcoord6.xy);
    // mul oC0.xyz, r0, r1
    out_color.xyz = temp0.xyz * temp1.xyz;
    // 

    return out_color;
}

// PS_H_Array_Shader_1 Pixel_3_0 Has PRES False
struct PS_H_Array_Shader_1_Input
{
    float2 texcoord : TEXCOORD;
    float3 texcoord1 : TEXCOORD1;
    float3 texcoord2 : TEXCOORD2;
    float3 texcoord3 : TEXCOORD3;
    float3 texcoord4 : TEXCOORD4;
    float3 texcoord5 : TEXCOORD5;
    float4 texcoord6 : TEXCOORD6;
    float4 color : COLOR;
};

float4 PS_H_Array_Shader_1(PS_H_Array_Shader_1_Input i) : COLOR
{
    float4 out_color;
    float4 temp0, temp1, temp2, temp3, temp4, temp5, temp6;
    float3 temp7;
    float2 temp8;
    // def c0, 2.2, 2, -1, -0
    // def c1, -0, -1, -2, -3
    // def c3, 0.25, 0, 0, 0
    // def c4, -4, -5, -6, -7
    // dcl_texcoord v0.xy
    // dcl_texcoord1_centroid v1.xyz
    // dcl_texcoord2_centroid v2.xyz
    // dcl_texcoord3_centroid v3.xyz
    // dcl_texcoord4 v4.xyz
    // dcl_texcoord5 v5.xyz
    // dcl_texcoord6 v6
    // dcl_color v7
    // dcl_2d s0
    // dcl_2d s1
    // dcl_2d s2
    // dcl_2d s3
    // dcl_2d s4
    // texld r0, v0, s2
    temp0 = tex2D(DiffuseTextureSampler, i.texcoord.xy);
    // log r1.x, r0.x
    temp1.x = log2(temp0.x);
    // log r1.y, r0.y
    temp1.y = log2(temp0.y);
    // log r1.z, r0.z
    temp1.z = log2(temp0.z);
    // mul r0.xyz, r1, c0.x
    temp0.xyz = temp1.xyz * float3(2.2, 2.2, 2.2);
    // exp r1.x, r0.x
    temp1.x = exp2(temp0.x);
    // exp r1.y, r0.y
    temp1.y = exp2(temp0.y);
    // exp r1.z, r0.z
    temp1.z = exp2(temp0.z);
    // mul r0.xyz, r1, c13
    temp0.xyz = temp1.xyz * DiffuseColor.xyz;
    // texld r2, v0, s3
    temp2 = tex2D(NormalMapSampler, i.texcoord.xy);
    // mad r2.xyz, r2, c0.y, c0.z
    temp2.xyz = temp2.xyz * float3(2, 2, 2) + float3(-1, -1, -1);
    // mul r2.xy, r2, c12.x
    temp2.xy = temp2.xy * BumpScale.xx;
    // dp3 r3.x, r2, v1
    temp3.x = dot(temp2.xyz, i.texcoord1.xyz);
    // dp3 r3.y, r2, v2
    temp3.y = dot(temp2.xyz, i.texcoord2.xyz);
    // dp3 r3.z, r2, v3
    temp3.z = dot(temp2.xyz, i.texcoord3.xyz);
    // nrm r2.xyz, r3
    temp2.xyz = normalize(temp3.xyz).xyz;
    // texld r3, v5, s0
    temp3 = tex2D(ShadowMapSampler, i.texcoord5.xy);
    // add r4.xy, c11.zxzw, v5
    temp4.xy = Shadowmap_Zero_Zero_OneOverMapSize_OneOverMapSize.zx + i.texcoord5.xy;
    // texld r4, r4, s0
    temp4 = tex2D(ShadowMapSampler, temp4.xy);
    // add r4.yz, c11, v5.xxyw
    temp4.yz = Shadowmap_Zero_Zero_OneOverMapSize_OneOverMapSize.yz + i.texcoord5.xy;
    // texld r5, r4.yzzw, s0
    temp5 = tex2D(ShadowMapSampler, temp4.yz);
    // add r4.yz, c11.xwzw, v5.xxyw
    temp4.yz = Shadowmap_Zero_Zero_OneOverMapSize_OneOverMapSize.wz + i.texcoord5.xy;
    // texld r6, r4.yzzw, s0
    temp6 = tex2D(ShadowMapSampler, temp4.yz);
    // mov r3.y, r4.x
    temp3.y = temp4.x;
    // mov r3.z, r5.x
    temp3.z = temp5.x;
    // mov r3.w, r6.x
    temp3.w = temp6.x;
    // add r3, r3, -v5.z
    temp3 = temp3 + -i.texcoord5.z;
    // cmp r3, r3, -c0.z, -c0.w
    temp3 = (temp3 >= 0) ? float4(1, 1, 1, 1) : float4(0, 0, 0, 0);
    // dp4 r1.w, -c0.z, r3
    temp1.w = dot(float4(1, 1, 1, 1), temp3);
    // mul r1.w, r1.w, c3.x
    temp1.w = temp1.w * float1(0.25);
    // texld r3, v6.zwzw, s1
    temp3 = tex2D(CloudTextureSampler, i.texcoord6.zw);
    // log r4.x, r3.x
    temp4.x = log2(temp3.x);
    // log r4.y, r3.y
    temp4.y = log2(temp3.y);
    // log r4.z, r3.z
    temp4.z = log2(temp3.z);
    // mul r3.xyz, r4, c0.x
    temp3.xyz = temp4.xyz * float3(2.2, 2.2, 2.2);
    // exp r4.x, r3.x
    temp4.x = exp2(temp3.x);
    // exp r4.y, r3.y
    temp4.y = exp2(temp3.y);
    // exp r4.z, r3.z
    temp4.z = exp2(temp3.z);
    // mul r3.xyz, r1.w, r4
    temp3.xyz = temp1.www * temp4.xyz;
    // dp3 r1.w, r2, c6
    temp1.w = dot(temp2.xyz, DirectionalLight[0].Direction.xyz);
    // max r2.w, r1.w, -c0.w
    temp2.w = max(temp1.w, float1(0));
    // mul r3.xyz, r3, c5
    temp3.xyz = temp3.xyz * DirectionalLight[0].Color.xyz;
    // mul r4.xyz, r0, r2.w
    temp4.xyz = temp0.xyz * temp2.www;
    // mul r3.xyz, r3, r4
    temp3.xyz = temp3.xyz * temp4.xyz;
    // mad r1.xyz, r1, v7, r3
    temp1.xyz = temp1.xyz * i.color.xyz + temp3.xyz;
    // dp3 r1.w, r2, c8
    temp1.w = dot(temp2.xyz, DirectionalLight[1].Direction.xyz);
    // max r2.w, r1.w, -c0.w
    temp2.w = max(temp1.w, float1(0));
    // mul r3.xyz, r0, r2.w
    temp3.xyz = temp0.xyz * temp2.www;
    // mad r1.xyz, c7, r3, r1
    temp1.xyz = DirectionalLight[1].Color.xyz * temp3.xyz + temp1.xyz;
    // mov r3.xyz, -c0.w
    temp3.xyz = float3(0, 0, 0);
    // mov r1.w, -c0.w
    temp1.w = float1(0);
    // rep i0
    for (int it0 = 0; it0 < NumPointLights; ++it0) {
        // add r4, r1.w, c1
        temp4 = temp1.w + float4(-0, -1, -2, -3);
        // add r5, r1.w, c4
        temp5 = temp1.w + float4(-4, -5, -6, -7);
        // mov r2.w, c0.w
        temp2.w = float1(-0);
        // cmp r6.xyz, -r4_abs.x, c89, -r2.w
        temp6.xyz = (-abs(temp4).xxx >= 0) ? PointLight[0].Color.xyz : -temp2.www;
        // cmp r7.xyz, -r4_abs.x, c90, -r2.w
        temp7.xyz = (-abs(temp4).xxx >= 0) ? PointLight[0].Position.xyz : -temp2.www;
        // cmp r8.xy, -r4_abs.x, c91, -r2.w
        temp8.xy = (-abs(temp4).xx >= 0) ? PointLight[0].Range_Inner_Outer.xy : -temp2.ww;
        // cmp r6.xyz, -r4_abs.y, c92, r6
        temp6.xyz = (-abs(temp4).yyy >= 0) ? PointLight[1].Color.xyz : temp6.xyz;
        // cmp r7.xyz, -r4_abs.y, c93, r7
        temp7.xyz = (-abs(temp4).yyy >= 0) ? PointLight[1].Position.xyz : temp7.xyz;
        // cmp r4.xy, -r4_abs.y, c94, r8
        temp4.xy = (-abs(temp4).yy >= 0) ? PointLight[1].Range_Inner_Outer.xy : temp8.xy;
        // cmp r6.xyz, -r4_abs.z, c95, r6
        temp6.xyz = (-abs(temp4).zzz >= 0) ? PointLight[2].Color.xyz : temp6.xyz;
        // cmp r7.xyz, -r4_abs.z, c96, r7
        temp7.xyz = (-abs(temp4).zzz >= 0) ? PointLight[2].Position.xyz : temp7.xyz;
        // cmp r4.xy, -r4_abs.z, c97, r4
        temp4.xy = (-abs(temp4).zz >= 0) ? PointLight[2].Range_Inner_Outer.xy : temp4.xy;
        // cmp r6.xyz, -r4_abs.w, c98, r6
        temp6.xyz = (-abs(temp4).www >= 0) ? PointLight[3].Color.xyz : temp6.xyz;
        // cmp r7.xyz, -r4_abs.w, c99, r7
        temp7.xyz = (-abs(temp4).www >= 0) ? PointLight[3].Position.xyz : temp7.xyz;
        // cmp r4.xy, -r4_abs.w, c100, r4
        temp4.xy = (-abs(temp4).ww >= 0) ? PointLight[3].Range_Inner_Outer.xy : temp4.xy;
        // cmp r6.xyz, -r5_abs.x, c101, r6
        temp6.xyz = (-abs(temp5).xxx >= 0) ? PointLight[4].Color.xyz : temp6.xyz;
        // cmp r7.xyz, -r5_abs.x, c102, r7
        temp7.xyz = (-abs(temp5).xxx >= 0) ? PointLight[4].Position.xyz : temp7.xyz;
        // cmp r4.xy, -r5_abs.x, c103, r4
        temp4.xy = (-abs(temp5).xx >= 0) ? PointLight[4].Range_Inner_Outer.xy : temp4.xy;
        // cmp r6.xyz, -r5_abs.y, c104, r6
        temp6.xyz = (-abs(temp5).yyy >= 0) ? PointLight[5].Color.xyz : temp6.xyz;
        // cmp r7.xyz, -r5_abs.y, c105, r7
        temp7.xyz = (-abs(temp5).yyy >= 0) ? PointLight[5].Position.xyz : temp7.xyz;
        // cmp r4.xy, -r5_abs.y, c106, r4
        temp4.xy = (-abs(temp5).yy >= 0) ? PointLight[5].Range_Inner_Outer.xy : temp4.xy;
        // cmp r6.xyz, -r5_abs.z, c107, r6
        temp6.xyz = (-abs(temp5).zzz >= 0) ? PointLight[6].Color.xyz : temp6.xyz;
        // cmp r7.xyz, -r5_abs.z, c108, r7
        temp7.xyz = (-abs(temp5).zzz >= 0) ? PointLight[6].Position.xyz : temp7.xyz;
        // cmp r4.xy, -r5_abs.z, c109, r4
        temp4.xy = (-abs(temp5).zz >= 0) ? PointLight[6].Range_Inner_Outer.xy : temp4.xy;
        // cmp r5.xyz, -r5_abs.w, c110, r6
        temp5.xyz = (-abs(temp5).www >= 0) ? PointLight[7].Color.xyz : temp6.xyz;
        // cmp r6.xyz, -r5_abs.w, c111, r7
        temp6.xyz = (-abs(temp5).www >= 0) ? PointLight[7].Position.xyz : temp7.xyz;
        // cmp r4.xy, -r5_abs.w, c112, r4
        temp4.xy = (-abs(temp5).ww >= 0) ? PointLight[7].Range_Inner_Outer.xy : temp4.xy;
        // add r6.xyz, r6, -v4
        temp6.xyz = temp6.xyz + -i.texcoord4.xyz;
        // dp3 r2.w, r6, r6
        temp2.w = dot(temp6.xyz, temp6.xyz);
        // rsq r2.w, r2.w
        temp2.w = 1 / sqrt(temp2.w);
        // rcp r3.w, r2.w
        temp3.w = 1.0f / temp2.w;
        // mul r6.xyz, r6, r2.w
        temp6.xyz = temp6.xyz * temp2.www;
        // add r2.w, -r4.x, r3.w
        temp2.w = -temp4.x + temp3.w;
        // add r3.w, -r4.x, r4.y
        temp3.w = -temp4.x + temp4.y;
        // rcp r3.w, r3.w
        temp3.w = 1.0f / temp3.w;
        // mad_sat r2.w, r2.w, -r3.w, -c0.z
        temp2.w = saturate(temp2.w * -temp3.w + float1(1));
        // mul r2.w, r2.w, r2.w
        temp2.w = temp2.w * temp2.w;
        // mul r4.xyz, r5, r2.w
        temp4.xyz = temp5.xyz * temp2.www;
        // dp3 r2.w, r2, r6
        temp2.w = dot(temp2.xyz, temp6.xyz);
        // max r3.w, r2.w, -c0.w
        temp3.w = max(temp2.w, float1(0));
        // mad r3.xyz, r4, r3.w, r3
        temp3.xyz = temp4.xyz * temp3.www + temp3.xyz;
        // add r1.w, r1.w, -c0.z
        temp1.w = temp1.w + float1(1);
        // endrep
    }
    // mad r0.xyz, r3, r0, r1
    temp0.xyz = temp3.xyz * temp0.xyz + temp1.xyz;
    // mul oC0.w, r0.w, v7.w
    out_color.w = temp0.w * i.color.w;
    // mul r0.xyz, r0, c2
    temp0.xyz = temp0.xyz * TintColor.xyz;
    // texld r1, v6, s4
    temp1 = tex2D(ShroudTextureSampler, i.texcoord6.xy);
    // mul oC0.xyz, r0, r1
    out_color.xyz = temp0.xyz * temp1.xyz;
    // 

    return out_color;
}

// PS_H_Array_Shader_2 Pixel_3_0 Has PRES False
struct PS_H_Array_Shader_2_Input
{
    float2 texcoord : TEXCOORD;
    float3 texcoord1 : TEXCOORD1;
    float3 texcoord2 : TEXCOORD2;
    float3 texcoord3 : TEXCOORD3;
    float3 texcoord4 : TEXCOORD4;
    float4 texcoord6 : TEXCOORD6;
    float4 color : COLOR;
};

float4 PS_H_Array_Shader_2(PS_H_Array_Shader_2_Input i) : COLOR
{
    float4 out_color;
    float4 temp0, temp1, temp2, temp3, temp4, temp5;
    float3 temp6, temp7;
    float2 temp8;
    // def c0, 2.2, 2, -1, 0
    // def c1, -0, -1, -2, -3
    // def c3, -4, -5, -6, -7
    // dcl_texcoord v0.xy
    // dcl_texcoord1_centroid v1.xyz
    // dcl_texcoord2_centroid v2.xyz
    // dcl_texcoord3_centroid v3.xyz
    // dcl_texcoord4 v4.xyz
    // dcl_texcoord6 v5
    // dcl_color v6
    // dcl_2d s0
    // dcl_2d s1
    // dcl_2d s2
    // dcl_2d s3
    // texld r0, v0, s1
    temp0 = tex2D(DiffuseTextureSampler, i.texcoord.xy);
    // log r1.x, r0.x
    temp1.x = log2(temp0.x);
    // log r1.y, r0.y
    temp1.y = log2(temp0.y);
    // log r1.z, r0.z
    temp1.z = log2(temp0.z);
    // mul r0.xyz, r1, c0.x
    temp0.xyz = temp1.xyz * float3(2.2, 2.2, 2.2);
    // exp r1.x, r0.x
    temp1.x = exp2(temp0.x);
    // exp r1.y, r0.y
    temp1.y = exp2(temp0.y);
    // exp r1.z, r0.z
    temp1.z = exp2(temp0.z);
    // mul r0.xyz, r1, c12
    temp0.xyz = temp1.xyz * DiffuseColor.xyz;
    // texld r2, v0, s2
    temp2 = tex2D(NormalMapSampler, i.texcoord.xy);
    // mad r2.xyz, r2, c0.y, c0.z
    temp2.xyz = temp2.xyz * float3(2, 2, 2) + float3(-1, -1, -1);
    // mul r2.xy, r2, c11.x
    temp2.xy = temp2.xy * BumpScale.xx;
    // dp3 r3.x, r2, v1
    temp3.x = dot(temp2.xyz, i.texcoord1.xyz);
    // dp3 r3.y, r2, v2
    temp3.y = dot(temp2.xyz, i.texcoord2.xyz);
    // dp3 r3.z, r2, v3
    temp3.z = dot(temp2.xyz, i.texcoord3.xyz);
    // nrm r2.xyz, r3
    temp2.xyz = normalize(temp3.xyz).xyz;
    // texld r3, v5.zwzw, s0
    temp3 = tex2D(CloudTextureSampler, i.texcoord6.zw);
    // log r4.x, r3.x
    temp4.x = log2(temp3.x);
    // log r4.y, r3.y
    temp4.y = log2(temp3.y);
    // log r4.z, r3.z
    temp4.z = log2(temp3.z);
    // mul r3.xyz, r4, c0.x
    temp3.xyz = temp4.xyz * float3(2.2, 2.2, 2.2);
    // exp r4.x, r3.x
    temp4.x = exp2(temp3.x);
    // exp r4.y, r3.y
    temp4.y = exp2(temp3.y);
    // exp r4.z, r3.z
    temp4.z = exp2(temp3.z);
    // dp3 r1.w, r2, c6
    temp1.w = dot(temp2.xyz, DirectionalLight[0].Direction.xyz);
    // max r2.w, r1.w, c0.w
    temp2.w = max(temp1.w, float1(0));
    // mul r3.xyz, r4, c5
    temp3.xyz = temp4.xyz * DirectionalLight[0].Color.xyz;
    // mul r4.xyz, r0, r2.w
    temp4.xyz = temp0.xyz * temp2.www;
    // mul r3.xyz, r3, r4
    temp3.xyz = temp3.xyz * temp4.xyz;
    // mad r1.xyz, r1, v6, r3
    temp1.xyz = temp1.xyz * i.color.xyz + temp3.xyz;
    // dp3 r1.w, r2, c8
    temp1.w = dot(temp2.xyz, DirectionalLight[1].Direction.xyz);
    // max r2.w, r1.w, c0.w
    temp2.w = max(temp1.w, float1(0));
    // mul r3.xyz, r0, r2.w
    temp3.xyz = temp0.xyz * temp2.www;
    // mad r1.xyz, c7, r3, r1
    temp1.xyz = DirectionalLight[1].Color.xyz * temp3.xyz + temp1.xyz;
    // mov r3.xyz, c0.w
    temp3.xyz = float3(0, 0, 0);
    // mov r1.w, c0.w
    temp1.w = float1(0);
    // rep i0
    for (int it0 = 0; it0 < NumPointLights; ++it0) {
        // add r4, r1.w, c1
        temp4 = temp1.w + float4(-0, -1, -2, -3);
        // add r5, r1.w, c3
        temp5 = temp1.w + float4(-4, -5, -6, -7);
        // mov r2.w, c0.w
        temp2.w = float1(0);
        // cmp r6.xyz, -r4_abs.x, c89, r2.w
        temp6.xyz = (-abs(temp4).xxx >= 0) ? PointLight[0].Color.xyz : temp2.www;
        // cmp r7.xyz, -r4_abs.x, c90, r2.w
        temp7.xyz = (-abs(temp4).xxx >= 0) ? PointLight[0].Position.xyz : temp2.www;
        // cmp r8.xy, -r4_abs.x, c91, r2.w
        temp8.xy = (-abs(temp4).xx >= 0) ? PointLight[0].Range_Inner_Outer.xy : temp2.ww;
        // cmp r6.xyz, -r4_abs.y, c92, r6
        temp6.xyz = (-abs(temp4).yyy >= 0) ? PointLight[1].Color.xyz : temp6.xyz;
        // cmp r7.xyz, -r4_abs.y, c93, r7
        temp7.xyz = (-abs(temp4).yyy >= 0) ? PointLight[1].Position.xyz : temp7.xyz;
        // cmp r4.xy, -r4_abs.y, c94, r8
        temp4.xy = (-abs(temp4).yy >= 0) ? PointLight[1].Range_Inner_Outer.xy : temp8.xy;
        // cmp r6.xyz, -r4_abs.z, c95, r6
        temp6.xyz = (-abs(temp4).zzz >= 0) ? PointLight[2].Color.xyz : temp6.xyz;
        // cmp r7.xyz, -r4_abs.z, c96, r7
        temp7.xyz = (-abs(temp4).zzz >= 0) ? PointLight[2].Position.xyz : temp7.xyz;
        // cmp r4.xy, -r4_abs.z, c97, r4
        temp4.xy = (-abs(temp4).zz >= 0) ? PointLight[2].Range_Inner_Outer.xy : temp4.xy;
        // cmp r6.xyz, -r4_abs.w, c98, r6
        temp6.xyz = (-abs(temp4).www >= 0) ? PointLight[3].Color.xyz : temp6.xyz;
        // cmp r7.xyz, -r4_abs.w, c99, r7
        temp7.xyz = (-abs(temp4).www >= 0) ? PointLight[3].Position.xyz : temp7.xyz;
        // cmp r4.xy, -r4_abs.w, c100, r4
        temp4.xy = (-abs(temp4).ww >= 0) ? PointLight[3].Range_Inner_Outer.xy : temp4.xy;
        // cmp r6.xyz, -r5_abs.x, c101, r6
        temp6.xyz = (-abs(temp5).xxx >= 0) ? PointLight[4].Color.xyz : temp6.xyz;
        // cmp r7.xyz, -r5_abs.x, c102, r7
        temp7.xyz = (-abs(temp5).xxx >= 0) ? PointLight[4].Position.xyz : temp7.xyz;
        // cmp r4.xy, -r5_abs.x, c103, r4
        temp4.xy = (-abs(temp5).xx >= 0) ? PointLight[4].Range_Inner_Outer.xy : temp4.xy;
        // cmp r6.xyz, -r5_abs.y, c104, r6
        temp6.xyz = (-abs(temp5).yyy >= 0) ? PointLight[5].Color.xyz : temp6.xyz;
        // cmp r7.xyz, -r5_abs.y, c105, r7
        temp7.xyz = (-abs(temp5).yyy >= 0) ? PointLight[5].Position.xyz : temp7.xyz;
        // cmp r4.xy, -r5_abs.y, c106, r4
        temp4.xy = (-abs(temp5).yy >= 0) ? PointLight[5].Range_Inner_Outer.xy : temp4.xy;
        // cmp r6.xyz, -r5_abs.z, c107, r6
        temp6.xyz = (-abs(temp5).zzz >= 0) ? PointLight[6].Color.xyz : temp6.xyz;
        // cmp r7.xyz, -r5_abs.z, c108, r7
        temp7.xyz = (-abs(temp5).zzz >= 0) ? PointLight[6].Position.xyz : temp7.xyz;
        // cmp r4.xy, -r5_abs.z, c109, r4
        temp4.xy = (-abs(temp5).zz >= 0) ? PointLight[6].Range_Inner_Outer.xy : temp4.xy;
        // cmp r5.xyz, -r5_abs.w, c110, r6
        temp5.xyz = (-abs(temp5).www >= 0) ? PointLight[7].Color.xyz : temp6.xyz;
        // cmp r6.xyz, -r5_abs.w, c111, r7
        temp6.xyz = (-abs(temp5).www >= 0) ? PointLight[7].Position.xyz : temp7.xyz;
        // cmp r4.xy, -r5_abs.w, c112, r4
        temp4.xy = (-abs(temp5).ww >= 0) ? PointLight[7].Range_Inner_Outer.xy : temp4.xy;
        // add r6.xyz, r6, -v4
        temp6.xyz = temp6.xyz + -i.texcoord4.xyz;
        // dp3 r2.w, r6, r6
        temp2.w = dot(temp6.xyz, temp6.xyz);
        // rsq r2.w, r2.w
        temp2.w = 1 / sqrt(temp2.w);
        // rcp r3.w, r2.w
        temp3.w = 1.0f / temp2.w;
        // mul r6.xyz, r6, r2.w
        temp6.xyz = temp6.xyz * temp2.www;
        // add r2.w, -r4.x, r3.w
        temp2.w = -temp4.x + temp3.w;
        // add r3.w, -r4.x, r4.y
        temp3.w = -temp4.x + temp4.y;
        // rcp r3.w, r3.w
        temp3.w = 1.0f / temp3.w;
        // mad_sat r2.w, r2.w, -r3.w, -c0.z
        temp2.w = saturate(temp2.w * -temp3.w + float1(1));
        // mul r2.w, r2.w, r2.w
        temp2.w = temp2.w * temp2.w;
        // mul r4.xyz, r5, r2.w
        temp4.xyz = temp5.xyz * temp2.www;
        // dp3 r2.w, r2, r6
        temp2.w = dot(temp2.xyz, temp6.xyz);
        // max r3.w, r2.w, c0.w
        temp3.w = max(temp2.w, float1(0));
        // mad r3.xyz, r4, r3.w, r3
        temp3.xyz = temp4.xyz * temp3.www + temp3.xyz;
        // add r1.w, r1.w, -c0.z
        temp1.w = temp1.w + float1(1);
        // endrep
    }
    // mad r0.xyz, r3, r0, r1
    temp0.xyz = temp3.xyz * temp0.xyz + temp1.xyz;
    // mul oC0.w, r0.w, v6.w
    out_color.w = temp0.w * i.color.w;
    // mul r0.xyz, r0, c2
    temp0.xyz = temp0.xyz * TintColor.xyz;
    // texld r1, v5, s3
    temp1 = tex2D(ShroudTextureSampler, i.texcoord6.xy);
    // mul oC0.xyz, r0, r1
    out_color.xyz = temp0.xyz * temp1.xyz;
    // 

    return out_color;
}

// PS_H_Array_Shader_3 Pixel_3_0 Has PRES False
struct PS_H_Array_Shader_3_Input
{
    float2 texcoord : TEXCOORD;
    float3 texcoord1 : TEXCOORD1;
    float3 texcoord2 : TEXCOORD2;
    float3 texcoord3 : TEXCOORD3;
    float3 texcoord4 : TEXCOORD4;
    float3 texcoord5 : TEXCOORD5;
    float4 texcoord6 : TEXCOORD6;
    float4 color : COLOR;
};

float4 PS_H_Array_Shader_3(PS_H_Array_Shader_3_Input i) : COLOR
{
    float4 out_color;
    float4 temp0, temp1, temp2, temp3, temp4, temp5, temp6;
    float3 temp7;
    float2 temp8;
    // def c0, 2.2, 2, -1, -0
    // def c1, -0, -1, -2, -3
    // def c3, 0.25, 0, 0, 0
    // def c4, -4, -5, -6, -7
    // dcl_texcoord v0.xy
    // dcl_texcoord1_centroid v1.xyz
    // dcl_texcoord2_centroid v2.xyz
    // dcl_texcoord3_centroid v3.xyz
    // dcl_texcoord4 v4.xyz
    // dcl_texcoord5 v5.xyz
    // dcl_texcoord6 v6
    // dcl_color v7
    // dcl_2d s0
    // dcl_2d s1
    // dcl_2d s2
    // dcl_2d s3
    // dcl_2d s4
    // texld r0, v0, s2
    temp0 = tex2D(DiffuseTextureSampler, i.texcoord.xy);
    // log r1.x, r0.x
    temp1.x = log2(temp0.x);
    // log r1.y, r0.y
    temp1.y = log2(temp0.y);
    // log r1.z, r0.z
    temp1.z = log2(temp0.z);
    // mul r0.xyz, r1, c0.x
    temp0.xyz = temp1.xyz * float3(2.2, 2.2, 2.2);
    // exp r1.x, r0.x
    temp1.x = exp2(temp0.x);
    // exp r1.y, r0.y
    temp1.y = exp2(temp0.y);
    // exp r1.z, r0.z
    temp1.z = exp2(temp0.z);
    // mul r0.xyz, r1, c13
    temp0.xyz = temp1.xyz * DiffuseColor.xyz;
    // texld r2, v0, s3
    temp2 = tex2D(NormalMapSampler, i.texcoord.xy);
    // mad r2.xyz, r2, c0.y, c0.z
    temp2.xyz = temp2.xyz * float3(2, 2, 2) + float3(-1, -1, -1);
    // mul r2.xy, r2, c12.x
    temp2.xy = temp2.xy * BumpScale.xx;
    // dp3 r3.x, r2, v1
    temp3.x = dot(temp2.xyz, i.texcoord1.xyz);
    // dp3 r3.y, r2, v2
    temp3.y = dot(temp2.xyz, i.texcoord2.xyz);
    // dp3 r3.z, r2, v3
    temp3.z = dot(temp2.xyz, i.texcoord3.xyz);
    // nrm r2.xyz, r3
    temp2.xyz = normalize(temp3.xyz).xyz;
    // texld r3, v5, s0
    temp3 = tex2D(ShadowMapSampler, i.texcoord5.xy);
    // add r4.xy, c11.zxzw, v5
    temp4.xy = Shadowmap_Zero_Zero_OneOverMapSize_OneOverMapSize.zx + i.texcoord5.xy;
    // texld r4, r4, s0
    temp4 = tex2D(ShadowMapSampler, temp4.xy);
    // add r4.yz, c11, v5.xxyw
    temp4.yz = Shadowmap_Zero_Zero_OneOverMapSize_OneOverMapSize.yz + i.texcoord5.xy;
    // texld r5, r4.yzzw, s0
    temp5 = tex2D(ShadowMapSampler, temp4.yz);
    // add r4.yz, c11.xwzw, v5.xxyw
    temp4.yz = Shadowmap_Zero_Zero_OneOverMapSize_OneOverMapSize.wz + i.texcoord5.xy;
    // texld r6, r4.yzzw, s0
    temp6 = tex2D(ShadowMapSampler, temp4.yz);
    // mov r3.y, r4.x
    temp3.y = temp4.x;
    // mov r3.z, r5.x
    temp3.z = temp5.x;
    // mov r3.w, r6.x
    temp3.w = temp6.x;
    // add r3, r3, -v5.z
    temp3 = temp3 + -i.texcoord5.z;
    // cmp r3, r3, -c0.z, -c0.w
    temp3 = (temp3 >= 0) ? float4(1, 1, 1, 1) : float4(0, 0, 0, 0);
    // dp4 r1.w, -c0.z, r3
    temp1.w = dot(float4(1, 1, 1, 1), temp3);
    // mul r1.w, r1.w, c3.x
    temp1.w = temp1.w * float1(0.25);
    // texld r3, v6.zwzw, s1
    temp3 = tex2D(CloudTextureSampler, i.texcoord6.zw);
    // log r4.x, r3.x
    temp4.x = log2(temp3.x);
    // log r4.y, r3.y
    temp4.y = log2(temp3.y);
    // log r4.z, r3.z
    temp4.z = log2(temp3.z);
    // mul r3.xyz, r4, c0.x
    temp3.xyz = temp4.xyz * float3(2.2, 2.2, 2.2);
    // exp r4.x, r3.x
    temp4.x = exp2(temp3.x);
    // exp r4.y, r3.y
    temp4.y = exp2(temp3.y);
    // exp r4.z, r3.z
    temp4.z = exp2(temp3.z);
    // mul r3.xyz, r1.w, r4
    temp3.xyz = temp1.www * temp4.xyz;
    // dp3 r1.w, r2, c6
    temp1.w = dot(temp2.xyz, DirectionalLight[0].Direction.xyz);
    // max r2.w, r1.w, -c0.w
    temp2.w = max(temp1.w, float1(0));
    // mul r3.xyz, r3, c5
    temp3.xyz = temp3.xyz * DirectionalLight[0].Color.xyz;
    // mul r4.xyz, r0, r2.w
    temp4.xyz = temp0.xyz * temp2.www;
    // mul r3.xyz, r3, r4
    temp3.xyz = temp3.xyz * temp4.xyz;
    // mad r1.xyz, r1, v7, r3
    temp1.xyz = temp1.xyz * i.color.xyz + temp3.xyz;
    // dp3 r1.w, r2, c8
    temp1.w = dot(temp2.xyz, DirectionalLight[1].Direction.xyz);
    // max r2.w, r1.w, -c0.w
    temp2.w = max(temp1.w, float1(0));
    // mul r3.xyz, r0, r2.w
    temp3.xyz = temp0.xyz * temp2.www;
    // mad r1.xyz, c7, r3, r1
    temp1.xyz = DirectionalLight[1].Color.xyz * temp3.xyz + temp1.xyz;
    // mov r3.xyz, -c0.w
    temp3.xyz = float3(0, 0, 0);
    // mov r1.w, -c0.w
    temp1.w = float1(0);
    // rep i0
    for (int it0 = 0; it0 < NumPointLights; ++it0) {
        // add r4, r1.w, c1
        temp4 = temp1.w + float4(-0, -1, -2, -3);
        // add r5, r1.w, c4
        temp5 = temp1.w + float4(-4, -5, -6, -7);
        // mov r2.w, c0.w
        temp2.w = float1(-0);
        // cmp r6.xyz, -r4_abs.x, c89, -r2.w
        temp6.xyz = (-abs(temp4).xxx >= 0) ? PointLight[0].Color.xyz : -temp2.www;
        // cmp r7.xyz, -r4_abs.x, c90, -r2.w
        temp7.xyz = (-abs(temp4).xxx >= 0) ? PointLight[0].Position.xyz : -temp2.www;
        // cmp r8.xy, -r4_abs.x, c91, -r2.w
        temp8.xy = (-abs(temp4).xx >= 0) ? PointLight[0].Range_Inner_Outer.xy : -temp2.ww;
        // cmp r6.xyz, -r4_abs.y, c92, r6
        temp6.xyz = (-abs(temp4).yyy >= 0) ? PointLight[1].Color.xyz : temp6.xyz;
        // cmp r7.xyz, -r4_abs.y, c93, r7
        temp7.xyz = (-abs(temp4).yyy >= 0) ? PointLight[1].Position.xyz : temp7.xyz;
        // cmp r4.xy, -r4_abs.y, c94, r8
        temp4.xy = (-abs(temp4).yy >= 0) ? PointLight[1].Range_Inner_Outer.xy : temp8.xy;
        // cmp r6.xyz, -r4_abs.z, c95, r6
        temp6.xyz = (-abs(temp4).zzz >= 0) ? PointLight[2].Color.xyz : temp6.xyz;
        // cmp r7.xyz, -r4_abs.z, c96, r7
        temp7.xyz = (-abs(temp4).zzz >= 0) ? PointLight[2].Position.xyz : temp7.xyz;
        // cmp r4.xy, -r4_abs.z, c97, r4
        temp4.xy = (-abs(temp4).zz >= 0) ? PointLight[2].Range_Inner_Outer.xy : temp4.xy;
        // cmp r6.xyz, -r4_abs.w, c98, r6
        temp6.xyz = (-abs(temp4).www >= 0) ? PointLight[3].Color.xyz : temp6.xyz;
        // cmp r7.xyz, -r4_abs.w, c99, r7
        temp7.xyz = (-abs(temp4).www >= 0) ? PointLight[3].Position.xyz : temp7.xyz;
        // cmp r4.xy, -r4_abs.w, c100, r4
        temp4.xy = (-abs(temp4).ww >= 0) ? PointLight[3].Range_Inner_Outer.xy : temp4.xy;
        // cmp r6.xyz, -r5_abs.x, c101, r6
        temp6.xyz = (-abs(temp5).xxx >= 0) ? PointLight[4].Color.xyz : temp6.xyz;
        // cmp r7.xyz, -r5_abs.x, c102, r7
        temp7.xyz = (-abs(temp5).xxx >= 0) ? PointLight[4].Position.xyz : temp7.xyz;
        // cmp r4.xy, -r5_abs.x, c103, r4
        temp4.xy = (-abs(temp5).xx >= 0) ? PointLight[4].Range_Inner_Outer.xy : temp4.xy;
        // cmp r6.xyz, -r5_abs.y, c104, r6
        temp6.xyz = (-abs(temp5).yyy >= 0) ? PointLight[5].Color.xyz : temp6.xyz;
        // cmp r7.xyz, -r5_abs.y, c105, r7
        temp7.xyz = (-abs(temp5).yyy >= 0) ? PointLight[5].Position.xyz : temp7.xyz;
        // cmp r4.xy, -r5_abs.y, c106, r4
        temp4.xy = (-abs(temp5).yy >= 0) ? PointLight[5].Range_Inner_Outer.xy : temp4.xy;
        // cmp r6.xyz, -r5_abs.z, c107, r6
        temp6.xyz = (-abs(temp5).zzz >= 0) ? PointLight[6].Color.xyz : temp6.xyz;
        // cmp r7.xyz, -r5_abs.z, c108, r7
        temp7.xyz = (-abs(temp5).zzz >= 0) ? PointLight[6].Position.xyz : temp7.xyz;
        // cmp r4.xy, -r5_abs.z, c109, r4
        temp4.xy = (-abs(temp5).zz >= 0) ? PointLight[6].Range_Inner_Outer.xy : temp4.xy;
        // cmp r5.xyz, -r5_abs.w, c110, r6
        temp5.xyz = (-abs(temp5).www >= 0) ? PointLight[7].Color.xyz : temp6.xyz;
        // cmp r6.xyz, -r5_abs.w, c111, r7
        temp6.xyz = (-abs(temp5).www >= 0) ? PointLight[7].Position.xyz : temp7.xyz;
        // cmp r4.xy, -r5_abs.w, c112, r4
        temp4.xy = (-abs(temp5).ww >= 0) ? PointLight[7].Range_Inner_Outer.xy : temp4.xy;
        // add r6.xyz, r6, -v4
        temp6.xyz = temp6.xyz + -i.texcoord4.xyz;
        // dp3 r2.w, r6, r6
        temp2.w = dot(temp6.xyz, temp6.xyz);
        // rsq r2.w, r2.w
        temp2.w = 1 / sqrt(temp2.w);
        // rcp r3.w, r2.w
        temp3.w = 1.0f / temp2.w;
        // mul r6.xyz, r6, r2.w
        temp6.xyz = temp6.xyz * temp2.www;
        // add r2.w, -r4.x, r3.w
        temp2.w = -temp4.x + temp3.w;
        // add r3.w, -r4.x, r4.y
        temp3.w = -temp4.x + temp4.y;
        // rcp r3.w, r3.w
        temp3.w = 1.0f / temp3.w;
        // mad_sat r2.w, r2.w, -r3.w, -c0.z
        temp2.w = saturate(temp2.w * -temp3.w + float1(1));
        // mul r2.w, r2.w, r2.w
        temp2.w = temp2.w * temp2.w;
        // mul r4.xyz, r5, r2.w
        temp4.xyz = temp5.xyz * temp2.www;
        // dp3 r2.w, r2, r6
        temp2.w = dot(temp2.xyz, temp6.xyz);
        // max r3.w, r2.w, -c0.w
        temp3.w = max(temp2.w, float1(0));
        // mad r3.xyz, r4, r3.w, r3
        temp3.xyz = temp4.xyz * temp3.www + temp3.xyz;
        // add r1.w, r1.w, -c0.z
        temp1.w = temp1.w + float1(1);
        // endrep
    }
    // mad r0.xyz, r3, r0, r1
    temp0.xyz = temp3.xyz * temp0.xyz + temp1.xyz;
    // mul oC0.w, r0.w, v7.w
    out_color.w = temp0.w * i.color.w;
    // mul r0.xyz, r0, c2
    temp0.xyz = temp0.xyz * TintColor.xyz;
    // texld r1, v6, s4
    temp1 = tex2D(ShroudTextureSampler, i.texcoord6.xy);
    // mul oC0.xyz, r0, r1
    out_color.xyz = temp0.xyz * temp1.xyz;
    // 

    return out_color;
}

PixelShader PS_H_Array[4] = {
    compile ps_3_0 PS_H_Array_Shader_0(), // 79
    compile ps_3_0 PS_H_Array_Shader_1(), // 80
    compile ps_3_0 PS_H_Array_Shader_2(), // 81
    compile ps_3_0 PS_H_Array_Shader_3(), // 82
};
// VS_M_Array_Shader_0 Vertex_3_0 Has PRES True
struct VS_M_Array_Shader_0_Input
{
    float4 position : POSITION;
    float4 normal : NORMAL;
    float4 tangent : TANGENT;
    float4 binormal : BINORMAL;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct VS_M_Array_Shader_0_Output
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 texcoord1 : TEXCOORD1;
    float3 texcoord2 : TEXCOORD2;
    float4 texcoord3 : TEXCOORD3;
    float4 texcoord4 : TEXCOORD4;
    float2 texcoord5 : TEXCOORD5;
    float4 color : COLOR;
};

VS_M_Array_Shader_0_Output VS_M_Array_Shader_0(VS_M_Array_Shader_0_Input i)
{
    /*
    PRSI
      OutputRegisterOffset: 14
      Unknown1: 0
      Unknown2: 0
      OutputRegisterCount: 1
      Unknown3: 0
      Unknown4: 0
      Unknown5: 14
      Unknown6: 1
      Mappings: 1
        0 - ConstOutput: 0 ConstInput 0
    
    */
    float4 expr14;
    {
        float4 temp0;
        // Expression_2_1
        // mul r0.x, c0.x, (66)
        temp0.x = MapCellSize.x * (66);
        // rcp c14.x, r0.x
        expr14.x = 1.0f / (temp0.x);
    }

    VS_M_Array_Shader_0_Output o;
    float4 temp0, temp1;
    float3 temp2, temp3, temp4;
    // def c0, 1, 0, -1, -0.0015
    // dcl_position v0
    // dcl_normal v1
    // dcl_tangent v2
    // dcl_binormal v3
    // dcl_texcoord v4
    // dcl_color v5
    // dcl_position o0
    // dcl_texcoord o1
    // dcl_texcoord1 o2
    // dcl_texcoord2 o3.xyz
    // dcl_texcoord3 o4
    // dcl_texcoord4 o5
    // dcl_texcoord5 o6.xy
    // dcl_color o7
    // mad r0, v0.xyzx, c0.xxxy, c0.yyyx
    temp0 = i.position.xyzx * float4(1, 1, 1, 0) + float4(0, 0, 0, 1);
    // dp4 r1.z, r0, c126
    temp1.z = dot(temp0, (World._m02_m12_m22_m32));
    // mov r1.w, c0.x
    temp1.w = float1(1);
    // dp4 r1.x, r0, c124
    temp1.x = dot(temp0, (World._m00_m10_m20_m30));
    // dp4 r1.y, r0, c125
    temp1.y = dot(temp0, (World._m01_m11_m21_m31));
    // dp4 o0.x, r1, c119
    o.position.x = dot(temp1, (ViewProjection._m00_m10_m20_m30));
    // dp4 o0.y, r1, c120
    o.position.y = dot(temp1, (ViewProjection._m01_m11_m21_m31));
    // dp4 o0.z, r1, c121
    o.position.z = dot(temp1, (ViewProjection._m02_m12_m22_m32));
    // dp4 o0.w, r1, c122
    o.position.w = dot(temp1, (ViewProjection._m03_m13_m23_m33));
    // dp3 r0.x, v3, c124
    temp0.x = dot(i.binormal.xyz, (World._m00_m10_m20_m30).xyz);
    // dp3 r0.y, v3, c125
    temp0.y = dot(i.binormal.xyz, (World._m01_m11_m21_m31).xyz);
    // dp3 r0.z, v3, c126
    temp0.z = dot(i.binormal.xyz, (World._m02_m12_m22_m32).xyz);
    // dp3 o2.x, c6, -r0
    o.texcoord1.x = dot(DirectionalLight[0].Direction.xyz, -temp0.xyz);
    // dp3 r2.x, v2, c124
    temp2.x = dot(i.tangent.xyz, (World._m00_m10_m20_m30).xyz);
    // dp3 r2.y, v2, c125
    temp2.y = dot(i.tangent.xyz, (World._m01_m11_m21_m31).xyz);
    // dp3 r2.z, v2, c126
    temp2.z = dot(i.tangent.xyz, (World._m02_m12_m22_m32).xyz);
    // dp3 o2.y, c6, -r2
    o.texcoord1.y = dot(DirectionalLight[0].Direction.xyz, -temp2.xyz);
    // dp3 r3.x, v1, c124
    temp3.x = dot(i.normal.xyz, (World._m00_m10_m20_m30).xyz);
    // dp3 r3.y, v1, c125
    temp3.y = dot(i.normal.xyz, (World._m01_m11_m21_m31).xyz);
    // dp3 r3.z, v1, c126
    temp3.z = dot(i.normal.xyz, (World._m02_m12_m22_m32).xyz);
    // dp3 o2.z, c6, r3
    o.texcoord1.z = dot(DirectionalLight[0].Direction.xyz, temp3.xyz);
    // add r4.xyz, -r1, c123
    temp4.xyz = -temp1.xyz + EyePosition.xyz;
    // dp3 r0.w, r4, r4
    temp0.w = dot(temp4.xyz, temp4.xyz);
    // rsq r0.w, r0.w
    temp0.w = 1 / sqrt(temp0.w);
    // mad r4.xyz, r4, r0.w, c6
    temp4.xyz = temp4.xyz * temp0.www + DirectionalLight[0].Direction.xyz;
    // dp3 r0.x, r4, -r0
    temp0.x = dot(temp4.xyz, -temp0.xyz);
    // dp3 r0.y, r4, -r2
    temp0.y = dot(temp4.xyz, -temp2.xyz);
    // dp3 r0.z, r4, r3
    temp0.z = dot(temp4.xyz, temp3.xyz);
    // dp3 r0.w, r0, r0
    temp0.w = dot(temp0.xyz, temp0.xyz);
    // rsq r0.w, r0.w
    temp0.w = 1 / sqrt(temp0.w);
    // mul o3.xyz, r0, r0.w
    o.texcoord2 = temp0 * temp0.w;
    // dp3 r0.x, r3, c10
    temp0.x = dot(temp3.xyz, DirectionalLight[2].Direction.xyz);
    // dp3 r0.y, r3, c8
    temp0.y = dot(temp3.xyz, DirectionalLight[1].Direction.xyz);
    // max r0.x, r0.x, c0.y
    temp0.x = max(temp0.x, float1(0));
    // mul r0.xzw, r0.x, c9.xyyz
    temp0.xzw = temp0.xxx * DirectionalLight[2].Color.xyz;
    // max r0.y, r0.y, c0.y
    temp0.y = max(temp0.y, float1(0));
    // mad r0.xyz, c7, r0.y, r0.xzww
    temp0.xyz = DirectionalLight[1].Color.xyz * temp0.yyy + temp0.xzw;
    // mul r0.xyz, r0, c12
    temp0.xyz = temp0.xyz * DiffuseColor.xyz;
    // mov r2.xyz, c4
    temp2.xyz = AmbientLightColor.xyz;
    // mad r0.xyz, r2, c11, r0
    temp0.xyz = temp2.xyz * AmbientColor.xyz + temp0.xyz;
    // mov r0.w, c1.x
    temp0.w = OpacityOverride.x;
    // mul o7, r0, v5
    o.color = temp0 * i.color;
    // add r0.xy, r1, c13.zwzw
    temp0.xy = temp1.xy + Shroud.ScaleUV_OffsetUV.zw;
    // mul o4.xy, r0, c13
    o.texcoord3.xy = temp0.xy * Shroud.ScaleUV_OffsetUV.xy;
    // mul r0.xy, r1.z, c117.zwzw
    temp0.xy = temp1.zz * Cloud.WorldPositionMultiplier_XYZZ.zw;
    // mad r0.xy, r1, c117, -r0
    temp0.xy = temp1.xy * Cloud.WorldPositionMultiplier_XYZZ.xy + -temp0.xy;
    // add o4.zw, r0.xyxy, c118.xyxy
    o.texcoord3.zw = temp0.xy + Cloud.CurrentOffsetUV.xy;
    // mov r0.xz, c0
    temp0.xz = float2(1, -1);
    // mul r0.xy, r0.xzzw, c14.x
    temp0.xy = temp0.xz * expr14.xx;
    // mul o6.xy, r1, r0
    o.texcoord5 = temp1 * temp0;
    // mov o1, v4.xyyx
    o.texcoord = i.texcoord.xyyx;
    // mov o2.w, c0.y
    o.texcoord1.w = float1(0);
    // dp4 r0.x, r1, c116
    temp0.x = dot(temp1, (ShadowMapWorldToShadow._m03_m13_m23_m33));
    // rcp r0.y, r0.x
    temp0.y = 1.0f / temp0.x;
    // mov o5.w, r0.x
    o.texcoord4.w = temp0.x;
    // dp4 r0.x, r1, c113
    temp0.x = dot(temp1, (ShadowMapWorldToShadow._m00_m10_m20_m30));
    // dp4 r0.z, r1, c114
    temp0.z = dot(temp1, (ShadowMapWorldToShadow._m01_m11_m21_m31));
    // dp4 r0.w, r1, c115
    temp0.w = dot(temp1, (ShadowMapWorldToShadow._m02_m12_m22_m32));
    // mad o5.xyz, r0.xzww, r0.y, c0.yyww
    o.texcoord4.xyz = temp0.xzw * temp0.yyy + float3(0, 0, -0.0015);
    // 

    return o;
}

// VS_M_Array_Shader_1 Vertex_3_0 Has PRES True
struct VS_M_Array_Shader_1_Input
{
    float4 position : POSITION;
    float4 normal : NORMAL;
    float4 tangent : TANGENT;
    float4 binormal : BINORMAL;
    float4 blendindices : BLENDINDICES;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct VS_M_Array_Shader_1_Output
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 texcoord1 : TEXCOORD1;
    float3 texcoord2 : TEXCOORD2;
    float4 texcoord3 : TEXCOORD3;
    float4 texcoord4 : TEXCOORD4;
    float2 texcoord5 : TEXCOORD5;
    float4 color : COLOR;
};

VS_M_Array_Shader_1_Output VS_M_Array_Shader_1(VS_M_Array_Shader_1_Input i)
{
    /*
    PRSI
      OutputRegisterOffset: 14
      Unknown1: 0
      Unknown2: 0
      OutputRegisterCount: 1
      Unknown3: 0
      Unknown4: 0
      Unknown5: 14
      Unknown6: 1
      Mappings: 1
        0 - ConstOutput: 0 ConstInput 0
    
    */
    float4 expr14;
    {
        float4 temp0;
        // Expression_2_1
        // mul r0.x, c0.x, (66)
        temp0.x = MapCellSize.x * (66);
        // rcp c14.x, r0.x
        expr14.x = 1.0f / (temp0.x);
    }

    VS_M_Array_Shader_1_Output o;
    float4 temp0, temp1, temp2, temp3, temp4;
    float addr0;
    // def c0, 1, -1, 0, -0.0015
    // dcl_position v0
    // dcl_normal v1
    // dcl_tangent v2
    // dcl_binormal v3
    // dcl_blendindices v4
    // dcl_texcoord v5
    // dcl_color v6
    // dcl_position o0
    // dcl_texcoord o1
    // dcl_texcoord1 o2
    // dcl_texcoord2 o3.xyz
    // dcl_texcoord3 o4
    // dcl_texcoord4 o5
    // dcl_texcoord5 o6.xy
    // dcl_color o7
    // add r0.x, v4.x, v4.x
    temp0.x = i.blendindices.x + i.blendindices.x;
    // frc r0.y, r0.x
    temp0.y = frac(temp0.x);
    // add r0.z, r0.x, -r0.y
    temp0.z = temp0.x + -temp0.y;
    // slt r0.y, -r0.y, r0.y
    temp0.y = (-temp0.y < temp0.y) ? 1 : 0;
    // slt r0.x, r0.x, -r0.x
    temp0.x = (temp0.x < -temp0.x) ? 1 : 0;
    // mad r0.x, r0.x, r0.y, r0.z
    temp0.x = temp0.x * temp0.y + temp0.z;
    // mova a0.x, r0.x
    addr0.x = temp0.x;
    // mul r0, v0.zxyy, c128[a0.x].yzxy
    temp0 = i.position.zxyy * WorldBones[0 + addr0.x].yzxy;
    // mad r0, c128[a0.x].wwwx, v0.xyzx, r0
    temp0 = WorldBones[0 + addr0.x].wwwx * i.position.xyzx + temp0;
    // mul r1, v0.yzxz, c128[a0.x].zxyz
    temp1 = i.position.yzxz * WorldBones[0 + addr0.x].zxyz;
    // mad r0, r0, c0.xxxy, -r1
    temp0 = temp0 * float4(1, 1, 1, -1) + -temp1;
    // mul r1.xyz, r0.w, c128[a0.x]
    temp1.xyz = temp0.www * WorldBones[0 + addr0.x].xyz;
    // mad r1.xyz, c128[a0.x].w, r0, -r1
    temp1.xyz = WorldBones[0 + addr0.x].www * temp0.xyz + -temp1.xyz;
    // mad r1.xyz, c128[a0.x].yzxw, r0.zxyw, r1
    temp1.xyz = WorldBones[0 + addr0.x].yzx * temp0.zxy + temp1.xyz;
    // mad r0.xyz, c128[a0.x].zxyw, -r0.yzxw, r1
    temp0.xyz = WorldBones[0 + addr0.x].zxy * -temp0.yzx + temp1.xyz;
    // add r0.xyz, r0, c129[a0.x]
    temp0.xyz = temp0.xyz + WorldBones[1 + addr0.x].xyz;
    // mov r0.w, c0.x
    temp0.w = float1(1);
    // dp4 o0.x, r0, c119
    o.position.x = dot(temp0, (ViewProjection._m00_m10_m20_m30));
    // dp4 o0.y, r0, c120
    o.position.y = dot(temp0, (ViewProjection._m01_m11_m21_m31));
    // dp4 o0.z, r0, c121
    o.position.z = dot(temp0, (ViewProjection._m02_m12_m22_m32));
    // dp4 o0.w, r0, c122
    o.position.w = dot(temp0, (ViewProjection._m03_m13_m23_m33));
    // mul r1, v3.zxyy, c128[a0.x].yzxy
    temp1 = i.binormal.zxyy * WorldBones[0 + addr0.x].yzxy;
    // mad r1, c128[a0.x].wwwx, v3.xyzx, r1
    temp1 = WorldBones[0 + addr0.x].wwwx * i.binormal.xyzx + temp1;
    // mul r2, v3.yzxz, c128[a0.x].zxyz
    temp2 = i.binormal.yzxz * WorldBones[0 + addr0.x].zxyz;
    // mad r1, r1, c0.xxxy, -r2
    temp1 = temp1 * float4(1, 1, 1, -1) + -temp2;
    // mul r2.xyz, r1.w, c128[a0.x]
    temp2.xyz = temp1.www * WorldBones[0 + addr0.x].xyz;
    // mad r2.xyz, c128[a0.x].w, r1, -r2
    temp2.xyz = WorldBones[0 + addr0.x].www * temp1.xyz + -temp2.xyz;
    // mad r2.xyz, c128[a0.x].yzxw, r1.zxyw, r2
    temp2.xyz = WorldBones[0 + addr0.x].yzx * temp1.zxy + temp2.xyz;
    // mad r1.xyz, c128[a0.x].zxyw, -r1.yzxw, r2
    temp1.xyz = WorldBones[0 + addr0.x].zxy * -temp1.yzx + temp2.xyz;
    // dp3 o2.x, c6, -r1
    o.texcoord1.x = dot(DirectionalLight[0].Direction.xyz, -temp1.xyz);
    // mul r2, v2.zxyy, c128[a0.x].yzxy
    temp2 = i.tangent.zxyy * WorldBones[0 + addr0.x].yzxy;
    // mad r2, c128[a0.x].wwwx, v2.xyzx, r2
    temp2 = WorldBones[0 + addr0.x].wwwx * i.tangent.xyzx + temp2;
    // mul r3, v2.yzxz, c128[a0.x].zxyz
    temp3 = i.tangent.yzxz * WorldBones[0 + addr0.x].zxyz;
    // mad r2, r2, c0.xxxy, -r3
    temp2 = temp2 * float4(1, 1, 1, -1) + -temp3;
    // mul r3.xyz, r2.w, c128[a0.x]
    temp3.xyz = temp2.www * WorldBones[0 + addr0.x].xyz;
    // mad r3.xyz, c128[a0.x].w, r2, -r3
    temp3.xyz = WorldBones[0 + addr0.x].www * temp2.xyz + -temp3.xyz;
    // mad r3.xyz, c128[a0.x].yzxw, r2.zxyw, r3
    temp3.xyz = WorldBones[0 + addr0.x].yzx * temp2.zxy + temp3.xyz;
    // mad r2.xyz, c128[a0.x].zxyw, -r2.yzxw, r3
    temp2.xyz = WorldBones[0 + addr0.x].zxy * -temp2.yzx + temp3.xyz;
    // dp3 o2.y, c6, -r2
    o.texcoord1.y = dot(DirectionalLight[0].Direction.xyz, -temp2.xyz);
    // mul r3, v1.zxyy, c128[a0.x].yzxy
    temp3 = i.normal.zxyy * WorldBones[0 + addr0.x].yzxy;
    // mad r3, c128[a0.x].wwwx, v1.xyzx, r3
    temp3 = WorldBones[0 + addr0.x].wwwx * i.normal.xyzx + temp3;
    // mul r4, v1.yzxz, c128[a0.x].zxyz
    temp4 = i.normal.yzxz * WorldBones[0 + addr0.x].zxyz;
    // mad r3, r3, c0.xxxy, -r4
    temp3 = temp3 * float4(1, 1, 1, -1) + -temp4;
    // mul r4.xyz, r3.w, c128[a0.x]
    temp4.xyz = temp3.www * WorldBones[0 + addr0.x].xyz;
    // mad r4.xyz, c128[a0.x].w, r3, -r4
    temp4.xyz = WorldBones[0 + addr0.x].www * temp3.xyz + -temp4.xyz;
    // mad r4.xyz, c128[a0.x].yzxw, r3.zxyw, r4
    temp4.xyz = WorldBones[0 + addr0.x].yzx * temp3.zxy + temp4.xyz;
    // mad r3.xyz, c128[a0.x].zxyw, -r3.yzxw, r4
    temp3.xyz = WorldBones[0 + addr0.x].zxy * -temp3.yzx + temp4.xyz;
    // dp3 o2.z, c6, r3
    o.texcoord1.z = dot(DirectionalLight[0].Direction.xyz, temp3.xyz);
    // add r4.xyz, -r0, c123
    temp4.xyz = -temp0.xyz + EyePosition.xyz;
    // dp3 r1.w, r4, r4
    temp1.w = dot(temp4.xyz, temp4.xyz);
    // rsq r1.w, r1.w
    temp1.w = 1 / sqrt(temp1.w);
    // mad r4.xyz, r4, r1.w, c6
    temp4.xyz = temp4.xyz * temp1.www + DirectionalLight[0].Direction.xyz;
    // dp3 r1.x, r4, -r1
    temp1.x = dot(temp4.xyz, -temp1.xyz);
    // dp3 r1.y, r4, -r2
    temp1.y = dot(temp4.xyz, -temp2.xyz);
    // dp3 r1.z, r4, r3
    temp1.z = dot(temp4.xyz, temp3.xyz);
    // dp3 r1.w, r1, r1
    temp1.w = dot(temp1.xyz, temp1.xyz);
    // rsq r1.w, r1.w
    temp1.w = 1 / sqrt(temp1.w);
    // mul o3.xyz, r1, r1.w
    o.texcoord2 = temp1 * temp1.w;
    // dp3 r1.x, r3, c10
    temp1.x = dot(temp3.xyz, DirectionalLight[2].Direction.xyz);
    // dp3 r1.y, r3, c8
    temp1.y = dot(temp3.xyz, DirectionalLight[1].Direction.xyz);
    // max r1.x, r1.x, c0.z
    temp1.x = max(temp1.x, float1(0));
    // mul r1.xzw, r1.x, c9.xyyz
    temp1.xzw = temp1.xxx * DirectionalLight[2].Color.xyz;
    // max r1.y, r1.y, c0.z
    temp1.y = max(temp1.y, float1(0));
    // mad r1.xyz, c7, r1.y, r1.xzww
    temp1.xyz = DirectionalLight[1].Color.xyz * temp1.yyy + temp1.xzw;
    // mul r1.xyz, r1, c12
    temp1.xyz = temp1.xyz * DiffuseColor.xyz;
    // mov r2.xyz, c4
    temp2.xyz = AmbientLightColor.xyz;
    // mad r1.xyz, r2, c11, r1
    temp1.xyz = temp2.xyz * AmbientColor.xyz + temp1.xyz;
    // slt r2.x, v4.x, -v4.x
    temp2.x = (i.blendindices.x < -i.blendindices.x) ? 1 : 0;
    // frc r2.y, v4.x
    temp2.y = frac(i.blendindices.x);
    // add r2.z, -r2.y, v4.x
    temp2.z = -temp2.y + i.blendindices.x;
    // slt r2.y, -r2.y, r2.y
    temp2.y = (-temp2.y < temp2.y) ? 1 : 0;
    // mad r2.x, r2.x, r2.y, r2.z
    temp2.x = temp2.x * temp2.y + temp2.z;
    // add r2.x, r2.x, r2.x
    temp2.x = temp2.x + temp2.x;
    // mova a0.x, r2.x
    addr0.x = temp2.x;
    // mul r2.w, v6.w, c129[a0.x].w
    temp2.w = i.color.w * WorldBones[1 + addr0.x].w;
    // mov r1.w, c1.x
    temp1.w = OpacityOverride.x;
    // mov r2.xyz, v6
    temp2.xyz = i.color.xyz;
    // mul o7, r1, r2
    o.color = temp1 * temp2;
    // add r1.xy, r0, c13.zwzw
    temp1.xy = temp0.xy + Shroud.ScaleUV_OffsetUV.zw;
    // mul o4.xy, r1, c13
    o.texcoord3.xy = temp1.xy * Shroud.ScaleUV_OffsetUV.xy;
    // mul r1.xy, r0.z, c117.zwzw
    temp1.xy = temp0.zz * Cloud.WorldPositionMultiplier_XYZZ.zw;
    // mad r1.xy, r0, c117, -r1
    temp1.xy = temp0.xy * Cloud.WorldPositionMultiplier_XYZZ.xy + -temp1.xy;
    // add o4.zw, r1.xyxy, c118.xyxy
    o.texcoord3.zw = temp1.xy + Cloud.CurrentOffsetUV.xy;
    // mov r1.xy, c0
    temp1.xy = float2(1, -1);
    // mul r1.xy, r1, c14.x
    temp1.xy = temp1.xy * expr14.xx;
    // mul o6.xy, r0, r1
    o.texcoord5 = temp0 * temp1;
    // mov o1, v5.xyyx
    o.texcoord = i.texcoord.xyyx;
    // mov o2.w, c0.z
    o.texcoord1.w = float1(0);
    // dp4 r1.x, r0, c113
    temp1.x = dot(temp0, (ShadowMapWorldToShadow._m00_m10_m20_m30));
    // dp4 r1.y, r0, c114
    temp1.y = dot(temp0, (ShadowMapWorldToShadow._m01_m11_m21_m31));
    // dp4 r1.z, r0, c115
    temp1.z = dot(temp0, (ShadowMapWorldToShadow._m02_m12_m22_m32));
    // dp4 r0.x, r0, c116
    temp0.x = dot(temp0, (ShadowMapWorldToShadow._m03_m13_m23_m33));
    // rcp r0.y, r0.x
    temp0.y = 1.0f / temp0.x;
    // mov o5.w, r0.x
    o.texcoord4.w = temp0.x;
    // mad o5.xyz, r1, r0.y, c0.zzww
    o.texcoord4.xyz = temp1.xyz * temp0.yyy + float3(0, 0, -0.0015);
    // 

    return o;
}

VertexShader VS_M_Array[2] = {
    compile vs_3_0 VS_M_Array_Shader_0(), // 86
    compile vs_3_0 VS_M_Array_Shader_1(), // 87
};
// PS_M_Array_Shader_0 Pixel_3_0 Has PRES False
struct PS_M_Array_Shader_0_Input
{
    float2 texcoord : TEXCOORD;
    float3 texcoord2 : TEXCOORD2;
    float4 texcoord3 : TEXCOORD3;
    float4 color : COLOR;
    float3 texcoord1 : TEXCOORD1;
};

float4 PS_M_Array_Shader_0(PS_M_Array_Shader_0_Input i) : COLOR
{
    float4 out_color;
    float4 temp0, temp1, temp2;
    // def c0, 2, -1, 0, 1
    // dcl_texcoord v0.xy
    // dcl_texcoord2_centroid v1.xyz
    // dcl_texcoord3 v2
    // dcl_color v3
    // dcl_texcoord1_centroid v4.xyz
    // dcl_2d s0
    // dcl_2d s1
    // dcl_2d s2
    // dcl_2d s3
    // texld r0, v0, s1
    temp0 = /* not implemented _pp modifier */ tex2D(DiffuseTextureSampler, i.texcoord.xy);
    // mul_pp oC0.w, r0.w, v3.w
    out_color.w = /* not implemented _pp modifier */ temp0.w * i.color.w;
    // texld r1, v0, s2
    temp1 = /* not implemented _pp modifier */ tex2D(NormalMapSampler, i.texcoord.xy);
    // mad_pp r1.xyz, r1, c0.x, c0.y
    temp1.xyz = /* not implemented _pp modifier */ temp1.xyz * float3(2, 2, 2) + float3(-1, -1, -1);
    // mul_pp r1.xy, r1, c11.x
    temp1.xy = /* not implemented _pp modifier */ temp1.xy * BumpScale.xx;
    // nrm_pp r2.xyz, r1
    temp2.xyz = /* not implemented _pp modifier */ normalize(temp1.xyz).xyz;
    // dp3_pp r0.w, r2, v1
    temp0.w = /* not implemented _pp modifier */ dot(temp2.xyz, i.texcoord2.xyz);
    // dp3_pp r1.x, r2, v4
    temp1.x = /* not implemented _pp modifier */ dot(temp2.xyz, i.texcoord1.xyz);
    // cmp r1.y, -r0.w, c0.z, c0.w
    temp1.y = (-temp0.w >= 0) ? float1(0) : float1(1);
    // pow r1.z, r0.w, c14.x
    temp1.z = pow(temp0.w, SpecularExponent.x);
    // cmp r0.w, -r1.x, c0.z, c0.w
    temp0.w = (-temp1.x >= 0) ? float1(0) : float1(1);
    // mul_pp r1.x, r1.x, r0.w
    temp1.x = /* not implemented _pp modifier */ temp1.x * temp0.w;
    // mul r0.w, r1.y, r0.w
    temp0.w = temp1.y * temp0.w;
    // mul_pp r0.w, r1.z, r0.w
    temp0.w = /* not implemented _pp modifier */ temp1.z * temp0.w;
    // mul_pp r1.yzw, r0.w, c13.xxyz
    temp1.yzw = /* not implemented _pp modifier */ temp0.www * SpecularColor.xyz;
    // mul_pp r2.xyz, r0, c12
    temp2.xyz = /* not implemented _pp modifier */ temp0.xyz * DiffuseColor.xyz;
    // mad_pp r1.xyz, r2, r1.x, r1.yzww
    temp1.xyz = /* not implemented _pp modifier */ temp2.xyz * temp1.xxx + temp1.yzw;
    // texld r2, v2.zwzw, s0
    temp2 = /* not implemented _pp modifier */ tex2D(CloudTextureSampler, i.texcoord3.zw);
    // mul r2.xyz, r2, c5
    temp2.xyz = temp2.xyz * DirectionalLight[0].Color.xyz;
    // mul r1.xyz, r1, r2
    temp1.xyz = temp1.xyz * temp2.xyz;
    // mad_pp r0.xyz, r0, v3, r1
    temp0.xyz = /* not implemented _pp modifier */ temp0.xyz * i.color.xyz + temp1.xyz;
    // mul_pp r0.xyz, r0, c2
    temp0.xyz = /* not implemented _pp modifier */ temp0.xyz * TintColor.xyz;
    // texld r1, v2, s3
    temp1 = /* not implemented _pp modifier */ tex2D(ShroudTextureSampler, i.texcoord3.xy);
    // mul_pp oC0.xyz, r0, r1
    out_color.xyz = /* not implemented _pp modifier */ temp0.xyz * temp1.xyz;
    // 

    return out_color;
}

// PS_M_Array_Shader_1 Pixel_3_0 Has PRES False
struct PS_M_Array_Shader_1_Input
{
    float2 texcoord : TEXCOORD;
    float3 texcoord2 : TEXCOORD2;
    float4 texcoord3 : TEXCOORD3;
    float3 texcoord4 : TEXCOORD4;
    float4 color : COLOR;
    float3 texcoord1 : TEXCOORD1;
};

float4 PS_M_Array_Shader_1(PS_M_Array_Shader_1_Input i) : COLOR
{
    float4 out_color;
    float4 temp0, temp1, temp2;
    // def c0, 2, -1, 0, 1
    // def c1, 0.25, 0, 0, 0
    // dcl_texcoord v0.xy
    // dcl_texcoord2_centroid v1.xyz
    // dcl_texcoord3 v2
    // dcl_texcoord4 v3.xyz
    // dcl_color v4
    // dcl_texcoord1_centroid v5.xyz
    // dcl_2d s0
    // dcl_2d s1
    // dcl_2d s2
    // dcl_2d s3
    // dcl_2d s4
    // texld r0, v0, s2
    temp0 = /* not implemented _pp modifier */ tex2D(DiffuseTextureSampler, i.texcoord.xy);
    // mul_pp oC0.w, r0.w, v4.w
    out_color.w = /* not implemented _pp modifier */ temp0.w * i.color.w;
    // add r1.xy, c11.zxzw, v3
    temp1.xy = Shadowmap_Zero_Zero_OneOverMapSize_OneOverMapSize.zx + i.texcoord4.xy;
    // texld r1, r1, s0
    temp1 = tex2D(ShadowMapSampler, temp1.xy);
    // mov r1.y, r1.x
    temp1.y = temp1.x;
    // add r2.xy, c11.yzzw, v3
    temp2.xy = Shadowmap_Zero_Zero_OneOverMapSize_OneOverMapSize.yz + i.texcoord4.xy;
    // texld r2, r2, s0
    temp2 = tex2D(ShadowMapSampler, temp2.xy);
    // mov r1.z, r2.x
    temp1.z = temp2.x;
    // add r2.xy, c11.wzzw, v3
    temp2.xy = Shadowmap_Zero_Zero_OneOverMapSize_OneOverMapSize.wz + i.texcoord4.xy;
    // texld r2, r2, s0
    temp2 = tex2D(ShadowMapSampler, temp2.xy);
    // mov r1.w, r2.x
    temp1.w = temp2.x;
    // texld r2, v3, s0
    temp2 = tex2D(ShadowMapSampler, i.texcoord4.xy);
    // mov r1.x, r2.x
    temp1.x = temp2.x;
    // add r1, r1, -v3.z
    temp1 = temp1 + -i.texcoord4.z;
    // cmp r1, r1, c0.w, c0.z
    temp1 = (temp1 >= 0) ? float4(1, 1, 1, 1) : float4(0, 0, 0, 0);
    // dp4 r0.w, c0.w, r1
    temp0.w = dot(float4(1, 1, 1, 1), temp1);
    // mul r0.w, r0.w, c1.x
    temp0.w = temp0.w * float1(0.25);
    // texld r1, v0, s3
    temp1 = /* not implemented _pp modifier */ tex2D(NormalMapSampler, i.texcoord.xy);
    // mad_pp r1.xyz, r1, c0.x, c0.y
    temp1.xyz = /* not implemented _pp modifier */ temp1.xyz * float3(2, 2, 2) + float3(-1, -1, -1);
    // mul_pp r1.xy, r1, c12.x
    temp1.xy = /* not implemented _pp modifier */ temp1.xy * BumpScale.xx;
    // nrm_pp r2.xyz, r1
    temp2.xyz = /* not implemented _pp modifier */ normalize(temp1.xyz).xyz;
    // dp3_pp r1.x, r2, v1
    temp1.x = /* not implemented _pp modifier */ dot(temp2.xyz, i.texcoord2.xyz);
    // dp3_pp r1.y, r2, v5
    temp1.y = /* not implemented _pp modifier */ dot(temp2.xyz, i.texcoord1.xyz);
    // cmp r1.z, -r1.x, c0.z, c0.w
    temp1.z = (-temp1.x >= 0) ? float1(0) : float1(1);
    // pow r2.x, r1.x, c15.x
    temp2.x = pow(temp1.x, SpecularExponent.x);
    // cmp r1.x, -r1.y, c0.z, c0.w
    temp1.x = (-temp1.y >= 0) ? float1(0) : float1(1);
    // mul r1.xy, r1.zyzw, r1.x
    temp1.xy = temp1.zy * temp1.xx;
    // mul_pp r1.w, r2.x, r1.x
    temp1.w = /* not implemented _pp modifier */ temp2.x * temp1.x;
    // mul_pp r1.xy, r0.w, r1.ywzw
    temp1.xy = /* not implemented _pp modifier */ temp0.ww * temp1.yw;
    // mul_pp r1.yzw, r1.y, c14.xxyz
    temp1.yzw = /* not implemented _pp modifier */ temp1.yyy * SpecularColor.xyz;
    // mul_pp r2.xyz, r0, c13
    temp2.xyz = /* not implemented _pp modifier */ temp0.xyz * DiffuseColor.xyz;
    // mad_pp r1.xyz, r2, r1.x, r1.yzww
    temp1.xyz = /* not implemented _pp modifier */ temp2.xyz * temp1.xxx + temp1.yzw;
    // texld r2, v2.zwzw, s1
    temp2 = /* not implemented _pp modifier */ tex2D(CloudTextureSampler, i.texcoord3.zw);
    // mul r2.xyz, r2, c5
    temp2.xyz = temp2.xyz * DirectionalLight[0].Color.xyz;
    // mul r1.xyz, r1, r2
    temp1.xyz = temp1.xyz * temp2.xyz;
    // mad_pp r0.xyz, r0, v4, r1
    temp0.xyz = /* not implemented _pp modifier */ temp0.xyz * i.color.xyz + temp1.xyz;
    // mul_pp r0.xyz, r0, c2
    temp0.xyz = /* not implemented _pp modifier */ temp0.xyz * TintColor.xyz;
    // texld r1, v2, s4
    temp1 = /* not implemented _pp modifier */ tex2D(ShroudTextureSampler, i.texcoord3.xy);
    // mul_pp oC0.xyz, r0, r1
    out_color.xyz = /* not implemented _pp modifier */ temp0.xyz * temp1.xyz;
    // 

    return out_color;
}

// PS_M_Array_Shader_2 Pixel_3_0 Has PRES False
struct PS_M_Array_Shader_2_Input
{
    float2 texcoord : TEXCOORD;
    float3 texcoord2 : TEXCOORD2;
    float4 texcoord3 : TEXCOORD3;
    float4 color : COLOR;
    float3 texcoord1 : TEXCOORD1;
};

float4 PS_M_Array_Shader_2(PS_M_Array_Shader_2_Input i) : COLOR
{
    float4 out_color;
    float4 temp0, temp1, temp2;
    // def c0, 2, -1, 0, 1
    // dcl_texcoord v0.xy
    // dcl_texcoord2_centroid v1.xyz
    // dcl_texcoord3 v2
    // dcl_color v3
    // dcl_texcoord1_centroid v4.xyz
    // dcl_2d s0
    // dcl_2d s1
    // dcl_2d s2
    // dcl_2d s3
    // texld r0, v0, s1
    temp0 = /* not implemented _pp modifier */ tex2D(DiffuseTextureSampler, i.texcoord.xy);
    // mul_pp oC0.w, r0.w, v3.w
    out_color.w = /* not implemented _pp modifier */ temp0.w * i.color.w;
    // texld r1, v0, s2
    temp1 = /* not implemented _pp modifier */ tex2D(NormalMapSampler, i.texcoord.xy);
    // mad_pp r1.xyz, r1, c0.x, c0.y
    temp1.xyz = /* not implemented _pp modifier */ temp1.xyz * float3(2, 2, 2) + float3(-1, -1, -1);
    // mul_pp r1.xy, r1, c11.x
    temp1.xy = /* not implemented _pp modifier */ temp1.xy * BumpScale.xx;
    // nrm_pp r2.xyz, r1
    temp2.xyz = /* not implemented _pp modifier */ normalize(temp1.xyz).xyz;
    // dp3_pp r0.w, r2, v1
    temp0.w = /* not implemented _pp modifier */ dot(temp2.xyz, i.texcoord2.xyz);
    // dp3_pp r1.x, r2, v4
    temp1.x = /* not implemented _pp modifier */ dot(temp2.xyz, i.texcoord1.xyz);
    // cmp r1.y, -r0.w, c0.z, c0.w
    temp1.y = (-temp0.w >= 0) ? float1(0) : float1(1);
    // pow r1.z, r0.w, c14.x
    temp1.z = pow(temp0.w, SpecularExponent.x);
    // cmp r0.w, -r1.x, c0.z, c0.w
    temp0.w = (-temp1.x >= 0) ? float1(0) : float1(1);
    // mul_pp r1.x, r1.x, r0.w
    temp1.x = /* not implemented _pp modifier */ temp1.x * temp0.w;
    // mul r0.w, r1.y, r0.w
    temp0.w = temp1.y * temp0.w;
    // mul_pp r0.w, r1.z, r0.w
    temp0.w = /* not implemented _pp modifier */ temp1.z * temp0.w;
    // mul_pp r1.yzw, r0.w, c13.xxyz
    temp1.yzw = /* not implemented _pp modifier */ temp0.www * SpecularColor.xyz;
    // mul_pp r2.xyz, r0, c12
    temp2.xyz = /* not implemented _pp modifier */ temp0.xyz * DiffuseColor.xyz;
    // mad_pp r1.xyz, r2, r1.x, r1.yzww
    temp1.xyz = /* not implemented _pp modifier */ temp2.xyz * temp1.xxx + temp1.yzw;
    // texld r2, v2.zwzw, s0
    temp2 = /* not implemented _pp modifier */ tex2D(CloudTextureSampler, i.texcoord3.zw);
    // mul r2.xyz, r2, c5
    temp2.xyz = temp2.xyz * DirectionalLight[0].Color.xyz;
    // mul r1.xyz, r1, r2
    temp1.xyz = temp1.xyz * temp2.xyz;
    // mad_pp r0.xyz, r0, v3, r1
    temp0.xyz = /* not implemented _pp modifier */ temp0.xyz * i.color.xyz + temp1.xyz;
    // mul_pp r0.xyz, r0, c2
    temp0.xyz = /* not implemented _pp modifier */ temp0.xyz * TintColor.xyz;
    // texld r1, v2, s3
    temp1 = /* not implemented _pp modifier */ tex2D(ShroudTextureSampler, i.texcoord3.xy);
    // mul_pp oC0.xyz, r0, r1
    out_color.xyz = /* not implemented _pp modifier */ temp0.xyz * temp1.xyz;
    // 

    return out_color;
}

// PS_M_Array_Shader_3 Pixel_3_0 Has PRES False
struct PS_M_Array_Shader_3_Input
{
    float2 texcoord : TEXCOORD;
    float3 texcoord2 : TEXCOORD2;
    float4 texcoord3 : TEXCOORD3;
    float3 texcoord4 : TEXCOORD4;
    float4 color : COLOR;
    float3 texcoord1 : TEXCOORD1;
};

float4 PS_M_Array_Shader_3(PS_M_Array_Shader_3_Input i) : COLOR
{
    float4 out_color;
    float4 temp0, temp1, temp2;
    // def c0, 2, -1, 0, 1
    // def c1, 0.25, 0, 0, 0
    // dcl_texcoord v0.xy
    // dcl_texcoord2_centroid v1.xyz
    // dcl_texcoord3 v2
    // dcl_texcoord4 v3.xyz
    // dcl_color v4
    // dcl_texcoord1_centroid v5.xyz
    // dcl_2d s0
    // dcl_2d s1
    // dcl_2d s2
    // dcl_2d s3
    // dcl_2d s4
    // texld r0, v0, s2
    temp0 = /* not implemented _pp modifier */ tex2D(DiffuseTextureSampler, i.texcoord.xy);
    // mul_pp oC0.w, r0.w, v4.w
    out_color.w = /* not implemented _pp modifier */ temp0.w * i.color.w;
    // add r1.xy, c11.zxzw, v3
    temp1.xy = Shadowmap_Zero_Zero_OneOverMapSize_OneOverMapSize.zx + i.texcoord4.xy;
    // texld r1, r1, s0
    temp1 = tex2D(ShadowMapSampler, temp1.xy);
    // mov r1.y, r1.x
    temp1.y = temp1.x;
    // add r2.xy, c11.yzzw, v3
    temp2.xy = Shadowmap_Zero_Zero_OneOverMapSize_OneOverMapSize.yz + i.texcoord4.xy;
    // texld r2, r2, s0
    temp2 = tex2D(ShadowMapSampler, temp2.xy);
    // mov r1.z, r2.x
    temp1.z = temp2.x;
    // add r2.xy, c11.wzzw, v3
    temp2.xy = Shadowmap_Zero_Zero_OneOverMapSize_OneOverMapSize.wz + i.texcoord4.xy;
    // texld r2, r2, s0
    temp2 = tex2D(ShadowMapSampler, temp2.xy);
    // mov r1.w, r2.x
    temp1.w = temp2.x;
    // texld r2, v3, s0
    temp2 = tex2D(ShadowMapSampler, i.texcoord4.xy);
    // mov r1.x, r2.x
    temp1.x = temp2.x;
    // add r1, r1, -v3.z
    temp1 = temp1 + -i.texcoord4.z;
    // cmp r1, r1, c0.w, c0.z
    temp1 = (temp1 >= 0) ? float4(1, 1, 1, 1) : float4(0, 0, 0, 0);
    // dp4 r0.w, c0.w, r1
    temp0.w = dot(float4(1, 1, 1, 1), temp1);
    // mul r0.w, r0.w, c1.x
    temp0.w = temp0.w * float1(0.25);
    // texld r1, v0, s3
    temp1 = /* not implemented _pp modifier */ tex2D(NormalMapSampler, i.texcoord.xy);
    // mad_pp r1.xyz, r1, c0.x, c0.y
    temp1.xyz = /* not implemented _pp modifier */ temp1.xyz * float3(2, 2, 2) + float3(-1, -1, -1);
    // mul_pp r1.xy, r1, c12.x
    temp1.xy = /* not implemented _pp modifier */ temp1.xy * BumpScale.xx;
    // nrm_pp r2.xyz, r1
    temp2.xyz = /* not implemented _pp modifier */ normalize(temp1.xyz).xyz;
    // dp3_pp r1.x, r2, v1
    temp1.x = /* not implemented _pp modifier */ dot(temp2.xyz, i.texcoord2.xyz);
    // dp3_pp r1.y, r2, v5
    temp1.y = /* not implemented _pp modifier */ dot(temp2.xyz, i.texcoord1.xyz);
    // cmp r1.z, -r1.x, c0.z, c0.w
    temp1.z = (-temp1.x >= 0) ? float1(0) : float1(1);
    // pow r2.x, r1.x, c15.x
    temp2.x = pow(temp1.x, SpecularExponent.x);
    // cmp r1.x, -r1.y, c0.z, c0.w
    temp1.x = (-temp1.y >= 0) ? float1(0) : float1(1);
    // mul r1.xy, r1.zyzw, r1.x
    temp1.xy = temp1.zy * temp1.xx;
    // mul_pp r1.w, r2.x, r1.x
    temp1.w = /* not implemented _pp modifier */ temp2.x * temp1.x;
    // mul_pp r1.xy, r0.w, r1.ywzw
    temp1.xy = /* not implemented _pp modifier */ temp0.ww * temp1.yw;
    // mul_pp r1.yzw, r1.y, c14.xxyz
    temp1.yzw = /* not implemented _pp modifier */ temp1.yyy * SpecularColor.xyz;
    // mul_pp r2.xyz, r0, c13
    temp2.xyz = /* not implemented _pp modifier */ temp0.xyz * DiffuseColor.xyz;
    // mad_pp r1.xyz, r2, r1.x, r1.yzww
    temp1.xyz = /* not implemented _pp modifier */ temp2.xyz * temp1.xxx + temp1.yzw;
    // texld r2, v2.zwzw, s1
    temp2 = /* not implemented _pp modifier */ tex2D(CloudTextureSampler, i.texcoord3.zw);
    // mul r2.xyz, r2, c5
    temp2.xyz = temp2.xyz * DirectionalLight[0].Color.xyz;
    // mul r1.xyz, r1, r2
    temp1.xyz = temp1.xyz * temp2.xyz;
    // mad_pp r0.xyz, r0, v4, r1
    temp0.xyz = /* not implemented _pp modifier */ temp0.xyz * i.color.xyz + temp1.xyz;
    // mul_pp r0.xyz, r0, c2
    temp0.xyz = /* not implemented _pp modifier */ temp0.xyz * TintColor.xyz;
    // texld r1, v2, s4
    temp1 = /* not implemented _pp modifier */ tex2D(ShroudTextureSampler, i.texcoord3.xy);
    // mul_pp oC0.xyz, r0, r1
    out_color.xyz = /* not implemented _pp modifier */ temp0.xyz * temp1.xyz;
    // 

    return out_color;
}

PixelShader PS_M_Array[4] = {
    compile ps_3_0 PS_M_Array_Shader_0(), // 88
    compile ps_3_0 PS_M_Array_Shader_1(), // 89
    compile ps_3_0 PS_M_Array_Shader_2(), // 90
    compile ps_3_0 PS_M_Array_Shader_3(), // 91
};
// VS_L_Array_Shader_0 Vertex_2_0 Has PRES False
struct VS_L_Array_Shader_0_Input
{
    float4 position : POSITION;
    float4 normal : NORMAL;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct VS_L_Array_Shader_0_Output
{
    float4 position : POSITION;
    float4 color : COLOR;
    float2 texcoord1 : TEXCOORD1;
    float4 texcoord : TEXCOORD;
};

VS_L_Array_Shader_0_Output VS_L_Array_Shader_0(VS_L_Array_Shader_0_Input i)
{
    VS_L_Array_Shader_0_Output o;
    float4 temp0, temp1;
    float3 temp2;
    // def c0, 1, 0, 0, 0
    // dcl_position v0
    // dcl_normal v1
    // dcl_texcoord v2
    // dcl_color v3
    // mad r0, v0.xyzx, c0.xxxy, c0.yyyx
    temp0 = i.position.xyzx * float4(1, 1, 1, 0) + float4(0, 0, 0, 1);
    // dp4 r1.z, r0, c126
    temp1.z = dot(temp0, (World._m02_m12_m22_m32));
    // mov r1.w, c0.x
    temp1.w = float1(1);
    // dp4 r1.x, r0, c124
    temp1.x = dot(temp0, (World._m00_m10_m20_m30));
    // dp4 r1.y, r0, c125
    temp1.y = dot(temp0, (World._m01_m11_m21_m31));
    // dp4 oPos.x, r1, c119
    o.position.x = dot(temp1, (ViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r1, c120
    o.position.y = dot(temp1, (ViewProjection._m01_m11_m21_m31));
    // dp4 oPos.z, r1, c121
    o.position.z = dot(temp1, (ViewProjection._m02_m12_m22_m32));
    // dp4 oPos.w, r1, c122
    o.position.w = dot(temp1, (ViewProjection._m03_m13_m23_m33));
    // add r0.xy, r1, c13.zwzw
    temp0.xy = temp1.xy + Shroud.ScaleUV_OffsetUV.zw;
    // dp3 r1.x, v1, c124
    temp1.x = dot(i.normal.xyz, (World._m00_m10_m20_m30).xyz);
    // dp3 r1.y, v1, c125
    temp1.y = dot(i.normal.xyz, (World._m01_m11_m21_m31).xyz);
    // dp3 r1.z, v1, c126
    temp1.z = dot(i.normal.xyz, (World._m02_m12_m22_m32).xyz);
    // dp3 r0.z, r1, c8
    temp0.z = dot(temp1.xyz, DirectionalLight[1].Direction.xyz);
    // max r0.z, r0.z, c0.y
    temp0.z = max(temp0.z, float1(0));
    // mul r2.xyz, r0.z, c7
    temp2.xyz = temp0.zzz * DirectionalLight[1].Color.xyz;
    // dp3 r0.z, r1, c6
    temp0.z = dot(temp1.xyz, DirectionalLight[0].Direction.xyz);
    // dp3 r0.w, r1, c10
    temp0.w = dot(temp1.xyz, DirectionalLight[2].Direction.xyz);
    // max r0.z, r0.z, c0.y
    temp0.z = max(temp0.z, float1(0));
    // mad r1.xyz, c5, r0.z, r2
    temp1.xyz = DirectionalLight[0].Color.xyz * temp0.zzz + temp2.xyz;
    // max r0.z, r0.w, c0.y
    temp0.z = max(temp0.w, float1(0));
    // mad r1.xyz, c9, r0.z, r1
    temp1.xyz = DirectionalLight[2].Color.xyz * temp0.zzz + temp1.xyz;
    // mul r1.xyz, r1, c12
    temp1.xyz = temp1.xyz * DiffuseColor.xyz;
    // mov r2.xyz, c4
    temp2.xyz = AmbientLightColor.xyz;
    // mad r1.xyz, r2, c11, r1
    temp1.xyz = temp2.xyz * AmbientColor.xyz + temp1.xyz;
    // mov r1.w, c1.x
    temp1.w = OpacityOverride.x;
    // mul oD0, r1, v3
    o.color = temp1 * i.color;
    // mul oT1.xy, r0, c13
    o.texcoord1 = temp0 * Shroud.ScaleUV_OffsetUV;
    // mov oT0, v2.xyyx
    o.texcoord = i.texcoord.xyyx;
    // 

    return o;
}

// VS_L_Array_Shader_1 Vertex_2_0 Has PRES False
struct VS_L_Array_Shader_1_Input
{
    float4 position : POSITION;
    float4 normal : NORMAL;
    float4 blendindices : BLENDINDICES;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct VS_L_Array_Shader_1_Output
{
    float4 position : POSITION;
    float4 color : COLOR;
    float2 texcoord1 : TEXCOORD1;
    float4 texcoord : TEXCOORD;
};

VS_L_Array_Shader_1_Output VS_L_Array_Shader_1(VS_L_Array_Shader_1_Input i)
{
    VS_L_Array_Shader_1_Output o;
    float4 temp0, temp1, temp2;
    float addr0;
    // def c0, 1, -1, 0, 0
    // dcl_position v0
    // dcl_normal v1
    // dcl_blendindices v2
    // dcl_texcoord v3
    // dcl_color v4
    // add r0.x, v2.x, v2.x
    temp0.x = i.blendindices.x + i.blendindices.x;
    // frc r0.y, r0.x
    temp0.y = frac(temp0.x);
    // add r0.z, r0.x, -r0.y
    temp0.z = temp0.x + -temp0.y;
    // slt r0.y, -r0.y, r0.y
    temp0.y = (-temp0.y < temp0.y) ? 1 : 0;
    // slt r0.x, r0.x, -r0.x
    temp0.x = (temp0.x < -temp0.x) ? 1 : 0;
    // mad r0.x, r0.x, r0.y, r0.z
    temp0.x = temp0.x * temp0.y + temp0.z;
    // mova a0.x, r0.x
    addr0.x = temp0.x;
    // mul r0, v0.zxyy, c128[a0.x].yzxy
    temp0 = i.position.zxyy * WorldBones[0 + addr0.x].yzxy;
    // mad r0, c128[a0.x].wwwx, v0.xyzx, r0
    temp0 = WorldBones[0 + addr0.x].wwwx * i.position.xyzx + temp0;
    // mul r1, v0.yzxz, c128[a0.x].zxyz
    temp1 = i.position.yzxz * WorldBones[0 + addr0.x].zxyz;
    // mad r0, r0, c0.xxxy, -r1
    temp0 = temp0 * float4(1, 1, 1, -1) + -temp1;
    // mul r1.xyz, r0.w, c128[a0.x]
    temp1.xyz = temp0.www * WorldBones[0 + addr0.x].xyz;
    // mad r1.xyz, c128[a0.x].w, r0, -r1
    temp1.xyz = WorldBones[0 + addr0.x].www * temp0.xyz + -temp1.xyz;
    // mad r1.xyz, c128[a0.x].yzxw, r0.zxyw, r1
    temp1.xyz = WorldBones[0 + addr0.x].yzx * temp0.zxy + temp1.xyz;
    // mad r0.xyz, c128[a0.x].zxyw, -r0.yzxw, r1
    temp0.xyz = WorldBones[0 + addr0.x].zxy * -temp0.yzx + temp1.xyz;
    // add r0.xyz, r0, c129[a0.x]
    temp0.xyz = temp0.xyz + WorldBones[1 + addr0.x].xyz;
    // mov r0.w, c0.x
    temp0.w = float1(1);
    // dp4 oPos.x, r0, c119
    o.position.x = dot(temp0, (ViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c120
    o.position.y = dot(temp0, (ViewProjection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c121
    o.position.z = dot(temp0, (ViewProjection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c122
    o.position.w = dot(temp0, (ViewProjection._m03_m13_m23_m33));
    // add r0.xy, r0, c13.zwzw
    temp0.xy = temp0.xy + Shroud.ScaleUV_OffsetUV.zw;
    // mul r1, v1.zxyy, c128[a0.x].yzxy
    temp1 = i.normal.zxyy * WorldBones[0 + addr0.x].yzxy;
    // mad r1, c128[a0.x].wwwx, v1.xyzx, r1
    temp1 = WorldBones[0 + addr0.x].wwwx * i.normal.xyzx + temp1;
    // mul r2, v1.yzxz, c128[a0.x].zxyz
    temp2 = i.normal.yzxz * WorldBones[0 + addr0.x].zxyz;
    // mad r1, r1, c0.xxxy, -r2
    temp1 = temp1 * float4(1, 1, 1, -1) + -temp2;
    // mul r2.xyz, r1.w, c128[a0.x]
    temp2.xyz = temp1.www * WorldBones[0 + addr0.x].xyz;
    // mad r2.xyz, c128[a0.x].w, r1, -r2
    temp2.xyz = WorldBones[0 + addr0.x].www * temp1.xyz + -temp2.xyz;
    // mad r2.xyz, c128[a0.x].yzxw, r1.zxyw, r2
    temp2.xyz = WorldBones[0 + addr0.x].yzx * temp1.zxy + temp2.xyz;
    // mad r1.xyz, c128[a0.x].zxyw, -r1.yzxw, r2
    temp1.xyz = WorldBones[0 + addr0.x].zxy * -temp1.yzx + temp2.xyz;
    // dp3 r0.z, r1, c6
    temp0.z = dot(temp1.xyz, DirectionalLight[0].Direction.xyz);
    // max r0.z, r0.z, c0.z
    temp0.z = max(temp0.z, float1(0));
    // dp3 r0.w, r1, c8
    temp0.w = dot(temp1.xyz, DirectionalLight[1].Direction.xyz);
    // dp3 r1.x, r1, c10
    temp1.x = dot(temp1.xyz, DirectionalLight[2].Direction.xyz);
    // max r0.w, r0.w, c0.z
    temp0.w = max(temp0.w, float1(0));
    // mul r1.yzw, r0.w, c7.xxyz
    temp1.yzw = temp0.www * DirectionalLight[1].Color.xyz;
    // mad r1.yzw, c5.xxyz, r0.z, r1
    temp1.yzw = DirectionalLight[0].Color.xyz * temp0.zzz + temp1.yzw;
    // max r0.z, r1.x, c0.z
    temp0.z = max(temp1.x, float1(0));
    // mad r1.xyz, c9, r0.z, r1.yzww
    temp1.xyz = DirectionalLight[2].Color.xyz * temp0.zzz + temp1.yzw;
    // mul r1.xyz, r1, c12
    temp1.xyz = temp1.xyz * DiffuseColor.xyz;
    // mov r2.xyz, c4
    temp2.xyz = AmbientLightColor.xyz;
    // mad r1.xyz, r2, c11, r1
    temp1.xyz = temp2.xyz * AmbientColor.xyz + temp1.xyz;
    // slt r0.z, v2.x, -v2.x
    temp0.z = (i.blendindices.x < -i.blendindices.x) ? 1 : 0;
    // frc r0.w, v2.x
    temp0.w = frac(i.blendindices.x);
    // add r2.x, -r0.w, v2.x
    temp2.x = -temp0.w + i.blendindices.x;
    // slt r0.w, -r0.w, r0.w
    temp0.w = (-temp0.w < temp0.w) ? 1 : 0;
    // mad r0.z, r0.z, r0.w, r2.x
    temp0.z = temp0.z * temp0.w + temp2.x;
    // add r0.z, r0.z, r0.z
    temp0.z = temp0.z + temp0.z;
    // mova a0.x, r0.z
    addr0.x = temp0.z;
    // mul r2.w, v4.w, c129[a0.x].w
    temp2.w = i.color.w * WorldBones[1 + addr0.x].w;
    // mov r1.w, c1.x
    temp1.w = OpacityOverride.x;
    // mov r2.xyz, v4
    temp2.xyz = i.color.xyz;
    // mul oD0, r1, r2
    o.color = temp1 * temp2;
    // mul oT1.xy, r0, c13
    o.texcoord1 = temp0 * Shroud.ScaleUV_OffsetUV;
    // mov oT0, v3.xyyx
    o.texcoord = i.texcoord.xyyx;
    // 

    return o;
}

VertexShader VS_L_Array[2] = {
    compile vs_2_0 VS_L_Array_Shader_0(), // 95
    compile vs_2_0 VS_L_Array_Shader_1(), // 96
};
// PS_L_Array_Shader_0 Pixel_2_0 Has PRES False
struct PS_L_Array_Shader_0_Input
{
    float4 color : COLOR;
    float2 texcoord : TEXCOORD;
    float2 texcoord1 : TEXCOORD1;
};

float4 PS_L_Array_Shader_0(PS_L_Array_Shader_0_Input i) : COLOR
{
    float4 out_color;
    float4 temp0, temp1, temp2;
    // dcl v0
    // dcl t0.xy
    // dcl t1.xy
    // dcl_2d s0
    // dcl_2d s1
    // texld r0, t0, s0
    temp0 = tex2D(DiffuseTextureSampler, i.texcoord.xy);
    // texld r1, t1, s1
    temp1 = tex2D(ShroudTextureSampler, i.texcoord1.xy);
    // mul r0.xyz, r0, v0
    temp0.xyz = temp0.xyz * i.color.xyz;
    // mul r2.w, r0.w, v0.w
    temp2.w = temp0.w * i.color.w;
    // mul r0.xyz, r0, c2
    temp0.xyz = temp0.xyz * TintColor.xyz;
    // mul r2.xyz, r1, r0
    temp2.xyz = temp1.xyz * temp0.xyz;
    // mov oC0, r2
    out_color = temp2;
    // 

    return out_color;
}

// PS_L_Array_Shader_1 Pixel_2_0 Has PRES False
struct PS_L_Array_Shader_1_Input
{
    float4 color : COLOR;
    float2 texcoord : TEXCOORD;
    float2 texcoord1 : TEXCOORD1;
};

float4 PS_L_Array_Shader_1(PS_L_Array_Shader_1_Input i) : COLOR
{
    float4 out_color;
    float4 temp0, temp1, temp2;
    // dcl v0
    // dcl t0.xy
    // dcl t1.xy
    // dcl_2d s0
    // dcl_2d s1
    // texld r0, t0, s0
    temp0 = tex2D(DiffuseTextureSampler, i.texcoord.xy);
    // texld r1, t1, s1
    temp1 = tex2D(ShroudTextureSampler, i.texcoord1.xy);
    // mul r0.xyz, r0, v0
    temp0.xyz = temp0.xyz * i.color.xyz;
    // mul r2.w, r0.w, v0.w
    temp2.w = temp0.w * i.color.w;
    // mul r0.xyz, r0, c2
    temp0.xyz = temp0.xyz * TintColor.xyz;
    // mul r2.xyz, r1, r0
    temp2.xyz = temp1.xyz * temp0.xyz;
    // mov oC0, r2
    out_color = temp2;
    // 

    return out_color;
}

PixelShader PS_L_Array[2] = {
    compile ps_2_0 PS_L_Array_Shader_0(), // 97
    compile ps_2_0 PS_L_Array_Shader_1(), // 98
};
// VSCreateShadowMap_Array_Shader_0 Vertex_2_0 Has PRES False
struct VSCreateShadowMap_Array_Shader_0_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct VSCreateShadowMap_Array_Shader_0_Output
{
    float4 position : POSITION;
    float texcoord1 : TEXCOORD1;
    float color : COLOR;
    float2 texcoord : TEXCOORD;
};

VSCreateShadowMap_Array_Shader_0_Output VSCreateShadowMap_Array_Shader_0(VSCreateShadowMap_Array_Shader_0_Input i)
{
    VSCreateShadowMap_Array_Shader_0_Output o;
    float4 temp0, temp1;
    // def c0, 1, 0, 0, 0
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_color v2
    // mad r0, v0.xyzx, c0.xxxy, c0.yyyx
    temp0 = i.position.xyzx * float4(1, 1, 1, 0) + float4(0, 0, 0, 1);
    // dp4 r1.x, r0, c124
    temp1.x = dot(temp0, (World._m00_m10_m20_m30));
    // dp4 r1.y, r0, c125
    temp1.y = dot(temp0, (World._m01_m11_m21_m31));
    // dp4 r1.z, r0, c126
    temp1.z = dot(temp0, (World._m02_m12_m22_m32));
    // mov r1.w, c0.x
    temp1.w = float1(1);
    // dp4 oPos.x, r1, c119
    o.position.x = dot(temp1, (ViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r1, c120
    o.position.y = dot(temp1, (ViewProjection._m01_m11_m21_m31));
    // dp4 r0.y, r1, c122
    temp0.y = dot(temp1, (ViewProjection._m03_m13_m23_m33));
    // dp4 r0.x, r1, c121
    temp0.x = dot(temp1, (ViewProjection._m02_m12_m22_m32));
    // rcp r0.z, r0.y
    temp0.z = 1.0f / temp0.y;
    // mov oPos.zw, r0.xyxy
    o.position.zw = temp0.xy;
    // mul oT1.x, r0.x, r0.z
    o.texcoord1 = temp0.x * temp0.z;
    // mul oD0.x, v2.w, c1.x
    o.color = i.color.w * OpacityOverride.x;
    // mov oT0.xy, v1
    o.texcoord = i.texcoord;
    // 

    return o;
}

// VSCreateShadowMap_Array_Shader_1 Vertex_2_0 Has PRES False
struct VSCreateShadowMap_Array_Shader_1_Input
{
    float4 position : POSITION;
    float4 blendindices : BLENDINDICES;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct VSCreateShadowMap_Array_Shader_1_Output
{
    float4 position : POSITION;
    float texcoord1 : TEXCOORD1;
    float color : COLOR;
    float2 texcoord : TEXCOORD;
};

VSCreateShadowMap_Array_Shader_1_Output VSCreateShadowMap_Array_Shader_1(VSCreateShadowMap_Array_Shader_1_Input i)
{
    VSCreateShadowMap_Array_Shader_1_Output o;
    float4 temp0, temp1;
    float addr0;
    // def c0, 1, -1, 0, 0
    // dcl_position v0
    // dcl_blendindices v1
    // dcl_texcoord v2
    // dcl_color v3
    // add r0.x, v1.x, v1.x
    temp0.x = i.blendindices.x + i.blendindices.x;
    // frc r0.y, r0.x
    temp0.y = frac(temp0.x);
    // add r0.z, r0.x, -r0.y
    temp0.z = temp0.x + -temp0.y;
    // slt r0.y, -r0.y, r0.y
    temp0.y = (-temp0.y < temp0.y) ? 1 : 0;
    // slt r0.x, r0.x, -r0.x
    temp0.x = (temp0.x < -temp0.x) ? 1 : 0;
    // mad r0.x, r0.x, r0.y, r0.z
    temp0.x = temp0.x * temp0.y + temp0.z;
    // mova a0.x, r0.x
    addr0.x = temp0.x;
    // mul r0, v0.zxyy, c128[a0.x].yzxy
    temp0 = i.position.zxyy * WorldBones[0 + addr0.x].yzxy;
    // mad r0, c128[a0.x].wwwx, v0.xyzx, r0
    temp0 = WorldBones[0 + addr0.x].wwwx * i.position.xyzx + temp0;
    // mul r1, v0.yzxz, c128[a0.x].zxyz
    temp1 = i.position.yzxz * WorldBones[0 + addr0.x].zxyz;
    // mad r0, r0, c0.xxxy, -r1
    temp0 = temp0 * float4(1, 1, 1, -1) + -temp1;
    // mul r1.xyz, r0.w, c128[a0.x]
    temp1.xyz = temp0.www * WorldBones[0 + addr0.x].xyz;
    // mad r1.xyz, c128[a0.x].w, r0, -r1
    temp1.xyz = WorldBones[0 + addr0.x].www * temp0.xyz + -temp1.xyz;
    // mad r1.xyz, c128[a0.x].yzxw, r0.zxyw, r1
    temp1.xyz = WorldBones[0 + addr0.x].yzx * temp0.zxy + temp1.xyz;
    // mad r0.xyz, c128[a0.x].zxyw, -r0.yzxw, r1
    temp0.xyz = WorldBones[0 + addr0.x].zxy * -temp0.yzx + temp1.xyz;
    // add r0.xyz, r0, c129[a0.x]
    temp0.xyz = temp0.xyz + WorldBones[1 + addr0.x].xyz;
    // mov r0.w, c0.x
    temp0.w = float1(1);
    // dp4 oPos.x, r0, c119
    o.position.x = dot(temp0, (ViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c120
    o.position.y = dot(temp0, (ViewProjection._m01_m11_m21_m31));
    // dp4 r1.y, r0, c122
    temp1.y = dot(temp0, (ViewProjection._m03_m13_m23_m33));
    // dp4 r1.x, r0, c121
    temp1.x = dot(temp0, (ViewProjection._m02_m12_m22_m32));
    // rcp r0.x, r1.y
    temp0.x = 1.0f / temp1.y;
    // mov oPos.zw, r1.xyxy
    o.position.zw = temp1.xy;
    // mul oT1.x, r1.x, r0.x
    o.texcoord1 = temp1.x * temp0.x;
    // slt r0.x, v1.x, -v1.x
    temp0.x = (i.blendindices.x < -i.blendindices.x) ? 1 : 0;
    // frc r0.y, v1.x
    temp0.y = frac(i.blendindices.x);
    // add r0.z, -r0.y, v1.x
    temp0.z = -temp0.y + i.blendindices.x;
    // slt r0.y, -r0.y, r0.y
    temp0.y = (-temp0.y < temp0.y) ? 1 : 0;
    // mad r0.x, r0.x, r0.y, r0.z
    temp0.x = temp0.x * temp0.y + temp0.z;
    // add r0.x, r0.x, r0.x
    temp0.x = temp0.x + temp0.x;
    // mova a0.x, r0.x
    addr0.x = temp0.x;
    // mul r0.x, v3.w, c129[a0.x].w
    temp0.x = i.color.w * WorldBones[1 + addr0.x].w;
    // mul oD0.x, r0.x, c1.x
    o.color = temp0.x * OpacityOverride.x;
    // mov oT0.xy, v2
    o.texcoord = i.texcoord;
    // 

    return o;
}

VertexShader VSCreateShadowMap_Array[2] = {
    compile vs_2_0 VSCreateShadowMap_Array_Shader_0(), // 102
    compile vs_2_0 VSCreateShadowMap_Array_Shader_1(), // 103
};
// PSCreateShadowMap_Array_Shader_0 Pixel_2_0 Has PRES False
float4 PSCreateShadowMap_Array_Shader_0(float texcoord1 : TEXCOORD1) : COLOR
{
    float4 out_color;
    float4 temp0;
    // dcl t1.x
    // mov r0, t1.x
    temp0 = texcoord1.x;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// PSCreateShadowMap_Array_Shader_1 Pixel_2_0 Has PRES False
struct PSCreateShadowMap_Array_Shader_1_Input
{
    float2 texcoord : TEXCOORD;
    float texcoord1 : TEXCOORD1;
    float color : COLOR;
};

float4 PSCreateShadowMap_Array_Shader_1(PSCreateShadowMap_Array_Shader_1_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    // def c0, -0.3764706, 0, 0, 0
    // dcl t0.xy
    // dcl t1.x
    // dcl v0.x
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(DiffuseTextureSampler, i.texcoord.xy);
    // mad r0, r0.w, v0.x, c0.x
    temp0 = temp0.w * i.color.x + float4(-0.3764706, -0.3764706, -0.3764706, -0.3764706);
    // texkill r0
    clip(temp0);
    // mov r0, t1.x
    temp0 = i.texcoord1.x;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

PixelShader PSCreateShadowMap_Array[2] = {
    compile ps_2_0 PSCreateShadowMap_Array_Shader_0(), // 104
    compile ps_2_0 PSCreateShadowMap_Array_Shader_1(), // 105
};
// _CreateShadowMap_Expression21 Expression_2_0 Has PRES False
float _CreateShadowMap_Expression21()
{
    float1 expr0;
    // mov c0.x, c0.x
    expr0.x = AlphaTestEnable.x;
    return expr0;
}

// _CreateShadowMap_Expression22 Expression_2_0 Has PRES False
float _CreateShadowMap_Expression22()
{
    float1 expr0;
    // min c0.x, c0.x, (1)
    expr0.x = min(NumJointsPerVertex.x, (1));
    return expr0;
}

// Default_L_Expression23 Expression_2_0 Has PRES False
float Default_L_Expression23()
{
    float1 expr0;
    // min c0.x, c0.x, (1)
    expr0.x = min(NumJointsPerVertex.x, (1));
    return expr0;
}

// Default_M_Expression24 Expression_2_0 Has PRES False
float Default_M_Expression24()
{
    float1 expr0;
    // mov c0.x, c0.x
    expr0.x = HasShadow.x;
    return expr0;
}

// Default_M_Expression25 Expression_2_0 Has PRES False
float Default_M_Expression25()
{
    float1 expr0;
    // min c0.x, c0.x, (1)
    expr0.x = min(NumJointsPerVertex.x, (1));
    return expr0;
}

// Default_Expression26 Expression_2_0 Has PRES False
float Default_Expression26()
{
    float1 expr0;
    // mov c0.x, c0.x
    expr0.x = HasShadow.x;
    return expr0;
}

// Default_Expression27 Expression_2_0 Has PRES False
float Default_Expression27()
{
    float1 expr0;
    // min c0.x, c0.x, (1)
    expr0.x = min(NumJointsPerVertex.x, (1));
    return expr0;
}

technique Default
{
    pass p0 <string ExpressionEvaluator = "Objects";>
    {
        VertexShader = VS_H_Array[Default_Expression27()]; // 84
        PixelShader = PS_H_Array[Default_Expression26()]; // 85
        ZEnable = 1;
        ZFunc = 4;
        ZWriteEnable = 1;
        CullMode = 2;
        SrcBlend = 5;
        DestBlend = 6;
        AlphaFunc = 7;
        AlphaRef = 96;
    }
}

technique Default_M
{
    pass p0 <string ExpressionEvaluator = "Objects";>
    {
        VertexShader = VS_M_Array[Default_M_Expression25()]; // 93
        PixelShader = PS_M_Array[Default_M_Expression24()]; // 94
        ZEnable = 1;
        ZFunc = 4;
        ZWriteEnable = 1;
        CullMode = 2;
        SrcBlend = 5;
        DestBlend = 6;
        AlphaFunc = 7;
        AlphaRef = 96;
    }
}

technique Default_L
{
    pass p0 <string ExpressionEvaluator = "Objects";>
    {
        VertexShader = VS_L_Array[Default_L_Expression23()]; // 100
        PixelShader = <PS_L_Array[0]>; // 101
        ZEnable = 1;
        ZFunc = 4;
        ZWriteEnable = 1;
        CullMode = 2;
        SrcBlend = 5;
        DestBlend = 6;
        AlphaFunc = 7;
        AlphaRef = 96;
    }
}

technique _CreateShadowMap
{
    pass p0
    {
        VertexShader = VSCreateShadowMap_Array[_CreateShadowMap_Expression22()]; // 106
        PixelShader = PSCreateShadowMap_Array[_CreateShadowMap_Expression21()]; // 107
        ZEnable = 1;
        ZFunc = 4;
        ZWriteEnable = 1;
        CullMode = 2;
        AlphaBlendEnable = 0;
        AlphaTestEnable = 0;
    }
}

