string DefaultParameterScopeBlock = "material"; // 1
float3 AmbientLightColor <bool unmanaged = 1;> = { 0.3, 0.3, 0.3 };
struct {
    float3 Color;
    float3 Direction;
} DirectionalLight[3] <bool unmanaged = 1;> = { 1.625198, 1.512711, 1.097048, 0.62914, -0.34874, 0.69465, 0.5232916, 0.6654605, 0.7815244, -0.32877, 0.90329, 0.27563, 0.4420466, 0.4102767, 0.4420466, -0.80704, -0.58635, 0.06975 };
struct {
    float3 Color;
    float3 Position;
    float2 Range_Inner_Outer;
} PointLight[8] <bool unmanaged = 1;>;
struct {
    float4 WorldPositionMultiplier_XYZZ;
    float2 CurrentOffsetUV;
} Cloud <bool unmanaged = 1;>;
float3 NoCloudMultiplier <bool unmanaged = 1;> = { 1, 1, 1 };
float3 RecolorColorDummy <bool unmanaged = 1;>;
row_major float4x4 ShadowMapWorldToShadow <bool unmanaged = 1;>;
float OpacityOverride <bool unmanaged = 1;> = { 1 };
float3 TintColor <bool unmanaged = 1;> = { 1, 1, 1 };
float3 EyePosition <bool unmanaged = 1;>;
column_major float4x4 ViewProjection : register(vs_2_0, c119) <bool unmanaged = 1;>;
float4 WorldBones[128] <bool unmanaged = 1;>;
texture Texture_0 <string UIWidget = "None"; string SasBindAddress = "WW3D.MiscTexture"; int WW3DDynamicSet = 2;>; // 2
sampler2D Texture_0Sampler : register(ps_2_0, s0) <string Texture = "Texture_0"; string UIWidget = "None"; string SasBindAddress = "WW3D.MiscTexture"; int WW3DDynamicSet = 2;> =
sampler_state
{
    Texture = <Texture_0>; // 5
    AddressU = 3;
    AddressV = 3;
    MinFilter = 2;
    MagFilter = 2;
    MipFilter = 2;
};
// Default_M_PixelShader1 Pixel_2_0 Has PRES False
struct Default_M_PixelShader1_Input
{
    float4 color : COLOR;
    float2 texcoord : TEXCOORD;
};

float4 Default_M_PixelShader1(Default_M_PixelShader1_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    // dcl v0
    // dcl t0.xy
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(Texture_0Sampler, i.texcoord.xy);
    // mul r0, r0, v0
    temp0 = temp0 * i.color;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// Default_M_VertexShader2 Vertex_2_0 Has PRES False
struct Default_M_VertexShader2_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct Default_M_VertexShader2_Output
{
    float4 position : POSITION;
    float4 color : COLOR;
    float2 texcoord : TEXCOORD;
};

Default_M_VertexShader2_Output Default_M_VertexShader2(Default_M_VertexShader2_Input i)
{
    Default_M_VertexShader2_Output o;
    float4 temp0;
    // def c0, 1, 0, 0, 0
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_color v2
    // mad r0, v0.xyzx, c0.xxxy, c0.yyyx
    temp0 = i.position.xyzx * float4(1, 1, 1, 0) + float4(0, 0, 0, 1);
    // dp4 oPos.x, r0, c119
    o.position.x = dot(temp0, (ViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c120
    o.position.y = dot(temp0, (ViewProjection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c121
    o.position.z = dot(temp0, (ViewProjection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c122
    o.position.w = dot(temp0, (ViewProjection._m03_m13_m23_m33));
    // mov oD0, v2
    o.color = i.color;
    // mov oT0.xy, v1
    o.texcoord = i.texcoord;
    // 

    return o;
}

// Default_PixelShader3 Pixel_2_0 Has PRES False
struct Default_PixelShader3_Input
{
    float4 color : COLOR;
    float2 texcoord : TEXCOORD;
};

float4 Default_PixelShader3(Default_PixelShader3_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    float3 temp1;
    // def c0, 2.2, 0, 0, 0
    // dcl v0
    // dcl t0.xy
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(Texture_0Sampler, i.texcoord.xy);
    // log r1.x, r0.x
    temp1.x = log2(temp0.x);
    // log r1.y, r0.y
    temp1.y = log2(temp0.y);
    // log r1.z, r0.z
    temp1.z = log2(temp0.z);
    // mul r1.xyz, r1, c0.x
    temp1.xyz = temp1.xyz * float3(2.2, 2.2, 2.2);
    // exp r0.x, r1.x
    temp0.x = exp2(temp1.x);
    // exp r0.y, r1.y
    temp0.y = exp2(temp1.y);
    // exp r0.z, r1.z
    temp0.z = exp2(temp1.z);
    // mul r0, r0, v0
    temp0 = temp0 * i.color;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// Default_VertexShader4 Vertex_2_0 Has PRES False
struct Default_VertexShader4_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct Default_VertexShader4_Output
{
    float4 position : POSITION;
    float4 color : COLOR;
    float2 texcoord : TEXCOORD;
};

Default_VertexShader4_Output Default_VertexShader4(Default_VertexShader4_Input i)
{
    Default_VertexShader4_Output o;
    float4 temp0;
    // def c0, 1, 0, 0, 0
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_color v2
    // mad r0, v0.xyzx, c0.xxxy, c0.yyyx
    temp0 = i.position.xyzx * float4(1, 1, 1, 0) + float4(0, 0, 0, 1);
    // dp4 oPos.x, r0, c119
    o.position.x = dot(temp0, (ViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c120
    o.position.y = dot(temp0, (ViewProjection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c121
    o.position.z = dot(temp0, (ViewProjection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c122
    o.position.w = dot(temp0, (ViewProjection._m03_m13_m23_m33));
    // mov oD0, v2
    o.color = i.color;
    // mov oT0.xy, v1
    o.texcoord = i.texcoord;
    // 

    return o;
}

technique Default
{
    pass P0
    {
        VertexShader = compile vs_2_0 Default_VertexShader4(); // 9
        PixelShader = compile ps_2_0 Default_PixelShader3(); // 10
        ZEnable = 1;
        ZFunc = 4;
        ZWriteEnable = 0;
        CullMode = 2;
        ColorWriteEnable = 7;
        AlphaBlendEnable = 1;
        SrcBlend = 5;
        DestBlend = 6;
        AlphaTestEnable = 0;
    }
}

technique Default_M
{
    pass P0
    {
        VertexShader = compile vs_2_0 Default_M_VertexShader2(); // 11
        PixelShader = compile ps_2_0 Default_M_PixelShader1(); // 12
        ZEnable = 1;
        ZFunc = 4;
        ZWriteEnable = 0;
        CullMode = 2;
        ColorWriteEnable = 7;
        AlphaBlendEnable = 1;
        SrcBlend = 5;
        DestBlend = 6;
        AlphaTestEnable = 0;
    }
}

