string DefaultParameterScopeBlock = "material"; // 1
float3 AmbientLightColor : register(vs_2_0, c4) <bool unmanaged = 1;> = { 0.3, 0.3, 0.3 };
struct
{
    float3 Color;
    float3 Direction;
} DirectionalLight[3] : register(vs_2_0, c5) <bool unmanaged = 1;> = { 1.625198, 1.512711, 1.097048, 0.62914, -0.34874, 0.69465, 0.5232916, 0.6654605, 0.7815244, -0.32877, 0.90329, 0.27563, 0.4420466, 0.4102767, 0.4420466, -0.80704, -0.58635, 0.06975 };
int NumPointLights <string SasBindAddress = "Sas.NumPointLights"; string UIWidget = "None";>;
struct
{
    float3 Color;
    float3 Position;
    float2 Range_Inner_Outer;
} PointLight[3] : register(vs_2_0, c89) <bool unmanaged = 1;>;
struct {
    float4 WorldPositionMultiplier_XYZZ;
    float2 CurrentOffsetUV;
} Cloud <bool unmanaged = 1;>;
float3 NoCloudMultiplier <bool unmanaged = 1;> = { 1, 1, 1 };
float3 RecolorColorDummy <bool unmanaged = 1;>;
column_major float4x4 ShadowMapWorldToShadow : register(vs_2_0, c113) <bool unmanaged = 1;>;
float OpacityOverride : register(vs_2_0, c1) : register(ps_2_0, c1) <bool unmanaged = 1;> = { 1 };
float3 TintColor <bool unmanaged = 1;> = { 1, 1, 1 };
float3 EyePosition <bool unmanaged = 1;>;
column_major float4x4 ViewProjection : register(vs_2_0, c119) <bool unmanaged = 1;>;
float4 WorldBones[128] : register(vs_2_0, c128) <bool unmanaged = 1;>;
bool HasShadow <string UIWidget = "None"; string SasBindAddress = "Sas.HasShadow";>;
texture ShadowMap <string UIWidget = "None"; string SasBindAddress = "Sas.Shadow[0].ShadowMap";>; // 6
sampler2D ShadowMapSampler <string Texture = "ShadowMap"; string UIWidget = "None"; string SasBindAddress = "Sas.Shadow[0].ShadowMap";> =
sampler_state
{
    Texture = <ShadowMap>; // 9
    MinFilter = 1;
    MagFilter = 1;
    MipFilter = 0;
    AddressU = 3;
    AddressV = 3;
};
float4 Shadowmap_Zero_Zero_OneOverMapSize_OneOverMapSize : register(ps_2_0, c11) <string UIWidget = "None"; string SasBindAddress = "Sas.Shadow[0].Zero_Zero_OneOverMapSize_OneOverMapSize";>;
int _SasGlobal : SasGlobal <string UIWidget = "None"; int3 SasVersion = int3(1, 0, 0); int MaxLocalLights = 3; int MaxSupportedInstancingMode = 1;>;
int NumJointsPerVertex <string UIWidget = "None"; string SasBindAddress = "Sas.Skeleton.NumJointsPerVertex";>;
column_major float4x3 World : World : register(vs_2_0, c124);
texture DiffuseTexture <string UIName = "Diffuse Texture";>; // 18
sampler2D DiffuseTextureSampler <string Texture = "DiffuseTexture"; string UIName = "Diffuse Texture";> =
sampler_state
{
    Texture = <DiffuseTexture>; // 20
    MinFilter = 3;
    MagFilter = 2;
    MipFilter = 2;
    MaxAnisotropy = 8;
    AddressU = 1;
    AddressV = 1;
};
float3 AmbientColor : register(vs_2_0, c15) <string UIName = "Ambient Color"; string UIWidget = "Color";> = { 0.4, 0.4, 0.4 };
float4 DiffuseColor : register(vs_2_0, c16) <string UIName = "Diffuse Color"; string UIWidget = "Color";> = { 1, 1, 1, 1 };
bool SwayEnable : register(vs_2_0, c17) <string UIName = "Sway Enable";>;
float Amp1 : register(vs_2_0, c18) <string UIName = "Sway Amplitude"; string UIWidget = "Slider"; float UIMax = 100; float UIMin = 0; float UIStep = 0.01;> = { 1 };
float Freq1 : register(vs_2_0, c19) <string UIName = "Sway Frequency"; string UIWidget = "Slider"; float UIMax = 100; float UIMin = 0; float UIStep = 0.01;> = { 10 };
float Phase1 <string UIName = "Sway Phase"; string UIWidget = "Slider"; float UIMax = 100; float UIMin = 0; float UIStep = 0.01;> = { 1 };
struct
{
    float4 ScaleUV_OffsetUV;
} Shroud : register(vs_2_0, c20) <string UIWidget = "None"; string SasBindAddress = "Terrain.Shroud";> = { 1, 1, 0, 0 };
texture ShroudTexture <string UIWidget = "None"; string SasBindAddress = "Terrain.Shroud.Texture";>; // 36
sampler2D ShroudTextureSampler <string Texture = "ShroudTexture"; string UIWidget = "None"; string SasBindAddress = "Terrain.Shroud.Texture";> =
sampler_state
{
    Texture = <ShroudTexture>; // 39
    MinFilter = 2;
    MagFilter = 2;
    MipFilter = 2;
    AddressU = 3;
    AddressV = 3;
};
float Time : Time;
// VS_Array_Shader_0 Vertex_2_0 Has PRES True
struct VS_Array_Shader_0_Input
{
    float4 position : POSITION;
    float4 normal : NORMAL;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct VS_Array_Shader_0_Output
{
    float3 texcoord3 : TEXCOORD3;
    float4 color : COLOR;
    float4 position : POSITION;
    float2 texcoord1 : TEXCOORD1;
    float2 texcoord : TEXCOORD;
    float4 texcoord2 : TEXCOORD2;
    float color1 : COLOR1;
};

VS_Array_Shader_0_Output VS_Array_Shader_0(VS_Array_Shader_0_Input i)
{
    /*
    PRSI
      OutputRegisterOffset: 11
      Unknown1: 0
      Unknown2: 0
      OutputRegisterCount: 4
      Unknown3: 0
      Unknown4: 0
      Unknown5: 11
      Unknown6: 4
      Mappings: 1
        0 - ConstOutput: 0 ConstInput 0
    
    */
    float4 expr11;
    float4 expr12;
    float4 expr13;
    float4 expr14;
    {
        // Expression_2_1
        // mul c11.x, c1.x, c2.x
        expr11.x = Phase1.x * Time.x;
        // lt c12.x, (0), c0.x
        expr12.x = (0) < NumPointLights.x;
        // lt c13.x, (1), c0.x
        expr13.x = (1) < NumPointLights.x;
        // lt c14.x, (2), c0.x
        expr14.x = (2) < NumPointLights.x;
    }

    VS_Array_Shader_0_Output o;
    float4 temp0, temp1, temp2, temp3;
    float3 temp4;
    // def c0, 1, 0, 0.1591549, 0.25
    // def c2, 6.283185, -3.141593, -2.523985E-07, 2.47609E-05
    // def c3, -0.00138884, 0.04166664, -0.5, 0.5
    // def c21, 0, -0.0015, 0, 0
    // dcl_position v0
    // dcl_normal v1
    // dcl_texcoord v2
    // dcl_color v3
    // dp3 r0.x, v1, c124
    temp0.x = dot(i.normal.xyz, (World._m00_m10_m20_m30).xyz);
    // dp3 r0.y, v1, c125
    temp0.y = dot(i.normal.xyz, (World._m01_m11_m21_m31).xyz);
    // dp3 r0.z, v1, c126
    temp0.z = dot(i.normal.xyz, (World._m02_m12_m22_m32).xyz);
    // dp3 r0.w, r0, c6
    temp0.w = dot(temp0.xyz, DirectionalLight[0].Direction.xyz);
    // max r0.w, r0.w, c0.y
    temp0.w = max(temp0.w, float1(0));
    // mul r1.xyz, r0.w, c5
    temp1.xyz = temp0.www * DirectionalLight[0].Color.xyz;
    // mul oT3.xyz, r1, c16
    o.texcoord3 = temp1 * DiffuseColor;
    // dp3 r0.w, r0, c10
    temp0.w = dot(temp0.xyz, DirectionalLight[2].Direction.xyz);
    // max r0.w, r0.w, c0.y
    temp0.w = max(temp0.w, float1(0));
    // mul r1.xyz, r0.w, c9
    temp1.xyz = temp0.www * DirectionalLight[2].Color.xyz;
    // dp3 r0.w, r0, c8
    temp0.w = dot(temp0.xyz, DirectionalLight[1].Direction.xyz);
    // max r0.w, r0.w, c0.y
    temp0.w = max(temp0.w, float1(0));
    // mad r1.xyz, c7, r0.w, r1
    temp1.xyz = DirectionalLight[1].Color.xyz * temp0.www + temp1.xyz;
    // add r0.w, -c91.x, c91.y
    temp0.w = -PointLight[0].Range_Inner_Outer.x + PointLight[0].Range_Inner_Outer.y;
    // rcp r0.w, r0.w
    temp0.w = 1.0f / temp0.w;
    // mad r2, v0.xyzx, c0.xxxy, c0.yyyx
    temp2 = i.position.xyzx * float4(1, 1, 1, 0) + float4(0, 0, 0, 1);
    // dp4 r3.x, r2, c124
    temp3.x = dot(temp2, (World._m00_m10_m20_m30));
    // frc r1.w, r3.x
    temp1.w = frac(temp3.x);
    // mov r4.x, c19.x
    temp4.x = Freq1.x;
    // mad r1.w, r1.w, r4.x, c11.x
    temp1.w = temp1.w * temp4.x + expr11.x;
    // mad r1.w, r1.w, c0.z, c0.w
    temp1.w = temp1.w * float1(0.15915494) + float1(0.25);
    // frc r1.w, r1.w
    temp1.w = frac(temp1.w);
    // mad r1.w, r1.w, c2.x, c2.y
    temp1.w = temp1.w * float1(6.2831855) + float1(-3.1415927);
    // mul r1.w, r1.w, r1.w
    temp1.w = temp1.w * temp1.w;
    // mad r3.w, r1.w, c2.z, c2.w
    temp3.w = temp1.w * float1(-2.523985E-07) + float1(2.47609E-05);
    // mad r3.w, r1.w, r3.w, c3.x
    temp3.w = temp1.w * temp3.w + float1(-0.0013888397);
    // mad r3.w, r1.w, r3.w, c3.y
    temp3.w = temp1.w * temp3.w + float1(0.04166664);
    // mad r3.w, r1.w, r3.w, c3.z
    temp3.w = temp1.w * temp3.w + float1(-0.5);
    // mad r1.w, r1.w, r3.w, c0.x
    temp1.w = temp1.w * temp3.w + float1(1);
    // mul r1.w, r1.w, c18.x
    temp1.w = temp1.w * Amp1.x;
    // mul r1.w, r1.w, v3.w
    temp1.w = temp1.w * i.color.w;
    // dp4 r3.y, r2, c125
    temp3.y = dot(temp2, (World._m01_m11_m21_m31));
    // dp4 r3.z, r2, c126
    temp3.z = dot(temp2, (World._m02_m12_m22_m32));
    // mad r2.xyz, c17.x, r1.w, r3
    temp2.xyz = SwayEnable.xxx * temp1.www + temp3.xyz;
    // add r3.xyz, -r2, c90
    temp3.xyz = -temp2.xyz + PointLight[0].Position.xyz;
    // dp3 r1.w, r3, r3
    temp1.w = dot(temp3.xyz, temp3.xyz);
    // rsq r1.w, r1.w
    temp1.w = 1 / sqrt(temp1.w);
    // rcp r3.w, r1.w
    temp3.w = 1.0f / temp1.w;
    // mul r3.xyz, r3, r1.w
    temp3.xyz = temp3.xyz * temp1.www;
    // add r1.w, r3.w, -c91.x
    temp1.w = temp3.w + -PointLight[0].Range_Inner_Outer.x;
    // mad r0.w, r1.w, -r0.w, c0.x
    temp0.w = temp1.w * -temp0.w + float1(1);
    // max r0.w, r0.w, c0.y
    temp0.w = max(temp0.w, float1(0));
    // min r0.w, r0.w, c0.x
    temp0.w = min(temp0.w, float1(1));
    // mul r0.w, r0.w, r0.w
    temp0.w = temp0.w * temp0.w;
    // mul r4.xyz, r0.w, c89
    temp4.xyz = temp0.www * PointLight[0].Color.xyz;
    // dp3 r0.w, r0, r3
    temp0.w = dot(temp0.xyz, temp3.xyz);
    // max r0.w, r0.w, c0.y
    temp0.w = max(temp0.w, float1(0));
    // mul r3.xyz, r4, r0.w
    temp3.xyz = temp4.xyz * temp0.www;
    // mad r1.xyz, c12.x, r3, r1
    temp1.xyz = expr12.xxx * temp3.xyz + temp1.xyz;
    // add r0.w, -c94.x, c94.y
    temp0.w = -PointLight[1].Range_Inner_Outer.x + PointLight[1].Range_Inner_Outer.y;
    // rcp r0.w, r0.w
    temp0.w = 1.0f / temp0.w;
    // add r3.xyz, -r2, c93
    temp3.xyz = -temp2.xyz + PointLight[1].Position.xyz;
    // dp3 r1.w, r3, r3
    temp1.w = dot(temp3.xyz, temp3.xyz);
    // rsq r1.w, r1.w
    temp1.w = 1 / sqrt(temp1.w);
    // rcp r3.w, r1.w
    temp3.w = 1.0f / temp1.w;
    // mul r3.xyz, r3, r1.w
    temp3.xyz = temp3.xyz * temp1.www;
    // add r1.w, r3.w, -c94.x
    temp1.w = temp3.w + -PointLight[1].Range_Inner_Outer.x;
    // mad r0.w, r1.w, -r0.w, c0.x
    temp0.w = temp1.w * -temp0.w + float1(1);
    // max r0.w, r0.w, c0.y
    temp0.w = max(temp0.w, float1(0));
    // min r0.w, r0.w, c0.x
    temp0.w = min(temp0.w, float1(1));
    // mul r0.w, r0.w, r0.w
    temp0.w = temp0.w * temp0.w;
    // mul r4.xyz, r0.w, c92
    temp4.xyz = temp0.www * PointLight[1].Color.xyz;
    // dp3 r0.w, r0, r3
    temp0.w = dot(temp0.xyz, temp3.xyz);
    // max r0.w, r0.w, c0.y
    temp0.w = max(temp0.w, float1(0));
    // mul r3.xyz, r4, r0.w
    temp3.xyz = temp4.xyz * temp0.www;
    // mad r1.xyz, c13.x, r3, r1
    temp1.xyz = expr13.xxx * temp3.xyz + temp1.xyz;
    // add r3.xyz, -r2, c96
    temp3.xyz = -temp2.xyz + PointLight[2].Position.xyz;
    // dp3 r0.w, r3, r3
    temp0.w = dot(temp3.xyz, temp3.xyz);
    // rsq r0.w, r0.w
    temp0.w = 1 / sqrt(temp0.w);
    // mul r3.xyz, r3, r0.w
    temp3.xyz = temp3.xyz * temp0.www;
    // rcp r0.w, r0.w
    temp0.w = 1.0f / temp0.w;
    // dp3 r0.x, r0, r3
    temp0.x = dot(temp0.xyz, temp3.xyz);
    // max r0.x, r0.x, c0.y
    temp0.x = max(temp0.x, float1(0));
    // add r0.y, -c97.x, c97.y
    temp0.y = -PointLight[2].Range_Inner_Outer.x + PointLight[2].Range_Inner_Outer.y;
    // rcp r0.y, r0.y
    temp0.y = 1.0f / temp0.y;
    // add r0.z, r0.w, -c97.x
    temp0.z = temp0.w + -PointLight[2].Range_Inner_Outer.x;
    // mad r0.y, r0.z, -r0.y, c0.x
    temp0.y = temp0.z * -temp0.y + float1(1);
    // max r0.y, r0.y, c0.y
    temp0.y = max(temp0.y, float1(0));
    // min r0.y, r0.y, c0.x
    temp0.y = min(temp0.y, float1(1));
    // mul r0.y, r0.y, r0.y
    temp0.y = temp0.y * temp0.y;
    // mul r0.yzw, r0.y, c95.xxyz
    temp0.yzw = temp0.yyy * PointLight[2].Color.xyz;
    // mul r0.xyz, r0.x, r0.yzww
    temp0.xyz = temp0.xxx * temp0.yzw;
    // mad r0.xyz, c14.x, r0, r1
    temp0.xyz = expr14.xxx * temp0.xyz + temp1.xyz;
    // mul r0.xyz, r0, c16
    temp0.xyz = temp0.xyz * DiffuseColor.xyz;
    // mov r1.xyz, c4
    temp1.xyz = AmbientLightColor.xyz;
    // mad r0.xyz, r1, c15, r0
    temp0.xyz = temp1.xyz * AmbientColor.xyz + temp0.xyz;
    // mov r0.w, c1.x
    temp0.w = OpacityOverride.x;
    // mul oD0, r0, c3.w
    o.color = temp0 * float4(0.5, 0.5, 0.5, 0.5);
    // mov r2.w, c0.x
    temp2.w = float1(1);
    // dp4 oPos.x, r2, c119
    o.position.x = dot(temp2, (ViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r2, c120
    o.position.y = dot(temp2, (ViewProjection._m01_m11_m21_m31));
    // dp4 oPos.z, r2, c121
    o.position.z = dot(temp2, (ViewProjection._m02_m12_m22_m32));
    // dp4 oPos.w, r2, c122
    o.position.w = dot(temp2, (ViewProjection._m03_m13_m23_m33));
    // add r0.xy, r2, c20.zwzw
    temp0.xy = temp2.xy + Shroud.ScaleUV_OffsetUV.zw;
    // mul oT1.xy, r0, c20
    o.texcoord1 = temp0 * Shroud.ScaleUV_OffsetUV;
    // mov oT0.xy, v2
    o.texcoord = i.texcoord;
    // dp4 r0.x, r2, c113
    temp0.x = dot(temp2, (ShadowMapWorldToShadow._m00_m10_m20_m30));
    // dp4 r0.y, r2, c114
    temp0.y = dot(temp2, (ShadowMapWorldToShadow._m01_m11_m21_m31));
    // dp4 r0.z, r2, c115
    temp0.z = dot(temp2, (ShadowMapWorldToShadow._m02_m12_m22_m32));
    // dp4 r0.w, r2, c116
    temp0.w = dot(temp2, (ShadowMapWorldToShadow._m03_m13_m23_m33));
    // rcp r1.x, r0.w
    temp1.x = 1.0f / temp0.w;
    // mov oT2.w, r0.w
    o.texcoord2.w = temp0.w;
    // mad oT2.xyz, r0, r1.x, c21.xxyw
    o.texcoord2.xyz = temp0.xyz * temp1.xxx + float3(0, 0, -0.0015);
    // mov oD1.x, c0.x
    o.color1 = float4(1, 1, 1, 1);
    // 

    return o;
}

// VS_Array_Shader_1 Vertex_2_0 Has PRES True
struct VS_Array_Shader_1_Input
{
    float4 position : POSITION;
    float4 normal : NORMAL;
    float4 blendindices : BLENDINDICES;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct VS_Array_Shader_1_Output
{
    float3 texcoord3 : TEXCOORD3;
    float4 color : COLOR;
    float4 position : POSITION;
    float2 texcoord1 : TEXCOORD1;
    float2 texcoord : TEXCOORD;
    float4 texcoord2 : TEXCOORD2;
    float color1 : COLOR1;
};

VS_Array_Shader_1_Output VS_Array_Shader_1(VS_Array_Shader_1_Input i)
{
    /*
    PRSI
      OutputRegisterOffset: 11
      Unknown1: 0
      Unknown2: 0
      OutputRegisterCount: 4
      Unknown3: 0
      Unknown4: 0
      Unknown5: 11
      Unknown6: 4
      Mappings: 1
        0 - ConstOutput: 0 ConstInput 0
    
    */
    float4 expr11;
    float4 expr12;
    float4 expr13;
    float4 expr14;
    {
        // Expression_2_1
        // mul c11.x, c1.x, c2.x
        expr11.x = Phase1.x * Time.x;
        // lt c12.x, (0), c0.x
        expr12.x = (0) < NumPointLights.x;
        // lt c13.x, (1), c0.x
        expr13.x = (1) < NumPointLights.x;
        // lt c14.x, (2), c0.x
        expr14.x = (2) < NumPointLights.x;
    }

    VS_Array_Shader_1_Output o;
    float4 temp0, temp1, temp2;
    float addr0;
    float3 temp3;
    // def c0, -0.00138884, 0.04166664, -0.5, 0
    // def c2, 1, -1, 0.1591549, 0.25
    // def c3, 6.283185, -3.141593, -2.523985E-07, 2.47609E-05
    // def c21, 0, -0.0015, 0, 0
    // dcl_position v0
    // dcl_normal v1
    // dcl_blendindices v2
    // dcl_texcoord v3
    // dcl_color v4
    // add r0.x, v2.x, v2.x
    temp0.x = i.blendindices.x + i.blendindices.x;
    // frc r0.y, r0.x
    temp0.y = frac(temp0.x);
    // add r0.z, r0.x, -r0.y
    temp0.z = temp0.x + -temp0.y;
    // slt r0.y, -r0.y, r0.y
    temp0.y = (-temp0.y < temp0.y) ? 1 : 0;
    // slt r0.x, r0.x, -r0.x
    temp0.x = (temp0.x < -temp0.x) ? 1 : 0;
    // mad r0.x, r0.x, r0.y, r0.z
    temp0.x = temp0.x * temp0.y + temp0.z;
    // mova a0.x, r0.x
    addr0.x = temp0.x;
    // mul r0, v1.zxyy, c128[a0.x].yzxy
    temp0 = i.normal.zxyy * WorldBones[0 + addr0.x].yzxy;
    // mad r0, c128[a0.x].wwwx, v1.xyzx, r0
    temp0 = WorldBones[0 + addr0.x].wwwx * i.normal.xyzx + temp0;
    // mul r1, v1.yzxz, c128[a0.x].zxyz
    temp1 = i.normal.yzxz * WorldBones[0 + addr0.x].zxyz;
    // mad r0, r0, c2.xxxy, -r1
    temp0 = temp0 * float4(1, 1, 1, -1) + -temp1;
    // mul r1.xyz, r0.w, c128[a0.x]
    temp1.xyz = temp0.www * WorldBones[0 + addr0.x].xyz;
    // mad r1.xyz, c128[a0.x].w, r0, -r1
    temp1.xyz = WorldBones[0 + addr0.x].www * temp0.xyz + -temp1.xyz;
    // mad r1.xyz, c128[a0.x].yzxw, r0.zxyw, r1
    temp1.xyz = WorldBones[0 + addr0.x].yzx * temp0.zxy + temp1.xyz;
    // mad r0.xyz, c128[a0.x].zxyw, -r0.yzxw, r1
    temp0.xyz = WorldBones[0 + addr0.x].zxy * -temp0.yzx + temp1.xyz;
    // dp3 r0.w, r0, c6
    temp0.w = dot(temp0.xyz, DirectionalLight[0].Direction.xyz);
    // max r0.w, r0.w, c0.w
    temp0.w = max(temp0.w, float1(0));
    // mul r1.xyz, r0.w, c5
    temp1.xyz = temp0.www * DirectionalLight[0].Color.xyz;
    // mul oT3.xyz, r1, c16
    o.texcoord3 = temp1 * DiffuseColor;
    // mul r1, v0.zxyy, c128[a0.x].yzxy
    temp1 = i.position.zxyy * WorldBones[0 + addr0.x].yzxy;
    // mad r1, c128[a0.x].wwwx, v0.xyzx, r1
    temp1 = WorldBones[0 + addr0.x].wwwx * i.position.xyzx + temp1;
    // mul r2, v0.yzxz, c128[a0.x].zxyz
    temp2 = i.position.yzxz * WorldBones[0 + addr0.x].zxyz;
    // mad r1, r1, c2.xxxy, -r2
    temp1 = temp1 * float4(1, 1, 1, -1) + -temp2;
    // mul r2.xyz, r1.w, c128[a0.x]
    temp2.xyz = temp1.www * WorldBones[0 + addr0.x].xyz;
    // mad r2.xyz, c128[a0.x].w, r1, -r2
    temp2.xyz = WorldBones[0 + addr0.x].www * temp1.xyz + -temp2.xyz;
    // mad r2.xyz, c128[a0.x].yzxw, r1.zxyw, r2
    temp2.xyz = WorldBones[0 + addr0.x].yzx * temp1.zxy + temp2.xyz;
    // mad r1.xyz, c128[a0.x].zxyw, -r1.yzxw, r2
    temp1.xyz = WorldBones[0 + addr0.x].zxy * -temp1.yzx + temp2.xyz;
    // add r1.xyz, r1, c129[a0.x]
    temp1.xyz = temp1.xyz + WorldBones[1 + addr0.x].xyz;
    // frc r0.w, r1.x
    temp0.w = frac(temp1.x);
    // mov r2.x, c19.x
    temp2.x = Freq1.x;
    // mad r0.w, r0.w, r2.x, c11.x
    temp0.w = temp0.w * temp2.x + expr11.x;
    // mad r0.w, r0.w, c2.z, c2.w
    temp0.w = temp0.w * float1(0.15915494) + float1(0.25);
    // frc r0.w, r0.w
    temp0.w = frac(temp0.w);
    // mad r0.w, r0.w, c3.x, c3.y
    temp0.w = temp0.w * float1(6.2831855) + float1(-3.1415927);
    // mul r0.w, r0.w, r0.w
    temp0.w = temp0.w * temp0.w;
    // mad r1.w, r0.w, c3.z, c3.w
    temp1.w = temp0.w * float1(-2.523985E-07) + float1(2.47609E-05);
    // mad r1.w, r0.w, r1.w, c0.x
    temp1.w = temp0.w * temp1.w + float1(-0.0013888397);
    // mad r1.w, r0.w, r1.w, c0.y
    temp1.w = temp0.w * temp1.w + float1(0.04166664);
    // mad r1.w, r0.w, r1.w, c0.z
    temp1.w = temp0.w * temp1.w + float1(-0.5);
    // mad r0.w, r0.w, r1.w, c2.x
    temp0.w = temp0.w * temp1.w + float1(1);
    // mul r0.w, r0.w, c18.x
    temp0.w = temp0.w * Amp1.x;
    // mul r0.w, r0.w, v4.w
    temp0.w = temp0.w * i.color.w;
    // mad r1.xyz, c17.x, r0.w, r1
    temp1.xyz = SwayEnable.xxx * temp0.www + temp1.xyz;
    // add r2.xyz, -r1, c90
    temp2.xyz = -temp1.xyz + PointLight[0].Position.xyz;
    // dp3 r0.w, r2, r2
    temp0.w = dot(temp2.xyz, temp2.xyz);
    // rsq r0.w, r0.w
    temp0.w = 1 / sqrt(temp0.w);
    // rcp r2.w, r0.w
    temp2.w = 1.0f / temp0.w;
    // mul r2.xyz, r2, r0.w
    temp2.xyz = temp2.xyz * temp0.www;
    // add r0.w, r2.w, -c91.x
    temp0.w = temp2.w + -PointLight[0].Range_Inner_Outer.x;
    // add r2.w, -c91.x, c91.y
    temp2.w = -PointLight[0].Range_Inner_Outer.x + PointLight[0].Range_Inner_Outer.y;
    // rcp r2.w, r2.w
    temp2.w = 1.0f / temp2.w;
    // mad r0.w, r0.w, -r2.w, c2.x
    temp0.w = temp0.w * -temp2.w + float1(1);
    // max r0.w, r0.w, c0.w
    temp0.w = max(temp0.w, float1(0));
    // min r0.w, r0.w, c2.x
    temp0.w = min(temp0.w, float1(1));
    // mul r0.w, r0.w, r0.w
    temp0.w = temp0.w * temp0.w;
    // mul r3.xyz, r0.w, c89
    temp3.xyz = temp0.www * PointLight[0].Color.xyz;
    // dp3 r0.w, r0, r2
    temp0.w = dot(temp0.xyz, temp2.xyz);
    // max r0.w, r0.w, c0.w
    temp0.w = max(temp0.w, float1(0));
    // mul r2.xyz, r3, r0.w
    temp2.xyz = temp3.xyz * temp0.www;
    // dp3 r0.w, r0, c10
    temp0.w = dot(temp0.xyz, DirectionalLight[2].Direction.xyz);
    // max r0.w, r0.w, c0.w
    temp0.w = max(temp0.w, float1(0));
    // mul r3.xyz, r0.w, c9
    temp3.xyz = temp0.www * DirectionalLight[2].Color.xyz;
    // dp3 r0.w, r0, c8
    temp0.w = dot(temp0.xyz, DirectionalLight[1].Direction.xyz);
    // max r0.w, r0.w, c0.w
    temp0.w = max(temp0.w, float1(0));
    // mad r3.xyz, c7, r0.w, r3
    temp3.xyz = DirectionalLight[1].Color.xyz * temp0.www + temp3.xyz;
    // mad r2.xyz, c12.x, r2, r3
    temp2.xyz = expr12.xxx * temp2.xyz + temp3.xyz;
    // add r3.xyz, -r1, c93
    temp3.xyz = -temp1.xyz + PointLight[1].Position.xyz;
    // dp3 r0.w, r3, r3
    temp0.w = dot(temp3.xyz, temp3.xyz);
    // rsq r0.w, r0.w
    temp0.w = 1 / sqrt(temp0.w);
    // mul r3.xyz, r3, r0.w
    temp3.xyz = temp3.xyz * temp0.www;
    // rcp r0.w, r0.w
    temp0.w = 1.0f / temp0.w;
    // dp3 r2.w, r0, r3
    temp2.w = dot(temp0.xyz, temp3.xyz);
    // max r2.w, r2.w, c0.w
    temp2.w = max(temp2.w, float1(0));
    // add r0.w, r0.w, -c94.x
    temp0.w = temp0.w + -PointLight[1].Range_Inner_Outer.x;
    // add r3.x, -c94.x, c94.y
    temp3.x = -PointLight[1].Range_Inner_Outer.x + PointLight[1].Range_Inner_Outer.y;
    // rcp r3.x, r3.x
    temp3.x = 1.0f / temp3.x;
    // mad r0.w, r0.w, -r3.x, c2.x
    temp0.w = temp0.w * -temp3.x + float1(1);
    // max r0.w, r0.w, c0.w
    temp0.w = max(temp0.w, float1(0));
    // min r0.w, r0.w, c2.x
    temp0.w = min(temp0.w, float1(1));
    // mul r0.w, r0.w, r0.w
    temp0.w = temp0.w * temp0.w;
    // mul r3.xyz, r0.w, c92
    temp3.xyz = temp0.www * PointLight[1].Color.xyz;
    // mul r3.xyz, r2.w, r3
    temp3.xyz = temp2.www * temp3.xyz;
    // mad r2.xyz, c13.x, r3, r2
    temp2.xyz = expr13.xxx * temp3.xyz + temp2.xyz;
    // add r3.xyz, -r1, c96
    temp3.xyz = -temp1.xyz + PointLight[2].Position.xyz;
    // dp3 r0.w, r3, r3
    temp0.w = dot(temp3.xyz, temp3.xyz);
    // rsq r0.w, r0.w
    temp0.w = 1 / sqrt(temp0.w);
    // mul r3.xyz, r3, r0.w
    temp3.xyz = temp3.xyz * temp0.www;
    // rcp r0.w, r0.w
    temp0.w = 1.0f / temp0.w;
    // dp3 r0.x, r0, r3
    temp0.x = dot(temp0.xyz, temp3.xyz);
    // max r0.x, r0.x, c0.w
    temp0.x = max(temp0.x, float1(0));
    // add r0.y, r0.w, -c97.x
    temp0.y = temp0.w + -PointLight[2].Range_Inner_Outer.x;
    // add r0.z, -c97.x, c97.y
    temp0.z = -PointLight[2].Range_Inner_Outer.x + PointLight[2].Range_Inner_Outer.y;
    // rcp r0.z, r0.z
    temp0.z = 1.0f / temp0.z;
    // mad r0.y, r0.y, -r0.z, c2.x
    temp0.y = temp0.y * -temp0.z + float1(1);
    // max r0.y, r0.y, c0.w
    temp0.y = max(temp0.y, float1(0));
    // min r0.y, r0.y, c2.x
    temp0.y = min(temp0.y, float1(1));
    // mul r0.y, r0.y, r0.y
    temp0.y = temp0.y * temp0.y;
    // mul r0.yzw, r0.y, c95.xxyz
    temp0.yzw = temp0.yyy * PointLight[2].Color.xyz;
    // mul r0.xyz, r0.x, r0.yzww
    temp0.xyz = temp0.xxx * temp0.yzw;
    // mad r0.xyz, c14.x, r0, r2
    temp0.xyz = expr14.xxx * temp0.xyz + temp2.xyz;
    // mul r0.xyz, r0, c16
    temp0.xyz = temp0.xyz * DiffuseColor.xyz;
    // mov r2.xyz, c4
    temp2.xyz = AmbientLightColor.xyz;
    // mad r0.xyz, r2, c15, r0
    temp0.xyz = temp2.xyz * AmbientColor.xyz + temp0.xyz;
    // mov r0.w, c1.x
    temp0.w = OpacityOverride.x;
    // mul oD0, r0, -c0.z
    o.color = temp0 * float4(0.5, 0.5, 0.5, 0.5);
    // mov r1.w, c2.x
    temp1.w = float1(1);
    // dp4 oPos.x, r1, c119
    o.position.x = dot(temp1, (ViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r1, c120
    o.position.y = dot(temp1, (ViewProjection._m01_m11_m21_m31));
    // dp4 oPos.z, r1, c121
    o.position.z = dot(temp1, (ViewProjection._m02_m12_m22_m32));
    // dp4 oPos.w, r1, c122
    o.position.w = dot(temp1, (ViewProjection._m03_m13_m23_m33));
    // add r0.xy, r1, c20.zwzw
    temp0.xy = temp1.xy + Shroud.ScaleUV_OffsetUV.zw;
    // mul oT1.xy, r0, c20
    o.texcoord1 = temp0 * Shroud.ScaleUV_OffsetUV;
    // mov oT0.xy, v3
    o.texcoord = i.texcoord;
    // dp4 r0.x, r1, c113
    temp0.x = dot(temp1, (ShadowMapWorldToShadow._m00_m10_m20_m30));
    // dp4 r0.y, r1, c114
    temp0.y = dot(temp1, (ShadowMapWorldToShadow._m01_m11_m21_m31));
    // dp4 r0.z, r1, c115
    temp0.z = dot(temp1, (ShadowMapWorldToShadow._m02_m12_m22_m32));
    // dp4 r0.w, r1, c116
    temp0.w = dot(temp1, (ShadowMapWorldToShadow._m03_m13_m23_m33));
    // rcp r1.x, r0.w
    temp1.x = 1.0f / temp0.w;
    // mov oT2.w, r0.w
    o.texcoord2.w = temp0.w;
    // mad oT2.xyz, r0, r1.x, c21.xxyw
    o.texcoord2.xyz = temp0.xyz * temp1.xxx + float3(0, 0, -0.0015);
    // mov oD1.x, c2.x
    o.color1 = float4(1, 1, 1, 1);
    // 

    return o;
}

VertexShader VS_Array[2] = {
    compile vs_2_0 VS_Array_Shader_0(), // 43
    compile vs_2_0 VS_Array_Shader_1(), // 44
};
// PS_Array_Shader_0 Pixel_2_0 Has PRES False
struct PS_Array_Shader_0_Input
{
    float2 texcoord : TEXCOORD;
    float2 texcoord1 : TEXCOORD1;
    float3 texcoord3 : TEXCOORD3;
    float4 color : COLOR;
};

float4 PS_Array_Shader_0(PS_Array_Shader_0_Input i) : COLOR
{
    float4 out_color;
    float4 temp0, temp1, temp2, temp3;
    float3 temp4;
    // def c0, 2.2, 2, 0, 0
    // dcl t0.xy
    // dcl t1.xy
    // dcl t3.xyz
    // dcl v0
    // dcl_2d s0
    // dcl_2d s1
    // texld r0, t0, s0
    temp0 = tex2D(DiffuseTextureSampler, i.texcoord.xy);
    // texld r1, t1, s1
    temp1 = tex2D(ShroudTextureSampler, i.texcoord1.xy);
    // mov r2.xyz, c0.y
    temp2.xyz = float3(2, 2, 2);
    // mov r3.xyz, v0
    temp3.xyz = i.color.xyz;
    // mad r2.xyz, r3, r2, t3
    temp2.xyz = temp3.xyz * temp2.xyz + i.texcoord3.xyz;
    // mov r3.w, c0.y
    temp3.w = float1(2);
    // log r4.x, r0.x
    temp4.x = log2(temp0.x);
    // log r4.y, r0.y
    temp4.y = log2(temp0.y);
    // log r4.z, r0.z
    temp4.z = log2(temp0.z);
    // mul r0.xyz, r4, c0.x
    temp0.xyz = temp4.xyz * float3(2.2, 2.2, 2.2);
    // exp r3.x, r0.x
    temp3.x = exp2(temp0.x);
    // exp r3.y, r0.y
    temp3.y = exp2(temp0.y);
    // exp r3.z, r0.z
    temp3.z = exp2(temp0.z);
    // mul r2.w, r0.w, v0.w
    temp2.w = temp0.w * i.color.w;
    // mul r0, r2, r3
    temp0 = temp2 * temp3;
    // mul r0.xyz, r1, r0
    temp0.xyz = temp1.xyz * temp0.xyz;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// PS_Array_Shader_1 Pixel_2_0 Has PRES False
struct PS_Array_Shader_1_Input
{
    float2 texcoord : TEXCOORD;
    float2 texcoord1 : TEXCOORD1;
    float3 texcoord2 : TEXCOORD2;
    float3 texcoord3 : TEXCOORD3;
    float4 color : COLOR;
};

float4 PS_Array_Shader_1(PS_Array_Shader_1_Input i) : COLOR
{
    float4 out_color;
    float4 temp0, temp1, temp2, temp3, temp4, temp5;
    // def c0, 2.2, 2, 1, 0
    // def c1, 0.25, 0, 0, 0
    // dcl t0.xy
    // dcl t1.xy
    // dcl t2.xyz
    // dcl t3.xyz
    // dcl v0
    // dcl_2d s0
    // dcl_2d s1
    // dcl_2d s2
    // add r0.xy, t2, c11.zxyw
    temp0.xy = i.texcoord2.xy + Shadowmap_Zero_Zero_OneOverMapSize_OneOverMapSize.zx;
    // add r1.xy, t2, c11.yzxw
    temp1.xy = i.texcoord2.xy + Shadowmap_Zero_Zero_OneOverMapSize_OneOverMapSize.yz;
    // add r2.xy, t2, c11.wzyx
    temp2.xy = i.texcoord2.xy + Shadowmap_Zero_Zero_OneOverMapSize_OneOverMapSize.wz;
    // texld r0, r0, s0
    temp0 = tex2D(ShadowMapSampler, temp0.xy);
    // texld r1, r1, s0
    temp1 = tex2D(ShadowMapSampler, temp1.xy);
    // texld r2, r2, s0
    temp2 = tex2D(ShadowMapSampler, temp2.xy);
    // texld r3, t2, s0
    temp3 = tex2D(ShadowMapSampler, i.texcoord2.xy);
    // texld r4, t0, s1
    temp4 = tex2D(DiffuseTextureSampler, i.texcoord.xy);
    // texld r5, t1, s2
    temp5 = tex2D(ShroudTextureSampler, i.texcoord1.xy);
    // mov r3.y, r0.x
    temp3.y = temp0.x;
    // mov r3.z, r1.x
    temp3.z = temp1.x;
    // mov r3.w, r2.x
    temp3.w = temp2.x;
    // add r0, r3, -t2.z
    temp0 = temp3 + -i.texcoord2.z;
    // cmp r0, r0, c0.z, c0.w
    temp0 = (temp0 >= 0) ? float4(1, 1, 1, 1) : float4(0, 0, 0, 0);
    // dp4 r5.w, c0.z, r0
    temp5.w = dot(float4(1, 1, 1, 1), temp0);
    // mul r5.w, r5.w, c1.x
    temp5.w = temp5.w * float1(0.25);
    // mov r0.xyz, c0.y
    temp0.xyz = float3(2, 2, 2);
    // mov r0.w, r4.w
    temp0.w = temp4.w;
    // mul r0, r0, v0
    temp0 = temp0 * i.color;
    // mad r0.xyz, t3, r5.w, r0
    temp0.xyz = i.texcoord3.xyz * temp5.www + temp0.xyz;
    // mov r1.w, c0.y
    temp1.w = float1(2);
    // log r2.x, r4.x
    temp2.x = log2(temp4.x);
    // log r2.y, r4.y
    temp2.y = log2(temp4.y);
    // log r2.z, r4.z
    temp2.z = log2(temp4.z);
    // mul r2.xyz, r2, c0.x
    temp2.xyz = temp2.xyz * float3(2.2, 2.2, 2.2);
    // exp r1.x, r2.x
    temp1.x = exp2(temp2.x);
    // exp r1.y, r2.y
    temp1.y = exp2(temp2.y);
    // exp r1.z, r2.z
    temp1.z = exp2(temp2.z);
    // mul r0, r0, r1
    temp0 = temp0 * temp1;
    // mul r0.xyz, r5, r0
    temp0.xyz = temp5.xyz * temp0.xyz;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

PixelShader PS_Array[2] = {
    compile ps_2_0 PS_Array_Shader_0(), // 45
    compile ps_2_0 PS_Array_Shader_1(), // 46
};
// VS_M_Array_Shader_0 Vertex_2_0 Has PRES True
struct VS_M_Array_Shader_0_Input
{
    float4 position : POSITION;
    float4 normal : NORMAL;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct VS_M_Array_Shader_0_Output
{
    float3 texcoord3 : TEXCOORD3;
    float4 color : COLOR;
    float4 position : POSITION;
    float2 texcoord1 : TEXCOORD1;
    float2 texcoord : TEXCOORD;
    float4 texcoord2 : TEXCOORD2;
    float color1 : COLOR1;
};

VS_M_Array_Shader_0_Output VS_M_Array_Shader_0(VS_M_Array_Shader_0_Input i)
{
    /*
    PRSI
      OutputRegisterOffset: 17
      Unknown1: 0
      Unknown2: 0
      OutputRegisterCount: 1
      Unknown3: 0
      Unknown4: 0
      Unknown5: 17
      Unknown6: 1
      Mappings: 1
        0 - ConstOutput: 0 ConstInput 0
    
    */
    float4 expr17;
    {
        // Expression_2_1
        // mul c17.x, c0.x, c1.x
        expr17.x = Phase1.x * Time.x;
    }

    VS_M_Array_Shader_0_Output o;
    float4 temp0, temp1;
    float temp2;
    // def c0, 1, 0, 0.1591549, 0.25
    // def c2, 6.283185, -3.141593, -2.523985E-07, 2.47609E-05
    // def c3, -0.00138884, 0.04166664, -0.5, 0.5
    // def c18, 0, -0.0015, 0, 0
    // dcl_position v0
    // dcl_normal v1
    // dcl_texcoord v2
    // dcl_color v3
    // dp3 r0.x, v1, c124
    temp0.x = dot(i.normal.xyz, (World._m00_m10_m20_m30).xyz);
    // dp3 r0.y, v1, c125
    temp0.y = dot(i.normal.xyz, (World._m01_m11_m21_m31).xyz);
    // dp3 r0.z, v1, c126
    temp0.z = dot(i.normal.xyz, (World._m02_m12_m22_m32).xyz);
    // dp3 r0.w, r0, c6
    temp0.w = dot(temp0.xyz, DirectionalLight[0].Direction.xyz);
    // max r0.w, r0.w, c0.y
    temp0.w = max(temp0.w, float1(0));
    // mul r1.xyz, r0.w, c5
    temp1.xyz = temp0.www * DirectionalLight[0].Color.xyz;
    // mul oT3.xyz, r1, c12
    o.texcoord3 = temp1 * DiffuseColor;
    // dp3 r0.w, r0, c10
    temp0.w = dot(temp0.xyz, DirectionalLight[2].Direction.xyz);
    // dp3 r0.x, r0, c8
    temp0.x = dot(temp0.xyz, DirectionalLight[1].Direction.xyz);
    // max r0.y, r0.w, c0.y
    temp0.y = max(temp0.w, float1(0));
    // mul r0.yzw, r0.y, c9.xxyz
    temp0.yzw = temp0.yyy * DirectionalLight[2].Color.xyz;
    // max r0.x, r0.x, c0.y
    temp0.x = max(temp0.x, float1(0));
    // mad r0.xyz, c7, r0.x, r0.yzww
    temp0.xyz = DirectionalLight[1].Color.xyz * temp0.xxx + temp0.yzw;
    // mul r0.xyz, r0, c12
    temp0.xyz = temp0.xyz * DiffuseColor.xyz;
    // mov r1.xyz, c4
    temp1.xyz = AmbientLightColor.xyz;
    // mad r0.xyz, r1, c11, r0
    temp0.xyz = temp1.xyz * AmbientColor.xyz + temp0.xyz;
    // mov r0.w, c1.x
    temp0.w = OpacityOverride.x;
    // mul oD0, r0, c3.w
    o.color = temp0 * float4(0.5, 0.5, 0.5, 0.5);
    // mad r0, v0.xyzx, c0.xxxy, c0.yyyx
    temp0 = i.position.xyzx * float4(1, 1, 1, 0) + float4(0, 0, 0, 1);
    // dp4 r1.x, r0, c124
    temp1.x = dot(temp0, (World._m00_m10_m20_m30));
    // frc r1.w, r1.x
    temp1.w = frac(temp1.x);
    // mov r2.x, c15.x
    temp2.x = Freq1.x;
    // mad r1.w, r1.w, r2.x, c17.x
    temp1.w = temp1.w * temp2.x + expr17.x;
    // mad r1.w, r1.w, c0.z, c0.w
    temp1.w = temp1.w * float1(0.15915494) + float1(0.25);
    // frc r1.w, r1.w
    temp1.w = frac(temp1.w);
    // mad r1.w, r1.w, c2.x, c2.y
    temp1.w = temp1.w * float1(6.2831855) + float1(-3.1415927);
    // mul r1.w, r1.w, r1.w
    temp1.w = temp1.w * temp1.w;
    // mad r2.x, r1.w, c2.z, c2.w
    temp2.x = temp1.w * float1(-2.523985E-07) + float1(2.47609E-05);
    // mad r2.x, r1.w, r2.x, c3.x
    temp2.x = temp1.w * temp2.x + float1(-0.0013888397);
    // mad r2.x, r1.w, r2.x, c3.y
    temp2.x = temp1.w * temp2.x + float1(0.04166664);
    // mad r2.x, r1.w, r2.x, c3.z
    temp2.x = temp1.w * temp2.x + float1(-0.5);
    // mad r1.w, r1.w, r2.x, c0.x
    temp1.w = temp1.w * temp2.x + float1(1);
    // mul r1.w, r1.w, c14.x
    temp1.w = temp1.w * Amp1.x;
    // mul r1.w, r1.w, v3.w
    temp1.w = temp1.w * i.color.w;
    // dp4 r1.y, r0, c125
    temp1.y = dot(temp0, (World._m01_m11_m21_m31));
    // dp4 r1.z, r0, c126
    temp1.z = dot(temp0, (World._m02_m12_m22_m32));
    // mad r0.xyz, c13.x, r1.w, r1
    temp0.xyz = SwayEnable.xxx * temp1.www + temp1.xyz;
    // mov r0.w, c0.x
    temp0.w = float1(1);
    // dp4 oPos.x, r0, c119
    o.position.x = dot(temp0, (ViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c120
    o.position.y = dot(temp0, (ViewProjection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c121
    o.position.z = dot(temp0, (ViewProjection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c122
    o.position.w = dot(temp0, (ViewProjection._m03_m13_m23_m33));
    // add r1.xy, r0, c16.zwzw
    temp1.xy = temp0.xy + Shroud.ScaleUV_OffsetUV.zw;
    // mul oT1.xy, r1, c16
    o.texcoord1 = temp1 * Shroud.ScaleUV_OffsetUV;
    // mov oT0.xy, v2
    o.texcoord = i.texcoord;
    // dp4 r1.x, r0, c113
    temp1.x = dot(temp0, (ShadowMapWorldToShadow._m00_m10_m20_m30));
    // dp4 r1.y, r0, c114
    temp1.y = dot(temp0, (ShadowMapWorldToShadow._m01_m11_m21_m31));
    // dp4 r1.z, r0, c115
    temp1.z = dot(temp0, (ShadowMapWorldToShadow._m02_m12_m22_m32));
    // dp4 r0.x, r0, c116
    temp0.x = dot(temp0, (ShadowMapWorldToShadow._m03_m13_m23_m33));
    // rcp r0.y, r0.x
    temp0.y = 1.0f / temp0.x;
    // mov oT2.w, r0.x
    o.texcoord2.w = temp0.x;
    // mad oT2.xyz, r1, r0.y, c18.xxyw
    o.texcoord2.xyz = temp1.xyz * temp0.yyy + float3(0, 0, -0.0015);
    // mov oD1.x, c0.x
    o.color1 = float4(1, 1, 1, 1);
    // 

    return o;
}

// VS_M_Array_Shader_1 Vertex_2_0 Has PRES True
struct VS_M_Array_Shader_1_Input
{
    float4 position : POSITION;
    float4 normal : NORMAL;
    float4 blendindices : BLENDINDICES;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct VS_M_Array_Shader_1_Output
{
    float3 texcoord3 : TEXCOORD3;
    float4 color : COLOR;
    float4 position : POSITION;
    float2 texcoord1 : TEXCOORD1;
    float2 texcoord : TEXCOORD;
    float4 texcoord2 : TEXCOORD2;
    float color1 : COLOR1;
};

VS_M_Array_Shader_1_Output VS_M_Array_Shader_1(VS_M_Array_Shader_1_Input i)
{
    /*
    PRSI
      OutputRegisterOffset: 17
      Unknown1: 0
      Unknown2: 0
      OutputRegisterCount: 1
      Unknown3: 0
      Unknown4: 0
      Unknown5: 17
      Unknown6: 1
      Mappings: 1
        0 - ConstOutput: 0 ConstInput 0
    
    */
    float4 expr17;
    {
        // Expression_2_1
        // mul c17.x, c0.x, c1.x
        expr17.x = Phase1.x * Time.x;
    }

    VS_M_Array_Shader_1_Output o;
    float4 temp0, temp1;
    float addr0;
    // def c0, 1, -1, 0.1591549, 0.25
    // def c2, 6.283185, -3.141593, -2.523985E-07, 2.47609E-05
    // def c3, -0.00138884, 0.04166664, -0.5, 0
    // def c18, 0, -0.0015, 0, 0
    // dcl_position v0
    // dcl_normal v1
    // dcl_blendindices v2
    // dcl_texcoord v3
    // dcl_color v4
    // add r0.x, v2.x, v2.x
    temp0.x = i.blendindices.x + i.blendindices.x;
    // frc r0.y, r0.x
    temp0.y = frac(temp0.x);
    // add r0.z, r0.x, -r0.y
    temp0.z = temp0.x + -temp0.y;
    // slt r0.y, -r0.y, r0.y
    temp0.y = (-temp0.y < temp0.y) ? 1 : 0;
    // slt r0.x, r0.x, -r0.x
    temp0.x = (temp0.x < -temp0.x) ? 1 : 0;
    // mad r0.x, r0.x, r0.y, r0.z
    temp0.x = temp0.x * temp0.y + temp0.z;
    // mova a0.x, r0.x
    addr0.x = temp0.x;
    // mul r0, v1.zxyy, c128[a0.x].yzxy
    temp0 = i.normal.zxyy * WorldBones[0 + addr0.x].yzxy;
    // mad r0, c128[a0.x].wwwx, v1.xyzx, r0
    temp0 = WorldBones[0 + addr0.x].wwwx * i.normal.xyzx + temp0;
    // mul r1, v1.yzxz, c128[a0.x].zxyz
    temp1 = i.normal.yzxz * WorldBones[0 + addr0.x].zxyz;
    // mad r0, r0, c0.xxxy, -r1
    temp0 = temp0 * float4(1, 1, 1, -1) + -temp1;
    // mul r1.xyz, r0.w, c128[a0.x]
    temp1.xyz = temp0.www * WorldBones[0 + addr0.x].xyz;
    // mad r1.xyz, c128[a0.x].w, r0, -r1
    temp1.xyz = WorldBones[0 + addr0.x].www * temp0.xyz + -temp1.xyz;
    // mad r1.xyz, c128[a0.x].yzxw, r0.zxyw, r1
    temp1.xyz = WorldBones[0 + addr0.x].yzx * temp0.zxy + temp1.xyz;
    // mad r0.xyz, c128[a0.x].zxyw, -r0.yzxw, r1
    temp0.xyz = WorldBones[0 + addr0.x].zxy * -temp0.yzx + temp1.xyz;
    // dp3 r0.w, r0, c6
    temp0.w = dot(temp0.xyz, DirectionalLight[0].Direction.xyz);
    // max r0.w, r0.w, c3.w
    temp0.w = max(temp0.w, float1(0));
    // mul r1.xyz, r0.w, c5
    temp1.xyz = temp0.www * DirectionalLight[0].Color.xyz;
    // mul oT3.xyz, r1, c12
    o.texcoord3 = temp1 * DiffuseColor;
    // dp3 r0.w, r0, c10
    temp0.w = dot(temp0.xyz, DirectionalLight[2].Direction.xyz);
    // dp3 r0.x, r0, c8
    temp0.x = dot(temp0.xyz, DirectionalLight[1].Direction.xyz);
    // max r0.y, r0.w, c3.w
    temp0.y = max(temp0.w, float1(0));
    // mul r0.yzw, r0.y, c9.xxyz
    temp0.yzw = temp0.yyy * DirectionalLight[2].Color.xyz;
    // max r0.x, r0.x, c3.w
    temp0.x = max(temp0.x, float1(0));
    // mad r0.xyz, c7, r0.x, r0.yzww
    temp0.xyz = DirectionalLight[1].Color.xyz * temp0.xxx + temp0.yzw;
    // mul r0.xyz, r0, c12
    temp0.xyz = temp0.xyz * DiffuseColor.xyz;
    // mov r1.xyz, c4
    temp1.xyz = AmbientLightColor.xyz;
    // mad r0.xyz, r1, c11, r0
    temp0.xyz = temp1.xyz * AmbientColor.xyz + temp0.xyz;
    // mov r0.w, c1.x
    temp0.w = OpacityOverride.x;
    // mul oD0, r0, -c3.z
    o.color = temp0 * float4(0.5, 0.5, 0.5, 0.5);
    // mul r0, v0.zxyy, c128[a0.x].yzxy
    temp0 = i.position.zxyy * WorldBones[0 + addr0.x].yzxy;
    // mad r0, c128[a0.x].wwwx, v0.xyzx, r0
    temp0 = WorldBones[0 + addr0.x].wwwx * i.position.xyzx + temp0;
    // mul r1, v0.yzxz, c128[a0.x].zxyz
    temp1 = i.position.yzxz * WorldBones[0 + addr0.x].zxyz;
    // mad r0, r0, c0.xxxy, -r1
    temp0 = temp0 * float4(1, 1, 1, -1) + -temp1;
    // mul r1.xyz, r0.w, c128[a0.x]
    temp1.xyz = temp0.www * WorldBones[0 + addr0.x].xyz;
    // mad r1.xyz, c128[a0.x].w, r0, -r1
    temp1.xyz = WorldBones[0 + addr0.x].www * temp0.xyz + -temp1.xyz;
    // mad r1.xyz, c128[a0.x].yzxw, r0.zxyw, r1
    temp1.xyz = WorldBones[0 + addr0.x].yzx * temp0.zxy + temp1.xyz;
    // mad r0.xyz, c128[a0.x].zxyw, -r0.yzxw, r1
    temp0.xyz = WorldBones[0 + addr0.x].zxy * -temp0.yzx + temp1.xyz;
    // add r0.xyz, r0, c129[a0.x]
    temp0.xyz = temp0.xyz + WorldBones[1 + addr0.x].xyz;
    // frc r0.w, r0.x
    temp0.w = frac(temp0.x);
    // mov r1.x, c15.x
    temp1.x = Freq1.x;
    // mad r0.w, r0.w, r1.x, c17.x
    temp0.w = temp0.w * temp1.x + expr17.x;
    // mad r0.w, r0.w, c0.z, c0.w
    temp0.w = temp0.w * float1(0.15915494) + float1(0.25);
    // frc r0.w, r0.w
    temp0.w = frac(temp0.w);
    // mad r0.w, r0.w, c2.x, c2.y
    temp0.w = temp0.w * float1(6.2831855) + float1(-3.1415927);
    // mul r0.w, r0.w, r0.w
    temp0.w = temp0.w * temp0.w;
    // mad r1.x, r0.w, c2.z, c2.w
    temp1.x = temp0.w * float1(-2.523985E-07) + float1(2.47609E-05);
    // mad r1.x, r0.w, r1.x, c3.x
    temp1.x = temp0.w * temp1.x + float1(-0.0013888397);
    // mad r1.x, r0.w, r1.x, c3.y
    temp1.x = temp0.w * temp1.x + float1(0.04166664);
    // mad r1.x, r0.w, r1.x, c3.z
    temp1.x = temp0.w * temp1.x + float1(-0.5);
    // mad r0.w, r0.w, r1.x, c0.x
    temp0.w = temp0.w * temp1.x + float1(1);
    // mul r0.w, r0.w, c14.x
    temp0.w = temp0.w * Amp1.x;
    // mul r0.w, r0.w, v4.w
    temp0.w = temp0.w * i.color.w;
    // mad r0.xyz, c13.x, r0.w, r0
    temp0.xyz = SwayEnable.xxx * temp0.www + temp0.xyz;
    // mov r0.w, c0.x
    temp0.w = float1(1);
    // dp4 oPos.x, r0, c119
    o.position.x = dot(temp0, (ViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c120
    o.position.y = dot(temp0, (ViewProjection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c121
    o.position.z = dot(temp0, (ViewProjection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c122
    o.position.w = dot(temp0, (ViewProjection._m03_m13_m23_m33));
    // add r1.xy, r0, c16.zwzw
    temp1.xy = temp0.xy + Shroud.ScaleUV_OffsetUV.zw;
    // mul oT1.xy, r1, c16
    o.texcoord1 = temp1 * Shroud.ScaleUV_OffsetUV;
    // mov oT0.xy, v3
    o.texcoord = i.texcoord;
    // dp4 r1.x, r0, c113
    temp1.x = dot(temp0, (ShadowMapWorldToShadow._m00_m10_m20_m30));
    // dp4 r1.y, r0, c114
    temp1.y = dot(temp0, (ShadowMapWorldToShadow._m01_m11_m21_m31));
    // dp4 r1.z, r0, c115
    temp1.z = dot(temp0, (ShadowMapWorldToShadow._m02_m12_m22_m32));
    // dp4 r0.x, r0, c116
    temp0.x = dot(temp0, (ShadowMapWorldToShadow._m03_m13_m23_m33));
    // rcp r0.y, r0.x
    temp0.y = 1.0f / temp0.x;
    // mov oT2.w, r0.x
    o.texcoord2.w = temp0.x;
    // mad oT2.xyz, r1, r0.y, c18.xxyw
    o.texcoord2.xyz = temp1.xyz * temp0.yyy + float3(0, 0, -0.0015);
    // mov oD1.x, c0.x
    o.color1 = float4(1, 1, 1, 1);
    // 

    return o;
}

VertexShader VS_M_Array[2] = {
    compile vs_2_0 VS_M_Array_Shader_0(), // 49
    compile vs_2_0 VS_M_Array_Shader_1(), // 50
};
// PS_M_Array_Shader_0 Pixel_2_0 Has PRES False
struct PS_M_Array_Shader_0_Input
{
    float2 texcoord : TEXCOORD;
    float2 texcoord1 : TEXCOORD1;
    float3 texcoord3 : TEXCOORD3;
    float4 color : COLOR;
};

float4 PS_M_Array_Shader_0(PS_M_Array_Shader_0_Input i) : COLOR
{
    float4 out_color;
    float4 temp0, temp1, temp2;
    float3 temp3;
    // def c0, 2, 0, 0, 0
    // dcl t0.xy
    // dcl t1.xy
    // dcl t3.xyz
    // dcl v0
    // dcl_2d s0
    // dcl_2d s1
    // texld r0, t0, s0
    temp0 = tex2D(DiffuseTextureSampler, i.texcoord.xy);
    // texld r1, t1, s1
    temp1 = tex2D(ShroudTextureSampler, i.texcoord1.xy);
    // mov r2.xyz, c0.x
    temp2.xyz = float3(2, 2, 2);
    // mov r3.xyz, v0
    temp3.xyz = i.color.xyz;
    // mad r2.xyz, r3, r2, t3
    temp2.xyz = temp3.xyz * temp2.xyz + i.texcoord3.xyz;
    // mul r2.w, r0.w, v0.w
    temp2.w = temp0.w * i.color.w;
    // mov r0.w, c0.x
    temp0.w = float1(2);
    // mul r0, r2, r0
    temp0 = temp2 * temp0;
    // mul r0.xyz, r1, r0
    temp0.xyz = temp1.xyz * temp0.xyz;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// PS_M_Array_Shader_1 Pixel_2_0 Has PRES False
struct PS_M_Array_Shader_1_Input
{
    float2 texcoord : TEXCOORD;
    float2 texcoord1 : TEXCOORD1;
    float3 texcoord2 : TEXCOORD2;
    float3 texcoord3 : TEXCOORD3;
    float4 color : COLOR;
};

float4 PS_M_Array_Shader_1(PS_M_Array_Shader_1_Input i) : COLOR
{
    float4 out_color;
    float4 temp0, temp1, temp2, temp3, temp4, temp5;
    // def c0, 2, 1, 0, 0.25
    // dcl t0.xy
    // dcl t1.xy
    // dcl t2.xyz
    // dcl t3.xyz
    // dcl v0
    // dcl_2d s0
    // dcl_2d s1
    // dcl_2d s2
    // add r0.xy, t2, c11.zxyw
    temp0.xy = i.texcoord2.xy + Shadowmap_Zero_Zero_OneOverMapSize_OneOverMapSize.zx;
    // add r1.xy, t2, c11.yzxw
    temp1.xy = i.texcoord2.xy + Shadowmap_Zero_Zero_OneOverMapSize_OneOverMapSize.yz;
    // add r2.xy, t2, c11.wzyx
    temp2.xy = i.texcoord2.xy + Shadowmap_Zero_Zero_OneOverMapSize_OneOverMapSize.wz;
    // texld r0, r0, s0
    temp0 = tex2D(ShadowMapSampler, temp0.xy);
    // texld r1, r1, s0
    temp1 = tex2D(ShadowMapSampler, temp1.xy);
    // texld r2, r2, s0
    temp2 = tex2D(ShadowMapSampler, temp2.xy);
    // texld r3, t2, s0
    temp3 = tex2D(ShadowMapSampler, i.texcoord2.xy);
    // texld r4, t0, s1
    temp4 = tex2D(DiffuseTextureSampler, i.texcoord.xy);
    // texld r5, t1, s2
    temp5 = tex2D(ShroudTextureSampler, i.texcoord1.xy);
    // mov r3.y, r0.x
    temp3.y = temp0.x;
    // mov r3.z, r1.x
    temp3.z = temp1.x;
    // mov r3.w, r2.x
    temp3.w = temp2.x;
    // add r0, r3, -t2.z
    temp0 = temp3 + -i.texcoord2.z;
    // cmp r0, r0, c0.y, c0.z
    temp0 = (temp0 >= 0) ? float4(1, 1, 1, 1) : float4(0, 0, 0, 0);
    // dp4 r5.w, c0.y, r0
    temp5.w = dot(float4(1, 1, 1, 1), temp0);
    // mul r5.w, r5.w, c0.w
    temp5.w = temp5.w * float1(0.25);
    // mov r0.xyz, c0.x
    temp0.xyz = float3(2, 2, 2);
    // mov r0.w, r4.w
    temp0.w = temp4.w;
    // mul r0, r0, v0
    temp0 = temp0 * i.color;
    // mad r0.xyz, t3, r5.w, r0
    temp0.xyz = i.texcoord3.xyz * temp5.www + temp0.xyz;
    // mov r4.w, c0.x
    temp4.w = float1(2);
    // mul r0, r4, r0
    temp0 = temp4 * temp0;
    // mul r0.xyz, r5, r0
    temp0.xyz = temp5.xyz * temp0.xyz;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

PixelShader PS_M_Array[2] = {
    compile ps_2_0 PS_M_Array_Shader_0(), // 51
    compile ps_2_0 PS_M_Array_Shader_1(), // 52
};
// VSCreateShadowMap_Array_Shader_0 Vertex_2_0 Has PRES True
struct VSCreateShadowMap_Array_Shader_0_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct VSCreateShadowMap_Array_Shader_0_Output
{
    float4 position : POSITION;
    float texcoord1 : TEXCOORD1;
    float2 texcoord : TEXCOORD;
};

VSCreateShadowMap_Array_Shader_0_Output VSCreateShadowMap_Array_Shader_0(VSCreateShadowMap_Array_Shader_0_Input i)
{
    /*
    PRSI
      OutputRegisterOffset: 14
      Unknown1: 0
      Unknown2: 0
      OutputRegisterCount: 1
      Unknown3: 0
      Unknown4: 0
      Unknown5: 14
      Unknown6: 1
      Mappings: 1
        0 - ConstOutput: 0 ConstInput 0
    
    */
    float4 expr14;
    {
        // Expression_2_1
        // mul c14.x, c0.x, c1.x
        expr14.x = Phase1.x * Time.x;
    }

    VSCreateShadowMap_Array_Shader_0_Output o;
    float4 temp0, temp1;
    float temp2;
    // def c0, 1, 0, 0.1591549, 0.25
    // def c1, 6.283185, -3.141593, -2.523985E-07, 2.47609E-05
    // def c2, -0.00138884, 0.04166664, -0.5, 0
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_color v2
    // mad r0, v0.xyzx, c0.xxxy, c0.yyyx
    temp0 = i.position.xyzx * float4(1, 1, 1, 0) + float4(0, 0, 0, 1);
    // dp4 r1.x, r0, c124
    temp1.x = dot(temp0, (World._m00_m10_m20_m30));
    // frc r1.w, r1.x
    temp1.w = frac(temp1.x);
    // mov r2.x, c13.x
    temp2.x = Freq1.x;
    // mad r1.w, r1.w, r2.x, c14.x
    temp1.w = temp1.w * temp2.x + expr14.x;
    // mad r1.w, r1.w, c0.z, c0.w
    temp1.w = temp1.w * float1(0.15915494) + float1(0.25);
    // frc r1.w, r1.w
    temp1.w = frac(temp1.w);
    // mad r1.w, r1.w, c1.x, c1.y
    temp1.w = temp1.w * float1(6.2831855) + float1(-3.1415927);
    // mul r1.w, r1.w, r1.w
    temp1.w = temp1.w * temp1.w;
    // mad r2.x, r1.w, c1.z, c1.w
    temp2.x = temp1.w * float1(-2.523985E-07) + float1(2.47609E-05);
    // mad r2.x, r1.w, r2.x, c2.x
    temp2.x = temp1.w * temp2.x + float1(-0.0013888397);
    // mad r2.x, r1.w, r2.x, c2.y
    temp2.x = temp1.w * temp2.x + float1(0.04166664);
    // mad r2.x, r1.w, r2.x, c2.z
    temp2.x = temp1.w * temp2.x + float1(-0.5);
    // mad r1.w, r1.w, r2.x, c0.x
    temp1.w = temp1.w * temp2.x + float1(1);
    // mul r1.w, r1.w, c12.x
    temp1.w = temp1.w * Amp1.x;
    // mul r1.w, r1.w, v2.w
    temp1.w = temp1.w * i.color.w;
    // dp4 r1.y, r0, c125
    temp1.y = dot(temp0, (World._m01_m11_m21_m31));
    // dp4 r1.z, r0, c126
    temp1.z = dot(temp0, (World._m02_m12_m22_m32));
    // mad r0.xyz, c11.x, r1.w, r1
    temp0.xyz = SwayEnable.xxx * temp1.www + temp1.xyz;
    // mov r0.w, c0.x
    temp0.w = float1(1);
    // dp4 oPos.x, r0, c119
    o.position.x = dot(temp0, (ViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c120
    o.position.y = dot(temp0, (ViewProjection._m01_m11_m21_m31));
    // dp4 r1.y, r0, c122
    temp1.y = dot(temp0, (ViewProjection._m03_m13_m23_m33));
    // dp4 r1.x, r0, c121
    temp1.x = dot(temp0, (ViewProjection._m02_m12_m22_m32));
    // rcp r0.x, r1.y
    temp0.x = 1.0f / temp1.y;
    // mov oPos.zw, r1.xyxy
    o.position.zw = temp1.xy;
    // mul oT1.x, r1.x, r0.x
    o.texcoord1 = temp1.x * temp0.x;
    // mov oT0.xy, v1
    o.texcoord = i.texcoord;
    // 

    return o;
}

// VSCreateShadowMap_Array_Shader_1 Vertex_2_0 Has PRES True
struct VSCreateShadowMap_Array_Shader_1_Input
{
    float4 position : POSITION;
    float4 blendindices : BLENDINDICES;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct VSCreateShadowMap_Array_Shader_1_Output
{
    float4 position : POSITION;
    float texcoord1 : TEXCOORD1;
    float2 texcoord : TEXCOORD;
};

VSCreateShadowMap_Array_Shader_1_Output VSCreateShadowMap_Array_Shader_1(VSCreateShadowMap_Array_Shader_1_Input i)
{
    /*
    PRSI
      OutputRegisterOffset: 14
      Unknown1: 0
      Unknown2: 0
      OutputRegisterCount: 1
      Unknown3: 0
      Unknown4: 0
      Unknown5: 14
      Unknown6: 1
      Mappings: 1
        0 - ConstOutput: 0 ConstInput 0
    
    */
    float4 expr14;
    {
        // Expression_2_1
        // mul c14.x, c0.x, c1.x
        expr14.x = Phase1.x * Time.x;
    }

    VSCreateShadowMap_Array_Shader_1_Output o;
    float4 temp0, temp1;
    float addr0;
    // def c0, 1, -1, 0.1591549, 0.25
    // def c1, 6.283185, -3.141593, -2.523985E-07, 2.47609E-05
    // def c2, -0.00138884, 0.04166664, -0.5, 0
    // dcl_position v0
    // dcl_blendindices v1
    // dcl_texcoord v2
    // dcl_color v3
    // add r0.x, v1.x, v1.x
    temp0.x = i.blendindices.x + i.blendindices.x;
    // frc r0.y, r0.x
    temp0.y = frac(temp0.x);
    // add r0.z, r0.x, -r0.y
    temp0.z = temp0.x + -temp0.y;
    // slt r0.y, -r0.y, r0.y
    temp0.y = (-temp0.y < temp0.y) ? 1 : 0;
    // slt r0.x, r0.x, -r0.x
    temp0.x = (temp0.x < -temp0.x) ? 1 : 0;
    // mad r0.x, r0.x, r0.y, r0.z
    temp0.x = temp0.x * temp0.y + temp0.z;
    // mova a0.x, r0.x
    addr0.x = temp0.x;
    // mul r0, v0.zxyy, c128[a0.x].yzxy
    temp0 = i.position.zxyy * WorldBones[0 + addr0.x].yzxy;
    // mad r0, c128[a0.x].wwwx, v0.xyzx, r0
    temp0 = WorldBones[0 + addr0.x].wwwx * i.position.xyzx + temp0;
    // mul r1, v0.yzxz, c128[a0.x].zxyz
    temp1 = i.position.yzxz * WorldBones[0 + addr0.x].zxyz;
    // mad r0, r0, c0.xxxy, -r1
    temp0 = temp0 * float4(1, 1, 1, -1) + -temp1;
    // mul r1.xyz, r0.w, c128[a0.x]
    temp1.xyz = temp0.www * WorldBones[0 + addr0.x].xyz;
    // mad r1.xyz, c128[a0.x].w, r0, -r1
    temp1.xyz = WorldBones[0 + addr0.x].www * temp0.xyz + -temp1.xyz;
    // mad r1.xyz, c128[a0.x].yzxw, r0.zxyw, r1
    temp1.xyz = WorldBones[0 + addr0.x].yzx * temp0.zxy + temp1.xyz;
    // mad r0.xyz, c128[a0.x].zxyw, -r0.yzxw, r1
    temp0.xyz = WorldBones[0 + addr0.x].zxy * -temp0.yzx + temp1.xyz;
    // add r0.xyz, r0, c129[a0.x]
    temp0.xyz = temp0.xyz + WorldBones[1 + addr0.x].xyz;
    // frc r0.w, r0.x
    temp0.w = frac(temp0.x);
    // mov r1.x, c13.x
    temp1.x = Freq1.x;
    // mad r0.w, r0.w, r1.x, c14.x
    temp0.w = temp0.w * temp1.x + expr14.x;
    // mad r0.w, r0.w, c0.z, c0.w
    temp0.w = temp0.w * float1(0.15915494) + float1(0.25);
    // frc r0.w, r0.w
    temp0.w = frac(temp0.w);
    // mad r0.w, r0.w, c1.x, c1.y
    temp0.w = temp0.w * float1(6.2831855) + float1(-3.1415927);
    // mul r0.w, r0.w, r0.w
    temp0.w = temp0.w * temp0.w;
    // mad r1.x, r0.w, c1.z, c1.w
    temp1.x = temp0.w * float1(-2.523985E-07) + float1(2.47609E-05);
    // mad r1.x, r0.w, r1.x, c2.x
    temp1.x = temp0.w * temp1.x + float1(-0.0013888397);
    // mad r1.x, r0.w, r1.x, c2.y
    temp1.x = temp0.w * temp1.x + float1(0.04166664);
    // mad r1.x, r0.w, r1.x, c2.z
    temp1.x = temp0.w * temp1.x + float1(-0.5);
    // mad r0.w, r0.w, r1.x, c0.x
    temp0.w = temp0.w * temp1.x + float1(1);
    // mul r0.w, r0.w, c12.x
    temp0.w = temp0.w * Amp1.x;
    // mul r0.w, r0.w, v3.w
    temp0.w = temp0.w * i.color.w;
    // mad r0.xyz, c11.x, r0.w, r0
    temp0.xyz = SwayEnable.xxx * temp0.www + temp0.xyz;
    // mov r0.w, c0.x
    temp0.w = float1(1);
    // dp4 oPos.x, r0, c119
    o.position.x = dot(temp0, (ViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c120
    o.position.y = dot(temp0, (ViewProjection._m01_m11_m21_m31));
    // dp4 r1.y, r0, c122
    temp1.y = dot(temp0, (ViewProjection._m03_m13_m23_m33));
    // dp4 r1.x, r0, c121
    temp1.x = dot(temp0, (ViewProjection._m02_m12_m22_m32));
    // rcp r0.x, r1.y
    temp0.x = 1.0f / temp1.y;
    // mov oPos.zw, r1.xyxy
    o.position.zw = temp1.xy;
    // mul oT1.x, r1.x, r0.x
    o.texcoord1 = temp1.x * temp0.x;
    // mov oT0.xy, v2
    o.texcoord = i.texcoord;
    // 

    return o;
}

VertexShader VSCreateShadowMap_Array[2] = {
    compile vs_2_0 VSCreateShadowMap_Array_Shader_0(), // 55
    compile vs_2_0 VSCreateShadowMap_Array_Shader_1(), // 56
};
// _CreateShadowMap_PixelShader11 Pixel_2_0 Has PRES False
struct _CreateShadowMap_PixelShader11_Input
{
    float2 texcoord : TEXCOORD;
    float texcoord1 : TEXCOORD1;
};

float4 _CreateShadowMap_PixelShader11(_CreateShadowMap_PixelShader11_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    // def c0, -0.3764706, 0, 0, 0
    // dcl t0.xy
    // dcl t1.x
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(DiffuseTextureSampler, i.texcoord.xy);
    // mov r0.x, c1.x
    temp0.x = OpacityOverride.x;
    // mad r0, r0.x, r0.w, c0.x
    temp0 = temp0.x * temp0.w + float4(-0.3764706, -0.3764706, -0.3764706, -0.3764706);
    // texkill r0
    clip(temp0);
    // mov r0, t1.x
    temp0 = i.texcoord1.x;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// _CreateShadowMap_Expression12 Expression_2_0 Has PRES False
float _CreateShadowMap_Expression12()
{
    float1 expr0;
    // min c0.x, c0.x, (1)
    expr0.x = min(NumJointsPerVertex.x, (1));
    return expr0;
}

// Default_M_Expression13 Expression_2_0 Has PRES False
float Default_M_Expression13()
{
    float1 expr0;
    // mov c0.x, c0.x
    expr0.x = HasShadow.x;
    return expr0;
}

// Default_M_Expression14 Expression_2_0 Has PRES False
float Default_M_Expression14()
{
    float1 expr0;
    // min c0.x, c0.x, (1)
    expr0.x = min(NumJointsPerVertex.x, (1));
    return expr0;
}

// Default_Expression15 Expression_2_0 Has PRES False
float Default_Expression15()
{
    float1 expr0;
    // mov c0.x, c0.x
    expr0.x = HasShadow.x;
    return expr0;
}

// Default_Expression16 Expression_2_0 Has PRES False
float Default_Expression16()
{
    float1 expr0;
    // min c0.x, c0.x, (1)
    expr0.x = min(NumJointsPerVertex.x, (1));
    return expr0;
}

technique Default
{
    pass p0
    {
        VertexShader = VS_Array[Default_Expression16()]; // 47
        PixelShader = PS_Array[Default_Expression15()]; // 48
        ZEnable = 1;
        ZFunc = 4;
        ZWriteEnable = 1;
        CullMode = 1;
        AlphaBlendEnable = 0;
        AlphaTestEnable = 1;
        AlphaFunc = 7;
        AlphaRef = 96;
    }
}

technique Default_M
{
    pass p0
    {
        VertexShader = VS_M_Array[Default_M_Expression14()]; // 53
        PixelShader = PS_M_Array[Default_M_Expression13()]; // 54
        ZEnable = 1;
        ZFunc = 4;
        ZWriteEnable = 1;
        CullMode = 1;
        AlphaBlendEnable = 0;
        AlphaTestEnable = 1;
        AlphaFunc = 7;
        AlphaRef = 96;
    }
}

technique _CreateShadowMap
{
    pass p0
    {
        VertexShader = VSCreateShadowMap_Array[_CreateShadowMap_Expression12()]; // 57
        PixelShader = compile ps_2_0 _CreateShadowMap_PixelShader11(); // 58
        ZEnable = 1;
        ZFunc = 4;
        ZWriteEnable = 1;
        CullMode = 1;
        AlphaBlendEnable = 0;
        AlphaTestEnable = 0;
    }
}

