string DefaultParameterScopeBlock = "material"; // 1
float3 AmbientLightColor <bool unmanaged = 1;> = { 0.3, 0.3, 0.3 };
struct {
    float3 Color;
    float3 Direction;
} DirectionalLight[3] <bool unmanaged = 1;> = { 1.625198, 1.512711, 1.097048, 0.62914, -0.34874, 0.69465, 0.5232916, 0.6654605, 0.7815244, -0.32877, 0.90329, 0.27563, 0.4420466, 0.4102767, 0.4420466, -0.80704, -0.58635, 0.06975 };
struct {
    float3 Color;
    float3 Position;
    float2 Range_Inner_Outer;
} PointLight[8] <bool unmanaged = 1;>;
struct {
    float4 WorldPositionMultiplier_XYZZ;
    float2 CurrentOffsetUV;
} Cloud <bool unmanaged = 1;>;
float3 NoCloudMultiplier <bool unmanaged = 1;> = { 1, 1, 1 };
float3 RecolorColorDummy <bool unmanaged = 1;>;
row_major float4x4 ShadowMapWorldToShadow <bool unmanaged = 1;>;
float OpacityOverride <bool unmanaged = 1;> = { 1 };
float3 TintColor <bool unmanaged = 1;> = { 1, 1, 1 };
float3 EyePosition <bool unmanaged = 1;>;
row_major float4x4 ViewProjection <bool unmanaged = 1;>;
float4 WorldBones[128] <bool unmanaged = 1;>;
texture ShadowMap <string SasBindAddress = "Sas.Shadow[0].ShadowMap";>; // 2
sampler2D ShadowMapSampler : register(ps_2_0, s0) <string Texture = "ShadowMap"; string SasBindAddress = "Sas.Shadow[0].ShadowMap";> =
sampler_state
{
    Texture = <ShadowMap>; // 4
    MinFilter = 1;
    MagFilter = 1;
    MipFilter = 1;
    AddressU = 3;
    AddressV = 3;
};
float4 FlatColorOverride <string UIWidget = "None"; string SasBindAddress = "WW3D.FlatColor"; int WW3DDynamicSet = 2;>;
column_major float4x4 WorldViewProjection : WorldViewProjection : register(vs_2_0, c11);
// CollisionBox_PixelShader1 Pixel_2_0 Has PRES False
float4 CollisionBox_PixelShader1(float4 color : COLOR) : COLOR
{
    float4 out_color;
    // dcl v0
    // mov oC0, v0
    out_color = color;
    // 

    return out_color;
}

// CollisionBox_VertexShader2 Vertex_2_0 Has PRES False
struct CollisionBox_VertexShader2_Input
{
    float4 position : POSITION;
    float4 normal : NORMAL;
    float4 color : COLOR;
};

struct CollisionBox_VertexShader2_Output
{
    float4 position : POSITION;
    float4 color : COLOR;
};

CollisionBox_VertexShader2_Output CollisionBox_VertexShader2(CollisionBox_VertexShader2_Input i)
{
    CollisionBox_VertexShader2_Output o;
    float4 temp0;
    // def c0, 1, 0, 0.5, 0.25
    // def c1, 0.8, 0.7, 0.2, 0
    // def c2, 0, 0.3, 0.9, 0
    // dcl_position v0
    // dcl_normal v1
    // dcl_color v2
    // mad r0, v0.xyzx, c0.xxxy, c0.yyyx
    temp0 = i.position.xyzx * float4(1, 1, 1, 0) + float4(0, 0, 0, 1);
    // dp4 oPos.x, r0, c11
    o.position.x = dot(temp0, (WorldViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c12
    o.position.y = dot(temp0, (WorldViewProjection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c13
    o.position.z = dot(temp0, (WorldViewProjection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c14
    o.position.w = dot(temp0, (WorldViewProjection._m03_m13_m23_m33));
    // dp3 r0.x, v1.xzyw, -c0.zzww
    temp0.x = dot(i.normal.xzy, float3(-0.5, -0.5, -0.25));
    // max r0.x, r0.x, c0.y
    temp0.x = max(temp0.x, float1(0));
    // min r0.x, r0.x, c0.x
    temp0.x = min(temp0.x, float1(1));
    // mul r0.xyz, r0.x, c2
    temp0.xyz = temp0.xxx * float3(0, 0.3, 0.9);
    // dp3 r0.w, v1.xzyw, c0.zzww
    temp0.w = dot(i.normal.xzy, float3(0.5, 0.5, 0.25));
    // max r0.w, r0.w, c0.y
    temp0.w = max(temp0.w, float1(0));
    // min r0.w, r0.w, c0.x
    temp0.w = min(temp0.w, float1(1));
    // mad oD0.xyz, r0.w, c1, r0
    o.color.xyz = temp0.www * float3(0.8, 0.7, 0.2) + temp0.xyz;
    // mov oD0.w, v2.w
    o.color.w = i.color.w;
    // 

    return o;
}

// DrawObject_Alpha_PixelShader3 Pixel_2_0 Has PRES False
float4 DrawObject_Alpha_PixelShader3(float4 color : COLOR) : COLOR
{
    float4 out_color;
    // dcl v0
    // mov oC0, v0
    out_color = color;
    // 

    return out_color;
}

// DrawObject_Alpha_VertexShader4 Vertex_2_0 Has PRES False
struct DrawObject_Alpha_VertexShader4_Input
{
    float4 position : POSITION;
    float4 color : COLOR;
};

struct DrawObject_Alpha_VertexShader4_Output
{
    float4 position : POSITION;
    float4 color : COLOR;
};

DrawObject_Alpha_VertexShader4_Output DrawObject_Alpha_VertexShader4(DrawObject_Alpha_VertexShader4_Input i)
{
    DrawObject_Alpha_VertexShader4_Output o;
    float4 temp0;
    // def c0, 1, 0, 0, 0
    // dcl_position v0
    // dcl_color v1
    // mad r0, v0.xyzx, c0.xxxy, c0.yyyx
    temp0 = i.position.xyzx * float4(1, 1, 1, 0) + float4(0, 0, 0, 1);
    // dp4 oPos.x, r0, c11
    o.position.x = dot(temp0, (WorldViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c12
    o.position.y = dot(temp0, (WorldViewProjection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c13
    o.position.z = dot(temp0, (WorldViewProjection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c14
    o.position.w = dot(temp0, (WorldViewProjection._m03_m13_m23_m33));
    // mov oD0, v1
    o.color = i.color;
    // 

    return o;
}

// DrawObject_Opaque_ZTest_PixelShader5 Pixel_2_0 Has PRES False
float4 DrawObject_Opaque_ZTest_PixelShader5(float4 color : COLOR) : COLOR
{
    float4 out_color;
    // dcl v0
    // mov oC0, v0
    out_color = color;
    // 

    return out_color;
}

// DrawObject_Opaque_ZTest_VertexShader6 Vertex_2_0 Has PRES False
struct DrawObject_Opaque_ZTest_VertexShader6_Input
{
    float4 position : POSITION;
    float4 color : COLOR;
};

struct DrawObject_Opaque_ZTest_VertexShader6_Output
{
    float4 position : POSITION;
    float4 color : COLOR;
};

DrawObject_Opaque_ZTest_VertexShader6_Output DrawObject_Opaque_ZTest_VertexShader6(DrawObject_Opaque_ZTest_VertexShader6_Input i)
{
    DrawObject_Opaque_ZTest_VertexShader6_Output o;
    float4 temp0;
    // def c0, 1, 0, 0, 0
    // dcl_position v0
    // dcl_color v1
    // mad r0, v0.xyzx, c0.xxxy, c0.yyyx
    temp0 = i.position.xyzx * float4(1, 1, 1, 0) + float4(0, 0, 0, 1);
    // dp4 oPos.x, r0, c11
    o.position.x = dot(temp0, (WorldViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c12
    o.position.y = dot(temp0, (WorldViewProjection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c13
    o.position.z = dot(temp0, (WorldViewProjection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c14
    o.position.w = dot(temp0, (WorldViewProjection._m03_m13_m23_m33));
    // mov oD0, v1
    o.color = i.color;
    // 

    return o;
}

// DrawObject_Opaque_PixelShader7 Pixel_2_0 Has PRES False
float4 DrawObject_Opaque_PixelShader7(float4 color : COLOR) : COLOR
{
    float4 out_color;
    // dcl v0
    // mov oC0, v0
    out_color = color;
    // 

    return out_color;
}

// DrawObject_Opaque_VertexShader8 Vertex_2_0 Has PRES False
struct DrawObject_Opaque_VertexShader8_Input
{
    float4 position : POSITION;
    float4 color : COLOR;
};

struct DrawObject_Opaque_VertexShader8_Output
{
    float4 position : POSITION;
    float4 color : COLOR;
};

DrawObject_Opaque_VertexShader8_Output DrawObject_Opaque_VertexShader8(DrawObject_Opaque_VertexShader8_Input i)
{
    DrawObject_Opaque_VertexShader8_Output o;
    float4 temp0;
    // def c0, 1, 0, 0, 0
    // dcl_position v0
    // dcl_color v1
    // mad r0, v0.xyzx, c0.xxxy, c0.yyyx
    temp0 = i.position.xyzx * float4(1, 1, 1, 0) + float4(0, 0, 0, 1);
    // dp4 oPos.x, r0, c11
    o.position.x = dot(temp0, (WorldViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c12
    o.position.y = dot(temp0, (WorldViewProjection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c13
    o.position.z = dot(temp0, (WorldViewProjection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c14
    o.position.w = dot(temp0, (WorldViewProjection._m03_m13_m23_m33));
    // mov oD0, v1
    o.color = i.color;
    // 

    return o;
}

// DebugDisplay_PixelShader9 Pixel_2_0 Has PRES False
float4 DebugDisplay_PixelShader9(float4 color : COLOR) : COLOR
{
    float4 out_color;
    // dcl v0
    // mov oC0, v0
    out_color = color;
    // 

    return out_color;
}

// DebugDisplay_VertexShader10 Vertex_2_0 Has PRES True
struct DebugDisplay_VertexShader10_Output
{
    float4 position : POSITION;
    float4 color : COLOR;
};

DebugDisplay_VertexShader10_Output DebugDisplay_VertexShader10(float4 position : POSITION)
{
    /*
    PRSI
      OutputRegisterOffset: 15
      Unknown1: 0
      Unknown2: 0
      OutputRegisterCount: 1
      Unknown3: 0
      Unknown4: 0
      Unknown5: 15
      Unknown6: 1
      Mappings: 1
        0 - ConstOutput: 0 ConstInput 0
    
    */
    float4 expr15;
    {
        // Expression_2_1
        // mov c15, c0
        expr15 = FlatColorOverride;
    }

    DebugDisplay_VertexShader10_Output o;
    float4 temp0;
    // def c0, 1, 0, 0, 0
    // dcl_position v0
    // mad r0, v0.xyzx, c0.xxxy, c0.yyyx
    temp0 = position.xyzx * float4(1, 1, 1, 0) + float4(0, 0, 0, 1);
    // dp4 oPos.x, r0, c11
    o.position.x = dot(temp0, (WorldViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c12
    o.position.y = dot(temp0, (WorldViewProjection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c13
    o.position.z = dot(temp0, (WorldViewProjection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c14
    o.position.w = dot(temp0, (WorldViewProjection._m03_m13_m23_m33));
    // mov oD0, c15
    o.color = expr15;
    // 

    return o;
}

// DebugIcons_Regular_PixelShader11 Pixel_2_0 Has PRES False
float4 DebugIcons_Regular_PixelShader11(float4 color : COLOR) : COLOR
{
    float4 out_color;
    // dcl v0
    // mov oC0, v0
    out_color = color;
    // 

    return out_color;
}

// DebugIcons_Regular_VertexShader12 Vertex_2_0 Has PRES False
struct DebugIcons_Regular_VertexShader12_Input
{
    float4 position : POSITION;
    float4 color : COLOR;
};

struct DebugIcons_Regular_VertexShader12_Output
{
    float4 position : POSITION;
    float4 color : COLOR;
};

DebugIcons_Regular_VertexShader12_Output DebugIcons_Regular_VertexShader12(DebugIcons_Regular_VertexShader12_Input i)
{
    DebugIcons_Regular_VertexShader12_Output o;
    float4 temp0;
    // def c0, 1, 0, 0, 0
    // dcl_position v0
    // dcl_color v1
    // mad r0, v0.xyzx, c0.xxxy, c0.yyyx
    temp0 = i.position.xyzx * float4(1, 1, 1, 0) + float4(0, 0, 0, 1);
    // dp4 oPos.x, r0, c11
    o.position.x = dot(temp0, (WorldViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c12
    o.position.y = dot(temp0, (WorldViewProjection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c13
    o.position.z = dot(temp0, (WorldViewProjection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c14
    o.position.w = dot(temp0, (WorldViewProjection._m03_m13_m23_m33));
    // mov oD0, v1
    o.color = i.color;
    // 

    return o;
}

// DisplayShadowMap_PixelShader13 Pixel_2_0 Has PRES False
float4 DisplayShadowMap_PixelShader13(float2 texcoord : TEXCOORD) : COLOR
{
    float4 out_color;
    float4 temp0;
    // dcl t0.xy
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(ShadowMapSampler, texcoord.xy);
    // mov r0, r0.x
    temp0 = temp0.x;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// DisplayShadowMap_VertexShader14 Vertex_2_0 Has PRES False
struct DisplayShadowMap_VertexShader14_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
};

struct DisplayShadowMap_VertexShader14_Output
{
    float4 position : POSITION;
    float2 texcoord : TEXCOORD;
};

DisplayShadowMap_VertexShader14_Output DisplayShadowMap_VertexShader14(DisplayShadowMap_VertexShader14_Input i)
{
    DisplayShadowMap_VertexShader14_Output o;
    // def c0, 1, 0, 0, 0
    // dcl_position v0
    // dcl_texcoord v1
    // mov oPos.xyz, v0
    o.position.xyz = i.position.xyz;
    // mov oPos.w, c0.x
    o.position.w = float1(1);
    // mov oT0.xy, v1
    o.texcoord = i.texcoord;
    // 

    return o;
}

technique DisplayShadowMap
{
    pass P0
    {
        VertexShader = compile vs_2_0 DisplayShadowMap_VertexShader14(); // 9
        PixelShader = compile ps_2_0 DisplayShadowMap_PixelShader13(); // 10
        ZEnable = 0;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 0;
        AlphaTestEnable = 0;
    }
}

technique DebugIcons_Regular
{
    pass P0
    {
        VertexShader = compile vs_2_0 DebugIcons_Regular_VertexShader12(); // 11
        PixelShader = compile ps_2_0 DebugIcons_Regular_PixelShader11(); // 12
        ZEnable = 0;
        ZFunc = 4;
        ZWriteEnable = 0;
        CullMode = 2;
        AlphaBlendEnable = 1;
        SrcBlend = 5;
        DestBlend = 6;
        ColorWriteEnable = 15;
        AlphaTestEnable = 0;
    }
}

technique DebugDisplay
{
    pass P0
    {
        VertexShader = compile vs_2_0 DebugDisplay_VertexShader10(); // 13
        PixelShader = compile ps_2_0 DebugDisplay_PixelShader9(); // 14
        ZEnable = 0;
        ZFunc = 4;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 0;
        AlphaTestEnable = 0;
    }
}

technique DrawObject_Opaque
{
    pass P0
    {
        VertexShader = compile vs_2_0 DrawObject_Opaque_VertexShader8(); // 15
        PixelShader = compile ps_2_0 DrawObject_Opaque_PixelShader7(); // 16
        FillMode = 3;
        ZEnable = 0;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 0;
        AlphaTestEnable = 0;
        ColorWriteEnable = 15;
    }
}

technique DrawObject_Opaque_ZTest
{
    pass P0
    {
        VertexShader = compile vs_2_0 DrawObject_Opaque_ZTest_VertexShader6(); // 17
        PixelShader = compile ps_2_0 DrawObject_Opaque_ZTest_PixelShader5(); // 18
        FillMode = 3;
        ZEnable = 1;
        ZFunc = 4;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 0;
        AlphaTestEnable = 0;
        ColorWriteEnable = 15;
    }
}

technique DrawObject_Alpha
{
    pass P0
    {
        VertexShader = compile vs_2_0 DrawObject_Alpha_VertexShader4(); // 19
        PixelShader = compile ps_2_0 DrawObject_Alpha_PixelShader3(); // 20
        FillMode = 3;
        ZEnable = 0;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 1;
        SrcBlend = 5;
        DestBlend = 6;
        AlphaTestEnable = 0;
        ColorWriteEnable = 15;
    }
}

technique CollisionBox
{
    pass P0
    {
        VertexShader = compile vs_2_0 CollisionBox_VertexShader2(); // 21
        PixelShader = compile ps_2_0 CollisionBox_PixelShader1(); // 22
        FillMode = 3;
        ZEnable = 1;
        ZFunc = 4;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 1;
        SrcBlend = 5;
        DestBlend = 6;
        AlphaTestEnable = 0;
        ColorWriteEnable = 15;
    }
}

