string DefaultParameterScopeBlock = "material"; // 1
float3 AmbientLightColor <bool unmanaged = 1;> = { 0.3, 0.3, 0.3 };
struct {
    float3 Color;
    float3 Direction;
} DirectionalLight[3] <bool unmanaged = 1;> = { 1.625198, 1.512711, 1.097048, 0.62914, -0.34874, 0.69465, 0.5232916, 0.6654605, 0.7815244, -0.32877, 0.90329, 0.27563, 0.4420466, 0.4102767, 0.4420466, -0.80704, -0.58635, 0.06975 };
struct {
    float3 Color;
    float3 Position;
    float2 Range_Inner_Outer;
} PointLight[8] <bool unmanaged = 1;>;
struct {
    float4 WorldPositionMultiplier_XYZZ;
    float2 CurrentOffsetUV;
} Cloud <bool unmanaged = 1;>;
float3 NoCloudMultiplier <bool unmanaged = 1;> = { 1, 1, 1 };
float3 RecolorColorDummy <bool unmanaged = 1;>;
row_major float4x4 ShadowMapWorldToShadow <bool unmanaged = 1;>;
float OpacityOverride : register(vs_2_0, c1) <bool unmanaged = 1;> = { 1 };
float3 TintColor <bool unmanaged = 1;> = { 1, 1, 1 };
float3 EyePosition <bool unmanaged = 1;>;
column_major float4x4 ViewProjection : register(vs_2_0, c119) <bool unmanaged = 1;>;
float4 WorldBones[128] : register(vs_2_0, c128) <bool unmanaged = 1;>;
int _SasGlobal : SasGlobal <string UIWidget = "None"; int3 SasVersion = int3(1, 0, 0); string RenderBin = "Distorter";>;
int NumJointsPerVertex <string UIWidget = "None"; string SasBindAddress = "Sas.Skeleton.NumJointsPerVertex";>;
column_major float4x3 World : World : register(vs_2_0, c124);
texture NormalMap <string UIName = "Normal Texture";>; // 6
sampler2D NormalMapSampler : register(ps_2_0, s0) <string Texture = "NormalMap"; string UIName = "Normal Texture";> =
sampler_state
{
    Texture = <NormalMap>; // 8
    MinFilter = 3;
    MagFilter = 2;
    MipFilter = 2;
    MaxAnisotropy = 8;
    AddressU = 1;
    AddressV = 1;
};
float4 TexCoordTransform_0 : register(vs_2_0, c14) <string UIName = "UV0 Scl/Move"; string UIWidget = "Spinner"; int UIMin = 0xfffffc18; int UIMax = 1000;> = { 1, 1, 0, 0 };
float BumpScale : register(ps_2_0, c11) <string UIName = "Bump Height"; string UIWidget = "Slider"; float UIMin = 0; float UIMax = 10; float UIStep = 0.1;> = { 1 };
bool AlphaTestEnable <string UIName = "Alpha Test Enable";>;
struct
{
    float4 ScaleUV_OffsetUV;
} Shroud : register(vs_2_0, c15) <string UIWidget = "None"; string SasBindAddress = "Terrain.Shroud";> = { 1, 1, 0, 0 };
texture ShroudTexture <string UIWidget = "None"; string SasBindAddress = "Terrain.Shroud.Texture";>; // 18
sampler2D ShroudTextureSampler : register(ps_2_0, s1) <string Texture = "ShroudTexture"; string UIWidget = "None"; string SasBindAddress = "Terrain.Shroud.Texture";> =
sampler_state
{
    Texture = <ShroudTexture>; // 21
    MinFilter = 2;
    MagFilter = 2;
    MipFilter = 2;
    AddressU = 3;
    AddressV = 3;
};
column_major float4x4 View : View : register(vs_2_0, c11);
float Time : Time;
// VS_Array_Shader_0 Vertex_2_0 Has PRES True
struct VS_Array_Shader_0_Input
{
    float4 position : POSITION;
    float4 normal : NORMAL;
    float4 tangent : TANGENT;
    float4 binormal : BINORMAL;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct VS_Array_Shader_0_Output
{
    float4 position : POSITION;
    float3 texcoord2 : TEXCOORD2;
    float3 texcoord3 : TEXCOORD3;
    float3 texcoord4 : TEXCOORD4;
    float4 color : COLOR;
    float2 texcoord : TEXCOORD;
    float2 texcoord1 : TEXCOORD1;
};

VS_Array_Shader_0_Output VS_Array_Shader_0(VS_Array_Shader_0_Input i)
{
    /*
    PRSI
      OutputRegisterOffset: 16
      Unknown1: 0
      Unknown2: 0
      OutputRegisterCount: 1
      Unknown3: 0
      Unknown4: 0
      Unknown5: 16
      Unknown6: 1
      Mappings: 1
        0 - ConstOutput: 0 ConstInput 0
    
    */
    float4 expr16;
    {
        // Expression_2_1
        // mul c16.xy, c1.x, c0.zw
        expr16.xy = Time.x * TexCoordTransform_0.zw;
    }

    VS_Array_Shader_0_Output o;
    float4 temp0, temp1;
    // def c0, 1, 0, 200, 500
    // dcl_position v0
    // dcl_normal v1
    // dcl_tangent v2
    // dcl_binormal v3
    // dcl_texcoord v4
    // dcl_color v5
    // mad r0, v0.xyzx, c0.xxxy, c0.yyyx
    temp0 = i.position.xyzx * float4(1, 1, 1, 0) + float4(0, 0, 0, 1);
    // dp4 r1.z, r0, c126
    temp1.z = dot(temp0, (World._m02_m12_m22_m32));
    // mov r1.w, c0.x
    temp1.w = float1(1);
    // dp4 r1.x, r0, c124
    temp1.x = dot(temp0, (World._m00_m10_m20_m30));
    // dp4 r1.y, r0, c125
    temp1.y = dot(temp0, (World._m01_m11_m21_m31));
    // dp4 oPos.x, r1, c119
    o.position.x = dot(temp1, (ViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r1, c120
    o.position.y = dot(temp1, (ViewProjection._m01_m11_m21_m31));
    // dp4 oPos.z, r1, c121
    o.position.z = dot(temp1, (ViewProjection._m02_m12_m22_m32));
    // dp4 oPos.w, r1, c122
    o.position.w = dot(temp1, (ViewProjection._m03_m13_m23_m33));
    // dp4 r0.x, r1, c13
    temp0.x = dot(temp1, (View._m02_m12_m22_m32));
    // add r0.yz, r1.xxyw, c15.xzww
    temp0.yz = temp1.xy + Shroud.ScaleUV_OffsetUV.zw;
    // dp3 r1.x, v3, c124
    temp1.x = dot(i.binormal.xyz, (World._m00_m10_m20_m30).xyz);
    // dp3 r1.y, v3, c125
    temp1.y = dot(i.binormal.xyz, (World._m01_m11_m21_m31).xyz);
    // dp3 r1.z, v3, c126
    temp1.z = dot(i.binormal.xyz, (World._m02_m12_m22_m32).xyz);
    // dp3 oT2.x, -r1, c11
    o.texcoord2.x = dot(-temp1.xyz, (View._m00_m10_m20_m30).xyz);
    // dp3 oT3.x, -r1, c12
    o.texcoord3.x = dot(-temp1.xyz, (View._m01_m11_m21_m31).xyz);
    // dp3 oT4.x, -r1, c13
    o.texcoord4.x = dot(-temp1.xyz, (View._m02_m12_m22_m32).xyz);
    // dp3 r1.x, v2, c124
    temp1.x = dot(i.tangent.xyz, (World._m00_m10_m20_m30).xyz);
    // dp3 r1.y, v2, c125
    temp1.y = dot(i.tangent.xyz, (World._m01_m11_m21_m31).xyz);
    // dp3 r1.z, v2, c126
    temp1.z = dot(i.tangent.xyz, (World._m02_m12_m22_m32).xyz);
    // dp3 oT2.y, -r1, c11
    o.texcoord2.y = dot(-temp1.xyz, (View._m00_m10_m20_m30).xyz);
    // dp3 oT3.y, -r1, c12
    o.texcoord3.y = dot(-temp1.xyz, (View._m01_m11_m21_m31).xyz);
    // dp3 oT4.y, -r1, c13
    o.texcoord4.y = dot(-temp1.xyz, (View._m02_m12_m22_m32).xyz);
    // dp3 r1.x, v1, c124
    temp1.x = dot(i.normal.xyz, (World._m00_m10_m20_m30).xyz);
    // dp3 r1.y, v1, c125
    temp1.y = dot(i.normal.xyz, (World._m01_m11_m21_m31).xyz);
    // dp3 r1.z, v1, c126
    temp1.z = dot(i.normal.xyz, (World._m02_m12_m22_m32).xyz);
    // dp3 oT2.z, r1, c11
    o.texcoord2.z = dot(temp1.xyz, (View._m00_m10_m20_m30).xyz);
    // dp3 oT3.z, r1, c12
    o.texcoord3.z = dot(temp1.xyz, (View._m01_m11_m21_m31).xyz);
    // dp3 oT4.z, r1, c13
    o.texcoord4.z = dot(temp1.xyz, (View._m02_m12_m22_m32).xyz);
    // add r0.x, -r0.x, c0.z
    temp0.x = -temp0.x + float1(200);
    // rcp r0.x, r0.x
    temp0.x = 1.0f / temp0.x;
    // mul r1.xyz, r0.x, c0.w
    temp1.xyz = temp0.xxx * float3(500, 500, 500);
    // mov r1.w, c1.x
    temp1.w = OpacityOverride.x;
    // mul oD0, r1, v5
    o.color = temp1 * i.color;
    // mov r1.xy, c14
    temp1.xy = TexCoordTransform_0.xy;
    // mad oT0.xy, v4, r1, c16
    o.texcoord = i.texcoord * temp1 + expr16;
    // mul oT1.xy, r0.yzzw, c15
    o.texcoord1 = temp0.yzzw * Shroud.ScaleUV_OffsetUV;
    // 

    return o;
}

// VS_Array_Shader_1 Vertex_2_0 Has PRES True
struct VS_Array_Shader_1_Input
{
    float4 position : POSITION;
    float4 normal : NORMAL;
    float4 tangent : TANGENT;
    float4 binormal : BINORMAL;
    float4 blendindices : BLENDINDICES;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct VS_Array_Shader_1_Output
{
    float4 position : POSITION;
    float3 texcoord2 : TEXCOORD2;
    float3 texcoord3 : TEXCOORD3;
    float3 texcoord4 : TEXCOORD4;
    float4 color : COLOR;
    float2 texcoord : TEXCOORD;
    float2 texcoord1 : TEXCOORD1;
};

VS_Array_Shader_1_Output VS_Array_Shader_1(VS_Array_Shader_1_Input i)
{
    /*
    PRSI
      OutputRegisterOffset: 16
      Unknown1: 0
      Unknown2: 0
      OutputRegisterCount: 1
      Unknown3: 0
      Unknown4: 0
      Unknown5: 16
      Unknown6: 1
      Mappings: 1
        0 - ConstOutput: 0 ConstInput 0
    
    */
    float4 expr16;
    {
        // Expression_2_1
        // mul c16.xy, c1.x, c0.zw
        expr16.xy = Time.x * TexCoordTransform_0.zw;
    }

    VS_Array_Shader_1_Output o;
    float4 temp0, temp1, temp2;
    float addr0;
    // def c0, 1, -1, 200, 500
    // dcl_position v0
    // dcl_normal v1
    // dcl_tangent v2
    // dcl_binormal v3
    // dcl_blendindices v4
    // dcl_texcoord v5
    // dcl_color v6
    // add r0.x, v4.x, v4.x
    temp0.x = i.blendindices.x + i.blendindices.x;
    // frc r0.y, r0.x
    temp0.y = frac(temp0.x);
    // add r0.z, r0.x, -r0.y
    temp0.z = temp0.x + -temp0.y;
    // slt r0.y, -r0.y, r0.y
    temp0.y = (-temp0.y < temp0.y) ? 1 : 0;
    // slt r0.x, r0.x, -r0.x
    temp0.x = (temp0.x < -temp0.x) ? 1 : 0;
    // mad r0.x, r0.x, r0.y, r0.z
    temp0.x = temp0.x * temp0.y + temp0.z;
    // mova a0.x, r0.x
    addr0.x = temp0.x;
    // mul r0, v0.zxyy, c128[a0.x].yzxy
    temp0 = i.position.zxyy * WorldBones[0 + addr0.x].yzxy;
    // mad r0, c128[a0.x].wwwx, v0.xyzx, r0
    temp0 = WorldBones[0 + addr0.x].wwwx * i.position.xyzx + temp0;
    // mul r1, v0.yzxz, c128[a0.x].zxyz
    temp1 = i.position.yzxz * WorldBones[0 + addr0.x].zxyz;
    // mad r0, r0, c0.xxxy, -r1
    temp0 = temp0 * float4(1, 1, 1, -1) + -temp1;
    // mul r1.xyz, r0.w, c128[a0.x]
    temp1.xyz = temp0.www * WorldBones[0 + addr0.x].xyz;
    // mad r1.xyz, c128[a0.x].w, r0, -r1
    temp1.xyz = WorldBones[0 + addr0.x].www * temp0.xyz + -temp1.xyz;
    // mad r1.xyz, c128[a0.x].yzxw, r0.zxyw, r1
    temp1.xyz = WorldBones[0 + addr0.x].yzx * temp0.zxy + temp1.xyz;
    // mad r0.xyz, c128[a0.x].zxyw, -r0.yzxw, r1
    temp0.xyz = WorldBones[0 + addr0.x].zxy * -temp0.yzx + temp1.xyz;
    // add r0.xyz, r0, c129[a0.x]
    temp0.xyz = temp0.xyz + WorldBones[1 + addr0.x].xyz;
    // mov r0.w, c0.x
    temp0.w = float1(1);
    // dp4 oPos.x, r0, c119
    o.position.x = dot(temp0, (ViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c120
    o.position.y = dot(temp0, (ViewProjection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c121
    o.position.z = dot(temp0, (ViewProjection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c122
    o.position.w = dot(temp0, (ViewProjection._m03_m13_m23_m33));
    // dp4 r0.z, r0, c13
    temp0.z = dot(temp0, (View._m02_m12_m22_m32));
    // add r0.xy, r0, c15.zwzw
    temp0.xy = temp0.xy + Shroud.ScaleUV_OffsetUV.zw;
    // mul r1, v3.zxyy, c128[a0.x].yzxy
    temp1 = i.binormal.zxyy * WorldBones[0 + addr0.x].yzxy;
    // mad r1, c128[a0.x].wwwx, v3.xyzx, r1
    temp1 = WorldBones[0 + addr0.x].wwwx * i.binormal.xyzx + temp1;
    // mul r2, v3.yzxz, c128[a0.x].zxyz
    temp2 = i.binormal.yzxz * WorldBones[0 + addr0.x].zxyz;
    // mad r1, r1, c0.xxxy, -r2
    temp1 = temp1 * float4(1, 1, 1, -1) + -temp2;
    // mul r2.xyz, r1.w, c128[a0.x]
    temp2.xyz = temp1.www * WorldBones[0 + addr0.x].xyz;
    // mad r2.xyz, c128[a0.x].w, r1, -r2
    temp2.xyz = WorldBones[0 + addr0.x].www * temp1.xyz + -temp2.xyz;
    // mad r2.xyz, c128[a0.x].yzxw, r1.zxyw, r2
    temp2.xyz = WorldBones[0 + addr0.x].yzx * temp1.zxy + temp2.xyz;
    // mad r1.xyz, c128[a0.x].zxyw, -r1.yzxw, r2
    temp1.xyz = WorldBones[0 + addr0.x].zxy * -temp1.yzx + temp2.xyz;
    // dp3 oT2.x, -r1, c11
    o.texcoord2.x = dot(-temp1.xyz, (View._m00_m10_m20_m30).xyz);
    // dp3 oT3.x, -r1, c12
    o.texcoord3.x = dot(-temp1.xyz, (View._m01_m11_m21_m31).xyz);
    // dp3 oT4.x, -r1, c13
    o.texcoord4.x = dot(-temp1.xyz, (View._m02_m12_m22_m32).xyz);
    // mul r1, v2.zxyy, c128[a0.x].yzxy
    temp1 = i.tangent.zxyy * WorldBones[0 + addr0.x].yzxy;
    // mad r1, c128[a0.x].wwwx, v2.xyzx, r1
    temp1 = WorldBones[0 + addr0.x].wwwx * i.tangent.xyzx + temp1;
    // mul r2, v2.yzxz, c128[a0.x].zxyz
    temp2 = i.tangent.yzxz * WorldBones[0 + addr0.x].zxyz;
    // mad r1, r1, c0.xxxy, -r2
    temp1 = temp1 * float4(1, 1, 1, -1) + -temp2;
    // mul r2.xyz, r1.w, c128[a0.x]
    temp2.xyz = temp1.www * WorldBones[0 + addr0.x].xyz;
    // mad r2.xyz, c128[a0.x].w, r1, -r2
    temp2.xyz = WorldBones[0 + addr0.x].www * temp1.xyz + -temp2.xyz;
    // mad r2.xyz, c128[a0.x].yzxw, r1.zxyw, r2
    temp2.xyz = WorldBones[0 + addr0.x].yzx * temp1.zxy + temp2.xyz;
    // mad r1.xyz, c128[a0.x].zxyw, -r1.yzxw, r2
    temp1.xyz = WorldBones[0 + addr0.x].zxy * -temp1.yzx + temp2.xyz;
    // dp3 oT2.y, -r1, c11
    o.texcoord2.y = dot(-temp1.xyz, (View._m00_m10_m20_m30).xyz);
    // dp3 oT3.y, -r1, c12
    o.texcoord3.y = dot(-temp1.xyz, (View._m01_m11_m21_m31).xyz);
    // dp3 oT4.y, -r1, c13
    o.texcoord4.y = dot(-temp1.xyz, (View._m02_m12_m22_m32).xyz);
    // mul r1, v1.zxyy, c128[a0.x].yzxy
    temp1 = i.normal.zxyy * WorldBones[0 + addr0.x].yzxy;
    // mad r1, c128[a0.x].wwwx, v1.xyzx, r1
    temp1 = WorldBones[0 + addr0.x].wwwx * i.normal.xyzx + temp1;
    // mul r2, v1.yzxz, c128[a0.x].zxyz
    temp2 = i.normal.yzxz * WorldBones[0 + addr0.x].zxyz;
    // mad r1, r1, c0.xxxy, -r2
    temp1 = temp1 * float4(1, 1, 1, -1) + -temp2;
    // mul r2.xyz, r1.w, c128[a0.x]
    temp2.xyz = temp1.www * WorldBones[0 + addr0.x].xyz;
    // mad r2.xyz, c128[a0.x].w, r1, -r2
    temp2.xyz = WorldBones[0 + addr0.x].www * temp1.xyz + -temp2.xyz;
    // mad r2.xyz, c128[a0.x].yzxw, r1.zxyw, r2
    temp2.xyz = WorldBones[0 + addr0.x].yzx * temp1.zxy + temp2.xyz;
    // mad r1.xyz, c128[a0.x].zxyw, -r1.yzxw, r2
    temp1.xyz = WorldBones[0 + addr0.x].zxy * -temp1.yzx + temp2.xyz;
    // dp3 oT2.z, r1, c11
    o.texcoord2.z = dot(temp1.xyz, (View._m00_m10_m20_m30).xyz);
    // dp3 oT3.z, r1, c12
    o.texcoord3.z = dot(temp1.xyz, (View._m01_m11_m21_m31).xyz);
    // dp3 oT4.z, r1, c13
    o.texcoord4.z = dot(temp1.xyz, (View._m02_m12_m22_m32).xyz);
    // add r0.z, -r0.z, c0.z
    temp0.z = -temp0.z + float1(200);
    // rcp r0.z, r0.z
    temp0.z = 1.0f / temp0.z;
    // mul r1.xyz, r0.z, c0.w
    temp1.xyz = temp0.zzz * float3(500, 500, 500);
    // mov r1.w, c1.x
    temp1.w = OpacityOverride.x;
    // mul oD0, r1, v6
    o.color = temp1 * i.color;
    // mov r1.xy, c14
    temp1.xy = TexCoordTransform_0.xy;
    // mad oT0.xy, v5, r1, c16
    o.texcoord = i.texcoord * temp1 + expr16;
    // mul oT1.xy, r0, c15
    o.texcoord1 = temp0 * Shroud.ScaleUV_OffsetUV;
    // 

    return o;
}

VertexShader VS_Array[2] = {
    compile vs_2_0 VS_Array_Shader_0(), // 25
    compile vs_2_0 VS_Array_Shader_1(), // 26
};
// Default_M_Expression3 Expression_2_0 Has PRES False
float Default_M_Expression3()
{
    float1 expr0;
    // mov c0.x, c0.x
    expr0.x = AlphaTestEnable.x;
    return expr0;
}

// Default_M_PixelShader4 Pixel_2_0 Has PRES False
struct Default_M_PixelShader4_Input
{
    float4 color : COLOR;
    float2 texcoord : TEXCOORD;
    float2 texcoord1 : TEXCOORD1;
    float3 texcoord2 : TEXCOORD2;
    float3 texcoord3 : TEXCOORD3;
    float3 texcoord4 : TEXCOORD4;
};

float4 Default_M_PixelShader4(Default_M_PixelShader4_Input i) : COLOR
{
    float4 out_color;
    float4 temp0, temp1, temp2;
    // def c0, 2, -1, 0.5, 0
    // dcl v0
    // dcl t0.xy
    // dcl t1.xy
    // dcl t2.xyz
    // dcl t3.xyz
    // dcl t4.xyz
    // dcl_2d s0
    // dcl_2d s1
    // texld r0, t0, s0
    temp0 = tex2D(NormalMapSampler, i.texcoord.xy);
    // texld r1, t1, s1
    temp1 = tex2D(ShroudTextureSampler, i.texcoord1.xy);
    // mad r0.xyz, r0, c0.x, c0.y
    temp0.xyz = temp0.xyz * float3(2, 2, 2) + float3(-1, -1, -1);
    // mul r0.w, r0.w, v0.w
    temp0.w = temp0.w * i.color.w;
    // mul r0.xy, r0, c11.x
    temp0.xy = temp0.xy * BumpScale.xx;
    // nrm r1.xyz, r0
    temp1.xyz = normalize(temp0.xyz).xyz;
    // dp3 r0.x, r1, t2
    temp0.x = dot(temp1.xyz, i.texcoord2.xyz);
    // dp3 r0.y, r1, t3
    temp0.y = dot(temp1.xyz, i.texcoord3.xyz);
    // dp3 r0.z, r1, t4
    temp0.z = dot(temp1.xyz, i.texcoord4.xyz);
    // mul r0.xyz, r0, v0
    temp0.xyz = temp0.xyz * i.color.xyz;
    // mad r2.xyz, r0, c0.z, c0.z
    temp2.xyz = temp0.xyz * float3(0.5, 0.5, 0.5) + float3(0.5, 0.5, 0.5);
    // mul r2.w, r1.w, r0.w
    temp2.w = temp1.w * temp0.w;
    // mov oC0, r2
    out_color = temp2;
    // 

    return out_color;
}

// Default_M_Expression5 Expression_2_0 Has PRES False
float Default_M_Expression5()
{
    float1 expr0;
    // min c0.x, c0.x, (1)
    expr0.x = min(NumJointsPerVertex.x, (1));
    return expr0;
}

technique Default_M
{
    pass p0 <string ExpressionEvaluator = "DistortingObject";>
    {
        VertexShader = VS_Array[Default_M_Expression5()]; // 28
        PixelShader = compile ps_2_0 Default_M_PixelShader4(); // 29
        ZEnable = 1;
        ZFunc = 4;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 1;
        SrcBlend = 5;
        DestBlend = 6;
        AlphaTestEnable = Default_M_Expression3(); // 0
        AlphaFunc = 7;
        AlphaRef = 96;
    }
}

technique Default_L
{
}

