string DefaultParameterScopeBlock = "material"; // 1
float3 AmbientLightColor <bool unmanaged = 1;> = { 0.3, 0.3, 0.3 };
struct
{
    float3 Color;
    float3 Direction;
} DirectionalLight[3] : register(ps_2_0, c5) : register(vs_2_0, c5) <bool unmanaged = 1;> = { 1.625198, 1.512711, 1.097048, 0.62914, -0.34874, 0.69465, 0.5232916, 0.6654605, 0.7815244, -0.32877, 0.90329, 0.27563, 0.4420466, 0.4102767, 0.4420466, -0.80704, -0.58635, 0.06975 };
struct {
    float3 Color;
    float3 Position;
    float2 Range_Inner_Outer;
} PointLight[8] <bool unmanaged = 1;>;
struct {
    float4 WorldPositionMultiplier_XYZZ;
    float2 CurrentOffsetUV;
} Cloud <bool unmanaged = 1;>;
float3 NoCloudMultiplier : register(ps_2_0, c3) <bool unmanaged = 1;> = { 1, 1, 1 };
float3 RecolorColorDummy <bool unmanaged = 1;>;
row_major float4x4 ShadowMapWorldToShadow <bool unmanaged = 1;>;
float OpacityOverride <bool unmanaged = 1;> = { 1 };
float3 TintColor <bool unmanaged = 1;> = { 1, 1, 1 };
float3 EyePosition <bool unmanaged = 1;>;
row_major float4x4 ViewProjection <bool unmanaged = 1;>;
float4 WorldBones[128] <bool unmanaged = 1;>;
struct
{
    float4 VideoTex_NumPerRow_LastFrame_SingleRow_isRand;
    float4 ColorAnimationFunctions[6];
    float4 TimeKeys;
    int ShaderType;
    float SpeedMultiplier;
    float2 ColorScaleRange;
} Draw : register(vs_2_0, c39) <string UIWidget = "None"; string SasBindAddress = "Particle.Draw";> = { 4, 15, -1, 0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 1, 1, -0.1, 0.2 };
struct
{
    float3 Gravity;
    float3 DriftVelocity;
    float2 VelocityDampingRange;
} Physics : register(vs_2_0, c65) <string UIWidget = "None"; string SasBindAddress = "Particle.Physics";> = { 0, 0, 0, 0, 0, 0, 1, 0 };
struct
{
    float3 Size_Rate_Damping__Min;
    float3 Size_Rate_Damping__Spread;
    float3 XYRotation_Rate_Damping__Min;
    float3 XYRotation_Rate_Damping__Spread;
    float3 ZRotation_Rate_Damping__Min;
    float3 ZRotation_Rate_Damping__Spread;
} Update : register(vs_2_0, c50) <string UIWidget = "None"; string SasBindAddress = "Particle.Update";> = { 0, 0, 1, 10, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0 };
texture ParticleTextureSampler <string UIWidget = "None"; string SasBindAddress = "Particle.Draw.Texture";>; // 8
sampler2D ParticleTextureSamplerSampler : register(ps_2_0, s0) <string Texture = "ParticleTextureSampler"; string UIWidget = "None"; string SasBindAddress = "Particle.Draw.Texture";> =
sampler_state
{
    Texture = <ParticleTextureSampler>; // 11
    MinFilter = 2;
    MagFilter = 2;
    MipFilter = 2;
    AddressU = 3;
    AddressV = 3;
};
texture NextFrameTextureSampler <string UIWidget = "None"; string SasBindAddress = "Particle.Draw.Texture";>; // 15
sampler2D NextFrameTextureSamplerSampler <string Texture = "NextFrameTextureSampler"; string UIWidget = "None"; string SasBindAddress = "Particle.Draw.Texture";> =
sampler_state
{
    Texture = <NextFrameTextureSampler>; // 18
    MinFilter = 2;
    MagFilter = 2;
    MipFilter = 2;
    AddressU = 3;
    AddressV = 3;
};
texture NormalTextureSampler <string UIWidget = "None"; string SasBindAddress = "Particle.Draw.DetailTexture";>; // 22
sampler2D NormalTextureSamplerSampler : register(ps_2_0, s1) <string Texture = "NormalTextureSampler"; string UIWidget = "None"; string SasBindAddress = "Particle.Draw.DetailTexture";> =
sampler_state
{
    Texture = <NormalTextureSampler>; // 25
    MinFilter = 2;
    MagFilter = 2;
    MipFilter = 2;
    AddressU = 1;
    AddressV = 1;
};
column_major float4x4 WorldViewProjection : WorldViewProjection : register(vs_2_0, c61);
column_major float4x3 View : View : register(vs_2_0, c68);
row_major float4x3 World : World;
float Time : Time;
// PS_Array_Shader_0 Pixel_2_0 Has PRES False
struct PS_Array_Shader_0_Input
{
    float2 texcoord : TEXCOORD;
    float4 color : COLOR;
    float3 texcoord5 : TEXCOORD5;
    float3 texcoord6 : TEXCOORD6;
    float3 texcoord7 : TEXCOORD7;
};

float4 PS_Array_Shader_0(PS_Array_Shader_0_Input i) : COLOR
{
    float4 out_color;
    float4 temp0, temp1, temp2, temp3;
    // def c0, 2, -1, 10, 0
    // dcl t0.xy
    // dcl v0
    // dcl t5.xyz
    // dcl t6.xyz
    // dcl t7.xyz
    // dcl_2d s0
    // dcl_2d s1
    // texld r0, t0, s1
    temp0 = tex2D(NormalTextureSamplerSampler, i.texcoord.xy);
    // texld r1, t0, s0
    temp1 = tex2D(ParticleTextureSamplerSampler, i.texcoord.xy);
    // mad r0.xyz, r0, c0.x, c0.y
    temp0.xyz = temp0.xyz * float3(2, 2, 2) + float3(-1, -1, -1);
    // mul r0.xyz, r0, c0.z
    temp0.xyz = temp0.xyz * float3(10, 10, 10);
    // nrm r2.xyz, r0
    temp2.xyz = normalize(temp0.xyz).xyz;
    // dp3 r2.w, r2, t6
    temp2.w = dot(temp2.xyz, i.texcoord6.xyz);
    // max r0.x, r2.w, c0.w
    temp0.x = max(temp2.w, float1(0));
    // mov r3.xyz, c3
    temp3.xyz = NoCloudMultiplier.xyz;
    // mul r0.yzw, r3.wzyx, c7.wzyx
    temp0.yzw = temp3.zyx * DirectionalLight[1].Color.zyx;
    // mul r0.xyz, r0.x, r0.wzyx
    temp0.xyz = temp0.xxx * temp0.wzy;
    // dp3 r0.w, r2, t5
    temp0.w = dot(temp2.xyz, i.texcoord5.xyz);
    // dp3 r3.w, r2, t7
    temp3.w = dot(temp2.xyz, i.texcoord7.xyz);
    // max r2.x, r0.w, c0.w
    temp2.x = max(temp0.w, float1(0));
    // mul r2.yzw, r3.wzyx, c5.wzyx
    temp2.yzw = temp3.zyx * DirectionalLight[0].Color.zyx;
    // mad r0.xyz, r2.wzyx, r2.x, r0
    temp0.xyz = temp2.wzy * temp2.xxx + temp0.xyz;
    // max r0.w, r3.w, c0.w
    temp0.w = max(temp3.w, float1(0));
    // mul r2.xyz, r3, c9
    temp2.xyz = temp3.xyz * DirectionalLight[2].Color.xyz;
    // mad r0.xyz, r2, r0.w, r0
    temp0.xyz = temp2.xyz * temp0.www + temp0.xyz;
    // mul r1, r1, v0
    temp1 = temp1 * i.color;
    // mul r1.xyz, r0, r1
    temp1.xyz = temp0.xyz * temp1.xyz;
    // mov oC0, r1
    out_color = temp1;
    // 

    return out_color;
}

// PS_Array_Shader_1 Pixel_2_0 Has PRES False
struct PS_Array_Shader_1_Input
{
    float2 texcoord : TEXCOORD;
    float4 color : COLOR;
    float3 texcoord5 : TEXCOORD5;
    float3 texcoord6 : TEXCOORD6;
    float3 texcoord7 : TEXCOORD7;
};

float4 PS_Array_Shader_1(PS_Array_Shader_1_Input i) : COLOR
{
    float4 out_color;
    float4 temp0, temp1, temp2, temp3;
    // def c0, 2, -1, 10, 0
    // dcl t0.xy
    // dcl v0
    // dcl t5.xyz
    // dcl t6.xyz
    // dcl t7.xyz
    // dcl_2d s0
    // dcl_2d s1
    // texld r0, t0, s1
    temp0 = tex2D(NormalTextureSamplerSampler, i.texcoord.xy);
    // texld r1, t0, s0
    temp1 = tex2D(ParticleTextureSamplerSampler, i.texcoord.xy);
    // mad r0.xyz, r0, c0.x, c0.y
    temp0.xyz = temp0.xyz * float3(2, 2, 2) + float3(-1, -1, -1);
    // mul r0.xyz, r0, c0.z
    temp0.xyz = temp0.xyz * float3(10, 10, 10);
    // nrm r2.xyz, r0
    temp2.xyz = normalize(temp0.xyz).xyz;
    // dp3 r2.w, r2, t6
    temp2.w = dot(temp2.xyz, i.texcoord6.xyz);
    // max r0.x, r2.w, c0.w
    temp0.x = max(temp2.w, float1(0));
    // mov r3.xyz, c3
    temp3.xyz = NoCloudMultiplier.xyz;
    // mul r0.yzw, r3.wzyx, c7.wzyx
    temp0.yzw = temp3.zyx * DirectionalLight[1].Color.zyx;
    // mul r0.xyz, r0.x, r0.wzyx
    temp0.xyz = temp0.xxx * temp0.wzy;
    // dp3 r0.w, r2, t5
    temp0.w = dot(temp2.xyz, i.texcoord5.xyz);
    // dp3 r3.w, r2, t7
    temp3.w = dot(temp2.xyz, i.texcoord7.xyz);
    // max r2.x, r0.w, c0.w
    temp2.x = max(temp0.w, float1(0));
    // mul r2.yzw, r3.wzyx, c5.wzyx
    temp2.yzw = temp3.zyx * DirectionalLight[0].Color.zyx;
    // mad r0.xyz, r2.wzyx, r2.x, r0
    temp0.xyz = temp2.wzy * temp2.xxx + temp0.xyz;
    // max r0.w, r3.w, c0.w
    temp0.w = max(temp3.w, float1(0));
    // mul r2.xyz, r3, c9
    temp2.xyz = temp3.xyz * DirectionalLight[2].Color.xyz;
    // mad r0.xyz, r2, r0.w, r0
    temp0.xyz = temp2.xyz * temp0.www + temp0.xyz;
    // mul r1, r1, v0
    temp1 = temp1 * i.color;
    // mul r1.xyz, r0, r1
    temp1.xyz = temp0.xyz * temp1.xyz;
    // mov oC0, r1
    out_color = temp1;
    // 

    return out_color;
}

// PS_Array_Shader_2 Pixel_2_0 Has PRES False
struct PS_Array_Shader_2_Input
{
    float2 texcoord : TEXCOORD;
    float4 color : COLOR;
    float3 texcoord5 : TEXCOORD5;
    float3 texcoord6 : TEXCOORD6;
    float3 texcoord7 : TEXCOORD7;
};

float4 PS_Array_Shader_2(PS_Array_Shader_2_Input i) : COLOR
{
    float4 out_color;
    float4 temp0, temp1, temp2, temp3;
    // def c0, 2, -1, 10, 0
    // dcl t0.xy
    // dcl v0
    // dcl t5.xyz
    // dcl t6.xyz
    // dcl t7.xyz
    // dcl_2d s0
    // dcl_2d s1
    // texld r0, t0, s1
    temp0 = tex2D(NormalTextureSamplerSampler, i.texcoord.xy);
    // texld r1, t0, s0
    temp1 = tex2D(ParticleTextureSamplerSampler, i.texcoord.xy);
    // mad r0.xyz, r0, c0.x, c0.y
    temp0.xyz = temp0.xyz * float3(2, 2, 2) + float3(-1, -1, -1);
    // mul r0.xyz, r0, c0.z
    temp0.xyz = temp0.xyz * float3(10, 10, 10);
    // nrm r2.xyz, r0
    temp2.xyz = normalize(temp0.xyz).xyz;
    // dp3 r2.w, r2, t6
    temp2.w = dot(temp2.xyz, i.texcoord6.xyz);
    // max r0.x, r2.w, c0.w
    temp0.x = max(temp2.w, float1(0));
    // mov r3.xyz, c3
    temp3.xyz = NoCloudMultiplier.xyz;
    // mul r0.yzw, r3.wzyx, c7.wzyx
    temp0.yzw = temp3.zyx * DirectionalLight[1].Color.zyx;
    // mul r0.xyz, r0.x, r0.wzyx
    temp0.xyz = temp0.xxx * temp0.wzy;
    // dp3 r0.w, r2, t5
    temp0.w = dot(temp2.xyz, i.texcoord5.xyz);
    // dp3 r3.w, r2, t7
    temp3.w = dot(temp2.xyz, i.texcoord7.xyz);
    // max r2.x, r0.w, c0.w
    temp2.x = max(temp0.w, float1(0));
    // mul r2.yzw, r3.wzyx, c5.wzyx
    temp2.yzw = temp3.zyx * DirectionalLight[0].Color.zyx;
    // mad r0.xyz, r2.wzyx, r2.x, r0
    temp0.xyz = temp2.wzy * temp2.xxx + temp0.xyz;
    // max r0.w, r3.w, c0.w
    temp0.w = max(temp3.w, float1(0));
    // mul r2.xyz, r3, c9
    temp2.xyz = temp3.xyz * DirectionalLight[2].Color.xyz;
    // mad r0.xyz, r2, r0.w, r0
    temp0.xyz = temp2.xyz * temp0.www + temp0.xyz;
    // mul r1, r1, v0
    temp1 = temp1 * i.color;
    // mul r1.xyz, r0, r1
    temp1.xyz = temp0.xyz * temp1.xyz;
    // mov oC0, r1
    out_color = temp1;
    // 

    return out_color;
}

PixelShader PS_Array[3] = {
    compile ps_2_0 PS_Array_Shader_0(), // 29
    compile ps_2_0 PS_Array_Shader_1(), // 30
    compile ps_2_0 PS_Array_Shader_2(), // 31
};
// PSCreateShadowMap_Array_Shader_0 Pixel_2_0 Has PRES False
float4 PSCreateShadowMap_Array_Shader_0(float texcoord3 : TEXCOORD3) : COLOR
{
    float4 out_color;
    float4 temp0;
    // dcl t3.x
    // mov r0, t3.x
    temp0 = texcoord3.x;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// PSCreateShadowMap_Array_Shader_1 Pixel_2_0 Has PRES False
struct PSCreateShadowMap_Array_Shader_1_Input
{
    float2 texcoord : TEXCOORD;
    float3 color : COLOR;
    float texcoord3 : TEXCOORD3;
};

float4 PSCreateShadowMap_Array_Shader_1(PSCreateShadowMap_Array_Shader_1_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    // def c0, 1, -0.3, 0, 0
    // dcl t0.xy
    // dcl v0.xyz
    // dcl t3.x
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(ParticleTextureSamplerSampler, i.texcoord.xy);
    // mul r0.xyz, r0, v0
    temp0.xyz = temp0.xyz * i.color.xyz;
    // dp3 r0.x, r0, c0.x
    temp0.x = dot(temp0.xyz, float3(1, 1, 1));
    // add r0, r0.x, c0.y
    temp0 = temp0.x + float4(-0.3, -0.3, -0.3, -0.3);
    // texkill r0
    clip(temp0);
    // mov r0, t3.x
    temp0 = i.texcoord3.x;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// PSCreateShadowMap_Array_Shader_2 Pixel_2_0 Has PRES False
struct PSCreateShadowMap_Array_Shader_2_Input
{
    float2 texcoord : TEXCOORD;
    float4 color : COLOR;
    float texcoord3 : TEXCOORD3;
};

float4 PSCreateShadowMap_Array_Shader_2(PSCreateShadowMap_Array_Shader_2_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    // def c0, -0.1, 0, 0, 0
    // dcl t0.xy
    // dcl v0
    // dcl t3.x
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(ParticleTextureSamplerSampler, i.texcoord.xy);
    // mad r0, r0.w, v0.w, c0.x
    temp0 = temp0.w * i.color.w + float4(-0.1, -0.1, -0.1, -0.1);
    // texkill r0
    clip(temp0);
    // mov r0, t3.x
    temp0 = i.texcoord3.x;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// PSCreateShadowMap_Array_Shader_3 Pixel_2_0 Has PRES False
struct PSCreateShadowMap_Array_Shader_3_Input
{
    float2 texcoord : TEXCOORD;
    float4 color : COLOR;
    float texcoord3 : TEXCOORD3;
};

float4 PSCreateShadowMap_Array_Shader_3(PSCreateShadowMap_Array_Shader_3_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    // def c0, -0.1, 0, 0, 0
    // dcl t0.xy
    // dcl v0
    // dcl t3.x
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(ParticleTextureSamplerSampler, i.texcoord.xy);
    // mad r0, r0.w, v0.w, c0.x
    temp0 = temp0.w * i.color.w + float4(-0.1, -0.1, -0.1, -0.1);
    // texkill r0
    clip(temp0);
    // mov r0, t3.x
    temp0 = i.texcoord3.x;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// PSCreateShadowMap_Array_Shader_4 Pixel_2_0 Has PRES False
struct PSCreateShadowMap_Array_Shader_4_Input
{
    float2 texcoord : TEXCOORD;
    float4 color : COLOR;
    float texcoord3 : TEXCOORD3;
};

float4 PSCreateShadowMap_Array_Shader_4(PSCreateShadowMap_Array_Shader_4_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    // def c0, -0.1, 0, 0, 0
    // dcl t0.xy
    // dcl v0
    // dcl t3.x
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(ParticleTextureSamplerSampler, i.texcoord.xy);
    // mad r0, r0.w, v0.w, c0.x
    temp0 = temp0.w * i.color.w + float4(-0.1, -0.1, -0.1, -0.1);
    // texkill r0
    clip(temp0);
    // mov r0, t3.x
    temp0 = i.texcoord3.x;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// PSCreateShadowMap_Array_Shader_5 Pixel_2_0 Has PRES False
struct PSCreateShadowMap_Array_Shader_5_Input
{
    float2 texcoord : TEXCOORD;
    float3 color : COLOR;
    float texcoord3 : TEXCOORD3;
};

float4 PSCreateShadowMap_Array_Shader_5(PSCreateShadowMap_Array_Shader_5_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    // def c0, 1, 0.3, 0, 0
    // dcl t0.xy
    // dcl v0.xyz
    // dcl t3.x
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(ParticleTextureSamplerSampler, i.texcoord.xy);
    // mul r0.xyz, r0, v0
    temp0.xyz = temp0.xyz * i.color.xyz;
    // dp3 r0.x, r0, c0.x
    temp0.x = dot(temp0.xyz, float3(1, 1, 1));
    // add r0, -r0.x, c0.y
    temp0 = -temp0.x + float4(0.3, 0.3, 0.3, 0.3);
    // texkill r0
    clip(temp0);
    // mov r0, t3.x
    temp0 = i.texcoord3.x;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

PixelShader PSCreateShadowMap_Array[6] = {
    compile ps_2_0 PSCreateShadowMap_Array_Shader_0(), // 38
    compile ps_2_0 PSCreateShadowMap_Array_Shader_1(), // 39
    compile ps_2_0 PSCreateShadowMap_Array_Shader_2(), // 40
    compile ps_2_0 PSCreateShadowMap_Array_Shader_3(), // 41
    compile ps_2_0 PSCreateShadowMap_Array_Shader_4(), // 42
    compile ps_2_0 PSCreateShadowMap_Array_Shader_5(), // 43
};
// _CreateShadowMap_Expression10 Expression_2_0 Has PRES False
float _CreateShadowMap_Expression10()
{
    float1 expr0;
    // min c0.x, c8.x, (5)
    expr0.x = min(Draw.ShaderType.x, (5));
    return expr0;
}

// _CreateShadowMap_VertexShader11 Vertex_2_0 Has PRES True
struct _CreateShadowMap_VertexShader11_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 texcoord1 : TEXCOORD1;
};

struct _CreateShadowMap_VertexShader11_Output
{
    float4 position : POSITION;
    float texcoord3 : TEXCOORD3;
    float4 texcoord5 : TEXCOORD5;
    float4 texcoord6 : TEXCOORD6;
    float4 texcoord7 : TEXCOORD7;
    float2 texcoord : TEXCOORD;
    float3 texcoord4 : TEXCOORD4;
    float4 color : COLOR;
};

_CreateShadowMap_VertexShader11_Output _CreateShadowMap_VertexShader11(_CreateShadowMap_VertexShader11_Input i)
{
    /*
    PRSI
      OutputRegisterOffset: 56
      Unknown1: 0
      Unknown2: 0
      OutputRegisterCount: 5
      Unknown3: 0
      Unknown4: 0
      Unknown5: 56
      Unknown6: 1
      Mappings: 2
        0 - ConstOutput: 58 ConstInput 3
        1 - ConstOutput: 0 ConstInput 0
    
    */
    float4 expr56;
    float4 expr57;
    float4 expr58;
    float4 expr59;
    float4 expr60;
    {
        float4 temp0;
        float4 temp1;
        float4 temp2;
        // Expression_2_1
        // mul c56.x, c6.x, (30)
        expr56.x = Time.x * (30);
        // mul r0.x, c3.z, c4.y
        temp0.x = (View._m00_m10_m20_m30).z * (View._m01_m11_m21_m31).y;
        // mul r0.y, c3.x, c4.z
        temp0.y = (View._m00_m10_m20_m30).x * (View._m01_m11_m21_m31).z;
        // mul r0.z, c3.y, c4.x
        temp0.z = (View._m00_m10_m20_m30).y * (View._m01_m11_m21_m31).x;
        // neg r1.xyz, r0.xyz
        temp1.xyz = -temp0.xyz;
        // mul r0.x, c3.y, c4.z
        temp0.x = (View._m00_m10_m20_m30).y * (View._m01_m11_m21_m31).z;
        // mul r0.y, c3.z, c4.x
        temp0.y = (View._m00_m10_m20_m30).z * (View._m01_m11_m21_m31).x;
        // mul r0.z, c3.x, c4.y
        temp0.z = (View._m00_m10_m20_m30).x * (View._m01_m11_m21_m31).y;
        // add r2.xyz, r1.xyz, r0.xyz
        temp2.xyz = temp1.xyz + temp0.xyz;
        // dot r0.xyz, r2.xyz, c0.xyz
        temp0.xyz = dot(temp2.xyz, (World._m00_m10_m20_m30).xyz);
        // dot r0.yzw, r2.xyz, c1.xyz
        temp0.yzw = dot(temp2.xyz, (World._m01_m11_m21_m31).xyz);
        // dot r0.zwx, r2.xyz, c2.xyz
        temp0.zwx = dot(temp2.xyz, (World._m02_m12_m22_m32).xyz);
        // dot r1.xyz, r0.xyz, r0.xyz
        temp1.xyz = dot(temp0.xyz, temp0.xyz);
        // rsq r0.w, r1.x
        temp0.w = 1.0f / sqrt(temp1.x);
        // mul c58.xyz, r0.w, r0.xyz
        expr58.xyz = temp0.w * temp0.xyz;
        // rcp c59.x, c5.y
        expr59.x = 1.0f / (Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.y);
        // rcp c60.x, c5.x
        expr60.x = 1.0f / (Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.x);
    }

    _CreateShadowMap_VertexShader11_Output o;
    float4 temp0, temp1, addr0, temp2, temp3, temp4;
    // def c36, 2.0625, 8.9375, 6.1875, 1.375
    // def c38, 1, -1, 0.5, 0
    // def c28, 0.5, -0.5, 16, -1
    // def c30, -0.5, 0.5, 0.1591549, 0
    // def c31, 0, 0, 6.283185, -3.141593
    // def c37, 0.1875, 4.8125, 2.75, 0
    // def c29, 0.5, 0.5, 1.0001, 0.6931472
    // def c27, -0.5, -0.5, 0, 0.1875
    // def c11, 0.957897, 0.3788705, 0.3635719, 0.3287609
    // def c12, 0.1762373, 0.9145751, 0.4360935, 0.3476284
    // def c13, 0.743219, 0.4425611, 0.9974546, 0.3622138
    // def c14, 0.4896626, 0.6664233, 0.8305699, 0.9742577
    // def c15, 0.8947675, 0.8236215, 0.9309705, 0.05219847
    // def c16, 0.1411007, 0.6527002, 0.008452523, 0.6430574
    // def c17, 0.229799, 0.897999, 0.753822, 0.1316504
    // def c18, 0.5815384, 0.2836916, 0.09156471, 0.407481
    // def c19, 0.2706044, 0.7228181, 0.1694367, 0.1469052
    // def c20, 0.5995556, 0.0964533, 0.8763983, 0.1172229
    // def c21, 0.5101711, 0.9421572, 0.1957888, 0.9167565
    // def c22, 0.03546793, 0.5340094, 0.1673218, 0.5576764
    // def c23, 0.861564, 0.2251601, 0.082332, 0.8790039
    // def c24, 0.1730866, 0.8935188, 0.01392406, 0.1787381
    // def c25, 0.8269383, 0.7718143, 0.4395359, 0.493963
    // def c26, 0.5423613, 0.7218617, 0.7697314, 0.5878567
    // def c32, -0.25, -0.25, 0, 0
    // def c33, 0.25, -0.25, 0, 0
    // def c34, 0.25, 0.25, 0, 0
    // def c35, -0.25, 0.25, 0, 0
    // def c0, -1.550099E-06, -2.170139E-05, 0.002604167, 0.0002604167
    // def c1, -0.02083333, -0.125, 1, 0.5
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_texcoord1 v2
    // mov r0.w, c27.w
    temp0.w = float1(0.1875);
    // mad r0, v2.x, r0.w, c36
    temp0 = i.texcoord1.x * temp0.w + float4(2.0625, 8.9375, 6.1875, 1.375);
    // frc r0, r0
    temp0 = frac(temp0);
    // mul r0, r0, c28.z
    temp0 = temp0 * float4(16, 16, 16, 16);
    // frc r1, r0
    temp1 = frac(temp0);
    // add r0, r0, -r1
    temp0 = temp0 + -temp1;
    // mova a0, r0
    addr0 = temp0;
    // mov r0.xy, c67
    temp0.xy = Physics.VelocityDampingRange.xy;
    // mad r0.x, c11[a0.y].x, r0.y, r0.x
    temp0.x = float1(0.957897) * temp0.y + temp0.x;
    // add r0.y, r0.x, c28.w
    temp0.y = temp0.x + float1(-1);
    // mul r0.y, r0.y, r0.y
    temp0.y = temp0.y * temp0.y;
    // sge r0.y, -r0.y, r0.y
    temp0.y = (-temp0.y >= temp0.y) ? 1 : 0;
    // lrp r1.x, r0.y, c29.z, r0.x
    temp1.x = lerp(temp0.x, float1(1.0001), temp0.y);
    // log r0.x, r1.x
    temp0.x = log2(temp1.x);
    // mul r0.y, r0.x, c29.w
    temp0.y = temp0.x * float1(0.6931472);
    // rcp r0.y, r0.y
    temp0.y = 1.0f / temp0.y;
    // add r0.z, -v1.w, c56.x
    temp0.z = -i.texcoord.w + expr56.x;
    // mul r0.x, r0.x, r0.z
    temp0.x = temp0.x * temp0.z;
    // exp r0.x, r0.x
    temp0.x = exp2(temp0.x);
    // add r0.x, r0.x, c28.w
    temp0.x = temp0.x + float1(-1);
    // mul r0.x, r0.y, r0.x
    temp0.x = temp0.y * temp0.x;
    // mov r1.xyz, v0
    temp1.xyz = i.position.xyz;
    // mad r0.xyw, v1.xyzz, r0.x, r1.xyzz
    temp0.xyw = i.texcoord.xyz * temp0.xxx + temp1.xyz;
    // mul r1.x, r0.z, -c27.x
    temp1.x = temp0.z * float1(0.5);
    // mov r2.xyz, c65
    temp2.xyz = Physics.Gravity.xyz;
    // mad r1.xyz, r1.x, r2, c66
    temp1.xyz = temp1.xxx * temp2.xyz + Physics.DriftVelocity.xyz;
    // mad r0.xyw, r1.xyzz, r0.z, r0
    temp0.xyw = temp1.xyz * temp0.zzz + temp0.xyw;
    // add r1.xyz, r0.xyyw, -v0.xyyw
    temp1.xyz = temp0.xyy + -i.position.xyy;
    // mov r2.xyz, c11[a0.z]
    temp2.xyz = float3(0.957897, 0.37887052, 0.36357188);
    // mov r3.xyz, c53
    temp3.xyz = Update.XYRotation_Rate_Damping__Spread.xyz;
    // mad r2.xyz, r2, r3, c52
    temp2.xyz = temp2.xyz * temp3.xyz + Update.XYRotation_Rate_Damping__Min.xyz;
    // add r1.w, r2.z, c28.w
    temp1.w = temp2.z + float1(-1);
    // mul r1.w, r1.w, r1.w
    temp1.w = temp1.w * temp1.w;
    // sge r1.w, -r1.w, r1.w
    temp1.w = (-temp1.w >= temp1.w) ? 1 : 0;
    // lrp r3.x, r1.w, c29.z, r2.z
    temp3.x = lerp(temp2.z, float1(1.0001), temp1.w);
    // log r1.w, r3.x
    temp1.w = log2(temp3.x);
    // mul r2.z, r1.w, c29.w
    temp2.z = temp1.w * float1(0.6931472);
    // mul r1.w, r0.z, r1.w
    temp1.w = temp0.z * temp1.w;
    // rcp r2.z, r2.z
    temp2.z = 1.0f / temp2.z;
    // exp r1.w, r1.w
    temp1.w = exp2(temp1.w);
    // add r1.w, r1.w, c28.w
    temp1.w = temp1.w + float1(-1);
    // mul r1.w, r2.z, r1.w
    temp1.w = temp2.z * temp1.w;
    // mad r1.w, r2.y, r1.w, r2.x
    temp1.w = temp2.y * temp1.w + temp2.x;
    // mad r1.w, r1.w, c30.z, c30.y
    temp1.w = temp1.w * float1(0.15915494) + float1(0.5);
    // frc r1.w, r1.w
    temp1.w = frac(temp1.w);
    // mad r1.w, r1.w, c31.z, c31.w
    temp1.w = temp1.w * float1(6.2831855) + float1(-3.1415927);
    // sincos r2.xy, r1.w, c0, c1
    temp2.xy = float2(cos(temp1.w), sin(temp1.w));
    // mul r1.yzw, r1.xxyz, r2.xxyx
    temp1.yzw = temp1.xyz * temp2.xyx;
    // mad r1.w, r1.x, -r2.y, r1.w
    temp1.w = temp1.x * -temp2.y + temp1.w;
    // add r1.x, r1.z, r1.y
    temp1.x = temp1.z + temp1.y;
    // add r0.xy, r1.xwzw, v0
    temp0.xy = temp1.xw + i.position.xy;
    // mov r1.xyz, c11[a0.w]
    temp1.xyz = float3(0.957897, 0.37887052, 0.36357188);
    // mov r2.xyz, c55
    temp2.xyz = Update.ZRotation_Rate_Damping__Spread.xyz;
    // mad r1.xyz, r1, r2, c54
    temp1.xyz = temp1.xyz * temp2.xyz + Update.ZRotation_Rate_Damping__Min.xyz;
    // mov r2.xyz, c11[a0.x]
    temp2.xyz = float3(0.957897, 0.37887052, 0.36357188);
    // mov r3.xyz, c51
    temp3.xyz = Update.Size_Rate_Damping__Spread.xyz;
    // mad r2.xyz, r2, r3, c50
    temp2.xyz = temp2.xyz * temp3.xyz + Update.Size_Rate_Damping__Min.xyz;
    // add r1.w, r1.z, c28.w
    temp1.w = temp1.z + float1(-1);
    // mul r1.w, r1.w, r1.w
    temp1.w = temp1.w * temp1.w;
    // sge r1.w, -r1.w, r1.w
    temp1.w = (-temp1.w >= temp1.w) ? 1 : 0;
    // lrp r2.w, r1.w, c29.z, r1.z
    temp2.w = lerp(temp1.z, float1(1.0001), temp1.w);
    // log r1.z, r2.w
    temp1.z = log2(temp2.w);
    // mul r1.w, r1.z, c29.w
    temp1.w = temp1.z * float1(0.6931472);
    // mul r1.z, r0.z, r1.z
    temp1.z = temp0.z * temp1.z;
    // rcp r1.w, r1.w
    temp1.w = 1.0f / temp1.w;
    // exp r1.z, r1.z
    temp1.z = exp2(temp1.z);
    // add r1.z, r1.z, c28.w
    temp1.z = temp1.z + float1(-1);
    // mul r1.z, r1.w, r1.z
    temp1.z = temp1.w * temp1.z;
    // mad r1.x, r1.y, r1.z, r1.x
    temp1.x = temp1.y * temp1.z + temp1.x;
    // mad r1.x, r1.x, c30.z, c30.y
    temp1.x = temp1.x * float1(0.15915494) + float1(0.5);
    // frc r1.x, r1.x
    temp1.x = frac(temp1.x);
    // mad r1.x, r1.x, c31.z, c31.w
    temp1.x = temp1.x * float1(6.2831855) + float1(-3.1415927);
    // sincos r3.xy, r1.x, c0, c1
    temp3.xy = float2(cos(temp1.x), sin(temp1.x));
    // slt r1.x, v0.w, r0.z
    temp1.x = (i.position.w < temp0.z) ? 1 : 0;
    // mad r1.x, r1.x, -v2.y, v2.y
    temp1.x = temp1.x * -i.texcoord1.y + i.texcoord1.y;
    // frc r1.y, r1.x
    temp1.y = frac(temp1.x);
    // add r1.x, r1.x, -r1.y
    temp1.x = temp1.x + -temp1.y;
    // mova a0.x, r1.x
    addr0.x = temp1.x;
    // mul r1.xyz, r3.xyxw, c27[a0.x].xyyw
    temp1.xyz = temp3.xyx * float3(-0.5, -0.5, -0.5);
    // mad r1.z, c27[a0.x].x, -r3.y, r1.z
    temp1.z = float1(-0.5) * -temp3.y + temp1.z;
    // add r1.x, r1.y, r1.x
    temp1.x = temp1.y + temp1.x;
    // mov r4.xy, c27[a0.x]
    temp4.xy = float2(-0.5, -0.5);
    // mad r1.yw, r4.xxzy, c38.xxzy, c38.z
    temp1.yw = temp4.xy * float2(1, -1) + float2(0.5, 0.5);
    // mul r4.xyz, r1.z, c69
    temp4.xyz = temp1.zzz * (View._m01_m11_m21_m31).xyz;
    // mad r4.xyz, r1.x, c68, r4
    temp4.xyz = temp1.xxx * (View._m00_m10_m20_m30).xyz + temp4.xyz;
    // add r1.x, r2.z, c28.w
    temp1.x = temp2.z + float1(-1);
    // mul r1.x, r1.x, r1.x
    temp1.x = temp1.x * temp1.x;
    // sge r1.x, -r1.x, r1.x
    temp1.x = (-temp1.x >= temp1.x) ? 1 : 0;
    // lrp r3.z, r1.x, c29.z, r2.z
    temp3.z = lerp(temp2.z, float1(1.0001), temp1.x);
    // log r1.x, r3.z
    temp1.x = log2(temp3.z);
    // mul r1.z, r1.x, c29.w
    temp1.z = temp1.x * float1(0.6931472);
    // mul r1.x, r0.z, r1.x
    temp1.x = temp0.z * temp1.x;
    // rcp r1.z, r1.z
    temp1.z = 1.0f / temp1.z;
    // exp r1.x, r1.x
    temp1.x = exp2(temp1.x);
    // add r1.x, r1.x, c28.w
    temp1.x = temp1.x + float1(-1);
    // mul r1.x, r1.z, r1.x
    temp1.x = temp1.z * temp1.x;
    // mad r1.x, r2.y, r1.x, r2.x
    temp1.x = temp2.y * temp1.x + temp2.x;
    // mad r2.xyz, r1.x, r4, r0.xyww
    temp2.xyz = temp1.xxx * temp4.xyz + temp0.xyw;
    // mov r2.w, -c28.w
    temp2.w = float1(1);
    // dp4 oPos.x, r2, c61
    o.position.x = dot(temp2, (WorldViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r2, c62
    o.position.y = dot(temp2, (WorldViewProjection._m01_m11_m21_m31));
    // dp4 r0.y, r2, c64
    temp0.y = dot(temp2, (WorldViewProjection._m03_m13_m23_m33));
    // dp4 r0.x, r2, c63
    temp0.x = dot(temp2, (WorldViewProjection._m02_m12_m22_m32));
    // rcp r0.w, r0.y
    temp0.w = 1.0f / temp0.y;
    // mov oPos.zw, r0.xyxy
    o.position.zw = temp0.xy;
    // mul oT3.x, r0.x, r0.w
    o.texcoord3 = temp0.x * temp0.w;
    // mul r0.xyw, r3.y, c69.xyzz
    temp0.xyw = temp3.yyy * (View._m01_m11_m21_m31).xyz;
    // mad r0.xyw, -c68.xyzz, r3.x, r0
    temp0.xyw = -(View._m00_m10_m20_m30).xyz * temp3.xxx + temp0.xyw;
    // dp3 oT5.x, c6, r0.xyww
    o.texcoord5.x = dot(DirectionalLight[0].Direction.xyz, temp0.xyw);
    // mul r2.xyz, r3.x, c69
    temp2.xyz = temp3.xxx * (View._m01_m11_m21_m31).xyz;
    // mad r2.xyz, c68, r3.y, r2
    temp2.xyz = (View._m00_m10_m20_m30).xyz * temp3.yyy + temp2.xyz;
    // dp3 oT5.y, c6, r2
    o.texcoord5.y = dot(DirectionalLight[0].Direction.xyz, temp2.xyz);
    // mov r3.xyz, c6
    temp3.xyz = DirectionalLight[0].Direction.xyz;
    // dp3 oT5.z, r3, c58
    o.texcoord5.z = dot(temp3.xyz, expr58.xyz);
    // dp3 oT6.x, c8, r0.xyww
    o.texcoord6.x = dot(DirectionalLight[1].Direction.xyz, temp0.xyw);
    // dp3 oT7.x, c10, r0.xyww
    o.texcoord7.x = dot(DirectionalLight[2].Direction.xyz, temp0.xyw);
    // dp3 oT6.y, c8, r2
    o.texcoord6.y = dot(DirectionalLight[1].Direction.xyz, temp2.xyz);
    // dp3 oT7.y, c10, r2
    o.texcoord7.y = dot(DirectionalLight[2].Direction.xyz, temp2.xyz);
    // mov r2.xyz, c8
    temp2.xyz = DirectionalLight[1].Direction.xyz;
    // dp3 oT6.z, r2, c58
    o.texcoord6.z = dot(temp2.xyz, expr58.xyz);
    // mov r2.xyz, c10
    temp2.xyz = DirectionalLight[2].Direction.xyz;
    // dp3 oT7.z, r2, c58
    o.texcoord7.z = dot(temp2.xyz, expr58.xyz);
    // mad r0.xy, v2.x, c37.x, c37.yzzw
    temp0.xy = i.texcoord1.xx * float2(0.1875, 0.1875) + float2(4.8125, 2.75);
    // frc r0.xy, r0
    temp0.xy = frac(temp0.xy);
    // mul r0.xy, r0, c28.z
    temp0.xy = temp0.xy * float2(16, 16);
    // frc r1.xz, r0.xyyw
    temp1.xz = frac(temp0.xy);
    // add r0.xy, r0, -r1.xzzw
    temp0.xy = temp0.xy + -temp1.xz;
    // mova a0.xy, r0
    addr0.xy = temp0.xy;
    // mov r0.y, c39.y
    temp0.y = Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.y;
    // mul r0.x, r0.y, c11[a0.x].x
    temp0.x = temp0.y * float1(0.957897);
    // frc r0.x, r0.x
    temp0.x = frac(temp0.x);
    // mad r0.x, c11[a0.x].x, r0.y, -r0.x
    temp0.x = float1(0.957897) * temp0.y + -temp0.x;
    // mov r2.xy, c49
    temp2.xy = Draw.ColorScaleRange.xy;
    // mad r0.y, c11[a0.y].x, r2.y, r2.x
    temp0.y = float1(0.957897) * temp2.y + temp2.x;
    // mad r0.x, r0.z, c48.x, r0.x
    temp0.x = temp0.z * Draw.SpeedMultiplier.x + temp0.x;
    // mul r0.w, r0.x, c59.x
    temp0.w = temp0.x * expr59.x;
    // abs r1.x, r0.w
    temp1.x = abs(temp0.w);
    // sge r0.w, r0.w, -r0.w
    temp0.w = (temp0.w >= -temp0.w) ? 1 : 0;
    // frc r1.x, r1.x
    temp1.x = frac(temp1.x);
    // lrp r2.x, r0.w, r1.x, -r1.x
    temp2.x = lerp(-temp1.x, temp1.x, temp0.w);
    // mul r0.w, r2.x, c39.y
    temp0.w = temp2.x * Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.y;
    // mul r1.z, r0.w, c60.x
    temp1.z = temp0.w * expr60.x;
    // abs r0.w, r1.z
    temp0.w = abs(temp1.z);
    // frc r0.w, r0.w
    temp0.w = frac(temp0.w);
    // sge r2.x, r1.z, -r1.z
    temp2.x = (temp1.z >= -temp1.z) ? 1 : 0;
    // lrp r3.x, r2.x, r0.w, -r0.w
    temp3.x = lerp(-temp0.w, temp0.w, temp2.x);
    // mul r1.x, r3.x, c39.x
    temp1.x = temp3.x * Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.x;
    // frc r2.xy, r1.xzzw
    temp2.xy = frac(temp1.xz);
    // add r1.xz, r1, -r2.xyyw
    temp1.xz = temp1.xz + -temp2.xy;
    // add r1.xz, r1.yyww, r1
    temp1.xz = temp1.yw + temp1.xz;
    // mul oT0.xy, r1.xzzw, c60.x
    o.texcoord = temp1.xzzw * expr60.x;
    // add r0.w, r0.x, -c28.w
    temp0.w = temp0.x + float1(1);
    // frc oT4.z, r0.x
    o.texcoord4.z = frac(temp0.x);
    // mul r0.x, r0.w, c59.x
    temp0.x = temp0.w * expr59.x;
    // abs r0.w, r0.x
    temp0.w = abs(temp0.x);
    // sge r0.x, r0.x, -r0.x
    temp0.x = (temp0.x >= -temp0.x) ? 1 : 0;
    // frc r0.w, r0.w
    temp0.w = frac(temp0.w);
    // lrp r1.x, r0.x, r0.w, -r0.w
    temp1.x = lerp(-temp0.w, temp0.w, temp0.x);
    // mul r0.x, r1.x, c39.y
    temp0.x = temp1.x * Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.y;
    // mul r0.w, r0.x, c60.x
    temp0.w = temp0.x * expr60.x;
    // abs r1.x, r0.w
    temp1.x = abs(temp0.w);
    // frc r1.x, r1.x
    temp1.x = frac(temp1.x);
    // sge r1.z, r0.w, -r0.w
    temp1.z = (temp0.w >= -temp0.w) ? 1 : 0;
    // lrp r2.x, r1.z, r1.x, -r1.x
    temp2.x = lerp(-temp1.x, temp1.x, temp1.z);
    // mul r0.x, r2.x, c39.x
    temp0.x = temp2.x * Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.x;
    // frc r1.xz, r0.xyww
    temp1.xz = frac(temp0.xw);
    // add r0.xw, r0, -r1.xyzz
    temp0.xw = temp0.xw + -temp1.xz;
    // add r0.xw, r1.yyzw, r0
    temp0.xw = temp1.yw + temp0.xw;
    // mul oT4.xy, r0.xwzw, c60.x
    o.texcoord4.xy = temp0.xw * expr60.xx;
    // rcp r0.x, v0.w
    temp0.x = 1.0f / i.position.w;
    // mul r0.x, r0.z, r0.x
    temp0.x = temp0.z * temp0.x;
    // mov r1, c42
    temp1 = Draw.ColorAnimationFunctions[2];
    // mad r1, r1, r0.x, c43
    temp1 = temp1 * temp0.x + Draw.ColorAnimationFunctions[3];
    // mov r2, c44
    temp2 = Draw.ColorAnimationFunctions[4];
    // mad r2, r2, r0.x, c45
    temp2 = temp2 * temp0.x + Draw.ColorAnimationFunctions[5];
    // slt r0.zw, r0.x, c46.xyyz
    temp0.zw = (temp0.xx < Draw.TimeKeys.yz) ? 1 : 0;
    // mov r3, c40
    temp3 = Draw.ColorAnimationFunctions[0];
    // mad r3, r3, r0.x, c41
    temp3 = temp3 * temp0.x + Draw.ColorAnimationFunctions[1];
    // lrp r4, r0.w, r1, r2
    temp4 = lerp(temp2, temp1, temp0.w);
    // lrp r1, r0.z, r3, r4
    temp1 = lerp(temp4, temp3, temp0.z);
    // mul oD0, r0.y, r1
    o.color = temp0.y * temp1;
    // mov oT5.w, c27.z
    o.texcoord5.w = float1(0);
    // mov oT6.w, c27.z
    o.texcoord6.w = float1(0);
    // mov oT7.w, c27.z
    o.texcoord7.w = float1(0);
    // 

    return o;
}

// _Default_L_PixelShader12 Pixel_2_0 Has PRES False
struct _Default_L_PixelShader12_Input
{
    float2 texcoord : TEXCOORD;
    float4 color : COLOR;
};

float4 _Default_L_PixelShader12(_Default_L_PixelShader12_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    // dcl t0.xy
    // dcl v0
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(ParticleTextureSamplerSampler, i.texcoord.xy);
    // mul r0, r0, v0
    temp0 = temp0 * i.color;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// _Default_L_VertexShader13 Vertex_2_0 Has PRES True
struct _Default_L_VertexShader13_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 texcoord1 : TEXCOORD1;
};

struct _Default_L_VertexShader13_Output
{
    float4 position : POSITION;
    float2 texcoord : TEXCOORD;
    float4 color : COLOR;
};

_Default_L_VertexShader13_Output _Default_L_VertexShader13(_Default_L_VertexShader13_Input i)
{
    /*
    PRSI
      OutputRegisterOffset: 61
      Unknown1: 0
      Unknown2: 0
      OutputRegisterCount: 3
      Unknown3: 0
      Unknown4: 0
      Unknown5: 61
      Unknown6: 3
      Mappings: 1
        0 - ConstOutput: 0 ConstInput 0
    
    */
    float4 expr61;
    float4 expr62;
    float4 expr63;
    {
        // Expression_2_1
        // mul c61.x, c1.x, (30)
        expr61.x = Time.x * (30);
        // rcp c62.x, c0.y
        expr62.x = 1.0f / (Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.y);
        // rcp c63.x, c0.x
        expr63.x = 1.0f / (Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.x);
    }

    _Default_L_VertexShader13_Output o;
    float4 temp0, temp1, temp2, temp3, temp4;
    float2 addr0, temp5;
    // def c36, 0.1875, 2.0625, 6.1875, 0
    // def c27, -0.5, -0.5, 16, -1
    // def c37, 1, -1, 0.5, 0
    // def c29, 0.5, 0.5, 0.1591549, 0
    // def c30, -0.5, 0.5, 6.283185, -3.141593
    // def c28, 0.5, -0.5, 1.0001, 0.6931472
    // def c11, 0.957897, 0.3788705, 0.3635719, 0.3287609
    // def c12, 0.1762373, 0.9145751, 0.4360935, 0.3476284
    // def c13, 0.743219, 0.4425611, 0.9974546, 0.3622138
    // def c14, 0.4896626, 0.6664233, 0.8305699, 0.9742577
    // def c15, 0.8947675, 0.8236215, 0.9309705, 0.05219847
    // def c16, 0.1411007, 0.6527002, 0.008452523, 0.6430574
    // def c17, 0.229799, 0.897999, 0.753822, 0.1316504
    // def c18, 0.5815384, 0.2836916, 0.09156471, 0.407481
    // def c19, 0.2706044, 0.7228181, 0.1694367, 0.1469052
    // def c20, 0.5995556, 0.0964533, 0.8763983, 0.1172229
    // def c21, 0.5101711, 0.9421572, 0.1957888, 0.9167565
    // def c22, 0.03546793, 0.5340094, 0.1673218, 0.5576764
    // def c23, 0.861564, 0.2251601, 0.082332, 0.8790039
    // def c24, 0.1730866, 0.8935188, 0.01392406, 0.1787381
    // def c25, 0.8269383, 0.7718143, 0.4395359, 0.493963
    // def c26, 0.5423613, 0.7218617, 0.7697314, 0.5878567
    // def c31, 0, 0, 0, 0
    // def c32, -0.25, -0.25, 0, 0
    // def c33, 0.25, -0.25, 0, 0
    // def c34, 0.25, 0.25, 0, 0
    // def c35, -0.25, 0.25, 0, 0
    // def c0, -1.550099E-06, -2.170139E-05, 0.002604167, 0.0002604167
    // def c1, -0.02083333, -0.125, 1, 0.5
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_texcoord1 v2
    // mad r0.xy, v2.x, c36.x, c36.yzzw
    temp0.xy = i.texcoord1.xx * float2(0.1875, 0.1875) + float2(2.0625, 6.1875);
    // frc r0.xy, r0
    temp0.xy = frac(temp0.xy);
    // mul r0.xy, r0, c27.z
    temp0.xy = temp0.xy * float2(16, 16);
    // frc r0.zw, r0.xyxy
    temp0.zw = frac(temp0.xy);
    // add r0.xy, r0, -r0.zwzw
    temp0.xy = temp0.xy + -temp0.zw;
    // mova a0.xy, r0
    addr0.xy = temp0.xy;
    // mov r0.xyz, c49
    temp0.xyz = Update.Size_Rate_Damping__Spread.xyz;
    // mov r0.w, c60.y
    temp0.w = Physics.VelocityDampingRange.y;
    // mov r1.xyz, c48
    temp1.xyz = Update.Size_Rate_Damping__Min.xyz;
    // mov r1.w, c60.x
    temp1.w = Physics.VelocityDampingRange.x;
    // mad r0, c11[a0.x], r0, r1
    temp0 = float4(0.957897, 0.37887052, 0.36357188, 0.32876092) * temp0 + temp1;
    // add r1.xy, r0.zwzw, c27.w
    temp1.xy = temp0.zw + float2(-1, -1);
    // mul r1.xy, r1, r1
    temp1.xy = temp1.xy * temp1.xy;
    // sge r1.xy, -r1, r1
    temp1.xy = (-temp1.xy >= temp1.xy) ? 1 : 0;
    // lrp r2.xy, r1, c28.z, r0.zwzw
    temp2.xy = lerp(temp0.zw, float2(1.0001, 1.0001), temp1.xy);
    // log r0.z, r2.y
    temp0.z = log2(temp2.y);
    // log r0.w, r2.x
    temp0.w = log2(temp2.x);
    // mul r1.x, r0.z, c28.w
    temp1.x = temp0.z * float1(0.6931472);
    // rcp r1.x, r1.x
    temp1.x = 1.0f / temp1.x;
    // add r1.y, -v1.w, c61.x
    temp1.y = -i.texcoord.w + expr61.x;
    // mul r0.z, r0.z, r1.y
    temp0.z = temp0.z * temp1.y;
    // exp r0.z, r0.z
    temp0.z = exp2(temp0.z);
    // add r0.z, r0.z, c27.w
    temp0.z = temp0.z + float1(-1);
    // mul r0.z, r1.x, r0.z
    temp0.z = temp1.x * temp0.z;
    // mov r2.xyz, v0
    temp2.xyz = i.position.xyz;
    // mad r1.xzw, v1.xyyz, r0.z, r2.xyyz
    temp1.xzw = i.texcoord.xyz * temp0.zzz + temp2.xyz;
    // mul r0.z, r1.y, -c27.x
    temp0.z = temp1.y * float1(0.5);
    // mov r2.xyz, c58
    temp2.xyz = Physics.Gravity.xyz;
    // mad r2.xyz, r0.z, r2, c59
    temp2.xyz = temp0.zzz * temp2.xyz + Physics.DriftVelocity.xyz;
    // mad r1.xzw, r2.xyyz, r1.y, r1
    temp1.xzw = temp2.xyz * temp1.yyy + temp1.xzw;
    // add r2.xyz, r1.xzzw, -v0.xyyw
    temp2.xyz = temp1.xzz + -i.position.xyy;
    // mov r3.xy, c51
    temp3.xy = Update.XYRotation_Rate_Damping__Spread.xy;
    // mov r3.zw, c53.xyxy
    temp3.zw = Update.ZRotation_Rate_Damping__Spread.xy;
    // mov r4.xy, c50
    temp4.xy = Update.XYRotation_Rate_Damping__Min.xy;
    // mov r4.zw, c52.xyxy
    temp4.zw = Update.ZRotation_Rate_Damping__Min.xy;
    // mad r3, c11[a0.y], r3, r4
    temp3 = float4(0.957897, 0.37887052, 0.36357188, 0.32876092) * temp3 + temp4;
    // mad r3.xy, r3.ywzw, r1.y, r3.xzzw
    temp3.xy = temp3.yw * temp1.yy + temp3.xz;
    // mad r3.xy, r3, c29.z, c29.x
    temp3.xy = temp3.xy * float2(0.15915494, 0.15915494) + float2(0.5, 0.5);
    // frc r3.xy, r3
    temp3.xy = frac(temp3.xy);
    // mad r3.xy, r3, c30.z, c30.w
    temp3.xy = temp3.xy * float2(6.2831855, 6.2831855) + float2(-3.1415927, -3.1415927);
    // sincos r4.xy, r3.x, c0, c1
    temp4.xy = float2(cos(temp3.x), sin(temp3.x));
    // sincos r5.xy, r3.y, c0, c1
    temp5.xy = float2(cos(temp3.y), sin(temp3.y));
    // mul r2.yzw, r2.xxyz, r4.xxyx
    temp2.yzw = temp2.xyz * temp4.xyx;
    // mad r2.w, r2.x, -r4.y, r2.w
    temp2.w = temp2.x * -temp4.y + temp2.w;
    // add r2.x, r2.z, r2.y
    temp2.x = temp2.z + temp2.y;
    // add r1.xz, r2.xyww, v0.xyyw
    temp1.xz = temp2.xw + i.position.xy;
    // slt r0.z, v0.w, r1.y
    temp0.z = (i.position.w < temp1.y) ? 1 : 0;
    // mad r0.z, r0.z, -v2.y, v2.y
    temp0.z = temp0.z * -i.texcoord1.y + i.texcoord1.y;
    // frc r2.x, r0.z
    temp2.x = frac(temp0.z);
    // add r0.z, r0.z, -r2.x
    temp0.z = temp0.z + -temp2.x;
    // mova a0.x, r0.z
    addr0.x = temp0.z;
    // mul r2.xyz, r5.xyxw, c27[a0.x].xyyw
    temp2.xyz = temp5.xyx * float3(-0.5, -0.5, -0.5);
    // mad r0.z, c27[a0.x].x, -r5.y, r2.z
    temp0.z = float1(-0.5) * -temp5.y + temp2.z;
    // mov r3.xy, c27[a0.x]
    temp3.xy = float2(-0.5, -0.5);
    // mad r2.zw, r3.xyxy, c37.xyxy, c37.z
    temp2.zw = temp3.xy * float2(1, -1) + float2(0.5, 0.5);
    // add r2.x, r2.y, r2.x
    temp2.x = temp2.y + temp2.x;
    // mul r3.xyz, r0.z, c65
    temp3.xyz = temp0.zzz * (View._m01_m11_m21_m31).xyz;
    // mad r3.xyz, r2.x, c64, r3
    temp3.xyz = temp2.xxx * (View._m00_m10_m20_m30).xyz + temp3.xyz;
    // mul r0.z, r0.w, c28.w
    temp0.z = temp0.w * float1(0.6931472);
    // mul r0.w, r0.w, r1.y
    temp0.w = temp0.w * temp1.y;
    // rcp r0.z, r0.z
    temp0.z = 1.0f / temp0.z;
    // exp r0.w, r0.w
    temp0.w = exp2(temp0.w);
    // add r0.w, r0.w, c27.w
    temp0.w = temp0.w + float1(-1);
    // mul r0.z, r0.z, r0.w
    temp0.z = temp0.z * temp0.w;
    // mad r0.x, r0.y, r0.z, r0.x
    temp0.x = temp0.y * temp0.z + temp0.x;
    // mad r0.xyz, r0.x, r3, r1.xzww
    temp0.xyz = temp0.xxx * temp3.xyz + temp1.xzw;
    // mov r0.w, -c27.w
    temp0.w = float1(1);
    // dp4 oPos.x, r0, c54
    o.position.x = dot(temp0, (WorldViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c55
    o.position.y = dot(temp0, (WorldViewProjection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c56
    o.position.z = dot(temp0, (WorldViewProjection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c57
    o.position.w = dot(temp0, (WorldViewProjection._m03_m13_m23_m33));
    // mul r0.x, r1.y, c47.x
    temp0.x = temp1.y * Draw.SpeedMultiplier.x;
    // mul r0.x, r0.x, c62.x
    temp0.x = temp0.x * expr62.x;
    // abs r0.y, r0.x
    temp0.y = abs(temp0.x);
    // sge r0.x, r0.x, -r0.x
    temp0.x = (temp0.x >= -temp0.x) ? 1 : 0;
    // frc r0.y, r0.y
    temp0.y = frac(temp0.y);
    // lrp r1.x, r0.x, r0.y, -r0.y
    temp1.x = lerp(-temp0.y, temp0.y, temp0.x);
    // mul r0.x, r1.x, c38.y
    temp0.x = temp1.x * Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.y;
    // mul r0.y, r0.x, c63.x
    temp0.y = temp0.x * expr63.x;
    // abs r0.z, r0.y
    temp0.z = abs(temp0.y);
    // frc r0.z, r0.z
    temp0.z = frac(temp0.z);
    // sge r0.w, r0.y, -r0.y
    temp0.w = (temp0.y >= -temp0.y) ? 1 : 0;
    // lrp r1.x, r0.w, r0.z, -r0.z
    temp1.x = lerp(-temp0.z, temp0.z, temp0.w);
    // mul r0.x, r1.x, c38.x
    temp0.x = temp1.x * Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.x;
    // frc r0.zw, r0.xyxy
    temp0.zw = frac(temp0.xy);
    // add r0.xy, r0, -r0.zwzw
    temp0.xy = temp0.xy + -temp0.zw;
    // add r0.xy, r2.zwzw, r0
    temp0.xy = temp2.zw + temp0.xy;
    // mul oT0.xy, r0, c63.x
    o.texcoord = temp0 * expr63.x;
    // rcp r0.x, v0.w
    temp0.x = 1.0f / i.position.w;
    // mul r0.x, r1.y, r0.x
    temp0.x = temp1.y * temp0.x;
    // mov r1, c41
    temp1 = Draw.ColorAnimationFunctions[2];
    // mad r1, r1, r0.x, c42
    temp1 = temp1 * temp0.x + Draw.ColorAnimationFunctions[3];
    // mov r2, c43
    temp2 = Draw.ColorAnimationFunctions[4];
    // mad r2, r2, r0.x, c44
    temp2 = temp2 * temp0.x + Draw.ColorAnimationFunctions[5];
    // slt r0.yz, r0.x, c45
    temp0.yz = (temp0.xx < Draw.TimeKeys.yz) ? 1 : 0;
    // mov r3, c39
    temp3 = Draw.ColorAnimationFunctions[0];
    // mad r3, r3, r0.x, c40
    temp3 = temp3 * temp0.x + Draw.ColorAnimationFunctions[1];
    // lrp r4, r0.z, r1, r2
    temp4 = lerp(temp2, temp1, temp0.z);
    // add r1, r3, -r4
    temp1 = temp3 + -temp4;
    // mad oD0, r0.y, r1, r4
    o.color = temp0.y * temp1 + temp4;
    // 

    return o;
}

// Default_M_Expression14 Expression_2_0 Has PRES False
float Default_M_Expression14()
{
    float1 expr0;
    // mov c0.x, (0)
    expr0.x = (0);
    return expr0;
}

// Default_M_VertexShader15 Vertex_2_0 Has PRES True
struct Default_M_VertexShader15_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 texcoord1 : TEXCOORD1;
};

struct Default_M_VertexShader15_Output
{
    float4 position : POSITION;
    float texcoord3 : TEXCOORD3;
    float4 texcoord5 : TEXCOORD5;
    float4 texcoord6 : TEXCOORD6;
    float4 texcoord7 : TEXCOORD7;
    float2 texcoord : TEXCOORD;
    float3 texcoord4 : TEXCOORD4;
    float4 color : COLOR;
};

Default_M_VertexShader15_Output Default_M_VertexShader15(Default_M_VertexShader15_Input i)
{
    /*
    PRSI
      OutputRegisterOffset: 56
      Unknown1: 0
      Unknown2: 0
      OutputRegisterCount: 5
      Unknown3: 0
      Unknown4: 0
      Unknown5: 56
      Unknown6: 1
      Mappings: 2
        0 - ConstOutput: 58 ConstInput 3
        1 - ConstOutput: 0 ConstInput 0
    
    */
    float4 expr56;
    float4 expr57;
    float4 expr58;
    float4 expr59;
    float4 expr60;
    {
        float4 temp0;
        float4 temp1;
        float4 temp2;
        // Expression_2_1
        // mul c56.x, c6.x, (30)
        expr56.x = Time.x * (30);
        // mul r0.x, c3.z, c4.y
        temp0.x = (View._m00_m10_m20_m30).z * (View._m01_m11_m21_m31).y;
        // mul r0.y, c3.x, c4.z
        temp0.y = (View._m00_m10_m20_m30).x * (View._m01_m11_m21_m31).z;
        // mul r0.z, c3.y, c4.x
        temp0.z = (View._m00_m10_m20_m30).y * (View._m01_m11_m21_m31).x;
        // neg r1.xyz, r0.xyz
        temp1.xyz = -temp0.xyz;
        // mul r0.x, c3.y, c4.z
        temp0.x = (View._m00_m10_m20_m30).y * (View._m01_m11_m21_m31).z;
        // mul r0.y, c3.z, c4.x
        temp0.y = (View._m00_m10_m20_m30).z * (View._m01_m11_m21_m31).x;
        // mul r0.z, c3.x, c4.y
        temp0.z = (View._m00_m10_m20_m30).x * (View._m01_m11_m21_m31).y;
        // add r2.xyz, r1.xyz, r0.xyz
        temp2.xyz = temp1.xyz + temp0.xyz;
        // dot r0.xyz, r2.xyz, c0.xyz
        temp0.xyz = dot(temp2.xyz, (World._m00_m10_m20_m30).xyz);
        // dot r0.yzw, r2.xyz, c1.xyz
        temp0.yzw = dot(temp2.xyz, (World._m01_m11_m21_m31).xyz);
        // dot r0.zwx, r2.xyz, c2.xyz
        temp0.zwx = dot(temp2.xyz, (World._m02_m12_m22_m32).xyz);
        // dot r1.xyz, r0.xyz, r0.xyz
        temp1.xyz = dot(temp0.xyz, temp0.xyz);
        // rsq r0.w, r1.x
        temp0.w = 1.0f / sqrt(temp1.x);
        // mul c58.xyz, r0.w, r0.xyz
        expr58.xyz = temp0.w * temp0.xyz;
        // rcp c59.x, c5.y
        expr59.x = 1.0f / (Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.y);
        // rcp c60.x, c5.x
        expr60.x = 1.0f / (Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.x);
    }

    Default_M_VertexShader15_Output o;
    float4 temp0, temp1, addr0, temp2, temp3, temp4;
    // def c36, 2.0625, 8.9375, 6.1875, 1.375
    // def c38, 1, -1, 0.5, 0
    // def c28, 0.5, -0.5, 16, -1
    // def c30, -0.5, 0.5, 0.1591549, 0
    // def c31, 0, 0, 6.283185, -3.141593
    // def c37, 0.1875, 4.8125, 2.75, 0
    // def c29, 0.5, 0.5, 1.0001, 0.6931472
    // def c27, -0.5, -0.5, 0, 0.1875
    // def c11, 0.957897, 0.3788705, 0.3635719, 0.3287609
    // def c12, 0.1762373, 0.9145751, 0.4360935, 0.3476284
    // def c13, 0.743219, 0.4425611, 0.9974546, 0.3622138
    // def c14, 0.4896626, 0.6664233, 0.8305699, 0.9742577
    // def c15, 0.8947675, 0.8236215, 0.9309705, 0.05219847
    // def c16, 0.1411007, 0.6527002, 0.008452523, 0.6430574
    // def c17, 0.229799, 0.897999, 0.753822, 0.1316504
    // def c18, 0.5815384, 0.2836916, 0.09156471, 0.407481
    // def c19, 0.2706044, 0.7228181, 0.1694367, 0.1469052
    // def c20, 0.5995556, 0.0964533, 0.8763983, 0.1172229
    // def c21, 0.5101711, 0.9421572, 0.1957888, 0.9167565
    // def c22, 0.03546793, 0.5340094, 0.1673218, 0.5576764
    // def c23, 0.861564, 0.2251601, 0.082332, 0.8790039
    // def c24, 0.1730866, 0.8935188, 0.01392406, 0.1787381
    // def c25, 0.8269383, 0.7718143, 0.4395359, 0.493963
    // def c26, 0.5423613, 0.7218617, 0.7697314, 0.5878567
    // def c32, -0.25, -0.25, 0, 0
    // def c33, 0.25, -0.25, 0, 0
    // def c34, 0.25, 0.25, 0, 0
    // def c35, -0.25, 0.25, 0, 0
    // def c0, -1.550099E-06, -2.170139E-05, 0.002604167, 0.0002604167
    // def c1, -0.02083333, -0.125, 1, 0.5
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_texcoord1 v2
    // mov r0.w, c27.w
    temp0.w = float1(0.1875);
    // mad r0, v2.x, r0.w, c36
    temp0 = i.texcoord1.x * temp0.w + float4(2.0625, 8.9375, 6.1875, 1.375);
    // frc r0, r0
    temp0 = frac(temp0);
    // mul r0, r0, c28.z
    temp0 = temp0 * float4(16, 16, 16, 16);
    // frc r1, r0
    temp1 = frac(temp0);
    // add r0, r0, -r1
    temp0 = temp0 + -temp1;
    // mova a0, r0
    addr0 = temp0;
    // mov r0.xy, c67
    temp0.xy = Physics.VelocityDampingRange.xy;
    // mad r0.x, c11[a0.y].x, r0.y, r0.x
    temp0.x = float1(0.957897) * temp0.y + temp0.x;
    // add r0.y, r0.x, c28.w
    temp0.y = temp0.x + float1(-1);
    // mul r0.y, r0.y, r0.y
    temp0.y = temp0.y * temp0.y;
    // sge r0.y, -r0.y, r0.y
    temp0.y = (-temp0.y >= temp0.y) ? 1 : 0;
    // lrp r1.x, r0.y, c29.z, r0.x
    temp1.x = lerp(temp0.x, float1(1.0001), temp0.y);
    // log r0.x, r1.x
    temp0.x = log2(temp1.x);
    // mul r0.y, r0.x, c29.w
    temp0.y = temp0.x * float1(0.6931472);
    // rcp r0.y, r0.y
    temp0.y = 1.0f / temp0.y;
    // add r0.z, -v1.w, c56.x
    temp0.z = -i.texcoord.w + expr56.x;
    // mul r0.x, r0.x, r0.z
    temp0.x = temp0.x * temp0.z;
    // exp r0.x, r0.x
    temp0.x = exp2(temp0.x);
    // add r0.x, r0.x, c28.w
    temp0.x = temp0.x + float1(-1);
    // mul r0.x, r0.y, r0.x
    temp0.x = temp0.y * temp0.x;
    // mov r1.xyz, v0
    temp1.xyz = i.position.xyz;
    // mad r0.xyw, v1.xyzz, r0.x, r1.xyzz
    temp0.xyw = i.texcoord.xyz * temp0.xxx + temp1.xyz;
    // mul r1.x, r0.z, -c27.x
    temp1.x = temp0.z * float1(0.5);
    // mov r2.xyz, c65
    temp2.xyz = Physics.Gravity.xyz;
    // mad r1.xyz, r1.x, r2, c66
    temp1.xyz = temp1.xxx * temp2.xyz + Physics.DriftVelocity.xyz;
    // mad r0.xyw, r1.xyzz, r0.z, r0
    temp0.xyw = temp1.xyz * temp0.zzz + temp0.xyw;
    // add r1.xyz, r0.xyyw, -v0.xyyw
    temp1.xyz = temp0.xyy + -i.position.xyy;
    // mov r2.xyz, c11[a0.z]
    temp2.xyz = float3(0.957897, 0.37887052, 0.36357188);
    // mov r3.xyz, c53
    temp3.xyz = Update.XYRotation_Rate_Damping__Spread.xyz;
    // mad r2.xyz, r2, r3, c52
    temp2.xyz = temp2.xyz * temp3.xyz + Update.XYRotation_Rate_Damping__Min.xyz;
    // add r1.w, r2.z, c28.w
    temp1.w = temp2.z + float1(-1);
    // mul r1.w, r1.w, r1.w
    temp1.w = temp1.w * temp1.w;
    // sge r1.w, -r1.w, r1.w
    temp1.w = (-temp1.w >= temp1.w) ? 1 : 0;
    // lrp r3.x, r1.w, c29.z, r2.z
    temp3.x = lerp(temp2.z, float1(1.0001), temp1.w);
    // log r1.w, r3.x
    temp1.w = log2(temp3.x);
    // mul r2.z, r1.w, c29.w
    temp2.z = temp1.w * float1(0.6931472);
    // mul r1.w, r0.z, r1.w
    temp1.w = temp0.z * temp1.w;
    // rcp r2.z, r2.z
    temp2.z = 1.0f / temp2.z;
    // exp r1.w, r1.w
    temp1.w = exp2(temp1.w);
    // add r1.w, r1.w, c28.w
    temp1.w = temp1.w + float1(-1);
    // mul r1.w, r2.z, r1.w
    temp1.w = temp2.z * temp1.w;
    // mad r1.w, r2.y, r1.w, r2.x
    temp1.w = temp2.y * temp1.w + temp2.x;
    // mad r1.w, r1.w, c30.z, c30.y
    temp1.w = temp1.w * float1(0.15915494) + float1(0.5);
    // frc r1.w, r1.w
    temp1.w = frac(temp1.w);
    // mad r1.w, r1.w, c31.z, c31.w
    temp1.w = temp1.w * float1(6.2831855) + float1(-3.1415927);
    // sincos r2.xy, r1.w, c0, c1
    temp2.xy = float2(cos(temp1.w), sin(temp1.w));
    // mul r1.yzw, r1.xxyz, r2.xxyx
    temp1.yzw = temp1.xyz * temp2.xyx;
    // mad r1.w, r1.x, -r2.y, r1.w
    temp1.w = temp1.x * -temp2.y + temp1.w;
    // add r1.x, r1.z, r1.y
    temp1.x = temp1.z + temp1.y;
    // add r0.xy, r1.xwzw, v0
    temp0.xy = temp1.xw + i.position.xy;
    // mov r1.xyz, c11[a0.w]
    temp1.xyz = float3(0.957897, 0.37887052, 0.36357188);
    // mov r2.xyz, c55
    temp2.xyz = Update.ZRotation_Rate_Damping__Spread.xyz;
    // mad r1.xyz, r1, r2, c54
    temp1.xyz = temp1.xyz * temp2.xyz + Update.ZRotation_Rate_Damping__Min.xyz;
    // mov r2.xyz, c11[a0.x]
    temp2.xyz = float3(0.957897, 0.37887052, 0.36357188);
    // mov r3.xyz, c51
    temp3.xyz = Update.Size_Rate_Damping__Spread.xyz;
    // mad r2.xyz, r2, r3, c50
    temp2.xyz = temp2.xyz * temp3.xyz + Update.Size_Rate_Damping__Min.xyz;
    // add r1.w, r1.z, c28.w
    temp1.w = temp1.z + float1(-1);
    // mul r1.w, r1.w, r1.w
    temp1.w = temp1.w * temp1.w;
    // sge r1.w, -r1.w, r1.w
    temp1.w = (-temp1.w >= temp1.w) ? 1 : 0;
    // lrp r2.w, r1.w, c29.z, r1.z
    temp2.w = lerp(temp1.z, float1(1.0001), temp1.w);
    // log r1.z, r2.w
    temp1.z = log2(temp2.w);
    // mul r1.w, r1.z, c29.w
    temp1.w = temp1.z * float1(0.6931472);
    // mul r1.z, r0.z, r1.z
    temp1.z = temp0.z * temp1.z;
    // rcp r1.w, r1.w
    temp1.w = 1.0f / temp1.w;
    // exp r1.z, r1.z
    temp1.z = exp2(temp1.z);
    // add r1.z, r1.z, c28.w
    temp1.z = temp1.z + float1(-1);
    // mul r1.z, r1.w, r1.z
    temp1.z = temp1.w * temp1.z;
    // mad r1.x, r1.y, r1.z, r1.x
    temp1.x = temp1.y * temp1.z + temp1.x;
    // mad r1.x, r1.x, c30.z, c30.y
    temp1.x = temp1.x * float1(0.15915494) + float1(0.5);
    // frc r1.x, r1.x
    temp1.x = frac(temp1.x);
    // mad r1.x, r1.x, c31.z, c31.w
    temp1.x = temp1.x * float1(6.2831855) + float1(-3.1415927);
    // sincos r3.xy, r1.x, c0, c1
    temp3.xy = float2(cos(temp1.x), sin(temp1.x));
    // slt r1.x, v0.w, r0.z
    temp1.x = (i.position.w < temp0.z) ? 1 : 0;
    // mad r1.x, r1.x, -v2.y, v2.y
    temp1.x = temp1.x * -i.texcoord1.y + i.texcoord1.y;
    // frc r1.y, r1.x
    temp1.y = frac(temp1.x);
    // add r1.x, r1.x, -r1.y
    temp1.x = temp1.x + -temp1.y;
    // mova a0.x, r1.x
    addr0.x = temp1.x;
    // mul r1.xyz, r3.xyxw, c27[a0.x].xyyw
    temp1.xyz = temp3.xyx * float3(-0.5, -0.5, -0.5);
    // mad r1.z, c27[a0.x].x, -r3.y, r1.z
    temp1.z = float1(-0.5) * -temp3.y + temp1.z;
    // add r1.x, r1.y, r1.x
    temp1.x = temp1.y + temp1.x;
    // mov r4.xy, c27[a0.x]
    temp4.xy = float2(-0.5, -0.5);
    // mad r1.yw, r4.xxzy, c38.xxzy, c38.z
    temp1.yw = temp4.xy * float2(1, -1) + float2(0.5, 0.5);
    // mul r4.xyz, r1.z, c69
    temp4.xyz = temp1.zzz * (View._m01_m11_m21_m31).xyz;
    // mad r4.xyz, r1.x, c68, r4
    temp4.xyz = temp1.xxx * (View._m00_m10_m20_m30).xyz + temp4.xyz;
    // add r1.x, r2.z, c28.w
    temp1.x = temp2.z + float1(-1);
    // mul r1.x, r1.x, r1.x
    temp1.x = temp1.x * temp1.x;
    // sge r1.x, -r1.x, r1.x
    temp1.x = (-temp1.x >= temp1.x) ? 1 : 0;
    // lrp r3.z, r1.x, c29.z, r2.z
    temp3.z = lerp(temp2.z, float1(1.0001), temp1.x);
    // log r1.x, r3.z
    temp1.x = log2(temp3.z);
    // mul r1.z, r1.x, c29.w
    temp1.z = temp1.x * float1(0.6931472);
    // mul r1.x, r0.z, r1.x
    temp1.x = temp0.z * temp1.x;
    // rcp r1.z, r1.z
    temp1.z = 1.0f / temp1.z;
    // exp r1.x, r1.x
    temp1.x = exp2(temp1.x);
    // add r1.x, r1.x, c28.w
    temp1.x = temp1.x + float1(-1);
    // mul r1.x, r1.z, r1.x
    temp1.x = temp1.z * temp1.x;
    // mad r1.x, r2.y, r1.x, r2.x
    temp1.x = temp2.y * temp1.x + temp2.x;
    // mad r2.xyz, r1.x, r4, r0.xyww
    temp2.xyz = temp1.xxx * temp4.xyz + temp0.xyw;
    // mov r2.w, -c28.w
    temp2.w = float1(1);
    // dp4 oPos.x, r2, c61
    o.position.x = dot(temp2, (WorldViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r2, c62
    o.position.y = dot(temp2, (WorldViewProjection._m01_m11_m21_m31));
    // dp4 r0.y, r2, c64
    temp0.y = dot(temp2, (WorldViewProjection._m03_m13_m23_m33));
    // dp4 r0.x, r2, c63
    temp0.x = dot(temp2, (WorldViewProjection._m02_m12_m22_m32));
    // rcp r0.w, r0.y
    temp0.w = 1.0f / temp0.y;
    // mov oPos.zw, r0.xyxy
    o.position.zw = temp0.xy;
    // mul oT3.x, r0.x, r0.w
    o.texcoord3 = temp0.x * temp0.w;
    // mul r0.xyw, r3.y, c69.xyzz
    temp0.xyw = temp3.yyy * (View._m01_m11_m21_m31).xyz;
    // mad r0.xyw, -c68.xyzz, r3.x, r0
    temp0.xyw = -(View._m00_m10_m20_m30).xyz * temp3.xxx + temp0.xyw;
    // dp3 oT5.x, c6, r0.xyww
    o.texcoord5.x = dot(DirectionalLight[0].Direction.xyz, temp0.xyw);
    // mul r2.xyz, r3.x, c69
    temp2.xyz = temp3.xxx * (View._m01_m11_m21_m31).xyz;
    // mad r2.xyz, c68, r3.y, r2
    temp2.xyz = (View._m00_m10_m20_m30).xyz * temp3.yyy + temp2.xyz;
    // dp3 oT5.y, c6, r2
    o.texcoord5.y = dot(DirectionalLight[0].Direction.xyz, temp2.xyz);
    // mov r3.xyz, c6
    temp3.xyz = DirectionalLight[0].Direction.xyz;
    // dp3 oT5.z, r3, c58
    o.texcoord5.z = dot(temp3.xyz, expr58.xyz);
    // dp3 oT6.x, c8, r0.xyww
    o.texcoord6.x = dot(DirectionalLight[1].Direction.xyz, temp0.xyw);
    // dp3 oT7.x, c10, r0.xyww
    o.texcoord7.x = dot(DirectionalLight[2].Direction.xyz, temp0.xyw);
    // dp3 oT6.y, c8, r2
    o.texcoord6.y = dot(DirectionalLight[1].Direction.xyz, temp2.xyz);
    // dp3 oT7.y, c10, r2
    o.texcoord7.y = dot(DirectionalLight[2].Direction.xyz, temp2.xyz);
    // mov r2.xyz, c8
    temp2.xyz = DirectionalLight[1].Direction.xyz;
    // dp3 oT6.z, r2, c58
    o.texcoord6.z = dot(temp2.xyz, expr58.xyz);
    // mov r2.xyz, c10
    temp2.xyz = DirectionalLight[2].Direction.xyz;
    // dp3 oT7.z, r2, c58
    o.texcoord7.z = dot(temp2.xyz, expr58.xyz);
    // mad r0.xy, v2.x, c37.x, c37.yzzw
    temp0.xy = i.texcoord1.xx * float2(0.1875, 0.1875) + float2(4.8125, 2.75);
    // frc r0.xy, r0
    temp0.xy = frac(temp0.xy);
    // mul r0.xy, r0, c28.z
    temp0.xy = temp0.xy * float2(16, 16);
    // frc r1.xz, r0.xyyw
    temp1.xz = frac(temp0.xy);
    // add r0.xy, r0, -r1.xzzw
    temp0.xy = temp0.xy + -temp1.xz;
    // mova a0.xy, r0
    addr0.xy = temp0.xy;
    // mov r0.y, c39.y
    temp0.y = Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.y;
    // mul r0.x, r0.y, c11[a0.x].x
    temp0.x = temp0.y * float1(0.957897);
    // frc r0.x, r0.x
    temp0.x = frac(temp0.x);
    // mad r0.x, c11[a0.x].x, r0.y, -r0.x
    temp0.x = float1(0.957897) * temp0.y + -temp0.x;
    // mov r2.xy, c49
    temp2.xy = Draw.ColorScaleRange.xy;
    // mad r0.y, c11[a0.y].x, r2.y, r2.x
    temp0.y = float1(0.957897) * temp2.y + temp2.x;
    // mad r0.x, r0.z, c48.x, r0.x
    temp0.x = temp0.z * Draw.SpeedMultiplier.x + temp0.x;
    // mul r0.w, r0.x, c59.x
    temp0.w = temp0.x * expr59.x;
    // abs r1.x, r0.w
    temp1.x = abs(temp0.w);
    // sge r0.w, r0.w, -r0.w
    temp0.w = (temp0.w >= -temp0.w) ? 1 : 0;
    // frc r1.x, r1.x
    temp1.x = frac(temp1.x);
    // lrp r2.x, r0.w, r1.x, -r1.x
    temp2.x = lerp(-temp1.x, temp1.x, temp0.w);
    // mul r0.w, r2.x, c39.y
    temp0.w = temp2.x * Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.y;
    // mul r1.z, r0.w, c60.x
    temp1.z = temp0.w * expr60.x;
    // abs r0.w, r1.z
    temp0.w = abs(temp1.z);
    // frc r0.w, r0.w
    temp0.w = frac(temp0.w);
    // sge r2.x, r1.z, -r1.z
    temp2.x = (temp1.z >= -temp1.z) ? 1 : 0;
    // lrp r3.x, r2.x, r0.w, -r0.w
    temp3.x = lerp(-temp0.w, temp0.w, temp2.x);
    // mul r1.x, r3.x, c39.x
    temp1.x = temp3.x * Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.x;
    // frc r2.xy, r1.xzzw
    temp2.xy = frac(temp1.xz);
    // add r1.xz, r1, -r2.xyyw
    temp1.xz = temp1.xz + -temp2.xy;
    // add r1.xz, r1.yyww, r1
    temp1.xz = temp1.yw + temp1.xz;
    // mul oT0.xy, r1.xzzw, c60.x
    o.texcoord = temp1.xzzw * expr60.x;
    // add r0.w, r0.x, -c28.w
    temp0.w = temp0.x + float1(1);
    // frc oT4.z, r0.x
    o.texcoord4.z = frac(temp0.x);
    // mul r0.x, r0.w, c59.x
    temp0.x = temp0.w * expr59.x;
    // abs r0.w, r0.x
    temp0.w = abs(temp0.x);
    // sge r0.x, r0.x, -r0.x
    temp0.x = (temp0.x >= -temp0.x) ? 1 : 0;
    // frc r0.w, r0.w
    temp0.w = frac(temp0.w);
    // lrp r1.x, r0.x, r0.w, -r0.w
    temp1.x = lerp(-temp0.w, temp0.w, temp0.x);
    // mul r0.x, r1.x, c39.y
    temp0.x = temp1.x * Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.y;
    // mul r0.w, r0.x, c60.x
    temp0.w = temp0.x * expr60.x;
    // abs r1.x, r0.w
    temp1.x = abs(temp0.w);
    // frc r1.x, r1.x
    temp1.x = frac(temp1.x);
    // sge r1.z, r0.w, -r0.w
    temp1.z = (temp0.w >= -temp0.w) ? 1 : 0;
    // lrp r2.x, r1.z, r1.x, -r1.x
    temp2.x = lerp(-temp1.x, temp1.x, temp1.z);
    // mul r0.x, r2.x, c39.x
    temp0.x = temp2.x * Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.x;
    // frc r1.xz, r0.xyww
    temp1.xz = frac(temp0.xw);
    // add r0.xw, r0, -r1.xyzz
    temp0.xw = temp0.xw + -temp1.xz;
    // add r0.xw, r1.yyzw, r0
    temp0.xw = temp1.yw + temp0.xw;
    // mul oT4.xy, r0.xwzw, c60.x
    o.texcoord4.xy = temp0.xw * expr60.xx;
    // rcp r0.x, v0.w
    temp0.x = 1.0f / i.position.w;
    // mul r0.x, r0.z, r0.x
    temp0.x = temp0.z * temp0.x;
    // mov r1, c42
    temp1 = Draw.ColorAnimationFunctions[2];
    // mad r1, r1, r0.x, c43
    temp1 = temp1 * temp0.x + Draw.ColorAnimationFunctions[3];
    // mov r2, c44
    temp2 = Draw.ColorAnimationFunctions[4];
    // mad r2, r2, r0.x, c45
    temp2 = temp2 * temp0.x + Draw.ColorAnimationFunctions[5];
    // slt r0.zw, r0.x, c46.xyyz
    temp0.zw = (temp0.xx < Draw.TimeKeys.yz) ? 1 : 0;
    // mov r3, c40
    temp3 = Draw.ColorAnimationFunctions[0];
    // mad r3, r3, r0.x, c41
    temp3 = temp3 * temp0.x + Draw.ColorAnimationFunctions[1];
    // lrp r4, r0.w, r1, r2
    temp4 = lerp(temp2, temp1, temp0.w);
    // lrp r1, r0.z, r3, r4
    temp1 = lerp(temp4, temp3, temp0.z);
    // mul oD0, r0.y, r1
    o.color = temp0.y * temp1;
    // mov oT5.w, c27.z
    o.texcoord5.w = float1(0);
    // mov oT6.w, c27.z
    o.texcoord6.w = float1(0);
    // mov oT7.w, c27.z
    o.texcoord7.w = float1(0);
    // 

    return o;
}

technique Default_M
{
    pass P0 <string ExpressionEvaluator = "Particle";>
    {
        VertexShader = compile vs_2_0 Default_M_VertexShader15(); // 33
        PixelShader = PS_Array[Default_M_Expression14()]; // 34
        ZEnable = 1;
        ZFunc = 4;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 1;
        AlphaFunc = 7;
        AlphaRef = 96;
    }
}

technique _Default_L
{
    pass P0 <string ExpressionEvaluator = "Particle";>
    {
        VertexShader = compile vs_2_0 _Default_L_VertexShader13(); // 36
        PixelShader = compile ps_2_0 _Default_L_PixelShader12(); // 37
        ZEnable = 1;
        ZFunc = 4;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 1;
        AlphaFunc = 7;
        AlphaRef = 96;
    }
}

technique _CreateShadowMap
{
    pass P0 <string ExpressionEvaluator = "GPUParticle_CreateShadowMap";>
    {
        VertexShader = compile vs_2_0 _CreateShadowMap_VertexShader11(); // 45
        PixelShader = PSCreateShadowMap_Array[_CreateShadowMap_Expression10()]; // 46
        ZEnable = 1;
        ZFunc = 4;
        ZWriteEnable = 1;
        CullMode = 1;
        AlphaBlendEnable = 0;
        AlphaTestEnable = 0;
    }
}

