string DefaultParameterScopeBlock = "material"; // 1
float3 AmbientLightColor <bool unmanaged = 1;> = { 0.3, 0.3, 0.3 };
struct
{
    float3 Color;
    float3 Direction;
} DirectionalLight[3] : register(vs_2_0, c5) : register(vs_3_0, c5) <bool unmanaged = 1;> = { 1.625198, 1.512711, 1.097048, 0.62914, -0.34874, 0.69465, 0.5232916, 0.6654605, 0.7815244, -0.32877, 0.90329, 0.27563, 0.4420466, 0.4102767, 0.4420466, -0.80704, -0.58635, 0.06975 };
int NumPointLights <string SasBindAddress = "Sas.NumPointLights"; string UIWidget = "None";>;
struct {
    float3 Color;
    float3 Position;
    float2 Range_Inner_Outer;
} PointLight[3] <bool unmanaged = 1;>;
struct
{
    float4 WorldPositionMultiplier_XYZZ;
    float2 CurrentOffsetUV;
} Cloud : register(vs_2_0, c117) : register(vs_3_0, c117) <bool unmanaged = 1;>;
float3 NoCloudMultiplier <bool unmanaged = 1;> = { 1, 1, 1 };
float3 RecolorColorDummy <bool unmanaged = 1;>;
column_major float4x4 ShadowMapWorldToShadow : register(vs_2_0, c113) : register(vs_3_0, c113) <bool unmanaged = 1;>;
float OpacityOverride : register(vs_2_0, c1) : register(vs_3_0, c1) <bool unmanaged = 1;> = { 1 };
float3 TintColor : register(vs_2_0, c2) : register(vs_3_0, c2) <bool unmanaged = 1;> = { 1, 1, 1 };
float3 EyePosition : register(vs_2_0, c123) : register(vs_3_0, c123) <bool unmanaged = 1;>;
column_major float4x4 ViewProjection : register(vs_2_0, c119) : register(vs_3_0, c119) <bool unmanaged = 1;>;
float4 WorldBones[128] : register(vs_2_0, c128) : register(vs_3_0, c128) <bool unmanaged = 1;>;
bool HasShadow <string UIWidget = "None"; string SasBindAddress = "Sas.HasShadow";>;
texture ShadowMap <string UIWidget = "None"; string SasBindAddress = "Sas.Shadow[0].ShadowMap";>; // 6
sampler2D ShadowMapSampler <string Texture = "ShadowMap"; string UIWidget = "None"; string SasBindAddress = "Sas.Shadow[0].ShadowMap";> =
sampler_state
{
    Texture = <ShadowMap>; // 9
    MinFilter = 1;
    MagFilter = 1;
    MipFilter = 0;
    AddressU = 3;
    AddressV = 3;
};
float4 Shadowmap_Zero_Zero_OneOverMapSize_OneOverMapSize <string UIWidget = "None"; string SasBindAddress = "Sas.Shadow[0].Zero_Zero_OneOverMapSize_OneOverMapSize";>;
int _SasGlobal : SasGlobal <string UIWidget = "None"; int3 SasVersion = int3(1, 0, 0); int MaxLocalLights = 3; int MaxSupportedInstancingMode = 1;>;
int NumJointsPerVertex <string UIWidget = "None"; string SasBindAddress = "Sas.Skeleton.NumJointsPerVertex";>;
column_major float4x3 World : World : register(vs_2_0, c124) : register(vs_3_0, c124);
float Time : Time;
float3 ColorAmbient <string UIName = "Ambient Material Color"; string UIWidget = "Color";> = { 1, 1, 1 };
float3 ColorDiffuse : register(vs_2_0, c11) : register(vs_3_0, c11) <string UIName = "Diffuse Material Color"; string UIWidget = "Color";> = { 1, 1, 1 };
float3 ColorSpecular : register(vs_2_0, c12) : register(vs_3_0, c12) <string UIName = "Specular Material Color"; string UIWidget = "Color";>;
float Shininess : register(vs_2_0, c13) : register(vs_3_0, c13) <string UIName = "Specular Shininess"; string UIWidget = "Slider"; float UIMax = 100;> = { 1 };
float3 ColorEmissive <string UIName = "Emissive Material Color"; string UIWidget = "Color";>;
texture Texture_0 <string UIName = "Base Texture";>; // 28
sampler2D Texture_0Sampler <string Texture = "Texture_0"; string UIName = "Base Texture";> =
sampler_state
{
    Texture = <Texture_0>; // 30
    MinFilter = 3;
    MagFilter = 2;
    MipFilter = 2;
    AddressU = 1;
    AddressV = 1;
};
bool DepthWriteEnable <string UIName = "Depth Write Enable";> = { 1 };
bool AlphaTestEnable <string UIName = "Alpha Test Enable";>;
bool CullingEnable <string UIName = "Culling Enable";> = { 1 };
int BlendMode <string UIName = "Blend mode (0: opaque, 1: alpha, 2: additive)"; int UIMin = 0; int UIMax = 2;>;
struct
{
    float4 ScaleUV_OffsetUV;
} Shroud : register(vs_2_0, c14) : register(vs_3_0, c14) <string UIWidget = "None"; string SasBindAddress = "Terrain.Shroud";> = { 1, 1, 0, 0 };
texture ShroudTexture <string UIWidget = "None"; string SasBindAddress = "Terrain.Shroud.Texture";>; // 39
sampler2D ShroudTextureSampler : register(ps_3_0, s0) <string Texture = "ShroudTexture"; string UIWidget = "None"; string SasBindAddress = "Terrain.Shroud.Texture";> =
sampler_state
{
    Texture = <ShroudTexture>; // 42
    MinFilter = 2;
    MagFilter = 2;
    MipFilter = 2;
    AddressU = 3;
    AddressV = 3;
};
texture CloudTexture <string UIWidget = "None"; string SasBindAddress = "Terrain.Cloud.Texture"; string ResourceName = "ShaderPreviewCloud.dds";>; // 46
sampler2D CloudTextureSampler <string Texture = "CloudTexture"; string UIWidget = "None"; string SasBindAddress = "Terrain.Cloud.Texture"; string ResourceName = "ShaderPreviewCloud.dds";> =
sampler_state
{
    Texture = <CloudTexture>; // 50
    MinFilter = 2;
    MagFilter = 2;
    MipFilter = 2;
    AddressU = 1;
    AddressV = 1;
};
// VS_Array_Shader_0 Vertex_3_0 Has PRES False
struct VS_Array_Shader_0_Input
{
    float4 position : POSITION;
    float4 normal : NORMAL;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct VS_Array_Shader_0_Output
{
    float4 position : POSITION;
    float4 texcoord1 : TEXCOORD1;
    float4 color1 : COLOR1;
    float2 texcoord : TEXCOORD;
    float4 texcoord2 : TEXCOORD2;
    float4 texcoord3 : TEXCOORD3;
    float3 texcoord4 : TEXCOORD4;
    float3 texcoord5 : TEXCOORD5;
};

VS_Array_Shader_0_Output VS_Array_Shader_0(VS_Array_Shader_0_Input i)
{
    VS_Array_Shader_0_Output o;
    float4 temp0, temp1, temp2, temp3, temp4;
    float3 temp5, temp6;
    float addr0;
    // def c0, 1, 0, 0.5, 2
    // def c3, 2.5, 0, -0.0015, 0
    // def c4, 0, 1, 0.055, 0.045
    // defi i0, 2, 0, 0, 0
    // dcl_position v0
    // dcl_normal v1
    // dcl_texcoord v2
    // dcl_color v3
    // dcl_position o0
    // dcl_texcoord1 o1
    // dcl_color1 o2
    // dcl_texcoord o3.xy
    // dcl_texcoord2 o4
    // dcl_texcoord3 o5
    // dcl_texcoord4 o6.xyz
    // dcl_texcoord5 o7.xyz
    // mad r0, v0.xyzx, c0.xxxy, c0.yyyx
    temp0 = i.position.xyzx * float4(1, 1, 1, 0) + float4(0, 0, 0, 1);
    // dp4 r1.x, r0, c124
    temp1.x = dot(temp0, (World._m00_m10_m20_m30));
    // dp4 r1.y, r0, c125
    temp1.y = dot(temp0, (World._m01_m11_m21_m31));
    // dp4 r1.z, r0, c126
    temp1.z = dot(temp0, (World._m02_m12_m22_m32));
    // dp3 r0.x, v1, c124
    temp0.x = dot(i.normal.xyz, (World._m00_m10_m20_m30).xyz);
    // dp3 r0.y, v1, c125
    temp0.y = dot(i.normal.xyz, (World._m01_m11_m21_m31).xyz);
    // dp3 r0.z, v1, c126
    temp0.z = dot(i.normal.xyz, (World._m02_m12_m22_m32).xyz);
    // mul r2.xyz, c2, v3
    temp2.xyz = TintColor.xyz * i.color.xyz;
    // mov r1.w, c0.x
    temp1.w = float1(1);
    // dp4 o0.x, r1, c119
    o.position.x = dot(temp1, (ViewProjection._m00_m10_m20_m30));
    // dp4 o0.y, r1, c120
    o.position.y = dot(temp1, (ViewProjection._m01_m11_m21_m31));
    // dp4 o0.z, r1, c121
    o.position.z = dot(temp1, (ViewProjection._m02_m12_m22_m32));
    // dp4 o0.w, r1, c122
    o.position.w = dot(temp1, (ViewProjection._m03_m13_m23_m33));
    // add r3.xyz, -r1, c123
    temp3.xyz = -temp1.xyz + EyePosition.xyz;
    // dp3 r0.w, r3, r3
    temp0.w = dot(temp3.xyz, temp3.xyz);
    // rsq r0.w, r0.w
    temp0.w = 1 / sqrt(temp0.w);
    // mul r4.xyz, r3, r0.w
    temp4.xyz = temp3.xyz * temp0.www;
    // mad r5.xyz, r3, r0.w, c6
    temp5.xyz = temp3.xyz * temp0.www + DirectionalLight[0].Direction.xyz;
    // nrm r6.xyz, r5
    temp6.xyz = normalize(temp5.xyz).xyz;
    // dp3 r2.w, r0, c6
    temp2.w = dot(temp0.xyz, DirectionalLight[0].Direction.xyz);
    // dp3 r3.w, r0, r6
    temp3.w = dot(temp0.xyz, temp6.xyz);
    // slt r4.w, -r2.w, r2.w
    temp4.w = (-temp2.w < temp2.w) ? 1 : 0;
    // mul r2.w, r2.w, r4.w
    temp2.w = temp2.w * temp4.w;
    // slt r5.x, -r3.w, r3.w
    temp5.x = (-temp3.w < temp3.w) ? 1 : 0;
    // mul r4.w, r4.w, r5.x
    temp4.w = temp4.w * temp5.x;
    // pow r5.x, r3.w, c13.x
    temp5.x = pow(temp3.w, Shininess.x);
    // mul r3.w, r4.w, r5.x
    temp3.w = temp4.w * temp5.x;
    // mul r5.xyz, r2.w, c5
    temp5.xyz = temp2.www * DirectionalLight[0].Color.xyz;
    // mul r6.xyz, r3.w, c5
    temp6.xyz = temp3.www * DirectionalLight[0].Color.xyz;
    // mul r5.xyz, r5, c11
    temp5.xyz = temp5.xyz * ColorDiffuse.xyz;
    // mul r2.xyz, r2, r5
    temp2.xyz = temp2.xyz * temp5.xyz;
    // mul o6.xyz, r2, c0.z
    o.texcoord4 = temp2 * float4(0.5, 0.5, 0.5, 0.5);
    // mul r2.xyz, r6, c12
    temp2.xyz = temp6.xyz * ColorSpecular.xyz;
    // mul o7.xyz, r2, c0.z
    o.texcoord5 = temp2 * float4(0.5, 0.5, 0.5, 0.5);
    // mov r2, c0.yyyx
    temp2 = float4(0, 0, 0, 1);
    // rep i0
    for (int it0 = 0; it0 < int1(2); ++it0) {
        // add r3.w, r2.w, r2.w
        temp3.w = temp2.w + temp2.w;
        // mova a0.x, r3.w
        addr0.x = temp3.w;
        // mad r5.xyz, r3, r0.w, c6[a0.x]
        temp5.xyz = temp3.xyz * temp0.www + DirectionalLight[0 + (addr0.x / 2)].Direction.xyz;
        // nrm r6.xyz, r5
        temp6.xyz = normalize(temp5.xyz).xyz;
        // dp3 r3.w, r0, c6[a0.x]
        temp3.w = dot(temp0.xyz, DirectionalLight[0 + (addr0.x / 2)].Direction.xyz);
        // dp3 r4.w, r0, r6
        temp4.w = dot(temp0.xyz, temp6.xyz);
        // slt r3.w, -r3.w, r3.w
        temp3.w = (-temp3.w < temp3.w) ? 1 : 0;
        // slt r5.x, -r4.w, r4.w
        temp5.x = (-temp4.w < temp4.w) ? 1 : 0;
        // mul r3.w, r3.w, r5.x
        temp3.w = temp3.w * temp5.x;
        // pow r5.x, r4.w, c13.x
        temp5.x = pow(temp4.w, Shininess.x);
        // mul r3.w, r3.w, r5.x
        temp3.w = temp3.w * temp5.x;
        // mad r2.xyz, c5[a0.x], r3.w, r2
        temp2.xyz = DirectionalLight[0 + (addr0.x / 2)].Color.xyz * temp3.www + temp2.xyz;
        // add r2.w, r2.w, c0.x
        temp2.w = temp2.w + float1(1);
        // endrep
    }
    // mul o1.w, c1.x, v3.w
    o.texcoord1.w = OpacityOverride.x * i.color.w;
    // mul r2.xyz, r2, c12
    temp2.xyz = temp2.xyz * ColorSpecular.xyz;
    // mul o2.xyz, r2, c0.z
    o.color1.xyz = temp2.xyz * float3(0.5, 0.5, 0.5);
    // dp4 r2.x, r1, c113
    temp2.x = dot(temp1, (ShadowMapWorldToShadow._m00_m10_m20_m30));
    // dp4 r2.y, r1, c114
    temp2.y = dot(temp1, (ShadowMapWorldToShadow._m01_m11_m21_m31));
    // dp4 r2.z, r1, c115
    temp2.z = dot(temp1, (ShadowMapWorldToShadow._m02_m12_m22_m32));
    // dp4 r0.w, r1, c116
    temp0.w = dot(temp1, (ShadowMapWorldToShadow._m03_m13_m23_m33));
    // rcp r1.w, r0.w
    temp1.w = 1.0f / temp0.w;
    // mul r3.xy, r1.z, c117.zwzw
    temp3.xy = temp1.zz * Cloud.WorldPositionMultiplier_XYZZ.zw;
    // mad r3.xy, r1, c117, -r3
    temp3.xy = temp1.xy * Cloud.WorldPositionMultiplier_XYZZ.xy + -temp3.xy;
    // add o4.xy, r3, c118
    o.texcoord2.xy = temp3.xy + Cloud.CurrentOffsetUV.xy;
    // add r1.xy, r1.yxzw, c14.wzzw
    temp1.xy = temp1.yx + Shroud.ScaleUV_OffsetUV.wz;
    // mul o4.zw, r1.xyxy, c14.xyyx
    o.texcoord2.zw = temp1.xy * Shroud.ScaleUV_OffsetUV.yx;
    // dp3 r0.x, r4, r0
    temp0.x = dot(temp4.xyz, temp0.xyz);
    // add r0.x, -r0.x, c0.x
    temp0.x = -temp0.x + float1(1);
    // pow r1.x, r0.x, c3.x
    temp1.x = pow(temp0.x, float1(2.5));
    // mad r0.xyz, r1.x, c4.xyxw, c4.xzww
    temp0.xyz = temp1.xxx * float3(0, 1, 0) + float3(0, 0.055, 0.045);
    // min o1.xyz, r0, c0.w
    o.texcoord1.xyz = min(temp0.xyz, float3(2, 2, 2));
    // mov o2.w, c0.x
    o.color1.w = float1(1);
    // mov o3.xy, v2
    o.texcoord = i.texcoord;
    // mad o5.xyz, r2, r1.w, c3.yyzw
    o.texcoord3.xyz = temp2.xyz * temp1.www + float3(0, 0, -0.0015);
    // mov o5.w, r0.w
    o.texcoord3.w = temp0.w;
    // 

    return o;
}

// VS_Array_Shader_1 Vertex_3_0 Has PRES False
struct VS_Array_Shader_1_Input
{
    float4 blendindices : BLENDINDICES;
    float4 position : POSITION;
    float4 normal : NORMAL;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct VS_Array_Shader_1_Output
{
    float4 position : POSITION;
    float4 texcoord1 : TEXCOORD1;
    float4 color1 : COLOR1;
    float2 texcoord : TEXCOORD;
    float4 texcoord2 : TEXCOORD2;
    float4 texcoord3 : TEXCOORD3;
    float3 texcoord4 : TEXCOORD4;
    float3 texcoord5 : TEXCOORD5;
};

VS_Array_Shader_1_Output VS_Array_Shader_1(VS_Array_Shader_1_Input i)
{
    VS_Array_Shader_1_Output o;
    float4 temp0, temp1, temp2, temp3, temp4;
    float addr0;
    float3 temp5, temp6;
    // def c0, 1, -1, 0.5, 2
    // def c3, 0, 2.5, -0.0015, 0
    // def c4, 0, 1, 0.055, 0.045
    // defi i0, 2, 0, 0, 0
    // dcl_blendindices v0
    // dcl_position v1
    // dcl_normal v2
    // dcl_texcoord v3
    // dcl_color v4
    // dcl_position o0
    // dcl_texcoord1 o1
    // dcl_color1 o2
    // dcl_texcoord o3.xy
    // dcl_texcoord2 o4
    // dcl_texcoord3 o5
    // dcl_texcoord4 o6.xyz
    // dcl_texcoord5 o7.xyz
    // frc r0.x, v0.x
    temp0.x = frac(i.blendindices.x);
    // add r0.y, -r0.x, v0.x
    temp0.y = -temp0.x + i.blendindices.x;
    // slt r0.z, v0.x, -v0.x
    temp0.z = (i.blendindices.x < -i.blendindices.x) ? 1 : 0;
    // slt r0.x, -r0.x, r0.x
    temp0.x = (-temp0.x < temp0.x) ? 1 : 0;
    // mad r0.x, r0.z, r0.x, r0.y
    temp0.x = temp0.z * temp0.x + temp0.y;
    // add r0.x, r0.x, r0.x
    temp0.x = temp0.x + temp0.x;
    // mova a0.x, r0.x
    addr0.x = temp0.x;
    // mul r0, v1.zxyy, c128[a0.x].yzxy
    temp0 = i.position.zxyy * WorldBones[0 + addr0.x].yzxy;
    // mad r0, c128[a0.x].wwwx, v1.xyzx, r0
    temp0 = WorldBones[0 + addr0.x].wwwx * i.position.xyzx + temp0;
    // mul r1, v1.yzxz, c128[a0.x].zxyz
    temp1 = i.position.yzxz * WorldBones[0 + addr0.x].zxyz;
    // mad r0, r0, c0.xxxy, -r1
    temp0 = temp0 * float4(1, 1, 1, -1) + -temp1;
    // mul r1.xyz, r0.w, c128[a0.x]
    temp1.xyz = temp0.www * WorldBones[0 + addr0.x].xyz;
    // mad r1.xyz, c128[a0.x].w, r0, -r1
    temp1.xyz = WorldBones[0 + addr0.x].www * temp0.xyz + -temp1.xyz;
    // mad r1.xyz, c128[a0.x].yzxw, r0.zxyw, r1
    temp1.xyz = WorldBones[0 + addr0.x].yzx * temp0.zxy + temp1.xyz;
    // mad r0.xyz, c128[a0.x].zxyw, -r0.yzxw, r1
    temp0.xyz = WorldBones[0 + addr0.x].zxy * -temp0.yzx + temp1.xyz;
    // add r0.xyz, r0, c129[a0.x]
    temp0.xyz = temp0.xyz + WorldBones[1 + addr0.x].xyz;
    // mul r1, v2.zxyy, c128[a0.x].yzxy
    temp1 = i.normal.zxyy * WorldBones[0 + addr0.x].yzxy;
    // mad r1, c128[a0.x].wwwx, v2.xyzx, r1
    temp1 = WorldBones[0 + addr0.x].wwwx * i.normal.xyzx + temp1;
    // mul r2, v2.yzxz, c128[a0.x].zxyz
    temp2 = i.normal.yzxz * WorldBones[0 + addr0.x].zxyz;
    // mad r1, r1, c0.xxxy, -r2
    temp1 = temp1 * float4(1, 1, 1, -1) + -temp2;
    // mul r2.xyz, r1.w, c128[a0.x]
    temp2.xyz = temp1.www * WorldBones[0 + addr0.x].xyz;
    // mad r2.xyz, c128[a0.x].w, r1, -r2
    temp2.xyz = WorldBones[0 + addr0.x].www * temp1.xyz + -temp2.xyz;
    // mad r2.xyz, c128[a0.x].yzxw, r1.zxyw, r2
    temp2.xyz = WorldBones[0 + addr0.x].yzx * temp1.zxy + temp2.xyz;
    // mad r1.xyz, c128[a0.x].zxyw, -r1.yzxw, r2
    temp1.xyz = WorldBones[0 + addr0.x].zxy * -temp1.yzx + temp2.xyz;
    // mul r1.w, v4.w, c129[a0.x].w
    temp1.w = i.color.w * WorldBones[1 + addr0.x].w;
    // mul r2.xyz, c2, v4
    temp2.xyz = TintColor.xyz * i.color.xyz;
    // mov r0.w, c0.x
    temp0.w = float1(1);
    // dp4 o0.x, r0, c119
    o.position.x = dot(temp0, (ViewProjection._m00_m10_m20_m30));
    // dp4 o0.y, r0, c120
    o.position.y = dot(temp0, (ViewProjection._m01_m11_m21_m31));
    // dp4 o0.z, r0, c121
    o.position.z = dot(temp0, (ViewProjection._m02_m12_m22_m32));
    // dp4 o0.w, r0, c122
    o.position.w = dot(temp0, (ViewProjection._m03_m13_m23_m33));
    // add r3.xyz, -r0, c123
    temp3.xyz = -temp0.xyz + EyePosition.xyz;
    // dp3 r2.w, r3, r3
    temp2.w = dot(temp3.xyz, temp3.xyz);
    // rsq r2.w, r2.w
    temp2.w = 1 / sqrt(temp2.w);
    // mul r4.xyz, r3, r2.w
    temp4.xyz = temp3.xyz * temp2.www;
    // mad r5.xyz, r3, r2.w, c6
    temp5.xyz = temp3.xyz * temp2.www + DirectionalLight[0].Direction.xyz;
    // nrm r6.xyz, r5
    temp6.xyz = normalize(temp5.xyz).xyz;
    // dp3 r3.w, r1, c6
    temp3.w = dot(temp1.xyz, DirectionalLight[0].Direction.xyz);
    // dp3 r4.w, r1, r6
    temp4.w = dot(temp1.xyz, temp6.xyz);
    // slt r5.x, -r3.w, r3.w
    temp5.x = (-temp3.w < temp3.w) ? 1 : 0;
    // mul r3.w, r3.w, r5.x
    temp3.w = temp3.w * temp5.x;
    // slt r5.y, -r4.w, r4.w
    temp5.y = (-temp4.w < temp4.w) ? 1 : 0;
    // mul r5.x, r5.x, r5.y
    temp5.x = temp5.x * temp5.y;
    // pow r5.y, r4.w, c13.x
    temp5.y = pow(temp4.w, Shininess.x);
    // mul r4.w, r5.x, r5.y
    temp4.w = temp5.x * temp5.y;
    // mul r5.xyz, r3.w, c5
    temp5.xyz = temp3.www * DirectionalLight[0].Color.xyz;
    // mul r6.xyz, r4.w, c5
    temp6.xyz = temp4.www * DirectionalLight[0].Color.xyz;
    // mul r5.xyz, r5, c11
    temp5.xyz = temp5.xyz * ColorDiffuse.xyz;
    // mul r2.xyz, r2, r5
    temp2.xyz = temp2.xyz * temp5.xyz;
    // mul o6.xyz, r2, c0.z
    o.texcoord4 = temp2 * float4(0.5, 0.5, 0.5, 0.5);
    // mul r2.xyz, r6, c12
    temp2.xyz = temp6.xyz * ColorSpecular.xyz;
    // mul o7.xyz, r2, c0.z
    o.texcoord5 = temp2 * float4(0.5, 0.5, 0.5, 0.5);
    // mov r2.xyz, c3.x
    temp2.xyz = float3(0, 0, 0);
    // mov r3.w, c0.x
    temp3.w = float1(1);
    // rep i0
    for (int it0 = 0; it0 < int1(2); ++it0) {
        // add r4.w, r3.w, r3.w
        temp4.w = temp3.w + temp3.w;
        // mova a0.x, r4.w
        addr0.x = temp4.w;
        // mad r5.xyz, r3, r2.w, c6[a0.x]
        temp5.xyz = temp3.xyz * temp2.www + DirectionalLight[0 + (addr0.x / 2)].Direction.xyz;
        // nrm r6.xyz, r5
        temp6.xyz = normalize(temp5.xyz).xyz;
        // dp3 r4.w, r1, c6[a0.x]
        temp4.w = dot(temp1.xyz, DirectionalLight[0 + (addr0.x / 2)].Direction.xyz);
        // dp3 r5.x, r1, r6
        temp5.x = dot(temp1.xyz, temp6.xyz);
        // slt r4.w, -r4.w, r4.w
        temp4.w = (-temp4.w < temp4.w) ? 1 : 0;
        // slt r5.y, -r5.x, r5.x
        temp5.y = (-temp5.x < temp5.x) ? 1 : 0;
        // mul r4.w, r4.w, r5.y
        temp4.w = temp4.w * temp5.y;
        // pow r6.x, r5.x, c13.x
        temp6.x = pow(temp5.x, Shininess.x);
        // mul r4.w, r4.w, r6.x
        temp4.w = temp4.w * temp6.x;
        // mad r2.xyz, c5[a0.x], r4.w, r2
        temp2.xyz = DirectionalLight[0 + (addr0.x / 2)].Color.xyz * temp4.www + temp2.xyz;
        // add r3.w, r3.w, c0.x
        temp3.w = temp3.w + float1(1);
        // endrep
    }
    // mul o1.w, r1.w, c1.x
    o.texcoord1.w = temp1.w * OpacityOverride.x;
    // mul r2.xyz, r2, c12
    temp2.xyz = temp2.xyz * ColorSpecular.xyz;
    // mul o2.xyz, r2, c0.z
    o.color1.xyz = temp2.xyz * float3(0.5, 0.5, 0.5);
    // dp4 r2.x, r0, c113
    temp2.x = dot(temp0, (ShadowMapWorldToShadow._m00_m10_m20_m30));
    // dp4 r2.y, r0, c114
    temp2.y = dot(temp0, (ShadowMapWorldToShadow._m01_m11_m21_m31));
    // dp4 r2.z, r0, c115
    temp2.z = dot(temp0, (ShadowMapWorldToShadow._m02_m12_m22_m32));
    // dp4 r0.w, r0, c116
    temp0.w = dot(temp0, (ShadowMapWorldToShadow._m03_m13_m23_m33));
    // rcp r1.w, r0.w
    temp1.w = 1.0f / temp0.w;
    // mul r3.xy, r0.z, c117.zwzw
    temp3.xy = temp0.zz * Cloud.WorldPositionMultiplier_XYZZ.zw;
    // mad r3.xy, r0, c117, -r3
    temp3.xy = temp0.xy * Cloud.WorldPositionMultiplier_XYZZ.xy + -temp3.xy;
    // add o4.xy, r3, c118
    o.texcoord2.xy = temp3.xy + Cloud.CurrentOffsetUV.xy;
    // add r0.xy, r0.yxzw, c14.wzzw
    temp0.xy = temp0.yx + Shroud.ScaleUV_OffsetUV.wz;
    // mul o4.zw, r0.xyxy, c14.xyyx
    o.texcoord2.zw = temp0.xy * Shroud.ScaleUV_OffsetUV.yx;
    // dp3 r0.x, r4, r1
    temp0.x = dot(temp4.xyz, temp1.xyz);
    // add r0.x, -r0.x, c0.x
    temp0.x = -temp0.x + float1(1);
    // pow r1.x, r0.x, c3.y
    temp1.x = pow(temp0.x, float1(2.5));
    // mad r0.xyz, r1.x, c4.xyxw, c4.xzww
    temp0.xyz = temp1.xxx * float3(0, 1, 0) + float3(0, 0.055, 0.045);
    // min o1.xyz, r0, c0.w
    o.texcoord1.xyz = min(temp0.xyz, float3(2, 2, 2));
    // mov o2.w, c0.x
    o.color1.w = float1(1);
    // mov o3.xy, v3
    o.texcoord = i.texcoord;
    // mad o5.xyz, r2, r1.w, c3.xxzw
    o.texcoord3.xyz = temp2.xyz * temp1.www + float3(0, 0, -0.0015);
    // mov o5.w, r0.w
    o.texcoord3.w = temp0.w;
    // 

    return o;
}

// VS_Array_Shader_2 Vertex_3_0 Has PRES False
struct VS_Array_Shader_2_Input
{
    float4 blendindices : BLENDINDICES;
    float4 blendweight : BLENDWEIGHT;
    float4 position : POSITION;
    float4 position1 : POSITION1;
    float4 normal : NORMAL;
    float4 normal1 : NORMAL1;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct VS_Array_Shader_2_Output
{
    float4 position : POSITION;
    float4 texcoord1 : TEXCOORD1;
    float4 color1 : COLOR1;
    float2 texcoord : TEXCOORD;
    float4 texcoord2 : TEXCOORD2;
    float4 texcoord3 : TEXCOORD3;
    float3 texcoord4 : TEXCOORD4;
    float3 texcoord5 : TEXCOORD5;
};

VS_Array_Shader_2_Output VS_Array_Shader_2(VS_Array_Shader_2_Input i)
{
    VS_Array_Shader_2_Output o;
    float4 temp0, temp1, temp2, temp3, temp4;
    float2 addr0;
    float3 temp5, temp6;
    // def c0, 1, -1, 0.5, 2
    // def c3, 0, 2.5, -0.0015, 0
    // def c4, 0, 1, 0.055, 0.045
    // defi i0, 2, 0, 0, 0
    // dcl_blendindices v0
    // dcl_blendweight v1
    // dcl_position v2
    // dcl_position1 v3
    // dcl_normal v4
    // dcl_normal1 v5
    // dcl_texcoord v6
    // dcl_color v7
    // dcl_position o0
    // dcl_texcoord1 o1
    // dcl_color1 o2
    // dcl_texcoord o3.xy
    // dcl_texcoord2 o4
    // dcl_texcoord3 o5
    // dcl_texcoord4 o6.xyz
    // dcl_texcoord5 o7.xyz
    // frc r0.xy, v0
    temp0.xy = frac(i.blendindices.xy);
    // add r0.zw, -r0.xyxy, v0.xyxy
    temp0.zw = -temp0.xy + i.blendindices.xy;
    // slt r1.xy, v0, -v0
    temp1.xy = (i.blendindices.xy < -i.blendindices.xy) ? 1 : 0;
    // slt r0.xy, -r0, r0
    temp0.xy = (-temp0.xy < temp0.xy) ? 1 : 0;
    // mad r0.xy, r1, r0, r0.zwzw
    temp0.xy = temp1.xy * temp0.xy + temp0.zw;
    // add r0.xy, r0, r0
    temp0.xy = temp0.xy + temp0.xy;
    // mova a0.xy, r0
    addr0.xy = temp0.xy;
    // mul r0, v2.zxyy, c128[a0.x].yzxy
    temp0 = i.position.zxyy * WorldBones[0 + addr0.x].yzxy;
    // mad r0, c128[a0.x].wwwx, v2.xyzx, r0
    temp0 = WorldBones[0 + addr0.x].wwwx * i.position.xyzx + temp0;
    // mul r1, v2.yzxz, c128[a0.x].zxyz
    temp1 = i.position.yzxz * WorldBones[0 + addr0.x].zxyz;
    // mad r0, r0, c0.xxxy, -r1
    temp0 = temp0 * float4(1, 1, 1, -1) + -temp1;
    // mul r1.xyz, r0.w, c128[a0.x]
    temp1.xyz = temp0.www * WorldBones[0 + addr0.x].xyz;
    // mad r1.xyz, c128[a0.x].w, r0, -r1
    temp1.xyz = WorldBones[0 + addr0.x].www * temp0.xyz + -temp1.xyz;
    // mad r1.xyz, c128[a0.x].yzxw, r0.zxyw, r1
    temp1.xyz = WorldBones[0 + addr0.x].yzx * temp0.zxy + temp1.xyz;
    // mad r0.xyz, c128[a0.x].zxyw, -r0.yzxw, r1
    temp0.xyz = WorldBones[0 + addr0.x].zxy * -temp0.yzx + temp1.xyz;
    // add r0.xyz, r0, c129[a0.x]
    temp0.xyz = temp0.xyz + WorldBones[1 + addr0.x].xyz;
    // mul r1, v4.zxyy, c128[a0.x].yzxy
    temp1 = i.normal.zxyy * WorldBones[0 + addr0.x].yzxy;
    // mad r1, c128[a0.x].wwwx, v4.xyzx, r1
    temp1 = WorldBones[0 + addr0.x].wwwx * i.normal.xyzx + temp1;
    // mul r2, v4.yzxz, c128[a0.x].zxyz
    temp2 = i.normal.yzxz * WorldBones[0 + addr0.x].zxyz;
    // mad r1, r1, c0.xxxy, -r2
    temp1 = temp1 * float4(1, 1, 1, -1) + -temp2;
    // mul r2.xyz, r1.w, c128[a0.x]
    temp2.xyz = temp1.www * WorldBones[0 + addr0.x].xyz;
    // mad r2.xyz, c128[a0.x].w, r1, -r2
    temp2.xyz = WorldBones[0 + addr0.x].www * temp1.xyz + -temp2.xyz;
    // mad r2.xyz, c128[a0.x].yzxw, r1.zxyw, r2
    temp2.xyz = WorldBones[0 + addr0.x].yzx * temp1.zxy + temp2.xyz;
    // mad r1.xyz, c128[a0.x].zxyw, -r1.yzxw, r2
    temp1.xyz = WorldBones[0 + addr0.x].zxy * -temp1.yzx + temp2.xyz;
    // mul r2, v3.zxyy, c128[a0.y].yzxy
    temp2 = i.position1.zxyy * WorldBones[0 + addr0.y].yzxy;
    // mad r2, c128[a0.y].wwwx, v3.xyzx, r2
    temp2 = WorldBones[0 + addr0.y].wwwx * i.position1.xyzx + temp2;
    // mul r3, v3.yzxz, c128[a0.y].zxyz
    temp3 = i.position1.yzxz * WorldBones[0 + addr0.y].zxyz;
    // mad r2, r2, c0.xxxy, -r3
    temp2 = temp2 * float4(1, 1, 1, -1) + -temp3;
    // mul r3.xyz, r2.w, c128[a0.y]
    temp3.xyz = temp2.www * WorldBones[0 + addr0.y].xyz;
    // mad r3.xyz, c128[a0.y].w, r2, -r3
    temp3.xyz = WorldBones[0 + addr0.y].www * temp2.xyz + -temp3.xyz;
    // mad r3.xyz, c128[a0.y].yzxw, r2.zxyw, r3
    temp3.xyz = WorldBones[0 + addr0.y].yzx * temp2.zxy + temp3.xyz;
    // mad r2.xyz, c128[a0.y].zxyw, -r2.yzxw, r3
    temp2.xyz = WorldBones[0 + addr0.y].zxy * -temp2.yzx + temp3.xyz;
    // add r2.xyz, r2, c129[a0.y]
    temp2.xyz = temp2.xyz + WorldBones[1 + addr0.y].xyz;
    // mul r2.xyz, r2, v1.y
    temp2.xyz = temp2.xyz * i.blendweight.yyy;
    // mad r0.xyz, r0, v1.x, r2
    temp0.xyz = temp0.xyz * i.blendweight.xxx + temp2.xyz;
    // mul r2, v5.zxyy, c128[a0.y].yzxy
    temp2 = i.normal1.zxyy * WorldBones[0 + addr0.y].yzxy;
    // mad r2, c128[a0.y].wwwx, v5.xyzx, r2
    temp2 = WorldBones[0 + addr0.y].wwwx * i.normal1.xyzx + temp2;
    // mul r3, v5.yzxz, c128[a0.y].zxyz
    temp3 = i.normal1.yzxz * WorldBones[0 + addr0.y].zxyz;
    // mad r2, r2, c0.xxxy, -r3
    temp2 = temp2 * float4(1, 1, 1, -1) + -temp3;
    // mul r3.xyz, r2.w, c128[a0.y]
    temp3.xyz = temp2.www * WorldBones[0 + addr0.y].xyz;
    // mad r3.xyz, c128[a0.y].w, r2, -r3
    temp3.xyz = WorldBones[0 + addr0.y].www * temp2.xyz + -temp3.xyz;
    // mad r3.xyz, c128[a0.y].yzxw, r2.zxyw, r3
    temp3.xyz = WorldBones[0 + addr0.y].yzx * temp2.zxy + temp3.xyz;
    // mad r2.xyz, c128[a0.y].zxyw, -r2.yzxw, r3
    temp2.xyz = WorldBones[0 + addr0.y].zxy * -temp2.yzx + temp3.xyz;
    // mul r2.xyz, r2, v1.y
    temp2.xyz = temp2.xyz * i.blendweight.yyy;
    // mad r1.xyz, r1, v1.x, r2
    temp1.xyz = temp1.xyz * i.blendweight.xxx + temp2.xyz;
    // mul r1.w, v1.y, c129[a0.y].w
    temp1.w = i.blendweight.y * WorldBones[1 + addr0.y].w;
    // mad r1.w, c129[a0.x].w, v1.x, r1.w
    temp1.w = WorldBones[1 + addr0.x].w * i.blendweight.x + temp1.w;
    // mul r1.w, r1.w, v7.w
    temp1.w = temp1.w * i.color.w;
    // mul r2.xyz, c2, v7
    temp2.xyz = TintColor.xyz * i.color.xyz;
    // mov r0.w, c0.x
    temp0.w = float1(1);
    // dp4 o0.x, r0, c119
    o.position.x = dot(temp0, (ViewProjection._m00_m10_m20_m30));
    // dp4 o0.y, r0, c120
    o.position.y = dot(temp0, (ViewProjection._m01_m11_m21_m31));
    // dp4 o0.z, r0, c121
    o.position.z = dot(temp0, (ViewProjection._m02_m12_m22_m32));
    // dp4 o0.w, r0, c122
    o.position.w = dot(temp0, (ViewProjection._m03_m13_m23_m33));
    // add r3.xyz, -r0, c123
    temp3.xyz = -temp0.xyz + EyePosition.xyz;
    // dp3 r2.w, r3, r3
    temp2.w = dot(temp3.xyz, temp3.xyz);
    // rsq r2.w, r2.w
    temp2.w = 1 / sqrt(temp2.w);
    // mul r4.xyz, r3, r2.w
    temp4.xyz = temp3.xyz * temp2.www;
    // mad r5.xyz, r3, r2.w, c6
    temp5.xyz = temp3.xyz * temp2.www + DirectionalLight[0].Direction.xyz;
    // nrm r6.xyz, r5
    temp6.xyz = normalize(temp5.xyz).xyz;
    // dp3 r3.w, r1, c6
    temp3.w = dot(temp1.xyz, DirectionalLight[0].Direction.xyz);
    // dp3 r4.w, r1, r6
    temp4.w = dot(temp1.xyz, temp6.xyz);
    // slt r5.x, -r3.w, r3.w
    temp5.x = (-temp3.w < temp3.w) ? 1 : 0;
    // mul r3.w, r3.w, r5.x
    temp3.w = temp3.w * temp5.x;
    // slt r5.y, -r4.w, r4.w
    temp5.y = (-temp4.w < temp4.w) ? 1 : 0;
    // mul r5.x, r5.x, r5.y
    temp5.x = temp5.x * temp5.y;
    // pow r5.y, r4.w, c13.x
    temp5.y = pow(temp4.w, Shininess.x);
    // mul r4.w, r5.x, r5.y
    temp4.w = temp5.x * temp5.y;
    // mul r5.xyz, r3.w, c5
    temp5.xyz = temp3.www * DirectionalLight[0].Color.xyz;
    // mul r6.xyz, r4.w, c5
    temp6.xyz = temp4.www * DirectionalLight[0].Color.xyz;
    // mul r5.xyz, r5, c11
    temp5.xyz = temp5.xyz * ColorDiffuse.xyz;
    // mul r2.xyz, r2, r5
    temp2.xyz = temp2.xyz * temp5.xyz;
    // mul o6.xyz, r2, c0.z
    o.texcoord4 = temp2 * float4(0.5, 0.5, 0.5, 0.5);
    // mul r2.xyz, r6, c12
    temp2.xyz = temp6.xyz * ColorSpecular.xyz;
    // mul o7.xyz, r2, c0.z
    o.texcoord5 = temp2 * float4(0.5, 0.5, 0.5, 0.5);
    // mov r2.xyz, c3.x
    temp2.xyz = float3(0, 0, 0);
    // mov r3.w, c0.x
    temp3.w = float1(1);
    // rep i0
    for (int it0 = 0; it0 < int1(2); ++it0) {
        // add r4.w, r3.w, r3.w
        temp4.w = temp3.w + temp3.w;
        // mova a0.x, r4.w
        addr0.x = temp4.w;
        // mad r5.xyz, r3, r2.w, c6[a0.x]
        temp5.xyz = temp3.xyz * temp2.www + DirectionalLight[0 + (addr0.x / 2)].Direction.xyz;
        // nrm r6.xyz, r5
        temp6.xyz = normalize(temp5.xyz).xyz;
        // dp3 r4.w, r1, c6[a0.x]
        temp4.w = dot(temp1.xyz, DirectionalLight[0 + (addr0.x / 2)].Direction.xyz);
        // dp3 r5.x, r1, r6
        temp5.x = dot(temp1.xyz, temp6.xyz);
        // slt r4.w, -r4.w, r4.w
        temp4.w = (-temp4.w < temp4.w) ? 1 : 0;
        // slt r5.y, -r5.x, r5.x
        temp5.y = (-temp5.x < temp5.x) ? 1 : 0;
        // mul r4.w, r4.w, r5.y
        temp4.w = temp4.w * temp5.y;
        // pow r6.x, r5.x, c13.x
        temp6.x = pow(temp5.x, Shininess.x);
        // mul r4.w, r4.w, r6.x
        temp4.w = temp4.w * temp6.x;
        // mad r2.xyz, c5[a0.x], r4.w, r2
        temp2.xyz = DirectionalLight[0 + (addr0.x / 2)].Color.xyz * temp4.www + temp2.xyz;
        // add r3.w, r3.w, c0.x
        temp3.w = temp3.w + float1(1);
        // endrep
    }
    // mul o1.w, r1.w, c1.x
    o.texcoord1.w = temp1.w * OpacityOverride.x;
    // mul r2.xyz, r2, c12
    temp2.xyz = temp2.xyz * ColorSpecular.xyz;
    // mul o2.xyz, r2, c0.z
    o.color1.xyz = temp2.xyz * float3(0.5, 0.5, 0.5);
    // dp4 r2.x, r0, c113
    temp2.x = dot(temp0, (ShadowMapWorldToShadow._m00_m10_m20_m30));
    // dp4 r2.y, r0, c114
    temp2.y = dot(temp0, (ShadowMapWorldToShadow._m01_m11_m21_m31));
    // dp4 r2.z, r0, c115
    temp2.z = dot(temp0, (ShadowMapWorldToShadow._m02_m12_m22_m32));
    // dp4 r0.w, r0, c116
    temp0.w = dot(temp0, (ShadowMapWorldToShadow._m03_m13_m23_m33));
    // rcp r1.w, r0.w
    temp1.w = 1.0f / temp0.w;
    // mul r3.xy, r0.z, c117.zwzw
    temp3.xy = temp0.zz * Cloud.WorldPositionMultiplier_XYZZ.zw;
    // mad r3.xy, r0, c117, -r3
    temp3.xy = temp0.xy * Cloud.WorldPositionMultiplier_XYZZ.xy + -temp3.xy;
    // add o4.xy, r3, c118
    o.texcoord2.xy = temp3.xy + Cloud.CurrentOffsetUV.xy;
    // add r0.xy, r0.yxzw, c14.wzzw
    temp0.xy = temp0.yx + Shroud.ScaleUV_OffsetUV.wz;
    // mul o4.zw, r0.xyxy, c14.xyyx
    o.texcoord2.zw = temp0.xy * Shroud.ScaleUV_OffsetUV.yx;
    // dp3 r0.x, r4, r1
    temp0.x = dot(temp4.xyz, temp1.xyz);
    // add r0.x, -r0.x, c0.x
    temp0.x = -temp0.x + float1(1);
    // pow r1.x, r0.x, c3.y
    temp1.x = pow(temp0.x, float1(2.5));
    // mad r0.xyz, r1.x, c4.xyxw, c4.xzww
    temp0.xyz = temp1.xxx * float3(0, 1, 0) + float3(0, 0.055, 0.045);
    // min o1.xyz, r0, c0.w
    o.texcoord1.xyz = min(temp0.xyz, float3(2, 2, 2));
    // mov o2.w, c0.x
    o.color1.w = float1(1);
    // mov o3.xy, v6
    o.texcoord = i.texcoord;
    // mad o5.xyz, r2, r1.w, c3.xxzw
    o.texcoord3.xyz = temp2.xyz * temp1.www + float3(0, 0, -0.0015);
    // mov o5.w, r0.w
    o.texcoord3.w = temp0.w;
    // 

    return o;
}

VertexShader VS_Array[3] = {
    compile vs_3_0 VS_Array_Shader_0(), // 55
    compile vs_3_0 VS_Array_Shader_1(), // 56
    compile vs_3_0 VS_Array_Shader_2(), // 57
};
// PS_Array_Shader_0 Pixel_3_0 Has PRES False
struct PS_Array_Shader_0_Input
{
    float4 texcoord1 : TEXCOORD1;
    float4 texcoord2 : TEXCOORD2;
};

float4 PS_Array_Shader_0(PS_Array_Shader_0_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    // dcl_texcoord1 v0
    // dcl_texcoord2 v1.zw
    // dcl_2d s0
    // texld r0, v1.wzzw, s0
    temp0 = tex2D(ShroudTextureSampler, i.texcoord2.wz);
    // mul oC0.xyz, r0, v0
    out_color.xyz = temp0.xyz * i.texcoord1.xyz;
    // mov oC0.w, v0.w
    out_color.w = i.texcoord1.w;
    // 

    return out_color;
}

// PS_Array_Shader_1 Pixel_3_0 Has PRES False
struct PS_Array_Shader_1_Input
{
    float4 texcoord1 : TEXCOORD1;
    float4 color1 : COLOR1;
    float4 texcoord2 : TEXCOORD2;
};

float4 PS_Array_Shader_1(PS_Array_Shader_1_Input i) : COLOR
{
    float4 out_color;
    float3 temp0;
    float4 temp1;
    // def c0, -1, 1, 0, 0
    // dcl_texcoord1 v0
    // dcl_color1 v1.w
    // dcl_texcoord2 v2.zw
    // dcl_2d s0
    // add r0.xyz, c0.x, v0
    temp0.xyz = float3(-1, -1, -1) + i.texcoord1.xyz;
    // mad r0.xyz, v1.w, r0, c0.y
    temp0.xyz = i.color1.www * temp0.xyz + float3(1, 1, 1);
    // texld r1, v2.wzzw, s0
    temp1 = tex2D(ShroudTextureSampler, i.texcoord2.wz);
    // mul oC0.xyz, r0, r1
    out_color.xyz = temp0.xyz * temp1.xyz;
    // mov oC0.w, v0.w
    out_color.w = i.texcoord1.w;
    // 

    return out_color;
}

// PS_Array_Shader_2 Pixel_3_0 Has PRES False
struct PS_Array_Shader_2_Input
{
    float4 texcoord1 : TEXCOORD1;
    float4 color1 : COLOR1;
    float4 texcoord2 : TEXCOORD2;
};

float4 PS_Array_Shader_2(PS_Array_Shader_2_Input i) : COLOR
{
    float4 out_color;
    float3 temp0;
    float4 temp1;
    // dcl_texcoord1 v0
    // dcl_color1 v1.w
    // dcl_texcoord2 v2.zw
    // dcl_2d s0
    // mov r0.xyz, v0
    temp0.xyz = i.texcoord1.xyz;
    // mul r0.xyz, r0, v1.w
    temp0.xyz = temp0.xyz * i.color1.www;
    // texld r1, v2.wzzw, s0
    temp1 = tex2D(ShroudTextureSampler, i.texcoord2.wz);
    // mul oC0.xyz, r0, r1
    out_color.xyz = temp0.xyz * temp1.xyz;
    // mov oC0.w, v0.w
    out_color.w = i.texcoord1.w;
    // 

    return out_color;
}

// PS_Array_Shader_3 Pixel_3_0 Has PRES False
struct PS_Array_Shader_3_Input
{
    float4 texcoord1 : TEXCOORD1;
    float4 texcoord2 : TEXCOORD2;
};

float4 PS_Array_Shader_3(PS_Array_Shader_3_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    // dcl_texcoord1 v0
    // dcl_texcoord2 v1.zw
    // dcl_2d s0
    // texld r0, v1.wzzw, s0
    temp0 = tex2D(ShroudTextureSampler, i.texcoord2.wz);
    // mul oC0.xyz, r0, v0
    out_color.xyz = temp0.xyz * i.texcoord1.xyz;
    // mov oC0.w, v0.w
    out_color.w = i.texcoord1.w;
    // 

    return out_color;
}

// PS_Array_Shader_4 Pixel_3_0 Has PRES False
struct PS_Array_Shader_4_Input
{
    float4 texcoord1 : TEXCOORD1;
    float4 color1 : COLOR1;
    float4 texcoord2 : TEXCOORD2;
};

float4 PS_Array_Shader_4(PS_Array_Shader_4_Input i) : COLOR
{
    float4 out_color;
    float3 temp0;
    float4 temp1;
    // def c0, -1, 1, 0, 0
    // dcl_texcoord1 v0
    // dcl_color1 v1.w
    // dcl_texcoord2 v2.zw
    // dcl_2d s0
    // add r0.xyz, c0.x, v0
    temp0.xyz = float3(-1, -1, -1) + i.texcoord1.xyz;
    // mad r0.xyz, v1.w, r0, c0.y
    temp0.xyz = i.color1.www * temp0.xyz + float3(1, 1, 1);
    // texld r1, v2.wzzw, s0
    temp1 = tex2D(ShroudTextureSampler, i.texcoord2.wz);
    // mul oC0.xyz, r0, r1
    out_color.xyz = temp0.xyz * temp1.xyz;
    // mov oC0.w, v0.w
    out_color.w = i.texcoord1.w;
    // 

    return out_color;
}

// PS_Array_Shader_5 Pixel_3_0 Has PRES False
struct PS_Array_Shader_5_Input
{
    float4 texcoord1 : TEXCOORD1;
    float4 color1 : COLOR1;
    float4 texcoord2 : TEXCOORD2;
};

float4 PS_Array_Shader_5(PS_Array_Shader_5_Input i) : COLOR
{
    float4 out_color;
    float3 temp0;
    float4 temp1;
    // dcl_texcoord1 v0
    // dcl_color1 v1.w
    // dcl_texcoord2 v2.zw
    // dcl_2d s0
    // mov r0.xyz, v0
    temp0.xyz = i.texcoord1.xyz;
    // mul r0.xyz, r0, v1.w
    temp0.xyz = temp0.xyz * i.color1.www;
    // texld r1, v2.wzzw, s0
    temp1 = tex2D(ShroudTextureSampler, i.texcoord2.wz);
    // mul oC0.xyz, r0, r1
    out_color.xyz = temp0.xyz * temp1.xyz;
    // mov oC0.w, v0.w
    out_color.w = i.texcoord1.w;
    // 

    return out_color;
}

PixelShader PS_Array[6] = {
    compile ps_3_0 PS_Array_Shader_0(), // 58
    compile ps_3_0 PS_Array_Shader_1(), // 59
    compile ps_3_0 PS_Array_Shader_2(), // 60
    compile ps_3_0 PS_Array_Shader_3(), // 61
    compile ps_3_0 PS_Array_Shader_4(), // 62
    compile ps_3_0 PS_Array_Shader_5(), // 63
};
// VS_M_Array_Shader_0 Vertex_2_0 Has PRES False
struct VS_M_Array_Shader_0_Input
{
    float4 position : POSITION;
    float4 normal : NORMAL;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct VS_M_Array_Shader_0_Output
{
    float4 texcoord2 : TEXCOORD2;
    float4 color1 : COLOR1;
    float3 texcoord4 : TEXCOORD4;
    float3 texcoord5 : TEXCOORD5;
    float4 texcoord1 : TEXCOORD1;
    float4 texcoord3 : TEXCOORD3;
    float4 position : POSITION;
    float2 texcoord : TEXCOORD;
};

VS_M_Array_Shader_0_Output VS_M_Array_Shader_0(VS_M_Array_Shader_0_Input i)
{
    VS_M_Array_Shader_0_Output o;
    float4 temp0, temp1, temp2, temp3, temp4, temp5;
    float addr0;
    float3 temp6;
    // def c0, 1, 0, 0.5, 2
    // def c3, 2.5, 0, -0.0015, 0
    // def c4, 0, 1, 0.055, 0.045
    // defi i0, 2, 0, 0, 0
    // dcl_position v0
    // dcl_normal v1
    // dcl_texcoord v2
    // dcl_color v3
    // mad r0, v0.xyzx, c0.xxxy, c0.yyyx
    temp0 = i.position.xyzx * float4(1, 1, 1, 0) + float4(0, 0, 0, 1);
    // dp4 r1.z, r0, c126
    temp1.z = dot(temp0, (World._m02_m12_m22_m32));
    // dp4 r1.x, r0, c124
    temp1.x = dot(temp0, (World._m00_m10_m20_m30));
    // dp4 r1.y, r0, c125
    temp1.y = dot(temp0, (World._m01_m11_m21_m31));
    // add r0.xy, r1.yxzw, c14.wzzw
    temp0.xy = temp1.yx + Shroud.ScaleUV_OffsetUV.wz;
    // mul oT2.zw, r0.xyxy, c14.xyyx
    o.texcoord2.zw = temp0.xy * Shroud.ScaleUV_OffsetUV.yx;
    // dp3 r0.x, v1, c124
    temp0.x = dot(i.normal.xyz, (World._m00_m10_m20_m30).xyz);
    // dp3 r0.y, v1, c125
    temp0.y = dot(i.normal.xyz, (World._m01_m11_m21_m31).xyz);
    // dp3 r0.z, v1, c126
    temp0.z = dot(i.normal.xyz, (World._m02_m12_m22_m32).xyz);
    // add r2.xyz, -r1, c123
    temp2.xyz = -temp1.xyz + EyePosition.xyz;
    // dp3 r0.w, r2, r2
    temp0.w = dot(temp2.xyz, temp2.xyz);
    // rsq r0.w, r0.w
    temp0.w = 1 / sqrt(temp0.w);
    // mul r3.xyz, r2, r0.w
    temp3.xyz = temp2.xyz * temp0.www;
    // dp3 r2.w, r3, r0
    temp2.w = dot(temp3.xyz, temp0.xyz);
    // mov r3.zw, c13.x
    temp3.zw = Shininess.x;
    // mov r4, c0.yyyx
    temp4 = float4(0, 0, 0, 1);
    // rep i0
    for (int it0 = 0; it0 < int1(2); ++it0) {
        // add r5.x, r4.w, r4.w
        temp5.x = temp4.w + temp4.w;
        // mova a0.x, r5.x
        addr0.x = temp5.x;
        // mad r5.xyz, r2, r0.w, c6[a0.x]
        temp5.xyz = temp2.xyz * temp0.www + DirectionalLight[0 + (addr0.x / 2)].Direction.xyz;
        // nrm r6.xyz, r5
        temp6.xyz = normalize(temp5.xyz).xyz;
        // dp3 r3.y, r0, r6
        temp3.y = dot(temp0.xyz, temp6.xyz);
        // dp3 r3.x, r0, c6[a0.x]
        temp3.x = dot(temp0.xyz, DirectionalLight[0 + (addr0.x / 2)].Direction.xyz);
        // lit r5, r3
        temp5 = lit(temp3.x, temp3.y, temp3.w);
        // mad r4.xyz, c5[a0.x], r5.z, r4
        temp4.xyz = DirectionalLight[0 + (addr0.x / 2)].Color.xyz * temp5.zzz + temp4.xyz;
        // add r4.w, r4.w, c0.x
        temp4.w = temp4.w + float1(1);
        // endrep
    }
    // mul r3.xyz, r4, c12
    temp3.xyz = temp4.xyz * ColorSpecular.xyz;
    // mul oD1.xyz, r3, c0.z
    o.color1.xyz = temp3.xyz * float3(0.5, 0.5, 0.5);
    // mad r2.xyz, r2, r0.w, c6
    temp2.xyz = temp2.xyz * temp0.www + DirectionalLight[0].Direction.xyz;
    // nrm r3.xyz, r2
    temp3.xyz = normalize(temp2.xyz).xyz;
    // dp3 r3.y, r0, r3
    temp3.y = dot(temp0.xyz, temp3.xyz);
    // dp3 r3.x, r0, c6
    temp3.x = dot(temp0.xyz, DirectionalLight[0].Direction.xyz);
    // mov r3.zw, c13.x
    temp3.zw = Shininess.x;
    // lit r0, r3
    temp0 = lit(temp3.x, temp3.y, temp3.w);
    // mul r0.xyw, r0.y, c5.xyzz
    temp0.xyw = temp0.yyy * DirectionalLight[0].Color.xyz;
    // mul r0.xyw, r0, c11.xyzz
    temp0.xyw = temp0.xyw * ColorDiffuse.xyz;
    // mul r2.xyz, v3, c2
    temp2.xyz = i.color.xyz * TintColor.xyz;
    // mul r0.xyw, r0, r2.xyzz
    temp0.xyw = temp0.xyw * temp2.xyz;
    // mul oT4.xyz, r0.xyww, c0.z
    o.texcoord4 = temp0.xyww * float4(0.5, 0.5, 0.5, 0.5);
    // mul r0.xy, r1.z, c117.zwzw
    temp0.xy = temp1.zz * Cloud.WorldPositionMultiplier_XYZZ.zw;
    // mad r0.xy, r1, c117, -r0
    temp0.xy = temp1.xy * Cloud.WorldPositionMultiplier_XYZZ.xy + -temp0.xy;
    // add oT2.xy, r0, c118
    o.texcoord2.xy = temp0.xy + Cloud.CurrentOffsetUV.xy;
    // mul r0.xyz, r0.z, c5
    temp0.xyz = temp0.zzz * DirectionalLight[0].Color.xyz;
    // mul r0.xyz, r0, c12
    temp0.xyz = temp0.xyz * ColorSpecular.xyz;
    // mul oT5.xyz, r0, c0.z
    o.texcoord5 = temp0 * float4(0.5, 0.5, 0.5, 0.5);
    // add r0.x, -r2.w, c0.x
    temp0.x = -temp2.w + float1(1);
    // pow r2.x, r0.x, c3.x
    temp2.x = pow(temp0.x, float1(2.5));
    // mad r0.xyz, r2.x, c4.xyxw, c4.xzww
    temp0.xyz = temp2.xxx * float3(0, 1, 0) + float3(0, 0.055, 0.045);
    // min oT1.xyz, r0, c0.w
    o.texcoord1.xyz = min(temp0.xyz, float3(2, 2, 2));
    // mov r1.w, c0.x
    temp1.w = float1(1);
    // dp4 r0.x, r1, c116
    temp0.x = dot(temp1, (ShadowMapWorldToShadow._m03_m13_m23_m33));
    // dp4 r0.y, r1, c113
    temp0.y = dot(temp1, (ShadowMapWorldToShadow._m00_m10_m20_m30));
    // dp4 r0.z, r1, c114
    temp0.z = dot(temp1, (ShadowMapWorldToShadow._m01_m11_m21_m31));
    // dp4 r0.w, r1, c115
    temp0.w = dot(temp1, (ShadowMapWorldToShadow._m02_m12_m22_m32));
    // rcp r2.x, r0.x
    temp2.x = 1.0f / temp0.x;
    // mad oT3.xyz, r0.yzww, r2.x, c3.yyzw
    o.texcoord3.xyz = temp0.yzw * temp2.xxx + float3(0, 0, -0.0015);
    // mov oT3.w, r0.x
    o.texcoord3.w = temp0.x;
    // dp4 oPos.x, r1, c119
    o.position.x = dot(temp1, (ViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r1, c120
    o.position.y = dot(temp1, (ViewProjection._m01_m11_m21_m31));
    // dp4 oPos.z, r1, c121
    o.position.z = dot(temp1, (ViewProjection._m02_m12_m22_m32));
    // dp4 oPos.w, r1, c122
    o.position.w = dot(temp1, (ViewProjection._m03_m13_m23_m33));
    // mul oT1.w, v3.w, c1.x
    o.texcoord1.w = i.color.w * OpacityOverride.x;
    // mov oD1.w, c0.x
    o.color1.w = float1(1);
    // mov oT0.xy, v2
    o.texcoord = i.texcoord;
    // 

    return o;
}

// VS_M_Array_Shader_1 Vertex_2_0 Has PRES False
struct VS_M_Array_Shader_1_Input
{
    float4 blendindices : BLENDINDICES;
    float4 position : POSITION;
    float4 normal : NORMAL;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct VS_M_Array_Shader_1_Output
{
    float4 texcoord1 : TEXCOORD1;
    float4 texcoord2 : TEXCOORD2;
    float3 texcoord5 : TEXCOORD5;
    float3 texcoord4 : TEXCOORD4;
    float4 color1 : COLOR1;
    float4 texcoord3 : TEXCOORD3;
    float4 position : POSITION;
    float2 texcoord : TEXCOORD;
};

VS_M_Array_Shader_1_Output VS_M_Array_Shader_1(VS_M_Array_Shader_1_Input i)
{
    VS_M_Array_Shader_1_Output o;
    float4 temp0, temp1, temp2, temp3, temp4, temp5;
    float addr0;
    float3 temp6;
    // def c0, 1, -1, 0.5, 2
    // def c3, 0, 2.5, -0.0015, 0
    // def c4, 0, 1, 0.055, 0.045
    // defi i0, 2, 0, 0, 0
    // dcl_blendindices v0
    // dcl_position v1
    // dcl_normal v2
    // dcl_texcoord v3
    // dcl_color v4
    // frc r0.x, v0.x
    temp0.x = frac(i.blendindices.x);
    // slt r0.y, -r0.x, r0.x
    temp0.y = (-temp0.x < temp0.x) ? 1 : 0;
    // add r0.x, -r0.x, v0.x
    temp0.x = -temp0.x + i.blendindices.x;
    // slt r0.z, v0.x, -v0.x
    temp0.z = (i.blendindices.x < -i.blendindices.x) ? 1 : 0;
    // mad r0.x, r0.z, r0.y, r0.x
    temp0.x = temp0.z * temp0.y + temp0.x;
    // add r0.x, r0.x, r0.x
    temp0.x = temp0.x + temp0.x;
    // mova a0.x, r0.x
    addr0.x = temp0.x;
    // mul r0.x, v4.w, c129[a0.x].w
    temp0.x = i.color.w * WorldBones[1 + addr0.x].w;
    // mul oT1.w, r0.x, c1.x
    o.texcoord1.w = temp0.x * OpacityOverride.x;
    // mul r0, v1.zxyy, c128[a0.x].yzxy
    temp0 = i.position.zxyy * WorldBones[0 + addr0.x].yzxy;
    // mad r0, c128[a0.x].wwwx, v1.xyzx, r0
    temp0 = WorldBones[0 + addr0.x].wwwx * i.position.xyzx + temp0;
    // mul r1, v1.yzxz, c128[a0.x].zxyz
    temp1 = i.position.yzxz * WorldBones[0 + addr0.x].zxyz;
    // mad r0, r0, c0.xxxy, -r1
    temp0 = temp0 * float4(1, 1, 1, -1) + -temp1;
    // mul r1.xyz, r0.w, c128[a0.x]
    temp1.xyz = temp0.www * WorldBones[0 + addr0.x].xyz;
    // mad r1.xyz, c128[a0.x].w, r0, -r1
    temp1.xyz = WorldBones[0 + addr0.x].www * temp0.xyz + -temp1.xyz;
    // mad r1.xyz, c128[a0.x].yzxw, r0.zxyw, r1
    temp1.xyz = WorldBones[0 + addr0.x].yzx * temp0.zxy + temp1.xyz;
    // mad r0.xyz, c128[a0.x].zxyw, -r0.yzxw, r1
    temp0.xyz = WorldBones[0 + addr0.x].zxy * -temp0.yzx + temp1.xyz;
    // add r0.xyz, r0, c129[a0.x]
    temp0.xyz = temp0.xyz + WorldBones[1 + addr0.x].xyz;
    // add r1.xy, r0.yxzw, c14.wzzw
    temp1.xy = temp0.yx + Shroud.ScaleUV_OffsetUV.wz;
    // mul oT2.zw, r1.xyxy, c14.xyyx
    o.texcoord2.zw = temp1.xy * Shroud.ScaleUV_OffsetUV.yx;
    // mul r1, v2.zxyy, c128[a0.x].yzxy
    temp1 = i.normal.zxyy * WorldBones[0 + addr0.x].yzxy;
    // mad r1, c128[a0.x].wwwx, v2.xyzx, r1
    temp1 = WorldBones[0 + addr0.x].wwwx * i.normal.xyzx + temp1;
    // mul r2, v2.yzxz, c128[a0.x].zxyz
    temp2 = i.normal.yzxz * WorldBones[0 + addr0.x].zxyz;
    // mad r1, r1, c0.xxxy, -r2
    temp1 = temp1 * float4(1, 1, 1, -1) + -temp2;
    // mul r2.xyz, r1.w, c128[a0.x]
    temp2.xyz = temp1.www * WorldBones[0 + addr0.x].xyz;
    // mad r2.xyz, c128[a0.x].w, r1, -r2
    temp2.xyz = WorldBones[0 + addr0.x].www * temp1.xyz + -temp2.xyz;
    // mad r2.xyz, c128[a0.x].yzxw, r1.zxyw, r2
    temp2.xyz = WorldBones[0 + addr0.x].yzx * temp1.zxy + temp2.xyz;
    // mad r1.xyz, c128[a0.x].zxyw, -r1.yzxw, r2
    temp1.xyz = WorldBones[0 + addr0.x].zxy * -temp1.yzx + temp2.xyz;
    // dp3 r2.x, r1, c6
    temp2.x = dot(temp1.xyz, DirectionalLight[0].Direction.xyz);
    // add r3.xyz, -r0, c123
    temp3.xyz = -temp0.xyz + EyePosition.xyz;
    // dp3 r1.w, r3, r3
    temp1.w = dot(temp3.xyz, temp3.xyz);
    // rsq r1.w, r1.w
    temp1.w = 1 / sqrt(temp1.w);
    // mul r4.xyz, r3, r1.w
    temp4.xyz = temp3.xyz * temp1.www;
    // dp3 r3.w, r4, r1
    temp3.w = dot(temp4.xyz, temp1.xyz);
    // mad r4.xyz, r3, r1.w, c6
    temp4.xyz = temp3.xyz * temp1.www + DirectionalLight[0].Direction.xyz;
    // nrm r5.xyz, r4
    temp5.xyz = normalize(temp4.xyz).xyz;
    // dp3 r2.y, r1, r5
    temp2.y = dot(temp1.xyz, temp5.xyz);
    // mov r2.zw, c13.x
    temp2.zw = Shininess.x;
    // lit r2, r2
    temp2 = lit(temp2.x, temp2.y, temp2.w);
    // mul r2.xzw, r2.z, c5.xyyz
    temp2.xzw = temp2.zzz * DirectionalLight[0].Color.xyz;
    // mul r2.xzw, r2, c12.xyyz
    temp2.xzw = temp2.xzw * ColorSpecular.xyz;
    // mul oT5.xyz, r2.xzww, c0.z
    o.texcoord5 = temp2.xzww * float4(0.5, 0.5, 0.5, 0.5);
    // mul r2.xz, r0.z, c117.zyww
    temp2.xz = temp0.zz * Cloud.WorldPositionMultiplier_XYZZ.zw;
    // mad r2.xz, r0.xyyw, c117.xyyw, -r2
    temp2.xz = temp0.xy * Cloud.WorldPositionMultiplier_XYZZ.xy + -temp2.xz;
    // add oT2.xy, r2.xzzw, c118
    o.texcoord2.xy = temp2.xz + Cloud.CurrentOffsetUV.xy;
    // add r2.x, -r3.w, c0.x
    temp2.x = -temp3.w + float1(1);
    // pow r3.w, r2.x, c3.y
    temp3.w = pow(temp2.x, float1(2.5));
    // mad r2.xzw, r3.w, c4.xyyx, c4
    temp2.xzw = temp3.www * float3(0, 1, 0) + float3(0, 0.055, 0.045);
    // min oT1.xyz, r2.xzww, c0.w
    o.texcoord1.xyz = min(temp2.xzw, float3(2, 2, 2));
    // mul r2.xyz, r2.y, c5
    temp2.xyz = temp2.yyy * DirectionalLight[0].Color.xyz;
    // mul r2.xyz, r2, c11
    temp2.xyz = temp2.xyz * ColorDiffuse.xyz;
    // mul r4.xyz, v4, c2
    temp4.xyz = i.color.xyz * TintColor.xyz;
    // mul r2.xyz, r2, r4
    temp2.xyz = temp2.xyz * temp4.xyz;
    // mul oT4.xyz, r2, c0.z
    o.texcoord4 = temp2 * float4(0.5, 0.5, 0.5, 0.5);
    // mov r2.zw, c13.x
    temp2.zw = Shininess.x;
    // mov r4.xyz, c3.x
    temp4.xyz = float3(0, 0, 0);
    // mov r3.w, c0.x
    temp3.w = float1(1);
    // rep i0
    for (int it0 = 0; it0 < int1(2); ++it0) {
        // add r4.w, r3.w, r3.w
        temp4.w = temp3.w + temp3.w;
        // mova a0.x, r4.w
        addr0.x = temp4.w;
        // mad r5.xyz, r3, r1.w, c6[a0.x]
        temp5.xyz = temp3.xyz * temp1.www + DirectionalLight[0 + (addr0.x / 2)].Direction.xyz;
        // nrm r6.xyz, r5
        temp6.xyz = normalize(temp5.xyz).xyz;
        // dp3 r2.y, r1, r6
        temp2.y = dot(temp1.xyz, temp6.xyz);
        // dp3 r2.x, r1, c6[a0.x]
        temp2.x = dot(temp1.xyz, DirectionalLight[0 + (addr0.x / 2)].Direction.xyz);
        // lit r5, r2
        temp5 = lit(temp2.x, temp2.y, temp2.w);
        // mad r4.xyz, c5[a0.x], r5.z, r4
        temp4.xyz = DirectionalLight[0 + (addr0.x / 2)].Color.xyz * temp5.zzz + temp4.xyz;
        // add r3.w, r3.w, c0.x
        temp3.w = temp3.w + float1(1);
        // endrep
    }
    // mul r1.xyz, r4, c12
    temp1.xyz = temp4.xyz * ColorSpecular.xyz;
    // mul oD1.xyz, r1, c0.z
    o.color1.xyz = temp1.xyz * float3(0.5, 0.5, 0.5);
    // mov r0.w, c0.x
    temp0.w = float1(1);
    // dp4 r1.x, r0, c116
    temp1.x = dot(temp0, (ShadowMapWorldToShadow._m03_m13_m23_m33));
    // dp4 r1.y, r0, c113
    temp1.y = dot(temp0, (ShadowMapWorldToShadow._m00_m10_m20_m30));
    // dp4 r1.z, r0, c114
    temp1.z = dot(temp0, (ShadowMapWorldToShadow._m01_m11_m21_m31));
    // dp4 r1.w, r0, c115
    temp1.w = dot(temp0, (ShadowMapWorldToShadow._m02_m12_m22_m32));
    // rcp r2.x, r1.x
    temp2.x = 1.0f / temp1.x;
    // mad oT3.xyz, r1.yzww, r2.x, c3.xxzw
    o.texcoord3.xyz = temp1.yzw * temp2.xxx + float3(0, 0, -0.0015);
    // mov oT3.w, r1.x
    o.texcoord3.w = temp1.x;
    // dp4 oPos.x, r0, c119
    o.position.x = dot(temp0, (ViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c120
    o.position.y = dot(temp0, (ViewProjection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c121
    o.position.z = dot(temp0, (ViewProjection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c122
    o.position.w = dot(temp0, (ViewProjection._m03_m13_m23_m33));
    // mov oD1.w, c0.x
    o.color1.w = float1(1);
    // mov oT0.xy, v3
    o.texcoord = i.texcoord;
    // 

    return o;
}

// VS_M_Array_Shader_2 Vertex_2_0 Has PRES False
struct VS_M_Array_Shader_2_Input
{
    float4 blendindices : BLENDINDICES;
    float4 blendweight : BLENDWEIGHT;
    float4 position : POSITION;
    float4 position1 : POSITION1;
    float4 normal : NORMAL;
    float4 normal1 : NORMAL1;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct VS_M_Array_Shader_2_Output
{
    float4 texcoord1 : TEXCOORD1;
    float4 texcoord2 : TEXCOORD2;
    float3 texcoord5 : TEXCOORD5;
    float3 texcoord4 : TEXCOORD4;
    float4 color1 : COLOR1;
    float4 texcoord3 : TEXCOORD3;
    float4 position : POSITION;
    float2 texcoord : TEXCOORD;
};

VS_M_Array_Shader_2_Output VS_M_Array_Shader_2(VS_M_Array_Shader_2_Input i)
{
    VS_M_Array_Shader_2_Output o;
    float4 temp0, temp1, temp2, temp3, temp4, temp5;
    float2 addr0;
    float3 temp6;
    // def c0, 1, -1, 0.5, 2
    // def c3, 0, 2.5, -0.0015, 0
    // def c4, 0, 1, 0.055, 0.045
    // defi i0, 2, 0, 0, 0
    // dcl_blendindices v0
    // dcl_blendweight v1
    // dcl_position v2
    // dcl_position1 v3
    // dcl_normal v4
    // dcl_normal1 v5
    // dcl_texcoord v6
    // dcl_color v7
    // frc r0.xy, v0
    temp0.xy = frac(i.blendindices.xy);
    // slt r0.zw, -r0.xyxy, r0.xyxy
    temp0.zw = (-temp0.xy < temp0.xy) ? 1 : 0;
    // add r0.xy, -r0, v0
    temp0.xy = -temp0.xy + i.blendindices.xy;
    // slt r1.xy, v0, -v0
    temp1.xy = (i.blendindices.xy < -i.blendindices.xy) ? 1 : 0;
    // mad r0.xy, r1, r0.zwzw, r0
    temp0.xy = temp1.xy * temp0.zw + temp0.xy;
    // add r0.xy, r0, r0
    temp0.xy = temp0.xy + temp0.xy;
    // mova a0.xy, r0
    addr0.xy = temp0.xy;
    // mul r0.x, v1.y, c129[a0.y].w
    temp0.x = i.blendweight.y * WorldBones[1 + addr0.y].w;
    // mad r0.x, c129[a0.x].w, v1.x, r0.x
    temp0.x = WorldBones[1 + addr0.x].w * i.blendweight.x + temp0.x;
    // mul r0.x, r0.x, v7.w
    temp0.x = temp0.x * i.color.w;
    // mul oT1.w, r0.x, c1.x
    o.texcoord1.w = temp0.x * OpacityOverride.x;
    // mul r0, v2.zxyy, c128[a0.x].yzxy
    temp0 = i.position.zxyy * WorldBones[0 + addr0.x].yzxy;
    // mad r0, c128[a0.x].wwwx, v2.xyzx, r0
    temp0 = WorldBones[0 + addr0.x].wwwx * i.position.xyzx + temp0;
    // mul r1, v2.yzxz, c128[a0.x].zxyz
    temp1 = i.position.yzxz * WorldBones[0 + addr0.x].zxyz;
    // mad r0, r0, c0.xxxy, -r1
    temp0 = temp0 * float4(1, 1, 1, -1) + -temp1;
    // mul r1.xyz, r0.w, c128[a0.x]
    temp1.xyz = temp0.www * WorldBones[0 + addr0.x].xyz;
    // mad r1.xyz, c128[a0.x].w, r0, -r1
    temp1.xyz = WorldBones[0 + addr0.x].www * temp0.xyz + -temp1.xyz;
    // mad r1.xyz, c128[a0.x].yzxw, r0.zxyw, r1
    temp1.xyz = WorldBones[0 + addr0.x].yzx * temp0.zxy + temp1.xyz;
    // mad r0.xyz, c128[a0.x].zxyw, -r0.yzxw, r1
    temp0.xyz = WorldBones[0 + addr0.x].zxy * -temp0.yzx + temp1.xyz;
    // add r0.xyz, r0, c129[a0.x]
    temp0.xyz = temp0.xyz + WorldBones[1 + addr0.x].xyz;
    // mul r1, v4.zxyy, c128[a0.x].yzxy
    temp1 = i.normal.zxyy * WorldBones[0 + addr0.x].yzxy;
    // mad r1, c128[a0.x].wwwx, v4.xyzx, r1
    temp1 = WorldBones[0 + addr0.x].wwwx * i.normal.xyzx + temp1;
    // mul r2, v4.yzxz, c128[a0.x].zxyz
    temp2 = i.normal.yzxz * WorldBones[0 + addr0.x].zxyz;
    // mad r1, r1, c0.xxxy, -r2
    temp1 = temp1 * float4(1, 1, 1, -1) + -temp2;
    // mul r2.xyz, r1.w, c128[a0.x]
    temp2.xyz = temp1.www * WorldBones[0 + addr0.x].xyz;
    // mad r2.xyz, c128[a0.x].w, r1, -r2
    temp2.xyz = WorldBones[0 + addr0.x].www * temp1.xyz + -temp2.xyz;
    // mad r2.xyz, c128[a0.x].yzxw, r1.zxyw, r2
    temp2.xyz = WorldBones[0 + addr0.x].yzx * temp1.zxy + temp2.xyz;
    // mad r1.xyz, c128[a0.x].zxyw, -r1.yzxw, r2
    temp1.xyz = WorldBones[0 + addr0.x].zxy * -temp1.yzx + temp2.xyz;
    // mul r2, v3.zxyy, c128[a0.y].yzxy
    temp2 = i.position1.zxyy * WorldBones[0 + addr0.y].yzxy;
    // mad r2, c128[a0.y].wwwx, v3.xyzx, r2
    temp2 = WorldBones[0 + addr0.y].wwwx * i.position1.xyzx + temp2;
    // mul r3, v3.yzxz, c128[a0.y].zxyz
    temp3 = i.position1.yzxz * WorldBones[0 + addr0.y].zxyz;
    // mad r2, r2, c0.xxxy, -r3
    temp2 = temp2 * float4(1, 1, 1, -1) + -temp3;
    // mul r3.xyz, r2.w, c128[a0.y]
    temp3.xyz = temp2.www * WorldBones[0 + addr0.y].xyz;
    // mad r3.xyz, c128[a0.y].w, r2, -r3
    temp3.xyz = WorldBones[0 + addr0.y].www * temp2.xyz + -temp3.xyz;
    // mad r3.xyz, c128[a0.y].yzxw, r2.zxyw, r3
    temp3.xyz = WorldBones[0 + addr0.y].yzx * temp2.zxy + temp3.xyz;
    // mad r2.xyz, c128[a0.y].zxyw, -r2.yzxw, r3
    temp2.xyz = WorldBones[0 + addr0.y].zxy * -temp2.yzx + temp3.xyz;
    // add r2.xyz, r2, c129[a0.y]
    temp2.xyz = temp2.xyz + WorldBones[1 + addr0.y].xyz;
    // mul r2.xyz, r2, v1.y
    temp2.xyz = temp2.xyz * i.blendweight.yyy;
    // mad r0.xyz, r0, v1.x, r2
    temp0.xyz = temp0.xyz * i.blendweight.xxx + temp2.xyz;
    // mul r2, v5.zxyy, c128[a0.y].yzxy
    temp2 = i.normal1.zxyy * WorldBones[0 + addr0.y].yzxy;
    // mad r2, c128[a0.y].wwwx, v5.xyzx, r2
    temp2 = WorldBones[0 + addr0.y].wwwx * i.normal1.xyzx + temp2;
    // mul r3, v5.yzxz, c128[a0.y].zxyz
    temp3 = i.normal1.yzxz * WorldBones[0 + addr0.y].zxyz;
    // mad r2, r2, c0.xxxy, -r3
    temp2 = temp2 * float4(1, 1, 1, -1) + -temp3;
    // mul r3.xyz, r2.w, c128[a0.y]
    temp3.xyz = temp2.www * WorldBones[0 + addr0.y].xyz;
    // mad r3.xyz, c128[a0.y].w, r2, -r3
    temp3.xyz = WorldBones[0 + addr0.y].www * temp2.xyz + -temp3.xyz;
    // mad r3.xyz, c128[a0.y].yzxw, r2.zxyw, r3
    temp3.xyz = WorldBones[0 + addr0.y].yzx * temp2.zxy + temp3.xyz;
    // mad r2.xyz, c128[a0.y].zxyw, -r2.yzxw, r3
    temp2.xyz = WorldBones[0 + addr0.y].zxy * -temp2.yzx + temp3.xyz;
    // mul r2.xyz, r2, v1.y
    temp2.xyz = temp2.xyz * i.blendweight.yyy;
    // mad r1.xyz, r1, v1.x, r2
    temp1.xyz = temp1.xyz * i.blendweight.xxx + temp2.xyz;
    // add r2.xy, r0.yxzw, c14.wzzw
    temp2.xy = temp0.yx + Shroud.ScaleUV_OffsetUV.wz;
    // mul oT2.zw, r2.xyxy, c14.xyyx
    o.texcoord2.zw = temp2.xy * Shroud.ScaleUV_OffsetUV.yx;
    // dp3 r2.x, r1, c6
    temp2.x = dot(temp1.xyz, DirectionalLight[0].Direction.xyz);
    // add r3.xyz, -r0, c123
    temp3.xyz = -temp0.xyz + EyePosition.xyz;
    // dp3 r1.w, r3, r3
    temp1.w = dot(temp3.xyz, temp3.xyz);
    // rsq r1.w, r1.w
    temp1.w = 1 / sqrt(temp1.w);
    // mul r4.xyz, r3, r1.w
    temp4.xyz = temp3.xyz * temp1.www;
    // dp3 r3.w, r4, r1
    temp3.w = dot(temp4.xyz, temp1.xyz);
    // mad r4.xyz, r3, r1.w, c6
    temp4.xyz = temp3.xyz * temp1.www + DirectionalLight[0].Direction.xyz;
    // nrm r5.xyz, r4
    temp5.xyz = normalize(temp4.xyz).xyz;
    // dp3 r2.y, r1, r5
    temp2.y = dot(temp1.xyz, temp5.xyz);
    // mov r2.zw, c13.x
    temp2.zw = Shininess.x;
    // lit r2, r2
    temp2 = lit(temp2.x, temp2.y, temp2.w);
    // mul r2.xzw, r2.z, c5.xyyz
    temp2.xzw = temp2.zzz * DirectionalLight[0].Color.xyz;
    // mul r2.xzw, r2, c12.xyyz
    temp2.xzw = temp2.xzw * ColorSpecular.xyz;
    // mul oT5.xyz, r2.xzww, c0.z
    o.texcoord5 = temp2.xzww * float4(0.5, 0.5, 0.5, 0.5);
    // mul r2.xz, r0.z, c117.zyww
    temp2.xz = temp0.zz * Cloud.WorldPositionMultiplier_XYZZ.zw;
    // mad r2.xz, r0.xyyw, c117.xyyw, -r2
    temp2.xz = temp0.xy * Cloud.WorldPositionMultiplier_XYZZ.xy + -temp2.xz;
    // add oT2.xy, r2.xzzw, c118
    o.texcoord2.xy = temp2.xz + Cloud.CurrentOffsetUV.xy;
    // add r2.x, -r3.w, c0.x
    temp2.x = -temp3.w + float1(1);
    // pow r3.w, r2.x, c3.y
    temp3.w = pow(temp2.x, float1(2.5));
    // mad r2.xzw, r3.w, c4.xyyx, c4
    temp2.xzw = temp3.www * float3(0, 1, 0) + float3(0, 0.055, 0.045);
    // min oT1.xyz, r2.xzww, c0.w
    o.texcoord1.xyz = min(temp2.xzw, float3(2, 2, 2));
    // mul r2.xyz, r2.y, c5
    temp2.xyz = temp2.yyy * DirectionalLight[0].Color.xyz;
    // mul r2.xyz, r2, c11
    temp2.xyz = temp2.xyz * ColorDiffuse.xyz;
    // mul r4.xyz, v7, c2
    temp4.xyz = i.color.xyz * TintColor.xyz;
    // mul r2.xyz, r2, r4
    temp2.xyz = temp2.xyz * temp4.xyz;
    // mul oT4.xyz, r2, c0.z
    o.texcoord4 = temp2 * float4(0.5, 0.5, 0.5, 0.5);
    // mov r2.zw, c13.x
    temp2.zw = Shininess.x;
    // mov r4.xyz, c3.x
    temp4.xyz = float3(0, 0, 0);
    // mov r3.w, c0.x
    temp3.w = float1(1);
    // rep i0
    for (int it0 = 0; it0 < int1(2); ++it0) {
        // add r4.w, r3.w, r3.w
        temp4.w = temp3.w + temp3.w;
        // mova a0.x, r4.w
        addr0.x = temp4.w;
        // mad r5.xyz, r3, r1.w, c6[a0.x]
        temp5.xyz = temp3.xyz * temp1.www + DirectionalLight[0 + (addr0.x / 2)].Direction.xyz;
        // nrm r6.xyz, r5
        temp6.xyz = normalize(temp5.xyz).xyz;
        // dp3 r2.y, r1, r6
        temp2.y = dot(temp1.xyz, temp6.xyz);
        // dp3 r2.x, r1, c6[a0.x]
        temp2.x = dot(temp1.xyz, DirectionalLight[0 + (addr0.x / 2)].Direction.xyz);
        // lit r5, r2
        temp5 = lit(temp2.x, temp2.y, temp2.w);
        // mad r4.xyz, c5[a0.x], r5.z, r4
        temp4.xyz = DirectionalLight[0 + (addr0.x / 2)].Color.xyz * temp5.zzz + temp4.xyz;
        // add r3.w, r3.w, c0.x
        temp3.w = temp3.w + float1(1);
        // endrep
    }
    // mul r1.xyz, r4, c12
    temp1.xyz = temp4.xyz * ColorSpecular.xyz;
    // mul oD1.xyz, r1, c0.z
    o.color1.xyz = temp1.xyz * float3(0.5, 0.5, 0.5);
    // mov r0.w, c0.x
    temp0.w = float1(1);
    // dp4 r1.x, r0, c116
    temp1.x = dot(temp0, (ShadowMapWorldToShadow._m03_m13_m23_m33));
    // dp4 r1.y, r0, c113
    temp1.y = dot(temp0, (ShadowMapWorldToShadow._m00_m10_m20_m30));
    // dp4 r1.z, r0, c114
    temp1.z = dot(temp0, (ShadowMapWorldToShadow._m01_m11_m21_m31));
    // dp4 r1.w, r0, c115
    temp1.w = dot(temp0, (ShadowMapWorldToShadow._m02_m12_m22_m32));
    // rcp r2.x, r1.x
    temp2.x = 1.0f / temp1.x;
    // mad oT3.xyz, r1.yzww, r2.x, c3.xxzw
    o.texcoord3.xyz = temp1.yzw * temp2.xxx + float3(0, 0, -0.0015);
    // mov oT3.w, r1.x
    o.texcoord3.w = temp1.x;
    // dp4 oPos.x, r0, c119
    o.position.x = dot(temp0, (ViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c120
    o.position.y = dot(temp0, (ViewProjection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c121
    o.position.z = dot(temp0, (ViewProjection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c122
    o.position.w = dot(temp0, (ViewProjection._m03_m13_m23_m33));
    // mov oD1.w, c0.x
    o.color1.w = float1(1);
    // mov oT0.xy, v6
    o.texcoord = i.texcoord;
    // 

    return o;
}

VertexShader VS_M_Array[3] = {
    compile vs_2_0 VS_M_Array_Shader_0(), // 67
    compile vs_2_0 VS_M_Array_Shader_1(), // 68
    compile vs_2_0 VS_M_Array_Shader_2(), // 69
};
// PS_M_Array_Shader_0 Pixel_2_0 Has PRES False
struct PS_M_Array_Shader_0_Input
{
    float4 texcoord1 : TEXCOORD1;
    float4 texcoord2 : TEXCOORD2;
};

float4 PS_M_Array_Shader_0(PS_M_Array_Shader_0_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    // dcl t1
    // dcl t2
    // dcl_2d s0
    // mov r0.xy, t2.wzyx
    temp0.xy = i.texcoord2.wz;
    // texld r0, r0, s0
    temp0 = tex2D(ShroudTextureSampler, temp0.xy);
    // mul r0.xyz, r0, t1
    temp0.xyz = temp0.xyz * i.texcoord1.xyz;
    // mov r0.w, t1.w
    temp0.w = i.texcoord1.w;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// PS_M_Array_Shader_1 Pixel_2_0 Has PRES False
struct PS_M_Array_Shader_1_Input
{
    float4 texcoord1 : TEXCOORD1;
    float4 color1 : COLOR1;
    float4 texcoord2 : TEXCOORD2;
};

float4 PS_M_Array_Shader_1(PS_M_Array_Shader_1_Input i) : COLOR
{
    float4 out_color;
    float4 temp0, temp1;
    // def c0, -1, 1, 0, 0
    // dcl t1
    // dcl v1
    // dcl t2
    // dcl_2d s0
    // add r0.xyz, t1, c0.x
    temp0.xyz = i.texcoord1.xyz + float3(-1, -1, -1);
    // mad r0.xyz, v1.w, r0, c0.y
    temp0.xyz = i.color1.www * temp0.xyz + float3(1, 1, 1);
    // mov r1.xy, t2.wzyx
    temp1.xy = i.texcoord2.wz;
    // texld r1, r1, s0
    temp1 = tex2D(ShroudTextureSampler, temp1.xy);
    // mul r0.xyz, r0, r1
    temp0.xyz = temp0.xyz * temp1.xyz;
    // mov r0.w, t1.w
    temp0.w = i.texcoord1.w;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// PS_M_Array_Shader_2 Pixel_2_0 Has PRES False
struct PS_M_Array_Shader_2_Input
{
    float4 texcoord1 : TEXCOORD1;
    float4 color1 : COLOR1;
    float4 texcoord2 : TEXCOORD2;
};

float4 PS_M_Array_Shader_2(PS_M_Array_Shader_2_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    float3 temp1;
    // dcl t1
    // dcl v1
    // dcl t2
    // dcl_2d s0
    // mov r0.xy, t2.wzyx
    temp0.xy = i.texcoord2.wz;
    // texld r0, r0, s0
    temp0 = tex2D(ShroudTextureSampler, temp0.xy);
    // mov r1.xyz, t1
    temp1.xyz = i.texcoord1.xyz;
    // mul r1.xyz, r1, v1.w
    temp1.xyz = temp1.xyz * i.color1.www;
    // mul r0.xyz, r0, r1
    temp0.xyz = temp0.xyz * temp1.xyz;
    // mov r0.w, t1.w
    temp0.w = i.texcoord1.w;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// PS_M_Array_Shader_3 Pixel_2_0 Has PRES False
struct PS_M_Array_Shader_3_Input
{
    float4 texcoord1 : TEXCOORD1;
    float4 texcoord2 : TEXCOORD2;
};

float4 PS_M_Array_Shader_3(PS_M_Array_Shader_3_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    // dcl t1
    // dcl t2
    // dcl_2d s0
    // mov r0.xy, t2.wzyx
    temp0.xy = i.texcoord2.wz;
    // texld r0, r0, s0
    temp0 = tex2D(ShroudTextureSampler, temp0.xy);
    // mul r0.xyz, r0, t1
    temp0.xyz = temp0.xyz * i.texcoord1.xyz;
    // mov r0.w, t1.w
    temp0.w = i.texcoord1.w;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// PS_M_Array_Shader_4 Pixel_2_0 Has PRES False
struct PS_M_Array_Shader_4_Input
{
    float4 texcoord1 : TEXCOORD1;
    float4 color1 : COLOR1;
    float4 texcoord2 : TEXCOORD2;
};

float4 PS_M_Array_Shader_4(PS_M_Array_Shader_4_Input i) : COLOR
{
    float4 out_color;
    float4 temp0, temp1;
    // def c0, -1, 1, 0, 0
    // dcl t1
    // dcl v1
    // dcl t2
    // dcl_2d s0
    // add r0.xyz, t1, c0.x
    temp0.xyz = i.texcoord1.xyz + float3(-1, -1, -1);
    // mad r0.xyz, v1.w, r0, c0.y
    temp0.xyz = i.color1.www * temp0.xyz + float3(1, 1, 1);
    // mov r1.xy, t2.wzyx
    temp1.xy = i.texcoord2.wz;
    // texld r1, r1, s0
    temp1 = tex2D(ShroudTextureSampler, temp1.xy);
    // mul r0.xyz, r0, r1
    temp0.xyz = temp0.xyz * temp1.xyz;
    // mov r0.w, t1.w
    temp0.w = i.texcoord1.w;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// PS_M_Array_Shader_5 Pixel_2_0 Has PRES False
struct PS_M_Array_Shader_5_Input
{
    float4 texcoord1 : TEXCOORD1;
    float4 color1 : COLOR1;
    float4 texcoord2 : TEXCOORD2;
};

float4 PS_M_Array_Shader_5(PS_M_Array_Shader_5_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    float3 temp1;
    // dcl t1
    // dcl v1
    // dcl t2
    // dcl_2d s0
    // mov r0.xy, t2.wzyx
    temp0.xy = i.texcoord2.wz;
    // texld r0, r0, s0
    temp0 = tex2D(ShroudTextureSampler, temp0.xy);
    // mov r1.xyz, t1
    temp1.xyz = i.texcoord1.xyz;
    // mul r1.xyz, r1, v1.w
    temp1.xyz = temp1.xyz * i.color1.www;
    // mul r0.xyz, r0, r1
    temp0.xyz = temp0.xyz * temp1.xyz;
    // mov r0.w, t1.w
    temp0.w = i.texcoord1.w;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

PixelShader PS_M_Array[6] = {
    compile ps_2_0 PS_M_Array_Shader_0(), // 70
    compile ps_2_0 PS_M_Array_Shader_1(), // 71
    compile ps_2_0 PS_M_Array_Shader_2(), // 72
    compile ps_2_0 PS_M_Array_Shader_3(), // 73
    compile ps_2_0 PS_M_Array_Shader_4(), // 74
    compile ps_2_0 PS_M_Array_Shader_5(), // 75
};
// VSCreateShadowMap_Array_Shader_0 Vertex_2_0 Has PRES True
struct VSCreateShadowMap_Array_Shader_0_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct VSCreateShadowMap_Array_Shader_0_Output
{
    float color : COLOR;
    float texcoord1 : TEXCOORD1;
    float4 position : POSITION;
    float2 texcoord : TEXCOORD;
};

VSCreateShadowMap_Array_Shader_0_Output VSCreateShadowMap_Array_Shader_0(VSCreateShadowMap_Array_Shader_0_Input i)
{
    /*
    PRSI
      OutputRegisterOffset: 11
      Unknown1: 0
      Unknown2: 0
      OutputRegisterCount: 1
      Unknown3: 0
      Unknown4: 0
      Unknown5: 11
      Unknown6: 1
      Mappings: 1
        0 - ConstOutput: 0 ConstInput 0
    
    */
    float4 expr11;
    {
        float4 temp0;
        float4 temp1;
        // Expression_2_1
        // add r0.x, c0.x, (-2)
        temp0.x = BlendMode.x + (-2);
        // mul r1.x, r0.x, r0.x
        temp1.x = temp0.x * temp0.x;
        // neg r0.x, r1.x
        temp0.x = -temp1.x;
        // ge c11.x, r0.x, r1.x
        expr11.x = temp0.x >= temp1.x;
    }

    VSCreateShadowMap_Array_Shader_0_Output o;
    float4 temp0, temp1;
    float temp2;
    // def c0, 1, 0, 0, 0
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_color v2
    // mul oD0.x, v2.w, c1.x
    o.color = i.color.w * OpacityOverride.x;
    // mad r0, v0.xyzx, c0.xxxy, c0.yyyx
    temp0 = i.position.xyzx * float4(1, 1, 1, 0) + float4(0, 0, 0, 1);
    // dp4 r1.x, r0, c124
    temp1.x = dot(temp0, (World._m00_m10_m20_m30));
    // dp4 r1.y, r0, c125
    temp1.y = dot(temp0, (World._m01_m11_m21_m31));
    // dp4 r1.z, r0, c126
    temp1.z = dot(temp0, (World._m02_m12_m22_m32));
    // mov r1.w, c0.x
    temp1.w = float1(1);
    // dp4 r0.w, r1, c122
    temp0.w = dot(temp1, (ViewProjection._m03_m13_m23_m33));
    // rcp r2.x, r0.w
    temp2.x = 1.0f / temp0.w;
    // dp4 r0.z, r1, c121
    temp0.z = dot(temp1, (ViewProjection._m02_m12_m22_m32));
    // mul oT1.x, r2.x, r0.z
    o.texcoord1 = temp2.x * temp0.z;
    // dp4 r0.x, r1, c119
    temp0.x = dot(temp1, (ViewProjection._m00_m10_m20_m30));
    // dp4 r0.y, r1, c120
    temp0.y = dot(temp1, (ViewProjection._m01_m11_m21_m31));
    // add r1, -r0, c0.xxxy
    temp1 = -temp0 + float4(1, 1, 1, 0);
    // mad oPos, c11.x, r1, r0
    o.position = expr11.x * temp1 + temp0;
    // mov oT0.xy, v1
    o.texcoord = i.texcoord;
    // 

    return o;
}

// VSCreateShadowMap_Array_Shader_1 Vertex_2_0 Has PRES True
struct VSCreateShadowMap_Array_Shader_1_Input
{
    float4 blendindices : BLENDINDICES;
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct VSCreateShadowMap_Array_Shader_1_Output
{
    float color : COLOR;
    float texcoord1 : TEXCOORD1;
    float4 position : POSITION;
    float2 texcoord : TEXCOORD;
};

VSCreateShadowMap_Array_Shader_1_Output VSCreateShadowMap_Array_Shader_1(VSCreateShadowMap_Array_Shader_1_Input i)
{
    /*
    PRSI
      OutputRegisterOffset: 11
      Unknown1: 0
      Unknown2: 0
      OutputRegisterCount: 1
      Unknown3: 0
      Unknown4: 0
      Unknown5: 11
      Unknown6: 1
      Mappings: 1
        0 - ConstOutput: 0 ConstInput 0
    
    */
    float4 expr11;
    {
        float4 temp0;
        float4 temp1;
        // Expression_2_1
        // add r0.x, c0.x, (-2)
        temp0.x = BlendMode.x + (-2);
        // mul r1.x, r0.x, r0.x
        temp1.x = temp0.x * temp0.x;
        // neg r0.x, r1.x
        temp0.x = -temp1.x;
        // ge c11.x, r0.x, r1.x
        expr11.x = temp0.x >= temp1.x;
    }

    VSCreateShadowMap_Array_Shader_1_Output o;
    float4 temp0, temp1;
    float addr0, temp2;
    // def c0, 1, -1, 0, 0
    // dcl_blendindices v0
    // dcl_position v1
    // dcl_texcoord v2
    // dcl_color v3
    // slt r0.x, v0.x, -v0.x
    temp0.x = (i.blendindices.x < -i.blendindices.x) ? 1 : 0;
    // frc r0.y, v0.x
    temp0.y = frac(i.blendindices.x);
    // add r0.z, -r0.y, v0.x
    temp0.z = -temp0.y + i.blendindices.x;
    // slt r0.y, -r0.y, r0.y
    temp0.y = (-temp0.y < temp0.y) ? 1 : 0;
    // mad r0.x, r0.x, r0.y, r0.z
    temp0.x = temp0.x * temp0.y + temp0.z;
    // add r0.x, r0.x, r0.x
    temp0.x = temp0.x + temp0.x;
    // mova a0.x, r0.x
    addr0.x = temp0.x;
    // mul r0.x, v3.w, c129[a0.x].w
    temp0.x = i.color.w * WorldBones[1 + addr0.x].w;
    // mul oD0.x, r0.x, c1.x
    o.color = temp0.x * OpacityOverride.x;
    // mul r0, v1.zxyy, c128[a0.x].yzxy
    temp0 = i.position.zxyy * WorldBones[0 + addr0.x].yzxy;
    // mad r0, c128[a0.x].wwwx, v1.xyzx, r0
    temp0 = WorldBones[0 + addr0.x].wwwx * i.position.xyzx + temp0;
    // mul r1, v1.yzxz, c128[a0.x].zxyz
    temp1 = i.position.yzxz * WorldBones[0 + addr0.x].zxyz;
    // mad r0, r0, c0.xxxy, -r1
    temp0 = temp0 * float4(1, 1, 1, -1) + -temp1;
    // mul r1.xyz, r0.w, c128[a0.x]
    temp1.xyz = temp0.www * WorldBones[0 + addr0.x].xyz;
    // mad r1.xyz, c128[a0.x].w, r0, -r1
    temp1.xyz = WorldBones[0 + addr0.x].www * temp0.xyz + -temp1.xyz;
    // mad r1.xyz, c128[a0.x].yzxw, r0.zxyw, r1
    temp1.xyz = WorldBones[0 + addr0.x].yzx * temp0.zxy + temp1.xyz;
    // mad r0.xyz, c128[a0.x].zxyw, -r0.yzxw, r1
    temp0.xyz = WorldBones[0 + addr0.x].zxy * -temp0.yzx + temp1.xyz;
    // add r0.xyz, r0, c129[a0.x]
    temp0.xyz = temp0.xyz + WorldBones[1 + addr0.x].xyz;
    // mov r0.w, c0.x
    temp0.w = float1(1);
    // dp4 r1.w, r0, c122
    temp1.w = dot(temp0, (ViewProjection._m03_m13_m23_m33));
    // rcp r2.x, r1.w
    temp2.x = 1.0f / temp1.w;
    // dp4 r1.z, r0, c121
    temp1.z = dot(temp0, (ViewProjection._m02_m12_m22_m32));
    // mul oT1.x, r2.x, r1.z
    o.texcoord1 = temp2.x * temp1.z;
    // dp4 r1.x, r0, c119
    temp1.x = dot(temp0, (ViewProjection._m00_m10_m20_m30));
    // dp4 r1.y, r0, c120
    temp1.y = dot(temp0, (ViewProjection._m01_m11_m21_m31));
    // add r0, -r1, c0.xxxz
    temp0 = -temp1 + float4(1, 1, 1, 0);
    // mad oPos, c11.x, r0, r1
    o.position = expr11.x * temp0 + temp1;
    // mov oT0.xy, v2
    o.texcoord = i.texcoord;
    // 

    return o;
}

// VSCreateShadowMap_Array_Shader_2 Vertex_2_0 Has PRES True
struct VSCreateShadowMap_Array_Shader_2_Input
{
    float4 blendindices : BLENDINDICES;
    float4 blendweight : BLENDWEIGHT;
    float4 position : POSITION;
    float4 position1 : POSITION1;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct VSCreateShadowMap_Array_Shader_2_Output
{
    float color : COLOR;
    float texcoord1 : TEXCOORD1;
    float4 position : POSITION;
    float2 texcoord : TEXCOORD;
};

VSCreateShadowMap_Array_Shader_2_Output VSCreateShadowMap_Array_Shader_2(VSCreateShadowMap_Array_Shader_2_Input i)
{
    /*
    PRSI
      OutputRegisterOffset: 11
      Unknown1: 0
      Unknown2: 0
      OutputRegisterCount: 1
      Unknown3: 0
      Unknown4: 0
      Unknown5: 11
      Unknown6: 1
      Mappings: 1
        0 - ConstOutput: 0 ConstInput 0
    
    */
    float4 expr11;
    {
        float4 temp0;
        float4 temp1;
        // Expression_2_1
        // add r0.x, c0.x, (-2)
        temp0.x = BlendMode.x + (-2);
        // mul r1.x, r0.x, r0.x
        temp1.x = temp0.x * temp0.x;
        // neg r0.x, r1.x
        temp0.x = -temp1.x;
        // ge c11.x, r0.x, r1.x
        expr11.x = temp0.x >= temp1.x;
    }

    VSCreateShadowMap_Array_Shader_2_Output o;
    float4 temp0, temp1, temp2;
    float2 addr0;
    // def c0, 1, -1, 0, 0
    // dcl_blendindices v0
    // dcl_blendweight v1
    // dcl_position v2
    // dcl_position1 v3
    // dcl_texcoord v4
    // dcl_color v5
    // slt r0.xy, v0, -v0
    temp0.xy = (i.blendindices.xy < -i.blendindices.xy) ? 1 : 0;
    // frc r0.zw, v0.xyxy
    temp0.zw = frac(i.blendindices.xy);
    // add r1.xy, -r0.zwzw, v0
    temp1.xy = -temp0.zw + i.blendindices.xy;
    // slt r0.zw, -r0, r0
    temp0.zw = (-temp0.zw < temp0.zw) ? 1 : 0;
    // mad r0.xy, r0, r0.zwzw, r1
    temp0.xy = temp0.xy * temp0.zw + temp1.xy;
    // add r0.xy, r0, r0
    temp0.xy = temp0.xy + temp0.xy;
    // mova a0.xy, r0
    addr0.xy = temp0.xy;
    // mul r0.x, v1.y, c129[a0.y].w
    temp0.x = i.blendweight.y * WorldBones[1 + addr0.y].w;
    // mad r0.x, c129[a0.x].w, v1.x, r0.x
    temp0.x = WorldBones[1 + addr0.x].w * i.blendweight.x + temp0.x;
    // mul r0.x, r0.x, v5.w
    temp0.x = temp0.x * i.color.w;
    // mul oD0.x, r0.x, c1.x
    o.color = temp0.x * OpacityOverride.x;
    // mul r0, v3.zxyy, c128[a0.y].yzxy
    temp0 = i.position1.zxyy * WorldBones[0 + addr0.y].yzxy;
    // mad r0, c128[a0.y].wwwx, v3.xyzx, r0
    temp0 = WorldBones[0 + addr0.y].wwwx * i.position1.xyzx + temp0;
    // mul r1, v3.yzxz, c128[a0.y].zxyz
    temp1 = i.position1.yzxz * WorldBones[0 + addr0.y].zxyz;
    // mad r0, r0, c0.xxxy, -r1
    temp0 = temp0 * float4(1, 1, 1, -1) + -temp1;
    // mul r1.xyz, r0.w, c128[a0.y]
    temp1.xyz = temp0.www * WorldBones[0 + addr0.y].xyz;
    // mad r1.xyz, c128[a0.y].w, r0, -r1
    temp1.xyz = WorldBones[0 + addr0.y].www * temp0.xyz + -temp1.xyz;
    // mad r1.xyz, c128[a0.y].yzxw, r0.zxyw, r1
    temp1.xyz = WorldBones[0 + addr0.y].yzx * temp0.zxy + temp1.xyz;
    // mad r0.xyz, c128[a0.y].zxyw, -r0.yzxw, r1
    temp0.xyz = WorldBones[0 + addr0.y].zxy * -temp0.yzx + temp1.xyz;
    // add r0.xyz, r0, c129[a0.y]
    temp0.xyz = temp0.xyz + WorldBones[1 + addr0.y].xyz;
    // mul r0.xyz, r0, v1.y
    temp0.xyz = temp0.xyz * i.blendweight.yyy;
    // mul r1, v2.zxyy, c128[a0.x].yzxy
    temp1 = i.position.zxyy * WorldBones[0 + addr0.x].yzxy;
    // mad r1, c128[a0.x].wwwx, v2.xyzx, r1
    temp1 = WorldBones[0 + addr0.x].wwwx * i.position.xyzx + temp1;
    // mul r2, v2.yzxz, c128[a0.x].zxyz
    temp2 = i.position.yzxz * WorldBones[0 + addr0.x].zxyz;
    // mad r1, r1, c0.xxxy, -r2
    temp1 = temp1 * float4(1, 1, 1, -1) + -temp2;
    // mul r2.xyz, r1.w, c128[a0.x]
    temp2.xyz = temp1.www * WorldBones[0 + addr0.x].xyz;
    // mad r2.xyz, c128[a0.x].w, r1, -r2
    temp2.xyz = WorldBones[0 + addr0.x].www * temp1.xyz + -temp2.xyz;
    // mad r2.xyz, c128[a0.x].yzxw, r1.zxyw, r2
    temp2.xyz = WorldBones[0 + addr0.x].yzx * temp1.zxy + temp2.xyz;
    // mad r1.xyz, c128[a0.x].zxyw, -r1.yzxw, r2
    temp1.xyz = WorldBones[0 + addr0.x].zxy * -temp1.yzx + temp2.xyz;
    // add r1.xyz, r1, c129[a0.x]
    temp1.xyz = temp1.xyz + WorldBones[1 + addr0.x].xyz;
    // mad r0.xyz, r1, v1.x, r0
    temp0.xyz = temp1.xyz * i.blendweight.xxx + temp0.xyz;
    // mov r0.w, c0.x
    temp0.w = float1(1);
    // dp4 r1.z, r0, c121
    temp1.z = dot(temp0, (ViewProjection._m02_m12_m22_m32));
    // dp4 r1.w, r0, c122
    temp1.w = dot(temp0, (ViewProjection._m03_m13_m23_m33));
    // rcp r2.x, r1.w
    temp2.x = 1.0f / temp1.w;
    // mul oT1.x, r1.z, r2.x
    o.texcoord1 = temp1.z * temp2.x;
    // dp4 r1.x, r0, c119
    temp1.x = dot(temp0, (ViewProjection._m00_m10_m20_m30));
    // dp4 r1.y, r0, c120
    temp1.y = dot(temp0, (ViewProjection._m01_m11_m21_m31));
    // add r0, -r1, c0.xxxz
    temp0 = -temp1 + float4(1, 1, 1, 0);
    // mad oPos, c11.x, r0, r1
    o.position = expr11.x * temp0 + temp1;
    // mov oT0.xy, v4
    o.texcoord = i.texcoord;
    // 

    return o;
}

VertexShader VSCreateShadowMap_Array[3] = {
    compile vs_2_0 VSCreateShadowMap_Array_Shader_0(), // 82
    compile vs_2_0 VSCreateShadowMap_Array_Shader_1(), // 83
    compile vs_2_0 VSCreateShadowMap_Array_Shader_2(), // 84
};
// PSCreateShadowMap_Array_Shader_0 Pixel_2_0 Has PRES False
float4 PSCreateShadowMap_Array_Shader_0(float texcoord1 : TEXCOORD1) : COLOR
{
    float4 out_color;
    float4 temp0;
    // dcl t1.x
    // mov r0, t1.x
    temp0 = texcoord1.x;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// PSCreateShadowMap_Array_Shader_1 Pixel_2_0 Has PRES False
struct PSCreateShadowMap_Array_Shader_1_Input
{
    float color : COLOR;
    float2 texcoord : TEXCOORD;
    float texcoord1 : TEXCOORD1;
};

float4 PSCreateShadowMap_Array_Shader_1(PSCreateShadowMap_Array_Shader_1_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    // def c0, -0.3764706, 0, 0, 0
    // dcl v0.x
    // dcl t0.xy
    // dcl t1.x
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(Texture_0Sampler, i.texcoord.xy);
    // mad r0, v0.x, r0.w, c0.x
    temp0 = i.color.x * temp0.w + float4(-0.3764706, -0.3764706, -0.3764706, -0.3764706);
    // texkill r0
    clip(temp0);
    // mov r0, t1.x
    temp0 = i.texcoord1.x;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

PixelShader PSCreateShadowMap_Array[2] = {
    compile ps_2_0 PSCreateShadowMap_Array_Shader_0(), // 85
    compile ps_2_0 PSCreateShadowMap_Array_Shader_1(), // 86
};
// _CreateDepthMap_Expression24 Expression_2_0 Has PRES False
float _CreateDepthMap_Expression24()
{
    float4 temp0;
    float4 temp1;
    float4 temp2;
    float1 expr0;
    // add r0.x, c1.x, (-1)
    temp0.x = BlendMode.x + (-1);
    // mul r1.x, r0.x, r0.x
    temp1.x = temp0.x * temp0.x;
    // neg r0.x, r1.x
    temp0.x = -temp1.x;
    // ge r2.x, r0.x, r1.x
    temp2.x = temp0.x >= temp1.x;
    // add r0.x, r2.x, c0.x
    temp0.x = temp2.x + AlphaTestEnable.x;
    // neg r1.x, r0.x
    temp1.x = -temp0.x;
    // lt c0.x, r1.x, r0.x
    expr0.x = temp1.x < temp0.x;
    return expr0;
}

// _CreateDepthMap_Expression25 Expression_2_0 Has PRES False
float _CreateDepthMap_Expression25()
{
    float1 expr0;
    // min c0.x, c0.x, (2)
    expr0.x = min(NumJointsPerVertex.x, (2));
    return expr0;
}

// _Default_L_Expression26 Expression_2_0 Has PRES False
float _Default_L_Expression26()
{
    float1 expr0;
    // mul c0.x, c0.x, (3)
    expr0.x = HasShadow.x * (3);
    return expr0;
}

// _Default_L_Expression27 Expression_2_0 Has PRES False
float _Default_L_Expression27()
{
    float1 expr0;
    // min c0.x, c0.x, (2)
    expr0.x = min(NumJointsPerVertex.x, (2));
    return expr0;
}

// _Default_M_Expression28 Expression_2_0 Has PRES False
float _Default_M_Expression28()
{
    float1 expr0;
    // mul c0.x, c0.x, (3)
    expr0.x = HasShadow.x * (3);
    return expr0;
}

// _Default_M_Expression29 Expression_2_0 Has PRES False
float _Default_M_Expression29()
{
    float1 expr0;
    // min c0.x, c0.x, (2)
    expr0.x = min(NumJointsPerVertex.x, (2));
    return expr0;
}

// Default_Expression30 Expression_2_0 Has PRES False
float Default_Expression30()
{
    float1 expr0;
    // mul c0.x, c0.x, (3)
    expr0.x = HasShadow.x * (3);
    return expr0;
}

// Default_Expression31 Expression_2_0 Has PRES False
float Default_Expression31()
{
    float1 expr0;
    // min c0.x, c0.x, (2)
    expr0.x = min(NumJointsPerVertex.x, (2));
    return expr0;
}

technique Default
{
    pass P0 <string ExpressionEvaluator = "BasicW3D";>
    {
        VertexShader = VS_Array[Default_Expression31()]; // 65
        PixelShader = PS_Array[Default_Expression30()]; // 66
        ZEnable = 1;
        ZFunc = 4;
        AlphaFunc = 7;
        AlphaRef = 96;
    }
}

technique _Default_M
{
    pass P0 <string ExpressionEvaluator = "BasicW3D";>
    {
        VertexShader = VS_M_Array[_Default_M_Expression29()]; // 77
        PixelShader = PS_M_Array[_Default_M_Expression28()]; // 78
        ZEnable = 1;
        ZFunc = 4;
        AlphaFunc = 7;
        AlphaRef = 96;
    }
}

technique _Default_L
{
    pass P0 <string ExpressionEvaluator = "BasicW3D";>
    {
        VertexShader = VS_M_Array[_Default_L_Expression27()]; // 80
        PixelShader = PS_M_Array[_Default_L_Expression26()]; // 81
        ZEnable = 1;
        ZFunc = 4;
        AlphaFunc = 7;
        AlphaRef = 96;
    }
}

technique _CreateDepthMap
{
    pass P0 <string ExpressionEvaluator = "BasicW3D_CreateShadowMap";>
    {
        VertexShader = VSCreateShadowMap_Array[_CreateDepthMap_Expression25()]; // 88
        PixelShader = PSCreateShadowMap_Array[_CreateDepthMap_Expression24()]; // 89
        ZEnable = 1;
        ZFunc = 4;
        AlphaBlendEnable = 0;
        AlphaTestEnable = 0;
    }
}

