string DefaultParameterScopeBlock = "material"; // 1
float3 AmbientLightColor <bool unmanaged = 1;> = { 0.3, 0.3, 0.3 };
struct
{
    float3 Color;
    float3 Direction;
} DirectionalLight[3] : register(vs_3_0, c5) <bool unmanaged = 1;> = { 1.625198, 1.512711, 1.097048, 0.62914, -0.34874, 0.69465, 0.5232916, 0.6654605, 0.7815244, -0.32877, 0.90329, 0.27563, 0.4420466, 0.4102767, 0.4420466, -0.80704, -0.58635, 0.06975 };
int NumPointLights <string SasBindAddress = "Sas.NumPointLights"; string UIWidget = "None";>;
struct {
    float3 Color;
    float3 Position;
    float2 Range_Inner_Outer;
} PointLight[8] <bool unmanaged = 1;>;
struct
{
    float4 WorldPositionMultiplier_XYZZ;
    float2 CurrentOffsetUV;
} Cloud : register(vs_3_0, c117) <bool unmanaged = 1;>;
float3 NoCloudMultiplier <bool unmanaged = 1;> = { 1, 1, 1 };
float3 RecolorColorDummy <bool unmanaged = 1;>;
column_major float4x4 ShadowMapWorldToShadow : register(vs_3_0, c113) <bool unmanaged = 1;>;
float OpacityOverride : register(vs_2_0, c1) : register(ps_2_0, c1) : register(ps_3_0, c1) <bool unmanaged = 1;> = { 1 };
float3 TintColor : register(ps_2_0, c2) : register(ps_3_0, c2) <bool unmanaged = 1;> = { 1, 1, 1 };
float3 EyePosition : register(vs_2_0, c123) : register(vs_3_0, c123) : register(ps_3_0, c123) <bool unmanaged = 1;>;
column_major float4x4 ViewProjection : register(vs_2_0, c119) : register(vs_3_0, c119) <bool unmanaged = 1;>;
float4 WorldBones[128] : register(vs_2_0, c128) : register(vs_3_0, c128) <bool unmanaged = 1;>;
bool HasShadow <string UIWidget = "None"; string SasBindAddress = "Sas.HasShadow";>;
texture ShadowMap <string UIWidget = "None"; string SasBindAddress = "Sas.Shadow[0].ShadowMap";>; // 6
sampler2D ShadowMapSampler <string Texture = "ShadowMap"; string UIWidget = "None"; string SasBindAddress = "Sas.Shadow[0].ShadowMap";> =
sampler_state
{
    Texture = <ShadowMap>; // 9
    MinFilter = 1;
    MagFilter = 1;
    MipFilter = 0;
    AddressU = 3;
    AddressV = 3;
};
float4 Shadowmap_Zero_Zero_OneOverMapSize_OneOverMapSize <string UIWidget = "None"; string SasBindAddress = "Sas.Shadow[0].Zero_Zero_OneOverMapSize_OneOverMapSize";>;
float2 MapCellSize <string UIWidget = "None"; string SasBindAddress = "Terrain.Map.CellSize";> = { 10, 10 };
texture MacroSampler <string UIWidget = "None"; string SasBindAddress = "Terrain.MacroTexture"; string ResourceName = "ShaderPreviewMacro.dds";>; // 17
sampler2D MacroSamplerSampler <string Texture = "MacroSampler"; string UIWidget = "None"; string SasBindAddress = "Terrain.MacroTexture"; string ResourceName = "ShaderPreviewMacro.dds";> =
sampler_state
{
    Texture = <MacroSampler>; // 21
    MinFilter = 2;
    MagFilter = 2;
    MipFilter = 2;
    AddressU = 1;
    AddressV = 1;
};
int _SasGlobal : SasGlobal <string UIWidget = "None"; int3 SasVersion = int3(1, 0, 0); string RenderBin = "StaticSort1"; int MaxLocalLights = 8; int MaxSupportedInstancingMode = 1;>;
int NumJointsPerVertex <string UIWidget = "None"; string SasBindAddress = "Sas.Skeleton.NumJointsPerVertex";>;
column_major float4x3 World : World : register(vs_2_0, c124) : register(vs_3_0, c124);
texture CloudTexture <string UIWidget = "None"; string SasBindAddress = "Terrain.Cloud.Texture"; string ResourceName = "ShaderPreviewCloud.dds";>; // 30
sampler2D CloudTextureSampler <string Texture = "CloudTexture"; string UIWidget = "None"; string SasBindAddress = "Terrain.Cloud.Texture"; string ResourceName = "ShaderPreviewCloud.dds";> =
sampler_state
{
    Texture = <CloudTexture>; // 34
    MinFilter = 2;
    MagFilter = 2;
    MipFilter = 2;
    AddressU = 1;
    AddressV = 1;
};
texture EnvironmentTexture <string UIWidget = "None"; string SasBindAddress = "Objects.LightSpaceEnvironmentMap"; string ResourceType = "Cube";>; // 39
samplerCUBE EnvironmentTextureSampler <string Texture = "EnvironmentTexture"; string UIWidget = "None"; string SasBindAddress = "Objects.LightSpaceEnvironmentMap"; string ResourceType = "Cube";> =
sampler_state
{
    Texture = <EnvironmentTexture>; // 43
    MinFilter = 2;
    MagFilter = 2;
    MipFilter = 2;
    AddressU = 3;
    AddressV = 3;
    AddressW = 3;
};
texture DiffuseTexture <string UIName = "Diffuse Texture";>; // 48
sampler2D DiffuseTextureSampler <string Texture = "DiffuseTexture"; string UIName = "Diffuse Texture";> =
sampler_state
{
    Texture = <DiffuseTexture>; // 50
    MinFilter = 3;
    MagFilter = 2;
    MipFilter = 2;
    MaxAnisotropy = 8;
    AddressU = 1;
    AddressV = 1;
};
texture NormalMap <string UIName = "Normal Texture";>; // 53
sampler2D NormalMapSampler : register(ps_3_0, s0) <string Texture = "NormalMap"; string UIName = "Normal Texture";> =
sampler_state
{
    Texture = <NormalMap>; // 55
    MinFilter = 3;
    MagFilter = 2;
    MipFilter = 2;
    MaxAnisotropy = 8;
    AddressU = 1;
    AddressV = 1;
};
float BumpScale : register(ps_3_0, c11) <string UIName = "Bump Height"; string UIWidget = "Slider"; float UIMin = 0; float UIMax = 10; float UIStep = 0.1;> = { 1 };
float3 AmbientColor <string UIName = "Ambient Color"; string UIWidget = "Color";> = { 0.4, 0.4, 0.4 };
float4 DiffuseColor <string UIName = "Diffuse Color"; string UIWidget = "Color";> = { 1, 1, 1, 1 };
float3 SpecularColor <string UIName = "Specular Color"; string UIWidget = "Color";> = { 0.8, 0.8, 0.8 };
float SpecularExponent <string UIName = "Specular Exponent"; string UIWidget = "Slider"; float UIMax = 200; float UIMin = 0; float UIStep = 1;> = { 50 };
bool AlphaTestEnable <string UIName = "Alpha Test Enable";>;
struct
{
    float4 ScaleUV_OffsetUV;
} Shroud : register(vs_2_0, c11) : register(vs_3_0, c11) <string UIWidget = "None"; string SasBindAddress = "Terrain.Shroud";> = { 1, 1, 0, 0 };
texture ShroudTexture <string UIWidget = "None"; string SasBindAddress = "Terrain.Shroud.Texture";>; // 71
sampler2D ShroudTextureSampler : register(ps_3_0, s1) <string Texture = "ShroudTexture"; string UIWidget = "None"; string SasBindAddress = "Terrain.Shroud.Texture";> =
sampler_state
{
    Texture = <ShroudTexture>; // 74
    MinFilter = 2;
    MagFilter = 2;
    MipFilter = 2;
    AddressU = 3;
    AddressV = 3;
};
float Time : Time;
// VS_H_Array_Shader_0 Vertex_3_0 Has PRES True
struct VS_H_Array_Shader_0_Input
{
    float4 position : POSITION;
    float4 normal : NORMAL;
    float4 tangent : TANGENT;
    float4 binormal : BINORMAL;
    float4 texcoord : TEXCOORD;
};

struct VS_H_Array_Shader_0_Output
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float3 texcoord1 : TEXCOORD1;
    float3 texcoord2 : TEXCOORD2;
    float3 texcoord3 : TEXCOORD3;
    float3 texcoord4 : TEXCOORD4;
    float4 texcoord5 : TEXCOORD5;
    float4 texcoord6 : TEXCOORD6;
    float4 color : COLOR;
};

VS_H_Array_Shader_0_Output VS_H_Array_Shader_0(VS_H_Array_Shader_0_Input i)
{
    /*
    PRSI
      OutputRegisterOffset: 12
      Unknown1: 0
      Unknown2: 0
      OutputRegisterCount: 1
      Unknown3: 0
      Unknown4: 0
      Unknown5: 12
      Unknown6: 1
      Mappings: 1
        0 - ConstOutput: 0 ConstInput 0
    
    */
    float4 expr12;
    {
        // Expression_2_1
        // mul c12.x, c0.x, (0.3)
        expr12.x = Time.x * (0.3);
    }

    VS_H_Array_Shader_0_Output o;
    float4 temp0, temp1, temp2;
    // def c0, 1, 0, -0.0015, 0.003
    // def c1, 0.4301922, 0.6143571, -0.6143571, 0
    // dcl_position v0
    // dcl_normal v1
    // dcl_tangent v2
    // dcl_binormal v3
    // dcl_texcoord v4
    // dcl_position o0
    // dcl_texcoord o1
    // dcl_texcoord1 o2.xyz
    // dcl_texcoord2 o3.xyz
    // dcl_texcoord3 o4.xyz
    // dcl_texcoord4 o5.xyz
    // dcl_texcoord5 o6
    // dcl_texcoord6 o7
    // dcl_color o8
    // dp3 o2.z, v1, c124
    o.texcoord1.z = dot(i.normal.xyz, (World._m00_m10_m20_m30).xyz);
    // dp3 o3.z, v1, c125
    o.texcoord2.z = dot(i.normal.xyz, (World._m01_m11_m21_m31).xyz);
    // dp3 o4.z, v1, c126
    o.texcoord3.z = dot(i.normal.xyz, (World._m02_m12_m22_m32).xyz);
    // mov r0.w, c0.x
    temp0.w = float1(1);
    // mad r1, v0.xyzx, c0.xxxy, c0.yyyx
    temp1 = i.position.xyzx * float4(1, 1, 1, 0) + float4(0, 0, 0, 1);
    // dp4 r0.z, r1, c126
    temp0.z = dot(temp1, (World._m02_m12_m22_m32));
    // dp4 r0.x, r1, c124
    temp0.x = dot(temp1, (World._m00_m10_m20_m30));
    // dp4 r0.y, r1, c125
    temp0.y = dot(temp1, (World._m01_m11_m21_m31));
    // dp4 r1.x, r0, c116
    temp1.x = dot(temp0, (ShadowMapWorldToShadow._m03_m13_m23_m33));
    // rcp r1.y, r1.x
    temp1.y = 1.0f / temp1.x;
    // mov o6.w, r1.x
    o.texcoord5.w = temp1.x;
    // dp4 r1.x, r0, c115
    temp1.x = dot(temp0, (ShadowMapWorldToShadow._m02_m12_m22_m32));
    // mad o6.z, r1.x, r1.y, c0.z
    o.texcoord5.z = temp1.x * temp1.y + float1(-0.0015);
    // dp4 o0.x, r0, c119
    o.position.x = dot(temp0, (ViewProjection._m00_m10_m20_m30));
    // dp4 o0.y, r0, c120
    o.position.y = dot(temp0, (ViewProjection._m01_m11_m21_m31));
    // dp4 o0.z, r0, c121
    o.position.z = dot(temp0, (ViewProjection._m02_m12_m22_m32));
    // dp4 o0.w, r0, c122
    o.position.w = dot(temp0, (ViewProjection._m03_m13_m23_m33));
    // mad r1, r0.xyxy, c0.w, v4.xyxy
    temp1 = temp0.xyxy * float4(0.003, 0.003, 0.003, 0.003) + i.texcoord.xyxy;
    // mul r2, r1, c1.xyzx
    temp2 = temp1 * float4(0.43019223, 0.6143571, -0.6143571, 0.43019223);
    // mul r1, r1, c1.xzyx
    temp1 = temp1 * float4(0.43019223, -0.6143571, 0.6143571, 0.43019223);
    // add o1.y, r2.w, r2.z
    o.texcoord.y = temp2.w + temp2.z;
    // add r0.w, r2.y, r2.x
    temp0.w = temp2.y + temp2.x;
    // add o1.x, r0.w, c12.x
    o.texcoord.x = temp0.w + expr12.x;
    // add o1.w, r1.w, r1.z
    o.texcoord.w = temp1.w + temp1.z;
    // add r0.w, r1.y, r1.x
    temp0.w = temp1.y + temp1.x;
    // add o1.z, r0.w, c12.x
    o.texcoord.z = temp0.w + expr12.x;
    // add r1.xy, r0, c11.zwzw
    temp1.xy = temp0.xy + Shroud.ScaleUV_OffsetUV.zw;
    // mul o7.xy, r1, c11
    o.texcoord6.xy = temp1.xy * Shroud.ScaleUV_OffsetUV.xy;
    // mul r1.xy, r0.z, c117.zwzw
    temp1.xy = temp0.zz * Cloud.WorldPositionMultiplier_XYZZ.zw;
    // mov o5.xyz, r0
    o.texcoord4 = temp0;
    // mad r0.xy, r0, c117, -r1
    temp0.xy = temp0.xy * Cloud.WorldPositionMultiplier_XYZZ.xy + -temp1.xy;
    // add o7.zw, r0.xyxy, c118.xyxy
    o.texcoord6.zw = temp0.xy + Cloud.CurrentOffsetUV.xy;
    // dp3 r0.x, v3, c124
    temp0.x = dot(i.binormal.xyz, (World._m00_m10_m20_m30).xyz);
    // mov o2.x, -r0.x
    o.texcoord1.x = -temp0.x;
    // dp3 r0.x, v2, c124
    temp0.x = dot(i.tangent.xyz, (World._m00_m10_m20_m30).xyz);
    // mov o2.y, -r0.x
    o.texcoord1.y = -temp0.x;
    // dp3 r0.x, v3, c125
    temp0.x = dot(i.binormal.xyz, (World._m01_m11_m21_m31).xyz);
    // mov o3.x, -r0.x
    o.texcoord2.x = -temp0.x;
    // dp3 r0.x, v2, c125
    temp0.x = dot(i.tangent.xyz, (World._m01_m11_m21_m31).xyz);
    // mov o3.y, -r0.x
    o.texcoord2.y = -temp0.x;
    // dp3 r0.x, v3, c126
    temp0.x = dot(i.binormal.xyz, (World._m02_m12_m22_m32).xyz);
    // mov o4.x, -r0.x
    o.texcoord3.x = -temp0.x;
    // dp3 r0.x, v2, c126
    temp0.x = dot(i.tangent.xyz, (World._m02_m12_m22_m32).xyz);
    // mov o4.y, -r0.x
    o.texcoord3.y = -temp0.x;
    // mov o6.xy, v4
    o.texcoord5.xy = i.texcoord.xy;
    // mov o8, c0.y
    o.color = float4(0, 0, 0, 0);
    // 

    return o;
}

// VS_H_Array_Shader_1 Vertex_3_0 Has PRES True
struct VS_H_Array_Shader_1_Input
{
    float4 position : POSITION;
    float4 normal : NORMAL;
    float4 tangent : TANGENT;
    float4 binormal : BINORMAL;
    float4 blendindices : BLENDINDICES;
    float4 texcoord : TEXCOORD;
};

struct VS_H_Array_Shader_1_Output
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float3 texcoord1 : TEXCOORD1;
    float3 texcoord2 : TEXCOORD2;
    float3 texcoord3 : TEXCOORD3;
    float3 texcoord4 : TEXCOORD4;
    float4 texcoord5 : TEXCOORD5;
    float4 texcoord6 : TEXCOORD6;
    float4 color : COLOR;
};

VS_H_Array_Shader_1_Output VS_H_Array_Shader_1(VS_H_Array_Shader_1_Input i)
{
    /*
    PRSI
      OutputRegisterOffset: 12
      Unknown1: 0
      Unknown2: 0
      OutputRegisterCount: 1
      Unknown3: 0
      Unknown4: 0
      Unknown5: 12
      Unknown6: 1
      Mappings: 1
        0 - ConstOutput: 0 ConstInput 0
    
    */
    float4 expr12;
    {
        // Expression_2_1
        // mul c12.x, c0.x, (0.3)
        expr12.x = Time.x * (0.3);
    }

    VS_H_Array_Shader_1_Output o;
    float4 temp0, temp1, temp2, temp3;
    float addr0;
    // def c0, 1, -1, -0.0015, 0.003
    // def c1, 0.4301922, 0.6143571, -0.6143571, 0
    // dcl_position v0
    // dcl_normal v1
    // dcl_tangent v2
    // dcl_binormal v3
    // dcl_blendindices v4
    // dcl_texcoord v5
    // dcl_position o0
    // dcl_texcoord o1
    // dcl_texcoord1 o2.xyz
    // dcl_texcoord2 o3.xyz
    // dcl_texcoord3 o4.xyz
    // dcl_texcoord4 o5.xyz
    // dcl_texcoord5 o6
    // dcl_texcoord6 o7
    // dcl_color o8
    // add r0.x, v4.x, v4.x
    temp0.x = i.blendindices.x + i.blendindices.x;
    // frc r0.y, r0.x
    temp0.y = frac(temp0.x);
    // add r0.z, r0.x, -r0.y
    temp0.z = temp0.x + -temp0.y;
    // slt r0.y, -r0.y, r0.y
    temp0.y = (-temp0.y < temp0.y) ? 1 : 0;
    // slt r0.x, r0.x, -r0.x
    temp0.x = (temp0.x < -temp0.x) ? 1 : 0;
    // mad r0.x, r0.x, r0.y, r0.z
    temp0.x = temp0.x * temp0.y + temp0.z;
    // mova a0.x, r0.x
    addr0.x = temp0.x;
    // mul r0, v0.zxyy, c128[a0.x].yzxy
    temp0 = i.position.zxyy * WorldBones[0 + addr0.x].yzxy;
    // mad r0, c128[a0.x].wwwx, v0.xyzx, r0
    temp0 = WorldBones[0 + addr0.x].wwwx * i.position.xyzx + temp0;
    // mul r1, v0.yzxz, c128[a0.x].zxyz
    temp1 = i.position.yzxz * WorldBones[0 + addr0.x].zxyz;
    // mad r0, r0, c0.xxxy, -r1
    temp0 = temp0 * float4(1, 1, 1, -1) + -temp1;
    // mul r1.xyz, r0.w, c128[a0.x]
    temp1.xyz = temp0.www * WorldBones[0 + addr0.x].xyz;
    // mad r1.xyz, c128[a0.x].w, r0, -r1
    temp1.xyz = WorldBones[0 + addr0.x].www * temp0.xyz + -temp1.xyz;
    // mad r1.xyz, c128[a0.x].yzxw, r0.zxyw, r1
    temp1.xyz = WorldBones[0 + addr0.x].yzx * temp0.zxy + temp1.xyz;
    // mad r0.xyz, c128[a0.x].zxyw, -r0.yzxw, r1
    temp0.xyz = WorldBones[0 + addr0.x].zxy * -temp0.yzx + temp1.xyz;
    // add r0.xyz, r0, c129[a0.x]
    temp0.xyz = temp0.xyz + WorldBones[1 + addr0.x].xyz;
    // mov r0.w, c0.x
    temp0.w = float1(1);
    // dp4 r1.x, r0, c116
    temp1.x = dot(temp0, (ShadowMapWorldToShadow._m03_m13_m23_m33));
    // rcp r1.y, r1.x
    temp1.y = 1.0f / temp1.x;
    // mov o6.w, r1.x
    o.texcoord5.w = temp1.x;
    // dp4 r1.x, r0, c115
    temp1.x = dot(temp0, (ShadowMapWorldToShadow._m02_m12_m22_m32));
    // mad o6.z, r1.x, r1.y, c0.z
    o.texcoord5.z = temp1.x * temp1.y + float1(-0.0015);
    // dp4 o0.x, r0, c119
    o.position.x = dot(temp0, (ViewProjection._m00_m10_m20_m30));
    // dp4 o0.y, r0, c120
    o.position.y = dot(temp0, (ViewProjection._m01_m11_m21_m31));
    // dp4 o0.z, r0, c121
    o.position.z = dot(temp0, (ViewProjection._m02_m12_m22_m32));
    // dp4 o0.w, r0, c122
    o.position.w = dot(temp0, (ViewProjection._m03_m13_m23_m33));
    // mad r1.xy, r0.yxzw, c0.w, v5.yxzw
    temp1.xy = temp0.yx * float2(0.003, 0.003) + i.texcoord.yx;
    // mul r2, r1.yxyx, c1.xyzx
    temp2 = temp1.yxyx * float4(0.43019223, 0.6143571, -0.6143571, 0.43019223);
    // add o1.y, r2.w, r2.z
    o.texcoord.y = temp2.w + temp2.z;
    // add r0.w, r2.y, r2.x
    temp0.w = temp2.y + temp2.x;
    // mad o1.w, r1.y, c1.y, r2.w
    o.texcoord.w = temp1.y * float1(0.6143571) + temp2.w;
    // add o1.x, r0.w, c12.x
    o.texcoord.x = temp0.w + expr12.x;
    // mul r0.w, r1.x, c1.z
    temp0.w = temp1.x * float1(-0.6143571);
    // mad r0.w, r1.y, c1.x, r0.w
    temp0.w = temp1.y * float1(0.43019223) + temp0.w;
    // add o1.z, r0.w, c12.x
    o.texcoord.z = temp0.w + expr12.x;
    // add r1.xy, r0, c11.zwzw
    temp1.xy = temp0.xy + Shroud.ScaleUV_OffsetUV.zw;
    // mul o7.xy, r1, c11
    o.texcoord6.xy = temp1.xy * Shroud.ScaleUV_OffsetUV.xy;
    // mul r1.xy, r0.z, c117.zwzw
    temp1.xy = temp0.zz * Cloud.WorldPositionMultiplier_XYZZ.zw;
    // mad r1.xy, r0, c117, -r1
    temp1.xy = temp0.xy * Cloud.WorldPositionMultiplier_XYZZ.xy + -temp1.xy;
    // mov o5.xyz, r0
    o.texcoord4 = temp0;
    // add o7.zw, r1.xyxy, c118.xyxy
    o.texcoord6.zw = temp1.xy + Cloud.CurrentOffsetUV.xy;
    // mul r0, v3.zxyy, c128[a0.x].yzxy
    temp0 = i.binormal.zxyy * WorldBones[0 + addr0.x].yzxy;
    // mad r0, c128[a0.x].wwwx, v3.xyzx, r0
    temp0 = WorldBones[0 + addr0.x].wwwx * i.binormal.xyzx + temp0;
    // mul r1, v3.yzxz, c128[a0.x].zxyz
    temp1 = i.binormal.yzxz * WorldBones[0 + addr0.x].zxyz;
    // mad r0, r0, c0.xxxy, -r1
    temp0 = temp0 * float4(1, 1, 1, -1) + -temp1;
    // mul r1.xyz, r0.w, c128[a0.x]
    temp1.xyz = temp0.www * WorldBones[0 + addr0.x].xyz;
    // mad r1.xyz, c128[a0.x].w, r0, -r1
    temp1.xyz = WorldBones[0 + addr0.x].www * temp0.xyz + -temp1.xyz;
    // mad r1.xyz, c128[a0.x].yzxw, r0.zxyw, r1
    temp1.xyz = WorldBones[0 + addr0.x].yzx * temp0.zxy + temp1.xyz;
    // mad r0.xyz, c128[a0.x].zxyw, -r0.yzxw, r1
    temp0.xyz = WorldBones[0 + addr0.x].zxy * -temp0.yzx + temp1.xyz;
    // mov o2.x, -r0.x
    o.texcoord1.x = -temp0.x;
    // mul r1, v2.zxyy, c128[a0.x].yzxy
    temp1 = i.tangent.zxyy * WorldBones[0 + addr0.x].yzxy;
    // mad r1, c128[a0.x].wwwx, v2.xyzx, r1
    temp1 = WorldBones[0 + addr0.x].wwwx * i.tangent.xyzx + temp1;
    // mul r2, v2.yzxz, c128[a0.x].zxyz
    temp2 = i.tangent.yzxz * WorldBones[0 + addr0.x].zxyz;
    // mad r1, r1, c0.xxxy, -r2
    temp1 = temp1 * float4(1, 1, 1, -1) + -temp2;
    // mul r2.xyz, r1.w, c128[a0.x]
    temp2.xyz = temp1.www * WorldBones[0 + addr0.x].xyz;
    // mad r2.xyz, c128[a0.x].w, r1, -r2
    temp2.xyz = WorldBones[0 + addr0.x].www * temp1.xyz + -temp2.xyz;
    // mad r2.xyz, c128[a0.x].yzxw, r1.zxyw, r2
    temp2.xyz = WorldBones[0 + addr0.x].yzx * temp1.zxy + temp2.xyz;
    // mad r1.xyz, c128[a0.x].zxyw, -r1.yzxw, r2
    temp1.xyz = WorldBones[0 + addr0.x].zxy * -temp1.yzx + temp2.xyz;
    // mov o2.y, -r1.x
    o.texcoord1.y = -temp1.x;
    // mul r2, v1.zxyy, c128[a0.x].yzxy
    temp2 = i.normal.zxyy * WorldBones[0 + addr0.x].yzxy;
    // mad r2, c128[a0.x].wwwx, v1.xyzx, r2
    temp2 = WorldBones[0 + addr0.x].wwwx * i.normal.xyzx + temp2;
    // mul r3, v1.yzxz, c128[a0.x].zxyz
    temp3 = i.normal.yzxz * WorldBones[0 + addr0.x].zxyz;
    // mad r2, r2, c0.xxxy, -r3
    temp2 = temp2 * float4(1, 1, 1, -1) + -temp3;
    // mul r3.xyz, r2.w, c128[a0.x]
    temp3.xyz = temp2.www * WorldBones[0 + addr0.x].xyz;
    // mad r3.xyz, c128[a0.x].w, r2, -r3
    temp3.xyz = WorldBones[0 + addr0.x].www * temp2.xyz + -temp3.xyz;
    // mad r3.xyz, c128[a0.x].yzxw, r2.zxyw, r3
    temp3.xyz = WorldBones[0 + addr0.x].yzx * temp2.zxy + temp3.xyz;
    // mad r2.xyz, c128[a0.x].zxyw, -r2.yzxw, r3
    temp2.xyz = WorldBones[0 + addr0.x].zxy * -temp2.yzx + temp3.xyz;
    // mov o2.z, r2.x
    o.texcoord1.z = temp2.x;
    // mov o3.x, -r0.y
    o.texcoord2.x = -temp0.y;
    // mov o4.x, -r0.z
    o.texcoord3.x = -temp0.z;
    // mov o3.y, -r1.y
    o.texcoord2.y = -temp1.y;
    // mov o4.y, -r1.z
    o.texcoord3.y = -temp1.z;
    // mov o3.z, r2.y
    o.texcoord2.z = temp2.y;
    // mov o4.z, r2.z
    o.texcoord3.z = temp2.z;
    // mov o6.xy, v5
    o.texcoord5.xy = i.texcoord.xy;
    // mov o8, c1.w
    o.color = float4(0, 0, 0, 0);
    // 

    return o;
}

VertexShader VS_H_Array[2] = {
    compile vs_3_0 VS_H_Array_Shader_0(), // 78
    compile vs_3_0 VS_H_Array_Shader_1(), // 79
};
// PS_H_Array_Shader_0 Pixel_3_0 Has PRES False
struct PS_H_Array_Shader_0_Input
{
    float3 texcoord1 : TEXCOORD1;
    float3 texcoord2 : TEXCOORD2;
    float3 texcoord3 : TEXCOORD3;
    float3 texcoord4 : TEXCOORD4;
    float2 texcoord5 : TEXCOORD5;
    float2 texcoord6 : TEXCOORD6;
};

float4 PS_H_Array_Shader_0(PS_H_Array_Shader_0_Input i) : COLOR
{
    float4 out_color;
    float4 temp0, temp1;
    float3 temp2;
    // def c0, 2, -1, 1, 2.5
    // def c3, 0, 3, 0.055, 0.045
    // dcl_texcoord1_centroid v0.xyz
    // dcl_texcoord2_centroid v1.xyz
    // dcl_texcoord3_centroid v2.xyz
    // dcl_texcoord4 v3.xyz
    // dcl_texcoord5 v4.xy
    // dcl_texcoord6 v5.xy
    // dcl_2d s0
    // dcl_2d s1
    // texld r0, v4, s0
    temp0 = tex2D(NormalMapSampler, i.texcoord5.xy);
    // mad r0.xyz, r0, c0.x, c0.y
    temp0.xyz = temp0.xyz * float3(2, 2, 2) + float3(-1, -1, -1);
    // mul r0.xy, r0, c11.x
    temp0.xy = temp0.xy * BumpScale.xx;
    // dp3 r1.x, r0, v0
    temp1.x = dot(temp0.xyz, i.texcoord1.xyz);
    // dp3 r1.y, r0, v1
    temp1.y = dot(temp0.xyz, i.texcoord2.xyz);
    // dp3 r1.z, r0, v2
    temp1.z = dot(temp0.xyz, i.texcoord3.xyz);
    // nrm r0.xyz, r1
    temp0.xyz = normalize(temp1.xyz).xyz;
    // add r1.xyz, c123, -v3
    temp1.xyz = EyePosition.xyz + -i.texcoord4.xyz;
    // nrm r2.xyz, r1
    temp2.xyz = normalize(temp1.xyz).xyz;
    // dp3 r0.x, r2, r0
    temp0.x = dot(temp2.xyz, temp0.xyz);
    // add r0.x, -r0.x, c0.z
    temp0.x = -temp0.x + float1(1);
    // pow r1.x, r0.x, c0.w
    temp1.x = pow(temp0.x, float1(2.5));
    // mad r0.xyz, r1.x, c3.xyxw, c3.xzww
    temp0.xyz = temp1.xxx * float3(0, 3, 0) + float3(0, 0.055, 0.045);
    // min r1.xyz, c0.x, r0
    temp1.xyz = min(float3(2, 2, 2), temp0.xyz);
    // mul r0.xyz, r1, c2
    temp0.xyz = temp1.xyz * TintColor.xyz;
    // texld r1, v5, s1
    temp1 = tex2D(ShroudTextureSampler, i.texcoord6.xy);
    // mul oC0.xyz, r0, r1
    out_color.xyz = temp0.xyz * temp1.xyz;
    // mov oC0.w, c1.x
    out_color.w = OpacityOverride.x;
    // 

    return out_color;
}

// PS_H_Array_Shader_1 Pixel_3_0 Has PRES False
struct PS_H_Array_Shader_1_Input
{
    float3 texcoord1 : TEXCOORD1;
    float3 texcoord2 : TEXCOORD2;
    float3 texcoord3 : TEXCOORD3;
    float3 texcoord4 : TEXCOORD4;
    float2 texcoord5 : TEXCOORD5;
    float2 texcoord6 : TEXCOORD6;
};

float4 PS_H_Array_Shader_1(PS_H_Array_Shader_1_Input i) : COLOR
{
    float4 out_color;
    float4 temp0, temp1;
    float3 temp2;
    // def c0, 2, -1, 1, 2.5
    // def c3, 0, 3, 0.055, 0.045
    // dcl_texcoord1_centroid v0.xyz
    // dcl_texcoord2_centroid v1.xyz
    // dcl_texcoord3_centroid v2.xyz
    // dcl_texcoord4 v3.xyz
    // dcl_texcoord5 v4.xy
    // dcl_texcoord6 v5.xy
    // dcl_2d s0
    // dcl_2d s1
    // texld r0, v4, s0
    temp0 = tex2D(NormalMapSampler, i.texcoord5.xy);
    // mad r0.xyz, r0, c0.x, c0.y
    temp0.xyz = temp0.xyz * float3(2, 2, 2) + float3(-1, -1, -1);
    // mul r0.xy, r0, c11.x
    temp0.xy = temp0.xy * BumpScale.xx;
    // dp3 r1.x, r0, v0
    temp1.x = dot(temp0.xyz, i.texcoord1.xyz);
    // dp3 r1.y, r0, v1
    temp1.y = dot(temp0.xyz, i.texcoord2.xyz);
    // dp3 r1.z, r0, v2
    temp1.z = dot(temp0.xyz, i.texcoord3.xyz);
    // nrm r0.xyz, r1
    temp0.xyz = normalize(temp1.xyz).xyz;
    // add r1.xyz, c123, -v3
    temp1.xyz = EyePosition.xyz + -i.texcoord4.xyz;
    // nrm r2.xyz, r1
    temp2.xyz = normalize(temp1.xyz).xyz;
    // dp3 r0.x, r2, r0
    temp0.x = dot(temp2.xyz, temp0.xyz);
    // add r0.x, -r0.x, c0.z
    temp0.x = -temp0.x + float1(1);
    // pow r1.x, r0.x, c0.w
    temp1.x = pow(temp0.x, float1(2.5));
    // mad r0.xyz, r1.x, c3.xyxw, c3.xzww
    temp0.xyz = temp1.xxx * float3(0, 3, 0) + float3(0, 0.055, 0.045);
    // min r1.xyz, c0.x, r0
    temp1.xyz = min(float3(2, 2, 2), temp0.xyz);
    // mul r0.xyz, r1, c2
    temp0.xyz = temp1.xyz * TintColor.xyz;
    // texld r1, v5, s1
    temp1 = tex2D(ShroudTextureSampler, i.texcoord6.xy);
    // mul oC0.xyz, r0, r1
    out_color.xyz = temp0.xyz * temp1.xyz;
    // mov oC0.w, c1.x
    out_color.w = OpacityOverride.x;
    // 

    return out_color;
}

// PS_H_Array_Shader_2 Pixel_3_0 Has PRES False
struct PS_H_Array_Shader_2_Input
{
    float3 texcoord1 : TEXCOORD1;
    float3 texcoord2 : TEXCOORD2;
    float3 texcoord3 : TEXCOORD3;
    float3 texcoord4 : TEXCOORD4;
    float2 texcoord5 : TEXCOORD5;
    float2 texcoord6 : TEXCOORD6;
};

float4 PS_H_Array_Shader_2(PS_H_Array_Shader_2_Input i) : COLOR
{
    float4 out_color;
    float4 temp0, temp1;
    float3 temp2;
    // def c0, 2, -1, 1, 2.5
    // def c3, 0, 3, 0.055, 0.045
    // dcl_texcoord1_centroid v0.xyz
    // dcl_texcoord2_centroid v1.xyz
    // dcl_texcoord3_centroid v2.xyz
    // dcl_texcoord4 v3.xyz
    // dcl_texcoord5 v4.xy
    // dcl_texcoord6 v5.xy
    // dcl_2d s0
    // dcl_2d s1
    // texld r0, v4, s0
    temp0 = tex2D(NormalMapSampler, i.texcoord5.xy);
    // mad r0.xyz, r0, c0.x, c0.y
    temp0.xyz = temp0.xyz * float3(2, 2, 2) + float3(-1, -1, -1);
    // mul r0.xy, r0, c11.x
    temp0.xy = temp0.xy * BumpScale.xx;
    // dp3 r1.x, r0, v0
    temp1.x = dot(temp0.xyz, i.texcoord1.xyz);
    // dp3 r1.y, r0, v1
    temp1.y = dot(temp0.xyz, i.texcoord2.xyz);
    // dp3 r1.z, r0, v2
    temp1.z = dot(temp0.xyz, i.texcoord3.xyz);
    // nrm r0.xyz, r1
    temp0.xyz = normalize(temp1.xyz).xyz;
    // add r1.xyz, c123, -v3
    temp1.xyz = EyePosition.xyz + -i.texcoord4.xyz;
    // nrm r2.xyz, r1
    temp2.xyz = normalize(temp1.xyz).xyz;
    // dp3 r0.x, r2, r0
    temp0.x = dot(temp2.xyz, temp0.xyz);
    // add r0.x, -r0.x, c0.z
    temp0.x = -temp0.x + float1(1);
    // pow r1.x, r0.x, c0.w
    temp1.x = pow(temp0.x, float1(2.5));
    // mad r0.xyz, r1.x, c3.xyxw, c3.xzww
    temp0.xyz = temp1.xxx * float3(0, 3, 0) + float3(0, 0.055, 0.045);
    // min r1.xyz, c0.x, r0
    temp1.xyz = min(float3(2, 2, 2), temp0.xyz);
    // mul r0.xyz, r1, c2
    temp0.xyz = temp1.xyz * TintColor.xyz;
    // texld r1, v5, s1
    temp1 = tex2D(ShroudTextureSampler, i.texcoord6.xy);
    // mul oC0.xyz, r0, r1
    out_color.xyz = temp0.xyz * temp1.xyz;
    // mov oC0.w, c1.x
    out_color.w = OpacityOverride.x;
    // 

    return out_color;
}

// PS_H_Array_Shader_3 Pixel_3_0 Has PRES False
struct PS_H_Array_Shader_3_Input
{
    float3 texcoord1 : TEXCOORD1;
    float3 texcoord2 : TEXCOORD2;
    float3 texcoord3 : TEXCOORD3;
    float3 texcoord4 : TEXCOORD4;
    float2 texcoord5 : TEXCOORD5;
    float2 texcoord6 : TEXCOORD6;
};

float4 PS_H_Array_Shader_3(PS_H_Array_Shader_3_Input i) : COLOR
{
    float4 out_color;
    float4 temp0, temp1;
    float3 temp2;
    // def c0, 2, -1, 1, 2.5
    // def c3, 0, 3, 0.055, 0.045
    // dcl_texcoord1_centroid v0.xyz
    // dcl_texcoord2_centroid v1.xyz
    // dcl_texcoord3_centroid v2.xyz
    // dcl_texcoord4 v3.xyz
    // dcl_texcoord5 v4.xy
    // dcl_texcoord6 v5.xy
    // dcl_2d s0
    // dcl_2d s1
    // texld r0, v4, s0
    temp0 = tex2D(NormalMapSampler, i.texcoord5.xy);
    // mad r0.xyz, r0, c0.x, c0.y
    temp0.xyz = temp0.xyz * float3(2, 2, 2) + float3(-1, -1, -1);
    // mul r0.xy, r0, c11.x
    temp0.xy = temp0.xy * BumpScale.xx;
    // dp3 r1.x, r0, v0
    temp1.x = dot(temp0.xyz, i.texcoord1.xyz);
    // dp3 r1.y, r0, v1
    temp1.y = dot(temp0.xyz, i.texcoord2.xyz);
    // dp3 r1.z, r0, v2
    temp1.z = dot(temp0.xyz, i.texcoord3.xyz);
    // nrm r0.xyz, r1
    temp0.xyz = normalize(temp1.xyz).xyz;
    // add r1.xyz, c123, -v3
    temp1.xyz = EyePosition.xyz + -i.texcoord4.xyz;
    // nrm r2.xyz, r1
    temp2.xyz = normalize(temp1.xyz).xyz;
    // dp3 r0.x, r2, r0
    temp0.x = dot(temp2.xyz, temp0.xyz);
    // add r0.x, -r0.x, c0.z
    temp0.x = -temp0.x + float1(1);
    // pow r1.x, r0.x, c0.w
    temp1.x = pow(temp0.x, float1(2.5));
    // mad r0.xyz, r1.x, c3.xyxw, c3.xzww
    temp0.xyz = temp1.xxx * float3(0, 3, 0) + float3(0, 0.055, 0.045);
    // min r1.xyz, c0.x, r0
    temp1.xyz = min(float3(2, 2, 2), temp0.xyz);
    // mul r0.xyz, r1, c2
    temp0.xyz = temp1.xyz * TintColor.xyz;
    // texld r1, v5, s1
    temp1 = tex2D(ShroudTextureSampler, i.texcoord6.xy);
    // mul oC0.xyz, r0, r1
    out_color.xyz = temp0.xyz * temp1.xyz;
    // mov oC0.w, c1.x
    out_color.w = OpacityOverride.x;
    // 

    return out_color;
}

PixelShader PS_H_Array[4] = {
    compile ps_3_0 PS_H_Array_Shader_0(), // 80
    compile ps_3_0 PS_H_Array_Shader_1(), // 81
    compile ps_3_0 PS_H_Array_Shader_2(), // 82
    compile ps_3_0 PS_H_Array_Shader_3(), // 83
};
// VS_M_Array_Shader_0 Vertex_3_0 Has PRES True
struct VS_M_Array_Shader_0_Input
{
    float4 position : POSITION;
    float4 normal : NORMAL;
    float4 tangent : TANGENT;
    float4 binormal : BINORMAL;
    float4 texcoord : TEXCOORD;
};

struct VS_M_Array_Shader_0_Output
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 texcoord1 : TEXCOORD1;
    float3 texcoord2 : TEXCOORD2;
    float4 texcoord3 : TEXCOORD3;
    float4 texcoord4 : TEXCOORD4;
    float2 texcoord5 : TEXCOORD5;
    float3 texcoord6 : TEXCOORD6;
    float4 color : COLOR;
};

VS_M_Array_Shader_0_Output VS_M_Array_Shader_0(VS_M_Array_Shader_0_Input i)
{
    /*
    PRSI
      OutputRegisterOffset: 11
      Unknown1: 0
      Unknown2: 0
      OutputRegisterCount: 2
      Unknown3: 0
      Unknown4: 0
      Unknown5: 11
      Unknown6: 2
      Mappings: 1
        0 - ConstOutput: 0 ConstInput 0
    
    */
    float4 expr11;
    float4 expr12;
    {
        float4 temp0;
        // Expression_2_1
        // mul c11.x, c1.x, (0.3)
        expr11.x = Time.x * (0.3);
        // mul r0.x, c0.x, (66)
        temp0.x = MapCellSize.x * (66);
        // rcp c12.x, r0.x
        expr12.x = 1.0f / (temp0.x);
    }

    VS_M_Array_Shader_0_Output o;
    float4 temp0, temp1, temp2, temp3;
    float3 temp4, temp5, temp6;
    // def c0, 1, 0, -0.0015, 0.003
    // def c1, 0.4301922, 0.6143571, -0.6143571, 0
    // def c2, 1, -1, 0, 0
    // dcl_position v0
    // dcl_normal v1
    // dcl_tangent v2
    // dcl_binormal v3
    // dcl_texcoord v4
    // dcl_position o0
    // dcl_texcoord o1
    // dcl_texcoord1 o2
    // dcl_texcoord2 o3.xyz
    // dcl_texcoord3 o4
    // dcl_texcoord4 o5
    // dcl_texcoord5 o6.xy
    // dcl_texcoord6 o7.xyz
    // dcl_color o8
    // mov r0.w, c0.x
    temp0.w = float1(1);
    // mad r1, v0.xyzx, c0.xxxy, c0.yyyx
    temp1 = i.position.xyzx * float4(1, 1, 1, 0) + float4(0, 0, 0, 1);
    // dp4 r0.z, r1, c126
    temp0.z = dot(temp1, (World._m02_m12_m22_m32));
    // dp4 r0.x, r1, c124
    temp0.x = dot(temp1, (World._m00_m10_m20_m30));
    // dp4 r0.y, r1, c125
    temp0.y = dot(temp1, (World._m01_m11_m21_m31));
    // dp4 o0.x, r0, c119
    o.position.x = dot(temp0, (ViewProjection._m00_m10_m20_m30));
    // dp4 o0.y, r0, c120
    o.position.y = dot(temp0, (ViewProjection._m01_m11_m21_m31));
    // dp4 o0.z, r0, c121
    o.position.z = dot(temp0, (ViewProjection._m02_m12_m22_m32));
    // dp4 o0.w, r0, c122
    o.position.w = dot(temp0, (ViewProjection._m03_m13_m23_m33));
    // dp3 r1.x, v3, c124
    temp1.x = dot(i.binormal.xyz, (World._m00_m10_m20_m30).xyz);
    // dp3 r1.y, v3, c125
    temp1.y = dot(i.binormal.xyz, (World._m01_m11_m21_m31).xyz);
    // dp3 r1.z, v3, c126
    temp1.z = dot(i.binormal.xyz, (World._m02_m12_m22_m32).xyz);
    // dp3 o2.x, c6, -r1
    o.texcoord1.x = dot(DirectionalLight[0].Direction.xyz, -temp1.xyz);
    // dp3 r2.x, v2, c124
    temp2.x = dot(i.tangent.xyz, (World._m00_m10_m20_m30).xyz);
    // dp3 r2.y, v2, c125
    temp2.y = dot(i.tangent.xyz, (World._m01_m11_m21_m31).xyz);
    // dp3 r2.z, v2, c126
    temp2.z = dot(i.tangent.xyz, (World._m02_m12_m22_m32).xyz);
    // dp3 o2.y, c6, -r2
    o.texcoord1.y = dot(DirectionalLight[0].Direction.xyz, -temp2.xyz);
    // dp3 r3.x, v1, c124
    temp3.x = dot(i.normal.xyz, (World._m00_m10_m20_m30).xyz);
    // dp3 r3.y, v1, c125
    temp3.y = dot(i.normal.xyz, (World._m01_m11_m21_m31).xyz);
    // dp3 r3.z, v1, c126
    temp3.z = dot(i.normal.xyz, (World._m02_m12_m22_m32).xyz);
    // dp3 o2.z, c6, r3
    o.texcoord1.z = dot(DirectionalLight[0].Direction.xyz, temp3.xyz);
    // add r4.xyz, -r0, c123
    temp4.xyz = -temp0.xyz + EyePosition.xyz;
    // dp3 r1.w, r4, r4
    temp1.w = dot(temp4.xyz, temp4.xyz);
    // rsq r1.w, r1.w
    temp1.w = 1 / sqrt(temp1.w);
    // mad r5.xyz, r4, r1.w, c6
    temp5.xyz = temp4.xyz * temp1.www + DirectionalLight[0].Direction.xyz;
    // mul r4.xyz, r4, r1.w
    temp4.xyz = temp4.xyz * temp1.www;
    // dp3 r6.x, r5, -r1
    temp6.x = dot(temp5.xyz, -temp1.xyz);
    // dp3 o7.x, r4, -r1
    o.texcoord6.x = dot(temp4.xyz, -temp1.xyz);
    // dp3 r6.y, r5, -r2
    temp6.y = dot(temp5.xyz, -temp2.xyz);
    // dp3 o7.y, r4, -r2
    o.texcoord6.y = dot(temp4.xyz, -temp2.xyz);
    // dp3 o7.z, r4, r3
    o.texcoord6.z = dot(temp4.xyz, temp3.xyz);
    // dp3 r6.z, r5, r3
    temp6.z = dot(temp5.xyz, temp3.xyz);
    // dp3 r1.x, r6, r6
    temp1.x = dot(temp6.xyz, temp6.xyz);
    // rsq r1.x, r1.x
    temp1.x = 1 / sqrt(temp1.x);
    // mul o3.xyz, r6, r1.x
    o.texcoord2 = temp6 * temp1.x;
    // dp4 r1.x, r0, c116
    temp1.x = dot(temp0, (ShadowMapWorldToShadow._m03_m13_m23_m33));
    // dp4 r0.w, r0, c115
    temp0.w = dot(temp0, (ShadowMapWorldToShadow._m02_m12_m22_m32));
    // mul r1.yz, r0.z, c117.xzww
    temp1.yz = temp0.zz * Cloud.WorldPositionMultiplier_XYZZ.zw;
    // rcp r0.z, r1.x
    temp0.z = 1.0f / temp1.x;
    // mov o5.w, r1.x
    o.texcoord4.w = temp1.x;
    // mad o5.z, r0.w, r0.z, c0.z
    o.texcoord4.z = temp0.w * temp0.z + float1(-0.0015);
    // mad r2, r0.xyxy, c0.w, v4.xyxy
    temp2 = temp0.xyxy * float4(0.003, 0.003, 0.003, 0.003) + i.texcoord.xyxy;
    // mul r3, r2, c1.xyzx
    temp3 = temp2 * float4(0.43019223, 0.6143571, -0.6143571, 0.43019223);
    // mul r2, r2, c1.xzyx
    temp2 = temp2 * float4(0.43019223, -0.6143571, 0.6143571, 0.43019223);
    // add o1.y, r3.w, r3.z
    o.texcoord.y = temp3.w + temp3.z;
    // add r0.z, r3.y, r3.x
    temp0.z = temp3.y + temp3.x;
    // add o1.x, r0.z, c11.x
    o.texcoord.x = temp0.z + expr11.x;
    // add o1.w, r2.w, r2.z
    o.texcoord.w = temp2.w + temp2.z;
    // add r0.z, r2.y, r2.x
    temp0.z = temp2.y + temp2.x;
    // add o1.z, r0.z, c11.x
    o.texcoord.z = temp0.z + expr11.x;
    // add r0.zw, r0.xyxy, c13
    temp0.zw = temp0.xy + Shroud.ScaleUV_OffsetUV.zw;
    // mul o4.xy, r0.zwzw, c13
    o.texcoord3.xy = temp0.zw * Shroud.ScaleUV_OffsetUV.xy;
    // mad r0.zw, r0.xyxy, c117.xyxy, -r1.xyyz
    temp0.zw = temp0.xy * Cloud.WorldPositionMultiplier_XYZZ.xy + -temp1.yz;
    // add o4.zw, r0, c118.xyxy
    o.texcoord3.zw = temp0.zw + Cloud.CurrentOffsetUV.xy;
    // mov r1.x, c12.x
    temp1.x = expr12.x;
    // mul r0.zw, r1.x, c2.xyxy
    temp0.zw = temp1.xx * float2(1, -1);
    // mul o6.xy, r0, r0.zwzw
    o.texcoord5 = temp0 * temp0.zwzw;
    // mov o2.w, c0.y
    o.texcoord1.w = float1(0);
    // mov o5.xy, v4
    o.texcoord4.xy = i.texcoord.xy;
    // mov o8, c0.y
    o.color = float4(0, 0, 0, 0);
    // 

    return o;
}

// VS_M_Array_Shader_1 Vertex_3_0 Has PRES True
struct VS_M_Array_Shader_1_Input
{
    float4 position : POSITION;
    float4 normal : NORMAL;
    float4 tangent : TANGENT;
    float4 binormal : BINORMAL;
    float4 blendindices : BLENDINDICES;
    float4 texcoord : TEXCOORD;
};

struct VS_M_Array_Shader_1_Output
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 texcoord1 : TEXCOORD1;
    float3 texcoord2 : TEXCOORD2;
    float4 texcoord3 : TEXCOORD3;
    float4 texcoord4 : TEXCOORD4;
    float2 texcoord5 : TEXCOORD5;
    float3 texcoord6 : TEXCOORD6;
    float4 color : COLOR;
};

VS_M_Array_Shader_1_Output VS_M_Array_Shader_1(VS_M_Array_Shader_1_Input i)
{
    /*
    PRSI
      OutputRegisterOffset: 11
      Unknown1: 0
      Unknown2: 0
      OutputRegisterCount: 2
      Unknown3: 0
      Unknown4: 0
      Unknown5: 11
      Unknown6: 2
      Mappings: 1
        0 - ConstOutput: 0 ConstInput 0
    
    */
    float4 expr11;
    float4 expr12;
    {
        float4 temp0;
        // Expression_2_1
        // mul c11.x, c1.x, (0.3)
        expr11.x = Time.x * (0.3);
        // mul r0.x, c0.x, (66)
        temp0.x = MapCellSize.x * (66);
        // rcp c12.x, r0.x
        expr12.x = 1.0f / (temp0.x);
    }

    VS_M_Array_Shader_1_Output o;
    float4 temp0, temp1, temp2, temp3, temp4;
    float addr0;
    float3 temp5, temp6;
    // def c0, 1, -1, -0.0015, 0.003
    // def c1, 0.4301922, 0.6143571, -0.6143571, 0
    // dcl_position v0
    // dcl_normal v1
    // dcl_tangent v2
    // dcl_binormal v3
    // dcl_blendindices v4
    // dcl_texcoord v5
    // dcl_position o0
    // dcl_texcoord o1
    // dcl_texcoord1 o2
    // dcl_texcoord2 o3.xyz
    // dcl_texcoord3 o4
    // dcl_texcoord4 o5
    // dcl_texcoord5 o6.xy
    // dcl_texcoord6 o7.xyz
    // dcl_color o8
    // add r0.x, v4.x, v4.x
    temp0.x = i.blendindices.x + i.blendindices.x;
    // frc r0.y, r0.x
    temp0.y = frac(temp0.x);
    // add r0.z, r0.x, -r0.y
    temp0.z = temp0.x + -temp0.y;
    // slt r0.y, -r0.y, r0.y
    temp0.y = (-temp0.y < temp0.y) ? 1 : 0;
    // slt r0.x, r0.x, -r0.x
    temp0.x = (temp0.x < -temp0.x) ? 1 : 0;
    // mad r0.x, r0.x, r0.y, r0.z
    temp0.x = temp0.x * temp0.y + temp0.z;
    // mova a0.x, r0.x
    addr0.x = temp0.x;
    // mul r0, v0.zxyy, c128[a0.x].yzxy
    temp0 = i.position.zxyy * WorldBones[0 + addr0.x].yzxy;
    // mad r0, c128[a0.x].wwwx, v0.xyzx, r0
    temp0 = WorldBones[0 + addr0.x].wwwx * i.position.xyzx + temp0;
    // mul r1, v0.yzxz, c128[a0.x].zxyz
    temp1 = i.position.yzxz * WorldBones[0 + addr0.x].zxyz;
    // mad r0, r0, c0.xxxy, -r1
    temp0 = temp0 * float4(1, 1, 1, -1) + -temp1;
    // mul r1.xyz, r0.w, c128[a0.x]
    temp1.xyz = temp0.www * WorldBones[0 + addr0.x].xyz;
    // mad r1.xyz, c128[a0.x].w, r0, -r1
    temp1.xyz = WorldBones[0 + addr0.x].www * temp0.xyz + -temp1.xyz;
    // mad r1.xyz, c128[a0.x].yzxw, r0.zxyw, r1
    temp1.xyz = WorldBones[0 + addr0.x].yzx * temp0.zxy + temp1.xyz;
    // mad r0.xyz, c128[a0.x].zxyw, -r0.yzxw, r1
    temp0.xyz = WorldBones[0 + addr0.x].zxy * -temp0.yzx + temp1.xyz;
    // add r0.xyz, r0, c129[a0.x]
    temp0.xyz = temp0.xyz + WorldBones[1 + addr0.x].xyz;
    // mov r0.w, c0.x
    temp0.w = float1(1);
    // dp4 o0.x, r0, c119
    o.position.x = dot(temp0, (ViewProjection._m00_m10_m20_m30));
    // dp4 o0.y, r0, c120
    o.position.y = dot(temp0, (ViewProjection._m01_m11_m21_m31));
    // dp4 o0.z, r0, c121
    o.position.z = dot(temp0, (ViewProjection._m02_m12_m22_m32));
    // dp4 o0.w, r0, c122
    o.position.w = dot(temp0, (ViewProjection._m03_m13_m23_m33));
    // mul r1, v3.zxyy, c128[a0.x].yzxy
    temp1 = i.binormal.zxyy * WorldBones[0 + addr0.x].yzxy;
    // mad r1, c128[a0.x].wwwx, v3.xyzx, r1
    temp1 = WorldBones[0 + addr0.x].wwwx * i.binormal.xyzx + temp1;
    // mul r2, v3.yzxz, c128[a0.x].zxyz
    temp2 = i.binormal.yzxz * WorldBones[0 + addr0.x].zxyz;
    // mad r1, r1, c0.xxxy, -r2
    temp1 = temp1 * float4(1, 1, 1, -1) + -temp2;
    // mul r2.xyz, r1.w, c128[a0.x]
    temp2.xyz = temp1.www * WorldBones[0 + addr0.x].xyz;
    // mad r2.xyz, c128[a0.x].w, r1, -r2
    temp2.xyz = WorldBones[0 + addr0.x].www * temp1.xyz + -temp2.xyz;
    // mad r2.xyz, c128[a0.x].yzxw, r1.zxyw, r2
    temp2.xyz = WorldBones[0 + addr0.x].yzx * temp1.zxy + temp2.xyz;
    // mad r1.xyz, c128[a0.x].zxyw, -r1.yzxw, r2
    temp1.xyz = WorldBones[0 + addr0.x].zxy * -temp1.yzx + temp2.xyz;
    // dp3 o2.x, c6, -r1
    o.texcoord1.x = dot(DirectionalLight[0].Direction.xyz, -temp1.xyz);
    // mul r2, v2.zxyy, c128[a0.x].yzxy
    temp2 = i.tangent.zxyy * WorldBones[0 + addr0.x].yzxy;
    // mad r2, c128[a0.x].wwwx, v2.xyzx, r2
    temp2 = WorldBones[0 + addr0.x].wwwx * i.tangent.xyzx + temp2;
    // mul r3, v2.yzxz, c128[a0.x].zxyz
    temp3 = i.tangent.yzxz * WorldBones[0 + addr0.x].zxyz;
    // mad r2, r2, c0.xxxy, -r3
    temp2 = temp2 * float4(1, 1, 1, -1) + -temp3;
    // mul r3.xyz, r2.w, c128[a0.x]
    temp3.xyz = temp2.www * WorldBones[0 + addr0.x].xyz;
    // mad r3.xyz, c128[a0.x].w, r2, -r3
    temp3.xyz = WorldBones[0 + addr0.x].www * temp2.xyz + -temp3.xyz;
    // mad r3.xyz, c128[a0.x].yzxw, r2.zxyw, r3
    temp3.xyz = WorldBones[0 + addr0.x].yzx * temp2.zxy + temp3.xyz;
    // mad r2.xyz, c128[a0.x].zxyw, -r2.yzxw, r3
    temp2.xyz = WorldBones[0 + addr0.x].zxy * -temp2.yzx + temp3.xyz;
    // dp3 o2.y, c6, -r2
    o.texcoord1.y = dot(DirectionalLight[0].Direction.xyz, -temp2.xyz);
    // mul r3, v1.zxyy, c128[a0.x].yzxy
    temp3 = i.normal.zxyy * WorldBones[0 + addr0.x].yzxy;
    // mad r3, c128[a0.x].wwwx, v1.xyzx, r3
    temp3 = WorldBones[0 + addr0.x].wwwx * i.normal.xyzx + temp3;
    // mul r4, v1.yzxz, c128[a0.x].zxyz
    temp4 = i.normal.yzxz * WorldBones[0 + addr0.x].zxyz;
    // mad r3, r3, c0.xxxy, -r4
    temp3 = temp3 * float4(1, 1, 1, -1) + -temp4;
    // mul r4.xyz, r3.w, c128[a0.x]
    temp4.xyz = temp3.www * WorldBones[0 + addr0.x].xyz;
    // mad r4.xyz, c128[a0.x].w, r3, -r4
    temp4.xyz = WorldBones[0 + addr0.x].www * temp3.xyz + -temp4.xyz;
    // mad r4.xyz, c128[a0.x].yzxw, r3.zxyw, r4
    temp4.xyz = WorldBones[0 + addr0.x].yzx * temp3.zxy + temp4.xyz;
    // mad r3.xyz, c128[a0.x].zxyw, -r3.yzxw, r4
    temp3.xyz = WorldBones[0 + addr0.x].zxy * -temp3.yzx + temp4.xyz;
    // dp3 o2.z, c6, r3
    o.texcoord1.z = dot(DirectionalLight[0].Direction.xyz, temp3.xyz);
    // add r4.xyz, -r0, c123
    temp4.xyz = -temp0.xyz + EyePosition.xyz;
    // dp3 r1.w, r4, r4
    temp1.w = dot(temp4.xyz, temp4.xyz);
    // rsq r1.w, r1.w
    temp1.w = 1 / sqrt(temp1.w);
    // mad r5.xyz, r4, r1.w, c6
    temp5.xyz = temp4.xyz * temp1.www + DirectionalLight[0].Direction.xyz;
    // mul r4.xyz, r4, r1.w
    temp4.xyz = temp4.xyz * temp1.www;
    // dp3 r6.x, r5, -r1
    temp6.x = dot(temp5.xyz, -temp1.xyz);
    // dp3 o7.x, r4, -r1
    o.texcoord6.x = dot(temp4.xyz, -temp1.xyz);
    // dp3 r6.y, r5, -r2
    temp6.y = dot(temp5.xyz, -temp2.xyz);
    // dp3 o7.y, r4, -r2
    o.texcoord6.y = dot(temp4.xyz, -temp2.xyz);
    // dp3 o7.z, r4, r3
    o.texcoord6.z = dot(temp4.xyz, temp3.xyz);
    // dp3 r6.z, r5, r3
    temp6.z = dot(temp5.xyz, temp3.xyz);
    // dp3 r1.x, r6, r6
    temp1.x = dot(temp6.xyz, temp6.xyz);
    // rsq r1.x, r1.x
    temp1.x = 1 / sqrt(temp1.x);
    // mul o3.xyz, r6, r1.x
    o.texcoord2 = temp6 * temp1.x;
    // dp4 r1.x, r0, c115
    temp1.x = dot(temp0, (ShadowMapWorldToShadow._m02_m12_m22_m32));
    // dp4 r0.w, r0, c116
    temp0.w = dot(temp0, (ShadowMapWorldToShadow._m03_m13_m23_m33));
    // rcp r1.y, r0.w
    temp1.y = 1.0f / temp0.w;
    // mov o5.w, r0.w
    o.texcoord4.w = temp0.w;
    // mad o5.z, r1.x, r1.y, c0.z
    o.texcoord4.z = temp1.x * temp1.y + float1(-0.0015);
    // mad r1.xy, r0.yxzw, c0.w, v5.yxzw
    temp1.xy = temp0.yx * float2(0.003, 0.003) + i.texcoord.yx;
    // mul r2, r1.yxyx, c1.xyzx
    temp2 = temp1.yxyx * float4(0.43019223, 0.6143571, -0.6143571, 0.43019223);
    // add o1.y, r2.w, r2.z
    o.texcoord.y = temp2.w + temp2.z;
    // add r0.w, r2.y, r2.x
    temp0.w = temp2.y + temp2.x;
    // mad o1.w, r1.y, c1.y, r2.w
    o.texcoord.w = temp1.y * float1(0.6143571) + temp2.w;
    // add o1.x, r0.w, c11.x
    o.texcoord.x = temp0.w + expr11.x;
    // mul r0.w, r1.x, c1.z
    temp0.w = temp1.x * float1(-0.6143571);
    // mad r0.w, r1.y, c1.x, r0.w
    temp0.w = temp1.y * float1(0.43019223) + temp0.w;
    // add o1.z, r0.w, c11.x
    o.texcoord.z = temp0.w + expr11.x;
    // add r1.xy, r0, c13.zwzw
    temp1.xy = temp0.xy + Shroud.ScaleUV_OffsetUV.zw;
    // mul o4.xy, r1, c13
    o.texcoord3.xy = temp1.xy * Shroud.ScaleUV_OffsetUV.xy;
    // mul r0.zw, r0.z, c117
    temp0.zw = temp0.zz * Cloud.WorldPositionMultiplier_XYZZ.zw;
    // mad r0.zw, r0.xyxy, c117.xyxy, -r0
    temp0.zw = temp0.xy * Cloud.WorldPositionMultiplier_XYZZ.xy + -temp0.zw;
    // add o4.zw, r0, c118.xyxy
    o.texcoord3.zw = temp0.zw + Cloud.CurrentOffsetUV.xy;
    // mov r1.xy, c0
    temp1.xy = float2(1, -1);
    // mul r0.zw, r1.xyxy, c12.x
    temp0.zw = temp1.xy * expr12.xx;
    // mul o6.xy, r0, r0.zwzw
    o.texcoord5 = temp0 * temp0.zwzw;
    // mov o2.w, c1.w
    o.texcoord1.w = float1(0);
    // mov o5.xy, v5
    o.texcoord4.xy = i.texcoord.xy;
    // mov o8, c1.w
    o.color = float4(0, 0, 0, 0);
    // 

    return o;
}

VertexShader VS_M_Array[2] = {
    compile vs_3_0 VS_M_Array_Shader_0(), // 87
    compile vs_3_0 VS_M_Array_Shader_1(), // 88
};
// PS_M_Array_Shader_0 Pixel_3_0 Has PRES False
struct PS_M_Array_Shader_0_Input
{
    float2 texcoord3 : TEXCOORD3;
    float2 texcoord4 : TEXCOORD4;
    float3 texcoord6 : TEXCOORD6;
};

float4 PS_M_Array_Shader_0(PS_M_Array_Shader_0_Input i) : COLOR
{
    float4 out_color;
    float4 temp0, temp1;
    // def c0, 2, -1, 1, 2.5
    // def c3, 0, 3, 0.055, 0.045
    // dcl_texcoord3 v0.xy
    // dcl_texcoord4 v1.xy
    // dcl_texcoord6 v2.xyz
    // dcl_2d s0
    // dcl_2d s1
    // texld r0, v1, s0
    temp0 = /* not implemented _pp modifier */ tex2D(NormalMapSampler, i.texcoord4.xy);
    // mad_pp r0.xyz, r0, c0.x, c0.y
    temp0.xyz = /* not implemented _pp modifier */ temp0.xyz * float3(2, 2, 2) + float3(-1, -1, -1);
    // mul_pp r0.xy, r0, c11.x
    temp0.xy = /* not implemented _pp modifier */ temp0.xy * BumpScale.xx;
    // nrm_pp r1.xyz, r0
    temp1.xyz = /* not implemented _pp modifier */ normalize(temp0.xyz).xyz;
    // dp3 r0.x, v2, r1
    temp0.x = dot(i.texcoord6.xyz, temp1.xyz);
    // add r0.x, -r0.x, c0.z
    temp0.x = -temp0.x + float1(1);
    // pow_pp r1.x, r0.x, c0.w
    temp1.x = /* not implemented _pp modifier */ pow(temp0.x, float1(2.5));
    // mad_pp r0.xyz, r1.x, c3.xyxw, c3.xzww
    temp0.xyz = /* not implemented _pp modifier */ temp1.xxx * float3(0, 3, 0) + float3(0, 0.055, 0.045);
    // min_pp r1.xyz, c0.x, r0
    temp1.xyz = /* not implemented _pp modifier */ min(float3(2, 2, 2), temp0.xyz);
    // mul_pp r0.xyz, r1, c2
    temp0.xyz = /* not implemented _pp modifier */ temp1.xyz * TintColor.xyz;
    // texld r1, v0, s1
    temp1 = /* not implemented _pp modifier */ tex2D(ShroudTextureSampler, i.texcoord3.xy);
    // mul_pp oC0.xyz, r0, r1
    out_color.xyz = /* not implemented _pp modifier */ temp0.xyz * temp1.xyz;
    // mov_pp oC0.w, c1.x
    out_color.w = /* not implemented _pp modifier */ OpacityOverride.x;
    // 

    return out_color;
}

// PS_M_Array_Shader_1 Pixel_3_0 Has PRES False
struct PS_M_Array_Shader_1_Input
{
    float2 texcoord3 : TEXCOORD3;
    float2 texcoord4 : TEXCOORD4;
    float3 texcoord6 : TEXCOORD6;
};

float4 PS_M_Array_Shader_1(PS_M_Array_Shader_1_Input i) : COLOR
{
    float4 out_color;
    float4 temp0, temp1;
    // def c0, 2, -1, 1, 2.5
    // def c3, 0, 3, 0.055, 0.045
    // dcl_texcoord3 v0.xy
    // dcl_texcoord4 v1.xy
    // dcl_texcoord6 v2.xyz
    // dcl_2d s0
    // dcl_2d s1
    // texld r0, v1, s0
    temp0 = /* not implemented _pp modifier */ tex2D(NormalMapSampler, i.texcoord4.xy);
    // mad_pp r0.xyz, r0, c0.x, c0.y
    temp0.xyz = /* not implemented _pp modifier */ temp0.xyz * float3(2, 2, 2) + float3(-1, -1, -1);
    // mul_pp r0.xy, r0, c11.x
    temp0.xy = /* not implemented _pp modifier */ temp0.xy * BumpScale.xx;
    // nrm_pp r1.xyz, r0
    temp1.xyz = /* not implemented _pp modifier */ normalize(temp0.xyz).xyz;
    // dp3 r0.x, v2, r1
    temp0.x = dot(i.texcoord6.xyz, temp1.xyz);
    // add r0.x, -r0.x, c0.z
    temp0.x = -temp0.x + float1(1);
    // pow_pp r1.x, r0.x, c0.w
    temp1.x = /* not implemented _pp modifier */ pow(temp0.x, float1(2.5));
    // mad_pp r0.xyz, r1.x, c3.xyxw, c3.xzww
    temp0.xyz = /* not implemented _pp modifier */ temp1.xxx * float3(0, 3, 0) + float3(0, 0.055, 0.045);
    // min_pp r1.xyz, c0.x, r0
    temp1.xyz = /* not implemented _pp modifier */ min(float3(2, 2, 2), temp0.xyz);
    // mul_pp r0.xyz, r1, c2
    temp0.xyz = /* not implemented _pp modifier */ temp1.xyz * TintColor.xyz;
    // texld r1, v0, s1
    temp1 = /* not implemented _pp modifier */ tex2D(ShroudTextureSampler, i.texcoord3.xy);
    // mul_pp oC0.xyz, r0, r1
    out_color.xyz = /* not implemented _pp modifier */ temp0.xyz * temp1.xyz;
    // mov_pp oC0.w, c1.x
    out_color.w = /* not implemented _pp modifier */ OpacityOverride.x;
    // 

    return out_color;
}

// PS_M_Array_Shader_2 Pixel_3_0 Has PRES False
struct PS_M_Array_Shader_2_Input
{
    float2 texcoord3 : TEXCOORD3;
    float2 texcoord4 : TEXCOORD4;
    float3 texcoord6 : TEXCOORD6;
};

float4 PS_M_Array_Shader_2(PS_M_Array_Shader_2_Input i) : COLOR
{
    float4 out_color;
    float4 temp0, temp1;
    // def c0, 2, -1, 1, 2.5
    // def c3, 0, 3, 0.055, 0.045
    // dcl_texcoord3 v0.xy
    // dcl_texcoord4 v1.xy
    // dcl_texcoord6 v2.xyz
    // dcl_2d s0
    // dcl_2d s1
    // texld r0, v1, s0
    temp0 = /* not implemented _pp modifier */ tex2D(NormalMapSampler, i.texcoord4.xy);
    // mad_pp r0.xyz, r0, c0.x, c0.y
    temp0.xyz = /* not implemented _pp modifier */ temp0.xyz * float3(2, 2, 2) + float3(-1, -1, -1);
    // mul_pp r0.xy, r0, c11.x
    temp0.xy = /* not implemented _pp modifier */ temp0.xy * BumpScale.xx;
    // nrm_pp r1.xyz, r0
    temp1.xyz = /* not implemented _pp modifier */ normalize(temp0.xyz).xyz;
    // dp3 r0.x, v2, r1
    temp0.x = dot(i.texcoord6.xyz, temp1.xyz);
    // add r0.x, -r0.x, c0.z
    temp0.x = -temp0.x + float1(1);
    // pow_pp r1.x, r0.x, c0.w
    temp1.x = /* not implemented _pp modifier */ pow(temp0.x, float1(2.5));
    // mad_pp r0.xyz, r1.x, c3.xyxw, c3.xzww
    temp0.xyz = /* not implemented _pp modifier */ temp1.xxx * float3(0, 3, 0) + float3(0, 0.055, 0.045);
    // min_pp r1.xyz, c0.x, r0
    temp1.xyz = /* not implemented _pp modifier */ min(float3(2, 2, 2), temp0.xyz);
    // mul_pp r0.xyz, r1, c2
    temp0.xyz = /* not implemented _pp modifier */ temp1.xyz * TintColor.xyz;
    // texld r1, v0, s1
    temp1 = /* not implemented _pp modifier */ tex2D(ShroudTextureSampler, i.texcoord3.xy);
    // mul_pp oC0.xyz, r0, r1
    out_color.xyz = /* not implemented _pp modifier */ temp0.xyz * temp1.xyz;
    // mov_pp oC0.w, c1.x
    out_color.w = /* not implemented _pp modifier */ OpacityOverride.x;
    // 

    return out_color;
}

// PS_M_Array_Shader_3 Pixel_3_0 Has PRES False
struct PS_M_Array_Shader_3_Input
{
    float2 texcoord3 : TEXCOORD3;
    float2 texcoord4 : TEXCOORD4;
    float3 texcoord6 : TEXCOORD6;
};

float4 PS_M_Array_Shader_3(PS_M_Array_Shader_3_Input i) : COLOR
{
    float4 out_color;
    float4 temp0, temp1;
    // def c0, 2, -1, 1, 2.5
    // def c3, 0, 3, 0.055, 0.045
    // dcl_texcoord3 v0.xy
    // dcl_texcoord4 v1.xy
    // dcl_texcoord6 v2.xyz
    // dcl_2d s0
    // dcl_2d s1
    // texld r0, v1, s0
    temp0 = /* not implemented _pp modifier */ tex2D(NormalMapSampler, i.texcoord4.xy);
    // mad_pp r0.xyz, r0, c0.x, c0.y
    temp0.xyz = /* not implemented _pp modifier */ temp0.xyz * float3(2, 2, 2) + float3(-1, -1, -1);
    // mul_pp r0.xy, r0, c11.x
    temp0.xy = /* not implemented _pp modifier */ temp0.xy * BumpScale.xx;
    // nrm_pp r1.xyz, r0
    temp1.xyz = /* not implemented _pp modifier */ normalize(temp0.xyz).xyz;
    // dp3 r0.x, v2, r1
    temp0.x = dot(i.texcoord6.xyz, temp1.xyz);
    // add r0.x, -r0.x, c0.z
    temp0.x = -temp0.x + float1(1);
    // pow_pp r1.x, r0.x, c0.w
    temp1.x = /* not implemented _pp modifier */ pow(temp0.x, float1(2.5));
    // mad_pp r0.xyz, r1.x, c3.xyxw, c3.xzww
    temp0.xyz = /* not implemented _pp modifier */ temp1.xxx * float3(0, 3, 0) + float3(0, 0.055, 0.045);
    // min_pp r1.xyz, c0.x, r0
    temp1.xyz = /* not implemented _pp modifier */ min(float3(2, 2, 2), temp0.xyz);
    // mul_pp r0.xyz, r1, c2
    temp0.xyz = /* not implemented _pp modifier */ temp1.xyz * TintColor.xyz;
    // texld r1, v0, s1
    temp1 = /* not implemented _pp modifier */ tex2D(ShroudTextureSampler, i.texcoord3.xy);
    // mul_pp oC0.xyz, r0, r1
    out_color.xyz = /* not implemented _pp modifier */ temp0.xyz * temp1.xyz;
    // mov_pp oC0.w, c1.x
    out_color.w = /* not implemented _pp modifier */ OpacityOverride.x;
    // 

    return out_color;
}

PixelShader PS_M_Array[4] = {
    compile ps_3_0 PS_M_Array_Shader_0(), // 89
    compile ps_3_0 PS_M_Array_Shader_1(), // 90
    compile ps_3_0 PS_M_Array_Shader_2(), // 91
    compile ps_3_0 PS_M_Array_Shader_3(), // 92
};
// VS_L_Array_Shader_0 Vertex_2_0 Has PRES True
struct VS_L_Array_Shader_0_Input
{
    float4 position : POSITION;
    float4 normal : NORMAL;
    float4 texcoord : TEXCOORD;
};

struct VS_L_Array_Shader_0_Output
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float3 texcoord2 : TEXCOORD2;
    float2 texcoord1 : TEXCOORD1;
    float4 color : COLOR;
};

VS_L_Array_Shader_0_Output VS_L_Array_Shader_0(VS_L_Array_Shader_0_Input i)
{
    /*
    PRSI
      OutputRegisterOffset: 12
      Unknown1: 0
      Unknown2: 0
      OutputRegisterCount: 1
      Unknown3: 0
      Unknown4: 0
      Unknown5: 12
      Unknown6: 1
      Mappings: 1
        0 - ConstOutput: 0 ConstInput 0
    
    */
    float4 expr12;
    {
        // Expression_2_1
        // mul c12.x, c0.x, (0.3)
        expr12.x = Time.x * (0.3);
    }

    VS_L_Array_Shader_0_Output o;
    float4 temp0, temp1, temp2;
    // def c0, 1, 0, 0.003, 2.5
    // def c1, 0, 1.05, 0, 0
    // def c2, 0.4301922, 0.6143571, -0.6143571, 0
    // dcl_position v0
    // dcl_normal v1
    // dcl_texcoord v2
    // mov r0.w, c0.x
    temp0.w = float1(1);
    // mad r1, v0.xyzx, c0.xxxy, c0.yyyx
    temp1 = i.position.xyzx * float4(1, 1, 1, 0) + float4(0, 0, 0, 1);
    // dp4 r0.z, r1, c126
    temp0.z = dot(temp1, (World._m02_m12_m22_m32));
    // dp4 r0.x, r1, c124
    temp0.x = dot(temp1, (World._m00_m10_m20_m30));
    // dp4 r0.y, r1, c125
    temp0.y = dot(temp1, (World._m01_m11_m21_m31));
    // dp4 oPos.x, r0, c119
    o.position.x = dot(temp0, (ViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c120
    o.position.y = dot(temp0, (ViewProjection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c121
    o.position.z = dot(temp0, (ViewProjection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c122
    o.position.w = dot(temp0, (ViewProjection._m03_m13_m23_m33));
    // add r1.xyz, -r0, c123
    temp1.xyz = -temp0.xyz + EyePosition.xyz;
    // mad r2, r0.xyxy, c0.z, v2.xyxy
    temp2 = temp0.xyxy * float4(0.003, 0.003, 0.003, 0.003) + i.texcoord.xyxy;
    // add r0.xy, r0, c11.zwzw
    temp0.xy = temp0.xy + Shroud.ScaleUV_OffsetUV.zw;
    // mul r2, r2, c2.xyzx
    temp2 = temp2 * float4(0.43019223, 0.6143571, -0.6143571, 0.43019223);
    // add r0.zw, r2.xyyw, r2.xyxz
    temp0.zw = temp2.yw + temp2.xz;
    // add oT0.x, r0.z, c12.x
    o.texcoord.x = temp0.z + expr12.x;
    // mov oT0.y, r0.w
    o.texcoord.y = temp0.w;
    // nrm r2.xyz, r1
    temp2.xyz = normalize(temp1.xyz).xyz;
    // dp3 r1.x, v1, c124
    temp1.x = dot(i.normal.xyz, (World._m00_m10_m20_m30).xyz);
    // dp3 r1.y, v1, c125
    temp1.y = dot(i.normal.xyz, (World._m01_m11_m21_m31).xyz);
    // dp3 r1.z, v1, c126
    temp1.z = dot(i.normal.xyz, (World._m02_m12_m22_m32).xyz);
    // dp3 r0.z, r2, r1
    temp0.z = dot(temp2.xyz, temp1.xyz);
    // add r0.z, -r0.z, c0.x
    temp0.z = -temp0.z + float1(1);
    // pow r1.x, r0.z, c0.w
    temp1.x = pow(temp0.z, float1(2.5));
    // mul oT2.xyz, r1.x, c1.xyxw
    o.texcoord2 = temp1.x * float4(0, 1.05, 0, 0);
    // mul oT1.xy, r0, c11
    o.texcoord1 = temp0 * Shroud.ScaleUV_OffsetUV;
    // mov oD0, c0.y
    o.color = float4(0, 0, 0, 0);
    // mov oT0.zw, v2.xyyx
    o.texcoord.zw = i.texcoord.yx;
    // 

    return o;
}

// VS_L_Array_Shader_1 Vertex_2_0 Has PRES True
struct VS_L_Array_Shader_1_Input
{
    float4 position : POSITION;
    float4 normal : NORMAL;
    float4 blendindices : BLENDINDICES;
    float4 texcoord : TEXCOORD;
};

struct VS_L_Array_Shader_1_Output
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float3 texcoord2 : TEXCOORD2;
    float2 texcoord1 : TEXCOORD1;
    float4 color : COLOR;
};

VS_L_Array_Shader_1_Output VS_L_Array_Shader_1(VS_L_Array_Shader_1_Input i)
{
    /*
    PRSI
      OutputRegisterOffset: 12
      Unknown1: 0
      Unknown2: 0
      OutputRegisterCount: 1
      Unknown3: 0
      Unknown4: 0
      Unknown5: 12
      Unknown6: 1
      Mappings: 1
        0 - ConstOutput: 0 ConstInput 0
    
    */
    float4 expr12;
    {
        // Expression_2_1
        // mul c12.x, c0.x, (0.3)
        expr12.x = Time.x * (0.3);
    }

    VS_L_Array_Shader_1_Output o;
    float4 temp0, temp1, temp2;
    float addr0;
    float3 temp3;
    // def c0, 1, -1, 0.003, 2.5
    // def c1, 0, 1.05, 0, 0
    // def c2, 0.4301922, 0.6143571, -0.6143571, 0
    // dcl_position v0
    // dcl_normal v1
    // dcl_blendindices v2
    // dcl_texcoord v3
    // add r0.x, v2.x, v2.x
    temp0.x = i.blendindices.x + i.blendindices.x;
    // frc r0.y, r0.x
    temp0.y = frac(temp0.x);
    // add r0.z, r0.x, -r0.y
    temp0.z = temp0.x + -temp0.y;
    // slt r0.y, -r0.y, r0.y
    temp0.y = (-temp0.y < temp0.y) ? 1 : 0;
    // slt r0.x, r0.x, -r0.x
    temp0.x = (temp0.x < -temp0.x) ? 1 : 0;
    // mad r0.x, r0.x, r0.y, r0.z
    temp0.x = temp0.x * temp0.y + temp0.z;
    // mova a0.x, r0.x
    addr0.x = temp0.x;
    // mul r0, v0.zxyy, c128[a0.x].yzxy
    temp0 = i.position.zxyy * WorldBones[0 + addr0.x].yzxy;
    // mad r0, c128[a0.x].wwwx, v0.xyzx, r0
    temp0 = WorldBones[0 + addr0.x].wwwx * i.position.xyzx + temp0;
    // mul r1, v0.yzxz, c128[a0.x].zxyz
    temp1 = i.position.yzxz * WorldBones[0 + addr0.x].zxyz;
    // mad r0, r0, c0.xxxy, -r1
    temp0 = temp0 * float4(1, 1, 1, -1) + -temp1;
    // mul r1.xyz, r0.w, c128[a0.x]
    temp1.xyz = temp0.www * WorldBones[0 + addr0.x].xyz;
    // mad r1.xyz, c128[a0.x].w, r0, -r1
    temp1.xyz = WorldBones[0 + addr0.x].www * temp0.xyz + -temp1.xyz;
    // mad r1.xyz, c128[a0.x].yzxw, r0.zxyw, r1
    temp1.xyz = WorldBones[0 + addr0.x].yzx * temp0.zxy + temp1.xyz;
    // mad r0.xyz, c128[a0.x].zxyw, -r0.yzxw, r1
    temp0.xyz = WorldBones[0 + addr0.x].zxy * -temp0.yzx + temp1.xyz;
    // add r0.xyz, r0, c129[a0.x]
    temp0.xyz = temp0.xyz + WorldBones[1 + addr0.x].xyz;
    // mov r0.w, c0.x
    temp0.w = float1(1);
    // dp4 oPos.x, r0, c119
    o.position.x = dot(temp0, (ViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c120
    o.position.y = dot(temp0, (ViewProjection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c121
    o.position.z = dot(temp0, (ViewProjection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c122
    o.position.w = dot(temp0, (ViewProjection._m03_m13_m23_m33));
    // mad r1, r0.xyxy, c0.z, v3.xyxy
    temp1 = temp0.xyxy * float4(0.003, 0.003, 0.003, 0.003) + i.texcoord.xyxy;
    // mul r1, r1, c2.xyzx
    temp1 = temp1 * float4(0.43019223, 0.6143571, -0.6143571, 0.43019223);
    // add r1.xy, r1.ywzw, r1.xzzw
    temp1.xy = temp1.yw + temp1.xz;
    // add oT0.x, r1.x, c12.x
    o.texcoord.x = temp1.x + expr12.x;
    // mov oT0.y, r1.y
    o.texcoord.y = temp1.y;
    // mul r1, v1.zxyy, c128[a0.x].yzxy
    temp1 = i.normal.zxyy * WorldBones[0 + addr0.x].yzxy;
    // mad r1, c128[a0.x].wwwx, v1.xyzx, r1
    temp1 = WorldBones[0 + addr0.x].wwwx * i.normal.xyzx + temp1;
    // mul r2, v1.yzxz, c128[a0.x].zxyz
    temp2 = i.normal.yzxz * WorldBones[0 + addr0.x].zxyz;
    // mad r1, r1, c0.xxxy, -r2
    temp1 = temp1 * float4(1, 1, 1, -1) + -temp2;
    // mul r2.xyz, r1.w, c128[a0.x]
    temp2.xyz = temp1.www * WorldBones[0 + addr0.x].xyz;
    // mad r2.xyz, c128[a0.x].w, r1, -r2
    temp2.xyz = WorldBones[0 + addr0.x].www * temp1.xyz + -temp2.xyz;
    // mad r2.xyz, c128[a0.x].yzxw, r1.zxyw, r2
    temp2.xyz = WorldBones[0 + addr0.x].yzx * temp1.zxy + temp2.xyz;
    // mad r1.xyz, c128[a0.x].zxyw, -r1.yzxw, r2
    temp1.xyz = WorldBones[0 + addr0.x].zxy * -temp1.yzx + temp2.xyz;
    // add r2.xyz, -r0, c123
    temp2.xyz = -temp0.xyz + EyePosition.xyz;
    // add r0.xy, r0, c11.zwzw
    temp0.xy = temp0.xy + Shroud.ScaleUV_OffsetUV.zw;
    // nrm r3.xyz, r2
    temp3.xyz = normalize(temp2.xyz).xyz;
    // dp3 r0.z, r3, r1
    temp0.z = dot(temp3.xyz, temp1.xyz);
    // add r0.z, -r0.z, c0.x
    temp0.z = -temp0.z + float1(1);
    // pow r1.x, r0.z, c0.w
    temp1.x = pow(temp0.z, float1(2.5));
    // mul oT2.xyz, r1.x, c1.xyxw
    o.texcoord2 = temp1.x * float4(0, 1.05, 0, 0);
    // mul oT1.xy, r0, c11
    o.texcoord1 = temp0 * Shroud.ScaleUV_OffsetUV;
    // mov oD0, c2.w
    o.color = float4(0, 0, 0, 0);
    // mov oT0.zw, v3.xyyx
    o.texcoord.zw = i.texcoord.yx;
    // 

    return o;
}

VertexShader VS_L_Array[2] = {
    compile vs_2_0 VS_L_Array_Shader_0(), // 96
    compile vs_2_0 VS_L_Array_Shader_1(), // 97
};
// PS_L_Array_Shader_0 Pixel_2_0 Has PRES False
struct PS_L_Array_Shader_0_Input
{
    float2 texcoord1 : TEXCOORD1;
    float3 texcoord2 : TEXCOORD2;
};

float4 PS_L_Array_Shader_0(PS_L_Array_Shader_0_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    float3 temp1, temp2;
    // def c0, 0, 0.22, 0.18, 2
    // dcl t1.xy
    // dcl t2.xyz
    // dcl_2d s0
    // texld r0, t1, s0
    temp0 = tex2D(ShroudTextureSampler, i.texcoord1.xy);
    // add r1.xyz, t2, c0
    temp1.xyz = i.texcoord2.xyz + float3(0, 0.22, 0.18);
    // min r2.xyz, c0.w, r1
    temp2.xyz = min(float3(2, 2, 2), temp1.xyz);
    // mul r1.xyz, r2, c2
    temp1.xyz = temp2.xyz * TintColor.xyz;
    // mul r0.xyz, r0, r1
    temp0.xyz = temp0.xyz * temp1.xyz;
    // mov r0.w, c1.x
    temp0.w = OpacityOverride.x;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// PS_L_Array_Shader_1 Pixel_2_0 Has PRES False
struct PS_L_Array_Shader_1_Input
{
    float2 texcoord1 : TEXCOORD1;
    float3 texcoord2 : TEXCOORD2;
};

float4 PS_L_Array_Shader_1(PS_L_Array_Shader_1_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    float3 temp1, temp2;
    // def c0, 0, 0.22, 0.18, 2
    // dcl t1.xy
    // dcl t2.xyz
    // dcl_2d s0
    // texld r0, t1, s0
    temp0 = tex2D(ShroudTextureSampler, i.texcoord1.xy);
    // add r1.xyz, t2, c0
    temp1.xyz = i.texcoord2.xyz + float3(0, 0.22, 0.18);
    // min r2.xyz, c0.w, r1
    temp2.xyz = min(float3(2, 2, 2), temp1.xyz);
    // mul r1.xyz, r2, c2
    temp1.xyz = temp2.xyz * TintColor.xyz;
    // mul r0.xyz, r0, r1
    temp0.xyz = temp0.xyz * temp1.xyz;
    // mov r0.w, c1.x
    temp0.w = OpacityOverride.x;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

PixelShader PS_L_Array[2] = {
    compile ps_2_0 PS_L_Array_Shader_0(), // 98
    compile ps_2_0 PS_L_Array_Shader_1(), // 99
};
// VSCreateShadowMap_Array_Shader_0 Vertex_2_0 Has PRES False
struct VSCreateShadowMap_Array_Shader_0_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct VSCreateShadowMap_Array_Shader_0_Output
{
    float4 position : POSITION;
    float texcoord1 : TEXCOORD1;
    float color : COLOR;
    float2 texcoord : TEXCOORD;
};

VSCreateShadowMap_Array_Shader_0_Output VSCreateShadowMap_Array_Shader_0(VSCreateShadowMap_Array_Shader_0_Input i)
{
    VSCreateShadowMap_Array_Shader_0_Output o;
    float4 temp0, temp1;
    // def c0, 1, 0, 0, 0
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_color v2
    // mad r0, v0.xyzx, c0.xxxy, c0.yyyx
    temp0 = i.position.xyzx * float4(1, 1, 1, 0) + float4(0, 0, 0, 1);
    // dp4 r1.x, r0, c124
    temp1.x = dot(temp0, (World._m00_m10_m20_m30));
    // dp4 r1.y, r0, c125
    temp1.y = dot(temp0, (World._m01_m11_m21_m31));
    // dp4 r1.z, r0, c126
    temp1.z = dot(temp0, (World._m02_m12_m22_m32));
    // mov r1.w, c0.x
    temp1.w = float1(1);
    // dp4 oPos.x, r1, c119
    o.position.x = dot(temp1, (ViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r1, c120
    o.position.y = dot(temp1, (ViewProjection._m01_m11_m21_m31));
    // dp4 r0.y, r1, c122
    temp0.y = dot(temp1, (ViewProjection._m03_m13_m23_m33));
    // dp4 r0.x, r1, c121
    temp0.x = dot(temp1, (ViewProjection._m02_m12_m22_m32));
    // rcp r0.z, r0.y
    temp0.z = 1.0f / temp0.y;
    // mov oPos.zw, r0.xyxy
    o.position.zw = temp0.xy;
    // mul oT1.x, r0.x, r0.z
    o.texcoord1 = temp0.x * temp0.z;
    // mul oD0.x, v2.w, c1.x
    o.color = i.color.w * OpacityOverride.x;
    // mov oT0.xy, v1
    o.texcoord = i.texcoord;
    // 

    return o;
}

// VSCreateShadowMap_Array_Shader_1 Vertex_2_0 Has PRES False
struct VSCreateShadowMap_Array_Shader_1_Input
{
    float4 position : POSITION;
    float4 blendindices : BLENDINDICES;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct VSCreateShadowMap_Array_Shader_1_Output
{
    float4 position : POSITION;
    float texcoord1 : TEXCOORD1;
    float color : COLOR;
    float2 texcoord : TEXCOORD;
};

VSCreateShadowMap_Array_Shader_1_Output VSCreateShadowMap_Array_Shader_1(VSCreateShadowMap_Array_Shader_1_Input i)
{
    VSCreateShadowMap_Array_Shader_1_Output o;
    float4 temp0, temp1;
    float addr0;
    // def c0, 1, -1, 0, 0
    // dcl_position v0
    // dcl_blendindices v1
    // dcl_texcoord v2
    // dcl_color v3
    // add r0.x, v1.x, v1.x
    temp0.x = i.blendindices.x + i.blendindices.x;
    // frc r0.y, r0.x
    temp0.y = frac(temp0.x);
    // add r0.z, r0.x, -r0.y
    temp0.z = temp0.x + -temp0.y;
    // slt r0.y, -r0.y, r0.y
    temp0.y = (-temp0.y < temp0.y) ? 1 : 0;
    // slt r0.x, r0.x, -r0.x
    temp0.x = (temp0.x < -temp0.x) ? 1 : 0;
    // mad r0.x, r0.x, r0.y, r0.z
    temp0.x = temp0.x * temp0.y + temp0.z;
    // mova a0.x, r0.x
    addr0.x = temp0.x;
    // mul r0, v0.zxyy, c128[a0.x].yzxy
    temp0 = i.position.zxyy * WorldBones[0 + addr0.x].yzxy;
    // mad r0, c128[a0.x].wwwx, v0.xyzx, r0
    temp0 = WorldBones[0 + addr0.x].wwwx * i.position.xyzx + temp0;
    // mul r1, v0.yzxz, c128[a0.x].zxyz
    temp1 = i.position.yzxz * WorldBones[0 + addr0.x].zxyz;
    // mad r0, r0, c0.xxxy, -r1
    temp0 = temp0 * float4(1, 1, 1, -1) + -temp1;
    // mul r1.xyz, r0.w, c128[a0.x]
    temp1.xyz = temp0.www * WorldBones[0 + addr0.x].xyz;
    // mad r1.xyz, c128[a0.x].w, r0, -r1
    temp1.xyz = WorldBones[0 + addr0.x].www * temp0.xyz + -temp1.xyz;
    // mad r1.xyz, c128[a0.x].yzxw, r0.zxyw, r1
    temp1.xyz = WorldBones[0 + addr0.x].yzx * temp0.zxy + temp1.xyz;
    // mad r0.xyz, c128[a0.x].zxyw, -r0.yzxw, r1
    temp0.xyz = WorldBones[0 + addr0.x].zxy * -temp0.yzx + temp1.xyz;
    // add r0.xyz, r0, c129[a0.x]
    temp0.xyz = temp0.xyz + WorldBones[1 + addr0.x].xyz;
    // mov r0.w, c0.x
    temp0.w = float1(1);
    // dp4 oPos.x, r0, c119
    o.position.x = dot(temp0, (ViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c120
    o.position.y = dot(temp0, (ViewProjection._m01_m11_m21_m31));
    // dp4 r1.y, r0, c122
    temp1.y = dot(temp0, (ViewProjection._m03_m13_m23_m33));
    // dp4 r1.x, r0, c121
    temp1.x = dot(temp0, (ViewProjection._m02_m12_m22_m32));
    // rcp r0.x, r1.y
    temp0.x = 1.0f / temp1.y;
    // mov oPos.zw, r1.xyxy
    o.position.zw = temp1.xy;
    // mul oT1.x, r1.x, r0.x
    o.texcoord1 = temp1.x * temp0.x;
    // slt r0.x, v1.x, -v1.x
    temp0.x = (i.blendindices.x < -i.blendindices.x) ? 1 : 0;
    // frc r0.y, v1.x
    temp0.y = frac(i.blendindices.x);
    // add r0.z, -r0.y, v1.x
    temp0.z = -temp0.y + i.blendindices.x;
    // slt r0.y, -r0.y, r0.y
    temp0.y = (-temp0.y < temp0.y) ? 1 : 0;
    // mad r0.x, r0.x, r0.y, r0.z
    temp0.x = temp0.x * temp0.y + temp0.z;
    // add r0.x, r0.x, r0.x
    temp0.x = temp0.x + temp0.x;
    // mova a0.x, r0.x
    addr0.x = temp0.x;
    // mul r0.x, v3.w, c129[a0.x].w
    temp0.x = i.color.w * WorldBones[1 + addr0.x].w;
    // mul oD0.x, r0.x, c1.x
    o.color = temp0.x * OpacityOverride.x;
    // mov oT0.xy, v2
    o.texcoord = i.texcoord;
    // 

    return o;
}

VertexShader VSCreateShadowMap_Array[2] = {
    compile vs_2_0 VSCreateShadowMap_Array_Shader_0(), // 103
    compile vs_2_0 VSCreateShadowMap_Array_Shader_1(), // 104
};
// PSCreateShadowMap_Array_Shader_0 Pixel_2_0 Has PRES False
float4 PSCreateShadowMap_Array_Shader_0(float texcoord1 : TEXCOORD1) : COLOR
{
    float4 out_color;
    float4 temp0;
    // dcl t1.x
    // mov r0, t1.x
    temp0 = texcoord1.x;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// PSCreateShadowMap_Array_Shader_1 Pixel_2_0 Has PRES False
struct PSCreateShadowMap_Array_Shader_1_Input
{
    float2 texcoord : TEXCOORD;
    float texcoord1 : TEXCOORD1;
    float color : COLOR;
};

float4 PSCreateShadowMap_Array_Shader_1(PSCreateShadowMap_Array_Shader_1_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    // def c0, -0.3764706, 0, 0, 0
    // dcl t0.xy
    // dcl t1.x
    // dcl v0.x
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(DiffuseTextureSampler, i.texcoord.xy);
    // mad r0, r0.w, v0.x, c0.x
    temp0 = temp0.w * i.color.x + float4(-0.3764706, -0.3764706, -0.3764706, -0.3764706);
    // texkill r0
    clip(temp0);
    // mov r0, t1.x
    temp0 = i.texcoord1.x;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

PixelShader PSCreateShadowMap_Array[2] = {
    compile ps_2_0 PSCreateShadowMap_Array_Shader_0(), // 105
    compile ps_2_0 PSCreateShadowMap_Array_Shader_1(), // 106
};
// _CreateDepthMap_Expression21 Expression_2_0 Has PRES False
float _CreateDepthMap_Expression21()
{
    float1 expr0;
    // mov c0.x, c0.x
    expr0.x = AlphaTestEnable.x;
    return expr0;
}

// _CreateDepthMap_Expression22 Expression_2_0 Has PRES False
float _CreateDepthMap_Expression22()
{
    float1 expr0;
    // min c0.x, c0.x, (1)
    expr0.x = min(NumJointsPerVertex.x, (1));
    return expr0;
}

// Default_L_Expression23 Expression_2_0 Has PRES False
float Default_L_Expression23()
{
    float1 expr0;
    // min c0.x, c0.x, (1)
    expr0.x = min(NumJointsPerVertex.x, (1));
    return expr0;
}

// Default_M_Expression24 Expression_2_0 Has PRES False
float Default_M_Expression24()
{
    float1 expr0;
    // mov c0.x, c0.x
    expr0.x = HasShadow.x;
    return expr0;
}

// Default_M_Expression25 Expression_2_0 Has PRES False
float Default_M_Expression25()
{
    float1 expr0;
    // min c0.x, c0.x, (1)
    expr0.x = min(NumJointsPerVertex.x, (1));
    return expr0;
}

// Default_Expression26 Expression_2_0 Has PRES False
float Default_Expression26()
{
    float1 expr0;
    // mov c0.x, c0.x
    expr0.x = HasShadow.x;
    return expr0;
}

// Default_Expression27 Expression_2_0 Has PRES False
float Default_Expression27()
{
    float1 expr0;
    // min c0.x, c0.x, (1)
    expr0.x = min(NumJointsPerVertex.x, (1));
    return expr0;
}

technique Default
{
    pass p0 <string ExpressionEvaluator = "Objects";>
    {
        VertexShader = VS_H_Array[Default_Expression27()]; // 85
        PixelShader = PS_H_Array[Default_Expression26()]; // 86
        ZEnable = 1;
        ZFunc = 4;
        ZWriteEnable = 1;
        CullMode = 2;
        SrcBlend = 5;
        DestBlend = 6;
        AlphaFunc = 7;
        AlphaRef = 96;
    }
}

technique Default_M
{
    pass p0 <string ExpressionEvaluator = "Objects";>
    {
        VertexShader = VS_M_Array[Default_M_Expression25()]; // 94
        PixelShader = PS_M_Array[Default_M_Expression24()]; // 95
        ZEnable = 1;
        ZFunc = 4;
        ZWriteEnable = 1;
        CullMode = 2;
        SrcBlend = 5;
        DestBlend = 6;
        AlphaFunc = 7;
        AlphaRef = 96;
    }
}

technique Default_L
{
    pass p0 <string ExpressionEvaluator = "Objects";>
    {
        VertexShader = VS_L_Array[Default_L_Expression23()]; // 101
        PixelShader = <PS_L_Array[0]>; // 102
        ZEnable = 1;
        ZFunc = 4;
        ZWriteEnable = 1;
        CullMode = 2;
        SrcBlend = 5;
        DestBlend = 6;
        AlphaFunc = 7;
        AlphaRef = 96;
    }
}

technique _CreateDepthMap
{
    pass p0
    {
        VertexShader = VSCreateShadowMap_Array[_CreateDepthMap_Expression22()]; // 107
        PixelShader = PSCreateShadowMap_Array[_CreateDepthMap_Expression21()]; // 108
        ZEnable = 1;
        ZFunc = 4;
        ZWriteEnable = 1;
        CullMode = 2;
        AlphaBlendEnable = 0;
        AlphaTestEnable = 0;
    }
}

