string DefaultParameterScopeBlock = "material"; // 1
float3 AmbientLightColor <bool unmanaged = 1;> = { 0.3, 0.3, 0.3 };
struct {
    float3 Color;
    float3 Direction;
} DirectionalLight[3] <bool unmanaged = 1;> = { 1.625198, 1.512711, 1.097048, 0.62914, -0.34874, 0.69465, 0.5232916, 0.6654605, 0.7815244, -0.32877, 0.90329, 0.27563, 0.4420466, 0.4102767, 0.4420466, -0.80704, -0.58635, 0.06975 };
struct {
    float3 Color;
    float3 Position;
    float2 Range_Inner_Outer;
} PointLight[8] <bool unmanaged = 1;>;
struct {
    float4 WorldPositionMultiplier_XYZZ;
    float2 CurrentOffsetUV;
} Cloud <bool unmanaged = 1;>;
float3 NoCloudMultiplier <bool unmanaged = 1;> = { 1, 1, 1 };
float3 RecolorColorDummy <bool unmanaged = 1;>;
row_major float4x4 ShadowMapWorldToShadow <bool unmanaged = 1;>;
float OpacityOverride <bool unmanaged = 1;> = { 1 };
float3 TintColor <bool unmanaged = 1;> = { 1, 1, 1 };
float3 EyePosition : register(vs_2_0, c123) <bool unmanaged = 1;>;
column_major float4x4 ViewProjection : register(vs_2_0, c119) <bool unmanaged = 1;>;
float4 WorldBones[128] <bool unmanaged = 1;>;
texture Texture1 <string UIWidget = "None";>; // 2
sampler2D Texture1Sampler : register(ps_2_0, s0) <string Texture = "Texture1"; string UIWidget = "None";> =
sampler_state
{
    Texture = <Texture1>; // 4
    MinFilter = 2;
    MagFilter = 2;
    MipFilter = 2;
    AddressU = 1;
    AddressV = 1;
};
texture Texture2 <string UIWidget = "None";>; // 7
sampler2D Texture2Sampler : register(ps_2_0, s1) <string Texture = "Texture2"; string UIWidget = "None";> =
sampler_state
{
    Texture = <Texture2>; // 9
    MinFilter = 2;
    MagFilter = 2;
    MipFilter = 2;
    AddressU = 1;
    AddressV = 1;
};
struct
{
    float4 ScaleUV_OffsetUV;
} Shroud : register(vs_2_0, c14) <string UIWidget = "None"; string SasBindAddress = "Terrain.Shroud";> = { 1, 1, 0, 0 };
texture ShroudTexture <string UIWidget = "None"; string SasBindAddress = "Terrain.Shroud.Texture"; string ResourceName = "ShaderPreviewShroud.dds";>; // 14
sampler2D ShroudTextureSampler : register(ps_2_0, s2) <string Texture = "ShroudTexture"; string UIWidget = "None"; string SasBindAddress = "Terrain.Shroud.Texture"; string ResourceName = "ShaderPreviewShroud.dds";> =
sampler_state
{
    Texture = <ShroudTexture>; // 18
    MinFilter = 2;
    MagFilter = 2;
    MipFilter = 2;
    AddressU = 3;
    AddressV = 3;
};
column_major float4x3 World : World : register(vs_2_0, c11);
float Time : Time;
// Additive_M_PixelShader1 Pixel_2_0 Has PRES True
struct Additive_M_PixelShader1_Input
{
    float2 texcoord : TEXCOORD;
    float2 texcoord3 : TEXCOORD3;
    float color : COLOR;
};

float4 Additive_M_PixelShader1(Additive_M_PixelShader1_Input i) : COLOR
{
    /*
    PRSI
      OutputRegisterOffset: 11
      Unknown1: 0
      Unknown2: 0
      OutputRegisterCount: 1
      Unknown3: 0
      Unknown4: 0
      Unknown5: 11
      Unknown6: 1
      Mappings: 1
        0 - ConstOutput: 0 ConstInput 0
    
    */
    float4 expr11;
    {
        // Expression_2_1
        // mul c11.x, c0.x, (0.1)
        expr11.x = Time.x * (0.1);
    }

    float4 out_color;
    float4 temp0, temp1, temp2;
    // def c0, 0.5, 0.75, -0.75, 0
    // dcl t0.xy
    // dcl t3.xy
    // dcl v0.x
    // dcl_2d s0
    // dcl_2d s1
    // dcl_2d s2
    // texld r0, t3, s2
    temp0 = tex2D(ShroudTextureSampler, i.texcoord3.xy);
    // add r0.x, r0.x, c0.z
    temp0.x = temp0.x + float1(-0.75);
    // add r0.x, r0.x, r0.x
    temp0.x = temp0.x + temp0.x;
    // max r1.w, r0.x, c0.w
    temp1.w = max(temp0.x, float1(0));
    // add r0.x, r1.w, r1.w
    temp0.x = temp1.w + temp1.w;
    // mov r1.x, c0.x
    temp1.x = float1(0.5);
    // mad r1.xy, t0, r1.x, c11.x
    temp1.xy = i.texcoord.xy * temp1.xx + expr11.xx;
    // texld r1, r1, s1
    temp1 = tex2D(Texture2Sampler, temp1.xy);
    // texld r2, t0, s0
    temp2 = tex2D(Texture1Sampler, i.texcoord.xy);
    // mul r1, r1, r2
    temp1 = temp1 * temp2;
    // mul r1, r1, v0.x
    temp1 = temp1 * i.color.x;
    // mul r1, r1, c0.y
    temp1 = temp1 * float4(0.75, 0.75, 0.75, 0.75);
    // mul r1.xyz, r0.x, r1
    temp1.xyz = temp0.xxx * temp1.xyz;
    // mov oC0, r1
    out_color = temp1;
    // 

    return out_color;
}

// Additive_M_VertexShader2 Vertex_2_0 Has PRES False
struct Additive_M_VertexShader2_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 normal : NORMAL;
};

struct Additive_M_VertexShader2_Output
{
    float4 position : POSITION;
    float3 color : COLOR;
    float2 texcoord3 : TEXCOORD3;
    float2 texcoord : TEXCOORD;
};

Additive_M_VertexShader2_Output Additive_M_VertexShader2(Additive_M_VertexShader2_Input i)
{
    Additive_M_VertexShader2_Output o;
    float4 temp0;
    float3 temp1, temp2;
    // def c0, 1, 0, -2, 3
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_normal v2
    // mad r0, v0.xyzx, c0.xxxy, c0.yyyx
    temp0 = i.position.xyzx * float4(1, 1, 1, 0) + float4(0, 0, 0, 1);
    // dp4 oPos.x, r0, c119
    o.position.x = dot(temp0, (ViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c120
    o.position.y = dot(temp0, (ViewProjection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c121
    o.position.z = dot(temp0, (ViewProjection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c122
    o.position.w = dot(temp0, (ViewProjection._m03_m13_m23_m33));
    // dp3 r0.x, v2, c11
    temp0.x = dot(i.normal.xyz, (World._m00_m10_m20_m30).xyz);
    // dp3 r0.y, v2, c12
    temp0.y = dot(i.normal.xyz, (World._m01_m11_m21_m31).xyz);
    // dp3 r0.z, v2, c13
    temp0.z = dot(i.normal.xyz, (World._m02_m12_m22_m32).xyz);
    // nrm r1.xyz, r0
    temp1.xyz = normalize(temp0.xyz).xyz;
    // add r0.xyz, -v0, c123
    temp0.xyz = -i.position.xyz + EyePosition.xyz;
    // nrm r2.xyz, r0
    temp2.xyz = normalize(temp0.xyz).xyz;
    // dp3 r0.x, r2, r1
    temp0.x = dot(temp2.xyz, temp1.xyz);
    // abs r0.x, r0.x
    temp0.x = abs(temp0.x);
    // min r0.x, r0.x, c0.x
    temp0.x = min(temp0.x, float1(1));
    // mad r0.y, r0.x, c0.z, c0.w
    temp0.y = temp0.x * float1(-2) + float1(3);
    // mul r0.x, r0.x, r0.x
    temp0.x = temp0.x * temp0.x;
    // mul oD0.xyz, r0.y, r0.x
    o.color = temp0.y * temp0.x;
    // add r0.xy, v0, c14.zwzw
    temp0.xy = i.position.xy + Shroud.ScaleUV_OffsetUV.zw;
    // mul oT3.xy, r0, c14
    o.texcoord3 = temp0 * Shroud.ScaleUV_OffsetUV;
    // mov oT0.xy, v1
    o.texcoord = i.texcoord;
    // 

    return o;
}

// Multiply_M_PixelShader3 Pixel_2_0 Has PRES True
struct Multiply_M_PixelShader3_Input
{
    float2 texcoord : TEXCOORD;
    float2 texcoord3 : TEXCOORD3;
    float color : COLOR;
};

float4 Multiply_M_PixelShader3(Multiply_M_PixelShader3_Input i) : COLOR
{
    /*
    PRSI
      OutputRegisterOffset: 11
      Unknown1: 0
      Unknown2: 0
      OutputRegisterCount: 1
      Unknown3: 0
      Unknown4: 0
      Unknown5: 11
      Unknown6: 1
      Mappings: 1
        0 - ConstOutput: 0 ConstInput 0
    
    */
    float4 expr11;
    {
        // Expression_2_1
        // mul c11.x, c0.x, (0.1)
        expr11.x = Time.x * (0.1);
    }

    float4 out_color;
    float4 temp0, temp1, temp2;
    // def c0, 0.5, 0.75, -0.75, 0
    // dcl t0.xy
    // dcl t3.xy
    // dcl v0.x
    // dcl_2d s0
    // dcl_2d s1
    // dcl_2d s2
    // texld r0, t3, s2
    temp0 = tex2D(ShroudTextureSampler, i.texcoord3.xy);
    // add r0.x, r0.x, c0.z
    temp0.x = temp0.x + float1(-0.75);
    // add r0.x, r0.x, r0.x
    temp0.x = temp0.x + temp0.x;
    // max r1.w, r0.x, c0.w
    temp1.w = max(temp0.x, float1(0));
    // add r0.x, r1.w, r1.w
    temp0.x = temp1.w + temp1.w;
    // mov r1.x, c0.x
    temp1.x = float1(0.5);
    // mad r1.xy, t0, r1.x, c11.x
    temp1.xy = i.texcoord.xy * temp1.xx + expr11.xx;
    // texld r1, r1, s1
    temp1 = tex2D(Texture2Sampler, temp1.xy);
    // texld r2, t0, s0
    temp2 = tex2D(Texture1Sampler, i.texcoord.xy);
    // mul r1, r1, r2
    temp1 = temp1 * temp2;
    // mul r1, r1, v0.x
    temp1 = temp1 * i.color.x;
    // mul r1, r1, c0.y
    temp1 = temp1 * float4(0.75, 0.75, 0.75, 0.75);
    // mul r1.xyz, r0.x, r1
    temp1.xyz = temp0.xxx * temp1.xyz;
    // mov oC0, r1
    out_color = temp1;
    // 

    return out_color;
}

// Multiply_M_VertexShader4 Vertex_2_0 Has PRES False
struct Multiply_M_VertexShader4_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 normal : NORMAL;
};

struct Multiply_M_VertexShader4_Output
{
    float4 position : POSITION;
    float3 color : COLOR;
    float2 texcoord3 : TEXCOORD3;
    float2 texcoord : TEXCOORD;
};

Multiply_M_VertexShader4_Output Multiply_M_VertexShader4(Multiply_M_VertexShader4_Input i)
{
    Multiply_M_VertexShader4_Output o;
    float4 temp0;
    float3 temp1, temp2;
    // def c0, 1, 0, -2, 3
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_normal v2
    // mad r0, v0.xyzx, c0.xxxy, c0.yyyx
    temp0 = i.position.xyzx * float4(1, 1, 1, 0) + float4(0, 0, 0, 1);
    // dp4 oPos.x, r0, c119
    o.position.x = dot(temp0, (ViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c120
    o.position.y = dot(temp0, (ViewProjection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c121
    o.position.z = dot(temp0, (ViewProjection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c122
    o.position.w = dot(temp0, (ViewProjection._m03_m13_m23_m33));
    // dp3 r0.x, v2, c11
    temp0.x = dot(i.normal.xyz, (World._m00_m10_m20_m30).xyz);
    // dp3 r0.y, v2, c12
    temp0.y = dot(i.normal.xyz, (World._m01_m11_m21_m31).xyz);
    // dp3 r0.z, v2, c13
    temp0.z = dot(i.normal.xyz, (World._m02_m12_m22_m32).xyz);
    // nrm r1.xyz, r0
    temp1.xyz = normalize(temp0.xyz).xyz;
    // add r0.xyz, -v0, c123
    temp0.xyz = -i.position.xyz + EyePosition.xyz;
    // nrm r2.xyz, r0
    temp2.xyz = normalize(temp0.xyz).xyz;
    // dp3 r0.x, r2, r1
    temp0.x = dot(temp2.xyz, temp1.xyz);
    // abs r0.x, r0.x
    temp0.x = abs(temp0.x);
    // min r0.x, r0.x, c0.x
    temp0.x = min(temp0.x, float1(1));
    // mad r0.y, r0.x, c0.z, c0.w
    temp0.y = temp0.x * float1(-2) + float1(3);
    // mul r0.x, r0.x, r0.x
    temp0.x = temp0.x * temp0.x;
    // mul oD0.xyz, r0.y, r0.x
    o.color = temp0.y * temp0.x;
    // add r0.xy, v0, c14.zwzw
    temp0.xy = i.position.xy + Shroud.ScaleUV_OffsetUV.zw;
    // mul oT3.xy, r0, c14
    o.texcoord3 = temp0 * Shroud.ScaleUV_OffsetUV;
    // mov oT0.xy, v1
    o.texcoord = i.texcoord;
    // 

    return o;
}

// Additive_PixelShader5 Pixel_2_0 Has PRES True
struct Additive_PixelShader5_Input
{
    float2 texcoord : TEXCOORD;
    float2 texcoord3 : TEXCOORD3;
    float color : COLOR;
};

float4 Additive_PixelShader5(Additive_PixelShader5_Input i) : COLOR
{
    /*
    PRSI
      OutputRegisterOffset: 11
      Unknown1: 0
      Unknown2: 0
      OutputRegisterCount: 1
      Unknown3: 0
      Unknown4: 0
      Unknown5: 11
      Unknown6: 1
      Mappings: 1
        0 - ConstOutput: 0 ConstInput 0
    
    */
    float4 expr11;
    {
        // Expression_2_1
        // mul c11.x, c0.x, (0.1)
        expr11.x = Time.x * (0.1);
    }

    float4 out_color;
    float4 temp0, temp1, temp2;
    // def c0, 0.5, 2.2, 0.75, -0.75
    // def c1, 0, 0, 0, 0
    // dcl t0.xy
    // dcl t3.xy
    // dcl v0.x
    // dcl_2d s0
    // dcl_2d s1
    // dcl_2d s2
    // mov r0.w, c0.x
    temp0.w = float1(0.5);
    // mad r0.xy, t0, r0.w, c11.x
    temp0.xy = i.texcoord.xy * temp0.ww + expr11.xx;
    // texld r0, r0, s1
    temp0 = tex2D(Texture2Sampler, temp0.xy);
    // texld r1, t0, s0
    temp1 = tex2D(Texture1Sampler, i.texcoord.xy);
    // texld r2, t3, s2
    temp2 = tex2D(ShroudTextureSampler, i.texcoord3.xy);
    // log r2.w, r0.x
    temp2.w = log2(temp0.x);
    // log r2.z, r0.y
    temp2.z = log2(temp0.y);
    // log r2.y, r0.z
    temp2.y = log2(temp0.z);
    // mul r2.yzw, r2, c0.y
    temp2.yzw = temp2.yzw * float3(2.2, 2.2, 2.2);
    // exp r0.x, r2.w
    temp0.x = exp2(temp2.w);
    // exp r0.y, r2.z
    temp0.y = exp2(temp2.z);
    // exp r0.z, r2.y
    temp0.z = exp2(temp2.y);
    // log r2.w, r1.x
    temp2.w = log2(temp1.x);
    // log r2.z, r1.y
    temp2.z = log2(temp1.y);
    // log r2.y, r1.z
    temp2.y = log2(temp1.z);
    // mul r2.yzw, r2, c0.y
    temp2.yzw = temp2.yzw * float3(2.2, 2.2, 2.2);
    // exp r1.x, r2.w
    temp1.x = exp2(temp2.w);
    // exp r1.y, r2.z
    temp1.y = exp2(temp2.z);
    // exp r1.z, r2.y
    temp1.z = exp2(temp2.y);
    // mul r0, r0, r1
    temp0 = temp0 * temp1;
    // mul r0, r0, v0.x
    temp0 = temp0 * i.color.x;
    // mul r0, r0, c0.z
    temp0 = temp0 * float4(0.75, 0.75, 0.75, 0.75);
    // add r1.x, r2.x, c0.w
    temp1.x = temp2.x + float1(-0.75);
    // add r1.x, r1.x, r1.x
    temp1.x = temp1.x + temp1.x;
    // max r2.x, r1.x, c1.x
    temp2.x = max(temp1.x, float1(0));
    // add r1.x, r2.x, r2.x
    temp1.x = temp2.x + temp2.x;
    // mul r0.xyz, r0, r1.x
    temp0.xyz = temp0.xyz * temp1.xxx;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// Additive_VertexShader6 Vertex_2_0 Has PRES False
struct Additive_VertexShader6_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 normal : NORMAL;
};

struct Additive_VertexShader6_Output
{
    float4 position : POSITION;
    float3 color : COLOR;
    float2 texcoord3 : TEXCOORD3;
    float2 texcoord : TEXCOORD;
};

Additive_VertexShader6_Output Additive_VertexShader6(Additive_VertexShader6_Input i)
{
    Additive_VertexShader6_Output o;
    float4 temp0;
    float3 temp1, temp2;
    // def c0, 1, 0, -2, 3
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_normal v2
    // mad r0, v0.xyzx, c0.xxxy, c0.yyyx
    temp0 = i.position.xyzx * float4(1, 1, 1, 0) + float4(0, 0, 0, 1);
    // dp4 oPos.x, r0, c119
    o.position.x = dot(temp0, (ViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c120
    o.position.y = dot(temp0, (ViewProjection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c121
    o.position.z = dot(temp0, (ViewProjection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c122
    o.position.w = dot(temp0, (ViewProjection._m03_m13_m23_m33));
    // dp3 r0.x, v2, c11
    temp0.x = dot(i.normal.xyz, (World._m00_m10_m20_m30).xyz);
    // dp3 r0.y, v2, c12
    temp0.y = dot(i.normal.xyz, (World._m01_m11_m21_m31).xyz);
    // dp3 r0.z, v2, c13
    temp0.z = dot(i.normal.xyz, (World._m02_m12_m22_m32).xyz);
    // nrm r1.xyz, r0
    temp1.xyz = normalize(temp0.xyz).xyz;
    // add r0.xyz, -v0, c123
    temp0.xyz = -i.position.xyz + EyePosition.xyz;
    // nrm r2.xyz, r0
    temp2.xyz = normalize(temp0.xyz).xyz;
    // dp3 r0.x, r2, r1
    temp0.x = dot(temp2.xyz, temp1.xyz);
    // abs r0.x, r0.x
    temp0.x = abs(temp0.x);
    // min r0.x, r0.x, c0.x
    temp0.x = min(temp0.x, float1(1));
    // mad r0.y, r0.x, c0.z, c0.w
    temp0.y = temp0.x * float1(-2) + float1(3);
    // mul r0.x, r0.x, r0.x
    temp0.x = temp0.x * temp0.x;
    // mul oD0.xyz, r0.y, r0.x
    o.color = temp0.y * temp0.x;
    // add r0.xy, v0, c14.zwzw
    temp0.xy = i.position.xy + Shroud.ScaleUV_OffsetUV.zw;
    // mul oT3.xy, r0, c14
    o.texcoord3 = temp0 * Shroud.ScaleUV_OffsetUV;
    // mov oT0.xy, v1
    o.texcoord = i.texcoord;
    // 

    return o;
}

// Multiply_PixelShader7 Pixel_2_0 Has PRES True
struct Multiply_PixelShader7_Input
{
    float2 texcoord : TEXCOORD;
    float2 texcoord3 : TEXCOORD3;
    float color : COLOR;
};

float4 Multiply_PixelShader7(Multiply_PixelShader7_Input i) : COLOR
{
    /*
    PRSI
      OutputRegisterOffset: 11
      Unknown1: 0
      Unknown2: 0
      OutputRegisterCount: 1
      Unknown3: 0
      Unknown4: 0
      Unknown5: 11
      Unknown6: 1
      Mappings: 1
        0 - ConstOutput: 0 ConstInput 0
    
    */
    float4 expr11;
    {
        // Expression_2_1
        // mul c11.x, c0.x, (0.1)
        expr11.x = Time.x * (0.1);
    }

    float4 out_color;
    float4 temp0, temp1, temp2;
    // def c0, 0.5, 2.2, 0.75, -0.75
    // def c1, 0, 0, 0, 0
    // dcl t0.xy
    // dcl t3.xy
    // dcl v0.x
    // dcl_2d s0
    // dcl_2d s1
    // dcl_2d s2
    // mov r0.w, c0.x
    temp0.w = float1(0.5);
    // mad r0.xy, t0, r0.w, c11.x
    temp0.xy = i.texcoord.xy * temp0.ww + expr11.xx;
    // texld r0, r0, s1
    temp0 = tex2D(Texture2Sampler, temp0.xy);
    // texld r1, t0, s0
    temp1 = tex2D(Texture1Sampler, i.texcoord.xy);
    // texld r2, t3, s2
    temp2 = tex2D(ShroudTextureSampler, i.texcoord3.xy);
    // log r2.w, r0.x
    temp2.w = log2(temp0.x);
    // log r2.z, r0.y
    temp2.z = log2(temp0.y);
    // log r2.y, r0.z
    temp2.y = log2(temp0.z);
    // mul r2.yzw, r2, c0.y
    temp2.yzw = temp2.yzw * float3(2.2, 2.2, 2.2);
    // exp r0.x, r2.w
    temp0.x = exp2(temp2.w);
    // exp r0.y, r2.z
    temp0.y = exp2(temp2.z);
    // exp r0.z, r2.y
    temp0.z = exp2(temp2.y);
    // log r2.w, r1.x
    temp2.w = log2(temp1.x);
    // log r2.z, r1.y
    temp2.z = log2(temp1.y);
    // log r2.y, r1.z
    temp2.y = log2(temp1.z);
    // mul r2.yzw, r2, c0.y
    temp2.yzw = temp2.yzw * float3(2.2, 2.2, 2.2);
    // exp r1.x, r2.w
    temp1.x = exp2(temp2.w);
    // exp r1.y, r2.z
    temp1.y = exp2(temp2.z);
    // exp r1.z, r2.y
    temp1.z = exp2(temp2.y);
    // mul r0, r0, r1
    temp0 = temp0 * temp1;
    // mul r0, r0, v0.x
    temp0 = temp0 * i.color.x;
    // mul r0, r0, c0.z
    temp0 = temp0 * float4(0.75, 0.75, 0.75, 0.75);
    // add r1.x, r2.x, c0.w
    temp1.x = temp2.x + float1(-0.75);
    // add r1.x, r1.x, r1.x
    temp1.x = temp1.x + temp1.x;
    // max r2.x, r1.x, c1.x
    temp2.x = max(temp1.x, float1(0));
    // add r1.x, r2.x, r2.x
    temp1.x = temp2.x + temp2.x;
    // mul r0.xyz, r0, r1.x
    temp0.xyz = temp0.xyz * temp1.xxx;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// Multiply_VertexShader8 Vertex_2_0 Has PRES False
struct Multiply_VertexShader8_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 normal : NORMAL;
};

struct Multiply_VertexShader8_Output
{
    float4 position : POSITION;
    float3 color : COLOR;
    float2 texcoord3 : TEXCOORD3;
    float2 texcoord : TEXCOORD;
};

Multiply_VertexShader8_Output Multiply_VertexShader8(Multiply_VertexShader8_Input i)
{
    Multiply_VertexShader8_Output o;
    float4 temp0;
    float3 temp1, temp2;
    // def c0, 1, 0, -2, 3
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_normal v2
    // mad r0, v0.xyzx, c0.xxxy, c0.yyyx
    temp0 = i.position.xyzx * float4(1, 1, 1, 0) + float4(0, 0, 0, 1);
    // dp4 oPos.x, r0, c119
    o.position.x = dot(temp0, (ViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c120
    o.position.y = dot(temp0, (ViewProjection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c121
    o.position.z = dot(temp0, (ViewProjection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c122
    o.position.w = dot(temp0, (ViewProjection._m03_m13_m23_m33));
    // dp3 r0.x, v2, c11
    temp0.x = dot(i.normal.xyz, (World._m00_m10_m20_m30).xyz);
    // dp3 r0.y, v2, c12
    temp0.y = dot(i.normal.xyz, (World._m01_m11_m21_m31).xyz);
    // dp3 r0.z, v2, c13
    temp0.z = dot(i.normal.xyz, (World._m02_m12_m22_m32).xyz);
    // nrm r1.xyz, r0
    temp1.xyz = normalize(temp0.xyz).xyz;
    // add r0.xyz, -v0, c123
    temp0.xyz = -i.position.xyz + EyePosition.xyz;
    // nrm r2.xyz, r0
    temp2.xyz = normalize(temp0.xyz).xyz;
    // dp3 r0.x, r2, r1
    temp0.x = dot(temp2.xyz, temp1.xyz);
    // abs r0.x, r0.x
    temp0.x = abs(temp0.x);
    // min r0.x, r0.x, c0.x
    temp0.x = min(temp0.x, float1(1));
    // mad r0.y, r0.x, c0.z, c0.w
    temp0.y = temp0.x * float1(-2) + float1(3);
    // mul r0.x, r0.x, r0.x
    temp0.x = temp0.x * temp0.x;
    // mul oD0.xyz, r0.y, r0.x
    o.color = temp0.y * temp0.x;
    // add r0.xy, v0, c14.zwzw
    temp0.xy = i.position.xy + Shroud.ScaleUV_OffsetUV.zw;
    // mul oT3.xy, r0, c14
    o.texcoord3 = temp0 * Shroud.ScaleUV_OffsetUV;
    // mov oT0.xy, v1
    o.texcoord = i.texcoord;
    // 

    return o;
}

technique Multiply
{
    pass pass0
    {
        VertexShader = compile vs_2_0 Multiply_VertexShader8(); // 23
        PixelShader = compile ps_2_0 Multiply_PixelShader7(); // 24
        ZEnable = 1;
        ZWriteEnable = 0;
        ZFunc = 4;
        AlphaBlendEnable = 1;
        CullMode = 3;
        SrcBlend = 1;
        DestBlend = 4;
    }
}

technique Additive
{
    pass pass0
    {
        VertexShader = compile vs_2_0 Additive_VertexShader6(); // 25
        PixelShader = compile ps_2_0 Additive_PixelShader5(); // 26
        ZEnable = 1;
        ZWriteEnable = 0;
        ZFunc = 4;
        AlphaBlendEnable = 1;
        CullMode = 3;
        SrcBlend = 2;
        DestBlend = 2;
    }
}

technique Multiply_M
{
    pass pass0
    {
        VertexShader = compile vs_2_0 Multiply_M_VertexShader4(); // 27
        PixelShader = compile ps_2_0 Multiply_M_PixelShader3(); // 28
        ZEnable = 1;
        ZWriteEnable = 0;
        ZFunc = 4;
        AlphaBlendEnable = 1;
        CullMode = 3;
        SrcBlend = 1;
        DestBlend = 4;
    }
}

technique Additive_M
{
    pass pass0
    {
        VertexShader = compile vs_2_0 Additive_M_VertexShader2(); // 29
        PixelShader = compile ps_2_0 Additive_M_PixelShader1(); // 30
        ZEnable = 1;
        ZWriteEnable = 0;
        ZFunc = 4;
        AlphaBlendEnable = 1;
        CullMode = 3;
        SrcBlend = 2;
        DestBlend = 2;
    }
}

